<?php
// Load Config
require_once 'config/config.php';

// Load Helpers
require_once 'helpers/url_helper.php';
require_once 'helpers/session_helper.php';
require_once 'helpers/security_helper.php';
require_once 'helpers/static_helper.php';
require_once 'helpers/template_helper.php';
require_once 'helpers/notification_helper.php';
require_once 'helpers/format_helper.php';
require_once 'helpers/setting_helper.php';
require_once 'helpers/email_helper.php';
require_once 'helpers/language_helper.php';
require_once 'helpers/homepage_helper.php';
require_once 'helpers/activity_helper.php';
require_once 'helpers/faq_helper.php';
require_once 'helpers/user_helper.php';
require_once 'helpers/company_helper.php';
require_once 'helpers/package_helper.php';
require_once 'helpers/subscription_helper.php';
require_once 'helpers/subscriber_helper.php';
require_once 'helpers/newsletter_helper.php';
require_once 'helpers/fav_helper.php';
require_once 'helpers/gateway_helper.php';
require_once 'helpers/payment_helper.php';
require_once 'helpers/page_helper.php';
require_once 'helpers/paging_helper.php';
require_once 'helpers/google_recaptcha_helper.php';
require_once 'helpers/custom_error_helper.php';
require_once 'helpers/openai_helper.php';
require_once 'helpers/affiliate_helper.php';
require_once 'helpers/payout_helper.php';
require_once 'helpers/post_helper.php';
require_once 'helpers/chat_helper.php';
require_once 'helpers/assistant_helper.php';
require_once 'helpers/ticket_helper.php';
require_once 'helpers/finetune_helper.php';
require_once 'helpers/file_helper.php';
require_once 'helpers/visit_helper.php';
require_once 'helpers/theme_helper.php';
require_once 'helpers/widget_helper.php';
require_once 'helpers/parsedown_helper.php';
require_once 'helpers/addon_helper.php';
require_once 'helpers/whatsapp_helper.php';

if(DB_HOST == 'YOUR_DATABASE_HOST'){
echo 'EmbedAI is not installed. Visit <a target="_blank" href="https://mybizcms.com/documentations/embedai">Installation Guide</a> for assistance';
die();
}

if(file_exists(APPROOT.'/install') && DB_HOST == 'YOUR_DATABASE_HOST'){
echo 'Delete the folder named <b style="color:red; font-size: 25;">install</b> from the system to proceed.';
die();
}

if(file_exists(APPROOT.'/install') && DB_HOST != 'YOUR_DATABASE_HOST'){
echo 'Delete the folder named <b style="color:red; font-size: 25;">install</b> from the system to proceed.';
die();
}

// Autoload Core Libraries
spl_autoload_register(function($className){
$autoload_models = array('Setting', 'Notification', 'User', 'Subscription', 'Company', 'Page', 'Affiliate', 'Post', 'Package','Openai', 'Ad', 'Homepage', 'Addon');
if (strpos($className, 'Tco\\') === 0) {
require_once 'third_party/2checkout/autoloader.php';
}elseif(in_array($className, $autoload_models)){
require_once 'models/'.$className.'.php';
}else{
require_once 'libraries/' . $className . '.php';
}
});

date_default_timezone_set(getOption('default_timezone'));
if(affiliate_accepted()){
	set_affiliate_cookie();
}