<?php
class Addons extends Controller {
public function __construct(){
	if(!isLoggedIn()){
		logout();
	}
	require APPROOT.'/views/inc/load_models.php';
}

public function index(){
	$data = [
		'addons' => addons()
	];
	$this->view('addons/index', $data);
}

public function add(){
	if($_SERVER['REQUEST_METHOD'] == 'POST'){
		$data = [
			'zipfile' => trim($_FILES['zipfile']['name']),
			'file_text' => str_replace('.zip','.txt',$_FILES['zipfile']['name'])
		];
		if(!addon_by_name(str_replace('.txt','',$data['file_text']))){
		$zipfile = APPROOT.UPDATES_FOLDER.$_FILES['zipfile']['name'];
		move_uploaded_file($_FILES['zipfile']['tmp_name'], $zipfile);
		$zip = new ZipArchive;
		$res = $zip->open($zipfile);
		if($res === TRUE){
			if($zip->locateName('app/uploads/updates/'.$data['file_text'])){
				$zip->extractTo(SYSTEMROOT);
				$zip->close();
				if($file = fopen(APPROOT.UPDATES_FOLDER.$data['file_text'], 'r')){
					while(!feof($file)){
						$line = fgets($file);
						$exp = (explode('|', $line));
						list($addon_name,$addon_description,$is_premium,$addon_uninstall_rules) = $exp;
						$data = [
							'addon_name' => $addon_name,
							'addon_description' => $addon_description,
							'is_premium' => $is_premium,
							'addon_uninstall_rules' => $addon_uninstall_rules
						];
						$this->addonModel->addAddon($data);
					}
					fclose($file);
				}
				addActivityLog('user', user_id(), 'addon_uploaded');
				flash('user_message', 'addons', 'addon_uploaded');
			}else{
				flash('user_message', 'addons', 'addon_upload_failed', 'danger');
			}
		}else{
			flash('user_message', 'addons', 'invalid_addon_file', 'danger');
		}
		}else{
			flash('user_message', 'addons', 'addon_already_installed', 'danger');
		}
		redirect('addons');
		die();
	}
	$this->view('addons');
}

public function activate($id=NULL){
		$addon = addon($id);
		if(empty($addon)){ redirect(404); }
	if($_SERVER['REQUEST_METHOD'] == 'GET'){
		$data = [
			'addon_id' => $id,
			'addon_status_id' => 1
		];
		if($this->addonModel->updateAddonStatus($data)){
			addActivityLog('addon', $id, 'addon_activated');
			flash('user_message', 'addons', 'addon_activated');
		}else{
			flash('user_message', 'addons', 'addon_activation_failed', 'danger');
		}
	}
	redirect('addons');
	die();
}

public function deactivate($id=NULL){
		$addon = addon($id);
		if(empty($addon)){ redirect(404); }
	if($_SERVER['REQUEST_METHOD'] == 'GET'){
		$data = [
			'addon_id' => $id,
			'addon_status_id' => 0
		];
		if($this->addonModel->updateAddonStatus($data)){
			addActivityLog('addon', $id, 'addon_deactivated');
			flash('user_message', 'addons', 'addon_deactivated');
		}else{
			flash('user_message', 'addons', 'addon_deactivation_failed', 'danger');
		}
	}
	redirect('addons');
	die();
}

public function uninstall($id=NULL){
		$addon = addon($id);
		if(empty($addon)){ redirect(404); }
	if($_SERVER['REQUEST_METHOD'] == 'GET'){
		foreach(json_decode($addon->addon_uninstall_rules)->folders as $row){
			$out = str_replace(array('APPROOT', 'SYSTEMROOT'), array(APPROOT, SYSTEMROOT), $row);
			if(is_dir($out)){
				foreach(glob($out 	. '/*') as $file){
					unlink($file);
				}
				rmdir($out);
			}else{
				unlink($out);
			}
		}
		if($this->addonModel->deleteAddon($id)){
			addActivityLog('addon', $id, 'addon_uninstalled');
			flash('user_message', 'addons', 'addon_uninstalled');
		}else{
			flash('user_message', 'addons', 'addon_uninstallation_failed', 'danger');
		}
	}
	redirect('addons');
	die();
}







}
