<?php
    
    
    class Blog extends Controller
    {
        public function __construct()
        {
            require APPROOT . '/views/inc/load_models.php';
        }
        
        public function index($post_slug = NULL)
        {
            if (isset($post_slug)) {
                $post = $this->postModel->getPostBySlug($post_slug);
                if (empty($post)) {
                    redirect(404);
                }
                $data = [
                    'post' => $post
                ];
                $this->view('themes/' . getOption('active_theme') . '/blog/post', $data);
            } else {
                $data = [
                    'posts' => posts(2)
                ];
                $this->view('themes/' . getOption('active_theme') . '/blog/index', $data);
            }
            
        }
        
        public function post_comment($id = NULL)
        {
            $post = $this->postModel->getPostById($id);
            if (empty($post)) {
                redirect(404);
            }
            if ($_SERVER['REQUEST_METHOD'] == 'POST') {
                $_POST = sanitize_post();
                $data = [
                    'post_id' => $id,
                    'post_comment_added_by' => user_id(),
                    'post_comment' => cleanString($_POST['post_comment']),
                    'post_comment_parent_id' => NULL,
                    'post_comment_status_id' => 1
                ];
                if (empty($data['post_comment'])) {
                    $data['input_error'][] = 'please_enter_comment';
                }
                if (empty($data['input_error'])) {
                    if ($this->postModel->addComment($data)) {
                        flash('user_message', 'post', 'post_comment_added');
                    } else {
                        flash('user_message', 'post', 'post_comment_adding_failed', 'danger');
                    }
                    redirect('blog/' . post($id)->post_slug);
                    die();
                }
                $this->view('themes/' . getOption('active_theme') . '/blog/' . post($id)->post_slug, $data);
            }
            redirect('blog/' . post($id)->post_slug);
            die();
        }
        
        public function post_reply($comment_id = NULL)
        {
            $reply = $this->postModel->getPostCommentById($comment_id);
            if (empty($reply)) {
                redirect(404);
            }
            if ($_SERVER['REQUEST_METHOD'] == 'POST') {
                $_POST = sanitize_post();
                $data = [
                    'post_id' => $reply->post_id,
                    'post_comment_added_by' => user_id(),
                    'post_comment' => cleanString($_POST['post_comment']),
                    'post_comment_parent_id' => $comment_id,
                    'post_comment_status_id' => 1
                ];
                if (empty($data['post_comment'])) {
                    $data['input_error'][] = 'please_enter_reply';
                }
                if (empty($data['input_error'])) {
                    if ($this->postModel->addComment($data)) {
                        flash('user_message', 'post', 'comment_reply_added');
                    } else {
                        flash('user_message', 'post', 'comment_reply_adding_failed', 'danger');
                    }
                    redirect('blog/' . post($reply->post_id)->post_slug);
                    die();
                }
                $this->view('themes/' . getOption('active_theme') . '/blog/' . post($reply->post_id)->post_slug, $data);
            }
            redirect('blog/' . post($reply->post_id)->post_slug);
            die();
        }
        
        public function category($category_slug = NULL)
        {
            if (isset($category_slug)) {
                $category = $this->postModel->getPostCategoryBySlug($category_slug);
                if (empty($category)) {
                    redirect(404);
                }
                $data = [
                    'category' => $category,
                    'posts' => posts_by_category($category->post_category_id, 2)
                ];
                $this->view('themes/' . getOption('active_theme') . '/blog/category', $data);
            } else {
                redirect('blog');
                die();
            }
            
        }
        
        
    }
