<?php
    
    
    class Chatbots extends Controller
    {
        public function __construct()
        {
            if (!isLoggedIn()) {
                logout();
                die();
            }
            require APPROOT . '/views/inc/load_models.php';
        }
        
        public function chatbot_options()
        {
            if ($_SERVER['REQUEST_METHOD'] == 'POST') {
                $_POST = sanitize_post();
                $dataW = [];
                if (isset($_POST['widget_id'])) {
                    $dataW = [
                        'widget_id' => $_POST['widget_id']
                    ];
                }
                if ($_POST['chatbot_option'] == 'chat_assistants') {
                    $data = [
                        'chat_assistants' => chat_assistants(1),
                        'my_assistants' => chat_assistants(user_id()),
                        'fav' => false
                    ];
                    if(isset($_POST['source'])){
						$this->view('chatbots/chat_assistants_widget', array_merge($data, $dataW));
					}else{
						$this->view('chatbots/chat_assistants', array_merge($data, $dataW));
					}
                } elseif ($_POST['chatbot_option'] == 'favourite_chat_assistants') {
                    $data = [
                        'chat_assistants' => selected_chat_assistants(favs_array(user_id()), 1),
                        'my_assistants' => selected_chat_assistants(favs_array(user_id()), user_id()),
                        'fav' => true
                    ];
                    if(isset($_POST['source'])){
						$this->view('chatbots/chat_assistants_widget', array_merge($data, $dataW));
					}else{
						$this->view('chatbots/chat_assistants', array_merge($data, $dataW));
					}
                } elseif ($_POST['chatbot_option'] == 'trained_model') {
                    $data = [
                        'finetune_files' => finetune_files(user_id())
                    ];
                    $this->view('chatbots/trained_model', array_merge($data, $dataW));
                } elseif ($_POST['chatbot_option'] == 'chat_files') {
                    $data = [
                        'chat_files' => chat_files(user_id())
                    ];
                    $this->view('chatbots/chat_files', array_merge($data, $dataW));
                } elseif ($_POST['chatbot_option'] == 'chat_links') {
                    $data = [
                        'chat_links' => chat_links(user_id())
                    ];
                    $this->view('chatbots/chat_links', array_merge($data, $dataW));
                } elseif ($_POST['chatbot_option'] == 'chat_sitemaps') {
                    $data = [
                        'chat_sitemaps' => chat_sitemaps(user_id())
                    ];
                    $this->view('chatbots/chat_sitemaps', array_merge($data, $dataW));
                }
            }
        }
        
        public function chats()
        {
            $data = [
                'chats' => chats(user_id())
            ];
            $this->view('chatbots/chats', $data);
        }
        
        public function chat($id = NULL)
        {
            $chat = chat($id);
            if (empty($chat)) {
                redirect(404);
            }
            $data = [
                'chat_messages' => chat_messages($id)
            ];
            $this->view('chatbots/chat', $data);
        }
        
        
    }