<?php
    
    
    class Chats extends Controller
    {
        public function __construct()
        {
            if (!isLoggedIn()) {
                logout();
                die();
            }
            
            $subscription = has_valid_subscription(user_id());
            
            if (!$subscription) {
                flash('user_message', 'chats', 'you_do_not_have_an_active_subscription', 'danger');
                redirect('packages/all');
                die();
            }
            require APPROOT . '/views/inc/load_models.php';
        }
        
        public function index($source = NULL, $assistant_id = NULL)
        {
        	$chat_instructions = 'No instructions';
            if ($source == 'assistant' && !empty(chat_assistant($assistant_id))) {
                $chat_icon = URLROOT . DIRECTORY_SEPARATOR . 'app' . MEDIA_FOLDER . chat_assistant($assistant_id)->chat_assistant_logo;
                $chat_source_name = chat_assistant($assistant_id)->chat_assistant_name;
                $chat_source_sub_name = chat_assistant($assistant_id)->chat_assistant_profession;
                $chat_id = !empty(last_chat_by_source(user_id(), 'assistant', $assistant_id)) ? last_chat_by_source(user_id(), 'assistant', $assistant_id)->chat_id : NULL;
                $assistant_file_id = NULL;
                $send_button_class = 'send_message';
            } elseif ($source == 'trained_model' && !empty(finetune_file($assistant_id))) {
                $chat_icon = URLROOT . DIRECTORY_SEPARATOR . DEFAULT_IMAGES_FOLDER . 'file.png';
                $chat_source_name = finetune_file($assistant_id)->finetune_file;
                $chat_source_sub_name = finetune_file($assistant_id)->finetune_job_output_model;
                $chat_id = !empty(source_chats_by_ip_address(user_id(), 'trained_model', $assistant_id)) ? source_chats_by_ip_address(user_id(), 'trained_model', $assistant_id)->chat_id : NULL;
                $assistant_file_id = NULL;
                $send_button_class = 'send_message';
            } elseif ($source == 'file' && !empty(chat_file($assistant_id))) {
                $chat_icon = URLROOT . DIRECTORY_SEPARATOR . DEFAULT_IMAGES_FOLDER . 'file.png';
                $chat_source_name = chat_file($assistant_id)->chat_file;
                $chat_source_sub_name = chat_file($assistant_id)->chat_file;
                $chat_id = !empty(source_chats_by_ip_address(user_id(), 'file', $assistant_id)) ? source_chats_by_ip_address(user_id(), 'file', $assistant_id)->chat_id : NULL;
                $assistant_file_id = chat_file($assistant_id)->chat_file_output_id;
                $send_button_class = 'create_thread';
            } elseif ($source == 'link' && !empty(chat_file($assistant_id))) {
                $chat_icon = URLROOT . DIRECTORY_SEPARATOR . DEFAULT_IMAGES_FOLDER . 'link.png';
                $chat_source_name = label('link') . ' <a href="javascript:void(0)" data-bs-html="true" data-bs-content="<a href=' . chat_file($assistant_id)->chat_link . '>' . chat_file($assistant_id)->chat_link . '</a>" title="' . label('link') . '" data-bs-placement="top" data-bs-toggle="popover"><i class="fa-solid fa-question-circle"></i></a>';
                $chat_source_sub_name = NULL;
                $chat_id = !empty(source_chats_by_ip_address(user_id(), 'link', $assistant_id)) ? source_chats_by_ip_address(user_id(), 'link', $assistant_id)->chat_id : NULL;
                $assistant_file_id = chat_file($assistant_id)->chat_file_output_id;
                $send_button_class = 'create_thread';
                $chat_instructions = 'You are a website help assistant. The documents attached are the contents of the website. Respond as though you are getting the information from the website.';
            } elseif ($source == 'sitemap' && chat_file($assistant_id)) {
                $chat_icon = URLROOT . DIRECTORY_SEPARATOR . DEFAULT_IMAGES_FOLDER . 'website.png';
                $chat_source_name = label('sitemap') . ' <a href="javascript:void(0)" data-bs-html="true" data-bs-content="<a href=' . chat_file($assistant_id)->chat_link . '>' . chat_file($assistant_id)->chat_link . '</a>" title="' . label('sitemap') . '" data-bs-placement="top" data-bs-toggle="popover"><i class="fa-solid fa-question-circle"></i></a>';
                $chat_source_sub_name = NULL;
                $chat_id = !empty(source_chats_by_ip_address(user_id(), 'sitemap', $assistant_id)) ? source_chats_by_ip_address(user_id(), 'sitemap', $assistant_id)->chat_id : NULL;
                $assistant_file_id = chat_file($assistant_id)->chat_file_output_id;
                $send_button_class = 'create_thread';
                $chat_instructions = 'You are a website help assistant. The documents attached are the contents of the website. Respond as though you are getting the information from the website.';
            } else {
                redirect('dashboards');
                die();
            }
            if (isset($assistant_id)) {
                $chats = source_chats(user_id(), 'assistant', $assistant_id);
                $chat_assistants = NULL;
                $chat_assistant = chat_assistant($assistant_id);
                $chat_view = 'assistant';
            } else {
                $chats = NULL;
                $chat_assistants = chat_assistants(1);
                $chat_assistant = chat_assistant($assistant_id);
                $chat_view = 'assistants';
            }
            $data = [
                'chats' => $chats,
                'chat_messages' => chat_messages(user_id()),
                'chat_assistants' => $chat_assistants,
                'chat_assistant' => $chat_assistant,
                'chat_icon' => $chat_icon,
                'chat_source_name' => $chat_source_name,
                'chat_source_sub_name' => $chat_source_sub_name,
                'chat_instructions' => $chat_instructions,
                'chat_id' => $chat_id,
                'assistant_file_id' => $assistant_file_id,
                'source' => $source,
                'source_id' => $assistant_id,
                'send_button_class' => $send_button_class
            ];
            $this->view('chats/index', $data);
        }
        
        public function my_assistants()
        {
            $data = [
                'chat_assistants' => chat_assistants(user_id())
            ];
            $this->view('chats/assistants', $data);
        }
        
        public function load_messages()
        {
        	$chat = chat($_GET['chat_id']);
        	$user = user(user_id());
        	$chat_messages = array();
        	if($chat->chat_added_by==$user->user_id){
				$chat_messages = chat_messages($chat->chat_id);
			}
            $data = [
                'chats' => $chat_messages
            ];
            $this->view('chats/load_messages', $data);
        }
        
        public function load_chats($source, $source_id = NULL)
        {
            $data = [
                'source' => $source,
                'source_id' => $source_id
            ];
            $this->view('chats/load_chats', $data);
        }
        
        public function load_new_message()
        {
            
            $result = array(
                "message" => 'you_do_not_have_an_active_subscription'
            );
            echo json_encode($result);
        }
        
        public function search()
        {
            if ($_SERVER['REQUEST_METHOD'] == 'POST') {
                $_POST = sanitize_post();
                $data = [
                    'term' => cleanString($_POST['term'])
                ];
                if (empty($data['input_error'])) {
                    $output = $this->chatModel->searchChat($data);
                    $result = '<ul class="nav flex-column border border-top-0 border-end-0 border-primary-subtle me-5">';
                    if (!empty($output)) {
                        foreach ($output as $chat) {
                            $result .= '<li class="nav-item ms-1">
						<button type="button" tabindex="0" class="dropdown-item sidebar-message item' . $chat->chat_id . '">
							<div class="widget-content p-0">
								<div class="widget-content-wrapper">
									<div class="widget-content-left me-3">
										<div class="avatar-icon-wrapper">
											<div class="badge badge-bottom badge-success badge-dot badge-dot-lg">
											</div>
											<div class="avatar-icon">
												<i class="fa-solid fa-user fa-2x pe-2"></i>
											</div>
										</div>
									</div>
									<div class="widget-content-left">
										<div class="widget-heading">
											' . $chat->chat_subject . '
										</div>
										<div class="widget-subheading">' . count(chat_messages($chat->chat_id)) . ' ' . label('messages') . '
										</div>
									</div>
								</div>
							</div>
						</button>
					</li>';
                        }
                    } else {
                        $result .= '<li>' . no_records('chat') . '</li>';
                    }
                    $result .= '</ul>';
                    echo $result;
                }
            }
        }
        
        public function send_message()
        {
            if ($_SERVER['REQUEST_METHOD'] == 'POST') {
                $_POST = sanitize_post();
                $subscription = has_valid_subscription(user_id());
                
                $data = [
                    'message' => cleanString($_POST['message']),
                    'temperature' => 1,
                    'n' => 1,
                    'words' => getOption('custom_package_maximum_result_length'),
                    'is_bot' => NULL,
                    'chat_id' => !empty($_POST['chat_id']) ? cleanString($_POST['chat_id']) : NULL,
                    'chat_subject' => label('new_chat'),
                    'source' => !empty($_POST['source']) ? cleanString($_POST['source']) : NULL,
                    'source_id' => !empty($_POST['source_id']) ? cleanString($_POST['source_id']) : NULL,
                    'assistant_file_id' => NULL,
                    'chat_message_added_by' => user_id(),
                    'chat_added_by' => user_id(),
                    'chat_file_id' => NULL,
                    'visit_id' => NULL,
                    'widget_id' => NULL
                ];
                
                if(!empty($data['source_id']) && $data['source']=='assistant'){
					$owner = chat_assistant($data['source_id'])->chat_assistant_added_by;
					if($owner==1){
						$owner = user_id();
					}
				}elseif(!empty($data['source_id']) && $data['source']=='trained_model'){
					$owner = finetune_file($data['source_id'])->finetune_file_added_by;
				}elseif(!empty($data['source_id']) && in_array($data['source'], array('link','sitemap'))){
					$owner = chat_file($data['source_id'])->chat_file_added_by;
				}
				
				if($owner!=user_id()){
					$data['input_error'] = 'resource_unavailable';
				}
                
                if (empty($data['input_error'])) {
                    $data_chat = [];
                    if (empty($data['chat_id']) && !empty($data['source_id'])) {
                        $chat_id = $this->chatModel->addChat($data);
                        $data_chat = [
                            'chat_id' => $chat_id
                        ];
                    }
                    
                    $this->chatModel->addChatMessage(array_merge($data, $data_chat));
                    
                    $result = array(
                        "status" => "success",
                        "message" => $data['message'],
                        "chat_id" => !empty($data['chat_id']) ? $data['chat_id'] : $data_chat['chat_id']
                    );
                } else {
                    $result = array(
                        "status" => "error",
                        "message" => $data['input_error']
                    );
                }
                echo json_encode($result);
            }
        }
        
        public function generate_chat()
        {
            if ($_SERVER['REQUEST_METHOD'] == 'POST') {
                $subscription = has_valid_subscription(user_id());
                $last = last_chat_message(1);
                
                if (!$last) {
                    $assistant_message = last_chat_message(1)->chat_message;
                } else {
                    if ($_POST['source'] == 'assistant') {
                        $assistant_message = chat_assistant(chat($_POST['chat_id'])->source_id)->chat_assistant_prompt;
                    } elseif ($_POST['source'] == 'trained_model') {
                        $assistant_message = NULL;
                    }
                }
                $_POST = sanitize_post();
                $data = [
                    'assistant_message' => $assistant_message,
                    'message' => cleanString($_POST['message']),
                    'temperature' => 1,
                    'n' => 1,
                    'words' => getOption('custom_package_maximum_result_length'),
                    'is_bot' => NULL
                ];
                
                if ($_POST['source'] == 'assistant') {
                    $response = open_ai(user_id(), $data['message'], (int)$data['temperature'], (int)$data['n'], (int)$data['words'], $data['assistant_message']);
                } elseif ($_POST['source'] == 'trained_model') {
                    $response = ai_user_trained_model_chat(user_id(), $data['message'], (int)$data['temperature'], (int)$data['n'], (int)$data['words'], $data['assistant_message'], finetune_file($_POST['source_id'])->finetune_job_output_model);
                }
                
                if ($response['status'] == 'error') {
                    $data['input_error'] = $response['message'];
                }
                
                if (empty($data['input_error'])) {
                    
                    $dataw = [
                        'user_id' => user_id(),
                        'user_remaining_words' => (int)$response['current_tokens'],
                        'user_remaining_chat_assistants' => (int)user(user_id())->user_remaining_chat_assistants,
                        'user_remaining_trained_models' => (int)user(user_id())->user_remaining_trained_models,
                        'user_remaining_chat_files' => (int)user(user_id())->user_remaining_chat_files,
                        'user_remaining_chat_links' => (int)user(user_id())->user_remaining_chat_links,
                        'user_remaining_chat_sitemaps' => (int)user(user_id())->user_remaining_chat_sitemaps
                    ];
                    
                    $dataz = [
                        'user_id' => user_id(),
                        'type' => 'words',
                        'transaction_type' => 'out',
                        'package_id' => NULL,
                        'openai_template_id' => NULL,
                        'old' => (int)$response['old_tokens'],
                        'current' => $dataw['user_remaining_words'],
                        'user_package_history_comment' => 'Chat ID: ' . $response['chat_id'],
                        'user_package_history_added_by' => user_id()
                    ];
                    $this->userModel->addUserPackageHistory($dataz);
                    $this->userModel->editUserRemaining($dataw);
                    
                    $datay = [
                        'is_bot' => 1,
                        'message' => $response['text'],
                        'chat_id' => !empty($_POST['chat_id']) ? cleanString($_POST['chat_id']) : NULL,
                        'assistant_file_id' => NULL,
                        'chat_message_added_by' => NULL
                    ];
                    
                    $this->chatModel->addChatMessage($datay);
                    
                    $result = array(
                        "status" => "success",
                        "text" => $response['text'],
                        "old_tokens" => $response['old_tokens'],
                        "current_tokens" => $response['current_tokens'],
                        "words_count" => str_word_count($response['text']),
                        "characters_count" => strlen($response['text']),
                        "chat_id" => $response['chat_id'],
                        "message" => "chat_generated"
                    );
                } else {
                    $result = array(
                        "status" => "error",
                        "message" => $data['input_error']
                    );
                }
                echo json_encode($result);
            }
        }
        
        public function send_email()
        {
            if ($_SERVER['REQUEST_METHOD'] == 'POST') {
                $_POST = sanitize_post();
                $data = [
                    'to' => user(user_id())->email,
                    'email_subject' => time(),
                    'message' => cleanString($_POST['message'], 'ignore_tags')
                ];
                
                $response = sendCustomEmail($data['to'], $data['email_subject'], $data['message']);
                
                if ($response) {
                    $result = array(
                        "status" => "success",
                        "message" => "email_sent"
                    );
                } else {
                    $result = array(
                        "status" => "error",
                        "message" => "email_not_sent"
                    );
                }
                echo json_encode($result);
            }
        }
        
        
        public function edit_modal($chat_id)
        {
            $data = [
                'chat' => chat($chat_id)
            ];
            $this->view('chats/edit_modal', $data);
        }
        
        public function edit($id = NULL)
        {
            $chat = chat($id);
            if (empty($chat)) {
                redirect(404);
            }
            if ($_SERVER['REQUEST_METHOD'] == 'POST') {
                $_POST = sanitize_post();
                $data = [
                    'chat_id' => $id,
                    'chat_subject' => cleanString($_POST['chat_subject'])
                ];
                if (empty($data['chat_subject'])) {
                    $data['input_error'][] = 'please_enter_chat_subject';
                }
                if (empty($data['input_error'])) {
                    if ($this->chatModel->updateChat($data)) {
                        addActivityLog('chat', $id, 'chat_updated');
                        flash('user_message', 'chats', 'chat_updated');
                    } else {
                        flash('user_message', 'chats', 'updating_chat_failed', 'danger');
                    }
                }
            }
            redirect('chats/' . (!empty($chat->source) ? $chat->source : 'assistant') . '/' . (empty($chat->source) ? $chat->assistant_id : $chat->chat_file_id));
        }
        
        public function create_thread()
        {
            if ($_SERVER['REQUEST_METHOD'] == 'POST') {
                $_POST = sanitize_post();
                
                $assistant_id = NULL;
                if(getOption('assistant_version') == 'v1'){
	                if(!empty($_POST['assistant_id'])){
	                	$assistant_id = cleanString($_POST['assistant_id']);
					}else{
						$ai_create_assistant = ai_create_assistant(cleanString($_POST['assistant_file_id']), cleanString($_POST['chat_instructions']));
						if(($ai_create_assistant['status'] == 'success')){
							$assistant_id = $ai_create_assistant['assistant_id'];
						}else{
							$assistant_id = array($ai_create_assistant['message']);
						}
					}
				}else{
					$vector_store = ai_create_vector_store(cleanString($_POST['assistant_file_id']));
					if (!empty($vector_store) && $vector_store['status'] == 'error') {
						$data['input_error'] = $vector_store['message'];
		            	log_custom_error($_POST['user_id'], get_error_message(ERR_OPENAI_ASSISTANT, $vector_store['message'])[1]);
					}else{
						$ai_create_assistant_v2 = ai_create_assistant_v2($vector_store['vector_store_id'], cleanString($_POST['chat_instructions']));
						if($ai_create_assistant_v2['status'] == 'success'){
							$assistant_id = $ai_create_assistant_v2['assistant_id'];
						}else{
							$assistant_id = array($ai_create_assistant_v2['message']);
						}
					}
				}
				
                $data = [
                    'user_id' => cleanString($_POST['user_id']),
                    'chat_id' => !empty($_POST['chat_id']) ? cleanString($_POST['chat_id']) : NULL,
                    'assistant_id' => $assistant_id,
                    'thread_id' => cleanString($_POST['thread_id']),
                    'assistant_file_id' => cleanString($_POST['assistant_file_id']),
                    'message' => cleanString($_POST['message']),
                    'chat_subject' => label('new_chat'),
                    'source' => !empty($_POST['source']) ? cleanString($_POST['source']) : NULL,
                    'source_id' => !empty($_POST['source_id']) ? cleanString($_POST['source_id']) : NULL,
                    'chat_added_by' => cleanString($_POST['user_id']),
                    'visit_id' => NULL,
                    'widget_id' => NULL
                ];
                
                if(is_array($data['assistant_id'])){
					$data['input_error'] = $data['assistant_id'][0];
		            log_custom_error($data['user_id'], get_error_message(ERR_OPENAI_ASSISTANT, $data['assistant_id'][0])[1]);
				}else{
                if(!empty($data['chat_id'])){
                	$chat_id = $data['chat_id'];
				}else{
					$chat_id = $this->chatModel->addChat($data);
				}
                
                if (!empty($data['thread_id']) && ai_retrieve_thread($data['thread_id'])) {
                    $thread = ai_create_thread_message($data['thread_id'], $data['message']);
                    if (!empty($thread) && $thread['status'] == 'error') {
                        $data['input_error'] = $thread['message'];
		            	log_custom_error($data['user_id'], get_error_message(ERR_OPENAI_ASSISTANT, $thread['message']));
                    } else {
                        $result = array(
                            "status" => "success",
                            "alert" => "success",
                            "thread_id" => $thread['thread_id'],
                            "message" => NULL,
                            
                            "data" => array(
                                "user_id" => $data['user_id'],
                                "chat_id" => $data['chat_id'],
                                'thread_id' => $thread['thread_id'],
                                'assistant_id' => $data['assistant_id'],
                                'assistant_file_id' => $data['assistant_file_id'],
                                'message' => $data['message']
                            )
                        );
                    }
                } else {
                    $thread = ai_create_thread($data['assistant_file_id'], $data['message']);
                    if (!empty($thread) && $thread['status'] == 'error') {
                        $data['input_error'] = $thread['message'];
		            	log_custom_error($data['user_id'], get_error_message(ERR_OPENAI_ASSISTANT, $thread['message']));
                    } else {
                        $result = array(
                            "status" => "success",
                            "alert" => "success",
                            "thread_id" => $thread['thread_id'],
                            "message" => NULL,
                            
                            "data" => array(
                                "user_id" => $data['user_id'],
                                "chat_id" => $chat_id,
                                'thread_id' => $thread['thread_id'],
                                'assistant_id' => $data['assistant_id'],
                                'assistant_file_id' => $data['assistant_file_id'],
                                'message' => $data['message']
                            )
                        );
                    }
                }
			}
                if (!empty($data['input_error'])) {
		            log_custom_error($data['user_id'], get_error_message(ERR_OPENAI_ASSISTANT, $data['input_error']));
                    $result = array(
                        "status" => "error",
                        "alert" => "danger",
                        "message" => get_error_message(ERR_OPENAI_ASSISTANT, $data['input_error'])
                    );
                }
                echo json_encode($result);
            }
        }
        
        public function create_thread_message()
        {
            if ($_SERVER['REQUEST_METHOD'] == 'POST') {
                $_POST = sanitize_post();
                $data = [
                    'user_id' => cleanString($_POST['user_id']),
                    'chat_id' => !empty($_POST['chat_id']) ? cleanString($_POST['chat_id']) : NULL,
                    'assistant_id' => cleanString($_POST['assistant_id']),
                    'thread_id' => cleanString($_POST['thread_id']),
                    'assistant_file_id' => cleanString($_POST['assistant_file_id']),
                    'message' => cleanString($_POST['message'])
                ];
                if (!empty($data['thread_id']) && ai_retrieve_thread($data['thread_id'])) {
                    $thread = ai_create_thread_message($data['thread_id'], $data['message']);
                    if (!empty($thread) && $thread['status'] == 'error') {
                        $data['input_error'] = $thread['message'];
		            	log_custom_error($data['user_id'], get_error_message(ERR_OPENAI_ASSISTANT, $thread['message']));
                    } else {
                        $datay = [
                            'is_bot' => NULL,
                            'assistant_file_id' => !empty(assistant_file_by_output_id($data['assistant_file_id'])) ? assistant_file_by_output_id($data['assistant_file_id'])->assistant_file_id : (!empty(chat_file_by_output_id($data['assistant_file_id'])) ? chat_file_by_output_id($data['assistant_file_id'])->chat_file_id : NULL),
                            'chat_message_added_by' => $data['user_id']
                        ];
                        $this->chatModel->addChatMessage(array_merge($data, $datay));
                        $result = array(
                            "status" => "success",
                            "alert" => "success",
                            "thread_id" => $thread['thread_id'],
                            "assistant_id" => $data['assistant_id'],
                            "assistant_file_id" => $data['assistant_file_id'],
                            "user_id" => $data['user_id'],
                            "chat_id" => $data['chat_id'],
                            "message" => NULL,
                            
                            "data" => array(
                                "user_id" => $data['user_id'],
                                "chat_id" => $data['chat_id'],
                                'thread_id' => $thread['thread_id'],
                                'assistant_id' => $data['assistant_id'],
                                'assistant_file_id' => $data['assistant_file_id'],
                                'message' => $data['message']
                            )
                        );
                    }
                } else {
                    $thread = ai_create_thread($data['assistant_file_id'], $data['message']);
                    if (!empty($thread) && $thread['status'] == 'error') {
                        $data['input_error'] = $thread['message'];
		            	log_custom_error($data['user_id'], get_error_message(ERR_OPENAI_ASSISTANT, $thread['message']));
                    } else {
                        $datay = [
                            'is_bot' => NULL,
                            'assistant_file_id' => assistant_file_by_output_id($data['assistant_file_id'])->assistant_file_id,
                            'chat_message_added_by' => $data['user_id']
                        ];
                        $this->chatModel->addChatMessage(array_merge($data, $datay));
                        $result = array(
                            "status" => "success",
                            "alert" => "success",
                            "thread_id" => $thread['thread_id'],
                            "assistant_id" => $data['assistant_id'],
                            "assistant_file_id" => $data['assistant_file_id'],
                            "user_id" => $data['user_id'],
                            "chat_id" => $data['chat_id'],
                            "message" => NULL,
                            
                            "data" => array(
                                "user_id" => $data['user_id'],
                                "chat_id" => $data['chat_id'],
                                'thread_id' => $thread['thread_id'],
                                'assistant_id' => $data['assistant_id'],
                                'assistant_file_id' => $data['assistant_file_id'],
                                'message' => $data['message']
                            )
                        );
                    }
                }
                if (!empty($data['input_error'])) {
                    $result = array(
                        "status" => "error",
                        "alert" => "danger",
                        "message" => get_error_message(ERR_OPENAI_ASSISTANT, $data['input_error'])
                    );
                }
                echo json_encode($result);
            }
        }
        
        public function create_run()
        {
            if ($_SERVER['REQUEST_METHOD'] == 'POST') {
                $_POST = sanitize_post();
                $data = [
                    'user_id' => cleanString($_POST['user_id']),
                    'chat_id' => cleanString($_POST['chat_id']),
                    'assistant_id' => cleanString($_POST['assistant_id']),
                    'thread_id' => cleanString($_POST['thread_id']),
                    'assistant_file_id' => cleanString($_POST['assistant_file_id'])
                ];
                $run = ai_create_run($data['thread_id'], $data['assistant_id']);
                if (!empty($run) && $run['status'] == 'success') {
                    $result = array(
                        "status" => "success",
                        "alert" => "success",
                        "run_id" => $run['run_id'],
                        "thread_id" => $data['thread_id'],
                        "assistant_id" => $data['assistant_id'],
                        "assistant_file_id" => $data['assistant_file_id'],
                        "user_id" => $data['user_id'],
                        "chat_id" => $data['chat_id'],
                        "message" => NULL,
                        
                        "data" => array(
                            "run_id" => $run['run_id'],
                            "user_id" => $data['user_id'],
                            "chat_id" => $data['chat_id'],
                            'thread_id' => $data['thread_id'],
                            'assistant_id' => $data['assistant_id'],
                            'assistant_file_id' => $data['assistant_file_id']
                        )
                    );
                } else {
                    $data['input_error'] = $run['message'];
		            log_custom_error($data['user_id'], get_error_message(ERR_OPENAI_ASSISTANT, $run['message']));
                }
                if (!empty($data['input_error'])) {
                    $result = array(
                        "status" => "error",
                        "alert" => "danger",
                        "message" => get_error_message(ERR_OPENAI_ASSISTANT, $data['input_error'])
                    );
                }
                echo json_encode($result);
            }
        }
        
        public function retrieve_run()
        {
            if ($_SERVER['REQUEST_METHOD'] == 'POST') {
                $_POST = sanitize_post();
                $data = [
                    'user_id' => cleanString($_POST['user_id']),
                    'chat_id' => cleanString($_POST['chat_id']),
                    'assistant_id' => cleanString($_POST['assistant_id']),
                    'thread_id' => cleanString($_POST['thread_id']),
                    'assistant_file_id' => cleanString($_POST['assistant_file_id']),
                    'run_id' => cleanString($_POST['run_id'])
                ];
                $run = ai_retrieve_run($data['thread_id'], $data['run_id']);
                if (!empty($run) && $run['status'] == 'success') {
                    if ($run['run_status'] == 'completed') {
                        $result = array(
                            "status" => "success",
                            "alert" => "success",
                            "run_id" => $run['run_id'],
                            "thread_id" => $data['thread_id'],
                            "assistant_id" => $data['assistant_id'],
                            "assistant_file_id" => $data['assistant_file_id'],
                            "user_id" => $data['user_id'],
                            "chat_id" => $data['chat_id'],
                            "message" => NULL,
                            
                            "data" => array(
                                "run_id" => $run['run_id'],
                                "user_id" => $data['user_id'],
                                "chat_id" => $data['chat_id'],
                                'thread_id' => $data['thread_id'],
                                'assistant_id' => $data['assistant_id'],
                                'assistant_file_id' => $data['assistant_file_id']
                            )
                        );
                    } elseif (in_array($run['run_status'], array('queued', 'in_progress'))) {
                        $result = array(
                            "status" => "wait",
                            "alert" => "warning",
                            "run_status" => $run['run_status']
                        );
                    } else {
                        $data['input_error'] = $run['last_error']['message'];
		            	log_custom_error($data['user_id'], get_error_message(ERR_OPENAI_ASSISTANT, $run['last_error']['message']));
                        $result = array(
                            "status" => "error",
                            "alert" => "danger",
                            "message" => get_error_message(ERR_OPENAI_ASSISTANT, $run['last_error']['message'])
                        );
                    }
                } else {
                    $data['input_error'] = $run['message'];
		            log_custom_error($data['user_id'], get_error_message(ERR_OPENAI_ASSISTANT, $run['message']));
                }
                if (!empty($data['input_error'])) {
                    $result = array(
                        "status" => "error",
                        "alert" => "danger",
                        "message" => get_error_message(ERR_OPENAI_ASSISTANT, $data['input_error'])
                    );
                }
                echo json_encode($result);
            }
        }
        
        public function list_messages()
        {
            if ($_SERVER['REQUEST_METHOD'] == 'POST') {
                $_POST = sanitize_post();
                $data = [
                    'chat_id' => cleanString($_POST['chat_id']),
                    'user_id' => cleanString($_POST['user_id']),
                    'assistant_id' => cleanString($_POST['assistant_id']),
                    'thread_id' => cleanString($_POST['thread_id']),
                    'assistant_file_id' => cleanString($_POST['assistant_file_id']),
                    //'run_id' => cleanString($_POST['run_id'])
                ];
                if (!empty($data['thread_id'])) {
                    $messages = ai_list_messages($data['thread_id']);
                    if (!empty($messages) && $messages['status'] == 'error') {
                        $data['input_error'] = $messages['message'];
		            	log_custom_error($data['user_id'], get_error_message(ERR_OPENAI_ASSISTANT, $messages['message']));
                    } elseif (!empty($messages) && $messages['status'] == 'wait') {
                        $result = array(
                            "status" => "wait",
                            "alert" => "warning",
                            "thread_id" => $data['thread_id'],
                            "assistant_id" => $data['assistant_id'],
                            "assistant_file_id" => $data['assistant_file_id'],
                            "user_id" => $data['user_id'],
                            "chat_id" => $data['chat_id'],
                            "message" => $messages['message'],
                            
                            "data" => array(
                                "user_id" => $data['user_id'],
                                "chat_id" => $data['chat_id'],
                                'thread_id' => $data['thread_id'],
                                'assistant_id' => $data['assistant_id'],
                                'assistant_file_id' => $data['assistant_file_id'],
                                'message' => $messages['message']
                            )
                        );
                    } else {
                    	if(!isset($_POST['dont_post'])){
	                        foreach (array_reverse($messages['data']) as $msg) {
	                            $datay = [
	                                'is_bot' => 1,
	                                'message' => $msg,
	                                'chat_id' => !empty($data['chat_id']) ? cleanString($data['chat_id']) : NULL,
	                                'assistant_file_id' => NULL,
	                                'chat_message_added_by' => $data['user_id']
	                            ];
	                            $out =  $this->chatModel->addChatMessage($datay);
	                        }
						}
                        $result = array(
                            "status" => "success",
                            "alert" => "success",
                            "thread_id" => $data['thread_id'],
                            "assistant_id" => $data['assistant_id'],
                            "assistant_file_id" => $data['assistant_file_id'],
                            "user_id" => $data['user_id'],
                            "chat_id" => $data['chat_id'],
                            "messages" => $messages['data'],
                            "message" => NULL,
                            
                            "data" => array(
                                "user_id" => $data['user_id'],
                                "chat_id" => $data['chat_id'],
                                'thread_id' => $data['thread_id'],
                                'assistant_id' => $data['assistant_id'],
                                'assistant_file_id' => $data['assistant_file_id'],
                            	"messages" => $messages['data'],
                                'message' => NULL
                            )
                        );
                    }
                }
                if (!empty($data['input_error'])) {
                    $result = array(
                        "status" => "error",
                        "alert" => "danger",
                        "messages" => "",
                        "message" => get_error_message(ERR_OPENAI_ASSISTANT, $data['input_error'])
                    );
                }
                echo json_encode($result);
            }
        }
        
        public function generate_document_chat()
        {
            if ($_SERVER['REQUEST_METHOD'] == 'POST') {
                if (!empty($_POST['data'])) {
                    $result = array(
                        "status" => "success",
                        "text" => cleanString($_POST['data'], 'ignore_tags')
                    );
                } else {
                    $result = array(
                        "status" => "error",
                        "message" => get_error_message(ERR_OPENAI_ASSISTANT, 'unknown_error')
                    );
                }
                echo json_encode($result);
            }
        }
    
    
    
    }
