<?php
    
    
    class Cronjobs extends Controller
    {
        public function __construct()
        {
            require APPROOT . '/views/inc/load_models.php';
        }
        
        public function index()
        {
            if (isset($_GET['option']) && ($_GET['option']) == "run_cronjob") {
                if (strtotime("- " . getOption('backup_database_automatically_after')) > strtotime(getOption('last_database_backup'))) {
                    if (getOption('backup_database_automatically') == '1') {
                        $tables_in_db = 'Tables_in_' . DB_NAME;
                        $all_tables = $this->utilityModel->getAllTables();
                        $data = [
                            'all_tables' => $all_tables
                        ];
                        $tables = array();
                        foreach ($data['all_tables'] as $table) {
                            $tables[] = $table->$tables_in_db;
                        }
                        $data = [
                            'all_tables' => $tables
                        ];
                        $this->utilityModel->backupDatabase($data);
                    }
                    //Last Backup
                    $data = [
                        'option_name' => 'last_database_backup',
                        'option_value' => now()
                    ];
                    $this->settingModel->updateOptions($data);
                }

//Delete backups
                $dir = APPROOT . DATABASE_FOLDER;
                if (is_dir($dir)) {
                    if ($dh = opendir($dir)) {
                        while (($file = readdir($dh)) !== false) {
                            if (($file == '.') || ($file == '..')) {
                                //Ignore them
                            } else {
                                $delete_database_backups_older_than = $this->settingModel->getOptions('delete_database_backups_older_than');
                                if ($delete_database_backups_older_than->option_value != 0) {
                                    if (((strtotime(now()) - strtotime(date("Y-m-d H:i:s", filemtime($dir . $file)))) / 86400) > $delete_database_backups_older_than->option_value) {
                                        unlink($dir . $file);
                                    }
                                }
                            }
                        }
                    }
                }
                
                foreach (subscriptions() as $subscription) {
                    if ($subscription->subscription_end_date < now()) {
                        $data = [
                            'subscription_id' => $subscription->subscription_id,
                            'subscription_status_id' => 4
                        ];
                        $this->subscriptionModel->updateSubscriptionStatus($data);
                        $this->notificationModel->addNotification('subscription_has_expired', $subscription->user_id, 'subscriptions/show/' . $subscription->subscription_id);
                        if (!getOption('keep_remaining_balances_after_subscription_expiry')) {
                            $datay = [
                                'user_id' => $subscription->user_id,
                                'user_remaining_words' => 0,
                                'user_remaining_chat_assistants' => 0,
                                'user_remaining_trained_models' => 0,
                                'user_remaining_chat_files' => 0,
                                'user_remaining_chat_links' => 0,
                                'user_remaining_chat_sitemaps' => 0
                            ];
                            $this->userModel->editUserRemaining($datay);
                        }
                    }
                }
                foreach (open_visits() as $visit) {
                    if (time() - $visit->visit_last_activity > (!empty($visit->widget_id) ? widget($visit->widget_id) : user($visit->visit_added_by))->widget_visit_timeout) {
                        $data = [
                            'visit_id' => $visit->visit_id,
                            'visit_date_ended' => ($widget = !empty($visit->widget_id) ? widget($visit->widget_id) : user($visit->visit_added_by)) ? date("Y-m-d H:i:s", strtotime('-' . $widget->widget_visit_timeout . ' seconds', time())) : NULL
                        ];
                        $this->visitModel->endVisit($data);
                    }
                }
                
                $data = [
                    'last_cronjob' => now()
                ];
                foreach ($data as $keys => $options) {
                    $data = [
                        'option_name' => $keys,
                        'option_value' => $options
                    ];
                    $this->settingModel->updateOptions($data);
                }
            }
            $this->view('cronjobs/index');
        }
        
        
    }