<?php
    
    
    class Embedded extends Controller
    {
        public function __construct()
        {
            require APPROOT . '/views/inc/load_models.php';
        }
        
        public function index($user_uid = NULL, $go_back = NULL)
        {
            $user = user_by_uid($user_uid);
            
            $subscription = has_valid_subscription($user->user_id);
            
            if (!$subscription) {
                echo get_error_message(ERR_CHAT_UNAVAILABLE)[0];
                log_custom_error($user->user_id, get_error_message(ERR_CHAT_UNAVAILABLE)[1]);
                die();
            }
            if (isset($go_back) && (!empty($go_back) && mb_substr($go_back, 0, 3) == 'eai')) {
            	$chat_id = !empty(last_chat_by_ip_address(ip_address())) ? last_chat_by_ip_address(ip_address())->chat_id : NULL;
            	/*if(chat($chat_id)->widget_by_uid($go_back)){
					
				}*/
                $data = [
                    'user' => $user,
                    'widget' => widget_by_uid($go_back),
                    'message' => 'success'
                ];
                
                $this->view('embedded/custom', $data);
                die();
            }
            if (!empty($user->user_trained_model)) {
                $data = [
                    'user' => $user,
                    'message' => 'success'
                ];
                
                $this->view('embedded/user_trained_model', $data);
            } elseif (!empty($user->user_bots)) {
                /*if (
                    !isset($go_back) &&
                    !isset($_SESSION['go_back']) &&
                    !empty(last_chat_by_ip_address(ip_address()))) {
                    redirect('embedded/assistant/' . $user->user_uid . '/' . chat_assistant(last_chat_by_ip_address(ip_address())->source_id)->chat_assistant_uid);
                    die();
                } else {*/
                    $datay = [
                        'visit_id' => !empty(last_visit_by_ip_address(ip_address())) ? last_visit_by_ip_address(ip_address())->visit_id : NULL,
                        'visit_timeline_action' => 'left_chat',
                        'visit_timeline' => !empty(last_visit_timeline_by_ip_address_and_type(ip_address(), 'chat_resumed')) ? last_visit_timeline_by_ip_address_and_type(ip_address(), 'chat_resumed')->visit_timeline : NULL
                    ];
                    $this->visitModel->addVisitTimeline($datay);
                    
                    if (isset($user_uid)) {
                        if (empty($user)) {
                            $chat_assistants = json_encode(array());
                        } else {
                            $chat_assistants = $user->user_bots;
                        }
                    } else {
                        $chat_assistants = json_encode(array());
                    }
                    $data = [
                        'user' => $user,
                        'chat_assistants' => json_decode($chat_assistants)
                    ];
                    $this->view('embedded/index', $data);
				//}
            } elseif (!empty($user->user_chat_files)) {
                $data = [
                    'user' => $user,
                    'message' => 'success'
                ];
                
                $this->view('embedded/user_chat_files', $data);
            } elseif (!empty($user->user_chat_links)) {
                $data = [
                    'user' => $user,
                    'message' => 'success'
                ];
                
                $this->view('embedded/user_chat_links', $data);
            } elseif (!empty($user->user_chat_sitemaps)) {
                $data = [
                    'user' => $user,
                    'message' => 'success'
                ];
                
                $this->view('embedded/user_chat_sitemaps', $data);
            } else {
                echo get_error_message(ERR_CHAT_OPTIONS_UNAVAILABLE)[0];
                log_custom_error($user->user_id, get_error_message(ERR_CHAT_OPTIONS_UNAVAILABLE)[1]);
                die();
            }
        }
        
        public function assistant($user_uid = NULL, $chat_assistant_uid = NULL)
        {
            if (isset($_SESSION['go_back'])) {
                unset($_SESSION['go_back']);
            }
            $message = '';
            if (isset($chat_assistant_uid) && isset($user_uid)) {
                $chat_assistant = chat_assistant_by_uid($chat_assistant_uid);
                if (empty($chat_assistant)) {
                    $message = 'chat_assistant_not_found';
                }
                $user = user_by_uid($user_uid);
                if (empty($user)) {
                    $message = 'user_not_found';
                }
                $chats = source_chats_by_ip_address(ip_address(), 'assistant', $chat_assistant->chat_assistant_id);
            } else {
            	$chats = NULL;
                $message = 'invalid';
            }
            $chat_view = 'assistant';
            if (isset($chat_assistant) && isset($user)) {
                $data = [
                    'chats' => $chats,
                    'user' => $user,
                    'chat_messages' => chat_messages($user->user_id),
                    'chat_assistant' => $chat_assistant,
                    'message' => 'success'
                ];
            } else {
                $data = [
                    'message' => $message
                ];
                flash('user_message', 'chats', 'chat_could_not_be_loaded', 'danger');
            }
            $this->view('embedded/' . $chat_view, $data);
        }
        
        public function assistant_header($user_uid = NULL, $chat_assistant_uid = NULL)
        {
            if (isset($_SESSION['go_back'])) {
                unset($_SESSION['go_back']);
            }
            if (isset($user_uid)) {
                $user = user_by_uid($user_uid);
                if (empty($user)) {
                    $message = 'user_not_found';
                }
            } else {
                $message = 'invalid';
            }
            if (isset($chat_assistant_uid) && (!empty($chat_assistant_uid) && mb_substr($chat_assistant_uid, 0, 3) != 'eai')) {
                $chat_assistant = chat_assistant_by_uid($chat_assistant_uid);
                if (empty($chat_assistant)) {
                    $message = 'chat_assistant_not_found';
                }
            } else {
                //$message = 'invalid';
                $chat_assistant = NULL;
                $custom_widget = $chat_assistant_uid;
            }
            
            if (empty($message) && !empty($user)) {
                $data = [
                    'chat_assistant' => $chat_assistant,
                    'widget_header' => !empty($custom_widget) ? widget_by_uid($custom_widget)->widget_header : $user->widget_header,
                    'widget_header_textarea' => !empty($custom_widget) ? widget_by_uid($custom_widget)->widget_header_textarea : $user->widget_header_textarea,
                    'widget_colour' => !empty($custom_widget) ? widget_by_uid($custom_widget)->widget_colour : $user->widget_colour,
                    'message' => 'success'
                ];
            } else {
                $data = [
                    'chat_assistant' => NULL,
                    'widget_header' => !empty($custom_widget) ? widget_by_uid($custom_widget)->widget_header : $user->widget_header,
                    'widget_header_textarea' => !empty($custom_widget) ? widget_by_uid($custom_widget)->widget_header_textarea : $user->widget_header_textarea,
                    'widget_colour' => !empty($custom_widget) ? widget_by_uid($custom_widget)->widget_colour : $user->widget_colour,
                    'message' => $message
                ];
            }
            
            $this->view('embedded/header', $data);
        }
        
        public function assistant_footer($user_uid = NULL, $chat_assistant_uid = NULL)
        {
            $message = '';
            $accept_custom_branding = false;
            if (isset($user_uid)) {
                $user = user_by_uid($user_uid);
                $subscription = has_valid_subscription($user->user_id);
                if ($subscription) {
                    $accept_custom_branding = !empty(json_decode($subscription->subscription_items)->accept_custom_branding) ? json_decode($subscription->subscription_items)->accept_custom_branding : false;
                }
                if (empty($user)) {
                    $message = 'user_not_found';
                }
            } else {
                $message = 'invalid';
            }
            
            $custom_assistant = true;
            if ((!empty($chat_assistant_uid) && mb_substr($chat_assistant_uid, 0, 3) == 'eai') && in_array(widget_chat_source(widget_by_uid($chat_assistant_uid)->widget_id)['source'], array('assistant', 'trained_model'))) {
                $custom_assistant = false;
            }
            
            $data = [
                'user_trained_model' => $user->user_trained_model,
                'user_chat_files' => $user->user_chat_files,
                'user_chat_links' => $user->user_chat_links,
                'user_chat_sitemaps' => $user->user_chat_sitemaps,
                'accept_custom_branding' => $accept_custom_branding,
                'custom_widget' => $chat_assistant_uid,
                'custom_assistant' => $custom_assistant,
                'user' => $user,
                'message' => $message
            ];
            $this->view('embedded/footer', $data);
        }
        
        public function load_messages()
        {
        	$chat = isset($_GET['chat_id']) ? chat($_GET['chat_id']) : NULL;
        	$user = isset($_GET['user_uid']) ? user_by_uid($_GET['user_uid']) : NULL;
            $widget_source = $user;
        	$chat_messages = array();
        	if(!empty($chat) && !empty($user)){
                $widget_source = (isset($_GET['widget_id']) && !empty($_GET['widget_id'])) ? widget($_GET['widget_id']) : $user;
	        	if($chat->chat_added_by==$user->user_id){
					$chat_messages = chat_messages($chat->chat_id);
				}
			}
            $data = [
                'chats' => $chat_messages,
                'widget_source' => $widget_source
            ];
            $this->view('embedded/load_messages', $data);
        }
        
        public function bars_right()
        {
            $result = array(
                "bars_right" => '<div class="sai-dropdown"> <a href="javascript:void(0)" class="text-white sai-dropdown-toggle" id="dropdownButton" role="button"> <i class="fa-solid fa-bars fa-2x"></i> </a> <div class="sai-dropdown-menu" id="dropdownMenu"> <a class="sai-dropdown-item" href="javascript:void(0)" id="popoutChat">' . label("popout_chat") . '</a> <a class="sai-dropdown-item" href="javascript:void(0)" id="popinChat" style="display: none;">' . label("popin_chat") . '</a> <a class="sai-dropdown-item" href="javascript:void(0)" id="emailModalBtn">' . label("email_transcript") . '</a> <a class="sai-dropdown-item" href="javascript:void(0)" id="endChatModalBtn">' . label("end_this_chat_session") . '</a> </div> </div> <script> var dropdownButton = document.getElementById("dropdownButton"); var dropdownMenu = document.getElementById("dropdownMenu"); dropdownButton.addEventListener("click", function() { dropdownMenu.classList.toggle("show"); }); document.addEventListener("click", function(event) { if (!event.target.matches("#dropdownButton")) { var dropdowns = document.getElementsByClassName("dropdown-menu"); for (var i = 0; i < dropdowns.length; i++) { var openDropdown = dropdowns[i]; if (openDropdown.classList.contains("show")) { openDropdown.classList.remove("show"); } } } });</script>',
                "user_chat_icon_animation" => (isset($_POST['widget_id']) && is_numeric($_POST['widget_id'])) ? widget($_POST['widget_id'])->user_chat_icon_animation : user($_POST['user_id'])->user_chat_icon_animation,
                "user_chat_icon_position" => (isset($_POST['widget_id']) && is_numeric($_POST['widget_id'])) ? widget($_POST['widget_id'])->user_chat_icon_position : user($_POST['user_id'])->user_chat_icon_position
            );
            echo json_encode($result);
        }
        
        public function next()
        {
            if ($_SERVER['REQUEST_METHOD'] == 'POST') {
                $datay = [
                    'visit_id' => !empty(last_visit_by_ip_address(ip_address())) ? last_visit_by_ip_address(ip_address())->visit_id : NULL,
                    'visit_timeline_action' => 'chat_resumed',
                    'visit_timeline' => label('with') . ' ' . chat_assistant($_POST['chat_assistant_id'])->chat_assistant_name
                ];
                $this->visitModel->addVisitTimeline($datay);
                
                $_POST = sanitize_post();
                
                $append_remove_button = "<a href='javascript:void(0)' class='text-danger remove-selected-file' id='removeSelectedFile' role='button'> <i class='fa-solid fa-trash'></i> </a>";
                
                $result = array(
                    "status" => "success",
                    "chat_assistant_uid" => chat_assistant($_POST['chat_assistant_id'])->chat_assistant_uid,
                    "user_uid" => user($_POST['user_id'])->user_uid,
                    "widget_header" => '<span class="lh-0">' . chat_assistant($_POST['chat_assistant_id'])->chat_assistant_name . ' <br><span class="sai-lead sai-fs-6 sai-fw-lighter">(' . chat_assistant($_POST['chat_assistant_id'])->chat_assistant_profession . ')</span></span>',
                    "widget_header_textarea" => NULL,
                    "angle_left" => '<i class="fa-solid fa-angle-left fa-2x load_assistants"></i>',
                    "bars_right" => '<div class="sai-dropdown"> <a href="javascript:void(0)" class="text-white sai-dropdown-toggle" id="dropdownButton" role="button"> <i class="fa-solid fa-bars fa-2x"></i> </a> <div class="sai-dropdown-menu" id="dropdownMenu"> <a class="sai-dropdown-item" href="javascript:void(0)" id="popoutChat">' . label("popout_chat") . '</a> <a class="sai-dropdown-item" href="javascript:void(0)" id="popinChat" style="display: none;">' . label("popin_chat") . '</a> <a class="sai-dropdown-item" href="javascript:void(0)" id="emailModalBtn">' . label("email_transcript") . '</a> <a class="sai-dropdown-item" href="javascript:void(0)" id="endChatModalBtn">' . label("end_this_chat_session") . '</a> </div> </div> <script> var dropdownButton = document.getElementById("dropdownButton"); var dropdownMenu = document.getElementById("dropdownMenu"); dropdownButton.addEventListener("click", function() { dropdownMenu.classList.toggle("show"); }); document.addEventListener("click", function(event) { if (!event.target.matches("#dropdownButton")) { var dropdowns = document.getElementsByClassName("dropdown-menu"); for (var i = 0; i < dropdowns.length; i++) { var openDropdown = dropdowns[i]; if (openDropdown.classList.contains("show")) { openDropdown.classList.remove("show"); } } } });</script>',
                    "custom_branding" => NULL,
                    "widget_footer" => NULL,
                    "document_and_link" => '<div class="sai-dropup"> <div class="sai-dropup-menu" id="otherOptionsMenu"> <a class="sai-dropup-item" href="javascript:void(0)"> <input type="file" id="document" name="document" class="hidden-input documentchat"> <label for="document" class="file-label"> <p><i class="fa-solid fa-file"></i> ' . label('document') . ' </p> </label> </a> <a class="sai-dropup-item" href="javascript:void(0)"><span class="webchat" id="link"><i class="fa-solid fa-link"></i> ' . label('link') . '</span></a> </div> </div> <div class="sai-input-group-text-p-0 click-toggle-checkbox"> <a href="javascript:void(0)" class="sai-text-dark sai-dropup-toggle" id="otherOptions" role="button"> <i class="fa-solid fa-plus" id="openOtherOptions"></i> </a> </div> <span class="append_stop_document_link_chat"></span> <script> var otherOptions = document.getElementById("otherOptions"); var otherOptionsMenu = document.getElementById("otherOptionsMenu"); otherOptions.addEventListener("click", function() { otherOptionsMenu.classList.toggle("show"); }); document.addEventListener("click", function(event) { if (!event.target.matches("#otherOptions")) { var dropups = document.getElementsByClassName("dropup-menu"); if ($("#otherOptionsMenu").hasClass("show")) { $("#openOtherOptions").removeClass("fa-plus"); $("#openOtherOptions").addClass("fa-times"); }else{ $("#openOtherOptions").removeClass("fa-times"); $("#openOtherOptions").addClass("fa-plus"); } for (var i = 0; i < dropups.length; i++) { var openDropup = dropups[i]; if (openDropup.classList.contains("show")) { openDropup.classList.remove("show"); } } } }); $("#document").change(function() { $("#message").attr("disabled", "disabled"); $("#message").val(""); $("#message").attr("placeholder", "' . label("selected_file") . ' : "+this.files[0].name); $("#otherOptionsMenu").removeClass("show"); $("#appendRemoveSelectedFile").html("' . $append_remove_button . '"); $("#appendRemoveSelectedFile").addClass("sai-input-group-text-border-0"); $("#openOtherOptions").removeClass("fa-times"); $("#openOtherOptions").addClass("fa-plus"); $("#send_message").removeClass("send_message"); $("#send_message").addClass("upload_document"); }); $(".webchat").click(function() { $("#message").removeAttr("disabled"); $("#appendRemoveSelectedFile").html("' . $append_remove_button . '"); $("#appendRemoveSelectedFile").addClass("sai-input-group-text-border-0"); $("#otherOptionsMenu").removeClass("show"); $("#send_message").removeClass("send_message"); $("#send_message").addClass("upload_link"); }); $(document).on("click", ".remove-selected-file", function () { $("#message").removeAttr("disabled"); $("#message").val(""); $("#message").attr("placeholder", "' . user($_POST['user_id'])->widget_message_placeholder . '"); $("#removeSelectedFile").remove(); $("#input_type").val(""); $("#appendRemoveSelectedFile").addClass("padding-0"); $("#send_message").addClass("send_message"); $("#send_message").removeClass("upload_document"); $("#send_message").removeClass("upload_link"); }); </script>',
                    "footer_form" => 1
                );
            } else {
                $result = array(
                    "status" => "error",
                    "message" => 'assistant_could_not_be_loaded'
                );
            }
            echo json_encode($result);
        }
        
        public function go_back()
        {
            if ($_SERVER['REQUEST_METHOD'] == 'POST') {
                $_POST = sanitize_post();
                $result = array(
                    "status" => "success",
                    "widget_header" => user_by_uid($_POST['user_uid'])->widget_header,
                    "widget_header_textarea" => user_by_uid($_POST['user_uid'])->widget_header_textarea,
                    "angle_left" => NULL,
                    "bars_right" => NULL,
                    "custom_branding" => NULL,
                    "widget_footer" => NULL,
                    "document_and_link" => NULL,
                    "footer_form" => NULL
                );
                $_SESSION['go_back'] = 'go_back';
            } else {
                $result = array(
                    "status" => "error",
                    "message" => 'assistant_could_not_be_loaded'
                );
            }
            echo json_encode($result);
        }
        
        public function send_message($user_trained_model = NULL)
        {
            if ($_SERVER['REQUEST_METHOD'] == 'POST') {
                $_POST = sanitize_post();
                $user = user($_POST['user_id']);
                $subscription = has_valid_subscription($user->user_id);
                $data = [
                    'message' => cleanString($_POST['message']),
                    'temperature' => 1,
                    'n' => 1,
                    'words' => getOption('custom_package_maximum_result_length'),
                    'is_bot' => NULL,
                    'assistant_file_id' => NULL,
                    'chat_id' => !empty($_POST['chat_id']) ? cleanString($_POST['chat_id']) : NULL,
                    'chat_subject' => label('new_chat'),
                    'finetune_id' => !empty($_POST['finetune_id']) ? cleanString($_POST['finetune_id']) : NULL,
                    'source_id' => !empty($_POST['assistant_id']) ? cleanString($_POST['assistant_id']) : NULL,
                    'chat_file_id' => !empty($_POST['chat_file_id']) ? cleanString($_POST['chat_file_id']) : NULL,
                    'chat_added_by' => $user->user_id,
                    'chat_message_added_by' => $user->user_id,
                    'chat_ip_address' => ip_address(),
                    'visit_id' => !empty(last_visit_by_ip_address(ip_address())) ? last_visit_by_ip_address(ip_address())->visit_id : NULL,
                    'widget_id' => !empty($_POST['widget_id']) ? cleanString($_POST['widget_id']) : NULL
                ];
                
                if ($_POST['input_type'] == 'url' && !validate_url($_POST['message'])) {
                    $data['input_error'] = 'invalid_url';
                }
                
                if (empty($data['message'])) {
                    $data['input_error'] = 'please_enter_message';
                }
                
                if (empty($data['input_error'])) {
                    $data_chat = [
                        'chat_id' => $data['chat_id']
                    ];
                    if (empty($data['chat_id'])) {
                        $chat_id = $this->chatModel->addChat($data);
                        $datay = [
                            'visit_id' => $data['visit_id'],
                            'visit_timeline_action' => 'chat_started',
                            'visit_timeline' => NULL
                        ];
                        $this->visitModel->addVisitTimeline($datay);
                        $data_chat = [
                            'chat_id' => $chat_id
                        ];
                    }
                    
                    $this->chatModel->addChatMessage(array_merge($data, $data_chat));
                    
                    $result = array(
                        "status" => "success",
                        "message" => $data['message'],
                        "chat_id" => !empty($data['chat_id']) ? $data['chat_id'] : $data_chat['chat_id']
                    );
                } else {
                    $result = array(
                        "status" => "error",
                        "message" => label($data['input_error'])
                    );
                }
                echo json_encode($result);
            }
        }
        
        public function generate_chat($user_trained_model = NULL)
        {
            if ($_SERVER['REQUEST_METHOD'] == 'POST') {
                $user = user($_POST['user_id']);
                $last = last_chat_message(1);
                if ($last) {
                    $assistant_message = last_chat_message(1)->chat_message;
                } else {
                    if (empty(chat($_POST['chat_id'])->assistant_id)) {
                        $assistant_message = NULL;
                    } else {
                        $assistant_message = chat_assistant(chat($_POST['chat_id'])->assistant_id)->chat_assistant_prompt;
                    }
                }
                                
                $_POST = sanitize_post();
                $data = [
                    'assistant_message' => $assistant_message,
                    'message' => cleanString($_POST['message']),
                    'temperature' => 1,
                    'n' => 1,
                    'words' => ($user->user_remaining_words == -1) ? NULL : $user->user_remaining_words,
                    'is_bot' => NULL
                ];
                if (empty($_POST['assistant_id']) && empty($_POST['chat_file_id']) && !empty($_POST['finetune_id'])) {
                    $response = ai_user_trained_model_chat($user->user_id, $data['message'], (int)$data['temperature'], (int)$data['n'], (int)$data['words'], $data['assistant_message'], finetune_file($_POST['finetune_id'])->finetune_job_output_model);
                } else {
                    $response = open_ai($user->user_id, $data['message'], (int)$data['temperature'], (int)$data['n'], (int)$data['words'], $data['assistant_message']);
                }
                
                if ($response['status'] == 'error') { 
                    $data['input_error'] = get_error_message(ERR_OPENAI_CHAT, $response['message'])[0];
		            log_custom_error($user->user_id, get_error_message(ERR_OPENAI_CHAT, $response['message'])[1]);
                }
                
                if (empty($data['input_error'])) {
                    
                    $dataw = [
                        'user_id' => $user->user_id,
                        'user_remaining_words' => (int)$response['current_tokens'],
                        'user_remaining_chat_assistants' => (int)user($user->user_id)->user_remaining_chat_assistants,
                        'user_remaining_trained_models' => (int)user($user->user_id)->user_remaining_trained_models,
                        'user_remaining_chat_files' => (int)user($user->user_id)->user_remaining_chat_files,
                        'user_remaining_chat_links' => (int)user($user->user_id)->user_remaining_chat_links,
                        'user_remaining_chat_sitemaps' => (int)user($user->user_id)->user_remaining_chat_sitemaps
                    ];
                    
                    $dataz = [
                        'user_id' => $user->user_id,
                        'type' => 'chats',
                        'transaction_type' => 'out',
                        'package_id' => NULL,
                        'openai_template_id' => NULL,
                        'old' => (int)$response['old_tokens'],
                        'current' => $dataw['user_remaining_words'],
                        'user_package_history_comment' => 'Chat ID: ' . $response['chat_id'],
                        'user_package_history_added_by' => $user->user_id
                    ];
                    $this->userModel->addUserPackageHistory($dataz);
                    $this->userModel->editUserRemaining($dataw);
                    
                    $datay = [
                        'is_bot' => 1,
                        'message' => $response['text'],
                        'chat_id' => !empty($_POST['chat_id']) ? cleanString($_POST['chat_id']) : NULL,
                        'assistant_file_id' => NULL,
                        'chat_message_added_by' => $user->user_id
                    ];
                    $this->chatModel->addChatMessage($datay);
                    
                    $result = array(
                        "status" => "success",
                        "text" => $response['text'],
                        "old_tokens" => $response['old_tokens'],
                        "current_tokens" => $response['current_tokens'],
                        "words_count" => str_word_count($response['text']),
                        "characters_count" => strlen($response['text']),
                        "chat_id" => $response['chat_id'],
                        "message" => "chat_generated"
                    );
                } else {
                    $result = array(
                        "status" => "error",
                        "message" => get_error_message(ERR_OPENAI_CHAT, $response['message'])[0]
                    );
                }
                echo json_encode($result);
            }
        }
        
        public function send_email()
        {
            if ($_SERVER['REQUEST_METHOD'] == 'POST') {
                $_POST = sanitize_post();
                $data = [
                    'to' => cleanString($_POST['email']),
                    'email_subject' => label('chat_transcript') . ' ' . dateTimeFormat(now()),
                    'message' => cleanString($_POST['message'], 'ignore_tags')
                ];
                if (empty($data['to'])) {
                    $data['input_error'] = label('please_enter_email');
                }
                if (empty($data['input_error'])) {
                    $response = sendCustomEmail($data['to'], $data['email_subject'], $data['message']);
                    
                    $result = array(
                        "status" => "success",
                        "message" => "email_sent"
                    );
                } else {
                    $result = array(
                        "status" => "error",
                        "message" => $data['input_error']
                    );
                }
                echo json_encode($result);
            }
        }
        
        public function end_chat_session()
        {
            if ($_SERVER['REQUEST_METHOD'] == 'POST') {
                $_POST = sanitize_post();
                
                $data = [
                    'chat_id' => cleanString($_POST['chat_id']),
                    'visit_ip_address' => ip_address(),
                    'visit_id' => chat(cleanString($_POST['chat_id']))->visit_id,
                    'visit_date_ended' => ($widget = !empty(isset($_POST['widget_id']) ? widget($_POST['widget_id']) : user(chat(cleanString($_POST['chat_id']))->chat_added_by))) ? date("Y-m-d H:i:s", strtotime('-' . (isset($_POST['widget_id']) ? $widget->widget_visit_timeout : user(chat(cleanString($_POST['chat_id']))->chat_added_by)->widget_visit_timeout) . ' seconds', time())) : NULL
                ];
                
                if ($this->chatModel->endChatSession($data)) {
                    $this->visitModel->endVisit($data);
                    $result = array(
                        "status" => "success",
                        "message" => "session_ended"
                    );
                } else {
                    $result = array(
                        "status" => "error",
                        "message" => "session_ending_failed"
                    );
                }
                echo json_encode($result);
            }
        }
        
        public function common($user_uid, $custom_widget = NULL)
        {
            $user = user_by_uid($user_uid);
            $subscription = has_valid_subscription($user->user_id);
            $accept_custom_branding = false;
            if ($subscription) {
                $accept_custom_branding = !empty(json_decode($subscription->subscription_items)->accept_custom_branding) ? json_decode($subscription->subscription_items)->accept_custom_branding : false;
            }
            $result = array(
                "widget_url" => URLROOT . '/embedded/',
                "user_uid" => $user->user_uid,
                "colour" => !empty($custom_widget) ? widget_by_uid($custom_widget)->widget_colour : $user->widget_colour,
                "comment" => !empty($custom_widget) ? widget_by_uid($custom_widget)->widget_open_button : $user->widget_open_button,
                "closed" => !empty($custom_widget) ? widget_by_uid($custom_widget)->widget_close_button : $user->widget_close_button,
                "accept_custom_branding" => $accept_custom_branding,
                "custom_widget" => $custom_widget,
                "custom_widget_url" => !empty($custom_widget) ? '/' . $custom_widget : ''
            );
            echo json_encode($result);
        }
        
        public function js($user_uid, $custom_widget = NULL)
        {
            $user = user_by_uid($user_uid);
            
            //END VISIT
            $_SESSION['last_activity'] = time();
            $visit = last_visit_by_ip_address(ip_address());
            
            $widget = isset($custom_widget) ? widget_by_uid($custom_widget) : $user;
            if (!empty($visit) && time() - $visit->visit_last_activity > $widget->widget_visit_timeout) {
                $data = [
                    'visit_id' => $visit->visit_id,
                    'visit_date_ended' => ($widget) ? date("Y-m-d H:i:s", strtotime('-' . (isset($custom_widget) ? $widget->widget_visit_timeout : $user->widget_visit_timeout) . ' seconds', time())) : NULL
                ];
                $this->visitModel->endVisit($data);
            }
            if (!empty($visit)) {
                $data = [
                    'visit_id' => $visit->visit_id,
                    'visit_last_activity' => $_SESSION['last_activity']
                ];
                $this->visitModel->updateVisitLastActivity($data);
            }
            
            //ADD VISIT
            if (!last_visit_by_ip_address(ip_address())) {
                $data = [
                    'widget_id' => isset($custom_widget) ? widget_by_uid($custom_widget)->widget_id : NULL,
                    'visit_added_by' => $user->user_id,
                    'visit_location' => (!empty(geoplugin(ip_address())) ? (!empty(geoplugin(ip_address())->geoplugin_city) ? geoplugin(ip_address())->geoplugin_city . ', ' : NULL) . (!empty(geoplugin(ip_address())->geoplugin_countryName) ? geoplugin(ip_address())->geoplugin_countryName : NULL) : NULL),
                    'visit_ip_address' => ip_address(),
                    'visit_platform' => $_SERVER['HTTP_USER_AGENT'],
                    'visit_last_activity' => time(),
                    'visit_date_added' => now()
                ];
                $this->visitModel->addVisit($data);
            }
            
            $data = [
                'user_uid' => $user_uid,
                'assistant_uid' => NULL,
                'custom_widget' => $custom_widget,
                'custom_widget_url' => !empty($custom_widget) ? '/' . $custom_widget : ''
            ];
            $this->view('embedded/js', $data);
            die();
        }
        
        public function record_timeline()
        {
            $datay = [
                'visit_id' => !empty(last_visit_by_ip_address(ip_address())) ? last_visit_by_ip_address(ip_address())->visit_id : NULL,
                'visit_timeline_action' => 'visited',
                'visit_timeline' => isset($_POST['current_url']) ? cleanString($_POST['current_url']) : NULL
            ];
            $this->visitModel->addVisitTimeline($datay);
        }
        
        
        public function upload_link()
        {
            if ($_POST['input_type'] == 'url' && !validate_url($_POST['message'])) {
                $data['input_error'] = 'invalid_url';
            } else {
                $url = $_POST['message'];
                
                $content = @file_get_contents($url);
                
                if ($content !== false) {
                    $file_name = time() . uid(5) . '.txt';
                    $file = fopen(APPROOT . DIRECTORY_SEPARATOR . DOCUMENTS_FOLDER . DIRECTORY_SEPARATOR . $file_name, "w") or die("Unable to open file!");
                    fwrite($file, $content);
                    fclose($file);
                    //Add to DB
                    $data = [
                        'assistant_file' => $url,
                        'assistant_file_size' => filesize(APPROOT . DOCUMENTS_FOLDER . $file_name)
                    ];
                    
                    if ($assistant_file_id = $this->assistantModel->addAssistantFile($data)) {
                        
                        $user = user($_POST['user_id']);
                        //what_question_do_you_have_about_the_uploaded_document
                        $datay = [
                            'is_bot' => 1,
                            'message' => 'start_link_chat',
                            'chat_id' => !empty($_POST['chat_id']) ? cleanString($_POST['chat_id']) : NULL,
                            'assistant_file_id' => $assistant_file_id,
                            'assistant_id' => NULL,
                            'source' => 'link',
                            'source_id' => NULL,
                            'chat_message_added_by' => $user->user_id,
                            'chat_subject' => label('new_chat'),
                            'chat_added_by' => $user->user_id,
                    		'chat_ip_address' => ip_address(),
                            'visit_id' => !empty(last_visit_by_ip_address(ip_address())) ? last_visit_by_ip_address(ip_address())->visit_id : NULL,
                    		'widget_id' => !empty($_POST['widget_id']) ? cleanString($_POST['widget_id']) : NULL
                        ];
                        if (empty($datay['chat_id'])) {
                            $chat_id = $this->chatModel->addChat($datay);
                            $dataz = [
                                'visit_id' => !empty(last_visit_by_ip_address(ip_address())) ? last_visit_by_ip_address(ip_address())->visit_id : NULL,
                                'visit_timeline_action' => 'link_chat_started',
                                'visit_timeline' => NULL
                            ];
                            $this->visitModel->addVisitTimeline($dataz);
                            $data_chat = [
                                'chat_id' => $chat_id
                            ];
                            $this->chatModel->addChatMessage(array_merge($datay, $data_chat));
                        }
                        $this->chatModel->addChatMessage($datay);
                        
                        $local_assistant_file = assistant_file($assistant_file_id);
                        //Upload to OpenAI
                        $uploaded_assistant_file = ai_upload_assistant_file(URLROOT . '/app' . DOCUMENTS_FOLDER . $file_name);
                        if (!empty($uploaded_assistant_file) && $uploaded_assistant_file['status'] == 'error') {
                            $data['input_error'] = $uploaded_assistant_file['message'];
                        } else {
                            //uploaded successfully
                            $datax = [
                                'assistant_file_id' => $assistant_file_id,
                                'assistant_id' => NULL,
                                'assistant_file_output_id' => $uploaded_assistant_file['file_id'],
                                'assistant_file_output_status' => $uploaded_assistant_file['file_status']
                            ];
                            $this->assistantModel->updateAssistantFile($datax);
                            //You can check if status is "processed" here
                            if ($datax['assistant_file_output_status'] == 'processed') {
                                //file_uploaded_and_processed_you_can_now_ask_question
                                //Delete the local file
                                unlinkUploads('documents', $file_name);
                                if ($assistant = ai_create_assistant($datax['assistant_file_output_id'], "You are a website help assistant. The documents attached are the contents of the website ".$url.". Respond as though you are getting the information from the website.")) {
                                    if ($assistant_file = ai_create_assistant_file($assistant_file_id, $datax['assistant_file_output_id'])) {
                                        $local_assistant_file = assistant_file($assistant_file_id);
                                        $datax = [
                                            'assistant_file_id' => $local_assistant_file->assistant_file_id,
                                            'assistant_id' => $assistant['assistant_id'],
                                            'assistant_file_output_id' => $local_assistant_file->assistant_file_output_id,
                                            'assistant_file_output_status' => $local_assistant_file->assistant_file_output_status
                                        ];
                                        $this->assistantModel->updateAssistantFile($datax);
                                        $result = array(
                                            "status" => "success",
                                            "alert" => "success",
                                            "chat_id" => !empty($datay['chat_id']) ? $datay['chat_id'] : $chat_id,
                                            "assistant_id" => $assistant['assistant_id'],
                                            "assistant_file_output_id" => $local_assistant_file->assistant_file_output_id,
                                            "message" => label('start_link_chat')
                                        );
                                    } else {
                                        //Creating assistant file failed
                                        $data['input_error'] = "creating_assistant_file_failed";
                                    }
                                } else {
                                    //Creating assistant failed
                                    $data['input_error'] = "creating_assistant_failed";
                                }
                            } else {
                                //wait a few moments
                                $data['input_error'] = "link_not_yet_processed";
                            }
                        }
                    } else {
                        $data['input_error'] = "link_not_added_to_database";
                    }
                    if (!empty($data['input_error'])) {
                        $result = array(
                            "status" => "error",
                            "alert" => "danger",
                            "message" => $data['input_error']
                        );
                    }
                } else {
                    // File read failed
                    $error = error_get_last(); // Retrieve last error message
                    if ($error !== null) {
                        $data['input_error'] = $error['message']; // Display error message
                    } else {
                        $data['input_error'] = "unknown_error_occurred"; // Fallback message
                    }
                }
            }
            if (!empty($data['input_error'])) {
                $result = array(
                    "status" => "error",
                    "alert" => "danger",
                    "message" => $data['input_error']
                );
            }
            echo json_encode($result);
        }
        
        public function upload_document()
        {
            if (!is_assistant_file_supported($_FILES['file']['name'])) {
                $result = array(
                    "status" => "error",
                    "alert" => "danger",
                    "message" => 'unsupported_file_type'
                );
            } else {
                $document = fileExists(APPROOT . DOCUMENTS_FOLDER, $_FILES['file']['name']);
                if (any_file($document, 'documents', $_FILES['file']['tmp_name'])) {
                    //Add to DB
                    $data = [
                        'assistant_file' => $document,
                        'assistant_file_size' => filesize(APPROOT . DOCUMENTS_FOLDER . $document)
                    ];
                    
                    if ($assistant_file_id = $this->assistantModel->addAssistantFile($data)) {
                        
                        $user = user($_POST['user_id']);
                        //what_question_do_you_have_about_the_uploaded_document
                        $datay = [
                            'is_bot' => 1,
                            'message' => 'start_document_chat',
                            'chat_id' => !empty($_POST['chat_id']) ? cleanString($_POST['chat_id']) : NULL,
                            'assistant_file_id' => $assistant_file_id,
                            'assistant_id' => NULL,
                            'source' => 'file',
                            'source_id' => NULL,
                            'chat_message_added_by' => $user->user_id,
                            'chat_subject' => label('new_chat'),
                            'chat_added_by' => $user->user_id,
                    		'chat_ip_address' => ip_address(),
                            'visit_id' => !empty(last_visit_by_ip_address(ip_address())) ? last_visit_by_ip_address(ip_address())->visit_id : NULL,
                    		'widget_id' => !empty($_POST['widget_id']) ? cleanString($_POST['widget_id']) : NULL
                        ];
                        if (empty($datay['chat_id'])) {
                            $chat_id = $this->chatModel->addChat($datay);
                            $dataz = [
                                'visit_id' => !empty(last_visit_by_ip_address(ip_address())) ? last_visit_by_ip_address(ip_address())->visit_id : NULL,
                                'visit_timeline_action' => 'document_chat_started',
                                'visit_timeline' => NULL
                            ];
                            $this->visitModel->addVisitTimeline($dataz);
                            $data_chat = [
                                'chat_id' => $chat_id
                            ];
                        }
                        $this->chatModel->addChatMessage($datay);
                        
                        $local_assistant_file = assistant_file($assistant_file_id);
                        //Upload to OpenAI
                        $uploaded_assistant_file = ai_upload_assistant_file(URLROOT . '/app' . DOCUMENTS_FOLDER . $local_assistant_file->assistant_file);
                        if (!empty($uploaded_assistant_file) && $uploaded_assistant_file['status'] == 'error') {
                            $data['input_error'] = $uploaded_assistant_file['message'];
                        } else {
                            //uploaded successfully
                            $datax = [
                                'chat_id' => !empty($datay['chat_id']) ? $datay['chat_id'] : $data_chat['chat_id'],
                                'assistant_file_id' => $assistant_file_id,
                                'assistant_id' => NULL,
                                'assistant_file_output_id' => $uploaded_assistant_file['file_id'],
                                'assistant_file_output_status' => $uploaded_assistant_file['file_status']
                            ];
                            $this->assistantModel->updateAssistantFile($datax);
                            //You can check if status is "processed" here
                            if ($datax['assistant_file_output_status'] == 'processed') {
                                //file_uploaded_and_processed_you_can_now_ask_question
                                //Delete the local file
                                unlinkUploads('documents', $local_assistant_file->assistant_file);
                                if ($assistant = ai_create_assistant($datax['assistant_file_output_id'], "You are a helpful assistant.")) {
                                    if ($assistant_file = ai_create_assistant_file($assistant_file_id, $datax['assistant_file_output_id'])) {
                                        $local_assistant_file = assistant_file($assistant_file_id);
                                        $datax = [
                                            'assistant_file_id' => $local_assistant_file->assistant_file_id,
                                            'assistant_id' => $assistant['assistant_id'],
                                            'assistant_file_output_id' => $local_assistant_file->assistant_file_output_id,
                                            'assistant_file_output_status' => $local_assistant_file->assistant_file_output_status
                                        ];
                                        $this->assistantModel->updateAssistantFile($datax);
                                        $result = array(
                                            "status" => "success",
                                            "alert" => "success",
                                            "assistant_id" => $assistant['assistant_id'],
                                            "assistant_file_output_id" => $local_assistant_file->assistant_file_output_id,
                                            "message" => label('start_document_chat')
                                        );
                                    } else {
                                        //Creating assistant file failed
                                        $data['input_error'] = "creating_assistant_file_failed";
                                    }
                                } else {
                                    //Creating assistant failed
                                    $data['input_error'] = "creating_assistant_failed";
                                }
                            } else {
                                //wait a few moments
                                $data['input_error'] = "file_not_yet_processed";
                            }
                        }
                    } else {
                        $data['input_error'] = "file_not_added_to_database";
                    }
                } else {
                    $data['input_error'] = "file_upload_failed";
                }
                if (!empty($data['input_error'])) {
		            log_custom_error($user->user_id, get_error_message(ERR_OPENAI_ASSISTANT, $data['input_error'])[1]);
                    $result = array(
                        "status" => "error",
                        "alert" => "danger",
                        "message" => $data['input_error']
                    );
                }
            }
            echo json_encode($result);
        }
        
        public function create_thread()
        {
            if ($_SERVER['REQUEST_METHOD'] == 'POST') {
                $_POST = sanitize_post();
                
                $assistant_id = NULL;
                if(getOption('assistant_version') == 'v1'){
	                if(!empty($_POST['assistant_id'])){
	                	$assistant_id = cleanString($_POST['assistant_id']);
					}else{
						$ai_create_assistant = ai_create_assistant($_POST['assistant_file_id'], cleanString($_POST['chat_instructions']));
						if(($ai_create_assistant['status'] == 'success')){
							$assistant_id = $ai_create_assistant['assistant_id'];
						}else{
							$assistant_id = array($ai_create_assistant['message']);
						}
					}
				}else{
					if(!isset($_POST['assistant_file_id'])){
						$assistant_id = whatsapp_files($_POST['user_id'])->assistant_id;
					}else{
						$vector_store = ai_create_vector_store($_POST['assistant_file_id']);
						if (!empty($vector_store) && $vector_store['status'] == 'error') {
							$data['input_error'] = $vector_store['message'];
			            	log_custom_error($_POST['user_id'], get_error_message(ERR_OPENAI_ASSISTANT, $vector_store['message'])[1]);
						}else{
							$ai_create_assistant_v2 = ai_create_assistant_v2($vector_store['vector_store_id'], cleanString($_POST['chat_instructions']));
							if($ai_create_assistant_v2['status'] == 'success'){
								$assistant_id = $ai_create_assistant_v2['assistant_id'];
							}else{
								$assistant_id = array($ai_create_assistant_v2['message']);
							}
						}
					}
				}
                
                $data = [
                    'user_id' => cleanString($_POST['user_id']),
                    'chat_id' => !empty($_POST['chat_id']) ? cleanString($_POST['chat_id']) : NULL,
                    'assistant_id' => $assistant_id,
                    'thread_id' => isset($_POST['thread_id']) ? cleanString($_POST['thread_id']) : NULL,
                    'assistant_file_id' => isset($_POST['assistant_file_id']) ? cleanString($_POST['assistant_file_id']) : NULL,
                    'message' => cleanString($_POST['message']),
                    'chat_subject' => label('new_chat'),
                    'source' => !empty($_POST['widget_id']) ? widget_chat_source($_POST['widget_id'])['source'] : NULL,
                    'source_id' => !empty($_POST['widget_id']) ? widget_chat_source($_POST['widget_id'])['source_id'] : NULL,
                    'chat_added_by' => cleanString($_POST['user_id']),
                    'chat_ip_address' => ip_address(),
                    'visit_id' => !empty(last_visit_by_ip_address(ip_address())) ? last_visit_by_ip_address(ip_address())->visit_id : NULL,
                    'widget_id' => !empty($_POST['widget_id']) ? cleanString($_POST['widget_id']) : NULL
                ];
                
                if (empty($data['message'])) {
                    $data['input_error'] = label('please_enter_message');
                } 
                
                if(is_array($data['assistant_id'])){
					$data['input_error'] = $data['assistant_id'][0];
		            log_custom_error($data['user_id'], get_error_message(ERR_OPENAI_ASSISTANT, $data['assistant_id'][0])[1]);
				}else{
	                if (empty($data['chat_id'])) {
	                    $chat_id = $this->chatModel->addChat($data);
	                    $dataz = [
	                        'visit_id' => !empty(last_visit_by_ip_address(ip_address())) ? last_visit_by_ip_address(ip_address())->visit_id : NULL,
	                        'visit_timeline_action' => 'document_chat_started',
	                        'visit_timeline' => NULL
	                    ];
	                    $this->visitModel->addVisitTimeline($dataz);
	                }
	                if (!empty($data['thread_id']) && ai_retrieve_thread($data['thread_id'])) {
	                    $thread = ai_create_thread_message($data['thread_id'], $data['message']);
	                    if (!empty($thread) && $thread['status'] == 'error') {
	                        $data['input_error'] = $thread['message'];
			            	log_custom_error($data['user_id'], get_error_message(ERR_OPENAI_ASSISTANT, $thread['message'])[1]);
	                    } else {
	                        $result = array(
	                            "status" => "success",
	                            "alert" => "success",
	                            "thread_id" => $thread['thread_id'],
	                            "message" => NULL,
	                            
	                            "data" => array(
	                                "user_id" => $data['user_id'],
	                                "chat_id" => !empty($data['chat_id']) ? $data['chat_id'] : $chat_id,
	                                'thread_id' => $thread['thread_id'],
	                                'assistant_id' => $data['assistant_id'],
	                                'assistant_file_id' => $data['assistant_file_id'],
	                                'message' => $data['message']
	                            )
	                        );
	                    }
	                } else {
	                    $thread = ai_create_thread($data['assistant_file_id'], $data['message']);
	                    if (!empty($thread) && $thread['status'] == 'error') {
	                        $data['input_error'] = $thread['message'];
			            	log_custom_error($data['user_id'], get_error_message(ERR_OPENAI_ASSISTANT, $thread['message'])[1]);
	                    } else {
	                        $result = array(
	                            "status" => "success",
	                            "alert" => "success",
	                            "thread_id" => $thread['thread_id'],
	                            "assistant_file_id" => $data['assistant_file_id'],
	                            "message" => NULL,
	                            
	                            "data" => array(
	                                "user_id" => $data['user_id'],
	                                "chat_id" => !empty($data['chat_id']) ? $data['chat_id'] : $chat_id,
	                                'thread_id' => $thread['thread_id'],
	                                'assistant_id' => $data['assistant_id'],
	                                'assistant_file_id' => $data['assistant_file_id'],
	                                'message' => $data['message']
	                            )
	                        );
	                    }
	                }
				}
                if (!empty($data['input_error'])) {
		            log_custom_error($data['user_id'], get_error_message(ERR_OPENAI_ASSISTANT, $data['input_error'])[1]);
                    $result = array(
                        "status" => "error",
                        "alert" => "danger",
                        "message" => get_error_message(ERR_OPENAI_ASSISTANT, $data['input_error'])[0]
                    );
                }
                echo json_encode($result);
            }
        }
        
        public function create_thread_message()
        {
            if ($_SERVER['REQUEST_METHOD'] == 'POST') {
                $_POST = sanitize_post();
                $data = [
                    'user_id' => cleanString($_POST['user_id']),
                    'chat_id' => !empty($_POST['chat_id']) ? cleanString($_POST['chat_id']) : NULL,
                    'assistant_id' => cleanString($_POST['assistant_id']),
                    'thread_id' => cleanString($_POST['thread_id']),
                    'assistant_file_id' => isset($_POST['assistant_file_id']) ? cleanString($_POST['assistant_file_id']) : NULL,
                    'message' => cleanString($_POST['message'])
                ];
                if (!empty($data['thread_id']) && ai_retrieve_thread($data['thread_id'])) {
                    $thread = ai_create_thread_message($data['thread_id'], $data['message']);
                    if (!empty($thread) && $thread['status'] == 'error') {
                        $data['input_error'] = $thread['message'];
		            	log_custom_error($data['user_id'], get_error_message(ERR_OPENAI_ASSISTANT, $thread['message'])[1]);
                    } else {
                        $datay = [
                            'is_bot' => NULL,
                            'assistant_file_id' => !empty(assistant_file_by_output_id($data['assistant_file_id'])) ? assistant_file_by_output_id($data['assistant_file_id'])->assistant_file_id : (!empty(chat_file_by_output_id($data['assistant_file_id'])) ? chat_file_by_output_id($data['assistant_file_id'])->chat_file_id : NULL),
                            'chat_message_added_by' => $data['user_id']
                        ];
                        $this->chatModel->addChatMessage(array_merge($data, $datay));
                        $result = array(
                            "status" => "success",
                            "alert" => "success",
                            "thread_id" => $thread['thread_id'],
                            "assistant_id" => $data['assistant_id'],
                            "assistant_file_id" => $data['assistant_file_id'],
                            "user_id" => $data['user_id'],
                            "chat_id" => $data['chat_id'],
                            "message" => $data['message'],
                            
                            "data" => array(
                                "user_id" => $data['user_id'],
                                "chat_id" => $data['chat_id'],
                                'thread_id' => $thread['thread_id'],
                                'assistant_id' => $data['assistant_id'],
                                'assistant_file_id' => $data['assistant_file_id'],
                                'message' => $data['message']
                            )
                        );
                    }
                } else {
                    $thread = ai_create_thread($data['assistant_file_id'], $data['message']);
                    if (!empty($thread) && $thread['status'] == 'error') {
                        $data['input_error'] = $thread['message'];
		            	log_custom_error($data['user_id'], get_error_message(ERR_OPENAI_ASSISTANT, $thread['message'])[1]);
                    } else {
                        $datay = [
                            'is_bot' => NULL,
                            'assistant_file_id' => assistant_file_by_output_id($data['assistant_file_id'])->assistant_file_id,
                            'chat_message_added_by' => $data['user_id']
                        ];
                        $this->chatModel->addChatMessage(array_merge($data, $datay));
                        $result = array(
                            "status" => "success",
                            "alert" => "success",
                            "thread_id" => $thread['thread_id'],
                            "assistant_id" => $data['assistant_id'],
                            "assistant_file_id" => $data['assistant_file_id'],
                            "user_id" => $data['user_id'],
                            "chat_id" => $data['chat_id'],
                            "message" => $data['message'],
                            
                            "data" => array(
                                "user_id" => $data['user_id'],
                                "chat_id" => $data['chat_id'],
                                'thread_id' => $thread['thread_id'],
                                'assistant_id' => $data['assistant_id'],
                                'assistant_file_id' => $data['assistant_file_id'],
                                'message' => $data['message']
                            )
                        );
                    }
                }
                if (!empty($data['input_error'])) {
                    $result = array(
                        "status" => "error",
                        "alert" => "danger",
                        "message" => get_error_message(ERR_OPENAI_ASSISTANT, $data['input_error'])[0]
                    );
                }
                echo json_encode($result);
            }
        }
        
        public function create_run()
        {
            if ($_SERVER['REQUEST_METHOD'] == 'POST') {
                $_POST = sanitize_post();
                $data = [
                    'user_id' => cleanString($_POST['user_id']),
                    'chat_id' => cleanString($_POST['chat_id']),
                    'assistant_id' => cleanString($_POST['assistant_id']),
                    'thread_id' => cleanString($_POST['thread_id']),
                    'assistant_file_id' => isset($_POST['assistant_file_id']) ? cleanString($_POST['assistant_file_id']) : NULL
                ];
                $run = ai_create_run($data['thread_id'], $data['assistant_id']);
                if (!empty($run) && $run['status'] == 'success') {
                    $result = array(
                        "status" => "success",
                        "alert" => "success",
                        "run_id" => $run['run_id'],
                        "thread_id" => $data['thread_id'],
                        "assistant_id" => $data['assistant_id'],
                        "assistant_file_id" => $data['assistant_file_id'],
                        "user_id" => $data['user_id'],
                        "chat_id" => $data['chat_id'],
                        "message" => NULL,
                        
                        "data" => array(
                        	"status" => "success",
                            "run_id" => $run['run_id'],
                            "user_id" => $data['user_id'],
                            "chat_id" => $data['chat_id'],
                            'thread_id' => $data['thread_id'],
                            'assistant_id' => $data['assistant_id'],
                            'assistant_file_id' => $data['assistant_file_id']
                        )
                    );
                } else {
                    $data['input_error'] = $run['message'];
		            log_custom_error($data['user_id'], get_error_message(ERR_OPENAI_ASSISTANT, $run['message'])[1]);
                }
                if (!empty($data['input_error'])) {
                    $result = array(
                        "status" => "error",
                        "alert" => "danger",
                        "message" => get_error_message(ERR_OPENAI_ASSISTANT, $data['input_error'])[0]
                    );
                }
                echo json_encode($result);
            }
        }
        
        public function retrieve_run()
        {
            if ($_SERVER['REQUEST_METHOD'] == 'POST') {
                $_POST = sanitize_post();
                $data = [
                    'user_id' => cleanString($_POST['user_id']),
                    'chat_id' => cleanString($_POST['chat_id']),
                    'assistant_id' => cleanString($_POST['assistant_id']),
                    'thread_id' => cleanString($_POST['thread_id']),
                    'assistant_file_id' => isset($_POST['assistant_file_id']) ? cleanString($_POST['assistant_file_id']) : NULL,
                    'run_id' => cleanString($_POST['run_id'])
                ];
                $run = ai_retrieve_run($data['thread_id'], $data['run_id']);
                if (!empty($run) && $run['status'] == 'success') {
                    if ($run['run_status'] == 'completed') {
                        $result = array(
                            "status" => "success",
                            "alert" => "success",
                            "run_id" => $run['run_id'],
                            "thread_id" => $data['thread_id'],
                            "assistant_id" => $data['assistant_id'],
                            "assistant_file_id" => $data['assistant_file_id'],
                            "user_id" => $data['user_id'],
                            "chat_id" => $data['chat_id'],
                            "message" => NULL,
                            
                            "data" => array(
                                "run_id" => $run['run_id'],
                                "user_id" => $data['user_id'],
                                "chat_id" => $data['chat_id'],
                                'thread_id' => $data['thread_id'],
                                'assistant_id' => $data['assistant_id'],
                                'assistant_file_id' => $data['assistant_file_id']
                            )
                        );
                    } elseif (in_array($run['run_status'], array('queued', 'in_progress'))) {
                        $result = array(
                            "status" => "wait",
                            "alert" => "warning",
                            "run_status" => $run['run_status']
                        );
                    } else {
                        $data['input_error'] = $run['last_error']['message'];
		            	log_custom_error($data['user_id'], get_error_message(ERR_OPENAI_ASSISTANT, $run['last_error']['message'])[1]);
                        $result = array(
                            "status" => "error",
                            "alert" => "danger",
                            "message" => get_error_message(ERR_OPENAI_ASSISTANT, $run['last_error']['message'])[0]
                        );
                    }
                } else {
                    $data['input_error'] = $run['message'];
		            log_custom_error($data['user_id'], get_error_message(ERR_OPENAI_ASSISTANT, $run['message'])[1]);
                }
                if (!empty($data['input_error'])) {
                    $result = array(
                        "status" => "error",
                        "alert" => "danger",
                        "message" => get_error_message(ERR_OPENAI_ASSISTANT, $data['input_error'])[0]
                    );
                }
                echo json_encode($result);
            }
        }
        
        public function list_messages()
        {
            if ($_SERVER['REQUEST_METHOD'] == 'POST') {
                $_POST = sanitize_post();
                $data = [
                    'chat_id' => cleanString($_POST['chat_id']),
                    'user_id' => cleanString($_POST['user_id']),
                    'assistant_id' => cleanString($_POST['assistant_id']),
                    'thread_id' => cleanString($_POST['thread_id']),
                    'assistant_file_id' => isset($_POST['assistant_file_id']) ? cleanString($_POST['assistant_file_id']) : NULL,
                    /*'run_id' => cleanString($_POST['run_id'])*/
                ];
                if (!empty($data['thread_id'])) {
                    $messages = ai_list_messages($data['thread_id']);
                    if (!empty($messages) && $messages['status'] == 'error') {
                        $data['input_error'] = $messages['message'];
		            	log_custom_error($data['user_id'], get_error_message(ERR_OPENAI_ASSISTANT, $messages['message'])[1]);
                    } elseif (!empty($messages) && $messages['status'] == 'wait') {
                        $result = array(
                            "status" => "wait",
                            "alert" => "warning",
                            "thread_id" => $data['thread_id'],
                            "assistant_id" => $data['assistant_id'],
                            "assistant_file_id" => $data['assistant_file_id'],
                            "user_id" => $data['user_id'],
                            "chat_id" => $data['chat_id'],
                            "message" => $messages['message'],
                            
                            "data" => array(
                                "user_id" => $data['user_id'],
                                "chat_id" => $data['chat_id'],
                                'thread_id' => $data['thread_id'],
                                'assistant_id' => $data['assistant_id'],
                                'assistant_file_id' => $data['assistant_file_id'],
                                'message' => $messages['message']
                            )
                        );
                    } else {
                    	if(!isset($_POST['dont_post'])){
	                        foreach (array_reverse($messages['data']) as $msg) {
	                            $datay = [
	                                'is_bot' => 1,
	                                'message' => $msg,
	                                'chat_id' => !empty($data['chat_id']) ? cleanString($data['chat_id']) : NULL,
	                                'assistant_file_id' => NULL,
	                                'chat_message_added_by' => $data['user_id']
	                            ];
	                            $out =  $this->chatModel->addChatMessage($datay);
	                        }
						}
                        $result = array(
                            "status" => "success",
                            "alert" => "success",
                            "messages" => $messages['data'],
                            "message" => NULL,
                            
                            "data" => array(
                                'messages' => $messages['data']
                            )
                        );
                    }
                }
                if (!empty($data['input_error'])) {
                    $result = array(
                        "status" => "error",
                        "alert" => "danger",
                        "messages" => "",
                        "message" => get_error_message(ERR_OPENAI_ASSISTANT, $data['input_error'])[0]
                    );
                }
                echo json_encode($result);
            }
        }
        
        public function generate_document_chat()
        {
            if ($_SERVER['REQUEST_METHOD'] == 'POST') {
                if (!empty($_POST['data'])) {
                    $result = array(
                        "status" => "success",
                        "text" => cleanString($_POST['data'], 'ignore_tags')
                    );
                } else {
                    $result = array(
                        "status" => "error",
                        "message" => get_error_message(ERR_OPENAI_ASSISTANT, 'unknown_error')[0]
                    );
                }
                echo json_encode($result);
            }
        }
        
        public function stop_document_link_chat()
        {
            if ($_SERVER['REQUEST_METHOD'] == 'POST') {
                $_POST = sanitize_post();
                $data = [
                    'run_id' => cleanString($_POST['run_id']),
                    'thread_id' => cleanString($_POST['thread_id'])
                ];
                $run = ai_cancel_run($data['thread_id'], $data['run_id']);
                if (!empty($run) && $run['status'] == 'error') {
                    $data['input_error'] = $run['message'];
                } else {
                    $result = array(
                        "status" => "success",
                        "alert" => "success",
                        "run_id" => $run['run_id'],
                        "thread_id" => $data['thread_id'],
                        "assistant_id" => $data['assistant_id'],
                        "assistant_file_id" => $data['assistant_file_id'],
                        "user_id" => $data['user_id'],
                        "chat_id" => $data['chat_id'],
                        "message" => NULL
                    );
                }
                if (!empty($data['input_error'])) {
                    $result = array(
                        "status" => "error",
                        "alert" => "danger",
                        "message" => get_error_message(ERR_OPENAI_ASSISTANT, $data['input_error'])[0]
                    );
                }
                echo json_encode($result);
            }
        }
        
    }