<?php
    
    
    class Favs extends Controller
    {
        public function __construct()
        {
            if (!isLoggedIn()) {
                logout();
            }
            require APPROOT . '/views/inc/load_models.php';
        }
        
        public function index()
        {
            $data = [
                'favs' => favs(user_id())
            ];
            $this->view('favs/index', $data);
        }
        
        public function add()
        {
            if ($_SERVER['REQUEST_METHOD'] == 'POST') {
                $_POST = sanitize_post();
                $data = [
                    'fav_added_by' => user_id(),
                    'chat_assistant_id' => cleanString($_POST['chat_assistant_id'])
                ];
                if (empty($data['chat_assistant_id'])) {
                    $data['input_error'][] = 'please_select_favourite_chat_assistant';
                }
                if (empty($data['input_error'])) {
                    if ($id = $this->favModel->addFav($data)) {
                        addActivityLog('fav', $id, 'chat_assistant_added_to_favourites');
                        flash('user_message', 'favs', 'chat_assistant_added_to_favourites');
                    } else {
                        flash('user_message', 'favs', 'adding_chat_assistant_to_favourites_failed', 'danger');
                    }
                } else {
                    flash('user_message', 'favs', $data['input_error'], 'danger');
                }
            }
            redirect(referrer_without_urlroot(referrer()));
            die();
        }
        
        public function remove($id)
        {
            $fav = fav($id);
            if (empty($fav)) {
                redirect(404);
            }
            
            if ($_SERVER['REQUEST_METHOD'] == 'POST') {
                $_POST = sanitize_post();
                if ($fav->fav_added_by != user_id()) {
                    $data['input_error'] = 'favorite_chat_assistant_cannot_be_removed';
                }
                
                if (empty($data['input_error'])) {
                    if ($this->favModel->deleteFav($id)) {
                        addActivityLog('fav', $id, 'chat_assistant_removed_from_favourites');
                        flash('user_message', 'favs', 'chat_assistant_removed_from_favourites');
                    } else {
                        flash('user_message', 'favs', 'removing_chat_assistant_from_favourites_failed', 'danger');
                    }
                } else {
                    flash('user_message', 'favs', $data['input_error'], 'danger');
                }
            }
            redirect(referrer_without_urlroot(referrer()));
            die();
        }
        
        
    }
