<?php
    
    
    class Files extends Controller
    {
        public function __construct()
        {
            if (!isLoggedIn()) {
                logout();
                die();
            }
            
            $subscription = has_valid_subscription(user_id());
            
            if (!$subscription) {
                flash('user_message', 'chats', 'you_do_not_have_an_active_subscription', 'danger');
                redirect('packages/all');
                die();
            }
            require APPROOT . '/views/inc/load_models.php';
        }
        
        public function index()
        {
            $data = [
                'chat_files' => chat_files(user_id())
            ];
            $this->view('files/index', $data);
        }
        
        public function upload()
        {
            $subscription = has_valid_subscription(user_id());
            
            if (!$subscription) {
                $flash = 'you_do_not_have_an_active_subscription';
            }
            if ($subscription && (int)user(user_id())->user_remaining_chat_files == 0) {
                $flash = 'maximum_number_of_chat_files_in_your_subscription_package_reached';
            }
            if (isset($flash)) {
                flash('user_message', 'file', $flash, 'danger');
                redirect('files');
                die();
            }
            $this->view('files/upload');
        }
        
        public function upload_file()
        {
            $subscription = has_valid_subscription(user_id());
            
            if (!$subscription) {
                $data['input_error'] = 'you_do_not_have_an_active_subscription';
            }
            if ($subscription && (int)user(user_id())->user_remaining_chat_files == 0) {
                $data['input_error'] = 'maximum_number_of_chat_files_in_your_subscription_package_reached';
            }
            if ($_FILES['file']['error'] === UPLOAD_ERR_OK) {
                $data['input_error'] = $_FILES['file']['error'];
            }
            if (empty($data['input_error'])) {
                $target_dir = APPROOT . MEDIA_FOLDER;
                for($i = 0; $i < count($_FILES['file']['name']); $i++){
                $file = fileExists(APPROOT . MEDIA_FOLDER, trim($_FILES['file']['name'][$i]));
                if (move_uploaded_file($_FILES['file']['tmp_name'][$i], $target_dir . $file)) {
                    $data = [
                        'chat_file' => $file,
                        'chat_file_size' => filesize(APPROOT . MEDIA_FOLDER . $file),
                        'chat_link' => NULL
                    ];
                    $file_id = $this->chatfileModel->addChatFile($data);
                    
                    $dataw = [
                        'user_id' => user_id(),
                        'user_remaining_words' => (int)user(user_id())->user_remaining_words,
                        'user_remaining_chat_assistants' => (int)user(user_id())->user_remaining_chat_assistants,
                        'user_remaining_trained_models' => (int)user(user_id())->user_remaining_trained_models,
                        'user_remaining_chat_files' => (user(user_id())->user_remaining_chat_files > 0) ? (int)user(user_id())->user_remaining_chat_files - 1 : -1,
                        'user_remaining_chat_links' => (int)user(user_id())->user_remaining_chat_links,
                        'user_remaining_chat_sitemaps' => (int)user(user_id())->user_remaining_chat_sitemaps
                    ];
                    
                    $dataz = [
                        'user_id' => user_id(),
                        'type' => 'chat_files',
                        'transaction_type' => 'out',
                        'package_id' => NULL,
                        'openai_template_id' => NULL,
                        'old' => ($dataw['user_remaining_chat_files'] == -1) ? -1 : $dataw['user_remaining_chat_files'] + 1,
                        'current' => $dataw['user_remaining_chat_files'],
                        'user_package_history_comment' => 'Chat File: ' . $file_id,
                        'user_package_history_added_by' => user_id()
                    ];
                    $this->userModel->addUserPackageHistory($dataz);
                    $this->userModel->editUserRemaining($dataw);
                    
                    $result = array(
                        "chat_file_id" => $file_id,
                        "chat_file" => URLROOT . '/app' . MEDIA_FOLDER . $file,
                        "status" => true,
                        "message" => label('file_uploaded_successfully')
                    );
                } else {
                    $result = array(
                        "chat_file_id" => false,
                        "chat_file" => false,
                        "status" => false,
                        "message" => label('failed_to_upload_file')
                    );
                }
                $file_ids[] = $file_id;
				}
				if($_POST['upload_for_chat']){
					foreach($file_ids as $file_for_chat){
						$response = ai_upload_assistant_file(URLROOT . '/app' . MEDIA_FOLDER . chat_file($file_for_chat)->chat_file);
						if($response['status'] == 'success'){
							$datax = [
		                        'chat_file_id' => $file_for_chat,
		                        'chat_file_output_id' => $response['file_id'],
		                        'chat_file_output_filename' => $response['filename'],
		                        'chat_file_output_size' => $response['bytes'],
		                        'chat_file_output_status' => $response['file_status']
		                    ];
		                    $this->chatfileModel->updateChatFileOutput($datax);
						}
					}
				}
            } else {
                $result = array(
                    "chat_file_id" => false,
                    "chat_file" => false,
                    "status" => false,
                    "message" => label($data['input_error'])
                );
            }
            echo json_encode($result);
        }
        
        public function upload_for_chat($id = NULL)
        {
        	$chat_file = chat_file($id);
            if (empty($chat_file) || $chat_file->chat_file_added_by != user_id()) {
                redirect(404);
                die();
            }
            if ($_SERVER['REQUEST_METHOD'] == 'GET') {
                $data = [
                    'chat_file_id' => $id
                ];
                
                if (is_null($chat_file->chat_file_output_id)) {
                    $response = ai_upload_assistant_file(URLROOT . '/app' . MEDIA_FOLDER . $chat_file->chat_file);
                    
                    if (!empty($response) && $response['status'] == 'error') {
                        $data['input_error'] = $response['message'];
                    }
                } else {
                    $data['input_error'] = "file_already_uploaded";
                }
                
                if (empty($data['input_error']) && isset($response)) {
                    $datax = [
                        'chat_file_id' => $id,
                        'chat_file_output_id' => $response['file_id'],
                        'chat_file_output_filename' => $response['filename'],
                        'chat_file_output_size' => $response['bytes'],
                        'chat_file_output_status' => $response['file_status']
                    ];
                    if ($this->chatfileModel->updateChatFileOutput($datax)) {
                        addActivityLog('file', $id, 'file_uploaded_for_chatting');
                        flash('user_message', 'file', 'file_uploaded_for_chatting');
                    } else {
                        flash('user_message', 'file', 'uploading_file_for_chatting_failed', 'danger');
                    }
                } else {
                    flash('user_message', 'file', $data['input_error'], 'danger');
                }
            }
            redirect('files/show/' . $id);
            die();
        }
        
        public function show($id = NULL)
        {
            $chat_file = chat_file($id);
            if (empty($chat_file) || $chat_file->chat_file_added_by != user_id()) {
                redirect(404);
                die();
            }
            
            $data = [
                'chat_file' => $chat_file
            ];
            $this->view('files/show', $data);
        }
        
        public function chat_file($id = NULL)
        {
            $chat_file = chat_file($id);
            if (empty($chat_file) || $chat_file->chat_file_added_by != user_id()) {
                redirect(404);
                die();
            }
            redirect('chats/file/' . $id);
            die();
        }
        
        public function delete($id = NULL)
        {
            $chat_file = chat_file($id);
            if (empty($chat_file) || $chat_file->chat_file_added_by != user_id()) {
                redirect(404);
                die();
            }
            if ($_SERVER['REQUEST_METHOD'] == 'GET') {
                $_GET = sanitize_get();
                if ($this->chatfileModel->deleteChatFile($id)) {
                    unlinkUploads('media', $chat_file->chat_file);
                    if (!empty($chat_file->chat_file_output_id)) {
                        ai_delete_file($chat_file->chat_file_output_id);
                    }
                    addActivityLog('file', $id, 'file_deleted');
                    flash('user_message', 'file', 'file_deleted');
                } else {
                    flash('user_message', 'file', 'file_delete_failed', 'danger');
                }
            }
            redirect('files');
            die();
        }
        
        
    }