<?php
    
    
    class Listeners extends Controller
    {
        public function __construct()
        {
            require APPROOT . '/views/inc/load_models.php';
        }
        
        public function index()
        {
            redirect('dashboards');
        }
        
        public function paypal_ipn_listener()
        {
            $paypal_standard_live_enabled = $this->settingModel->getOptions('paypal_standard_live_enabled');
            $paypal_standard_settings = $this->settingModel->getPaypalStandardSettings($paypal_standard_live_enabled->option_value);
            
            $explode = explode("|", $_POST['custom']);
            if (isset($_POST['ipn_track_id']) && !empty($_POST['ipn_track_id']) && $_POST['mc_gross'] == package_cost($explode[1], $explode[2])) {
                $data = [
                    'subscription_cost' => $_POST['mc_gross'],
                    'subscription_uid' => uid(),
                    'transaction_id' => $_POST['txn_id'],
                    'payment_option_id' => payment_option_slug('paypal_standard')->payment_option_id,
                    'subscription_added_by' => $explode[0],
                    'transaction_reference' => NULL,
                    'package_id' => $explode[1],
                    'package_duration' => package_duration($explode[1], $explode[2])[0],
                    'package_duration_type' => package_duration($explode[1], $explode[2])[1],
                    'subscription_items' => json_encode(package($explode[1]))
                ];
                if ($subscription_id = $this->subscriptionModel->addSubscriptionPayment($data)) {
                    if (affiliate_accepted($subscription_id)) {
                        $dataA = [
                            'user_id' => user(subscription($subscription_id)->user_id)->referred_by,
                            'affiliate_rule_id' => getOption('affiliate_rule_id'),
                            'affiliate_commission_rate' => getOption('affiliate_commission_rate'),
                            'subscription_id' => $subscription_id
                        ];
                        $this->affiliateModel->addAffiliate($dataA);
                    }
                    if (getOption('approve_subscription_automatically') && payment_option($data['payment_option_id'])->payment_option_online == 1) {
                        $dataw = [
                            'user_id' => $explode[0],
                            'user_remaining_words' => add_user_remaining_balances($explode[0], $subscription_id, 'words'),
                            'user_remaining_chat_assistants' => add_user_remaining_balances($explode[0], $subscription_id, 'chat_assistants'),
                            'user_remaining_trained_models' => add_user_remaining_balances($explode[0], $subscription_id, 'trained_models'),
                            'user_remaining_chat_files' => add_user_remaining_balances($explode[0], $subscription_id, 'chat_files'),
                            'user_remaining_chat_links' => add_user_remaining_balances($explode[0], $subscription_id, 'chat_links'),
                            'user_remaining_chat_sitemaps' => add_user_remaining_balances($explode[0], $subscription_id, 'chat_sitemaps')
                        ];
                        foreach (package_types() as $type) {
                            $out_type = 'user_remaining_' . $type;
                            $dataz = [
                                'user_id' => $explode[0],
                                'type' => $type,
                                'transaction_type' => 'in',
                                'package_id' => $explode[1],
                                'old' => (int)user($explode[0])->$out_type,
                                'current' => $dataw[$out_type],
                                'user_package_history_comment' => json_encode(package($explode[1])),
                                'user_package_history_added_by' => $explode[0]
                            ];
                            $this->userModel->addUserPackageHistory($dataz);
                        }
                        $this->userModel->editUserRemaining($dataw);
                    }
                    sendEmail('SubscriptionPaid', user($explode[0])->email, 'subscriptions', $subscription_id, $explode[0]);
                    notificationToUser('subscription_paid', 1, 'subscriptions/show/' . $subscription_id);
                    addActivityLog('subscription', $subscription_id, 'paypal_standard_payment_added');
                }
            }
        }
        
        public function tap_listener()
        {
        	
        }
        
    }