<?php
    
    
    class Pmt_aamarpay extends Controller
    {
        public function __construct()
        {
            if (!isLoggedIn()) {
                logout();
            }
            require APPROOT . '/views/inc/load_models.php';
        }
        
        public function index()
        {
            $aamarpay_live_enabled = $this->settingModel->getOptions('aamarpay_live_enabled');
            $aamarpay_settings = $this->settingModel->getAamarpaySettings($aamarpay_live_enabled->option_value);
            
            if ($_SERVER['REQUEST_METHOD'] == 'POST') {
            	
            	$fields = array(
                    'store_id' => $aamarpay_settings->aamarpay_store_id,
                    'amount' => package_cost($_POST['package_id'], $_POST['package_group']),
                    'payment_type' => '',
                    'currency' => getOption('default_currency'),
                    'tran_id' => strtoupper(uid(10)),
                    'cus_name' => user(user_id())->firstname . ' ' . user(user_id())->lastname,
                    'cus_email' => user(user_id())->email,
                    'cus_add1' => user(user_id())->city,
                    'cus_add2' => user(user_id())->street,
                    'cus_city' => user(user_id())->city,
                    'cus_state' => user(user_id())->state,
                    'cus_postcode' => user(user_id())->postal_code,
                    'cus_country' => country(user(user_id())->country_id)->iso2,
                    'cus_phone' => user(user_id())->calling_code . user(user_id())->phone,
                    'cus_fax' => 'Not-Applicable',
                    'ship_name' => user(user_id())->firstname . ' ' . user(user_id())->lastname,
                    'ship_add1' => user(user_id())->city,
                    'ship_add2' => user(user_id())->street,
                    'ship_city' => user(user_id())->city,
                    'ship_state' => user(user_id())->state,
                    'ship_postcode' => user(user_id())->postal_code,
                    'ship_country' => country(user(user_id())->country_id)->iso2,
                    'desc' => company(1)->company_name,
                    'success_url' => URLROOT . '/pmt_aamarpay/aamarpay_success',
                    'fail_url' => URLROOT . '/pmt_aamarpay/aamarpay_fail',
                    'cancel_url' => URLROOT . '/pmt_aamarpay/aamarpay_cancel',
                    'opt_a' => '',
                    'opt_b' => '',
                    'opt_c' => '',
                    'opt_d' => '',
                    'signature_key' => $aamarpay_settings->aamarpay_signature_key);
            	
				$curl = curl_init();

				curl_setopt_array($curl, array(
				CURLOPT_URL => $aamarpay_settings->aamarpay_url.'/request.php',
				CURLOPT_RETURNTRANSFER => true,
				CURLOPT_ENCODING => '',
				CURLOPT_MAXREDIRS => 10,
				CURLOPT_TIMEOUT => 0,
				CURLOPT_FOLLOWLOCATION => true,
				CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
				CURLOPT_CUSTOMREQUEST => 'POST',
				CURLOPT_POSTFIELDS => $fields,
				));

				$response = curl_exec($curl);

				curl_close($curl);
				
				$search = array('"', '\\');
				$replace = array('', '');
				$result = str_replace($search, $replace, $response);
				
				if (strpos($result, 'track') !== false) {
				    header("Location: ".$aamarpay_settings->aamarpay_url.'/'.$result);
				} else {
				    flash('user_message', 'subscriptions', $result, 'danger');
				    redirect('subscriptions');
				}
				die();
            }
        }
        
        public function aamarpay_success()
        {
            $aamarpay_live_enabled = $this->settingModel->getOptions('aamarpay_live_enabled');
            $aamarpay_settings = $this->settingModel->getAamarpaySettings($aamarpay_live_enabled->option_value);
            
            if ($_POST['pay_status'] == "Successful") {
                $merTxnId = $_POST['mer_txnid'];
            }
            $curl_handle = curl_init();
            curl_setopt($curl_handle, CURLOPT_URL, $aamarpay_settings->aamarpay_url . "/api/v1/trxcheck/request.php?request_id=" . $merTxnId . "&store_id=" . $aamarpay_settings->aamarpay_store_id . "&signature_key=" . $aamarpay_settings->aamarpay_signature_key . "&type=json");
            
            curl_setopt($curl_handle, CURLOPT_VERBOSE, true);
            curl_setopt($curl_handle, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($curl_handle, CURLOPT_SSL_VERIFYPEER, false);
            $buffer = curl_exec($curl_handle);
            curl_close($curl_handle);
            $a = (array)json_decode($buffer);
            
            if ($a['pay_status'] == "Successful" && $a['amount'] == package_cost($explode[1], $explode[2])) {
                $explode = explode("|", $_SESSION['custom']);
                $data = [
                    'subscription_cost' => $a['amount'],
                    'subscription_uid' => uid(),
                    'transaction_id' => $a['pg_txnid'],
                    'payment_option_id' => payment_option_slug('aamarpay')->payment_option_id,
                    'subscription_added_by' => $explode[0],
                    'transaction_reference' => $a['mer_txnid'],
                    'package_id' => $explode[1],
                    'package_duration' => package_duration($explode[1], $explode[2])[0],
                    'package_duration_type' => package_duration($explode[1], $explode[2])[1],
                    'subscription_items' => json_encode(package($explode[1]))
                ];
                if (empty($data['input_error'])) {
                    if ($subscription_id = $this->subscriptionModel->addSubscriptionPayment($data)) {
                        if (affiliate_accepted($subscription_id)) {
                            $dataA = [
                                'user_id' => user(subscription($subscription_id)->user_id)->referred_by,
                                'affiliate_rule_id' => getOption('affiliate_rule_id'),
                                'affiliate_commission_rate' => getOption('affiliate_commission_rate'),
                                'subscription_id' => $subscription_id
                            ];
                            $this->affiliateModel->addAffiliate($dataA);
                        }
                        if (getOption('approve_subscription_automatically') && payment_option($data['payment_option_id'])->payment_option_online == 1) {
                            $dataw = [
                                'user_id' => $explode[0],
                                'user_remaining_words' => add_user_remaining_balances($explode[0], $subscription_id, 'words'),
                                'user_remaining_chat_assistants' => add_user_remaining_balances($explode[0], $subscription_id, 'chat_assistants'),
                                'user_remaining_trained_models' => add_user_remaining_balances($explode[0], $subscription_id, 'trained_models'),
                                'user_remaining_chat_files' => add_user_remaining_balances($explode[0], $subscription_id, 'chat_files'),
                                'user_remaining_chat_links' => add_user_remaining_balances($explode[0], $subscription_id, 'chat_links'),
                                'user_remaining_chat_sitemaps' => add_user_remaining_balances($explode[0], $subscription_id, 'chat_sitemaps')
                            ];
                            foreach (package_types() as $type) {
                                $out_type = 'user_remaining_' . $type;
                                $dataz = [
                                    'user_id' => $explode[0],
                                    'type' => $type,
                                    'transaction_type' => 'in',
                                    'package_id' => $explode[1],
                                    'old' => (int)user($explode[0])->$out_type,
                                    'current' => $dataw[$out_type],
                                    'user_package_history_comment' => json_encode(package($explode[1])),
                                    'user_package_history_added_by' => $explode[0]
                                ];
                                $this->userModel->addUserPackageHistory($dataz);
                            }
                            $this->userModel->editUserRemaining($dataw);
                        }
                        sendEmail('SubscriptionPaid', user($explode[0])->email, 'subscriptions', $subscription_id, $explode[0]);
                        notificationToUser('subscription_paid', 1, 'subscriptions/show/' . $subscription_id);
                        addActivityLog('subscription', $subscription_id, 'aamarpay_payment_added');
                        flash('user_message', 'subscriptions', 'aamarpay_payment_added');
                    } else {
                        flash('user_message', 'subscriptions', 'adding_aamarpay_payment_failed', 'danger');
                    }
                    redirect('subscriptions/show/' . $subscription_id);
                    die();
                } else {
                    redirect('subscriptions');
                }
            } else {
                flash('user_message', 'subscriptions', 'aamarpay_payment_transaction_failed', 'danger');
                redirect('subscriptions');
            }
            die();
        }
        
        public function aamarpay_fail()
        {
            flash('user_message', 'subscriptions', 'aamarpay_payment_transaction_failed', 'danger');
            redirect('subscriptions');
            die();
        }
        
        public function aamarpay_cancel()
        {
            flash('user_message', 'subscriptions', 'aamarpay_payment_transaction_cancelled', 'danger');
            redirect('subscriptions');
            die();
        }
        
    }
