<?php
    
    
    class Pmt_cash_on_delivery extends Controller
    {
        public function __construct()
        {
            if (!isLoggedIn()) {
                logout();
            }
            require APPROOT . '/views/inc/load_models.php';
        }
        
        public function pay()
        {
        	$free_trial_subscription = free_trial_subscription(user_id(), payment_option_slug('free-trial')->payment_option_id);
            $trial_used = FALSE;
            if ($free_trial_subscription) {
                if ($free_trial_subscription->user_id == user_id() && $free_trial_subscription->package_id == $_POST['package_id'] && $free_trial_subscription->payment_option_id == payment_option_slug('free-trial')->payment_option_id) {
                    $trial_used = TRUE;
                }
            }
            $package = $this->packageModel->getPackageById($_POST['package_id']);
            if (empty($package)) {
                redirect(404);
            }
            if ($_SERVER['REQUEST_METHOD'] == 'POST') {
                if ($trial_used) {
                    flash('user_message', 'subscriptions', 'you_have_already_subscribed_to_free_trial_package', 'danger');
                    redirect('subscriptions');
                    die();
                }
                
				$package_duration = package_duration($_POST['package_id'], $_POST['package_group'])[0];
				$package_duration_type = package_duration($_POST['package_id'], $_POST['package_group'])[1];
                if(payment_option($_POST['payment_option_id'])->payment_option=='free-trial'){
					$package_duration = 1;
					$package_duration_type = 'months';
				}
                
                $data = [
                    'subscription_cost' => package_cost($_POST['package_id'], $_POST['package_group']),
                    'subscription_uid' => uid(),
                    'transaction_id' => time() . user_id(),
                    'payment_option_id' => $_POST['payment_option_id'],
                    'subscription_added_by' => user_id(),
                    'transaction_reference' => NULL,
                    'package_id' => $_POST['package_id'],
                    'package_duration' => $package_duration,
                    'package_duration_type' => $package_duration_type,
                    'subscription_items' => json_encode(package($_POST['package_id']))
                ];
                if ($subscription_id = $this->subscriptionModel->addSubscriptionPayment($data)) {
                    if (getOption('approve_subscription_automatically') && payment_option($data['payment_option_id'])->payment_option_online == 1) {
                        if (affiliate_accepted($subscription_id)) {
                            $dataA = [
                                'user_id' => user(subscription($subscription_id)->user_id)->referred_by,
                                'affiliate_rule_id' => getOption('affiliate_rule_id'),
                                'affiliate_commission_rate' => getOption('affiliate_commission_rate'),
                                'subscription_id' => $subscription_id
                            ];
                            $this->affiliateModel->addAffiliate($dataA);
                        }
                        $dataw = [
                            'user_id' => user_id(),
                            'user_remaining_words' => add_user_remaining_balances(user_id(), $subscription_id, 'words'),
                            'user_remaining_chat_assistants' => add_user_remaining_balances(user_id(), $subscription_id, 'chat_assistants'),
                            'user_remaining_trained_models' => add_user_remaining_balances(user_id(), $subscription_id, 'trained_models'),
                            'user_remaining_chat_files' => add_user_remaining_balances(user_id(), $subscription_id, 'chat_files'),
                            'user_remaining_chat_links' => add_user_remaining_balances(user_id(), $subscription_id, 'chat_links'),
                            'user_remaining_chat_sitemaps' => add_user_remaining_balances(user_id(), $subscription_id, 'chat_sitemaps')
                        ];
                        foreach (package_types() as $type) {
                            $out_type = 'user_remaining_' . $type;
                            $dataz = [
                                'user_id' => user_id(),
                                'type' => $type,
                                'transaction_type' => 'in',
                                'package_id' => $data['package_id'],
                                'old' => (int)user(user_id())->$out_type,
                                'current' => $dataw[$out_type],
                                'user_package_history_comment' => json_encode(package($data['package_id'])),
                                'user_package_history_added_by' => user_id()
                            ];
                            $this->userModel->addUserPackageHistory($dataz);
                        }
                        $this->userModel->editUserRemaining($dataw);
                    }
                    sendEmail('SubscriptionPaid', user(user_id())->email, 'subscriptions', $subscription_id, user_id());
                    notificationToUser('subscription_paid', 1, 'subscriptions/show/' . $subscription_id);
                    addActivityLog('subscription', $subscription_id, 'payment_added');
                    flash('user_message', 'subscriptions', 'payment_added');
            		redirect('subscriptions/show/' . $subscription_id);
                } else {
                    flash('user_message', 'subscriptions', 'adding_payment_failed', 'danger');
            		redirect('subscriptions');
                }
            } else {
                flash('user_message', 'subscriptions', 'adding_payment_failed', 'danger');
            	redirect('subscriptions');
            }
            die();
        }
        
    }
