<?php
    
    
    class Pmt_esewa extends Controller
    {
        public function __construct()
        {
            if (!isLoggedIn()) {
                logout();
            }
            require APPROOT . '/views/inc/load_models.php';
        }
        
        public function index()
        {
        	
        }
        
        public function esewa_success()
        {
            $esewa_live_enabled = $this->settingModel->getOptions('esewa_live_enabled');
            $esewa_settings = $this->settingModel->getEsewaSettings($esewa_live_enabled->option_value);

            $dataX = [
                'amt' => $_GET['amt'],
                'rid' => $_GET['refId'],
                'pid' => $_GET['oid'],
                'scd' => $esewa_settings->esewa_merchant_code
            ];
            
            $curl = curl_init($esewa_settings->esewa_verification_url);
            curl_setopt($curl, CURLOPT_POST, true);
            curl_setopt($curl, CURLOPT_POSTFIELDS, $dataX);
            curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
            $response = curl_exec($curl);
            curl_close($curl);
            $xml = simplexml_load_string($response);
            $response_code = (string)$xml->response_code;
                        
            $explode = explode("|", $_SESSION['custom']);
            if (trim($response_code) == 'Success' && $dataX['amt'] == package_cost($explode[1], $explode[2])) {
                $data = [
                    'subscription_cost' => $dataX['amt'],
                    'subscription_uid' => uid(),
                    'transaction_id' => $dataX['rid'],
                    'payment_option_id' => payment_option_slug('esewa')->payment_option_id,
                    'subscription_added_by' => $explode[0],
                    'transaction_reference' => $dataX['pid'],
                    'package_id' => $explode[1],
                    'package_duration' => package_duration($explode[1], $explode[2])[0],
                    'package_duration_type' => package_duration($explode[1], $explode[2])[1],
                    'subscription_items' => json_encode(package($explode[1]))
                ];
                if (empty($data['input_error'])) {
                    if ($subscription_id = $this->subscriptionModel->addSubscriptionPayment($data)) {
                        if (affiliate_accepted($subscription_id)) {
                            $dataA = [
                                'user_id' => user(subscription($subscription_id)->user_id)->referred_by,
                                'affiliate_rule_id' => getOption('affiliate_rule_id'),
                                'affiliate_commission_rate' => getOption('affiliate_commission_rate'),
                                'subscription_id' => $subscription_id
                            ];
                            $this->affiliateModel->addAffiliate($dataA);
                        }
                        if (getOption('approve_subscription_automatically') && payment_option($data['payment_option_id'])->payment_option_online == 1) {
                            $dataw = [
                                'user_id' => $explode[0],
                                'user_remaining_words' => add_user_remaining_balances($explode[0], $subscription_id, 'words'),
                                'user_remaining_chat_assistants' => add_user_remaining_balances($explode[0], $subscription_id, 'chat_assistants'),
                                'user_remaining_trained_models' => add_user_remaining_balances($explode[0], $subscription_id, 'trained_models'),
                                'user_remaining_chat_files' => add_user_remaining_balances($explode[0], $subscription_id, 'chat_files'),
                                'user_remaining_chat_links' => add_user_remaining_balances($explode[0], $subscription_id, 'chat_links'),
                                'user_remaining_chat_sitemaps' => add_user_remaining_balances($explode[0], $subscription_id, 'chat_sitemaps')
                            ];
                            foreach (package_types() as $type) {
                                $out_type = 'user_remaining_' . $type;
                                $dataz = [
                                    'user_id' => $explode[0],
                                    'type' => $type,
                                    'transaction_type' => 'in',
                                    'package_id' => $explode[1],
                                    'old' => (int)user($explode[0])->$out_type,
                                    'current' => $dataw[$out_type],
                                    'user_package_history_comment' => json_encode(package($explode[1])),
                                    'user_package_history_added_by' => $explode[0]
                                ];
                                $this->userModel->addUserPackageHistory($dataz);
                            }
                            $this->userModel->editUserRemaining($dataw);
                        }
                        sendEmail('SubscriptionPaid', user($explode[0])->email, 'subscriptions', $subscription_id, $explode[0]);
                        notificationToUser('subscription_paid', 1, 'subscriptions/show/' . $subscription_id);
                        addActivityLog('subscription', $subscription_id, 'esewa_payment_added');
                        flash('user_message', 'subscriptions', 'esewa_payment_added');
                    } else {
                        flash('user_message', 'subscriptions', 'adding_esewa_payment_failed', 'danger');
                    }
                    redirect('subscriptions/show/' . $subscription_id);
                    die();
                } else {
                    redirect('subscriptions');
                }
            } else {
                flash('user_message', 'subscriptions', 'esewa_payment_transaction_failed', 'danger');
                redirect('subscriptions');
            }
            die();
        }
        
        public function esewa_failed()
        {
            flash('user_message', 'subscriptions', 'esewa_payment_transaction_failed', 'danger');
            redirect('subscriptions');
            die();
        }
        
    }
