<?php
    
    
    class Pmt_flutterwave extends Controller
    {
        public function __construct()
        {
            if (!isLoggedIn()) {
                logout();
            }
            require APPROOT . '/views/inc/load_models.php';
        }
        
        public function index()
        {
            $flutterwave_live_enabled = $this->settingModel->getOptions('flutterwave_live_enabled');
            $flutterwave_settings = $this->settingModel->getFlutterwaveSettings($flutterwave_live_enabled->option_value);
            $datay = [
                'flutterwave_live_enabled' => $flutterwave_live_enabled,
                'flutterwave_settings' => $flutterwave_settings,
            ];
            $this->view('gateways/flutterwave', $datay);
        }
        
        public function flutterwave_success()
        {
            $flutterwave_live_enabled = $this->settingModel->getOptions('flutterwave_live_enabled');
            $flutterwave_settings = $this->settingModel->getFlutterwaveSettings($flutterwave_live_enabled->option_value);
            
            $txid = $_GET['transaction_id'];
            
            $curl = curl_init();
            curl_setopt_array($curl, array(
                CURLOPT_URL => "https://api.flutterwave.com/v3/transactions/$txid/verify",
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_ENCODING => "",
                CURLOPT_MAXREDIRS => 10,
                CURLOPT_TIMEOUT => 0,
                CURLOPT_FOLLOWLOCATION => true,
                CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                CURLOPT_CUSTOMREQUEST => "GET",
                CURLOPT_HTTPHEADER => array(
                    "Content-Type: application/json",
                    "Authorization: Bearer " . $flutterwave_settings->flutterwave_secret_key
                ),
            ));
            
            $response = curl_exec($curl);
            
            curl_close($curl);
            
            $res = json_decode($response);
            
            $explode = explode("|", $_SESSION['custom']);
            if ($res->status == 'success' && $res->data->charged_amount == package_cost($explode[1], $explode[2])) {
                $data = [
                    'subscription_cost' => $res->data->charged_amount,
                    'subscription_uid' => uid(),
                    'transaction_id' => $res->data->id,
                    'payment_option_id' => payment_option_slug('flutterwave')->payment_option_id,
                    'subscription_added_by' => $explode[0],
                    'transaction_reference' => $res->data->tx_ref,
                    'package_id' => $explode[1],
                    'package_duration' => package_duration($explode[1], $explode[2])[0],
                    'package_duration_type' => package_duration($explode[1], $explode[2])[1],
                    'subscription_items' => json_encode(package($explode[1]))
                ];
                if (empty($data['input_error'])) {
                    if ($subscription_id = $this->subscriptionModel->addSubscriptionPayment($data)) {
                        if (affiliate_accepted($subscription_id)) {
                            $dataA = [
                                'user_id' => user(subscription($subscription_id)->user_id)->referred_by,
                                'affiliate_rule_id' => getOption('affiliate_rule_id'),
                                'affiliate_commission_rate' => getOption('affiliate_commission_rate'),
                                'subscription_id' => $subscription_id
                            ];
                            $this->affiliateModel->addAffiliate($dataA);
                        }
                        if (getOption('approve_subscription_automatically') && payment_option($data['payment_option_id'])->payment_option_online == 1) {
                            $dataw = [
                                'user_id' => $explode[0],
                                'user_remaining_words' => add_user_remaining_balances($explode[0], $subscription_id, 'words'),
                                'user_remaining_chat_assistants' => add_user_remaining_balances($explode[0], $subscription_id, 'chat_assistants'),
                                'user_remaining_trained_models' => add_user_remaining_balances($explode[0], $subscription_id, 'trained_models'),
                                'user_remaining_chat_files' => add_user_remaining_balances($explode[0], $subscription_id, 'chat_files'),
                                'user_remaining_chat_links' => add_user_remaining_balances($explode[0], $subscription_id, 'chat_links'),
                                'user_remaining_chat_sitemaps' => add_user_remaining_balances($explode[0], $subscription_id, 'chat_sitemaps')
                            ];
                            foreach (package_types() as $type) {
                                $out_type = 'user_remaining_' . $type;
                                $dataz = [
                                    'user_id' => $explode[0],
                                    'type' => $type,
                                    'transaction_type' => 'in',
                                    'package_id' => $explode[1],
                                    'old' => (int)user($explode[0])->$out_type,
                                    'current' => $dataw[$out_type],
                                    'user_package_history_comment' => json_encode(package($explode[1])),
                                    'user_package_history_added_by' => $explode[0]
                                ];
                                $this->userModel->addUserPackageHistory($dataz);
                            }
                            $this->userModel->editUserRemaining($dataw);
                        }
                        sendEmail('SubscriptionPaid', user($explode[0])->email, 'subscriptions', $subscription_id, $explode[0]);
                        notificationToUser('subscription_paid', 1, 'subscriptions/show/' . $subscription_id);
                        addActivityLog('subscription', $subscription_id, 'flutterwave_payment_added');
                        flash('user_message', 'subscriptions', 'flutterwave_payment_added');
                    } else {
                        flash('user_message', 'subscriptions', 'adding_flutterwave_payment_failed', 'danger');
                    }
                    redirect('subscriptions/show/' . $subscription_id);
                    die();
                } else {
                    redirect('subscriptions');
                }
            } else {
                flash('user_message', 'subscriptions', 'adding_flutterwave_payment_failed', 'danger');
                redirect('subscriptions');
            }
            die();
        }
        
    }
