<?php
    
    
    class Pmt_hyperpay extends Controller
    {
        public function __construct()
        {
            if (!isLoggedIn()) {
                logout();
            }
            require APPROOT . '/views/inc/load_models.php';
        }
        
        public function index()
        {
            $hyperpay_live_enabled = $this->settingModel->getOptions('hyperpay_live_enabled');
            $hyperpay_settings = $this->settingModel->getHyperpaySettings($hyperpay_live_enabled->option_value);

            $url = $hyperpay_settings->hyperpay_url . "v1/checkouts";
            $data = "entityId=" . $hyperpay_settings->hyperpay_entity_id .
                "&amount=" . package_cost($_POST['package_id'], $_POST['package_group']) .
                "&currency=" . getOption('default_currency') .
                "&paymentType=DB";
            $ch = curl_init();
            curl_setopt($ch, CURLOPT_URL, $url);
            curl_setopt($ch, CURLOPT_HTTPHEADER, array(
                'Authorization:Bearer ' . $hyperpay_settings->hyperpay_access_token));
            curl_setopt($ch, CURLOPT_POST, 1);
            curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);// this should be set to true in production
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            $responseData = curl_exec($ch);
            $response = json_decode($responseData);
            if (curl_errno($ch)) {
                echo curl_error($ch);
            }
            curl_close($ch);
            if (isset($response->id)) {
                echo '<form action="' . URLROOT . '/pmt_hyperpay/hyperpay_success?id="' . $response->id . ' class="paymentWidgets" data-brands="' . $hyperpay_settings->hyperpay_brands . '"></form>';
                echo '<script src="' . $hyperpay_settings->hyperpay_url . 'v1/paymentWidgets.js?checkoutId=' . $response->id . '"></script>';
            }
        }
        
        public function hyperpay_success()
        {
            $hyperpay_live_enabled = $this->settingModel->getOptions('hyperpay_live_enabled');
            $hyperpay_settings = $this->settingModel->getHyperpaySettings($hyperpay_live_enabled->option_value);
            $url = $hyperpay_settings->hyperpay_url . "v1/checkouts/" . $_GET['id'] . "/payment";
            $url .= "?entityId=" . $hyperpay_settings->hyperpay_entity_id;
            
            $ch = curl_init();
            curl_setopt($ch, CURLOPT_URL, $url);
            curl_setopt($ch, CURLOPT_HTTPHEADER, array(
                'Authorization:Bearer ' . $hyperpay_settings->hyperpay_access_token));
            curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'GET');
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);// this should be set to true in production
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            $responseData = curl_exec($ch);
            if (curl_errno($ch)) {
                return curl_error($ch);
            }
            curl_close($ch);
            $response = json_decode($responseData);
            $explode = explode("|", $_SESSION['custom']);
            if (!empty($response->id) && $response->amount == package_cost($explode[1], $explode[2])) {
                $data = [
                    'subscription_cost' => $response->amount,
                    'subscription_uid' => uid(),
                    'transaction_id' => $response->id,
                    'payment_option_id' => payment_option_slug('hyperpay')->payment_option_id,
                    'subscription_added_by' => $explode[0],
                    'transaction_reference' => NULL,
                    'package_id' => $explode[1],
                    'package_duration' => package_duration($explode[1], $explode[2])[0],
                    'package_duration_type' => package_duration($explode[1], $explode[2])[1],
                    'subscription_items' => json_encode(package($explode[1]))
                ];
                if (empty($data['input_error'])) {
                    if ($subscription_id = $this->subscriptionModel->addSubscriptionPayment($data)) {
                        if (affiliate_accepted($subscription_id)) {
                            $dataA = [
                                'user_id' => user(subscription($subscription_id)->user_id)->referred_by,
                                'affiliate_rule_id' => getOption('affiliate_rule_id'),
                                'affiliate_commission_rate' => getOption('affiliate_commission_rate'),
                                'subscription_id' => $subscription_id
                            ];
                            $this->affiliateModel->addAffiliate($dataA);
                        }
                        if (getOption('approve_subscription_automatically') && payment_option($data['payment_option_id'])->payment_option_online == 1) {
                            $dataw = [
                                'user_id' => $explode[0],
                                'user_remaining_words' => add_user_remaining_balances($explode[0], $subscription_id, 'words'),
                                'user_remaining_chat_assistants' => add_user_remaining_balances($explode[0], $subscription_id, 'chat_assistants'),
                                'user_remaining_trained_models' => add_user_remaining_balances($explode[0], $subscription_id, 'trained_models'),
                                'user_remaining_chat_files' => add_user_remaining_balances($explode[0], $subscription_id, 'chat_files'),
                                'user_remaining_chat_links' => add_user_remaining_balances($explode[0], $subscription_id, 'chat_links'),
                                'user_remaining_chat_sitemaps' => add_user_remaining_balances($explode[0], $subscription_id, 'chat_sitemaps')
                            ];
                            foreach (package_types() as $type) {
                                $out_type = 'user_remaining_' . $type;
                                $dataz = [
                                    'user_id' => $explode[0],
                                    'type' => $type,
                                    'transaction_type' => 'in',
                                    'package_id' => $explode[1],
                                    'old' => (int)user($explode[0])->$out_type,
                                    'current' => $dataw[$out_type],
                                    'user_package_history_comment' => json_encode(package($explode[1])),
                                    'user_package_history_added_by' => $explode[0]
                                ];
                                $this->userModel->addUserPackageHistory($dataz);
                            }
                            $this->userModel->editUserRemaining($dataw);
                        }
                        sendEmail('SubscriptionPaid', user($explode[0])->email, 'subscriptions', $subscription_id, $explode[0]);
                        notificationToUser('subscription_paid', 1, 'subscriptions/show/' . $subscription_id);
                        addActivityLog('subscription', $subscription_id, 'hyperpay_payment_added');
                        flash('user_message', 'subscriptions', 'hyperpay_payment_added');
                    } else {
                        flash('user_message', 'subscriptions', 'adding_hyperpay_payment_failed', 'danger');
                    }
                }
            }
            redirect('subscriptions');
            die();
        }
        
    }
