<?php
    
    
    class Pmt_midtrans extends Controller
    {
        public function __construct()
        {
            if (!isLoggedIn()) {
                logout();
            }
            require APPROOT . '/views/inc/load_models.php';
        }
        
        public function index()
        {
            $midtrans_live_enabled = $this->settingModel->getOptions('midtrans_live_enabled');
            $midtrans_settings = $this->settingModel->getMidtransSettings($midtrans_live_enabled->option_value);
            
            $_SESSION['order_id'] = uid();
            
            $body = '{"transaction_details":{"order_id":"' . $_SESSION['order_id'] . '","gross_amount":' . package_cost($_POST['package_id'], $_POST['package_group']) . '},"credit_card":{"secure":true}}';
            
            $curl = curl_init();
            
            curl_setopt_array($curl, [
                CURLOPT_URL => $midtrans_settings->midtrans_url . "/snap/v1/transactions",
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_ENCODING => "",
                CURLOPT_MAXREDIRS => 10,
                CURLOPT_TIMEOUT => 30,
                CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                CURLOPT_CUSTOMREQUEST => "POST",
                CURLOPT_POSTFIELDS => $body,
                CURLOPT_HTTPHEADER => [
                    "accept: application/json",
                    "authorization: Basic " . base64_encode($midtrans_settings->midtrans_server_key . ":"),
                    "content-type: application/json"
                ],
            ]);
            
            $response = curl_exec($curl);
            $err = curl_error($curl);
            
            curl_close($curl);
            
            if ($err) {
                //echo "cURL Error #:" . $err;
            	flash('user_message', 'subscriptions', $err, 'danger');
        		redirect('subscriptions');
            } else {
                if (isset(json_decode($response)->redirect_url)) {
                    header("Location: " . json_decode($response)->redirect_url);
                } else {
                	flash('user_message', 'subscriptions', json_decode($response)->error_messages[0], 'danger');
            		redirect('subscriptions');
                    //echo $response;
                }
                die();
            }
        }
        
        public function midtrans_success()
        {
            $midtrans_live_enabled = $this->settingModel->getOptions('midtrans_live_enabled');
            $midtrans_settings = $this->settingModel->getMidtransSettings($midtrans_live_enabled->option_value);
            
            
            $curl = curl_init();
            
            curl_setopt_array($curl, [
                CURLOPT_URL => $midtrans_settings->midtrans_api_url . "/v2/" . $_SESSION['order_id'] . "/status",
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_ENCODING => "",
                CURLOPT_MAXREDIRS => 10,
                CURLOPT_TIMEOUT => 30,
                CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                CURLOPT_CUSTOMREQUEST => "GET",
                CURLOPT_HTTPHEADER => [
                    "accept: application/json",
                    "authorization: Basic " . base64_encode($midtrans_settings->midtrans_server_key . ":")
                ],
            ]);
            
            $response = curl_exec($curl);
            $err = curl_error($curl);
            
            curl_close($curl);
            
            $response = json_decode($response);
            
            $explode = explode("|", $_SESSION['custom']);
            
            if (isset($response->status_code) && $response->status_code == 200 && $response->gross_amount == package_cost($explode[1], $explode[2])) {           	
                $data = [
                    'subscription_cost' => $response->gross_amount,
                    'subscription_uid' => uid(),
                    'transaction_id' => $response->transaction_id,
                    'payment_option_id' => payment_option_slug('midtrans')->payment_option_id,
                    'subscription_added_by' => $explode[0],
                    'transaction_reference' => $response->order_id,
                    'package_id' => $explode[1],
                    'package_duration' => package_duration($explode[1], $explode[2])[0],
                    'package_duration_type' => package_duration($explode[1], $explode[2])[1],
                    'subscription_items' => json_encode(package($explode[1]))
                ];
                if (empty($data['input_error'])) {
                    if ($subscription_id = $this->subscriptionModel->addSubscriptionPayment($data)) {
                        if (affiliate_accepted($subscription_id)) {
                            $dataA = [
                                'user_id' => user(subscription($subscription_id)->user_id)->referred_by,
                                'affiliate_rule_id' => getOption('affiliate_rule_id'),
                                'affiliate_commission_rate' => getOption('affiliate_commission_rate'),
                                'subscription_id' => $subscription_id
                            ];
                            $this->affiliateModel->addAffiliate($dataA);
                        }
                        if (getOption('approve_subscription_automatically') && payment_option($data['payment_option_id'])->payment_option_online == 1) {
                            $dataw = [
                                'user_id' => $explode[0],
                                'user_remaining_words' => add_user_remaining_balances($explode[0], $subscription_id, 'words'),
                                'user_remaining_chat_assistants' => add_user_remaining_balances($explode[0], $subscription_id, 'chat_assistants'),
                                'user_remaining_trained_models' => add_user_remaining_balances($explode[0], $subscription_id, 'trained_models'),
                                'user_remaining_chat_files' => add_user_remaining_balances($explode[0], $subscription_id, 'chat_files'),
                                'user_remaining_chat_links' => add_user_remaining_balances($explode[0], $subscription_id, 'chat_links'),
                                'user_remaining_chat_sitemaps' => add_user_remaining_balances($explode[0], $subscription_id, 'chat_sitemaps')
                            ];
                            foreach (package_types() as $type) {
                                $out_type = 'user_remaining_' . $type;
                                $dataz = [
                                    'user_id' => $explode[0],
                                    'type' => $type,
                                    'transaction_type' => 'in',
                                    'package_id' => $explode[1],
                                    'old' => (int)user($explode[0])->$out_type,
                                    'current' => $dataw[$out_type],
                                    'user_package_history_comment' => json_encode(package($explode[1])),
                                    'user_package_history_added_by' => $explode[0]
                                ];
                                $this->userModel->addUserPackageHistory($dataz);
                            }
                            $this->userModel->editUserRemaining($dataw);
                        }
                        sendEmail('SubscriptionPaid', user($explode[0])->email, 'subscriptions', $subscription_id, $explode[0]);
                        notificationToUser('subscription_paid', 1, 'subscriptions/show/' . $subscription_id);
                        addActivityLog('subscription', $subscription_id, 'midtrans_payment_added');
                        flash('user_message', 'subscriptions', 'midtrans_payment_added');
                    } else {
                        flash('user_message', 'subscriptions', 'adding_midtrans_payment_failed', 'danger');
                    }
                }
            }
            redirect('subscriptions');
            die();
        }
        
    }
