<?php
    
    
    class Pmt_paddle extends Controller
    {
        public function __construct()
        {
            if (!isLoggedIn()) {
                logout();
            }
            require APPROOT . '/views/inc/load_models.php';
        }
        
        public function index($silence = NULL)
        {
//silence
        }
        
        public function paddle_success()
        {
            $transaction = paddle_transaction($_POST['transaction_id']);
            $explode = explode("|", $_SESSION['custom']);
            if (!empty($transaction) && in_array($transaction['data']['status'], array('paid', 'completed')) && ($transaction['data']["details"]['totals']["currency_code"] == 'USD' ? ($transaction['data']["details"]['totals']["grand_total"] / 100) : $transaction['data']["details"]['totals']["grand_total"]) == package_cost($explode[1], $explode[2])) {
                $data = [
                    'subscription_cost' => $transaction['data']["details"]['totals']["currency_code"] == 'USD' ? ($transaction['data']["details"]['totals']["grand_total"] / 100) : $transaction['data']["details"]['totals']["grand_total"],
                    'subscription_uid' => uid(),
                    'transaction_id' => $transaction['data']['id'],
                    'payment_option_id' => payment_option_slug('paddle')->payment_option_id,
                    'subscription_added_by' => user_id(),
                    'transaction_reference' => NULL,
                    'package_id' => $explode[1],
                    'package_duration' => package_duration($explode[1], $explode[2])[0],
                    'package_duration_type' => package_duration($explode[1], $explode[2])[1],
                    'subscription_items' => json_encode(package($explode[1]))
                ];
            } else {
                //error from api
                $data['input_error'] = $transaction['error']['type'] . ' ' . $transaction['error']['detail'];
            }
            if (empty($data['input_error'])) {
                if ($subscription_id = $this->subscriptionModel->addSubscriptionPayment($data)) {
                    if (affiliate_accepted($subscription_id)) {
                        $dataA = [
                            'user_id' => user(subscription($subscription_id)->user_id)->referred_by,
                            'affiliate_rule_id' => getOption('affiliate_rule_id'),
                            'affiliate_commission_rate' => getOption('affiliate_commission_rate'),
                            'subscription_id' => $subscription_id
                        ];
                        $this->affiliateModel->addAffiliate($dataA);
                    }
                    if (getOption('approve_subscription_automatically') && payment_option($data['payment_option_id'])->payment_option_online == 1) {
                        $dataw = [
                            'user_id' => user_id(),
                            'user_remaining_words' => add_user_remaining_balances(user_id(), $subscription_id, 'words'),
                            'user_remaining_chat_assistants' => add_user_remaining_balances(user_id(), $subscription_id, 'chat_assistants'),
                            'user_remaining_trained_models' => add_user_remaining_balances(user_id(), $subscription_id, 'trained_models'),
                            'user_remaining_chat_files' => add_user_remaining_balances(user_id(), $subscription_id, 'chat_files'),
                            'user_remaining_chat_links' => add_user_remaining_balances(user_id(), $subscription_id, 'chat_links'),
                            'user_remaining_chat_sitemaps' => add_user_remaining_balances(user_id(), $subscription_id, 'chat_sitemaps')
                        ];
                        foreach (package_types() as $type) {
                            $out_type = 'user_remaining_' . $type;
                            $dataz = [
                                'user_id' => user_id(),
                                'type' => $type,
                                'transaction_type' => 'in',
                                'package_id' => $explode[1],
                                'old' => (int)user(user_id())->$out_type,
                                'current' => $dataw[$out_type],
                                'user_package_history_comment' => json_encode(package($explode[1])),
                                'user_package_history_added_by' => user_id()
                            ];
                            $this->userModel->addUserPackageHistory($dataz);
                        }
                        $this->userModel->editUserRemaining($dataw);
                    }
                    sendEmail('SubscriptionPaid', user(user_id())->email, 'subscriptions', $subscription_id, user_id());
                    notificationToUser('subscription_paid', 1, 'subscriptions/show/' . $subscription_id);
                    addActivityLog('subscription', $subscription_id, 'paddle_payment_added');
                    $data['status'] = 'success';
                    $data['message'] = 'paddle_payment_added';
                } else {
                    $data['status'] = 'error';
                    $data['message'] = 'paddle_payment_transaction_failed';
                }
            } else {
                $data['status'] = 'error';
                $data['message'] = $data['input_error'];
            }
            echo json_encode($data);
        }
        
        public function paddle_success_close()
        {
            $transaction = paddle_transaction($_POST['transaction_id']);
            
            if (!empty($transaction['data']) && in_array($transaction['data']['status'], array('paid', 'completed'))) {
                $payment = subscription_payment_by_transaction_id($_POST['transaction_id']);
                
                if ($payment) {
                    $data['status'] = 'success';
                    $data['subscription_id'] = $payment->subscription_id;
                    $data['message'] = 'paddle_payment_added';
                } else {
                    $data['status'] = 'error';
                    $data['subscription_id'] = NULL;
                    $data['message'] = 'paddle_payment_transaction_failed';
                }
            } else {
                $data['status'] = 'error';
                $data['subscription_id'] = NULL;
                $data['message'] = 'paddle_payment_transaction_failed';
            }
            echo json_encode($data);
        }
        
    }
