<?php
    
    
    class Pmt_paygate extends Controller
    {
        public function __construct()
        {
            if (!isLoggedIn()) {
                logout();
            }
            require APPROOT . '/views/inc/load_models.php';
        }
        
        public function index()
        {
            $paygate_live_enabled = $this->settingModel->getOptions('paygate_live_enabled');
            $paygate_settings = $this->settingModel->getPaygateSettings($paygate_live_enabled->option_value);
            
            if ($_SERVER['REQUEST_METHOD'] == 'POST') {
                $_POST = sanitize_post();
                
                $DateTime = new DateTime();
                
                $_SESSION['REFERENCE'] = strtoupper(uid(16));
                
                $data = array(
                    'PAYGATE_ID' => $paygate_settings->paygate_paygate_id,
                    'REFERENCE' => $_SESSION['REFERENCE'],
                    'AMOUNT' => number_format(package_cost($_POST['package_id'], $_POST['package_group']), 2) * 100,
                    'CURRENCY' => getOption('default_currency'),
                    'RETURN_URL' => URLROOT . '/pmt_paygate/paygate_return',
                    'TRANSACTION_DATE' => $DateTime->format('Y-m-d H:i:s'),
                    'LOCALE' => 'en',
                    'COUNTRY' => country(user(user_id())->country_id)->iso3,
                    'EMAIL' => $_POST['email'],
                );
                
                $checksum = md5(implode('', $data) . $paygate_settings->paygate_encryption_key);
                
                $data['CHECKSUM'] = $checksum;
                
                $fieldsString = http_build_query($data);
                
                //open connection
                $ch = curl_init();
                
                //set the url, number of POST vars, POST data
                curl_setopt($ch, CURLOPT_URL, $paygate_settings->paygate_url);
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                curl_setopt($ch, CURLOPT_NOBODY, false);
                curl_setopt($ch, CURLOPT_REFERER, $_SERVER['HTTP_HOST']);
                curl_setopt($ch, CURLOPT_POST, true);
                curl_setopt($ch, CURLOPT_POSTFIELDS, $fieldsString);
                
                //execute post
                $result = curl_exec($ch);
                
                preg_match_all("/([^,= ]+)=([^,= ]+)/", str_replace('&', ',', $result), $r);
                $out = array_combine($r[1], $r[2]);
                
                //close connection
                curl_close($ch);
                
                echo '<html xmlns="http://www.w3.org/1999/xhtml">
      <head><script type="text/javascript">
        function closethisasap() { document.forms["redirectpost"].submit(); } 
      </script></head>
      <body onLoad="closethisasap();">
      
        <form name="redirectpost" method="post" action="' . $paygate_settings->paygate_redirection_url . '">
        	<input type="hidden" name="PAY_REQUEST_ID" value="' . $out["PAY_REQUEST_ID"] . '">
    		<input type="hidden" name="CHECKSUM" value="' . $out["CHECKSUM"] . '">
        </form>
      </body>
    </html>';
            }
        }
        
        public function paygate_return()
        {
            $paygate_live_enabled = $this->settingModel->getOptions('paygate_live_enabled');
            $paygate_settings = $this->settingModel->getPaygateSettings($paygate_live_enabled->option_value);
            
            $data = array(
                'PAYGATE_ID' => $paygate_settings->paygate_paygate_id,
                'PAY_REQUEST_ID' => $_POST['PAY_REQUEST_ID'],
                'REFERENCE' => $_SESSION['REFERENCE']
            );
            
            $checksum = md5(implode('', $data) . $paygate_settings->paygate_encryption_key);
            
            $data['CHECKSUM'] = $checksum;
            
            $fieldsString = http_build_query($data);

//open connection
            $ch = curl_init();

//set the url, number of POST vars, POST data
            curl_setopt($ch, CURLOPT_URL, $paygate_settings->paygate_verification_url);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_NOBODY, false);
            curl_setopt($ch, CURLOPT_REFERER, $_SERVER['HTTP_HOST']);
            curl_setopt($ch, CURLOPT_POST, true);
            curl_setopt($ch, CURLOPT_POSTFIELDS, $fieldsString);

//execute post
            $result = curl_exec($ch);
            
            preg_match_all("/([^,= ]+)=([^,= ]+)/", str_replace('&', ',', $result), $r);
            $out = array_combine($r[1], $r[2]);

//close connection
            curl_close($ch);
            
            $explode = explode("|", $_SESSION['custom']);
            if (isset($_POST['PAY_REQUEST_ID']) && ($out["AMOUNT"] / 100) == package_cost($explode[1], $explode[2])) {
                $data = [
                    'subscription_cost' => number_format($out["AMOUNT"] / 100, 2),
                    'subscription_uid' => uid(),
                    'transaction_id' => $out["TRANSACTION_ID"],
                    'payment_option_id' => payment_option_slug('paygate')->payment_option_id,
                    'subscription_added_by' => $explode[0],
                    'transaction_reference' => $out["REFERENCE"],
                    'package_id' => $explode[1],
                    'package_duration' => package_duration($explode[1], $explode[2])[0],
                    'package_duration_type' => package_duration($explode[1], $explode[2])[1],
                    'subscription_items' => json_encode(package($explode[1]))
                ];
                if (empty($data['input_error'])) {
                    if ($subscription_id = $this->subscriptionModel->addSubscriptionPayment($data)) {
                        if (affiliate_accepted($subscription_id)) {
                            $dataA = [
                                'user_id' => user(subscription($subscription_id)->user_id)->referred_by,
                                'affiliate_rule_id' => getOption('affiliate_rule_id'),
                                'affiliate_commission_rate' => getOption('affiliate_commission_rate'),
                                'subscription_id' => $subscription_id
                            ];
                            $this->affiliateModel->addAffiliate($dataA);
                        }
                        if (getOption('approve_subscription_automatically') && payment_option($data['payment_option_id'])->payment_option_online == 1) {
                            $dataw = [
                                'user_id' => $explode[0],
                                'user_remaining_words' => add_user_remaining_balances($explode[0], $subscription_id, 'words'),
                                'user_remaining_chat_assistants' => add_user_remaining_balances($explode[0], $subscription_id, 'chat_assistants'),
                                'user_remaining_trained_models' => add_user_remaining_balances($explode[0], $subscription_id, 'trained_models'),
                                'user_remaining_chat_files' => add_user_remaining_balances($explode[0], $subscription_id, 'chat_files'),
                                'user_remaining_chat_links' => add_user_remaining_balances($explode[0], $subscription_id, 'chat_links'),
                                'user_remaining_chat_sitemaps' => add_user_remaining_balances($explode[0], $subscription_id, 'chat_sitemaps')
                            ];
                            foreach (package_types() as $type) {
                                $out_type = 'user_remaining_' . $type;
                                $dataz = [
                                    'user_id' => $explode[0],
                                    'type' => $type,
                                    'transaction_type' => 'in',
                                    'package_id' => $explode[1],
                                    'old' => (int)user($explode[0])->$out_type,
                                    'current' => $dataw[$out_type],
                                    'user_package_history_comment' => json_encode(package($explode[1])),
                                    'user_package_history_added_by' => $explode[0]
                                ];
                                $this->userModel->addUserPackageHistory($dataz);
                            }
                            $this->userModel->editUserRemaining($dataw);
                        }
                        sendEmail('SubscriptionPaid', user($explode[0])->email, 'subscriptions', $subscription_id, $explode[0]);
                        notificationToUser('subscription_paid', 1, 'subscriptions/show/' . $subscription_id);
                        addActivityLog('subscription', $subscription_id, 'paygate_payment_added');
                        flash('user_message', 'subscriptions', 'paygate_payment_added');
                    } else {
                        flash('user_message', 'subscriptions', 'adding_paygate_payment_failed', 'danger');
                    }
                    redirect('subscriptions/show/' . $subscription_id);
                    die();
                } else {
                    redirect('subscriptions');
                }
            } else {
                flash('user_message', 'subscriptions', 'paygate_payment_transaction_failed', 'danger');
                redirect('subscriptions');
            }
            die();
        }
    }
