<?php
    
    
    class Pmt_paytr extends Controller
    {
        public function __construct()
        {
            if (!isLoggedIn()) {
                logout();
            }
            require APPROOT . '/views/inc/load_models.php';
        }
        
        public function index()
        {
        	//Do nothing
        }
        
        public function paytr_success()
        {
            $paytr_live_enabled = $this->settingModel->getOptions('paytr_live_enabled');
            $paytr_settings = $this->settingModel->getPayTRSettings($paytr_live_enabled->option_value);
            
            $post = $_POST;
            
            $hash = base64_encode(hash_hmac('sha256', $post['merchant_oid'] . $paytr_settings->paytr_merchant_salt . $post['status'] . $post['total_amount'], $paytr_settings->paytr_merchant_key, true));
            
            if ($hash != $post['hash']) {
                flash('user_message', 'subscriptions', 'bad_hash', 'danger');
                redirect('subscriptions');
                die();
            }
            
            $explode = explode("|", $_SESSION['custom']);
            if ($post['status'] == 'success' && (($post['currency'] == 'TL') ? $post['payment_amount'] / 100 : $post['payment_amount']) == package_cost($explode[1], $explode[2])) {
                $data = [
                    'subscription_cost' => ($post['currency'] == 'TL') ? $post['payment_amount'] / 100 : $post['payment_amount'],
                    'subscription_uid' => $post['merchant_oid'],
                    'transaction_id' => $post['merchant_oid'],
                    'payment_option_id' => payment_option_slug('paytr')->payment_option_id,
                    'subscription_added_by' => $explode[0],
                    'transaction_reference' => NULL,
                    'package_id' => $explode[1],
                    'package_duration' => package_duration($explode[1], $explode[2])[0],
                    'package_duration_type' => package_duration($explode[1], $explode[2])[1],
                    'subscription_items' => json_encode(package($explode[1]))
                ];
                if (empty($data['input_error'])) {
                    if ($subscription_id = $this->subscriptionModel->addSubscriptionPayment($data)) {
                        if (affiliate_accepted($subscription_id)) {
                            $dataA = [
                                'user_id' => user(subscription($subscription_id)->user_id)->referred_by,
                                'affiliate_rule_id' => getOption('affiliate_rule_id'),
                                'affiliate_commission_rate' => getOption('affiliate_commission_rate'),
                                'subscription_id' => $subscription_id
                            ];
                            $this->affiliateModel->addAffiliate($dataA);
                        }
                        if (getOption('approve_subscription_automatically') && payment_option($data['payment_option_id'])->payment_option_online == 1) {
                            $dataw = [
                                'user_id' => $explode[0],
                                'user_remaining_words' => add_user_remaining_balances($explode[0], $subscription_id, 'words'),
                                'user_remaining_chat_assistants' => add_user_remaining_balances($explode[0], $subscription_id, 'chat_assistants'),
                                'user_remaining_trained_models' => add_user_remaining_balances($explode[0], $subscription_id, 'trained_models'),
                                'user_remaining_chat_files' => add_user_remaining_balances($explode[0], $subscription_id, 'chat_files'),
                                'user_remaining_chat_links' => add_user_remaining_balances($explode[0], $subscription_id, 'chat_links'),
                                'user_remaining_chat_sitemaps' => add_user_remaining_balances($explode[0], $subscription_id, 'chat_sitemaps')
                            ];
                            foreach (package_types() as $type) {
                                $out_type = 'user_remaining_' . $type;
                                $dataz = [
                                    'user_id' => $explode[0],
                                    'type' => $type,
                                    'transaction_type' => 'in',
                                    'package_id' => $explode[1],
                                    'old' => (int)user($explode[0])->$out_type,
                                    'current' => $dataw[$out_type],
                                    'user_package_history_comment' => json_encode(package($explode[1])),
                                    'user_package_history_added_by' => $explode[0]
                                ];
                                $this->userModel->addUserPackageHistory($dataz);
                            }
                            $this->userModel->editUserRemaining($dataw);
                        }
                        sendEmail('SubscriptionPaid', user($explode[0])->email, 'subscriptions', $subscription_id, $explode[0]);
                        addActivityLog('subscription', $subscription_id, 'paytr_payment_added');
                        flash('user_message', 'subscriptions', 'paytr_payment_added');
                    } else {
                        flash('user_message', 'subscriptions', 'adding_paytr_payment_failed', 'danger');
                    }
                    redirect('subscriptions/show/' . $subscription_id);
                    die();
                } else {
                    redirect('subscriptions');
                }
            } else {
                flash('user_message', 'subscriptions', $post['failed_reason_msg'], 'danger');
                redirect('subscriptions');
            }
            echo "OK";
            exit;
        }
        
        public function paytr_error()
        {
            flash('user_message', 'subscriptions', 'adding_paytr_payment_failed', 'danger');
            redirect('subscriptions');
            die();
        }
        
    }
