<?php
    
    
    class Pmt_pesapal extends Controller
    {
        public function __construct()
        {
            require APPROOT . '/views/inc/load_models.php';
        }
        
        public function index()
        {
            $pesapal_live_enabled = $this->settingModel->getOptions('pesapal_live_enabled');
            $pesapal_settings = $this->settingModel->getPesapalSettings($pesapal_live_enabled->option_value);
                        
            $curl = curl_init();
            curl_setopt_array($curl, array(
                CURLOPT_URL => $pesapal_settings->pesapal_authentication_url,
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_ENCODING => '',
                CURLOPT_MAXREDIRS => 10,
                CURLOPT_TIMEOUT => 0,
                CURLOPT_FOLLOWLOCATION => true,
                CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                CURLOPT_CUSTOMREQUEST => 'POST',
                CURLOPT_POSTFIELDS => '{
		  "consumer_key": "' . $pesapal_settings->pesapal_consumer_key . '",
		  "consumer_secret": "' . $pesapal_settings->pesapal_consumer_secret . '"
		}',
                CURLOPT_HTTPHEADER => array(
                    'Content-Type: application/json',
                    'Accept: application/json'
                ),
            ));
            $response = curl_exec($curl);
            if (!empty(json_decode($response)->error)) {
                flash('user_message', 'subscriptions', json_decode($response)->error->message, 'danger');
                redirect('subscriptions');
            } else {
                $token = json_decode($response)->token;
                $_SESSION['pesapal_token'] = $token;
                curl_close($curl);
                $curl = curl_init();
                curl_setopt_array($curl, array(
                    CURLOPT_URL => $pesapal_settings->pesapal_order_request_url,
                    CURLOPT_RETURNTRANSFER => true,
                    CURLOPT_ENCODING => '',
                    CURLOPT_MAXREDIRS => 10,
                    CURLOPT_TIMEOUT => 0,
                    CURLOPT_FOLLOWLOCATION => true,
                    CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                    CURLOPT_CUSTOMREQUEST => 'POST',
                    CURLOPT_POSTFIELDS => '{
			    "id": "' . uid() . '",
			    "currency": "' . getOption('default_currency') . '",
			    "amount": ' . package_cost($_POST['package_id'], $_POST['package_group']) . ',
			    "description": "' . company(1)->company_name . '",
				"callback_url": "' . URLROOT . '/pmt_pesapal/pesapal_ipn_listener",
			    "notification_id": "' . $pesapal_settings->pesapal_notification_id . '",
			    "billing_address": {
			        "email_address": "' . user(user_id())->email . '",
			        "phone_number": null,
			        "country_code": "",
			        "first_name": "' . user(user_id())->firstname . '",
			        "middle_name": "",
			        "last_name": "' . user(user_id())->lastname . '",
			        "line_1": "",
			        "line_2": "",
			        "city": "",
			        "state": "",
			        "postal_code": null,
			        "zip_code": null
			    }
			}',
			
                    CURLOPT_HTTPHEADER => array(
                        'Content-Type: application/json',
                        'Authorization: Bearer ' . $token
                    ),
                ));
                
                $response = curl_exec($curl);
                
                if (!empty(json_decode($response)->error)) {
                    flash('user_message', 'subscriptions', json_decode($response)->error->message, 'danger');
                    redirect('subscriptions');
                } else {
                    echo '<iframe src="' . json_decode($response)->redirect_url . '" width="100%" height="650px"  scrolling="no" frameBorder="0">
						<p>Browser unable to load iFrame</p>
					</iframe>';
                }
                
                curl_close($curl);
            }
        }
        
        public function pesapal_ipn_listener()
        {
            $pesapal_live_enabled = $this->settingModel->getOptions('pesapal_live_enabled');
            $pesapal_settings = $this->settingModel->getPesapalSettings($pesapal_live_enabled->option_value);
            $token = $_SESSION['pesapal_token'];
            $curl = curl_init();
            curl_setopt_array($curl, array(
                CURLOPT_URL => $pesapal_settings->pesapal_transaction_status_url . '?orderTrackingId=' . $_GET['OrderTrackingId'],
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_ENCODING => '',
                CURLOPT_MAXREDIRS => 10,
                CURLOPT_TIMEOUT => 0,
                CURLOPT_FOLLOWLOCATION => true,
                CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                CURLOPT_CUSTOMREQUEST => 'GET',
                CURLOPT_HTTPHEADER => array(
                    'Accept: application/json',
                    'Content-Type: application/json',
                    'Authorization: Bearer ' . $token
                ),
            ));
            
            $response = curl_exec($curl);
            
            curl_close($curl);
            $response = json_decode($response);
            $explode = explode("|", $_SESSION['custom']);
            if ($response->payment_status_description == 'Completed' && $response->amount == package_cost($explode[1], $explode[2])) {
                $data = [
                    'subscription_cost' => $response->amount,
                    'subscription_uid' => uid(),
                    'transaction_id' => $_GET['OrderTrackingId'],
                    'payment_option_id' => payment_option_slug('pesapal')->payment_option_id,
                    'subscription_added_by' => $explode[0],
                    'transaction_reference' => $response->merchant_reference,
                    'package_id' => $explode[1],
                    'package_duration' => package_duration($explode[1], $explode[2])[0],
                    'package_duration_type' => package_duration($explode[1], $explode[2])[1],
                    'subscription_items' => json_encode(package($explode[1]))
                ];
                if (empty($data['input_error'])) {
                    if ($subscription_id = $this->subscriptionModel->addSubscriptionPayment($data)) {
                        if (affiliate_accepted($subscription_id)) {
                            $dataA = [
                                'user_id' => user(subscription($subscription_id)->user_id)->referred_by,
                                'affiliate_rule_id' => getOption('affiliate_rule_id'),
                                'affiliate_commission_rate' => getOption('affiliate_commission_rate'),
                                'subscription_id' => $subscription_id
                            ];
                            $this->affiliateModel->addAffiliate($dataA);
                        }
                        if (getOption('approve_subscription_automatically') && payment_option($data['payment_option_id'])->payment_option_online == 1) {
                            $dataw = [
                                'user_id' => $explode[0],
                                'user_remaining_words' => add_user_remaining_balances($explode[0], $subscription_id, 'words'),
                                'user_remaining_chat_assistants' => add_user_remaining_balances($explode[0], $subscription_id, 'chat_assistants'),
                                'user_remaining_trained_models' => add_user_remaining_balances($explode[0], $subscription_id, 'trained_models'),
                                'user_remaining_chat_files' => add_user_remaining_balances($explode[0], $subscription_id, 'chat_files'),
                                'user_remaining_chat_links' => add_user_remaining_balances($explode[0], $subscription_id, 'chat_links'),
                                'user_remaining_chat_sitemaps' => add_user_remaining_balances($explode[0], $subscription_id, 'chat_sitemaps')
                            ];
                            foreach (package_types() as $type) {
                                $out_type = 'user_remaining_' . $type;
                                $dataz = [
                                    'user_id' => $explode[0],
                                    'type' => $type,
                                    'transaction_type' => 'in',
                                    'package_id' => $data['package_id'],
                                    'old' => (int)user($explode[0])->$out_type,
                                    'current' => $dataw[$out_type],
                                    'user_package_history_comment' => $data['subscription_items'],
                                    'user_package_history_added_by' => $explode[0]
                                ];
                                $this->userModel->addUserPackageHistory($dataz);
                            }
                            $this->userModel->editUserRemaining($dataw);
                        }
                        sendEmail('SubscriptionPaid', user($explode[0])->email, 'subscriptions', $subscription_id, $explode[0]);
                        notificationToUser('subscription_paid', 1, 'subscriptions/show/' . $subscription_id);
                        addActivityLog('subscription', $subscription_id, 'payment_added');
                        flash('user_message', 'subscriptions', 'payment_added');
                    } else {
                        flash('user_message', 'subscriptions', 'payment_failed', 'danger');
                    }
                    redirect('subscriptions/show/' . $subscription_id);
                    die();
                } else {
                    redirect('subscriptions');
                }
            } else {
                flash('user_message', 'subscriptions', 'payment_transaction_validation_not_complete', 'danger');
            }
            redirect('subscriptions');
        }
        
    }
