<?php
    
    
    class Pmt_sslcommerz extends Controller
    {
        public function __construct()
        {
            if (!isLoggedIn()) {
                logout();
            }
            require APPROOT . '/views/inc/load_models.php';
        }
        
        public function index()
        {
            $sslcommerz_live_enabled = $this->settingModel->getOptions('sslcommerz_live_enabled');
            $sslcommerz_settings = $this->settingModel->getSslcommerzSettings($sslcommerz_live_enabled->option_value);

            $post_data = array();
            $post_data['store_id'] = $sslcommerz_settings->sslcommerz_store_id;
            $post_data['store_passwd'] = $sslcommerz_settings->sslcommerz_password;
            $post_data['total_amount'] = package_cost($_POST['package_id'], $_POST['package_group']);
            $post_data['currency'] = getOption('default_currency');
            $post_data['tran_id'] = company(1)->company_name . uniqid();
            $post_data['success_url'] = URLROOT . "/pmt_sslcommerz/sslcommerz_success";
            $post_data['fail_url'] = URLROOT . "/pmt_sslcommerz/sslcommerz_fail";
            $post_data['cancel_url'] = URLROOT . "/pmt_sslcommerz/sslcommerz_cancel";
# $post_data['multi_card_name'] = "mastercard,visacard,amexcard";  # DISABLE TO DISPLAY ALL AVAILABLE

# EMI INFO
            $post_data['emi_option'] = "1";
            $post_data['emi_max_inst_option'] = "9";
            $post_data['emi_selected_inst'] = "9";

# CUSTOMER INFORMATION
            $post_data['cus_name'] = user(user_id())->firstname . ' ' . user(user_id())->lastname;
            $post_data['cus_email'] = user(user_id())->email;
            $post_data['cus_add1'] = user(user_id())->street;
            $post_data['cus_add2'] = user(user_id())->street;
            $post_data['cus_city'] = user(user_id())->city;
            $post_data['cus_state'] = user(user_id())->state;
            $post_data['cus_postcode'] = user(user_id())->postal_code;
            $post_data['cus_country'] = country(user(user_id())->country_id)->short_name;
            $post_data['cus_phone'] = "0" . user(user_id())->phone;
            $post_data['cus_fax'] = "0" . user(user_id())->phone;

# SHIPMENT INFORMATION
            $post_data['shipping_method'] = 'NO';
            $post_data['ship_name'] = company(1)->company_name;
            $post_data['ship_add1 '] = user(user_id())->street;
            $post_data['ship_add2'] = user(user_id())->street;
            $post_data['ship_city'] = user(user_id())->city;
            $post_data['ship_state'] = user(user_id())->state;
            $post_data['ship_postcode'] = user(user_id())->postal_code;
            $post_data['ship_country'] = country(user(user_id())->country_id)->short_name;

# PRODUCT INFORMATION
            $post_data['product_name'] = 'ecommerce';
            $post_data['product_category'] = 'online';
            $post_data['product_profile'] = 'general';


# CART PARAMETERS
            $post_data['cart'] = json_encode(array(
                array("product" => company(1)->company_name, "amount" => package_cost($_POST['package_id'], $_POST['package_group']))
            ));
            $post_data['product_amount'] = package_cost($_POST['package_id'], $_POST['package_group']);
            $post_data['vat'] = "0";
            $post_data['discount_amount'] = "0";
            $post_data['convenience_fee'] = "0";


# REQUEST SEND TO SSLCOMMERZ
            $direct_api_url = $sslcommerz_settings->sslcommerz_endpoint_url;
            
            $handle = curl_init();
            curl_setopt($handle, CURLOPT_URL, $direct_api_url);
            curl_setopt($handle, CURLOPT_TIMEOUT, 30);
            curl_setopt($handle, CURLOPT_CONNECTTIMEOUT, 30);
            curl_setopt($handle, CURLOPT_POST, 1);
            curl_setopt($handle, CURLOPT_POSTFIELDS, $post_data);
            curl_setopt($handle, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($handle, CURLOPT_SSL_VERIFYPEER, FALSE); # KEEP IT FALSE IF YOU RUN FROM LOCAL PC
            
            
            $content = curl_exec($handle);
            
            $code = curl_getinfo($handle, CURLINFO_HTTP_CODE);
            
            if ($code == 200 && !(curl_errno($handle))) {
                curl_close($handle);
                $sslcommerzResponse = $content;
            } else {
                curl_close($handle);
                //echo "FAILED TO CONNECT WITH SSLCOMMERZ API";
                flash('user_message', 'subscriptions', 'adding_sslcommerz_payment_failed', 'danger');
                redirect('subscriptions');
            }
# PARSE THE JSON RESPONSE
            $sslcz = json_decode($sslcommerzResponse, true);
            
            if (isset($sslcz['GatewayPageURL']) && $sslcz['GatewayPageURL'] != "") {
                # THERE ARE MANY WAYS TO REDIRECT - Javascript, Meta Tag or Php Header Redirect or Other
                # echo "<script>window.location.href = '". $sslcz['GatewayPageURL'] ."';</script>";
                echo "<meta http-equiv='refresh' content='0;url=" . $sslcz['GatewayPageURL'] . "'>";
                # header("Location: ". $sslcz['GatewayPageURL']);
                exit;
            } else {
                //echo "JSON Data parsing error!";
                flash('user_message', 'subscriptions', 'adding_sslcommerz_payment_failed', 'danger');
                redirect('subscriptions');
            }
            
        }
        
        public function sslcommerz_success()
        {
            $sslcommerz_live_enabled = $this->settingModel->getOptions('sslcommerz_live_enabled');
            $sslcommerz_settings = $this->settingModel->getsslcommerzSettings($sslcommerz_live_enabled->option_value);
            
            $val_id = urlencode($_POST['val_id']);
            $store_id = urlencode($sslcommerz_settings->sslcommerz_store_id);
            $store_passwd = urlencode($sslcommerz_settings->sslcommerz_password);
            $requested_url = ($sslcommerz_settings->sslcommerz_validation_url . "?val_id=" . $val_id . "&store_id=" . $store_id . "&store_passwd=" . $store_passwd . "&v=1&format=json");
            
            $handle = curl_init();
            curl_setopt($handle, CURLOPT_URL, $requested_url);
            curl_setopt($handle, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($handle, CURLOPT_SSL_VERIFYHOST, false); # IF YOU RUN FROM LOCAL PC
            curl_setopt($handle, CURLOPT_SSL_VERIFYPEER, false); # IF YOU RUN FROM LOCAL PC
            
            $result = curl_exec($handle);
            
            $code = curl_getinfo($handle, CURLINFO_HTTP_CODE);
            
            if ($code == 200 && !(curl_errno($handle))) {
                # TO CONVERT AS OBJECT
                $result = json_decode($result);
                
                # TRANSACTION INFO
                $status = $result->status;
                $tran_date = $result->tran_date;
                $tran_id = $result->tran_id;
                $val_id = $result->val_id;
                $amount = $result->amount;
                $store_amount = $result->store_amount;
                $bank_tran_id = $result->bank_tran_id;
                $card_type = $result->card_type;
                
                $explode = explode("|", $_SESSION['custom']);
                $data = [
                    'subscription_cost' => $amount,
                    'subscription_uid' => uid(),
                    'transaction_id' => $tran_id,
                    'payment_option_id' => payment_option_slug('sslcommerz')->payment_option_id,
                    'subscription_added_by' => user_id(),
                    'transaction_reference' => NULL,
                    'package_id' => $explode[1],
                    'package_duration' => package_duration($explode[1], $explode[2])[0],
                    'package_duration_type' => package_duration($explode[1], $explode[2])[1],
                    'subscription_items' => json_encode(package($explode[1]))
                ];
                if ($amount == package_cost($explode[1], $explode[2])) {
                    if ($subscription_id = $this->subscriptionModel->addSubscriptionPayment($data)) {
                        if (affiliate_accepted($subscription_id)) {
                            $dataA = [
                                'user_id' => user(subscription($subscription_id)->user_id)->referred_by,
                                'affiliate_rule_id' => getOption('affiliate_rule_id'),
                                'affiliate_commission_rate' => getOption('affiliate_commission_rate'),
                                'subscription_id' => $subscription_id
                            ];
                            $this->affiliateModel->addAffiliate($dataA);
                        }
                        if (getOption('approve_subscription_automatically') && payment_option($data['payment_option_id'])->payment_option_online == 1) {
                            $dataw = [
                                'user_id' => user_id(),
                                'user_remaining_words' => add_user_remaining_balances(user_id(), $subscription_id, 'words'),
                                'user_remaining_chat_assistants' => add_user_remaining_balances(user_id(), $subscription_id, 'chat_assistants'),
                                'user_remaining_trained_models' => add_user_remaining_balances(user_id(), $subscription_id, 'trained_models'),
                                'user_remaining_chat_files' => add_user_remaining_balances(user_id(), $subscription_id, 'chat_files'),
                                'user_remaining_chat_links' => add_user_remaining_balances(user_id(), $subscription_id, 'chat_links'),
                                'user_remaining_chat_sitemaps' => add_user_remaining_balances(user_id(), $subscription_id, 'chat_sitemaps')
                            ];
                            foreach (package_types() as $type) {
                                $out_type = 'user_remaining_' . $type;
                                $dataz = [
                                    'user_id' => user_id(),
                                    'type' => $type,
                                    'transaction_type' => 'in',
                                    'package_id' => $data['package_id'],
                                    'old' => (int)user(user_id())->$out_type,
                                    'current' => $dataw[$out_type],
                                    'user_package_history_comment' => json_encode(package($explode[1])),
                                    'user_package_history_added_by' => user_id()
                                ];
                                $this->userModel->addUserPackageHistory($dataz);
                            }
                            $this->userModel->editUserRemaining($dataw);
                        }
                        sendEmail('SubscriptionPaid', user(user_id())->email, 'subscriptions', $subscription_id, user_id());
                        notificationToUser('subscription_paid', 1, 'subscriptions/show/' . $subscription_id);
                        addActivityLog('subscription', $subscription_id, 'sslcommerz_payment_added');
                        flash('user_message', 'subscriptions', 'sslcommerz_payment_added');
                    } else {
                        flash('user_message', 'subscriptions', 'adding_sslcommerz_payment_failed', 'danger');
                    }
                } else {
                        flash('user_message', 'subscriptions', 'adding_sslcommerz_payment_failed', 'danger');
                }
            } else {
                flash('user_message', 'subscriptions', 'sslcommerz_payment_transaction_failed', 'danger');
            }
            redirect('subscriptions');
            die();
        }
        
    }
