<?php
    
    
    class Pmt_toyyibpay extends Controller
    {
        public function __construct()
        {
            if (!isLoggedIn()) {
                logout();
            }
            require APPROOT . '/views/inc/load_models.php';
        }
        
        public function index()
        {
            $toyyibpay_live_enabled = $this->settingModel->getOptions('toyyibpay_live_enabled');
            $toyyibpay_settings = $this->settingModel->getToyyibpaySettings($toyyibpay_live_enabled->option_value);
            $some_data = array(
                'userSecretKey' => $toyyibpay_settings->toyyibpay_secret_key,
                'categoryCode' => $toyyibpay_settings->toyyibpay_category,
                'billName' => uid(),
                'billDescription' => company(1)->company_name,
                'billPriceSetting' => 1,
                'billPayorInfo' => 0,
                'billAmount' => package_cost($_POST['package_id'], $_POST['package_group']),
                'billReturnUrl' => URLROOT . '/pmt_toyyibpay/toyyibpay_return',
                'billCallbackUrl' => URLROOT . '/pmt_toyyibpay/toyyibpay_callback',
                'billExternalReferenceNo' => uid(),
                'billTo' => user(user_id())->firstname . ' ' . user(user_id())->lastname,
                'billEmail' => user(user_id())->email,
                'billPhone' => user(user_id())->calling_code . user(user_id())->phone,
                'billSplitPayment' => NULL,
                'billSplitPaymentArgs' => NULL,
                'billPaymentChannel' => '2',
                'billContentEmail' => NULL,
                'billChargeToCustomer' => NULL,
                'billExpiryDate' => NULL,
                'billExpiryDays' => NULL
            );
            
            $curl = curl_init();
            curl_setopt($curl, CURLOPT_POST, 1);
            curl_setopt($curl, CURLOPT_URL, $toyyibpay_settings->toyyibpay_url . '/index.php/api/createBill');
            curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($curl, CURLOPT_POSTFIELDS, $some_data);
            
            $result = curl_exec($curl);
            $info = curl_getinfo($curl);
            curl_close($curl);
            $obj = json_decode($result);
            if (isset($obj->status) && $obj->status == "error") {
                flash('user_message', 'subscriptions', $obj->msg, 'danger');
                redirect('subscriptions');
            } else {
                header("Location:" . $toyyibpay_settings->toyyibpay_url . "/" . $obj[0]->BillCode);
            }
            die();
        }
        
        public function toyyibpay_return()
        {
            $toyyibpay_live_enabled = $this->settingModel->getOptions('toyyibpay_live_enabled');
            $toyyibpay_settings = $this->settingModel->getToyyibpaySettings($toyyibpay_live_enabled->option_value);
            //status_id, billcode, order_id
            $status_id = $_GET['status_id'];
            $billcode = $_GET['billcode'];
            if ($status_id == 1) {
                $some_data = array(
                    'billCode' => $billcode,
                    'billpaymentStatus' => NULL
                );
                $curl = curl_init();
                curl_setopt($curl, CURLOPT_POST, 1);
                curl_setopt($curl, CURLOPT_URL, $toyyibpay_settings->toyyibpay_url . '/index.php/api/getBillTransactions');
                curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
                curl_setopt($curl, CURLOPT_POSTFIELDS, $some_data);
                $result = curl_exec($curl);
                $info = curl_getinfo($curl);
                curl_close($curl);
                $obj = json_decode($result);
                
                $explode = explode("|", $_SESSION['custom']);
                if ($obj[0]->billpaymentStatus == 1 && ($obj[0]->billpaymentAmount * 100) == package_cost($explode[1], $explode[2])) {
                    $data = [
                        'subscription_cost' => $obj[0]->billpaymentAmount * 100,
                        'subscription_uid' => uid(),
                        'transaction_id' => $billcode,
                        'payment_option_id' => payment_option_slug('toyyibpay')->payment_option_id,
                        'subscription_added_by' => $explode[0],
                        'transaction_reference' => $obj[0]->billpaymentInvoiceNo,
                        'package_id' => $explode[1],
	                    'package_duration' => package_duration($explode[1], $explode[2])[0],
	                    'package_duration_type' => package_duration($explode[1], $explode[2])[1],
                        'subscription_items' => json_encode(package($explode[1]))
                    ];
                    if (empty($data['input_error'])) {
                        if ($subscription_id = $this->subscriptionModel->addSubscriptionPayment($data)) {
                            if (affiliate_accepted($subscription_id)) {
                                $dataA = [
                                    'user_id' => user(subscription($subscription_id)->user_id)->referred_by,
                                    'affiliate_rule_id' => getOption('affiliate_rule_id'),
                                    'affiliate_commission_rate' => getOption('affiliate_commission_rate'),
                                    'subscription_id' => $subscription_id
                                ];
                                $this->affiliateModel->addAffiliate($dataA);
                            }
                            if (getOption('approve_subscription_automatically') && payment_option($data['payment_option_id'])->payment_option_online == 1) {
                                $dataw = [
                                    'user_id' => $explode[0],
                                    'user_remaining_words' => add_user_remaining_balances($explode[0], $subscription_id, 'words'),
                                    'user_remaining_chat_assistants' => add_user_remaining_balances($explode[0], $subscription_id, 'chat_assistants'),
                                    'user_remaining_trained_models' => add_user_remaining_balances($explode[0], $subscription_id, 'trained_models'),
                                    'user_remaining_chat_files' => add_user_remaining_balances($explode[0], $subscription_id, 'chat_files'),
                                    'user_remaining_chat_links' => add_user_remaining_balances($explode[0], $subscription_id, 'chat_links'),
                                    'user_remaining_chat_sitemaps' => add_user_remaining_balances($explode[0], $subscription_id, 'chat_sitemaps')
                                ];
                                foreach (package_types() as $type) {
                                    $out_type = 'user_remaining_' . $type;
                                    $dataz = [
                                        'user_id' => $explode[0],
                                        'type' => $type,
                                        'transaction_type' => 'in',
                                        'package_id' => $explode[1],
                                        'old' => (int)user($explode[0])->$out_type,
                                        'current' => $dataw[$out_type],
                                        'user_package_history_comment' => json_encode(package($explode[1])),
                                        'user_package_history_added_by' => $explode[0]
                                    ];
                                    $this->userModel->addUserPackageHistory($dataz);
                                }
                                $this->userModel->editUserRemaining($dataw);
                            }
                            sendEmail('SubscriptionPaid', user($explode[0])->email, 'subscriptions', $subscription_id, $explode[0]);
                            notificationToUser('subscription_paid', 1, 'subscriptions/show/' . $subscription_id);
                            addActivityLog('subscription', $subscription_id, 'toyyibpay_payment_added');
                            flash('user_message', 'subscriptions', 'toyyibpay_payment_added');
                        } else {
                            flash('user_message', 'subscriptions', 'adding_toyyibpay_payment_failed', 'danger');
                        }
                        redirect('subscriptions/show/' . $subscription_id);
                        die();
                    } else {
                        redirect('subscriptions');
                    }
                } else {
                    flash('user_message', 'subscriptions', 'adding_toyyibpay_payment_failed', 'danger');
                    redirect('subscriptions');
                }
            } else {
                flash('user_message', 'subscriptions', 'adding_toyyibpay_payment_failed', 'danger');
                redirect('subscriptions');
            }
            die();
        }
        
    }
