<?php
    
    class Subscribers extends Controller
    {
        public function __construct()
        {
            require APPROOT . '/views/inc/load_models.php';
        }
        
        public function index()
        {
            if (!isSuperAdmin()) {
                redirect(404);
            }
            $subscribers = subscribers();
            
            $data = [
                'subscribers' => $subscribers
            ];
            $this->view('subscribers/index', $data);
        }
        
        public function add()
        {
            if ($_SERVER['REQUEST_METHOD'] == 'POST') {
                $_POST = sanitize_post();
                $data = [
                    'subscriber_email' => cleanString($_POST['subscriber_email'])
                ];
                if (empty($data['subscriber_email'])) {
                    $data['input_error'] = 'please_enter_email';
                } elseif (!validate_email($data['subscriber_email'])) {
                    $data['input_error'] = 'please_enter_valid_email_address';
                } elseif ($this->subscriberModel->getSubscriberByEmail($data['subscriber_email'])) {
                    $data['input_error'] = 'email_is_already_taken';
                }
                if (empty($data['input_error'])) {
                    if ($this->subscriberModel->addSubscriber($data)) {
                        echo '<div class="alert alert-success">' . label('your_newsletter_subscription_is_successful') . '</div>';
                    } else {
                        echo '<div class="alert alert-danger">' . label('newsletter_subscription_failed') . '</div>';
                    }
                } else {
                    echo '<div class="alert alert-danger">' . label($data['input_error']) . '</div>';
                }
            }
        }
        
        public function show($id = NULL)
        {
            if (!isSuperAdmin()) {
                redirect(404);
            }
            $subscriber = $this->subscriberModel->getSubscriberById($id);
            if (empty($subscriber)) {
                redirect(404);
            }
            $data = [
                'subscriber' => $subscriber
            ];
            $this->view('subscribers/show', $data);
        }
        
        
    }
