<?php
    
    
    class Themes extends Controller
    {
        public function __construct()
        {
            if (!isLoggedIn() && !isSuperAdmin()) {
                logout();
            }
            require APPROOT . '/views/inc/load_models.php';
        }
        
        public function index()
        {
            $data = [
                'themes' => themes()
            ];
            $this->view('themes/index', $data);
        }
        
        public function status($id = NULL)
        {
            if ($_SERVER['REQUEST_METHOD'] == 'GET') {
                $theme = theme($id);
                if (empty($theme)) {
                    redirect(404);
                }
                $data = [
                    'option_name' => 'active_theme',
                    'option_value' => $theme->theme
                ];
                if ($this->settingModel->updateOptions($data)) {
                    addActivityLog('theme', $id, 'theme_activated');
                    flash('user_message', 'themes', 'theme_activated');
                } else {
                    flash('user_message', 'themes', 'theme_activation_failed', 'danger');
                }
            }
            redirect('themes');
        }
        
        
    }















