<?php
    
    
    class Visits extends Controller
    {
        public function __construct()
        {
            if (!isLoggedIn()) {
                logout();
            }
            require APPROOT . '/views/inc/load_models.php';
        }
        
        public function index()
        {
            $data = [
                'visits' => visits(user_id())
            ];
            $this->view('visits/index', $data);
        }
        
        public function show($id = NULL)
        {
            $visit = visit($id);
            if (empty($visit) || $visit->visit_added_by != user_id()) {
                redirect(404);
            }
            $data = [
                'visit' => $visit
            ];
            $this->view('visits/show', $data);
        }
        
        public function chats($id = NULL)
        {
            $visit = visit($id);
            if (empty($visit) || $visit->visit_added_by != user_id()) {
                redirect(404);
            }
            $data = [
                'chats' => visit_chats($id)
            ];
            $this->view('visits/chats', $data);
        }
        
        public function timelines($id = NULL)
        {
            $visit = visit($id);
            if (empty($visit) || $visit->visit_added_by != user_id()) {
                redirect(404);
            }
            $data = [
                'visit_timelines' => visit_timelines($id)
            ];
            $this->view('visits/timelines', $data);
        }
        
        
    }