<?php
    
    
    class Widgets extends Controller
    {
        public function __construct()
        {
            if (!isLoggedIn()) {
                logout();
            }
            require APPROOT . '/views/inc/load_models.php';
        }
        
        public function index()
        {
            $data = [
                'user' => user(user_id()),
                'chat_assistants' => chat_assistants(),
                'widgets' => widgets(user_id())
            ];
            $this->view('widgets/index', $data);
        }
        
        public function default()
        {
            if ($_SERVER['REQUEST_METHOD'] == 'POST') {
                $data = [
                    'user' => user(user_id()),
                    'user_trained_model' => isset($_POST['user_trained_model']) ? cleanString($_POST['user_trained_model']) : NULL,
                    'user_bots' => !empty($_POST['user_bots']) ? json_encode($_POST['user_bots']) : NULL,
                    'user_chat_files' => isset($_POST['user_chat_files']) ? json_encode($_POST['user_chat_files']) : NULL,
                    'user_chat_links' => isset($_POST['user_chat_links']) ? cleanString($_POST['user_chat_links']) : NULL,
                    'user_chat_sitemaps' => isset($_POST['user_chat_sitemaps']) ? cleanString($_POST['user_chat_sitemaps']) : NULL,
                    'user_chat_icon_animation' => cleanString($_POST['user_chat_icon_animation']),
                    'user_chat_icon_position' => cleanString($_POST['user_chat_icon_position']),
                    'user_chat_instructions' => cleanString($_POST['user_chat_instructions']),
                    'widget_header' => cleanString($_POST['widget_header']),
                    'widget_header_textarea' => cleanString($_POST['widget_header_textarea']),
                    'widget_colour' => cleanString($_POST['widget_colour']),
                    'widget_assistant_background_colour' => cleanString($_POST['widget_assistant_background_colour']),
                    'widget_assistant_text_colour' => cleanString($_POST['widget_assistant_text_colour']),
                    'widget_user_background_colour' => cleanString($_POST['widget_user_background_colour']),
                    'widget_user_text_colour' => cleanString($_POST['widget_user_text_colour']),
                    'widget_message_placeholder' => cleanString($_POST['chat_message_placeholder'], 'ignore_tags'),
                    'widget_open_button' => cleanString($_POST['widget_open_button'], 'ignore_tags'),
                    'widget_close_button' => empty(strpos($_POST['widget_close_button'], ' sai-close"></i>')) ? cleanString(str_replace('"></i>', ' sai-close"></i>', $_POST['widget_close_button']), 'ignore_tags') : cleanString($_POST['widget_close_button'], 'ignore_tags'),
                    'widget_visit_timeout' => cleanString($_POST['widget_visit_timeout']),
                    'widget_document_timeout' => cleanString($_POST['widget_document_timeout']),
                    'widget_document_retries' => cleanString($_POST['widget_document_retries']),
                    'user_id' => user_id(),
                    'chat_assistants' => chat_assistants()
                ];
                if (empty($data['input_error'])) {
                    if ($this->userModel->editChatbot($data)) {
                        addActivityLog('user', user_id(), 'chatbot_updated');
                        flash('user_message', 'user', 'chatbot_updated');
                    } else {
                        flash('user_message', 'user', 'chatbot_update_failed', 'danger');
                    }
                    redirect('widgets/default');
                    die();
                }
                $this->view('widgets/default', $data);
            }
            $data = [
                'user' => user(user_id()),
                'chat_assistants' => chat_assistants(),
                'widget_code' => '
<script type="text/javascript">
(function(){
var s1=document.createElement("script"),s0=document.getElementsByTagName("script")[0];
s1.async=true;
s1.src="' . URLROOT . '/embedded/js/' . user(user_id())->user_uid . '";
s1.charset="UTF-8";
s1.setAttribute("crossorigin","*");
s0.parentNode.insertBefore(s1,s0);
})();
</script>'
            ];
            $this->view('widgets/default', $data);
        }
        
        public function add()
        {
            if ($_SERVER['REQUEST_METHOD'] == 'POST') {
                $data = [
                    'user' => user(user_id()),
                    'widget_name' => cleanString($_POST['widget_name']),
                    'user_trained_model' => isset($_POST['user_trained_model']) ? cleanString($_POST['user_trained_model']) : NULL,
                    'user_bots' => !empty($_POST['user_bots']) ? $_POST['user_bots'][0] : NULL,
                    'user_chat_files' => isset($_POST['user_chat_files']) ? json_encode($_POST['user_chat_files']) : NULL,
                    'user_chat_links' => isset($_POST['user_chat_links']) ? cleanString($_POST['user_chat_links']) : NULL,
                    'user_chat_sitemaps' => isset($_POST['user_chat_sitemaps']) ? cleanString($_POST['user_chat_sitemaps']) : NULL,
                    'user_chat_icon_animation' => cleanString($_POST['user_chat_icon_animation']),
                    'user_chat_icon_position' => cleanString($_POST['user_chat_icon_position']),
                    'user_chat_instructions' => cleanString($_POST['user_chat_instructions']),
                    'widget_header' => cleanString($_POST['widget_header']),
                    'widget_header_textarea' => cleanString($_POST['widget_header_textarea']),
                    'widget_colour' => cleanString($_POST['widget_colour']),
                    'widget_assistant_background_colour' => cleanString($_POST['widget_assistant_background_colour']),
                    'widget_assistant_text_colour' => cleanString($_POST['widget_assistant_text_colour']),
                    'widget_user_background_colour' => cleanString($_POST['widget_user_background_colour']),
                    'widget_user_text_colour' => cleanString($_POST['widget_user_text_colour']),
                    'widget_message_placeholder' => cleanString($_POST['chat_message_placeholder'], 'ignore_tags'),
                    'widget_open_button' => cleanString($_POST['widget_open_button'], 'ignore_tags'),
                    'widget_close_button' => empty(strpos($_POST['widget_close_button'], ' sai-close"></i>')) ? cleanString(str_replace('"></i>', ' sai-close"></i>', $_POST['widget_close_button']), 'ignore_tags') : cleanString($_POST['widget_close_button'], 'ignore_tags'),
                    'widget_visit_timeout' => cleanString($_POST['widget_visit_timeout']),
                    'widget_document_timeout' => cleanString($_POST['widget_document_timeout']),
                    'widget_document_retries' => cleanString($_POST['widget_document_retries']),
                    'widget_added_by' => user_id(),
                    'chat_assistants' => chat_assistants()
                ];
                
                if (empty($data['widget_name'])) {
                    $data['input_error'][] = 'please_enter_widget_name';
                }
                
                if (empty($data['input_error'])) {
                    if ($this->widgetModel->addWidget($data)) {
                        addActivityLog('widget', user_id(), 'widget_added');
                        flash('user_message', 'widget', 'widget_added');
                    } else {
                        flash('user_message', 'widget', 'adding_widget_failed', 'danger');
                    }
                    redirect('widgets');
                    die();
                }
                $this->view('widgets/add', $data);
            }
            $data = [
                'user' => user(user_id()),
                'chat_assistants' => chat_assistants()
            ];
            $this->view('widgets/add', $data);
        }
        
        public function edit($id = NULL)
        {
            $widget = widget($id);
            if (empty($widget)) {
                redirect(404);
                die();
            }
            if ($_SERVER['REQUEST_METHOD'] == 'POST') {
                $data = [
                    'widget_id' => $id,
                    'user' => user(user_id()),
                    'widget_name' => cleanString($_POST['widget_name']),
                    'user_trained_model' => isset($_POST['user_trained_model']) ? cleanString($_POST['user_trained_model']) : NULL,
                    'user_bots' => !empty($_POST['user_bots']) ? $_POST['user_bots'][0] : NULL,
                    'user_chat_files' => isset($_POST['user_chat_files']) ? json_encode($_POST['user_chat_files']) : NULL,
                    'user_chat_links' => isset($_POST['user_chat_links']) ? cleanString($_POST['user_chat_links']) : NULL,
                    'user_chat_sitemaps' => isset($_POST['user_chat_sitemaps']) ? cleanString($_POST['user_chat_sitemaps']) : NULL,
                    'user_chat_icon_animation' => cleanString($_POST['user_chat_icon_animation']),
                    'user_chat_icon_position' => cleanString($_POST['user_chat_icon_position']),
                    'user_chat_instructions' => cleanString($_POST['user_chat_instructions']),
                    'widget_header' => cleanString($_POST['widget_header']),
                    'widget_header_textarea' => cleanString($_POST['widget_header_textarea']),
                    'widget_colour' => cleanString($_POST['widget_colour']),
                    'widget_assistant_background_colour' => cleanString($_POST['widget_assistant_background_colour']),
                    'widget_assistant_text_colour' => cleanString($_POST['widget_assistant_text_colour']),
                    'widget_user_background_colour' => cleanString($_POST['widget_user_background_colour']),
                    'widget_user_text_colour' => cleanString($_POST['widget_user_text_colour']),
                    'widget_message_placeholder' => cleanString($_POST['chat_message_placeholder'], 'ignore_tags'),
                    'widget_open_button' => cleanString($_POST['widget_open_button'], 'ignore_tags'),
                    'widget_close_button' => empty(strpos($_POST['widget_close_button'], ' sai-close"></i>')) ? cleanString(str_replace('"></i>', ' sai-close"></i>', $_POST['widget_close_button']), 'ignore_tags') : cleanString($_POST['widget_close_button'], 'ignore_tags'),
                    'widget_visit_timeout' => cleanString($_POST['widget_visit_timeout']),
                    'widget_document_timeout' => cleanString($_POST['widget_document_timeout']),
                    'widget_document_retries' => cleanString($_POST['widget_document_retries']),
                    'widget_added_by' => user_id(),
                    'chat_assistants' => chat_assistants()
                ];
                if (empty($data['input_error'])) {
                    if ($this->widgetModel->updateWidget($data)) {
                        addActivityLog('user', user_id(), 'widget_updated');
                        flash('user_message', 'user', 'widget_updated');
                    } else {
                        flash('user_message', 'user', 'widget_update_failed', 'danger');
                    }
                    redirect('widgets/show/' . $id);
                    die();
                }
                $this->view('widgets/edit', $data);
            }
            $data = [
                'widget' => $widget,
                'user' => user(user_id()),
                'chat_assistants' => chat_assistants()
            ];
            $this->view('widgets/edit', $data);
        }
        
        public function show($id = NULL)
        {
            $widget = widget($id);
            if (empty($widget)) {
                redirect(404);
            }
            $data = [
                'widget' => $widget,
                'widget_code' => '
<script type="text/javascript">
(function(){
var s1=document.createElement("script"),s0=document.getElementsByTagName("script")[0];
s1.async=true;
s1.src="' . URLROOT . '/embedded/js/' . user(user_id())->user_uid . '/' . $widget->widget_uid . '";
s1.charset="UTF-8";
s1.setAttribute("crossorigin","*");
s0.parentNode.insertBefore(s1,s0);
})();
</script>'
            ];
            $this->view('widgets/show', $data);
        }
        
        public function delete($id = NULL)
        {
            $widget = widget($id);
            if (empty($widget)) {
                redirect(404);
            }
            if ($_SERVER['REQUEST_METHOD'] == 'GET') {
                $_GET = sanitize_get();
                if ($this->widgetModel->deleteWidget($id)) {
                    addActivityLog('widget', $id, 'widget_deleted');
                    flash('user_message', 'widgets', 'widget_deleted');
                    redirect('widgets');
                } else {
                    flash('user_message', 'widgets', 'widget_delete_failed', 'danger');
                    redirect('widgets/show/' . $id);
                }
                die();
            } else {
                redirect('widgets');
            }
        }
        
        
    }