<?php
    function affiliate_model()
    {
        return new Affiliate;
    }
    
    function affiliates()
    {
        $model = affiliate_model();
        if (isSuperAdmin()) {
            $results = $model->getAffiliates();
        } else {
            $results = $model->getAffiliates(user_id());
        }
        return $results;
    }
    
    function affiliates_total()
    {
        $total = 0;
        foreach (affiliates() as $affiliate) {
            $total += (int)subscription($affiliate->subscription_id)->subscription_cost * ($affiliate->affiliate_commission_rate / 100);
        }
        return $total;
    }
    
    function affiliate($affiliate_id)
    {
        $model = affiliate_model();
        return $model->getAffiliateById($affiliate_id);
    }
    
    function affiliate_by_subscription_id($subscription_id)
    {
        $model = affiliate_model();
        return $model->getAffiliateBySubscriptionId($subscription_id);
    }
    
    function affiliate_by_user_id($user_id)
    {
        $model = affiliate_model();
        return $model->getAffiliateByUserId($user_id);
    }
    
    function affiliate_rules()
    {
        $model = affiliate_model();
        return $model->getAffiliateRules();
    }
    
    function affiliate_rule($affiliate_rule_id)
    {
        $model = affiliate_model();
        return $model->getAffiliateRuleById($affiliate_rule_id);
    }
    
    function set_affiliate_cookie()
    {
        $cookie_value = false;
        if (isset($_GET['ref'])) {
            $cookie_name = "affiliate";
            $cookie_value = !empty($_GET['ref']) ? $_GET['ref'] : NULL;
            setcookie($cookie_name, $cookie_value, time() + 60 * 60 * 24 * 90, "/"); // 90 days
        }
        return $cookie_value;
    }
    
    function get_affiliate_cookie()
    {
        $cookie_name = "affiliate";
        
        if (!isset($_COOKIE[$cookie_name])) {
            $cookie = NULL;
        } else {
            $cookie = $_COOKIE[$cookie_name];
        }
        return $cookie;
    }
    
    function affiliate_accepted($subscription_id = NULL)
    {
        $accept = false;
        if (isset($subscription_id)) {
            if (getOption('enable_affiliate') && getOption('affiliate_rule_id') == 1 && !empty(user(subscription($subscription_id)->user_id)->referred_by) && empty(affiliate_by_user_id(user(subscription($subscription_id)->user_id)->referred_by))) {
                $accept = true;
            } elseif (getOption('enable_affiliate') && getOption('affiliate_rule_id') == 2) {
                $accept = true;
            }
        }
        return $accept;
    }


