<?php
    function chat_model()
    {
        return new Chat;
    }
    
    function chats($user_id = NULL)
    {
        $model = chat_model();
        
        if (isset($user_id)) {
            $results = $model->getChats($user_id);
        } else {
            $results = $model->getChats();
        }
        
        return $results;
    }
    
    function whatsapp_chats($user_id)
    {
        $model = chat_model();
        
        $results = $model->getWhatsappChats($user_id);
        
        return $results;
    }
    
    function chats_between_dates($from, $to, $user_id = NULL)
    {
        $model = chat_model();
        
        if (isset($user_id)) {
            $results = $model->getChatsBetweenDates($from, $to, $user_id);
        } else {
            $results = $model->getChatsBetweenDates($from, $to);
        }
        
        return $results;
    }
    
    function chat_messages($chat_id = NULL)
    {
        $model = chat_model();
        
        if (isset($chat_id)) {
            $results = $model->getChatMessages($chat_id);
        } else {
            $results = $model->getChatMessages();
        }
        
        return $results;
    }
    
    function last_chat_message($is_bot = NULL)
    {
        $model = chat_model();
        if (isset($is_bot)) {
            $row = $model->getLastChatMessage(1);
        } else {
            $row = $model->getLastChatMessage();
        }
        return $row;
    }
    
    function last_chat()
    {
        $model = chat_model();
        return $model->getLastChat();
    }
    
    function next_chat_id()
    {
        $model = chat_model();
        return $model->nextChatId();
    }
    
    function chat($chat_id)
    {
        $model = chat_model();
        return $model->getChatById($chat_id);
    }
    
    function chat_assistants_usage()
    {
        $model = chat_model();
        return $model->getChatAssistantsUsage();
    }
    
    function last_chat_by_source($user_id, $source, $source_id)
    {
        $model = chat_model();
        return $model->getLastChatBySource($user_id, $source, $source_id);
    }
    
    function last_chat_by_source_owner($user_id, $source, $source_id)
    {
        $model = chat_model();
        return $model->getLastChatBySourceOwner($user_id, $source, $source_id);
    }
    
    function last_chat_by_ip_address($ip_address, $source = NULL, $source_id = NULL)
    {
        $model = chat_model();
        if (isset($source) && isset($source_id)) {
            $row = $model->getLastChatByIpAddress($ip_address, $source, $source_id);
        } else {
            $row = $model->getLastChatByIpAddress($ip_address);
        }
        return $row;
    }
    
    function source_chats_by_ip_address($ip_address, $source = NULL, $source_id = NULL)
    {
        $model = chat_model();
        if (isset($source) && isset($source_id)) {
            $results = $model->getSourceChatsByIpAddress($ip_address, $source, $source_id);
        } else {
            $results = $model->getSourceChatsByIpAddress($ip_address);
        }
        return $results;
    }
    
    function source_chats($user_id, $source, $source_id)
    {
        $model = chat_model();
        return $model->getSourceChats($user_id, $source, $source_id);
    }
    
    function visit_chats($visit_id)
    {
        $model = chat_model();
        return $model->getChatsByVisit($visit_id);
    }
    
    
    function special_chat_messages()
    {
        return array('start_document_chat', 'start_link_chat');
    }