<?php
// Custom error codes
define('ERR_CHAT_UNAVAILABLE', 1001);
define('ERR_CHAT_OPTIONS_UNAVAILABLE', 1002);
define('ERR_OPENAI_CHAT', 2001);
define('ERR_OPENAI_ASSISTANT', 2002);

function get_error_message($error_code, $custom_error_message = NULL) {
	$error_message = label('error_code') . ': ';
	$real_error_message = label('error') . ': ';
    switch ($error_code) {
        case ERR_CHAT_UNAVAILABLE:
			$error_message .= ERR_CHAT_UNAVAILABLE . '. ';
			$error_message .= !empty(user_id()) ? label('you_do_not_have_an_active_subscription') : label('chat_unavailable');
			$real_error_message .= label('you_do_not_have_an_active_subscription');
			return array($error_message, $real_error_message);
        case ERR_CHAT_OPTIONS_UNAVAILABLE:
			$error_message .= ERR_CHAT_OPTIONS_UNAVAILABLE . '. ';
			$error_message .= !empty(user_id()) ? label('no_chat_options_available') : label('chat_unavailable');
			$real_error_message .= label('no_chat_options_available');
			return array($error_message, $real_error_message);
        case ERR_OPENAI_CHAT:
			$error_message .= ERR_OPENAI_CHAT . '. ';
			$error_message .= !empty(user_id()) ? $custom_error_message : label('chat_server_error');
			$real_error_message .= $custom_error_message;
			return array($error_message, $real_error_message);
        case ERR_OPENAI_ASSISTANT:
			$error_message .= ERR_OPENAI_ASSISTANT . '. ';
			$error_message .= !empty(user_id()) ? $custom_error_message : label('file_or_link_chat_error');
			$real_error_message .= $custom_error_message;
			return array($error_message, $real_error_message);
        default:
			$error_message .= label('unknown_error_occurred');
			$real_error_message .= $custom_error_message;
			return array($error_message, $real_error_message);
    }
}