<?php
    function label($label)
    {
        if (isset($_SESSION['language'])) {
            $iso = $_SESSION['language'];
        } else {
            if (user_id()) {
                $iso = user(user_id())->default_language;
                if (language_file($iso)) {
                    $iso = user(user_id())->default_language;
                } else {
                    $iso = getOption('default_language');
                }
            } else {
                $iso = getOption('default_language');
            }
        }
        if (language_file($iso)) {
            require language_file_name($iso);
            $label_t = $lang[$label] ?? str_replace('_', ' ', $label);
            return ucfirst($label_t);
        } else {
            return ucfirst($label);
        }
    }
    
    function use_db()
    {
        return true;
    }
    
    function yes_no_label($id)
    {
        if ($id == 0) {
            $colour = 'danger';
            $label = 'No';
        } else {
            $colour = 'success';
            $label = 'Yes';
        }
        return "<label class='mb-2 mr-2 badge bg-" . $colour . "'> " . $label . "</label>";
    }
    
    function status_label($status_colour, $status)
    {
        return "<label class='badge bg-" . $status_colour . "'> " . $status . "</label>";
    }
    
    function status_ribbon($status_colour, $status)
    {
        return "<div class='ribbon " . $status_colour . "'><span> " . $status . "</span></div>";
    }
    
    function item_nav_card()
    {
        return '
        <div class="mb-3  bg-transparent">
            <div class="no-gutters row">';
    }
    
    function item_nav_start()
    {
        $f = '<div class="col-sm-12">';
        $f .= '<div class="card bg-white mb-3">';
        $f .= '<div class="card-body">';
        $f .= '<ul class="tabs-animated-shadow tabs-animated nav  tabs-rounded-lg">';
        return $f;
    }
    
    function item_nav($url, $fa, $label, $link_attribute = NULL)
    {
        if (current_file() == $url) {
            $nav = "<li class='nav-item'> <a href=" . primary_url() . '/' . $url . '/' . current_id() . " class='nav-link active'> <span> <i class='fa-solid fa-" . $fa . "'></i> " . label($label) . "</span></a></li>";
        } else {
            $nav = "<li class='nav-item'> <a href=" . primary_url() . '/' . $url . '/' . current_id() . " class=' nav-link'> <span> <i class='fa-solid fa-" . $fa . "'></i> " . label($label) . "</span></a></li>";
        }
        return $nav;
    }
    
    function item_nav_end()
    {
        $f = '</div>';
        $f .= '</div>';
        $f .= '</div>';
        $f .= '</ul>';
        return $f;
    }
    
    function selectpicker()
    {
        return 'selectpicker';
        //return '';
    }
    
    function fa_link($controller, $action, $id, $fa)
    {
        return '<a href="' . URLROOT . '/' . $controller . '/' . $action . '/' . $id . '" data-bs-toggle="tooltip" data-bs-placement="left" title="' . label($action) . '" class="btn btn-transparent btn-xs"><i class="fa fa-' . $fa . ' fa-"></i></a>';
    }
    
    function n_link($controller, $action, $id, $label, $extra = NULL, $remove = NULL)
    {
        if (validate_url($label) && !isset($remove)) {
            $link = '<a href="' . URLROOT . '/' . $controller . '/' . $action . '/' . $id . '"><img src=' . $label . ' class="img-rounded" height="40px" width="40px" alt=""/> ' . $extra . '</a>';
        } else {
            $link = '<a href="' . URLROOT . '/' . $controller . '/' . $action . '/' . $id . '">' . $label . '</a>';
        }
        return $link;
    }
    
    function card_div()
    {
        return '<div class="row">';
    }
    
    function close_card_div($no = NULL)
    {
        if ($no == 1) {
            $div = '</div>';
        } elseif ($no == 2) {
            $div = '</div></div>';
        } else {
            $div = '</div></div></div>';
        }
        return $div;
    }
    
function currency_format($currency, $used = NULL)
    {
    	$currency = !empty($currency) ? str_replace(',','',$currency) : 0;
        if ($currency == 0) {
            $currency = '0.00';
        } else {
    		$currency = str_replace(',','',$currency);
            $currency = number_format($currency, getOption('number_of_currency_decimals'));
        }
        
        if(getOption('use_currency_symbol')){
			$useCurrency = getOption('currency_symbol');
		}else{
			$useCurrency = getOption('default_currency');
		}
        
        if (getOption('currency_symbol_placement') == 'after') {
            $format = $currency . $useCurrency;
            $cents = substr($currency, -2);
        } else {
            $format = $useCurrency . $currency;
            $cents = substr($format, -2);
        }
        $format = str_replace('.' . $cents, '.<small>' . $cents . '</small>', $format);
        return $format;
    }
    
    function bold_currency_format($currency, $used = NULL)
    {
    	$currency = !empty($currency) ? str_replace(',','',$currency) : 0;
        if ($currency == 0) {
            $currency = '0.00';
        } else {
            $currency = number_format($currency, getOption('number_of_currency_decimals'));
        }
        
        if(getOption('use_currency_symbol')){
			$useCurrency = getOption('currency_symbol');
		}else{
			$useCurrency = getOption('default_currency');
		}
        
        if (getOption('currency_symbol_placement') == 'after') {
            $format = $currency . $useCurrency;
            $cents = substr($currency, -2);
        } else {
            $format = $useCurrency . $currency;
            $cents = substr($format, -2);
        }
        $format = str_replace('.' . $cents, '.<small>' . $cents . '</small>', $format);
        $format = "<span class='fw-bolder'>" . $format . "</span>";
        return $format;
    }
    
    function text_normal($text)
    {
        return "<span class='fw-normal'>" . $text . "</span>";
    }
    
    function text_bold($text)
    {
        return "<span class='fw-bold'>" . $text . "</span>";
    }
    
    function text_bold_red($text)
    {
        return "<span class='fw-bold text-danger'>" . $text . "</span>";
    }
    
    function increase_or_decrease($amount, $total)
    {
        $percentage = percentage(($amount - $total), $total, 2);
        if ($percentage > 0 && ($amount + $total)) {
            $i_d = label('increase');
            $icon = 'up';
            $colour = 'success';
            $sign = '% ';
        } elseif ($percentage < 0 && ($amount != $total)) {
            $percentage = number_format($percentage * -1, 2);
            $i_d = label('decrease');
            $icon = 'down';
            $colour = 'danger';
            $sign = '% ';
        } else {
            $percentage = '';
            $i_d = '';
            $icon = '';
            $colour = '';
            $sign = '';
        }
        $out = '';
        if (!empty($percentage)) {
            $out .= '<span class="d-inline text-' . $colour . ' pr-1">';
            $out .= '&nbsp;&nbsp;<i class="fa fa-arrow-' . $icon . ' fw-bold"></i>&nbsp;&nbsp;';
            $out .= '<span class="pl-1">';
            $out .= $percentage;
            $out .= $sign;
            $out .= '</span>';
            $out .= '</span>';
            //$out .= '<span class="text-' . $colour . '">' . $i_d . '</span>';
        }
        return $out;
    }
    
    function month_name_in_json()
    {
        return '["' . label('january') . '","' . label('february') . '","' . label('march') . '","' . label('april') . '","' . label('may') . '","' . label('june') . '","' . label('july') . '","' . label('august') . '","' . label('september') . '","' . label('october') . '","' . label('november') . '","' . label('december') . '"]';
    }
    
    function week_name_in_json()
    {
        return '["' . label('monday') . '", "' . label('tuesday') . '", "' . label('wednesday') . '", "' . label('thursday') . '", "' . label('friday') . '", "' . label('saturday') . '", "' . label('sunday') . '"]';
    }
