<?php
    function paddle_authentication()
    {
        $paddle = payment_option_settings('paddle')['settings'];
        
        $headers = [
            "Authorization: Bearer " . $paddle->paddle_api_key,
        ];
        
        $ch = curl_init($paddle->paddle_url . "event-types");
        
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
        
        $result = curl_exec($ch);
        
        $response = json_decode($result, true);
        
        if (isset($response['data'])) {
            $data['status'] = 'success';
            $data['message'] = NULL;
        } elseif (isset($response['error'])) {
            $data['status'] = 'error';
            $data['product_id'] = NULL;
            $data['message'] = $response['error']['detail'];
        } else {
            $data['status'] = 'error';
            $data['product_id'] = NULL;
            $data['message'] = 'unknown_error';
        }
        
        curl_close($ch);
        
        return $data;
    }
    
    function paddle_create_product($product)
    {
        $paddle = payment_option_settings('paddle')['settings'];
        
        $post_data = '{
	  "name": "' . $product . '",
	  "tax_category": "standard",
	  "description": "",
	  "image_url": "",
	  "custom_data": {
	    "features": {
	      "crm": false,
	      "data_retention": true,
	      "reports": true
	    }
	  }
	}';
        
        $ch = curl_init($paddle->paddle_url . "products");
        
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $post_data);
        curl_setopt($ch, CURLOPT_HTTPHEADER, [
            "Authorization: Bearer " . $paddle->paddle_api_key,
            "Content-Type: application/json",
        ]);
        
        $result = curl_exec($ch);
        
        $response = json_decode($result, true);
        
        if (isset($response['data'])) {
            $data['status'] = 'success';
            $data['product_id'] = $response['data']['id'];
            $data['message'] = NULL;
        } elseif (isset($response['error'])) {
            $data['status'] = 'error';
            $data['product_id'] = NULL;
            $data['message'] = $response['error']['detail'];
        } else {
            $data['status'] = 'error';
            $data['product_id'] = NULL;
            $data['message'] = 'unknown_error';
        }
    
        curl_close($ch);
        
        return $data;
    }
    
    function paddle_create_price($input_data)
    {
        $paddle = payment_option_settings('paddle')['settings'];
        
        $post_data = '{
	  "description": "' . $input_data["description"] . '",
	  "name": "' . $input_data["name"] . '",
	  "product_id": "' . $input_data["product_id"] . '",
	  "unit_price": {
	    "amount": "' . $input_data["amount"] . '",
	    "currency_code": "' . $input_data["currency_code"] . '"
	  },
	  "billing_cycle": null,
	  "trial_period": null,
	  "tax_mode": "account_setting",
	  "quantity": {
	    "minimum": 1,
	    "maximum": 1
	  }
	}';
        
        $ch = curl_init($paddle->paddle_url . "prices");
        
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $post_data);
        curl_setopt($ch, CURLOPT_HTTPHEADER, [
            "Authorization: Bearer " . $paddle->paddle_api_key,
            "Content-Type: application/json",
        ]);
        
        $result = curl_exec($ch);
        
        $response = json_decode($result, true);
        
        if (isset($response['data'])) {
            $data['status'] = 'success';
            $data['price_id'] = $response['data']['id'];
            $data['message'] = NULL;
        } elseif (isset($response['error'])) {
            $data['status'] = 'error';
            $data['product_id'] = NULL;
            $data['message'] = $response['error']['detail'];
        } else {
            $data['status'] = 'error';
            $data['product_id'] = NULL;
            $data['message'] = 'unknown_error';
        }
    
        curl_close($ch);
        
        return $data;
    }
    
    function paddle_transaction($transaction_id)
    {
        $paddle = payment_option_settings('paddle')['settings'];
        
        $headers = [
            "Authorization: Bearer " . $paddle->paddle_api_key,
        ];
        
        $ch = curl_init($paddle->paddle_url . "transactions/" . $transaction_id);
        
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
        
        $result = curl_exec($ch);
        
        $response = json_decode($result, true);
        
        if (isset($response['data'])) {
            $data['status'] = 'success';
            $data['message'] = NULL;
            $data['data'] = $response['data'];
        } elseif (isset($response['error'])) {
            $data['status'] = 'error';
            $data['message'] = $response['error']['detail'];
            $data['data'] = NULL;
        } else {
            $data['status'] = 'error';
            $data['message'] = 'unknown_error';
            $data['data'] = NULL;
        }
        
        curl_close($ch);
    
        return $data;
    }