<?php
    ini_set('session.cookie_httponly', true);
    session_start();

// Flash message helper
    function flash($name = '', $type = '', $message = '', $class = '')
    {
        if (!empty($class)) {
            $class = 'alert alert-' . $class;
        } else {
            $class = 'alert alert-success';
        }
        
        if (!empty($name)) {
            if (!empty($message) && empty($_SESSION[$name])) {
    
                if (!empty($_SESSION[$name . '_class'])) {
                    unset($_SESSION[$name . '_class']);
                }
                
                $_SESSION[$name] = ucfirst(strtolower(label($message)));
                $_SESSION[$name . '_class'] = $class;
            } elseif (empty($message) && !empty($_SESSION[$name])) {
                $class = !empty($_SESSION[$name . '_class']) ? $_SESSION[$name . '_class'] : '';
                echo '<div class="' . $class . '" id="msg-flash">' . $_SESSION[$name] . '</div>';
                unset($_SESSION[$name]);
                unset($_SESSION[$name . '_class']);
            }
        }
    }
    
    function company_id()
    {
        return $_SESSION['company_id'] ?? false;
    }
    
    function user_id()
    {
        if (isset($_SESSION['user_id']) && isset($_SESSION['session_access_token'])) {
            return $_SESSION['user_id'];
        } else {
            return false;
        }
    }
    
    function getUserSession()
    {
        $model = new User;
        return $model->getUserSession(user_id());
    }
    
    function isLoggedIn()
    {
        if (user_id() && isset($_SESSION['session_access_token']) && getUserSession()->session_access_token == $_SESSION['session_access_token']) {
            return true;
        } else {
            return false;
        }
    }
    
    function isSuperAdmin()
    {
        if (user_id() == 1) {
            return true;
        } else {
            return false;
        }
    }
    
    function isUser()
    {
        if (user_id()) {
            return true;
        } else {
            return false;
        }
    }
    
    function token()
    {
        if (user_id()) {
            return $_SESSION['session_access_token'];
        }else{
            return false;
        }
    }
    
    function logout()
    {
        $model = new User;
        if (isset($_SESSION['session_access_token']) && isset($_SESSION['user_id'])) {
            $model->deleteUserSession($_SESSION['session_access_token']);
//setRedirect();
            unset($_SESSION['company_id']);
            unset($_SESSION['user_id']);
            unset($_SESSION['email']);
            unset($_SESSION['username']);
            unset($_SESSION['session_access_token']);
            session_destroy();
        }
        redirect('');
        die();
    }