<?php
    function setting_model()
    {
        return new Setting;
    }
    
    function useCurrency()
    {
        if (getOption('use_currency_symbol') == 0) {
            return getOption('default_currency') . ' ';
        } else {
            return getOption('currency_symbol');
        }
    }
    
    function timezones()
    {
        $model = new Setting;
        return $model->getTimezones();
    }
    
    function supported_currencies()
    {
        $model = new Setting;
        return $model->getSupportedCurrencies();
    }
    
    function supported_date_formats()
    {
        $model = new Setting;
        return $model->getSupportedDateFormats();
    }
    
    function supported_date_time_formats()
    {
        $model = new Setting;
        return $model->getSupportedDateTimeFormats();
    }
    
    function email_templates()
    {
        $model = new Setting;
        return $model->getEmailTemplates();
    }
    
    function countries()
    {
        $model = new Setting;
        return $model->getCountries();
    }
    
    function country($country_id)
    {
        $model = new Setting;
        return $model->getCountryById($country_id);
    }
    
    function getCountryByName($country_name)
    {
        $model = new Setting;
        return $model->getCountryByName($country_name);
    }
    
    function getCurrencies()
    {
        $model = new Setting;
        return $model->getCurrencies();
    }
    
    function getCurrencyById($currency_id)
    {
        $model = new Setting;
        return $model->getCurrencyById($currency_id);
    }
    
    function getCreditCardTypes()
    {
        $model = new Setting;
        return $model->getCreditCardTypes();
    }
    
    function getEmailTemplateById($id)
    {
        $model = new Setting;
        return $model->getEmailTemplateById($id);
    }
    
    function email_template_by_type($type)
    {
        $model = new Setting;
        return $model->getEmailTemplateByType($type);
    }
    
    function getOption($option_name)
    {
        $model = new Setting;
        return $model->getOptions($option_name)->option_value;
    }
    
    function getOptionAutoload($option_name)
    {
        $model = new Setting;
        return $model->getOptions($option_name)->option_autoload;
    }
    
    function payment_gateways()
    {
        $model = new Setting;
        return $model->getPaymentGateways();
    }
    
    function payment_gateway($id)
    {
        $model = new Setting;
        return $model->getPaymentGatewayById($id);
    }
    
    function isPaymentGatewayActive($gateway)
    {
        $model = new Setting;
        $row = $model->getOptions($gateway);
        if (!empty($row) && $row->option_autoload == 1) {
            return true;
        } else {
            return false;
        }
    }
    
    function isEmailTemplateEnabled($email_template_id)
    {
        $model = new Setting;
        $row = $model->getEmailTemplateById($email_template_id);
        if ($row->email_template_status == 1) {
            return true;
        } else {
            return false;
        }
    }
    
    function emailTemplate($email_template_id)
    {
        $model = new Setting;
        $row = $model->getEmailTemplateById($email_template_id);
        return $row->email_message;
    }
    
    function getEmailTemplate($email_template_id)
    {
        $model = new Setting;
        return $model->getEmailTemplateById($email_template_id);
    }
    
    function file_type($file, $sub_dir, $temp_file)
    {
        $model = new Setting;
        $row = $model->getOptions('allowed_file_types');
//Allow certain file formats
        $target_dir = APPROOT . UPLOADS_FOLDER . $sub_dir . "/";
        $target_file = $target_dir . basename($file);
        $imageFileType = pathinfo($target_file, PATHINFO_EXTENSION);
        $allowed = explode(",", $row->option_value);
        if (!in_array($imageFileType, $allowed)) {
            return false;
        } else {
            if (move_uploaded_file($temp_file, $target_dir . $file)) {
                return true;
            }else{
                return false;
            }
        }
    }
    
    function payment_option_settings($payment_option)
    {
        $model = new Setting;
        $payment_option_two = str_replace('_', '', ucfirst($payment_option));
        $get_settings = 'get' . $payment_option_two . 'Settings';
        $live_enabled = $model->getOptions($payment_option . '_live_enabled');
        $settings = $model->$get_settings($live_enabled->option_value);
        return [
            'live_enabled' => $live_enabled,
            'settings' => $settings
        ];
    }
    
    function item_statuses()
    {
        $model = new Setting;
        return $model->getItemStatuses();
    }
    
    function item_status($item_status_id)
    {
        $model = new Setting;
        return $model->getItemStatusById($item_status_id);
    }
    
    function item_settings()
    {
        $model = new Setting;
        return $model->getItemSettings();
    }
    
    function navigation($navigation_name)
    {
        $model = new Setting;
        return $model->getNavigationByName($navigation_name);
    }
    
    function social_profiles()
    {
        $model = new Setting;
        return $model->getSocialProfiles();
    }
    
    function programming_languages()
    {
        $model = new Setting;
        return $model->getProgrammingLanguages();
    }
    
    function chat_icon_animations()
    {
        $model = new Setting;
        return $model->getChatIconAnimations();
    }
    
    function item($item)
    {
        $model = new Setting;
        return $model->getItemByName($item);
    }
    
    function item_values($item, $monthly, $weekly, $daily)
    {
        //item|colour|monthly|weekly|daily
        return [
            'item' => label($item),
            'rgb_colour' => item($item)->item_rgb_colour,
            'monthly' => $monthly,
            'weekly' => $weekly,
            'daily' => $daily
        ];
    }
    
    function monthly_breakdown($item, $user_id = NULL)
    {
        for ($m = 1; $m <= 12; $m++) {
            $last_day = date("t", strtotime(date('Y') . "-" . $m . "-01"));
            if ($item == 'subscriptions') {
                $data[] = count(subscriptions_between_dates(date('Y') . '-' . $m . '-01 00:00', date('Y') . '-' . $m . '-' . $last_day . ' 23:59', $user_id));
            } elseif ($item == 'visits') {
                $data[] = count(visits_between_dates(date('Y') . '-' . $m . '-01 00:00', date('Y') . '-' . $m . '-' . $last_day . ' 23:59', $user_id));
            } elseif ($item == 'users') {
                $data[] = count(users_between_dates(date('Y') . '-' . $m . '-01 00:00', date('Y') . '-' . $m . '-' . $last_day . ' 23:59'));
            } elseif ($item == 'chats') {
                $data[] = count(chats_between_dates(date('Y') . '-' . $m . '-01 00:00', date('Y') . '-' . $m . '-' . $last_day . ' 23:59', $user_id));
            } elseif ($item == 'subscriptions_income') {
                $data[] = !empty(total_subscriptions_income_between_dates(date('Y') . '-' . $m . '-01 00:00', date('Y') . '-' . $m . '-' . $last_day . ' 23:59')->subscription_cost) ? total_subscriptions_income_between_dates(date('Y') . '-' . $m . '-01 00:00', date('Y') . '-' . $m . '-' . $last_day . ' 23:59')->subscription_cost : 0;
            } elseif ($item == 'payouts') {
                $data[] = !empty(payouts_total(2, date('Y') . '-' . $m . '-01 00:00', date('Y') . '-' . $m . '-' . $last_day . ' 23:59')->payout_amount) ? payouts_total(2, date('Y') . '-' . $m . '-01 00:00', date('Y') . '-' . $m . '-' . $last_day . ' 23:59')->payout_amount : 0;
            } else {
                $data = array();
            }
        }
        return $data;
    }
    
    function daily_breakdown($item, $user_id = NULL)
    {
        $last_day = date("t", strtotime(date('Y') . "-" . date('m') . "-01"));
        $data = array();
        for ($d = 1; $d <= $last_day; $d++) {
            if ($item == 'subscriptions') {
                $data[] = count(subscriptions_between_dates(date('Y') . '-' . date('m') . '-' . $d . ' 00:00', date('Y') . '-' . date('m') . '-' . $d . ' 23:59', $user_id));
            } elseif ($item == 'users') {
                $data[] = count(users_between_dates(date('Y') . '-' . date('m') . '-' . $d . ' 00:00', date('Y') . '-' . date('m') . '-' . $d . ' 23:59'));
            } elseif ($item == 'visits') {
                $data[] = count(visits_between_dates(date('Y') . '-' . date('m') . '-' . $d . ' 00:00', date('Y') . '-' . date('m') . '-' . $d . ' 23:59', $user_id));
            } elseif ($item == 'chats') {
                $data[] = count(chats_between_dates(date('Y') . '-' . date('m') . '-' . $d . ' 00:00', date('Y') . '-' . date('m') . '-' . $d . ' 23:59', $user_id));
            } else {
                $data = array();
            }
        }
        return $data;
    }
    
    function graph_labels()
    {
        $last_day = date("t", strtotime(date('Y') . "-" . date('m') . "-01"));
        $day = array();
        for ($d = 1; $d <= $last_day; $d++) {
            $day[] = $d;
        }
        return [
            'month' => json_decode(month_name_in_json()),
            'week' => json_decode(week_name_in_json()),
            'day' => $day
        ];
    }
