<?php
// Unique id generator (uid) 8 alpha-numeric characters
    function uid($no_of_characters = NULL)
    {
        if (isset($no_of_characters)) {
            return substr(base_convert(sha1(uniqid(mt_rand())), 16, 36), 0, $no_of_characters);
        } else {
            return substr(base_convert(sha1(uniqid(mt_rand())), 16, 36), 0, 8);
        }
    }
    
    function generate_key_string()
    {
        $tokens = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789';
        $segment_chars = 5;
        $num_segments = 4;
        $key_string = '';
        for ($i = 0; $i < $num_segments; $i++) {
            $segment = '';
            
            for ($j = 0; $j < $segment_chars; $j++) {
                $segment .= $tokens[rand(0, 35)];
            }
            $key_string .= $segment;
            if ($i < ($num_segments - 1)) {
                $key_string .= '-';
            }
        }
        return $key_string;
    }
    
    function generate_random_string($n = NULL)
    {
        if (!isset($n)) {
            $n = 15;
        }
        $characters = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
        $randomString = '';
        
        for ($i = 0; $i < $n; $i++) {
            $index = rand(0, strlen($characters) - 1);
            $randomString .= $characters[$index];
        }
        
        return $randomString;
    }
    
    function generate_otp($length = 4)
    {
        $alphabet = "0123456789";
        $otp = "";
        for ($i = 0; $i < $length; $i++) {
            $otp .= $alphabet[rand(0, strlen($alphabet) - 1)];
        }
        return $otp;
    }

//IP address
    function ip_address()
    {
        $ip_address = '';
        if (getenv('HTTP_CLIENT_IP')) {
            $ip_address = getenv('HTTP_CLIENT_IP');
        } elseif (getenv('HTTP_X_FORWARDED_FOR')) {
            $ip_address = getenv('HTTP_X_FORWARDED_FOR');
        } elseif (getenv('HTTP_X_FORWARDED')) {
            $ip_address = getenv('HTTP_X_FORWARDED');
        } elseif (getenv('HTTP_FORWARDED_FOR')) {
            $ip_address = getenv('HTTP_FORWARDED_FOR');
        } elseif (getenv('HTTP_FORWARDED')) {
            $ip_address = getenv('HTTP_FORWARDED');
        } elseif (getenv('REMOTE_ADDR')) {
            $ip_address = getenv('REMOTE_ADDR');
        } else {
            $ip_address = 'UNKNOWN';
        }
        return $ip_address;
    }

//Get protocol
    function protocol()
    {
        if (isset($_SERVER['HTTPS']) &&
            ($_SERVER['HTTPS'] == 'on' || $_SERVER['HTTPS'] == 1) ||
            isset($_SERVER['HTTP_X_FORWARDED_PROTO']) &&
            $_SERVER['HTTP_X_FORWARDED_PROTO'] == 'https') {
            $protocol = 'https://';
        } else {
            $protocol = 'http://';
        }
        return $protocol;
    }

//Get complete Url
    function completeUrl()
    {
        return protocol() . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'];
    }
    
    function url_without_urlroot($url = NULL)
    {
        if (isset($url)) {
            return str_replace(URLROOT . '/', '', $url);
        } else {
            return str_replace(URLROOT . '/', '', completeUrl());
        }
    }
    
    function getExplodedUrl()
    {
        if (isset($_GET['url'])) {
            $url = rtrim($_GET['url'], '/');
            $url = filter_var($url, FILTER_SANITIZE_URL);
            return explode('/', $url);
        }else{
            return false;
        }
    }
    
    function urlroot_domain($url)
    {
        $parsedUrl = parse_url($url);
        $host = $parsedUrl['host'];
        if ($host === 'localhost' || $host === '127.0.0.1') {
            $domain = $host;
        } else {
            $hostParts = explode('.', $host);
            $domain = $hostParts[count($hostParts) - 2] . '.' . $hostParts[count($hostParts) - 1];
        }
        return $domain;
    }
    
    
    function itemsPrefixed()
    {
        return array('subscription', 'order');
    }
    
    function empty_stdclass($item, $value = NULL)
    {
        $row = new stdClass;
        if (isset($value)) {
            $row->$item = $value;
        } else {
            $row->$item = '-';
        }
        return $row;
    }
    
    /*function to_stdclass($array){
        $object = new stdClass;
        foreach($array as $key=>$value){
            if(is_array($value)){
                $value = toObject($value);
            }
            $object->$key = $value;
        }
        return $value;
    }*/
    
    function to_stdclass($array)
    {
        return json_decode(json_encode($array), FALSE);
    }
    
    function text_number_only($string)
    {
        if (preg_match('/^[a-zA-Z\d]+$/', $string)) {
            return $string;
        } else {
            return '';
        }
    }
    
    function html_decode($string)
    {
        if (!getOption('htmlentities_decode_enabled')) {
            $string = htmlentities($string);
        }
        return $string;
    }
    
    function decode_text($string, $language)
    {
        if ($language == 'arabic') {
            $string = preg_replace('/\\\u([0-9a-z]{4})/i', '&#x$1;', str_replace('%u', '\u', $string));
        } else {
            $string = html_decode($string);
        }
        return $string;
    }

//Time now
    function now()
    {
        return date('Y-m-d H:i:s');
    }

//Today
    function today()
    {
        return date('Y-m-d');
    }

//Year
    function year()
    {
        return date('Y');
    }

//Today start
    function today_start()
    {
        return date("Y-m-d") . ' 00:00:00';
    }

//Today end
    function today_end()
    {
        return date("Y-m-d") . ' 23:59:59';
    }

//Yesterday start
    function yesterday_start()
    {
        return date("Y-m-d", strtotime('-1 days')) . ' 00:00:00';
    }

//Yesterday end
    function yesterday_end()
    {
        return date("Y-m-d", strtotime('-1 days')) . ' 23:59:59';
    }

//Week start
    function week_start()
    {
        return date("Y-m-d", strtotime('monday this week'));
    }

//Week end
    function week_end()
    {
        return date("Y-m-d", strtotime("sunday this week"));
    }

//Last Week start
    function last_week_start()
    {
        return date("Y-m-d", strtotime('monday last week'));
    }

//Week end
    function last_week_end()
    {
        return date("Y-m-d", strtotime("sunday last week"));
    }

//Month start
    function month_start()
    {
        return date("Y-m-d", strtotime('first day of this month'));
    }

//Month end
    function month_end()
    {
        return date("Y-m-d", strtotime("last day of this month"));
    }

//Last Month start
    function last_month_start()
    {
        return date("Y-m-d", strtotime('first day of last month'));
    }

//Last Month end
    function last_month_end()
    {
        return date("Y-m-d", strtotime("last day of last month"));
    }

//Year start
    function year_start()
    {
        return date("Y-m-d", strtotime('first day of January'));
    }

//Year end
    function year_end()
    {
        return date("Y-m-d", strtotime("last day of December"));
    }

//Number of seconds in a day
    function no_of_seconds_in_a_day()
    {
        return 24 * 60 * 60;
    }
    
    function time_elapsed_string($datetime, $full = false)
    {
        $now = new DateTime;
        $ago = new DateTime($datetime);
        $diff = $now->diff($ago);
        
        /*$diff->w = floor($diff->d / 7);
        $diff->d -= $diff->w * 7;*/
        
        $string = array(
            'y' => 'year',
            'm' => 'month',
            //'w' => 'week',
            'd' => 'day',
            'h' => 'hour',
            'i' => 'minute',
            's' => 'second',
        );
        foreach ($string as $k => &$v) {
            if ($diff->$k) {
                $v = $diff->$k . ' ' . $v . ($diff->$k > 1 ? 's' : '');
            } else {
                unset($string[$k]);
            }
        }
        
        if (!$full) $string = array_slice($string, 0, 1);
        return $string ? implode(', ', $string) . ' ago' : 'just now';
    }

//convert to hours, minutes and seconds
    function convert_to_h_i_s($time)
    {
        $hours = !empty(floor($time / 3600)) ? floor($time / 3600) . 'h ' : NULL;
        $minutes = !empty(floor(($time % 3600) / 60)) ? floor(($time % 3600) / 60) . 'm ' : NULL;
        $seconds = ($time % 60) . 's';
        return $hours . ' ' . $minutes . ' ' . $seconds;
    }

//Is date valid
    function is_date_valid($date)
    {
        $out = "Valid";
//Check the length of the entered Date value
        if ((strlen($date) < 10) or (strlen($date) > 10)) {
            $out = "Enter the date in 'yyyy-mm-dd' format 1";
        } else {
//The entered value is checked for proper Date format
            if ((substr_count($date, "-")) <> 2) {
                $out = "Enter the date in 'yyyy-mm-dd' format 2";
            } else {
                $pos = strpos($date, "-");
                $year = substr($date, 0, ($pos));
                $result = preg_match("/^[0-9]+$/", $year, $trashed);
                if (!($result)) {
                    $out = "Enter a Valid year";
                } else {
                    if (($year < 1900) or ($year > 2200)) {
                        $out = "Enter a year between 1900-2200";
                    }
                }
                $month = substr($date, ($pos + 1), ($pos - 2));
                if (($month <= 0) or ($month > 12)) {
                    $out = "Enter a Valid Month";
                } else {
                    $result = preg_match("/^[0-9]+$/", $month, $trashed);
                    if (!($result)) {
                        $out = "Enter a Valid Month";
                    }
                }
                $date = substr($date, ($pos - 6), ($pos));
                $result = preg_match("/^[0-9]+$/", $date, $trashed);
                if (!($result)) {
                    $out = "Enter a Valid Date";
                } else {
                    if (($date <= 0) or ($date > 31)) {
                        $out = "Enter a Valid Date";
                    }
                }
            }
        }
        if ($out == "Valid") {
            return true;
        } else {
            return false;
        }
    }
    
    function item_slug($text)
    {
        $divider = '_';
        // replace non letter or digits by divider
        $text = preg_replace('~[^\pL\d]+~u', $divider, $text);
        
        // transliterate
        $text = iconv('utf-8', 'us-ascii//TRANSLIT', $text);
        
        // remove unwanted characters
        $text = preg_replace('~[^-\w]+~', '', $text);
        
        // trim
        $text = trim($text, $divider);
        
        // remove duplicate divider
        $text = preg_replace('~-+~', $divider, $text);
        
        // lowercase
        $text = strtolower($text);
        
        if (empty($text)) {
            return 'n-a';
        }
        
        return $text;
    }
    
    function generate_seo_url($string, $wordLimit = 0)
    {
        $separator = '-';
        
        if ($wordLimit != 0) {
            $wordArr = explode(' ', $string);
            $string = implode(' ', array_slice($wordArr, 0, $wordLimit));
        }
        
        $quoteSeparator = preg_quote($separator, '#');
        
        $trans = array(
            '&.+?;' => '',
            '[^\w\d _-]' => '',
            '\s+' => $separator,
            '(' . $quoteSeparator . ')+' => $separator
        );
        
        $string = strip_tags($string);
        foreach ($trans as $key => $val) {
            $string = preg_replace('#' . $key . '#iu', $val, $string);
        }
        
        $string = strtolower($string);
        
        return trim(trim($string, $separator));
    }
    
    function month_names()
    {
        return array('January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December');
    }
    
    function month_short_names()
    {
        return array('Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec');
    }
    
    function week_names()
    {
        return array('Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday', 'Sunday');
    }
    
    function week_short_names()
    {
        return array('Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat', 'Sun');
    }

//Default date format
    function dateFormat($date)
    {
        $date = date(getOption('default_date_format'), strtotime($date));
        if (!function_exists('use_db')) {
            $date = str_replace(array_merge(month_names(), month_short_names(), week_names(), week_short_names()), array_merge((array)label('month_names'), (array)label('month_short_names'), (array)label('week_names'), (array)label('week_short_names')), $date);
        }
        return $date;
    }

//Valid date format characters
    function validDateFormatCharacters()
    {
        return array('d', 'j', 'D', 'l', 'm', 'n', 'M', 'F', 'y', 'Y');
    }

//Default datetime format
    function dateTimeFormat($datetime)
    {
        $datetime = date(getOption('default_datetime_format'), strtotime($datetime));
        if (!function_exists('use_db')) {
            $datetime = str_replace(array_merge(month_names(), month_short_names(), week_names(), week_short_names()), array_merge((array)label('month_names'), (array)label('month_short_names'), (array)label('week_names'), (array)label('week_short_names')), $datetime);
        }
        return $datetime;
    }

//Valid datetime format characters
    function validDateTimeFormatCharacters()
    {
        return array('g', 'h', 'G', 'H', 'a', 'A', 'i', 's');
    }
    
    function onlyLetters($string)
    {
        return preg_replace('/[^a-z]/i', '', $string);
    }

//File size
    function customFileSize($filesize)
    {
        if ($filesize >= 1073741824) {
            $size = number_format($filesize / 1073741824) . " GB";
        } elseif ($filesize >= 1048576) {
            $size = number_format($filesize / 1048576) . " MB";
        } elseif ($filesize >= 1024) {
            $size = number_format($filesize / 1024) . " KB";
        } else {
            $size = (!empty($filesize) ? number_format($filesize) : 0) . " B";
        }
        return $size;
    }
    
    function percentage($amount, $total, $decimals = NULL)
    {
        if ($total == 0) {
            $count = number_format(100, 2);
        } else {
            $count1 = $amount / $total;
            $count2 = $count1 * 100;
            $count = number_format($count2, $decimals);
        }
        return $count;
    }
    
    function no_records($controller)
    {
        return label('no') . ' ' . label(strtolower($controller)) . ' ' . label('found');
    }
    
    function last_day($duration, $duration_type)
    {
        return date("Y-m-d H:i:s", strtotime('+' . $duration . ' ' . $duration_type));
    }
    
    function dueDateMessage($end_date)
    {
        $from_now = (strtotime($end_date) - strtotime(now())) / 86400;
        $msg = '';
        if ($end_date == today()) {
            $msg = 'due date is today';
        } elseif ($end_date < today() && $end_date != today()) {
            $msg = 'due date was ' . $end_date . ' ' . round(abs($from_now)) . ' days ago';
        } elseif ($end_date > today() && $end_date != today()) {
            $msg = 'due date is ' . $end_date . ' ' . round($from_now) . ' days to go';
        }
        return $msg;
    }
    
    function dueDateCalc($end_date)
    {
        $from_now = (strtotime($end_date) - strtotime(now())) / 86400;
        if ($from_now == 0) {
            $from_now = 0;
        }
        return $from_now;
    }
    
    function unlinkUploads($folder, $file)
    {
        if (unlink(APPROOT . UPLOADS_FOLDER . $folder . '/' . $file)) {
            return true;
        } else {
            return false;
        }
    }
    
    function companyPath($company_logo)
    {
        if (($company_logo != 'default_company.png') && (file_exists(APPROOT . MEDIA_FOLDER . $company_logo))) {
            $profilePath = URLROOT . "/app" . MEDIA_FOLDER . $company_logo;
        } else {
            $profilePath = URLROOT . DEFAULT_IMAGES_FOLDER . 'default_company.png';
        }
        return $profilePath;
    }
    
    function systemPath($system_logo)
    {
        if (($system_logo != 'default_logo.png') && (file_exists(APPROOT . MEDIA_FOLDER . $system_logo))) {
            $profilePath = URLROOT . "/app" . MEDIA_FOLDER . $system_logo;
        } else {
            $profilePath = URLROOT . DEFAULT_IMAGES_FOLDER . 'default_logo.png';
        }
        return $profilePath;
    }
    
    function faviconPath($system_favicon)
    {
        if (($system_favicon != 'default_favicon.png') && (file_exists(APPROOT . MEDIA_FOLDER . $system_favicon))) {
            $profilePath = URLROOT . "/app" . MEDIA_FOLDER . $system_favicon;
        } else {
            $profilePath = URLROOT . DEFAULT_IMAGES_FOLDER . 'default_favicon.png';
        }
        return $profilePath;
    }
    
    function profilePath($profile_image, $url = NULL)
    {
        $profilePath = '';
        if (isset($url) && $profile_image != 'default_customer.png') {
            $profilePath = $url . '/app' . MEDIA_FOLDER . $profile_image;
        } elseif (($profile_image != 'default_user.png') && ($profile_image != 'default_customer.png') && (file_exists(APPROOT . MEDIA_FOLDER . $profile_image))) {
            $profilePath = URLROOT . '/app' . MEDIA_FOLDER . $profile_image;
        } elseif (($profile_image == 'default_user.png') || ($profile_image != 'default_customer.png') && (!file_exists(APPROOT . MEDIA_FOLDER . $profile_image))) {
            $profilePath = URLROOT . DEFAULT_IMAGES_FOLDER . 'default_user.png';
        } elseif (($profile_image == 'default_customer.png') || (!file_exists(APPROOT . MEDIA_FOLDER . $profile_image))) {
            $profilePath = URLROOT . DEFAULT_IMAGES_FOLDER . 'default_customer.png';
        }
        return $profilePath;
    }
    
    function fileExists($path, $filename)
    {
        if ($pos = strrpos($filename, '.')) {
            $name = substr($filename, 0, $pos);
            $ext = substr($filename, $pos);
        } else {
            $name = $filename;
        }
        $newpath = $path . '/' . $filename;
        $newname = str_replace(' ', '_', $filename);
        $counter = 0;
        while (file_exists($newpath)) {
            $newname = str_replace(' ', '_', $name . '_' . $counter . $ext);
            $newpath = $path . '/' . $newname;
            $counter++;
        }
        return $newname;
    }
    
    function is_image($file, $sub_dir, $temp_file = NULL)
    {
        $file = str_replace(' ', '_', $file);
//Allow certain file formats
        $target_dir = APPROOT . "/uploads/" . $sub_dir . "/";
        $target_file = $target_dir . basename($file);
        $imageFileType = strtolower(pathinfo($target_file, PATHINFO_EXTENSION));
        if ($imageFileType != "jpg" && $imageFileType != "png" && $imageFileType != "jpeg"
            && $imageFileType != "gif") {
            return false;
        } else {
            return true;
        }
    }
    
    function upload_image($file, $sub_dir, $temp_file)
    {
        if (!is_image($file, $sub_dir, $temp_file)) {
            return false;
        } else {
            $target_dir = APPROOT . "/uploads/" . $sub_dir . "/";
            if (move_uploaded_file($temp_file, $target_dir . $file)) {
                return true;
            }else{
                return false;
            }
        }
    }
    
    function image_size($image, $required_width, $required_height)
    {
        $imagesize = getimagesize($image);
        $width = $imagesize[0];
        $height = $imagesize[1];
        if (($width == $required_width) && ($height == $required_height)) {
            return true;
        } else {
            return false;
        }
    }
    
    function load_image($source, $width)
    {
        return '<img src=' . $source . ' class="img-rounded w-' . $width . '" alt=""/>';
    }
    
    function any_file($file, $sub_dir, $temp_file)
    {
        $file = str_replace(' ', '_', $file);
//Allow certain file formats
        $target_dir = APPROOT . "/uploads/" . $sub_dir . "/";
        if (move_uploaded_file($temp_file, $target_dir . $file)) {
            return true;
        }else{
            return false;
        }
    }
    
    function isValidCSV($file_name, $file)
    {
        $csvMimes = array('text/x-comma-separated-values', 'text/comma-separated-values', 'application/octet-stream', 'application/vnd.ms-excel', 'application/x-csv', 'text/x-csv', 'text/csv', 'application/csv', 'application/excel', 'application/vnd.msexcel', 'text/plain');
        if (!empty($file_name) && in_array($file, $csvMimes)) {
            return true;
        } else {
            return false;
        }
    }
    
    function file_get_contents_utf8($file)
    {
        $content = file_get_contents($file);
        return mb_convert_encoding($content, 'UTF-8', mb_detect_encoding($content, 'UTF-8, ISO-8859-1', true));
    }
    
    function is_valid_json_file($file)
    {
        return json_decode(file_get_contents_utf8($file));
    }
    
    function zip_app($source, $destination)
    {
        if (extension_loaded('zip')) {
            if (file_exists($source)) {
                $zip = new ZipArchive();
                if ($zip->open($destination, ZIPARCHIVE::CREATE)) {
                    $source = realpath($source);
                    if (is_dir($source)) {
                        $files = new RecursiveIteratorIterator(new RecursiveDirectoryIterator($source, RecursiveDirectoryIterator::SKIP_DOTS), RecursiveIteratorIterator::SELF_FIRST);
                        foreach ($files as $file) {
                            $file = realpath($file);
                            if (is_dir($file)) {
                                if (DIRECTORY_SEPARATOR == '/') {
                                    $zip->addEmptyDir(str_replace($source . '/', '', $file . '/'));
                                } else {
                                    $zip->addEmptyDir(str_replace($source . '', '', $file . ''));
                                }
                            } else if (is_file($file)) {
                                if (DIRECTORY_SEPARATOR == '/') {
                                    $zip->addFromString(str_replace($source . '/', '', $file), file_get_contents($file));
                                } else {
                                    $zip->addFromString(str_replace($source . '', '', $file), file_get_contents($file));
                                }
                            }
                        }
                    } else if (is_file($source)) {
                        $zip->addFromString(basename($source), file_get_contents($source));
                    }
                }
                return $zip->close();
            }
        }
        return false;
    }
    
    function force_download($file_name, $file_path)
    {
        header("Cache-Control: public");
        header("Content-Description: File Transfer");
        header("Content-Disposition: attachment; filename=" . basename($file_name));
        header("Content-Transfer-Encoding: binary");
        
        // Read the file 
        return readfile($file_path);
    }
    
    function days_left($start_date, $end_date)
    {
        if ($start_date > date('Y-m-d')) {
            $start_date = strtotime($start_date);
        } else {
            $start_date = strtotime(date('Y-m-d'));
        }
        $end_date = strtotime($end_date);
        return round(($end_date - $start_date) / (60 * 60 * 24));
        
        
    }
    
    function total_days($start_date, $end_date)
    {
        $start_date = strtotime($start_date);
        $end_date = strtotime($end_date);
        $total_days = ($end_date - $start_date) / (60 * 60 * 24);
        if ($total_days == 0) {
            $total_days = 1;
        }
        return $total_days;
    }
    
    function shorten_string($string, $length = NULL)
    {
        if (isset($length)) {
            return $out = strlen($string) > $length ? substr($string, 0, $length) . "..." : $string;
        } else {
            return $out = strlen($string) > 25 ? substr($string, 0, 25) . "..." : $string;
        }
    }
    
    function isEmail($email)
    {
        return (preg_match("/^[-_.[:alnum:]]+@((([[:alnum:]]|[[:alnum:]][[:alnum:]-]*[[:alnum:]])\.)+(ad|ae|aero|af|ag|ai|al|am|an|ao|aq|ar|arpa|as|at|au|aw|az|ba|bb|bd|be|bf|bg|bh|bi|biz|bj|bm|bn|bo|br|bs|bt|bv|bw|by|bz|ca|cc|cd|cf|cg|ch|ci|ck|cl|cm|cn|co|com|coop|cr|cs|cu|cv|cx|cy|cz|de|dj|dk|dm|do|dz|ec|edu|ee|eg|eh|er|es|et|eu|fi|fj|fk|fm|fo|fr|ga|gb|gd|ge|gf|gh|gi|gl|gm|gn|gov|gp|gq|gr|gs|gt|gu|gw|gy|hk|hm|hn|hr|ht|hu|id|ie|il|in|info|int|io|iq|ir|is|it|jm|jo|jp|ke|kg|kh|ki|km|kn|kp|kr|kw|ky|kz|la|lb|lc|li|lk|lr|ls|lt|lu|lv|ly|ma|mc|md|mg|mh|mil|mk|ml|mm|mn|mo|mp|mq|mr|ms|mt|mu|museum|mv|mw|mx|my|mz|na|name|nc|ne|net|nf|ng|ni|nl|no|np|nr|nt|nu|nz|om|org|pa|pe|pf|pg|ph|pk|pl|pm|pn|pr|pro|ps|pt|pw|py|qa|re|ro|ru|rw|sa|sb|sc|sd|se|sg|sh|si|sj|sk|sl|sm|sn|so|sr|st|su|sv|sy|sz|tc|td|tf|tg|th|tj|tk|tm|tn|to|tp|tr|tt|tv|tw|tz|ua|ug|uk|um|us|uy|uz|va|vc|ve|vg|vi|vn|vu|wf|ws|ye|yt|yu|za|zm|zw)$|(([0-9][0-9]?|[0-1][0-9][0-9]|[2][0-4][0-9]|[2][5][0-5])\.){3}([0-9][0-9]?|[0-1][0-9][0-9]|[2][0-4][0-9]|[2][5][0-5]))$/i", $email));
    }
    
    function validate_input($input)
    {
        $input = trim($input);
        $input = stripslashes($input);
        return htmlspecialchars($input);
    }
    
    function validate_email($email)
    {
        $email = validate_input($email);
        if (filter_var($email, FILTER_VALIDATE_EMAIL)) {
            return true;
        } else {
            return false;
        }
    }
    
    function validate_url($url)
    {
        return filter_var($url, FILTER_VALIDATE_URL) !== false;
    }
    
	function rgb2hex2rgb($color)
	{
		// Trim whitespace from input
		$color = trim($color);
		// Initialize result variable
		$result = false;
		// Check if color is in hexadecimal format
		if (preg_match("/^#?([a-fA-F0-9]{3}){1,2}$/", $color)) {
			// Remove '#' if present
			$hex = ltrim($color, '#');
			// Expand shorthand if needed
			if (strlen($hex) == 3) {
				$hex = str_repeat(substr($hex, 0, 1), 2) . str_repeat(substr($hex, 1, 1), 2) . str_repeat(substr($hex, 2, 1), 2);
			}
			// Convert hexadecimal to RGB
			$result = [
				'r' => hexdec(substr($hex, 0, 2)),
				'g' => hexdec(substr($hex, 2, 2)),
				'b' => hexdec(substr($hex, 4, 2))
			];
		} 
		// Check if color is in RGB format
		elseif (preg_match("/^\d{1,3}(\s*,\s*\d{1,3}){2}$/", $color)) {
			// Split RGB values
			$rgbarr = array_map('intval', explode(',', $color));

			// Validate RGB values
			if (count($rgbarr) === 3 && max($rgbarr) <= 255 && min($rgbarr) >= 0) {
				// Convert RGB to hexadecimal
				$result = '#' . sprintf("%02X%02X%02X", $rgbarr[0], $rgbarr[1], $rgbarr[2]);
			}
		}

		return $result;
	}
    
    function log_custom_error($user_id, $error)
    {
        /*
        Order of writing
        date_added|error
        */
        $rootPath = $_SERVER['DOCUMENT_ROOT'];
        $thisPath = dirname($_SERVER['PHP_SELF']);
        $onlyPath = str_replace($rootPath, '', $thisPath);
        
        $file = "custom_errors.txt";
        $file_exists = $_SERVER['DOCUMENT_ROOT'] . $onlyPath . DIRECTORY_SEPARATOR . $file;
        $myfile = fopen($file_exists, "a") or die("Unable to open file!");
        $txt = now() . "|" . $user_id . "|" . $_SERVER['REMOTE_ADDR'] . "|" . $error . PHP_EOL;
        fwrite($myfile, $txt);
        fclose($myfile);
        
        if(getOption('email_custom_errors')){
        	ob_start();
			sendCustomEmail(user($user_id)->email, label('chat_widget_error').': '.company(1)->company_name , $error);
			ob_end_clean();
		}
        
    }
    
    function view_custom_errors($count = NULL)
    {
        $rootPath = $_SERVER['DOCUMENT_ROOT'];
        $thisPath = dirname($_SERVER['PHP_SELF']);
        $onlyPath = str_replace($rootPath, '', $thisPath);
        $finalPath = str_replace('/public', '', $onlyPath);
        
        $file_exists = $_SERVER['DOCUMENT_ROOT'] . $onlyPath . DIRECTORY_SEPARATOR . "custom_errors.txt";
        $out = array();
        if (file_exists($file_exists)) {
            $filer = fopen($file_exists, "r");
            while (!feof($filer)) {
                $explod = explode('|', fgets($filer));
                $string = "date_added|user_id|ip_address|message";
                $keys = explode('|', $string);
                if (count($explod) == 4) {
                    $explode = $explod;
                    $merged = array_combine($keys, $explode);
                    $out[] = toObject($merged);
                }
            }
            fclose($filer);
        }
        if (!empty($out)) {
            $in = array_map("unserialize", array_unique(array_map("serialize", $out)));
            if (isset($count)) {
                $in = array_slice($in, 0, $count);
            }
        } else {
            $in = array();
        }
        return $in;
    }
    
    function custom_errors_count($user_id)
    {
        $elementToSearch = 'user_id';
        $counter = 0;
        // Iterate through each object in the array
        foreach (view_custom_errors() as $object) {
            // Check if the element exists in the current object and has the desired value
            if (isset($object->{$elementToSearch}) && $object->{$elementToSearch} == $user_id) {
                $counter++;
            }
        }
        return $counter;
    }
    
    function required_twocheckout_zip()
    {
        return array('ARG', 'AUS', 'BGR', 'CAN', 'CHN', 'CYP', 'EGY', 'FRA', 'IND', 'IDN', 'ITA', 'JPN', 'MYS', 'MEX', 'NLD', 'PAN', 'PHL', 'POL', 'ROU', 'RUS', 'SRB', 'SGP', 'ZAF', 'ESP', 'SWE', 'THA', 'TUR', 'GBR', 'USA');
    }
    
    function required_twocheckout_state()
    {
        return array('ARG', 'AUS', 'BGR', 'CAN', 'CHN', 'CYP', 'EGY', 'FRA', 'IND', 'IDN', 'ITA', 'JPN', 'MYS', 'MEX', 'NLD', 'PAN', 'PHL', 'POL', 'ROU', 'RUS', 'SRB', 'SGP', 'ZAF', 'ESP', 'SWE', 'THA', 'TUR', 'GBR', 'USA');
    }
    
    function required_twocheckout_street_address2()
    {
        return array('CHN', 'JPN', 'RUS');
    }
    
    function geoplugin($ip)
    {
        return @json_decode(file_get_contents("http://www.geoplugin.net/json.gp?ip=" . $ip));
    }
    
    function read_json_file($filename)
    {
        $content = file_get_contents($filename);
        return json_decode($content, true);
    }
    
    function sitemap_urls($url = NULL)
    {
        // Load the XML file
        $xml = simplexml_load_file($url);
        
        // Check if the XML is loaded successfully
        if ($xml === false) {
            //echo "Failed to load XML file.";
            $loc = false;
            $urls = array();
        } else {
            $urls = array();
            
            // Iterate through each <url> element
            foreach ($xml->url as $url) {
                // Create stdClass object for URL
                $urlObject = new stdClass();
                
                // Extract the <loc> (URL) element and add to the object
                $urlObject->loc = (string)$url->loc;
                
                // Add URL object to the array
                $urls[] = $urlObject;
            }
        }
        
        return $urls;
    }
    
    function validate_xml_sitemap($xmlFilePath)
    {
    	libxml_use_internal_errors(true); // Enable user error handling
    	try {
		    $xml = new DOMDocument();
		    $xml->load($xmlFilePath);

		    // Validate against XML schema
		    $isValid = $xml->schemaValidate('http://www.sitemaps.org/schemas/sitemap/0.9/sitemap.xsd');
		    
		    if ($isValid) {
		        return true;
		    } else {
		        // "The XML does not validate against the schema.";
		        return false;
		    }
		} catch (Exception $e) {
			// "Failed to load XML: " . implode(", ", $this->getXmlErrors());
			return false;
		}
    }
    
    function getXmlErrors()
    {
	    $errors = [];
	    foreach (libxml_get_errors() as $error) {
	        $errors[] = $error->message;
	    }
	    libxml_clear_errors();
	    return $errors;
	}
    
    function merge_files($files)
    {
        $file_name = time() . uid(5) . '.txt';
        $destination_handle = fopen(APPROOT . DIRECTORY_SEPARATOR . MEDIA_FOLDER . DIRECTORY_SEPARATOR . $file_name, "a") or die("Unable to open file!");
        foreach ($files as $key => $file) {
            if (file_exists(APPROOT . MEDIA_FOLDER . $file)) {
                $source_handle = fopen(URLROOT . '/app' . MEDIA_FOLDER . $file, "r");
                fwrite($destination_handle, $key);
                while (!feof($source_handle)) {
                    $line = fgets($source_handle);
                    $bytes_written = fwrite($destination_handle, $line);
                    if ($bytes_written === false) {
                        $writing_failed = true;
                    }
                }
                fwrite($destination_handle, "\n\n");
                fclose($source_handle);
            }
        }
        fclose($destination_handle);
        if (isset($writing_failed)) {
            return false;
        }
        return $file_name;
    }

	function detect_card_type($card_number){
		$card_type = 'Unknown';

		// Remove spaces and hyphens from the card number
		$card_number = preg_replace('/[\s-]/', '', $card_number);

		// Define patterns for card types
		$card_patterns = [
			'Visa' => '/^4[0-9]{12}(?:[0-9]{3})?$/',
			'MasterCard' => '/^5[1-5][0-9]{14}$/',
			'American Express' => '/^3[47][0-9]{13}$/',
			'Diners Club' => '/^3(?:0[0-5]|[68][0-9])[0-9]{11}$/',
			'Discover' => '/^6(?:011|5[0-9]{2})[0-9]{12}$/',
			'JCB' => '/^(?:2131|1800|35\d{3})\d{11}$/'
		];

		// Check card number against patterns
		foreach($card_patterns as $type => $pattern){
			if(preg_match($pattern, $card_number)){
				$card_type = $type;
				break;
			}
		}

		return $card_type;
	}
	
	function singularize($word) {
		$rules = array(
			'/(quiz)zes$/i' => '\1',
			'/(matr)ices$/i' => '\1ix',
			'/(vert|ind)ices$/i' => '\1ex',
			'/(ox)en$/i' => '\1',
			'/(alias|status)es$/i' => '\1',
			'/([octop|vir])i$/i' => '\1us',
			'/(cris|ax|test)es$/i' => '\1is',
			'/(shoe)s$/i' => '\1',
			'/(o)es$/i' => '\1',
			'/(bus)es$/i' => '\1',
			'/([m|l])ice$/i' => '\1ouse',
			'/(x|ch|ss|sh)es$/i' => '\1',
			'/(m)ovies$/i' => '\1ovie',
			'/(s)eries$/i' => '\1eries',
			'/([^aeiouy]|qu)ies$/i' => '\1y',
			'/([lr])ves$/i' => '\1f',
			'/(tive)s$/i' => '\1',
			'/(hive)s$/i' => '\1',
			'/([^f])ves$/i' => '\1fe',
			'/(^analy)ses$/i' => '\1sis',
			'/((a)naly|(b)a|(d)iagno|(p)arenthe|(p)rogno|(s)ynop|(t)he)ses$/i' => '\1\2sis',
			'/([ti])a$/i' => '\1um',
			'/(n)ews$/i' => '\1ews',
			'/(ss)$/i' => '\1',
			'/s$/i' => '',
		);

		foreach ($rules as $pattern => $replacement) {
			if (preg_match($pattern, $word)) {
				return preg_replace($pattern, $replacement, $word);
			}
		}

		return $word;
	}
	
	function is_valid_json($string) {
		json_decode($string);
		return (json_last_error() == JSON_ERROR_NONE);
	}



