<?php
//Other email variables
    function otherEmailVariables($email_template_id = NULL)
    {
        $other = '<p class="pb-3"><span class="float-start fw-bold">' . label('company') . '</span> <span class="float-end text-danger">{company_name} </span></p>';
        $other .= '<p class="pb-3"><span class="float-start fw-bold">' . label('phone') . '</span> <span class="float-end text-danger">{company_phone} </span></p>';
        $other .= '<p class="pb-3"><span class="float-start fw-bold">' . label('email') . '</span> <span class="float-end text-danger">{company_email} </span></p>';
        $other .= '<p class="pb-3"><span class="float-start fw-bold">' . label('website') . '</span> <span class="float-end text-danger">{company_website} </span></p>';
        $other .= '<p class="pb-3"><span class="float-start fw-bold">' . label('currency') . '</span> <span class="float-end text-danger">{company_currency} </span></p>';
        $other .= '<p class="pb-3"><span class="float-start fw-bold">' . label('currency_symbol') . '</span> <span class="float-end text-danger">{currency_symbol} </span></p>';
        $other .= '<p class="pb-3"><span class="float-start fw-bold">' . label('today') . '</span> <span class="float-end text-danger">{today} </span></p>';
        $other .= '<p class="pb-3"><span class="float-start fw-bold">' . label('current_time') . '</span> <span class="float-end text-danger">{now} </span></p>';
        return $other;
    }
    
    function email_template_types($type)
    {
        $return = "";
        if ($type == 'users') {
            $return = "ForgotPassword,PasswordChanged,CreateAccount,WelcomeMessage,NewCustomer";
        } elseif ($type == 'subscriptions') {
            $return = "SubscriptionPaid,SubscriptionCancelled,SubscriptionApproved";
        } elseif ($type == 'affiliates') {
            $return = "InviteFriend";
        } elseif ($type == 'payouts') {
            $return = "PayoutRequestedForAdmin,PayoutSent,PayoutDeclined,PayoutCancelledForAdmin";
        }
        return explode(',', $return);
    }
    
    function getTemplateVariables($email_type)
    {
        $datax = array();
        if (in_array($email_type, (email_template_types('users')))) {
            $datax = array(
                'username' => 'username',
                'first_name' => 'firstname',
                'last_name' => 'lastname',
                'reset_link' => 'reset_link',
                'login_url' => 'login_url',
                'user_profile' => 'user_profile'
            );
        } elseif (in_array($email_type, (email_template_types('subscriptions')))) {
            $datax = array(
                'username' => 'username',
                'first_name' => 'firstname',
                'last_name' => 'lastname',
                'subscription_name' => 'subscription_name',
                'plan_type' => 'plan_type',
                'duration' => 'subscription_duration',
                'duration_type' => 'subscription_duration_type',
                'start_date' => 'subscription_start_date',
                'end_date' => 'subscription_end_date',
                'cost' => 'subscription_cost',
                'subscription_link' => 'subscription_link'
            );
        } elseif (in_array($email_type, (email_template_types('affiliates')))) {
            $datax = array(
                'referral_link' => 'referral_link'
            );
        } elseif (in_array($email_type, (email_template_types('payouts')))) {
            $datax = array(
                'username' => 'username',
                'first_name' => 'firstname',
                'last_name' => 'lastname',
                'payout_name' => 'payout_name',
                'payout_mode' => 'payout_mode',
                'address' => 'payout_address',
                'transaction_id' => 'payout_transaction_id',
                'note' => 'payout_note',
                'date_paid' => 'payout_date_paid',
                'amount' => 'payout_amount',
                'payout_link' => 'payout_link'
            );
        }
        
        return $datax;
    }
    
    
    function template_helper($item, $id, $template)
    {
        $other_fields = array('{company_name}', '{company_email}', '{company_phone}', '{company_website}', '{currency_symbol}', '{company_currency}', '{today}', '{now}');
        $other_values = array(company(1)->company_name, company(1)->company_email, company(1)->company_phone, company(1)->company_website, useCurrency(), getOption('default_currency'), dateFormat(today()), dateTimeFormat(now()));
        $fields = array();
        $values = array();
        if ($item == 'users') {
            $model = new User;
            $result = $model->getUserById($id);
            $fields = array('{username}', '{firstname}', '{lastname}', '{reset_link}', '{login_url}', '{user_profile}');
            $values = array($result->username, $result->firstname, $result->lastname, URLROOT . '/users/reset_password/?email=' . $result->email . '&&passkey=' . $result->passkey, URLROOT . '/users/login', URLROOT . '/users/profile');
        } elseif ($item == 'subscriptions') {
            $model = new Subscription;
            $result = $model->getSubscriptionById($id);
            $fields = array('{username}', '{firstname}', '{lastname}', '{subscription_name}', '{subscription_cost}', '{subscription_duration}', '{subscription_duration_type}', '{subscription_start_date}', '{subscription_end_date}', '{subscription_end_date}', '{subscription_link}');
            $values = array(user($result->user_id)->username, user($result->user_id)->firstname, user($result->user_id)->lastname, $result->subscription_name, $result->subscription_cost, $result->subscription_duration, $result->subscription_duration_type, $result->subscription_start_date, $result->subscription_end_date, $result->subscription_end_date, URLROOT . '/subscriptions/show/' . $id);
        } elseif ($item == 'affiliates') {
            $model = new Affiliate;
            $result = $model->getAffiliateById($id);
            $fields = array('{referral_link}');
            $values = array(URLROOT . '/?ref=' . strtoupper(user(user_id())->user_uid));
        } elseif ($item == 'payouts') {
            $model = new Payout;
            $result = $model->getPayoutById($id);
            $fields = array('{username}', '{firstname}', '{lastname}', '{payout_name}', '{payout_mode}', '{payout_address}', '{payout_transaction_id}', '{payout_note}', '{payout_date_paid}', '{payout_amount}', '{payout_link}');
            $values = array(user($result->user_id)->username, user($result->user_id)->firstname, user($result->user_id)->lastname, $result->payout_name, payout_mode($result->payout_mode_id)->payout_mode_name, $result->payout_address, $result->payout_transaction_id, $result->payout_note, $result->payout_date_paid, $result->payout_amount, URLROOT . '/payouts/show/' . $id);
        }
        
        if (getOption('htmlentities_decode_enabled') == 0) {
            $template = strip_tags($template);
        }
        
        return str_replace(array_merge($fields, $other_fields), array_merge($values, $other_values), $template);
    }