<?php
// Simple page redirect
    function redirect($page, $public = NULL)
    {
        if (is_numeric($page)) {
            switch ($page) {
                case 404:
                    header('HTTP/1.0 404 Not Found');
                    if (isset($public) || !isLoggedIn()) {
                        include APPROOT . '/views/themes/' . getOption('active_theme') . '/inc/404.php';
                    } else {
                        include APPROOT . '/views/inc/404.php';
                    }
                    exit();
    
                default:
                    break;
            }
        }
        header('location: ' . URLROOT . '/' . $page);
    }
    
    function referrer()
    {
        return $_SERVER['HTTP_REFERER'] ?? false;
    }
    
    
    function referrer_without_urlroot($referrer)
    {
        return str_replace(URLROOT . '/', '', $referrer);
    }
    
    function page_title($page = NULL)
    {
        $page = $page ?? NULL;
        $current_id = current_id();
        return label($page) . ' ' . $current_id;
    }
    
    function primary_url()
    {
        $primary_url = getExplodedUrl();
        if (count($primary_url) == 1) {
            $primary_urlzero = end($primary_url);
            $primary_url = URLROOT . '/' . $primary_urlzero;
        } elseif (count($primary_url) == 2) {
            $primary_urlzero = end($primary_url);
            $primary_url = URLROOT . '/' . $primary_url[0] . '/' . $primary_urlzero;
        } elseif (count($primary_url) == 3) {
            $primary_url = URLROOT . '/' . $primary_url[0];
        }
        return $primary_url;
    }
    
    function current_controller()
    {
        $primary_url = getExplodedUrl();
        return $primary_url[0];
    }
    
    function current_file()
    {
        $primary_url = getExplodedUrl();
        return $primary_url[1] ?? NULL;
    }
    
    function current_id()
    {
        $primary_url = getExplodedUrl();
        return $primary_url[2] ?? NULL;
    }