<?php
    function user_model()
    {
        return new User;
    }
    
    function users()
    {
        $model = user_model();
        return $model->getUsers();
    }
    
    function users_between_dates($from_date, $to_date)
    {
        $model = user_model();
        return $model->getUsersBetweenDates($from_date, $to_date);
    }
    
    function user($user_id)
    {
        if ($user_id > 0) {
            $model = user_model();
            $row = $model->getUserById($user_id);
        } else {
            $row = empty_stdclass('username');
        }
        return $row;
    }
    
    function user_by_uid($user_uid)
    {
        $model = user_model();
        return $model->getUserByUid($user_uid);
    }
    
    function username_exists($username)
    {
        $model = user_model();
        $row = $model->findUserByUsername($username);
        if (!empty($row) > 0) {
            return true;
        } else {
            return false;
        }
    }
    
    function email_exists($email)
    {
        $model = user_model();
        $row = $model->findUserByEmail($email);
        if (!empty($row) > 0) {
            return true;
        } else {
            return false;
        }
    }
    
    function users_by_status($status_id)
    {
        $model = user_model();
        return $model->getUsersByStatus($status_id);
    }
    
    function user_statuses()
    {
        $model = user_model();
        return $model->getUserStatus();
    }
    
    function user_status($user_status_id)
    {
        $model = user_model();
        return $model->getUserStatusById($user_status_id);
    }
    
    function package_history($transaction_type = NULL, $from_date = NULL, $to_date = NULL, $user_id = NULL)
    {
        $model = user_model();
        return $model->getUserPackageHistory($transaction_type, $from_date, $to_date, $user_id);
    }
    
    function package_history_words($transaction_type = NULL, $from_date = NULL, $to_date = NULL, $user_id = NULL)
    {
        $model = user_model();
        if (isset($transaction_type) && isset($from_date) && isset($to_date) && isset($user_id)) {
            $results = $model->getUserPackageHistoryWords($transaction_type, $from_date, $to_date, $user_id);
        } elseif (isset($transaction_type) && isset($from_date) && isset($to_date)) {
            $results = $model->getUserPackageHistoryWords($transaction_type, $from_date, $to_date);
        } elseif (isset($transaction_type)) {
            $results = $model->getUserPackageHistoryWords($transaction_type);
        }
        $words = 0;
        foreach ($results as $row) {
            $words += $row->words_count;
        }
        return $words;
    }
    
    function add_user_remaining_balances($user_id, $subscription_id, $type)
    {
        $user_remaining_type = 'user_remaining_' . $type;
        $package_item_type = 'package_' . $type;
        if ((int)json_decode(subscription($subscription_id)->subscription_items)->$package_item_type === -1) {
            $out = -1;
        } else {
            $out = (int)user($user_id)->$user_remaining_type + (int)json_decode(subscription($subscription_id)->subscription_items)->$package_item_type;
        }
        return $out;
    }
    
    function adjust_user_remaining_balances($user_id, $quantity, $type)
    {
        $user_remaining_type = 'user_remaining_' . $type;
        $package_item_type = 'package_' . $type;
        if (!is_null($quantity) && (int)user($user_id)->$user_remaining_type != -1) {
            $out = (int)user($user_id)->$user_remaining_type + (int)$quantity;
        } else {
            $out = (int)user($user_id)->$user_remaining_type;
        }
        return $out;
    }
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
    
    
    
    