<?php
    function visit_model()
    {
        return new Visit;
    }
    
    function visits($user_id = NULL)
    {
        $model = visit_model();
        if (isset($user_id)) {
            $results = $model->getVisits($user_id);
        } else {
            $results = $model->getVisits();
        }
        return $results;
    }
    
    function open_visits()
    {
        $model = visit_model();
        return $model->getOpenVisits();
    }
    
    function visit($visit_id)
    {
        $model = visit_model();
        return $model->getVisitById($visit_id);
    }
    
    function last_visit_by_ip_address($ip_address, $closed = NULL)
    {
        $model = visit_model();
        if (isset($closed)) {
            $row = $model->getLastVisitByIpAddress($ip_address, $closed);
        } else {
            $row = $model->getLastVisitByIpAddress($ip_address);
        }
        return $row;
    }
    
    function visits_between_dates($from, $to, $user_id = NULL)
    {
        $model = visit_model();
        if (isset($user_id)) {
            $results = $model->getVisitsBetweenDates($from, $to, $user_id);
        } else {
            $results = $model->getVisitsBetweenDates($from, $to);
        }
        return $results;
    }
    
    function timeline_type($type)
    {
        return match ($type) {
            'chat_started' => "bg-primary",
            'visited' => "bg-success",
            'chat_resumed' => "bg-info",
            'left_chat' => "bg-warning",
            default => "bg-dark",
        };
    }
    
    function visit_timelines($visit_id)
    {
        $model = visit_model();
        return $model->getVisitTimelines($visit_id);
    }
    
    function last_visit_timeline_by_ip_address_and_type($ip_address, $type)
    {
        $model = visit_model();
        return $model->getLastVisitTimelineByIpAddressAndType($ip_address, $type);
    }
    
    function visit_timelines_between_dates($from, $to, $user_id = NULL)
    {
        $model = visit_model();
        if (isset($user_id)) {
            $results = $model->getVisitTimelinesBetweenDates($from, $to, $user_id);
        } else {
            $results = $model->getVisitTimelinesBetweenDates($from, $to);
        }
        return $results;
    }
