<?php
    function widget_model()
    {
        return new Widget;
    }
    
    function widgets($user_id)
    {
        $model = widget_model();
        return $model->getWidgets($user_id);
    }
    
    function widget($widget_id)
    {
        $model = widget_model();
        return $model->getWidgetById($widget_id);
    }
    
    function widget_by_uid($widget)
    {
        $model = widget_model();
        return $model->getWidgetByUid($widget);
    }
    
    function widget_exists($widget)
    {
        $model = widget_model();
        $row = $model->getWidgetByName($widget);
        if (!empty($row) > 0) {
            return true;
        } else {
            return false;
        }
    }
    
    function widget_chat_source($widget_id)
    {
        $widget = widget($widget_id);
        
        $data = [
            'source' => NULL,
            'source_id' => NULL,
            'file_id' => NULL,
            'file_output_id' => NULL
        ];
        
	    if(!empty($widget)){
	        if (!is_null($widget->user_trained_model)) {
	            $data = [
	                'source' => 'trained_model',
	                'source_id' => finetune_file($widget->user_trained_model)->finetune_file,
	                'file_id' => NULL,
	                'file_output_id' => NULL
	            ];
	        } elseif (!is_null($widget->user_bots)) {
	            $data = [
	                'source' => 'assistant',
	                'source_id' => chat_assistant($widget->user_bots)->chat_assistant_name,
	                'file_id' => NULL,
	                'file_output_id' => NULL
	            ];
	        } elseif (!is_null($widget->user_chat_files)) {
	        	if(is_valid_json($widget->user_chat_files)){
	        		
	        		foreach(json_decode($widget->user_chat_files) as $file){
						$out[] = chat_file($file)->chat_file_output_id;
						$out_files[] = chat_file($file)->chat_file;
					}
	        		
					$user_chat_files = implode(', ', $out_files);
					$chat_file_output_id = implode(',', ($out));
				}else{
					$user_chat_files = chat_file($widget->user_chat_files)->chat_file;
					$chat_file_output_id = chat_file($widget->user_chat_files)->chat_file_output_id;
				}
	            $data = [
	                'source' => 'file',
	                'source_id' => $user_chat_files,
	                'file_id' => $widget->user_chat_files,
	                'file_output_id' => $chat_file_output_id
	            ];
	        } elseif (!is_null($widget->user_chat_links)) {
	            $data = [
	                'source' => 'link',
	                'source_id' => chat_file($widget->user_chat_links)->chat_link,
	                'file_id' => $widget->user_chat_links,
	                'file_output_id' => chat_file($widget->user_chat_links)->chat_file_output_id
	            ];
	        } elseif (!is_null($widget->user_chat_sitemaps)) {
	            $data = [
	                'source' => 'sitemap',
	                'source_id' => chat_file($widget->user_chat_sitemaps)->chat_link,
	                'file_id' => $widget->user_chat_sitemaps,
	                'file_output_id' => chat_file($widget->user_chat_sitemaps)->chat_file_output_id
	            ];
	        } else {
	            $data = [
	                'source' => NULL,
	                'source_id' => NULL,
	                'file_id' => NULL,
	                'file_output_id' => NULL
	            ];
	        }
		}
        return $data;
    }

