<?php
class Paging extends Core{


private $_records;
private $_max_pp;
private $_numb_of_pages;
private $_numb_of_records;
private $_current;
private $_offset = 0;
public static $_key = 'pg';
public $_url;



public function __construct($rows, $max = NULL) {
$this->_records = $rows;
$this->_numb_of_records = count($this->_records);
$this->_max_pp = $max;
$this->_url = !empty($this->getUrl()) ? URLROOT.'/'.implode('/', $this->getUrl()).$this->getUrlParams() : URLROOT;
$current = $this->getParam(self::$_key);
$this->_current = !empty($current) ? $current : 1;
$this->numberOfPages();
$this->getOffset();
}


private function numberOfPages() {
$this->_numb_of_pages = ceil($this->_numb_of_records / $this->_max_pp);
}


private function getOffset() {
$this->_offset = ($this->_current - 1) * $this->_max_pp;
}

private static function getUrlParams(){	
$url = completeUrl();
$parsed = parse_url($url);
$query = isset($parsed['query']) ? $parsed['query'] : '';

parse_str($query, $params);

unset($params['pg']);
$string = http_build_query($params);
return '?'.$string;
}

private static function getParam($par) {
return isset($_GET[$par]) && $_GET[$par] != "" ?
$_GET[$par] : null;
}

public function getRecords() {
$out = array();
if ($this->_numb_of_pages > 1) {
$last = ($this->_offset + $this->_max_pp);

for($i = $this->_offset; $i < $last; $i++) {
if ($i < $this->_numb_of_records) {
$out[] = $this->_records[$i];
}
}
} else {
$out = $this->_records;
}
return $out;
}


private function getLinks() {
if ($this->_numb_of_pages > 1) {

$out = array();

// first link
if ($this->_current > 1) {
$out[] = "<a href=\"".$this->_url."\" class='page-link'>".label('first')."</a>";
} else {
$out[] = "<a href='javascript:void(0);' class='page-link'>".label('first')."</a>";
}


// previous link
if ($this->_current > 1) {

// previous page number
$id = ($this->_current - 1);

$url = $id > 1 ? 
$this->_url."&amp;".self::$_key."=".$id :
$this->_url;
$out[] = "<a href=\"{$url}\" class='page-link'>".label('previous')."</a>";

} else {
$out[] = "<a href='javascript:void(0);' class='page-link'>".label('previous')."</a>";
}

// numbered link to the left
if ($this->_current > 1) {
for($i = $this->_current-4; $i < $this->_current; $i++){
if($i > 0){
$url = $this->_url."&amp;".self::$_key."=".$i;
$out[] = "<a href=\"{$url}\" class='page-link'>$i</a>";
}
}
}

// current page number
$out[] = "<a href='javascript:void(0);' class='page-link'>".$this->_current."</a>";

// numbered link to the right
for($i = $this->_current+1; $i <= $this->_numb_of_pages; $i++){
if($i > 0){
$url = $this->_url."&amp;".self::$_key."=".$i;
$out[] = "<a href=\"{$url}\" class='page-link'>$i</a>";
if($i >= $this->_current+4){
break;
}
}
}

// next link
if ($this->_current != $this->_numb_of_pages) {
// next page number
$id = ($this->_current + 1);

$url = $this->_url."&amp;".self::$_key."=".$id;
$out[] = "<a href=\"{$url}\" class='page-link'>".label('next')."</a>";

} else {
$out[] = "<a href='javascript:void(0);' class='page-link'>".label('next')."</a>";
}


// last link
if ($this->_current != $this->_numb_of_pages) {
$url = $this->_url."&amp;".self::$_key."=".$this->_numb_of_pages;
$out[] = "<a href=\"{$url}\" class='page-link'>".label('last')."</a>";
} else {
$out[] = "<a href='javascript:void(0);' class='page-link'>".label('last')."</a>";
}

	$active = 'active';


return "<li class='page-item ".$active."'>".implode("</li><li class='page-item'>", $out)."</li>";

}	
}


public function getPaging() {
$links = $this->getLinks();
if (!empty($links)) {
$out  = "<nav class='pagination-rounded' aria-label='Page navigation example'>";
$out .= "<ul class=\"pagination\">";
$out .= $links;
$out .= "</ul>";
$out .= "</nav>";
return $out;
}
}





}