<?php
class Addon {
private $db;

public function __construct(){
$this->db = new Database;
}

public function getAddons(){
$this->db->query("SELECT * FROM addons ");
$results = $this->db->resultSet();
return $results;
}

public function addAddon($data){
$this->db->query('INSERT INTO addons (addon_uid, addon_name, addon_description, is_premium, addon_uninstall_rules, addon_date_added) VALUES(:addon_uid, :addon_name, :addon_description, :is_premium, :addon_uninstall_rules, :addon_date_added)');
// Bind values
$this->db->bind(':addon_uid', uid(8));
$this->db->bind(':addon_name', $data['addon_name']);
$this->db->bind(':addon_description', $data['addon_description']);
$this->db->bind(':is_premium', $data['is_premium']);
$this->db->bind(':addon_uninstall_rules', $data['addon_uninstall_rules']);
$this->db->bind(':addon_date_added', now());
// Execute
if($this->db->execute()){
return $this->db->lastInsertId();
} else {
return false;
}
}

public function updateAddonStatus($data){
$this->db->query('UPDATE addons SET addon_status_id = :addon_status_id WHERE addon_id = :addon_id');
// Bind values
$this->db->bind(':addon_status_id', $data['addon_status_id']);
$this->db->bind(':addon_id', $data['addon_id']);
// Execute
if($this->db->execute()){
return true;
} else {
return false;
}
}

public function getAddonById($id){
$this->db->query('SELECT * FROM addons 
WHERE addon_id = :addon_id');
$this->db->bind(':addon_id', $id);
$row = $this->db->single();
return $row;
}

public function getAddonByName($addon_name){
$this->db->query('SELECT * FROM addons WHERE addon_name = :addon_name');
$this->db->bind(':addon_name', $addon_name);
$row = $this->db->single();
return $row;
}

public function deleteAddon($id){
$this->db->query('DELETE FROM addons WHERE addon_id = :addon_id');
// Bind values
$this->db->bind(':addon_id', $id);
// Execute
if($this->db->execute()){
return true;
} else {
return false;
}
}




}