<?php
    
    class Affiliate
    {
        private Database $db;
        
        public function __construct()
        {
            $this->db = new Database;
        }
        
        public function getAffiliates($user_id = NULL)
        {
            $query = "SELECT * FROM affiliates ";
            if (isset($user_id)) {
                $query .= " WHERE user_id = :user_id ";
            }
            $query .= " ORDER BY affiliate_id Desc";
            $this->db->query($query);
            if (isset($user_id)) {
                $this->db->bind(':user_id', $user_id);
            }
            return $this->db->resultSet();
        }
        
        public function addAffiliate($data)
        {
            $this->db->query('INSERT INTO affiliates (affiliate_uid, user_id, affiliate_rule_id, affiliate_commission_rate, subscription_id, affiliate_date_added) VALUES(:affiliate_uid, :user_id, :affiliate_rule_id, :affiliate_commission_rate, :subscription_id, :affiliate_date_added)');
// Bind values
            $this->db->bind(':affiliate_uid', uid());
            $this->db->bind(':user_id', $data['user_id']);
            $this->db->bind(':affiliate_rule_id', $data['affiliate_rule_id']);
            $this->db->bind(':affiliate_commission_rate', $data['affiliate_commission_rate']);
            $this->db->bind(':subscription_id', $data['subscription_id']);
            $this->db->bind(':affiliate_date_added', now());
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function getAffiliateById($id)
        {
            $this->db->query('SELECT * FROM affiliates WHERE affiliate_id = :affiliate_id');
            $this->db->bind(':affiliate_id', $id);
            return $this->db->single();
        }
        
        public function getAffiliateBySubscriptionId($id)
        {
            $this->db->query('SELECT * FROM affiliates WHERE subscription_id = :subscription_id');
            $this->db->bind(':subscription_id', $id);
            return $this->db->single();
        }
        
        public function getAffiliateByUserId($id)
        {
            $this->db->query('SELECT * FROM affiliates WHERE user_id = :user_id');
            $this->db->bind(':user_id', $id);
            return $this->db->single();
        }
        
        public function getAffiliateRules()
        {
            $this->db->query("SELECT * FROM affiliate_rules ORDER BY affiliate_rule_id Desc");
            return $this->db->resultSet();
        }
        
        public function getAffiliateRuleById($id)
        {
            $this->db->query('SELECT * FROM affiliate_rules WHERE affiliate_rule_id = :affiliate_rule_id');
            $this->db->bind(':affiliate_rule_id', $id);
            return $this->db->single();
        }
        
        
    }