<?php
    
    class Company
    {
        private Database $db;
        
        public function __construct()
        {
            $this->db = new Database;
        }
        
        public function getCompanies()
        {
            $this->db->query("SELECT * FROM company
ORDER BY company_id Desc");
            return $this->db->resultSet();
        }
        
        public function addCompany($data)
        {
            $this->db->query('INSERT INTO company (company_slug,company_name,company_street,company_city,company_state,company_zip,company_country_id,company_tax,company_phone,company_email,company_website,company_passkey,company_date_added) VALUES(:company_slug, :company_name, :company_street, :company_city, :company_state, :company_zip, :company_country_id, :company_tax, :company_phone, :company_email, :company_website, :company_passkey, :company_date_added)');
// Bind values
            $this->db->bind(':company_slug', generate_seo_url($data['company_name']));
            $this->db->bind(':company_name', $data['company_name']);
            $this->db->bind(':company_street', $data['company_street']);
            $this->db->bind(':company_city', $data['company_city']);
            $this->db->bind(':company_state', $data['company_state']);
            $this->db->bind(':company_zip', $data['company_zip']);
            $this->db->bind(':company_country_id', $data['company_country_id']);
            $this->db->bind(':company_tax', $data['company_tax']);
            $this->db->bind(':company_phone', $data['company_phone']);
            $this->db->bind(':company_email', $data['company_email']);
            $this->db->bind(':company_website', $data['company_website']);
            $this->db->bind(':company_passkey', md5(now()));
            $this->db->bind(':company_date_added', now());
// Execute
            if ($this->db->execute()) {
                return $this->db->lastInsertId();
            } else {
                return false;
            }
        }
        
        public function updateCompany($data)
        {
            $this->db->query('UPDATE company SET company_name=:company_name, company_street=:company_street, company_city=:company_city, company_state=:company_state, company_zip=:company_zip, company_website=:company_website, company_email=:company_email, company_phone=:company_phone, company_country_id=:company_country_id, company_tax=:company_tax, company_title = :company_title, company_subtitle = :company_subtitle, company_website_title = :company_website_title, company_website_description=:company_website_description, company_website_keywords = :company_website_keywords WHERE company_id=:company_id');
// Bind values
            $this->db->bind(':company_name', $data['company_name']);
            $this->db->bind(':company_street', $data['company_street']);
            $this->db->bind(':company_city', $data['company_city']);
            $this->db->bind(':company_state', $data['company_state']);
            $this->db->bind(':company_zip', $data['company_zip']);
            $this->db->bind(':company_website', $data['company_website']);
            $this->db->bind(':company_email', $data['company_email']);
            $this->db->bind(':company_phone', $data['company_phone']);
            $this->db->bind(':company_country_id', $data['company_country_id']);
            $this->db->bind(':company_tax', $data['company_tax']);
            $this->db->bind(':company_title', $data['company_title']);
            $this->db->bind(':company_subtitle', $data['company_subtitle']);
            $this->db->bind(':company_website_title', $data['company_website_title']);
            $this->db->bind(':company_website_description', $data['company_website_description']);
            $this->db->bind(':company_website_keywords', $data['company_website_keywords']);
            $this->db->bind(':company_id', $data['company_id']);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function updateCompanyLogo($data)
        {
            $this->db->query('UPDATE company SET company_logo = :company_logo WHERE company_id = :company_id');
// Bind values
            $this->db->bind(':company_logo', $data['image']);
            $this->db->bind(':company_id', $data['company_id']);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function updateCompanyWebsiteLogo($data)
        {
            $this->db->query('UPDATE company SET company_website_logo = :company_website_logo WHERE company_id = :company_id');
// Bind values
            $this->db->bind(':company_website_logo', $data['image']);
            $this->db->bind(':company_id', $data['company_id']);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function updateCompanyWebsiteFavicon($data)
        {
            $this->db->query('UPDATE company SET company_website_favicon = :company_website_favicon WHERE company_id = :company_id');
// Bind values
            $this->db->bind(':company_website_favicon', $data['image']);
            $this->db->bind(':company_id', $data['company_id']);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function updateCompanyHomepage($data)
        {
            $this->db->query('UPDATE company SET company_title = :company_title, company_subtitle = :company_subtitle, company_theme_selector = :company_theme_selector, company_primary_colour = :company_primary_colour, company_primary_colour_rgb = :company_primary_colour_rgb, company_tawk_to_script = :company_tawk_to_script WHERE company_id = :company_id');
// Bind values
            $this->db->bind(':company_title', $data['company_title'] ?? company($data['company_id'])->company_title);
            $this->db->bind(':company_subtitle', $data['company_subtitle'] ?? company($data['company_id'])->company_subtitle);
            $this->db->bind(':company_theme_selector', $data['company_theme_selector'] ?? company($data['company_id'])->company_theme_selector);
            $this->db->bind(':company_primary_colour', $data['company_primary_colour'] ?? company($data['company_id'])->company_primary_colour);
            $this->db->bind(':company_primary_colour_rgb', $data['company_primary_colour_rgb'] ?? company($data['company_id'])->company_primary_colour_rgb);
            $this->db->bind(':company_tawk_to_script', $data['company_tawk_to_script'] ?? company($data['company_id'])->company_tawk_to_script);
            $this->db->bind(':company_id', $data['company_id']);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function updateCompanyHomepageImage($data)
        {
            $this->db->query('UPDATE company SET company_banner = :company_banner WHERE company_id = :company_id');
// Bind values
            $this->db->bind(':company_banner', $data['company_banner'] ?? company($data['company_id'])->company_banner);
            $this->db->bind(':company_id', $data['company_id']);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function getCompanyById($id)
        {
            $this->db->query('SELECT *
FROM company 
WHERE company_id = :company_id');
// Bind value
            $this->db->bind(':company_id', $id);
            return $this->db->single();
        }
        
        public function getCompanyByName($company_name)
        {
            $this->db->query('SELECT *
FROM company 
WHERE company_name = :company_name');
// Bind value
            $this->db->bind(':company_name', $company_name);
            return $this->db->single();
        }
        
        public function getCompanyBySlug($company_slug)
        {
            $this->db->query('SELECT *
FROM company 
WHERE company_slug = :company_slug');
// Bind value
            $this->db->bind(':company_slug', $company_slug);
            return $this->db->single();
        }
        
        public function getCompanyByEmail($company_email)
        {
            $this->db->query('SELECT *
FROM company 
WHERE company_email = :company_email');
// Bind value
            $this->db->bind(':company_email', $company_email);
            return $this->db->single();
        }
        
    }