<?php
    
    class Faq
    {
        private Database $db;
        
        public function __construct()
        {
            $this->db = new Database;
        }
        
        public function getFaqs()
        {
            $this->db->query("SELECT * FROM faqs ORDER BY faq_id Desc");
            return $this->db->resultSet();
        }
        
        public function addFaq($data)
        {
            $this->db->query('INSERT INTO faqs (faq_added_by, faq_title, faq_slug, faq_content, faq_status_id, faq_date_added) VALUES(:faq_added_by, :faq_title, :faq_slug, :faq_content, :faq_status_id, :faq_date_added)');
// Bind values
            $this->db->bind(':faq_added_by', user_id());
            $this->db->bind(':faq_title', $data['question']);
            $this->db->bind(':faq_slug', generate_seo_url($data['question']));
            $this->db->bind(':faq_content', $data['answer']);
            $this->db->bind(':faq_status_id', $data['faq_status_id']);
            $this->db->bind(':faq_date_added', now());
// Execute
            if ($this->db->execute()) {
                return $this->db->lastInsertId();
            } else {
                return false;
            }
        }
        
        public function updateFaq($data)
        {
            $this->db->query('UPDATE faqs SET faq_title=:faq_title, faq_content=:faq_content, faq_status_id=:faq_status_id WHERE faq_id=:faq_id');
// Bind values
            $this->db->bind(':faq_title', $data['question']);
            $this->db->bind(':faq_content', $data['answer']);
            $this->db->bind(':faq_status_id', $data['faq_status_id']);
            $this->db->bind(':faq_id', $data['faq_id']);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function getFaqById($id)
        {
            $this->db->query('SELECT * FROM faqs WHERE faq_id = :faq_id');
            $this->db->bind(':faq_id', $id);
            return $this->db->single();
        }
        
        public function getFaqByName($name)
        {
            $this->db->query('SELECT * FROM faqs WHERE faq_title = :faq_title');
            $this->db->bind(':faq_title', $name);
            return $this->db->single();
        }
        
        public function deleteFaq($id)
        {
            $this->db->query('DELETE FROM faqs WHERE faq_id = :faq_id');
// Bind values
            $this->db->bind(':faq_id', $id);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        
    }