<?php
    
    class Fav
    {
        private Database $db;
        
        public function __construct()
        {
            $this->db = new Database;
        }
        
        public function getFavs($user_id)
        {
            $this->db->query("SELECT * FROM favs
WHERE fav_added_by = :fav_added_by ORDER BY fav_id Desc");
            $this->db->bind(':fav_added_by', $user_id);
            return $this->db->resultSet();
        }
        
        
        public function addFav($data)
        {
            $this->db->query('INSERT INTO favs (fav_added_by, chat_assistant_id, fav_date_added) VALUES(:fav_added_by, :chat_assistant_id, :fav_date_added)');
// Bind values
            $this->db->bind(':fav_added_by', user_id());
            $this->db->bind(':chat_assistant_id', $data['chat_assistant_id']);
            $this->db->bind(':fav_date_added', now());
// Execute
            if ($this->db->execute()) {
                return $this->db->lastInsertId();
            } else {
                return false;
            }
        }
        
        public function getFavById($id)
        {
            $this->db->query('SELECT * FROM favs
WHERE fav_id = :fav_id');
            $this->db->bind(':fav_id', $id);
            return $this->db->single();
        }
        
        public function getFavByChatAssistantId($chat_assistant_id, $user_id)
        {
            $this->db->query('SELECT * FROM favs
WHERE chat_assistant_id = :chat_assistant_id AND fav_added_by = :fav_added_by');
            $this->db->bind(':chat_assistant_id', $chat_assistant_id);
            $this->db->bind(':fav_added_by', $user_id);
            return $this->db->single();
        }
        
        public function deleteFav($id)
        {
            $this->db->query('DELETE FROM favs WHERE fav_id = :fav_id');
// Bind values
            $this->db->bind(':fav_id', $id);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
    }