<?php
    
    class Favourite
    {
        private Database $db;
        
        public function __construct()
        {
            $this->db = new Database;
        }
        
        public function getFavourites($user_id)
        {
            $this->db->query("SELECT * FROM favourites
WHERE favourite_added_by = :favourite_added_by ORDER BY favourite_id Desc");
            $this->db->bind(':favourite_added_by', $user_id);
            return $this->db->resultSet();
        }
        
        
        public function addFavourite($data)
        {
            $this->db->query('INSERT INTO favourites (favourite_added_by, openai_template_id, favourite_date_added) VALUES(:favourite_added_by, :openai_template_id, :favourite_date_added)');
// Bind values
            $this->db->bind(':favourite_added_by', user_id());
            $this->db->bind(':openai_template_id', $data['openai_template_id']);
            $this->db->bind(':favourite_date_added', now());
// Execute
            if ($this->db->execute()) {
                return $this->db->lastInsertId();
            } else {
                return false;
            }
        }
        
        public function getFavouriteById($id)
        {
            $this->db->query('SELECT * FROM favourites
WHERE favourite_id = :favourite_id');
            $this->db->bind(':favourite_id', $id);
            return $this->db->single();
        }
        
        public function getFavouriteByTemplateId($openai_template_id, $user_id)
        {
            $this->db->query('SELECT * FROM favourites
WHERE openai_template_id = :openai_template_id AND favourite_added_by = :favourite_added_by');
            $this->db->bind(':openai_template_id', $openai_template_id);
            $this->db->bind(':favourite_added_by', $user_id);
            return $this->db->single();
        }
        
        public function deleteFavourite($id)
        {
            $this->db->query('DELETE FROM favourites WHERE favourite_id = :favourite_id');
// Bind values
            $this->db->bind(':favourite_id', $id);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
    }