<?php
    
    class Homepage
    {
        private Database $db;
        
        public function __construct()
        {
            $this->db = new Database;
        }
        
        
        public function updateHomepageSectionStatus($data)
        {
            $this->db->query('UPDATE homepage_sections SET homepage_section_status_id = :homepage_section_status_id WHERE homepage_section_id = :homepage_section_id');
// Bind values
            $this->db->bind(':homepage_section_status_id', $data['homepage_section_status_id']);
            $this->db->bind(':homepage_section_id', $data['homepage_section_id']);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        
        public function updateHomepageSectionShowInHeader($data)
        {
            $this->db->query('UPDATE homepage_sections SET homepage_section_show_in_header = :homepage_section_show_in_header WHERE homepage_section_id = :homepage_section_id');
// Bind values
            $this->db->bind(':homepage_section_show_in_header', $data['homepage_section_show_in_header']);
            $this->db->bind(':homepage_section_id', $data['homepage_section_id']);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function updateHomepageSectionOrder($data)
        {
            $this->db->query('UPDATE homepage_sections SET homepage_section_order = :homepage_section_order WHERE homepage_section_id = :homepage_section_id');
// Bind values
            $this->db->bind(':homepage_section_order', $data['homepage_section_order']);
            $this->db->bind(':homepage_section_id', $data['homepage_section_id']);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function getHomepageSections($order_by = NULL)
        {
            $query = "SELECT * FROM homepage_sections ORDER BY ";
            if ($order_by) {
                $query .= " homepage_section_id Desc";
            } else {
                $query .= " homepage_section_order Asc";
            }
            $this->db->query($query);
            return $this->db->resultSet();
        }
        
        public function getHomepageSectionById($homepage_section_id)
        {
            $this->db->query("SELECT * FROM homepage_sections WHERE homepage_section_id = :homepage_section_id");
            $this->db->bind(':homepage_section_id', $homepage_section_id);
            return $this->db->single();
        }
        
        public function updateHomepageIntro($data)
        {
            $this->db->query('UPDATE homepage_intro SET homepage_intro_title = :homepage_intro_title, homepage_intro_description = :homepage_intro_description, homepage_intro_sub_description = :homepage_intro_sub_description, homepage_intro_image_text = :homepage_intro_image_text, homepage_intro_background_type = :homepage_intro_background_type, homepage_intro_background = :homepage_intro_background WHERE homepage_intro_id = :homepage_intro_id');
// Bind values
            $this->db->bind(':homepage_intro_title', $data['homepage_intro_title']);
            $this->db->bind(':homepage_intro_description', $data['homepage_intro_description']);
            $this->db->bind(':homepage_intro_sub_description', $data['homepage_intro_sub_description']);
            $this->db->bind(':homepage_intro_image_text', $data['homepage_intro_image_text']);
            $this->db->bind(':homepage_intro_background_type', $data['homepage_intro_background_type']);
            $this->db->bind(':homepage_intro_background', $data['homepage_intro_background']);
            $this->db->bind(':homepage_intro_id', $data['homepage_intro_id']);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function updateHomepageIntroImage($data)
        {
            $this->db->query('UPDATE homepage_intro SET homepage_intro_image = :homepage_intro_image WHERE homepage_intro_id = :homepage_intro_id');
// Bind values
            $this->db->bind(':homepage_intro_image', $data['homepage_intro_image']);
            $this->db->bind(':homepage_intro_id', $data['homepage_intro_id']);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function getHomepageIntro()
        {
            $this->db->query("SELECT * FROM homepage_intro");
            return $this->db->single();
        }
        
        public function getHomepageIntroItems()
        {
            $this->db->query("SELECT * FROM homepage_intro_items ORDER BY homepage_intro_item_order Asc");
            return $this->db->resultSet();
        }
        
        public function addHomepageIntroItem($data)
        {
            $this->db->query('INSERT INTO homepage_intro_items (homepage_intro_item, homepage_intro_item_value) VALUES(:homepage_intro_item, :homepage_intro_item_value)');
// Bind values
            $this->db->bind(':homepage_intro_item', $data['homepage_intro_item']);
            $this->db->bind(':homepage_intro_item_value', $data['homepage_intro_item_value']);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function updateHomepageIntroItem($data)
        {
            $this->db->query('UPDATE homepage_intro_items SET homepage_intro_item = :homepage_intro_item, homepage_intro_item_value = :homepage_intro_item_value WHERE homepage_intro_item_id = :homepage_intro_item_id');
// Bind values
            $this->db->bind(':homepage_intro_item', $data['homepage_intro_item']);
            $this->db->bind(':homepage_intro_item_value', $data['homepage_intro_item_value']);
            $this->db->bind(':homepage_intro_item_id', $data['homepage_intro_item_id']);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function updateHomepageIntroItemOrder($data)
        {
            $this->db->query('UPDATE homepage_intro_items SET homepage_intro_item_order = :homepage_intro_item_order WHERE homepage_intro_item_id = :homepage_intro_item_id');
// Bind values
            $this->db->bind(':homepage_intro_item_order', $data['homepage_intro_item_order']);
            $this->db->bind(':homepage_intro_item_id', $data['homepage_intro_item_id']);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function getHomepageIntroItemById($intro_item_id)
        {
            $this->db->query("SELECT * FROM homepage_intro_items WHERE homepage_intro_item_id = :homepage_intro_item_id");
            $this->db->bind(':homepage_intro_item_id', $intro_item_id);
            return $this->db->single();
        }
        
        public function deleteHomepageIntroItem($data)
        {
            $this->db->query("DELETE FROM homepage_intro_items WHERE homepage_intro_item_id = :homepage_intro_item_id");
            $this->db->bind(':homepage_intro_item_id', $data['homepage_intro_item_id']);
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function updateHomepageFeature($data)
        {
            $this->db->query('UPDATE homepage_features SET homepage_features_heading = :homepage_features_heading, homepage_features_title = :homepage_features_title, homepage_features_background_type = :homepage_features_background_type, homepage_features_background = :homepage_features_background WHERE homepage_features_id = :homepage_features_id');
// Bind values
            $this->db->bind(':homepage_features_heading', $data['homepage_features_heading']);
            $this->db->bind(':homepage_features_title', $data['homepage_features_title']);
            $this->db->bind(':homepage_features_background_type', $data['homepage_features_background_type']);
            $this->db->bind(':homepage_features_background', $data['homepage_features_background']);
            $this->db->bind(':homepage_features_id', $data['homepage_features_id']);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function updateHomepageFeaturesImage($data)
        {
            $this->db->query('UPDATE homepage_features SET homepage_features_image = :homepage_features_image WHERE homepage_features_id = :homepage_features_id');
// Bind values
            $this->db->bind(':homepage_features_image', $data['homepage_features_image']);
            $this->db->bind(':homepage_features_id', $data['homepage_features_id']);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function getHomepageFeatures()
        {
            $this->db->query("SELECT * FROM homepage_features");
            return $this->db->single();
        }
        
        public function getHomepagefeaturesItems()
        {
            $this->db->query("SELECT * FROM homepage_features_items ORDER BY homepage_features_item_order Asc");
            return $this->db->resultSet();
        }
        
        public function addHomepageFeaturesItem($data)
        {
            $this->db->query('INSERT INTO homepage_features_items (homepage_features_item, homepage_features_item_description) VALUES(:homepage_features_item, :homepage_features_item_description)');
// Bind values
            $this->db->bind(':homepage_features_item', $data['homepage_features_item']);
            $this->db->bind(':homepage_features_item_description', $data['homepage_features_item_description']);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function updateHomepageFeaturesItem($data)
        {
            $this->db->query('UPDATE homepage_features_items SET homepage_features_item = :homepage_features_item, homepage_features_item_description = :homepage_features_item_description WHERE homepage_features_item_id = :homepage_features_item_id');
// Bind values
            $this->db->bind(':homepage_features_item', $data['homepage_features_item']);
            $this->db->bind(':homepage_features_item_description', $data['homepage_features_item_description']);
            $this->db->bind(':homepage_features_item_id', $data['homepage_features_item_id']);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function updateHomepageFeaturesItemOrder($data)
        {
            $this->db->query('UPDATE homepage_features_items SET homepage_features_item_order = :homepage_features_item_order WHERE homepage_features_item_id = :homepage_features_item_id');
// Bind values
            $this->db->bind(':homepage_features_item_order', $data['homepage_features_item_order']);
            $this->db->bind(':homepage_features_item_id', $data['homepage_features_item_id']);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function getHomepageFeaturesItemById($features_item_id)
        {
            $this->db->query("SELECT * FROM homepage_features_items WHERE homepage_features_item_id = :homepage_features_item_id");
            $this->db->bind(':homepage_features_item_id', $features_item_id);
            return $this->db->single();
        }
        
        public function deleteHomepageFeaturesItem($data)
        {
            $this->db->query("DELETE FROM homepage_features_items WHERE homepage_features_item_id = :homepage_features_item_id");
            $this->db->bind(':homepage_features_item_id', $data['homepage_features_item_id']);
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function updateHomepageHowItWorks($data)
        {
            $this->db->query('UPDATE homepage_howitworks SET homepage_howitworks_heading = :homepage_howitworks_heading, homepage_howitworks_title = :homepage_howitworks_title, homepage_howitworks_description = :homepage_howitworks_description, homepage_howitworks_background_type = :homepage_howitworks_background_type, homepage_howitworks_background = :homepage_howitworks_background WHERE homepage_howitworks_id = :homepage_howitworks_id');
// Bind values
            $this->db->bind(':homepage_howitworks_heading', $data['homepage_howitworks_heading']);
            $this->db->bind(':homepage_howitworks_title', $data['homepage_howitworks_title']);
            $this->db->bind(':homepage_howitworks_description', $data['homepage_howitworks_description']);
            $this->db->bind(':homepage_howitworks_background_type', $data['homepage_howitworks_background_type']);
            $this->db->bind(':homepage_howitworks_background', $data['homepage_howitworks_background']);
            $this->db->bind(':homepage_howitworks_id', $data['homepage_howitworks_id']);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function getHomepageHowItWorks()
        {
            $this->db->query("SELECT * FROM homepage_howitworks");
            return $this->db->single();
        }
        
        public function getHomepageHowItWorksSteps()
        {
            $this->db->query("SELECT * FROM homepage_howitworks_steps ORDER BY homepage_howitworks_step_order Asc");
            return $this->db->resultSet();
        }
        
        public function addHomepageHowItWorksStep($data)
        {
            $this->db->query('INSERT INTO homepage_howitworks_steps (homepage_howitworks_step_icon, homepage_howitworks_step_title, homepage_howitworks_step_description) VALUES(:homepage_howitworks_step_icon, :homepage_howitworks_step_title, :homepage_howitworks_step_description)');
// Bind values
            $this->db->bind(':homepage_howitworks_step_icon', $data['homepage_howitworks_step_icon']);
            $this->db->bind(':homepage_howitworks_step_title', $data['homepage_howitworks_step_title']);
            $this->db->bind(':homepage_howitworks_step_description', $data['homepage_howitworks_step_description']);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function updateHomepageHowItWorksStep($data)
        {
            $this->db->query("UPDATE homepage_howitworks_steps SET homepage_howitworks_step_icon = :homepage_howitworks_step_icon, homepage_howitworks_step_title = :homepage_howitworks_step_title, homepage_howitworks_step_description = :homepage_howitworks_step_description WHERE homepage_howitworks_step_id = :homepage_howitworks_step_id");
// Bind values
            $this->db->bind(':homepage_howitworks_step_icon', $data['homepage_howitworks_step_icon']);
            $this->db->bind(':homepage_howitworks_step_title', $data['homepage_howitworks_step_title']);
            $this->db->bind(':homepage_howitworks_step_description', $data['homepage_howitworks_step_description']);
            $this->db->bind(':homepage_howitworks_step_id', $data['homepage_howitworks_step_id']);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function getHomepageHowItWorksStepById($homepage_howitworks_step_id)
        {
            $this->db->query("SELECT * FROM homepage_howitworks_steps WHERE homepage_howitworks_step_id = :homepage_howitworks_step_id");
            $this->db->bind(':homepage_howitworks_step_id', $homepage_howitworks_step_id);
            return $this->db->single();
        }
        
        public function deleteHomepageHowItWorksStep($data)
        {
            $this->db->query("DELETE FROM homepage_howitworks_steps WHERE homepage_howitworks_step_id = :homepage_howitworks_step_id");
            $this->db->bind(':homepage_howitworks_step_id', $data['homepage_howitworks_step_id']);
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function updateHomepageApplications($data)
        {
            $this->db->query('UPDATE homepage_applications SET homepage_applications_heading = :homepage_applications_heading, homepage_applications_title = :homepage_applications_title, homepage_applications_background_type = :homepage_applications_background_type, homepage_applications_background = :homepage_applications_background WHERE homepage_applications_id = :homepage_applications_id');
// Bind values
            $this->db->bind(':homepage_applications_heading', $data['homepage_applications_heading']);
            $this->db->bind(':homepage_applications_title', $data['homepage_applications_title']);
            $this->db->bind(':homepage_applications_background_type', $data['homepage_applications_background_type']);
            $this->db->bind(':homepage_applications_background', $data['homepage_applications_background']);
            $this->db->bind(':homepage_applications_id', $data['homepage_applications_id']);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function getHomepageApplications()
        {
            $this->db->query("SELECT * FROM homepage_applications");
            return $this->db->single();
        }
        
        public function getHomepageApplicationsItems()
        {
            $this->db->query("SELECT * FROM homepage_applications_items ORDER BY homepage_applications_item_order Asc");
            return $this->db->resultSet();
        }
        
        public function addHomepageApplicationsItem($data)
        {
            $this->db->query('INSERT INTO homepage_applications_items (homepage_applications_item_icon,homepage_applications_item) VALUES(:homepage_applications_item_icon,:homepage_applications_item)');
// Bind values
            $this->db->bind(':homepage_applications_item_icon', $data['homepage_applications_item_icon']);
            $this->db->bind(':homepage_applications_item', $data['homepage_applications_item']);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function updateHomepageApplicationsItem($data)
        {
            $this->db->query('UPDATE homepage_applications_items SET homepage_applications_item_icon = :homepage_applications_item_icon, homepage_applications_item = :homepage_applications_item WHERE homepage_applications_item_id = :homepage_applications_item_id');
// Bind values
            $this->db->bind(':homepage_applications_item_icon', $data['homepage_applications_item_icon']);
            $this->db->bind(':homepage_applications_item', $data['homepage_applications_item']);
            $this->db->bind(':homepage_applications_item_id', $data['homepage_applications_item_id']);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function updateHomepageApplicationsItemOrder($data)
        {
            $this->db->query('UPDATE homepage_applications_items SET homepage_applications_item_order = :homepage_applications_item_order WHERE homepage_applications_item_id = :homepage_applications_item_id');
// Bind values
            $this->db->bind(':homepage_applications_item_order', $data['homepage_applications_item_order']);
            $this->db->bind(':homepage_applications_item_id', $data['homepage_applications_item_id']);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function getHomepageApplicationsItemById($applications_item_id)
        {
            $this->db->query("SELECT * FROM homepage_applications_items WHERE homepage_applications_item_id = :homepage_applications_item_id");
            $this->db->bind(':homepage_applications_item_id', $applications_item_id);
            return $this->db->single();
        }
        
        public function deleteHomepageApplicationsItem($data)
        {
            $this->db->query("DELETE FROM homepage_applications_items WHERE homepage_applications_item_id = :homepage_applications_item_id");
            $this->db->bind(':homepage_applications_item_id', $data['homepage_applications_item_id']);
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function updateHomepageChoose($data)
        {
            $this->db->query('UPDATE homepage_choose SET homepage_choose_heading = :homepage_choose_heading, homepage_choose_title = :homepage_choose_title, homepage_choose_background_type = :homepage_choose_background_type, homepage_choose_background = :homepage_choose_background WHERE homepage_choose_id = :homepage_choose_id');
// Bind values
            $this->db->bind(':homepage_choose_heading', $data['homepage_choose_heading']);
            $this->db->bind(':homepage_choose_title', $data['homepage_choose_title']);
            $this->db->bind(':homepage_choose_background_type', $data['homepage_choose_background_type']);
            $this->db->bind(':homepage_choose_background', $data['homepage_choose_background']);
            $this->db->bind(':homepage_choose_id', $data['homepage_choose_id']);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function updateHomepageChooseImage($data)
        {
            $this->db->query('UPDATE homepage_choose SET homepage_choose_top_image = :homepage_choose_top_image, homepage_choose_bottom_image = :homepage_choose_bottom_image WHERE homepage_choose_id = :homepage_choose_id');
// Bind values
            $this->db->bind(':homepage_choose_top_image', $data['homepage_choose_top_image']);
            $this->db->bind(':homepage_choose_bottom_image', $data['homepage_choose_bottom_image']);
            $this->db->bind(':homepage_choose_id', $data['homepage_choose_id']);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function getHomepageChoose()
        {
            $this->db->query("SELECT * FROM homepage_choose");
            return $this->db->single();
        }
        
        public function getHomepageChooseItems()
        {
            $this->db->query("SELECT * FROM homepage_choose_items ORDER BY homepage_choose_item_order Asc");
            return $this->db->resultSet();
        }
        
        public function addHomepageChooseItem($data)
        {
            $this->db->query('INSERT INTO homepage_choose_items (homepage_choose_item) VALUES(:homepage_choose_item)');
// Bind values
            $this->db->bind(':homepage_choose_item', $data['homepage_choose_item']);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function updateHomepageChooseItem($data)
        {
            $this->db->query('UPDATE homepage_choose_items SET homepage_choose_item = :homepage_choose_item WHERE homepage_choose_item_id = :homepage_choose_item_id');
// Bind values
            $this->db->bind(':homepage_choose_item', $data['homepage_choose_item']);
            $this->db->bind(':homepage_choose_item_id', $data['homepage_choose_item_id']);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function updateHomepageChooseItemOrder($data)
        {
            $this->db->query('UPDATE homepage_choose_items SET homepage_choose_item_order = :homepage_choose_item_order WHERE homepage_choose_item_id = :homepage_choose_item_id');
// Bind values
            $this->db->bind(':homepage_choose_item_order', $data['homepage_choose_item_order']);
            $this->db->bind(':homepage_choose_item_id', $data['homepage_choose_item_id']);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function getHomepageChooseItemById($choose_item_id)
        {
            $this->db->query("SELECT * FROM homepage_choose_items WHERE homepage_choose_item_id = :homepage_choose_item_id");
            $this->db->bind(':homepage_choose_item_id', $choose_item_id);
            return $this->db->single();
        }
        
        public function deleteHomepageChooseItem($data)
        {
            $this->db->query("DELETE FROM homepage_choose_items WHERE homepage_choose_item_id = :homepage_choose_item_id");
            $this->db->bind(':homepage_choose_item_id', $data['homepage_choose_item_id']);
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function updateHomepagetrust($data)
        {
            $this->db->query('UPDATE homepage_trust SET homepage_trust_heading = :homepage_trust_heading, homepage_trust_title = :homepage_trust_title, homepage_trust_description = :homepage_trust_description, homepage_trust_background_type = :homepage_trust_background_type, homepage_trust_background = :homepage_trust_background WHERE homepage_trust_id = :homepage_trust_id');
// Bind values
            $this->db->bind(':homepage_trust_heading', $data['homepage_trust_heading']);
            $this->db->bind(':homepage_trust_title', $data['homepage_trust_title']);
            $this->db->bind(':homepage_trust_description', $data['homepage_trust_description']);
            $this->db->bind(':homepage_trust_background_type', $data['homepage_trust_background_type']);
            $this->db->bind(':homepage_trust_background', $data['homepage_trust_background']);
            $this->db->bind(':homepage_trust_id', $data['homepage_trust_id']);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function updateHomepageTrustImage($data)
        {
            $this->db->query('UPDATE homepage_trust SET homepage_trust_image = :homepage_trust_image WHERE homepage_trust_id = :homepage_trust_id');
// Bind values
            $this->db->bind(':homepage_trust_image', $data['homepage_trust_image']);
            $this->db->bind(':homepage_trust_id', $data['homepage_trust_id']);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function getHomepageTrust()
        {
            $this->db->query("SELECT * FROM homepage_trust");
            return $this->db->single();
        }
        
        public function getHomepagetrustItems()
        {
            $this->db->query("SELECT * FROM homepage_trust_items ORDER BY homepage_trust_item_order Asc");
            return $this->db->resultSet();
        }
        
        public function addHomepagetrustItem($data)
        {
            $this->db->query('INSERT INTO homepage_trust_items (homepage_trust_item) VALUES(:homepage_trust_item)');
// Bind values
            $this->db->bind(':homepage_trust_item', $data['homepage_trust_item']);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function updateHomepagetrustItem($data)
        {
            $this->db->query('UPDATE homepage_trust_items SET homepage_trust_item = :homepage_trust_item WHERE homepage_trust_item_id = :homepage_trust_item_id');
// Bind values
            $this->db->bind(':homepage_trust_item', $data['homepage_trust_item']);
            $this->db->bind(':homepage_trust_item_id', $data['homepage_trust_item_id']);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function updateHomepagetrustItemOrder($data)
        {
            $this->db->query('UPDATE homepage_trust_items SET homepage_trust_item_order = :homepage_trust_item_order WHERE homepage_trust_item_id = :homepage_trust_item_id');
// Bind values
            $this->db->bind(':homepage_trust_item_order', $data['homepage_trust_item_order']);
            $this->db->bind(':homepage_trust_item_id', $data['homepage_trust_item_id']);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function getHomepagetrustItemById($trust_item_id)
        {
            $this->db->query("SELECT * FROM homepage_trust_items WHERE homepage_trust_item_id = :homepage_trust_item_id");
            $this->db->bind(':homepage_trust_item_id', $trust_item_id);
            return $this->db->single();
        }
        
        public function deleteHomepagetrustItem($data)
        {
            $this->db->query("DELETE FROM homepage_trust_items WHERE homepage_trust_item_id = :homepage_trust_item_id");
            $this->db->bind(':homepage_trust_item_id', $data['homepage_trust_item_id']);
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function updateHomepagePricing($data)
        {
            $this->db->query('UPDATE homepage_pricing SET homepage_pricing_heading = :homepage_pricing_heading, homepage_pricing_title = :homepage_pricing_title, homepage_pricing_background_type = :homepage_pricing_background_type, homepage_pricing_background = :homepage_pricing_background WHERE homepage_pricing_id = :homepage_pricing_id');
// Bind values
            $this->db->bind(':homepage_pricing_heading', $data['homepage_pricing_heading']);
            $this->db->bind(':homepage_pricing_title', $data['homepage_pricing_title']);
            $this->db->bind(':homepage_pricing_background_type', $data['homepage_pricing_background_type']);
            $this->db->bind(':homepage_pricing_background', $data['homepage_pricing_background']);
            $this->db->bind(':homepage_pricing_id', $data['homepage_pricing_id']);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function getHomepagePricing()
        {
            $this->db->query("SELECT * FROM homepage_pricing");
            return $this->db->single();
        }
        
        public function updateHomepageFaqs($data)
        {
            $this->db->query('UPDATE homepage_faqs SET homepage_faqs_heading = :homepage_faqs_heading, homepage_faqs_title = :homepage_faqs_title, homepage_faqs_background_type = :homepage_faqs_background_type, homepage_faqs_background = :homepage_faqs_background WHERE homepage_faqs_id = :homepage_faqs_id');
// Bind values
            $this->db->bind(':homepage_faqs_heading', $data['homepage_faqs_heading']);
            $this->db->bind(':homepage_faqs_title', $data['homepage_faqs_title']);
            $this->db->bind(':homepage_faqs_background_type', $data['homepage_faqs_background_type']);
            $this->db->bind(':homepage_faqs_background', $data['homepage_faqs_background']);
            $this->db->bind(':homepage_faqs_id', $data['homepage_faqs_id']);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function getHomepageFaqs()
        {
            $this->db->query("SELECT * FROM homepage_faqs");
            return $this->db->single();
        }
        
        public function getHomepageFooterBlock()
        {
            $this->db->query("SELECT * FROM homepage_footer_block");
            return $this->db->single();
        }
        
        public function updateHomepageFooterBlock($data)
        {
            $this->db->query('UPDATE homepage_footer_block SET homepage_footer_block_heading = :homepage_footer_block_heading, homepage_footer_block_title = :homepage_footer_block_title, homepage_footer_block_link = :homepage_footer_block_link, homepage_footer_block_link_description = :homepage_footer_block_link_description, homepage_footer_block_background_type = :homepage_footer_block_background_type, homepage_footer_block_background = :homepage_footer_block_background WHERE homepage_footer_block_id = :homepage_footer_block_id');
// Bind values
            $this->db->bind(':homepage_footer_block_heading', $data['homepage_footer_block_heading']);
            $this->db->bind(':homepage_footer_block_title', $data['homepage_footer_block_title']);
            $this->db->bind(':homepage_footer_block_link', $data['homepage_footer_block_link']);
            $this->db->bind(':homepage_footer_block_link_description', $data['homepage_footer_block_link_description']);
            $this->db->bind(':homepage_footer_block_background_type', $data['homepage_footer_block_background_type']);
            $this->db->bind(':homepage_footer_block_background', $data['homepage_footer_block_background']);
            $this->db->bind(':homepage_footer_block_id', $data['homepage_footer_block_id']);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function getHomepageFooterBlockFeatures()
        {
            $this->db->query("SELECT * FROM homepage_footer_block_features ORDER BY homepage_footer_block_feature_order Asc");
            return $this->db->resultSet();
        }
        
        public function getHomepageFooterBlockFeatureById($homepage_footer_block_feature_id)
        {
            $this->db->query("SELECT * FROM homepage_footer_block_features WHERE homepage_footer_block_feature_id = :homepage_footer_block_feature_id");
            $this->db->bind(':homepage_footer_block_feature_id', $homepage_footer_block_feature_id);
            return $this->db->single();
        }
        
        public function updateHomepageFooterBlockFeature($data)
        {
            $this->db->query('UPDATE homepage_footer_block_features SET homepage_footer_block_feature_description = :homepage_footer_block_feature_description WHERE homepage_footer_block_feature_id = :homepage_footer_block_feature_id');
// Bind values
            $this->db->bind(':homepage_footer_block_feature_description', $data['homepage_footer_block_feature_description']);
            $this->db->bind(':homepage_footer_block_feature_id', $data['homepage_footer_block_feature_id']);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function addHomepageFooterBlockFeature($data)
        {
            $this->db->query('INSERT INTO homepage_footer_block_features (homepage_footer_block_feature_description) VALUES(:homepage_footer_block_feature_description)');
// Bind values
            $this->db->bind(':homepage_footer_block_feature_description', $data['homepage_footer_block_feature_description']);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function deleteHomepageFooterBlockFeature($data)
        {
            $this->db->query("DELETE FROM homepage_footer_block_features WHERE homepage_footer_block_feature_id = :homepage_footer_block_feature_id");
            $this->db->bind(':homepage_footer_block_feature_id', $data['homepage_footer_block_feature_id']);
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function getHomepageBlog()
        {
            $this->db->query("SELECT * FROM homepage_blog");
            return $this->db->single();
        }
        
        public function updateHomepageBlog($data)
        {
            $this->db->query('UPDATE homepage_blog SET homepage_blog_heading = :homepage_blog_heading, homepage_blog_title = :homepage_blog_title, homepage_blog_background_type = :homepage_blog_background_type, homepage_blog_background = :homepage_blog_background WHERE homepage_blog_id = :homepage_blog_id');
// Bind values
            $this->db->bind(':homepage_blog_heading', $data['homepage_blog_heading']);
            $this->db->bind(':homepage_blog_title', $data['homepage_blog_title']);
            $this->db->bind(':homepage_blog_background_type', $data['homepage_blog_background_type']);
            $this->db->bind(':homepage_blog_background', $data['homepage_blog_background']);
            $this->db->bind(':homepage_blog_id', $data['homepage_blog_id']);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        
    }