<?php
    
    class Newsletter
    {
        private Database $db;
        
        public function __construct()
        {
            $this->db = new Database;
        }
        
        public function getNewsletters()
        {
            $this->db->query("SELECT * FROM newsletters ORDER BY newsletter_id Desc");
            return $this->db->resultSet();
        }
        
        public function addNewsletter($data)
        {
            $this->db->query('INSERT INTO newsletters (newsletter_added_by, newsletter_slug, newsletter_title, newsletter_description, newsletter_sent_at, newsletter_date_added) VALUES(:newsletter_added_by, :newsletter_slug, :newsletter_title, :newsletter_description, :newsletter_sent_at, :newsletter_date_added)');
// Bind values
            $this->db->bind(':newsletter_added_by', $data['newsletter_added_by']);
            $this->db->bind(':newsletter_slug', $data['newsletter_slug']);
            $this->db->bind(':newsletter_title', $data['newsletter_title']);
            $this->db->bind(':newsletter_description', $data['newsletter_description']);
            $this->db->bind(':newsletter_sent_at', $data['newsletter_sent_at']);
            $this->db->bind(':newsletter_date_added', now());
// Execute
            if ($this->db->execute()) {
                return $this->db->lastInsertId();
            } else {
                return false;
            }
        }
        
        public function updateNewsletter($data)
        {
            $this->db->query('UPDATE newsletters SET newsletter_title=:newsletter_title, newsletter_description=:newsletter_description WHERE newsletter_id=:newsletter_id');
// Bind values
            $this->db->bind(':newsletter_title', $data['newsletter_title']);
            $this->db->bind(':newsletter_description', $data['newsletter_description']);
            $this->db->bind(':newsletter_id', $data['newsletter_id']);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function sendNewsletter($data)
        {
            $this->db->query('UPDATE newsletters SET newsletter_sent_at=:newsletter_sent_at WHERE newsletter_id=:newsletter_id');
// Bind values
            $this->db->bind(':newsletter_sent_at', $data['newsletter_sent_at']);
            $this->db->bind(':newsletter_id', $data['newsletter_id']);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function getNewsletterById($id)
        {
            $this->db->query('SELECT * FROM newsletters
WHERE newsletter_id = :newsletter_id');
            $this->db->bind(':newsletter_id', $id);
            return $this->db->single();
        }
        
        public function deleteNewsletter($id)
        {
            $this->db->query('DELETE FROM newsletters WHERE newsletter_id = :newsletter_id');
// Bind values
            $this->db->bind(':newsletter_id', $id);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        
    }