<?php
    
    class Openai
    {
        private Database $db;
        
        public function __construct()
        {
            $this->db = new Database;
        }
        
        public function getOpenAiTones()
        {
            $this->db->query("SELECT * FROM openai_tones ORDER BY openai_tone_id Desc");
            return $this->db->resultSet();
        }
        
        public function getOpenAiModels()
        {
            $query = "SELECT * FROM openai_models ";
            $query .= "WHERE openai_model_status_id = :openai_model_status_id ";
            $query .= "ORDER BY openai_model_id Desc";
            $this->db->query($query);
            $this->db->bind(':openai_model_status_id', 1);
            return $this->db->resultSet();
        }
        
        public function addModel($data)
        {
            $this->db->query('INSERT INTO openai_models (openai_model, openai_model_type, openai_model_usage_type, openai_model_description, openai_model_tokens, openai_model_status_id) VALUES(:openai_model, :openai_model_type, :openai_model_usage_type, :openai_model_description, :openai_model_tokens, :openai_model_status_id)');
// Bind values
            $this->db->bind(':openai_model', $data['openai_model']);
            $this->db->bind(':openai_model_type', $data['openai_model_type']);
            $this->db->bind(':openai_model_usage_type', $data['openai_model_usage_type']);
            $this->db->bind(':openai_model_description', $data['openai_model_description']);
            $this->db->bind(':openai_model_tokens', $data['openai_model_tokens']);
            $this->db->bind(':openai_model_status_id', $data['openai_model_status_id']);
// Execute
            if ($this->db->execute()) {
                return $this->db->lastInsertId();
            } else {
                return false;
            }
        }
        
        public function updateModel($data)
        {
            $this->db->query('UPDATE openai_models SET openai_model=:openai_model, openai_model_type=:openai_model_type, openai_model_usage_type=:openai_model_usage_type,openai_model_description = :openai_model_description, openai_model_tokens = :openai_model_tokens WHERE openai_model_id=:openai_model_id');
// Bind values
            $this->db->bind(':openai_model', $data['openai_model']);
            $this->db->bind(':openai_model_type', $data['openai_model_type']);
            $this->db->bind(':openai_model_usage_type', $data['openai_model_usage_type']);
            $this->db->bind(':openai_model_description', $data['openai_model_description']);
            $this->db->bind(':openai_model_tokens', $data['openai_model_tokens']);
            $this->db->bind(':openai_model_id', $data['openai_model_id']);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function getOpenAiModel($openai_model)
        {
            $this->db->query('SELECT * FROM openai_models WHERE openai_model = :openai_model');
            $this->db->bind(':openai_model', $openai_model);
            return $this->db->single();
        }
        
        public function getOpenAiModelById($openai_model_id)
        {
            $this->db->query('SELECT * FROM openai_models WHERE openai_model_id = :openai_model_id');
            $this->db->bind(':openai_model_id', $openai_model_id);
            return $this->db->single();
        }

        public function deleteOpenAiModel($id)
        {
            $this->db->query('DELETE FROM openai_models WHERE openai_model_id = :openai_model_id');
// Bind values
            $this->db->bind(':openai_model_id', $id);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        
    }