<?php
    
    class Page
    {
        private Database $db;
        
        public function __construct()
        {
            $this->db = new Database;
        }
        
        public function getPages()
        {
            $this->db->query("SELECT * FROM pages ORDER BY Page_id Desc");
            return $this->db->resultSet();
        }
        
        public function addPage($data)
        {
            $this->db->query('INSERT INTO pages (page_added_by, page_slug, page_background, page_title, page_short_description, page_description, show_in_header, show_in_footer, page_status_id, page_date_added) VALUES(:page_added_by, :page_slug, :page_background, :page_title, :page_short_description, :page_description, :show_in_header, :show_in_footer, :page_status_id, :page_date_added)');
// Bind values
            $this->db->bind(':page_added_by', $data['page_added_by']);
            $this->db->bind(':page_slug', $data['page_slug']);
            $this->db->bind(':page_background', $data['page_background']);
            $this->db->bind(':page_title', $data['page_title']);
            $this->db->bind(':page_short_description', $data['page_short_description']);
            $this->db->bind(':page_description', $data['page_description']);
            $this->db->bind(':show_in_header', $data['show_in_header']);
            $this->db->bind(':show_in_footer', $data['show_in_footer']);
            $this->db->bind(':page_status_id', $data['page_status_id']);
            $this->db->bind(':page_date_added', now());
// Execute
            if ($this->db->execute()) {
                return $this->db->lastInsertId();
            } else {
                return false;
            }
        }
        
        public function updatePage($data)
        {
            $this->db->query('UPDATE pages SET page_title=:page_title, page_background=:page_background, page_short_description=:page_short_description, page_description=:page_description, show_in_header=:show_in_header, show_in_footer=:show_in_footer, page_status_id=:page_status_id WHERE page_id=:page_id');
// Bind values
            $this->db->bind(':page_title', $data['page_title']);
            $this->db->bind(':page_background', $data['page_background']);
            $this->db->bind(':page_short_description', $data['page_short_description']);
            $this->db->bind(':page_description', $data['page_description']);
            $this->db->bind(':page_status_id', $data['page_status_id']);
            $this->db->bind(':show_in_header', $data['show_in_header']);
            $this->db->bind(':show_in_footer', $data['show_in_footer']);
            $this->db->bind(':page_id', $data['page_id']);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function deletePageBackground($id)
        {
            $this->db->query('UPDATE pages SET page_background=:page_background WHERE page_id=:page_id');
// Bind values
            $this->db->bind(':page_background', NULL);
            $this->db->bind(':page_id', $id);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function getPageById($id)
        {
            $this->db->query('SELECT * FROM pages WHERE Page_id = :Page_id');
            $this->db->bind(':Page_id', $id);
            return $this->db->single();
        }
        
        public function getPageByTitle($page_title)
        {
            $this->db->query('SELECT * FROM pages WHERE page_title = :page_title');
            $this->db->bind(':page_title', $page_title);
            return $this->db->single();
        }
        
        public function getPageBySlug($page_slug)
        {
            $this->db->query('SELECT * FROM pages WHERE page_slug = :page_slug');
            $this->db->bind(':page_slug', $page_slug);
            return $this->db->single();
        }
        
        public function deletePage($id)
        {
            $this->db->query('DELETE FROM pages WHERE page_id = :page_id');
// Bind values
            $this->db->bind(':page_id', $id);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        
    }