<?php
    
    class Subscriber
    {
        private Database $db;
        
        public function __construct()
        {
            $this->db = new Database;
        }
        
        public function getSubscribers($status = NULL)
        {
            $query = "SELECT * FROM subscribers ";
            if (isset($status)) {
                $query .= " WHERE subscriber_status_id = :subscriber_status_id ";
            }
            $query .= " ORDER BY subscriber_id Desc";
            $this->db->query($query);
            if (isset($status)) {
                $this->db->bind(':subscriber_status_id', $status);
            }
            return $this->db->resultSet();
        }
        
        public function addSubscriber($data)
        {
            $this->db->query('INSERT INTO subscribers (subscriber_email, subscriber_hash, subscriber_date_added) VALUES(:subscriber_email, :subscriber_hash, :subscriber_date_added)');
// Bind values
            $this->db->bind(':subscriber_email', $data['subscriber_email']);
            $this->db->bind(':subscriber_hash', md5(now()));
            $this->db->bind(':subscriber_date_added', now());
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function getSubscriberById($id)
        {
            $this->db->query('SELECT * FROM subscribers
WHERE subscriber_id = :subscriber_id');
            $this->db->bind(':subscriber_id', $id);
            return $this->db->single();
        }
        
        public function getSubscriberByEmail($subscriber_email)
        {
            $this->db->query('SELECT * FROM subscribers WHERE subscriber_email = :subscriber_email');
// Bind value
            $this->db->bind(':subscriber_email', $subscriber_email);
            // Check row
            return $this->db->single();
        }
        
        
    }