<?php
    
    class User
    {
        private Database $db;
        
        public function __construct()
        {
            $this->db = new Database;
        }
        
        public function getUsers()
        {
            $this->db->query("SELECT * FROM users
ORDER BY user_id Desc");
            return $this->db->resultSet();
        }
        
        public function getUsersBetweenDates($from_date, $to_date)
        {
            $query = "SELECT * FROM users
WHERE date_added BETWEEN :from_date AND :to_date ";
            $query .= " ORDER BY user_id Desc";
            $this->db->query($query);
// Bind values
            $this->db->bind(':from_date', $from_date);
            $this->db->bind(':to_date', $to_date);
            return $this->db->resultSet();
        }
        
        public function addUser($data)
        {
            $this->db->query('INSERT INTO users (user_uid,role_id,referred_by,firstname,lastname,username,email,calling_code,phone,password,country_id,city,postal_code,zip_code,state,street,date_added,last_ip,passkey) VALUES(:user_uid, :role_id, :referred_by, :firstname, :lastname, :username, :email, :calling_code, :phone, :password, :country_id, :city, :postal_code, :zip_code, :state, :street, :date_added, :last_ip, :passkey)');
// Bind values
            $this->db->bind(':user_uid', uid());
            $this->db->bind(':role_id', $data['role_id']);
            $this->db->bind(':referred_by', $data['referred_by']);
            $this->db->bind(':firstname', $data['firstname']);
            $this->db->bind(':lastname', $data['lastname']);
            $this->db->bind(':username', $data['username']);
            $this->db->bind(':email', $data['email']);
            $this->db->bind(':calling_code', $data['calling_code']);
            $this->db->bind(':phone', $data['phone']);
            $this->db->bind(':password', $data['password']);
            $this->db->bind(':country_id', $data['country_id']);
            $this->db->bind(':city', $data['city']);
            $this->db->bind(':postal_code', $data['postal_code']);
            $this->db->bind(':zip_code', $data['zip_code']);
            $this->db->bind(':state', $data['state']);
            $this->db->bind(':street', $data['street']);
            $this->db->bind(':date_added', now());
            $this->db->bind(':last_ip', ip_address());
            $this->db->bind(':passkey', md5(now()));
// Execute
            if ($this->db->execute()) {
                return $this->db->lastInsertId();
            } else {
                return false;
            }
        }
        
        public function getPermissions($role_id)
        {
            $this->db->query('SELECT * FROM role_permissions WHERE role_id =:role_id');
// Bind values
            $this->db->bind(':role_id', $role_id);
            return $this->db->resultSet();
        }

// edit user
        public function editUser($data)
        {
            $this->db->query('UPDATE users SET firstname=:firstname, lastname=:lastname, email=:email, calling_code=:calling_code, phone=:phone, country_id=:country_id, city=:city, postal_code=:postal_code, zip_code=:zip_code, state=:state, street=:street WHERE user_id=:user_id');
// Bind values
            $this->db->bind(':firstname', $data['firstname']);
            $this->db->bind(':lastname', $data['lastname']);
            $this->db->bind(':email', $data['email']);
            $this->db->bind(':calling_code', $data['calling_code']);
            $this->db->bind(':phone', $data['phone']);
            $this->db->bind(':country_id', $data['country_id']);
            $this->db->bind(':city', $data['city']);
            $this->db->bind(':postal_code', $data['postal_code']);
            $this->db->bind(':zip_code', $data['zip_code']);
            $this->db->bind(':state', $data['state']);
            $this->db->bind(':street', $data['street']);
            $this->db->bind(':user_id', $data['user_id']);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function editChatbot($data)
        {
            $this->db->query('UPDATE users SET user_trained_model=:user_trained_model, user_bots=:user_bots, user_chat_files=:user_chat_files, user_chat_links = :user_chat_links, user_chat_sitemaps=:user_chat_sitemaps, user_chat_icon_animation=:user_chat_icon_animation, user_chat_icon_position=:user_chat_icon_position, user_chat_instructions=:user_chat_instructions, widget_header=:widget_header, widget_header_textarea=:widget_header_textarea, widget_colour=:widget_colour, widget_assistant_background_colour = :widget_assistant_background_colour, widget_assistant_text_colour = :widget_assistant_text_colour, widget_user_background_colour = :widget_user_background_colour, widget_user_text_colour = :widget_user_text_colour, widget_message_placeholder=:widget_message_placeholder, widget_open_button = :widget_open_button, widget_close_button = :widget_close_button, widget_visit_timeout=:widget_visit_timeout, widget_document_timeout = :widget_document_timeout, widget_document_retries = :widget_document_retries WHERE user_id=:user_id');
// Bind values
            $this->db->bind(':user_trained_model', $data['user_trained_model']);
            $this->db->bind(':user_bots', $data['user_bots']);
            $this->db->bind(':user_chat_files', $data['user_chat_files']);
            $this->db->bind(':user_chat_links', $data['user_chat_links']);
            $this->db->bind(':user_chat_sitemaps', $data['user_chat_sitemaps']);
            $this->db->bind(':user_chat_icon_animation', $data['user_chat_icon_animation']);
            $this->db->bind(':user_chat_icon_position', $data['user_chat_icon_position']);
            $this->db->bind(':user_chat_instructions', $data['user_chat_instructions']);
            $this->db->bind(':widget_header', $data['widget_header']);
            $this->db->bind(':widget_header_textarea', $data['widget_header_textarea']);
            $this->db->bind(':widget_colour', $data['widget_colour']);
            $this->db->bind(':widget_assistant_background_colour', $data['widget_assistant_background_colour']);
            $this->db->bind(':widget_assistant_text_colour', $data['widget_assistant_text_colour']);
            $this->db->bind(':widget_user_background_colour', $data['widget_user_background_colour']);
            $this->db->bind(':widget_user_text_colour', $data['widget_user_text_colour']);
            $this->db->bind(':widget_message_placeholder', $data['widget_message_placeholder']);
            $this->db->bind(':widget_open_button', $data['widget_open_button']);
            $this->db->bind(':widget_close_button', $data['widget_close_button']);
            $this->db->bind(':widget_visit_timeout', $data['widget_visit_timeout']);
            $this->db->bind(':widget_document_timeout', $data['widget_document_timeout']);
            $this->db->bind(':widget_document_retries', $data['widget_document_retries']);
            $this->db->bind(':user_id', $data['user_id']);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }

        public function updateWhatsappSettings($data)
        {
            $this->db->query('UPDATE users SET whatsapp_access_token=:whatsapp_access_token, whatsapp_phone_number_id=:whatsapp_phone_number_id, whatsapp_webhook_listener=:whatsapp_webhook_listener, whatsapp_webhook_verify_token=:whatsapp_webhook_verify_token, whatsapp_default_response=:whatsapp_default_response, whatsapp_api_version=:whatsapp_api_version WHERE user_id=:user_id');
// Bind values
            $this->db->bind(':whatsapp_access_token', $data['whatsapp_access_token']);
            $this->db->bind(':whatsapp_phone_number_id', $data['whatsapp_phone_number_id']);
            $this->db->bind(':whatsapp_webhook_listener', $data['whatsapp_webhook_listener']);
            $this->db->bind(':whatsapp_webhook_verify_token', $data['whatsapp_webhook_verify_token']);
            $this->db->bind(':whatsapp_default_response', $data['whatsapp_default_response']);
            $this->db->bind(':whatsapp_api_version', $data['whatsapp_api_version']);
            $this->db->bind(':user_id', $data['user_id']);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function editUserRemaining($data)
        {
            $this->db->query('UPDATE users SET user_remaining_words=:user_remaining_words, user_remaining_chat_assistants = :user_remaining_chat_assistants, user_remaining_trained_models = :user_remaining_trained_models, user_remaining_chat_files = :user_remaining_chat_files, user_remaining_chat_links = :user_remaining_chat_links, user_remaining_chat_sitemaps = :user_remaining_chat_sitemaps WHERE user_id=:user_id');
// Bind values
            $this->db->bind(':user_remaining_words', $data['user_remaining_words']);
            $this->db->bind(':user_remaining_chat_assistants', $data['user_remaining_chat_assistants']);
            $this->db->bind(':user_remaining_trained_models', $data['user_remaining_trained_models']);
            $this->db->bind(':user_remaining_chat_files', $data['user_remaining_chat_files']);
            $this->db->bind(':user_remaining_chat_links', $data['user_remaining_chat_links']);
            $this->db->bind(':user_remaining_chat_sitemaps', $data['user_remaining_chat_sitemaps']);
            $this->db->bind(':user_id', $data['user_id']);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function addUserPackageHistory($data)
        {
            $this->db->query('INSERT INTO user_package_history (user_id,type,transaction_type,package_id,openai_template_id,old,current,tokens_used,user_package_history_comment,user_package_history_added_by,user_package_history_date_added) VALUES(:user_id, :type, :transaction_type, :package_id, :openai_template_id, :old, :current, :tokens_used, :user_package_history_comment, :user_package_history_added_by, :user_package_history_date_added)');
// Bind values
            $this->db->bind(':user_id', $data['user_id']);
            $this->db->bind(':type', $data['type']);
            $this->db->bind(':transaction_type', $data['transaction_type']);
            $this->db->bind(':package_id', !empty($data['package_id']) ? $data['package_id'] : NULL);
            $this->db->bind(':openai_template_id', $data['openai_template_id'] ?? NULL);
            $this->db->bind(':old', $data['old']);
            $this->db->bind(':current', $data['current']);
            $this->db->bind(':tokens_used', $data['tokens_used'] ?? NULL);
            $this->db->bind(':user_package_history_comment', $data['user_package_history_comment']);
            $this->db->bind(':user_package_history_added_by', $data['user_package_history_added_by']);
            $this->db->bind(':user_package_history_date_added', now());
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function getUserPackageHistory($transaction_type = NULL, $from_date = NULL, $to_date = NULL, $user_id = NULL)
        {
            $query = "SELECT * FROM user_package_history WHERE 1=1 ";
            if (!empty($transaction_type)) {
                $query .= " AND transaction_type = :transaction_type ";
            }
            if (!empty($from_date) && !empty($to_date)) {
                $query .= " AND user_package_history_date_added BETWEEN :from_date AND :to_date ";
            }
            if (!empty($user_id)) {
                $query .= " AND user_id = :user_id ";
            }
            $query .= " ORDER BY user_package_history_id Desc";
            
            $this->db->query($query);
// Bind values
            if (!empty($transaction_type)) {
                $this->db->bind(':transaction_type', $transaction_type);
            }
            if (!empty($from_date) && !empty($to_date)) {
                $this->db->bind(':from_date', $from_date);
                $this->db->bind(':to_date', $to_date);
            }
            if (!empty($user_id)) {
                $this->db->bind(':user_id', $user_id);
            }
            return $this->db->resultSet();
        }
        
        public function getUserPackageHistoryWords($transaction_type = NULL, $from_date = NULL, $to_date = NULL, $user_id = NULL)
        {
            $query = "SELECT SUM(old-current) as words_count FROM user_package_history WHERE type = :type ";
            if (isset($transaction_type)) {
                $query .= " AND transaction_type = :transaction_type ";
            }
            if (isset($from_date) && isset($to_date)) {
                $query .= " AND user_package_history_date_added BETWEEN :from_date AND :to_date ";
            }
            if (isset($user_id)) {
                $query .= " AND user_id = :user_id ";
            }
            $query .= " ORDER BY user_package_history_id Desc";
            
            $this->db->query($query);
// Bind values
            $this->db->bind(':type', 'words');
            if (isset($transaction_type)) {
                $this->db->bind(':transaction_type', $transaction_type);
            }
            if (isset($from_date) && isset($to_date)) {
                $this->db->bind(':from_date', $from_date);
                $this->db->bind(':to_date', $to_date);
            }
            if (isset($user_id)) {
                $this->db->bind(':user_id', $user_id);
            }
            return $this->db->resultSet();
        }

// change password
        public function changePassword($data)
        {
            $this->db->query('UPDATE users SET password=:password, last_password_change=:last_password_change WHERE user_id=:user_id');
// Bind values
            $this->db->bind(':password', $data['new_password']);
            $this->db->bind(':last_password_change', now());
            $this->db->bind(':user_id', user_id());
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }

// reset password
        public function resetPassword($data)
        {
            $this->db->query('UPDATE users SET password=:password, last_password_change=:last_password_change, passkey=:passkey, new_pass_key_requested=:new_pass_key_requested WHERE email=:email');
// Bind values
            $this->db->bind(':password', $data['new_password']);
            $this->db->bind(':last_password_change', now());
            $this->db->bind(':passkey', md5(now()));
            $this->db->bind(':new_pass_key_requested', now());
            $this->db->bind(':email', $data['email']);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }

// change role
        public function changeRole($data)
        {
            $this->db->query('UPDATE users SET role_id=:role_id WHERE user_id=:user_id');
// Bind values
            $this->db->bind(':role_id', $data['role_id']);
            $this->db->bind(':user_id', $data['user_id']);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }

// set user role to null
        public function setUserRoleToNull($id)
        {
            $this->db->query('UPDATE users SET role_id=:set_null WHERE role_id=:role_id');
// Bind values
            $this->db->bind(':set_null', NULL);
            $this->db->bind(':role_id', $id);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function updateUserStatus($data)
        {
            $this->db->query('UPDATE users SET user_status_id = :user_status_id WHERE user_id = :user_id');
// Bind values
            $this->db->bind(':user_status_id', $data['user_status_id']);
            $this->db->bind(':user_id', $data['user_id']);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function updatePayoutSettings($data)
        {
            $this->db->query('UPDATE users SET payout_mode_id = :payout_mode_id, payout_address = :payout_address WHERE user_id = :user_id');
// Bind values
            $this->db->bind(':payout_mode_id', $data['payout_mode_id']);
            $this->db->bind(':payout_address', $data['payout_address']);
            $this->db->bind(':user_id', $data['user_id']);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function updateLanguage($data)
        {
            $this->db->query('UPDATE users SET default_language = :default_language WHERE user_id = :user_id');
// Bind values
            $this->db->bind(':default_language', $data['default_language']);
            $this->db->bind(':user_id', $data['user_id']);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function login($username, $password)
        {
            $this->db->query('SELECT * FROM users WHERE (username=:username OR email=:email)');
            $this->db->bind(':username', $username);
            $this->db->bind(':email', $username);
            $row = $this->db->single();
            $hashed_password = $row->password;
            if (password_verify($password, $hashed_password)) {
                return $row;
            } else {
                return false;
            }
        }
        
        public function findUserByEmail($email)
        {
            $this->db->query('SELECT * FROM users WHERE email = :email');
// Bind value
            $this->db->bind(':email', $email);
            $row = $this->db->single();
// Check row
            if ($this->db->rowCount() > 0) {
                return $row;
            } else {
                return false;
            }
        }
        
        public function findUserByUsername($username)
        {
            $this->db->query('SELECT * FROM users WHERE username = :username');
// Bind value
            $this->db->bind(':username', $username);
            $row = $this->db->single();
// Check row
            if ($this->db->rowCount() > 0) {
                return true;
            } else {
                return false;
            }
        }
        
        public function findUserByPasskey($passkey)
        {
            $this->db->query('SELECT * FROM users WHERE passkey = :passkey');
// Bind value
            $this->db->bind(':passkey', $passkey);
            $row = $this->db->single();
// Check row
            if ($this->db->rowCount() > 0) {
                return true;
            } else {
                return false;
            }
        }
        
        public function getUserById($id)
        {
            $this->db->query('SELECT *
FROM users 
WHERE user_id = :user_id');
// Bind value
            $this->db->bind(':user_id', $id);
            return $this->db->single();
        }
        
        public function getUserByUid($uid)
        {
            $this->db->query('SELECT *
FROM users 
WHERE user_uid = :user_uid');
// Bind value
            $this->db->bind(':user_uid', $uid);
            return $this->db->single();
        }
        
        public function getUsersByStatus($user_status_id)
        {
            $query = "SELECT *
FROM users  
WHERE user_status_id = :user_status_id ";
            $query .= " ORDER BY user_id Desc";
            $this->db->query($query);
            $this->db->bind(':user_status_id', $user_status_id);
            return $this->db->resultSet();
        }
        
        public function getUserStatus()
        {
            $this->db->query("SELECT * FROM user_status ORDER BY user_status_id Asc");
            return $this->db->resultSet();
        }
        
        public function getUserStatusById($user_status_id)
        {
            $this->db->query("SELECT * FROM user_status  WHERE user_status_id = :user_status_id");
// Bind values
            $this->db->bind(':user_status_id', $user_status_id);
            return $this->db->single();
        }
        
        public function getRandomUser()
        {
            $this->db->query('SELECT * FROM users ORDER BY rand() LIMIT 1');
            return $this->db->single();
        }
        
        public function updateProfileImage($data)
        {
            $this->db->query('UPDATE users SET profile_image = :profile_image WHERE user_id = :user_id');
// Bind values
            $this->db->bind(':profile_image', $data['image']);
            $this->db->bind(':user_id', user_id());
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function deleteProfileImage()
        {
            $this->db->query('UPDATE users SET profile_image = :profile_image WHERE user_id = :user_id');
// Bind values
            $this->db->bind(':profile_image', 'default_user.png');
            $this->db->bind(':user_id', user_id());
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function addUserSession($user_id, $session_access_token, $session_refresh_token)
        {
            $this->db->query('INSERT INTO sessions (user_id, session_access_token, session_access_token_expiry, session_refresh_token, session_refresh_token_expiry) VALUES(:user_id, :session_access_token, :session_access_token_expiry, :session_refresh_token, :session_refresh_token_expiry)');
// Bind values
            $this->db->bind(':user_id', $user_id);
            $this->db->bind(':session_access_token', $session_access_token);
            $this->db->bind(':session_access_token_expiry', date('Y-m-d H:i:s', strtotime('+20 minutes', strtotime(now()))));
            $this->db->bind(':session_refresh_token', $session_refresh_token);
            $this->db->bind(':session_refresh_token_expiry', date('Y-m-d H:i:s', strtotime('+14 days', strtotime(now()))));
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function getUserSession($user_id)
        {
            $this->db->query('SELECT * FROM sessions WHERE user_id = :user_id ORDER BY session_id DESC LIMIT 1');
// Bind values
            $this->db->bind(':user_id', $user_id);
            $row = $this->db->single();
            if ($this->db->rowCount() > 0) {
                return $row;
            } else {
                return false;
            }
        }
        
        public function deleteUserSession($session_access_token)
        {
            $this->db->query('DELETE FROM sessions WHERE session_access_token = :session_access_token');
// Bind values
            $this->db->bind(':session_access_token', $session_access_token);
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        
    }