<?php
    
    class Utility
    {
        private Database $db;
        
        public function __construct()
        {
            $this->db = new Database;
        }
        
        public function getAllTables()
        {
            $this->db->query("SHOW TABLES");
            return $this->db->resultSet();
        }
        
        
        public function backupDatabase($data)
        {
            $tables = is_array($data['all_tables']) ? $data['all_tables'] : explode(',', $data['all_tables']);
            $return = '';
//loop through the tables
            foreach ($tables as $table) {
                $this->db->query("SELECT * FROM $table");
                $result = $this->db->resultSetNum();
                $numColumns = $this->db->columnCount();
                $numRows = $this->db->rowCount();
                $result2 = $this->db->query("SHOW CREATE TABLE $table");
                $row2 = $this->db->singleAssoc();
                $return .= "\n\n" . $row2['Create Table'] . ";\n\n";
                foreach ($result as $keys => $row) {
                    $return .= "INSERT INTO $table VALUES(";
                    for ($j = 0; $j < $numColumns; $j++) {
                        if (is_numeric($row[$j]) && $row[$j] == 0) {
                            $return .= '0';
                        } elseif ($row[$j] == '0000-00-00 00:00:00') {
                            $return .= '"' . now() . '"';
                        } elseif (is_null($row[$j])) {
                            $return .= 'NULL';
                        } elseif (!empty($row[$j])) {
                            $row[$j] = addslashes($row[$j]);
                            $row[$j] = preg_replace("/\n/", "\\n", $row[$j]);
                            $return .= '"' . $row[$j] . '"';
                        } else {
                            $row[$j] = addslashes($row[$j]);
                            $row[$j] = preg_replace("/\n/", "\\n", $row[$j]);
                            $return .= '""';
                        }
                        if ($j < ($numColumns - 1)) {
                            $return .= ',';
                        }
                    }
                    $return .= ");\n";
                }
                $return .= "\n\n\n";
            }
//save file
            $dst_dir = APPROOT . DATABASE_FOLDER;
            $file_name = $dst_dir . '/db_backup_' . time() . '.sql';
            $handle = fopen($file_name, 'w+');
            fwrite($handle, $return);
            fclose($handle);
            return $file_name;
        }
        
        
    }