<?php
    
    class Whatsapp
    {
        private Database $db;
        
        public function __construct()
        {
            $this->db = new Database;
        }
        
        public function getWhatsappFiles($user_id)
        {
            $this->db->query("SELECT * FROM whatsapp_files WHERE whatsapp_file_added_by = :whatsapp_file_added_by ORDER BY Whatsapp_file_id Desc");
            $this->db->bind(':whatsapp_file_added_by', $user_id);
            return $this->db->single();
        }
        
        public function addWhatsappFiles($data)
        {
            $this->db->query('INSERT INTO whatsapp_files (whatsapp_file_uid, whatsapp_file_added_by, whatsapp_file_source_id, whatsapp_file_date_added) VALUES(:whatsapp_file_uid, :whatsapp_file_added_by, :whatsapp_file_source_id, :whatsapp_file_date_added)');
// Bind values
            $this->db->bind(':whatsapp_file_uid', uid());
            $this->db->bind(':whatsapp_file_added_by', user_id());
            $this->db->bind(':whatsapp_file_source_id', $data['whatsapp_file_source_id']);
            $this->db->bind(':whatsapp_file_date_added', now());
// Execute
            if ($this->db->execute()) {
                return $this->db->lastInsertId();
            } else {
                return false;
            }
        }
        
        public function updateWhatsappFiles($data)
        {
            $this->db->query('UPDATE whatsapp_files SET whatsapp_file_source_id = :whatsapp_file_source_id WHERE whatsapp_file_id=:whatsapp_file_id');
// Bind values
            $this->db->bind(':whatsapp_file_source_id', $data['whatsapp_file_source_id']);
            $this->db->bind(':whatsapp_file_id', $data['whatsapp_file_id']);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function updateWhatsappFilesVS($data)
        {
            $this->db->query('UPDATE whatsapp_files SET vector_store_id = :vector_store_id, assistant_id = :assistant_id, chat_instructions = :chat_instructions WHERE whatsapp_file_id=:whatsapp_file_id');
// Bind values
            $this->db->bind(':vector_store_id', $data['vector_store_id']);
            $this->db->bind(':assistant_id', $data['assistant_id']);
            $this->db->bind(':chat_instructions', $data['chat_instructions']);
            $this->db->bind(':whatsapp_file_id', $data['whatsapp_file_id']);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function getWhatsappFilesById($id)
        {
            $this->db->query('SELECT * FROM whatsapp_files WHERE Whatsapp_file_id = :Whatsapp_file_id');
            $this->db->bind(':Whatsapp_file_id', $id);
            return $this->db->single();
        }
        
        
    }