<?php
    
    class Widget
    {
        private Database $db;
        
        public function __construct()
        {
            $this->db = new Database;
        }
        
        public function getWidgets($user_id)
        {
            $this->db->query("SELECT * FROM widgets WHERE widget_added_by = :widget_added_by ORDER BY Widget_id Desc");
            $this->db->bind(':widget_added_by', $user_id);
            return $this->db->resultSet();
        }
        
        public function addWidget($data)
        {
            $this->db->query('INSERT INTO widgets (widget_uid, widget_added_by, widget_name, user_trained_model, user_bots, user_chat_files, user_chat_links, user_chat_sitemaps, user_chat_icon_animation, user_chat_icon_position, user_chat_instructions, widget_header, widget_header_textarea, widget_colour, widget_assistant_background_colour, widget_assistant_text_colour, widget_user_background_colour, widget_user_text_colour,widget_message_placeholder, widget_open_button, widget_close_button, widget_visit_timeout, widget_document_timeout, widget_document_retries, widget_date_added) VALUES(:widget_uid, :widget_added_by, :widget_name, :user_trained_model, :user_bots, :user_chat_files, :user_chat_links, :user_chat_sitemaps, :user_chat_icon_animation, :user_chat_icon_position, :user_chat_instructions, :widget_header, :widget_header_textarea, :widget_colour, :widget_assistant_background_colour, :widget_assistant_text_colour, :widget_user_background_colour, :widget_user_text_colour, :widget_message_placeholder, :widget_open_button, :widget_close_button, :widget_visit_timeout, :widget_document_timeout, :widget_document_retries, :widget_date_added)');
// Bind values
            $this->db->bind(':widget_uid', 'eai' . uid(10));
            $this->db->bind(':widget_added_by', $data['widget_added_by']);
            $this->db->bind(':widget_name', $data['widget_name']);
            $this->db->bind(':user_trained_model', $data['user_trained_model']);
            $this->db->bind(':user_bots', $data['user_bots']);
            $this->db->bind(':user_chat_files', $data['user_chat_files']);
            $this->db->bind(':user_chat_links', $data['user_chat_links']);
            $this->db->bind(':user_chat_sitemaps', $data['user_chat_sitemaps']);
            $this->db->bind(':user_chat_icon_animation', $data['user_chat_icon_animation']);
            $this->db->bind(':user_chat_icon_position', $data['user_chat_icon_position']);
            $this->db->bind(':user_chat_instructions', $data['user_chat_instructions']);
            $this->db->bind(':widget_header', $data['widget_header']);
            $this->db->bind(':widget_header_textarea', $data['widget_header_textarea']);
            $this->db->bind(':widget_colour', $data['widget_colour']);
            $this->db->bind(':widget_assistant_background_colour', $data['widget_assistant_background_colour']);
            $this->db->bind(':widget_assistant_text_colour', $data['widget_assistant_text_colour']);
            $this->db->bind(':widget_user_background_colour', $data['widget_user_background_colour']);
            $this->db->bind(':widget_user_text_colour', $data['widget_user_text_colour']);
            $this->db->bind(':widget_message_placeholder', $data['widget_message_placeholder']);
            $this->db->bind(':widget_open_button', $data['widget_open_button']);
            $this->db->bind(':widget_close_button', $data['widget_close_button']);
            $this->db->bind(':widget_visit_timeout', $data['widget_visit_timeout']);
            $this->db->bind(':widget_document_timeout', $data['widget_document_timeout']);
            $this->db->bind(':widget_document_retries', $data['widget_document_retries']);
            $this->db->bind(':widget_date_added', now());
// Execute
            if ($this->db->execute()) {
                return $this->db->lastInsertId();
            } else {
                return false;
            }
        }
        
        public function updateWidget($data)
        {
            $this->db->query('UPDATE widgets SET widget_name = :widget_name, user_trained_model = :user_trained_model, user_bots = :user_bots, user_chat_files = :user_chat_files, user_chat_links = :user_chat_links, user_chat_sitemaps = :user_chat_sitemaps, user_chat_icon_animation = :user_chat_icon_animation, user_chat_icon_position = :user_chat_icon_position, user_chat_instructions = :user_chat_instructions, widget_header = :widget_header, widget_header_textarea = :widget_header_textarea, widget_colour = :widget_colour, widget_assistant_background_colour = :widget_assistant_background_colour, widget_assistant_text_colour = :widget_assistant_text_colour, widget_user_background_colour = :widget_user_background_colour, widget_user_text_colour = :widget_user_text_colour, widget_message_placeholder = :widget_message_placeholder, widget_open_button = :widget_open_button, widget_close_button = :widget_close_button, widget_visit_timeout = :widget_visit_timeout, widget_document_timeout = :widget_document_timeout, widget_document_retries = :widget_document_retries WHERE widget_id=:widget_id');
// Bind values
            $this->db->bind(':widget_name', $data['widget_name']);
            $this->db->bind(':user_trained_model', $data['user_trained_model']);
            $this->db->bind(':user_bots', $data['user_bots']);
            $this->db->bind(':user_chat_files', $data['user_chat_files']);
            $this->db->bind(':user_chat_links', $data['user_chat_links']);
            $this->db->bind(':user_chat_sitemaps', $data['user_chat_sitemaps']);
            $this->db->bind(':user_chat_icon_animation', $data['user_chat_icon_animation']);
            $this->db->bind(':user_chat_icon_position', $data['user_chat_icon_position']);
            $this->db->bind(':user_chat_instructions', $data['user_chat_instructions']);
            $this->db->bind(':widget_header', $data['widget_header']);
            $this->db->bind(':widget_header_textarea', $data['widget_header_textarea']);
            $this->db->bind(':widget_colour', $data['widget_colour']);
            $this->db->bind(':widget_assistant_background_colour', $data['widget_assistant_background_colour']);
            $this->db->bind(':widget_assistant_text_colour', $data['widget_assistant_text_colour']);
            $this->db->bind(':widget_user_background_colour', $data['widget_user_background_colour']);
            $this->db->bind(':widget_user_text_colour', $data['widget_user_text_colour']);
            $this->db->bind(':widget_message_placeholder', $data['widget_message_placeholder']);
            $this->db->bind(':widget_open_button', $data['widget_open_button']);
            $this->db->bind(':widget_close_button', $data['widget_close_button']);
            $this->db->bind(':widget_visit_timeout', $data['widget_visit_timeout']);
            $this->db->bind(':widget_document_timeout', $data['widget_document_timeout']);
            $this->db->bind(':widget_document_retries', $data['widget_document_retries']);
            $this->db->bind(':widget_id', $data['widget_id']);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        public function getWidgetById($id)
        {
            $this->db->query('SELECT * FROM widgets WHERE Widget_id = :Widget_id');
            $this->db->bind(':Widget_id', $id);
            return $this->db->single();
        }
        
        public function getWidgetByName($widget_name)
        {
            $this->db->query('SELECT * FROM widgets WHERE widget_name = :widget_name');
            $this->db->bind(':widget_name', $widget_name);
            return $this->db->single();
        }
        
        public function getWidgetByUid($widget_uid)
        {
            $this->db->query('SELECT * FROM widgets WHERE widget_uid = :widget_uid');
            $this->db->bind(':widget_uid', $widget_uid);
            return $this->db->single();
        }
        
        public function deleteWidget($id)
        {
            $this->db->query('DELETE FROM widgets WHERE widget_id = :widget_id');
// Bind values
            $this->db->bind(':widget_id', $id);
// Execute
            if ($this->db->execute()) {
                return true;
            } else {
                return false;
            }
        }
        
        
    }