<?php $page = 'affiliate_program'; ?>
<?php require APPROOT . '/views/inc/header.php'; ?>
<?php require 'affiliate_nav.php'; ?>
<?php echo card_div(); ?>
<div class="row">
    <div class="col-md-6">
        <div class="card mb-3">
            <div class="card-header"><?php echo label('affiliate_program'); ?></div>
            <div class="card-body">
                <p><?php echo getOption('affiliate_action_phrase'); ?></p>
                <p>
                    <span class="h5"><?php echo label('my_referral_link'); ?></span>
                <div class="input-group mb-3">
                    <input type="text" value="<?php echo URLROOT . '/?ref=' . strtoupper(user(user_id())->user_uid); ?>"
                           class="form-control" id="my_referral_link" name="my_referral_link">
                    <button class="btn btn-outline-primary" onclick="copyText()"><?php echo label('copy'); ?></button>
                </div>
                </p>
                <div class="row">
                    <div class="col-md-6">
                        <p class="mt-3">
                            <span class="h5"><?php echo label('referral_rule'); ?></span>
                        <p><?php echo affiliate_rule(getOption('affiliate_rule_id'))->affiliate_rule; ?></p>
                        </p>

                    </div>
                    <div class="col-md-6">
                        <p class="mt-3">
                            <span class="h5"><?php echo label('commission_rate'); ?></span>
                        <p><?php echo getOption('affiliate_commission_rate'); ?>%</p>
                        </p>

                    </div>
                </div>
                <p class="mt-3">
                    <span class="h5"><?php echo label('referral_guidelines'); ?></span>
                <p><?php echo getOption('affiliate_guidelines'); ?></p>
                </p>
            </div>
        </div>
    </div>
    <div class="col-md-6">
        <div class="card mb-3">
            <div class="card-header"><?php echo label('invite_your_friends'); ?></div>
            <div class="card-body">
                <form action="<?php echo URLROOT; ?>/affiliates/send_referral_link" method="post" autocomplete="off"
                      enctype="multipart/form-data">
                    <label class="form-label"><?php echo label('enter_your_friends_email_address_and_send_an_invitation_to_join'); ?>
                        <span
                                class="symbol required"></span></label>
                    <div class="input-group mb-3">
                        <input type="text" placeholder="<?php echo label('email_address'); ?>"
                               class="form-control" id="email" name="email">
                        <button class="btn btn-outline-primary" type="submit"><?php echo label('send'); ?></button>
                    </div>
                </form>
                <span class="h5 mt-3 mb-3"><?php echo label('or'); ?></span>
                <p class="mt-3">
                    <span class="h5"><?php echo label('share_referral_link'); ?></span>

                </p>
                <p>
                    <a class="mx-2"
                       href="https://wa.me/?text=<?php echo URLROOT . '/?ref=' . strtoupper(user(user_id())->user_uid); ?>"
                       data-bs-toggle="tooltip" data-bs-placement="bottom" title="<?php echo label('whatsapp'); ?>"
                       target="_blank"><i class="fab fa-whatsapp fa-2x"></i></a>
                    <a class="mx-2"
                       href="https://twitter.com/intent/tweet/?url=<?php echo URLROOT . '/?ref=' . strtoupper(user(user_id())->user_uid); ?>"
                       data-bs-toggle="tooltip" data-bs-placement="bottom" title="<?php echo label('twitter'); ?>"
                       target="_blank"><i class="fab fa-twitter fa-2x"></i></a>
                    <a class="mx-2"
                       href="https://www.facebook.com/sharer/sharer.php?u=<?php echo URLROOT . '/?ref=' . strtoupper(user(user_id())->user_uid); ?>"
                       data-bs-toggle="tooltip" data-bs-placement="bottom" title="<?php echo label('facebook'); ?>"
                       target="_blank"><i class="fab fa-facebook fa-2x"></i></a>
                    <a class="mx-2"
                       href="https://www.reddit.com/submit?title=<?php echo label('join'); ?>&url=<?php echo URLROOT . '/?ref=' . strtoupper(user(user_id())->user_uid); ?>"
                       data-bs-toggle="tooltip" data-bs-placement="bottom" title="<?php echo label('reddit'); ?>"
                       target="_blank"><i class="fab fa-reddit fa-2x"></i></a>
                    <a class="mx-2"
                       href="https://www.linkedin.com/sharing/share-offsite/?url=<?php echo URLROOT . '/?ref=' . strtoupper(user(user_id())->user_uid); ?>"
                       data-bs-toggle="tooltip" data-bs-placement="bottom" title="<?php echo label('linkedin'); ?>"
                       target="_blank"><i class="fab fa-linkedin fa-2x"></i></a>
                    <a class="mx-2"
                       href="https://telegram.me/share/url?url=<?php echo URLROOT . '/?ref=' . strtoupper(user(user_id())->user_uid); ?>&text=<?php echo label('join'); ?>"
                       data-bs-toggle="tooltip" data-bs-placement="bottom" title="<?php echo label('telegram'); ?>"
                       target="_blank"><i class="fab fa-telegram fa-2x"></i></a>
                </p>
            </div>
        </div>
    </div>
</div>
<?php require APPROOT . '/views/inc/footer.php'; ?>
<script>
    function copyText() {
        // Get the text field
        var copyText = document.getElementById("my_referral_link");

        // Select the text field
        copyText.select();
        copyText.setSelectionRange(0, 99999); // For mobile devices

        // Copy the text inside the text field
        navigator.clipboard.writeText(copyText.value);

        // Alert the copied text
        alert("<?php echo label('copied_text'); ?>: " + copyText.value);
    }
</script>