<?php $page = 'payouts'; ?>
<?php require APPROOT . '/views/inc/header.php'; ?>
<?php require 'affiliate_nav.php'; ?>
<?php echo card_div(); ?>
    <div class="col-md-6">
        <div class="card mb-3">
            <div class="card-body">
                <p class="fw-bold"><?php echo label('available_balance'); ?>
                    <span class="fw-bold float-end"><?php echo currency_format(affiliates_total() - user_payouts_total(user_id(), '1')->payout_amount - user_payouts_total(user_id(), '2')->payout_amount); ?></span>
                </p>
            </div>
        </div>
        <form action="<?php echo URLROOT; ?>/affiliates/request_payout" method="post" enctype="multipart/form-data">
            <div class="card mb-3">
                <div class="card-body">
                    <div class="form-group mb-3">
                        <label><?php echo label('payout_amount'); ?></label>
                        <div class="input-group">
                            <div class="input-group-prepend"><span
                                        class="input-group-text"><?php echo useCurrency(); ?></span></div>
                            <input type="text" id="payout_amount" name="payout_amount" class="form-control"
                                   required/>
                        </div>
                    </div>
                    <div class="form-group mb-3">
                        <button class="btn btn-primary btn-wide float-end" type="submit">
                            <?php echo label('request_payout'); ?>
                        </button>
                    </div>
                </div>
            </div>
        </form>
    </div>
    <div class="col-md-6">
        <div class="card mb-3">
            <div class="card-body">
                <p class="fw-bold"><?php echo label('payout_mode'); ?>
                    : <?php echo !empty(user(user_id())->payout_mode_id) ? payout_mode(user(user_id())->payout_mode_id)->payout_mode_name : NULL; ?>
                    <span class="float-end">[<a
                                href="<?php echo URLROOT . '/users/profile'; ?>"><?php echo label('change_payout_details'); ?></a>]</span>
                </p>
                <p class="fw-bold"><?php echo label('payout_address'); ?>
                    : <?php echo user(user_id())->payout_address; ?></p>
            </div>
        </div>
        <table class="table table-striped table-hover">
            <caption><?php echo label('payout_request_requirements'); ?></caption>
            <thead>
            <tr>
                <th><?php echo label('payout_mode'); ?></th>
                <th><?php echo label('payout_mode_minimum'); ?></th>
            </tr>
            </thead>
            <tbody>
            <?php foreach (payout_modes() as $payout_mode) { ?>
                <tr>
                    <td><?php echo $payout_mode->payout_mode_name; ?></td>
                    <td><?php echo currency_format($payout_mode->payout_mode_minimum); ?></td>
                </tr>
            <?php } ?>
            </tbody>
        </table>
    </div>

<?php $rows = start_paging($data['payouts']); ?>
    <div class="col-md-12">
        <table class="table table-striped table-hover">
            <thead>
            <tr>
                <th><?php echo label('payout'); ?></th>
                <th><?php echo label('user'); ?></th>
                <th><?php echo label('payout_mode'); ?></th>
                <th><?php echo label('payout_address'); ?></th>
                <th><?php echo label('payout_amount'); ?></th>
                <th><?php echo label('status'); ?></th>
                <th><?php echo label('date_requested'); ?></th>
                <th></th>
            </tr>
            </thead>
            <tbody>
            <?php foreach ($rows as $payout) { ?>
                <tr>
                    <td><?php echo n_link('affiliates', 'show', $payout->payout_id, $payout->payout_name); ?></td>
                    <td><?php echo user($payout->user_id)->username; ?></td>
                    <td><?php echo payout_mode($payout->payout_mode_id)->payout_mode_name; ?></td>
                    <td><?php echo $payout->payout_address; ?></td>
                    <td><?php echo bold_currency_format($payout->payout_amount); ?></td>
                    <td><?php echo status_label(payout_status($payout->payout_status_id)->payout_status_colour, label(payout_status($payout->payout_status_id)->payout_status)); ?></td>
                    <td><?php echo dateTimeFormat($payout->payout_date_added); ?></td>
                    <td class="text-end">
                        <?php if (isSuperAdmin() && payout($payout->payout_id)->payout_status_id == '1' && $payout->user_id != user_id()) {
                            echo fa_link('affiliates', 'pay', $payout->payout_id, 'dollar');
                        }
                            if (payout($payout->payout_id)->payout_status_id == '1') {
                                if (isSuperAdmin()) {
                                    echo fa_link('affiliates', 'decline', $payout->payout_id, 'exclamation');
                                }
                                if (payout($payout->payout_id)->user_id == user_id()) {
                                    echo fa_link('affiliates', 'cancel', $payout->payout_id, 'ban');
                                }
                            }
                        ?>
                    </td>
                </tr>
            <?php } ?>
            </tbody>
            <caption>
                <p class="fw-bold mx-2 float-end">
                    <?php echo label('earnings'); ?>
                    : <?php echo currency_format(user_payouts_total(user_id())->payout_amount); ?>
                    <?php echo label('paid'); ?>
                    : <?php echo currency_format(user_payouts_total(user_id(), '2')->payout_amount); ?>
                    <?php echo label('pending'); ?>
                    : <?php echo currency_format(user_payouts_total(user_id(), '1')->payout_amount); ?>
                </p>
            </caption>
        </table>
    </div>
<?php echo close_paging($data['payouts']); ?>
<?php require APPROOT . '/views/inc/footer.php'; ?>