<?php $page = 'chat_assistants'; ?>
<?php require APPROOT . '/views/inc/header.php'; ?>
<?php echo card_div(); ?>
<div class="form-group mb-3">
    <div class="input-group">
        <input type="text" id="search" name="search" class="form-control"
               placeholder="<?php echo label('type_to_search'); ?>"/>
        <span class="input-group-text"><i class="fa-solid fa-search"></i></span>
    </div>
</div>
<div class="list-group" id="show-list">
    <!-- Here autocomplete list will be display -->
</div>
<?php if (!empty($data['assistants'])) { ?>
    <?php $rows = start_paging($data['assistants']); ?>
    <div class="row">
        <?php foreach ($rows as $assistant) {
            $favourite = fav_by_assistant($assistant->chat_assistant_id, user_id());
            $attributes = assistant_attributes($assistant->chat_assistant_id, user_id());
            ?>
            <div class="col-md-3">
                <div class="card border-<?php echo $attributes->border; ?> mb-3 assistant-box">
                    <?php if ($assistant->chat_assistant_added_by != 1) { ?>
                        <div class="card-header bg-primary text-white"><?php echo label('owned'); ?></div>
                    <?php } ?>
                    <div class="card-body">
                        <div class="card-text text-center">
	                        <span class="float-end pt-1">
	                    		<form id="chat_assistant_id<?php echo $assistant->chat_assistant_id; ?>"
                                      action="<?php echo URLROOT; ?>/favs/<?php echo $attributes->action; ?>/<?php echo !empty($favourite) ? $favourite->fav_id : NULL; ?>"
                                      method="post" autocomplete="off" enctype="multipart/form-data">
	                    		<input type="hidden" id="chat_assistant_id" name="chat_assistant_id"
                                       value="<?php echo $assistant->chat_assistant_id; ?>"/>
	                    		<i class="<?php echo $attributes->action_icon; ?>" data-bs-toggle="tooltip"
                                   data-bs-placement="bottom" title="<?php echo $attributes->action_title; ?>"
                                   onclick="document.getElementById('chat_assistant_id<?php echo $assistant->chat_assistant_id; ?>').submit();"></i>
	                    		</form>
                    		</span>
                            <a href="<?php echo URLROOT; ?>/assistants/show/<?php echo $assistant->chat_assistant_id; ?>"
                               class="text-reset">
                                <img class="rounded-circle w-50"
                                     src="<?php echo URLROOT . DIRECTORY_SEPARATOR . 'app' . MEDIA_FOLDER . $assistant->chat_assistant_logo; ?>"
                                     alt="">
                                <p class="fs-5 pt-1"><?php echo $assistant->chat_assistant_name; ?></p>
                                <p class="text-muted"><?php echo $assistant->chat_assistant_profession; ?></p>
                            </a>
                        </div>
                    </div>
                </div>
            </div>
        <?php } ?>
    </div>
    <?php echo close_paging($data['assistants']); ?>
<?php } else {
    echo no_records($page);
} ?>
<?php require APPROOT . '/views/inc/footer.php'; ?>
<script type="text/javascript">
    $(document).ready(function () {
        // Send Search Text to the server
        $("#search").keyup(function () {
            let searchText = $(this).val();
            if (searchText != "") {
                $.ajax({
                    url: "<?php echo URLROOT; ?>/assistants/search_assistant",
                    method: "post",
                    data: {
                        query: searchText,
                    },
                    success: function (response) {
                        $("#show-list").html(response);
                    },
                });
            } else {
                $("#show-list").html("");
            }
        });
        // Set searched text in input field on click of search button
        $(document).on("click", "a", function () {
            $("#search").val($(this).text());
            $("#show-list").html("");
        });
    });
</script>
