<?php $page = 'chat'; ?>
<?php require APPROOT . '/views/inc/header.php'; ?>
<?php echo card_div(); ?>

<div class="row mb-3">
    <div class="col-sm-12 bg-white">
        <div class="app-inner-layout-top-pane border-bottom">
            <div class="pane-left">
                <div class="widget-content p-0">
                    <div class="widget-content-wrapper">
                        <span class=" mx-1 my-1">
								<span class="fw-bold float-end mx-5 mt-1">
									<span class="badge rounded-pill bg-light">
										<span class="h6 fw-bold text-primary mr-1 user_remaining_words"><?php echo (user(user_id())->user_remaining_words == -1) ? label('unlimited') : (int)user(user_id())->user_remaining_words; ?></span>
										<span class="h6 fw-bold text-dark"><?php echo label('words_left'); ?></span>
									</span>
									<button class="btn btn-light"
                                            onclick="Export2Pdf('load_messages', <?php echo time(); ?>, 'from_html');"><i
                                                class="fa-solid fa-file-pdf" data-bs-toggle="tooltip"
                                                data-bs-placement="bottom"
                                                data-bs-title="<?php echo label('export_as_pdf_document'); ?>"></i></button>
									<button class="btn btn-light"
                                            onclick="Export2Word('load_messages', <?php echo time(); ?>, 'from_html');"><i
                                                class="fa-solid fa-file-word" data-bs-toggle="tooltip"
                                                data-bs-placement="bottom"
                                                data-bs-title="<?php echo label('export_as_word_document'); ?>"></i></button>
									<button class="btn btn-light"
                                            onclick="Export2Text('load_messages', <?php echo time(); ?>, 'from_html');"><i
                                                class="fa-solid fa-file-text" data-bs-toggle="tooltip"
                                                data-bs-placement="bottom"
                                                data-bs-title="<?php echo label('export_as_text_document'); ?>"></i></button>
									<button class="btn btn-light"
                                            onclick="CopyText('load_messages', <?php echo time(); ?>, 'from_html');"><i
                                                class="fa-solid fa-copy" data-bs-toggle="tooltip"
                                                data-bs-placement="bottom"
                                                data-bs-title="<?php echo label('copy_text'); ?>"></i></button>
									<button class="btn btn-light send_email"><i class="fa-solid fa-at"
                                                                                data-bs-toggle="tooltip"
                                                                                data-bs-placement="bottom"
                                                                                data-bs-title="<?php echo label('email_text'); ?>"></i></button>
								</span>
							</span>
                    </div>
                </div>
            </div>
        </div>

        <div class="chat-wrapper overflow-auto load_messages" id="load_messages">
            <ul class="nav flex-column">
                <?php foreach ($data['chat_messages'] as $key => $chat) { ?>
                    <?php if ($chat->is_bot) { ?>
                        <div class="chat-box-wrapper">
                            <div class="float-start">
                                <div class="chat-box"><?php echo $chat->chat_message; ?></div>
                                <small class="opacity-6">
                                    <i class="fa-regular fa-clock mr-1"></i>
                                    <?php echo time_elapsed_string($chat->chat_message_date_added); ?>
                                </small>
                            </div>
                        </div>
                    <?php } ?>
                    <?php if (!$chat->is_bot) { ?>
                        <div class="chat-box-wrapper chat-box-wrapper-right">
                            <div class="float-end">
                                <div class="chat-box bg-primary text-white"><?php echo $chat->chat_message; ?></div>
                                <small class="opacity-6 float-end">
                                    <i class="fa-regular fa-clock me-1"></i>
                                    <?php echo time_elapsed_string($chat->chat_message_date_added); ?>
                                </small>
                            </div>
                        </div>
                    <?php } ?>
                <?php } ?>
            </ul>
        </div>
    </div>
</div>
<?php require APPROOT . '/views/inc/footer.php'; ?>
<div class="modal" id="edit_class_modal" tabindex="-1">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-body"></div>
        </div>
    </div>
</div>
<script>
    $(document).ready(function () {
        var delay = 2;
        $('.send_email').click(function (e) {
            e.preventDefault();
            var _this = $(this) //click button
            var existingHTML = _this.html() //store exiting button HTML

            var email_subject = "<?php echo time(); ?>";
            var message = $('#load_messages').html();
            $.ajax
            ({
                type: "POST",
                url: "<?php echo URLROOT; ?>/chats/send_email",
                data:
                    "email_subject=" + email_subject +
                    "&&message=" + message,
                beforeSend: function () {
                    $(".send_email").attr("disabled", "disabled");
                    $('.send_email').html('<span class="spinner-border spinner-border-sm" role="status" aria-hidden="true"></span> <?php echo label('sending'); ?>...');

                },
                success: function (data) {
                    var result = jQuery.parseJSON(data);
                    setTimeout(function () {
                        if (result.status == "success") {
                            $('.completion_result').html('<div class="alert alert-success" id="msg-flash">' + result.message + '</div>');
                        } else {
                            $('.completion_result').html('<div class="alert alert-danger" id="msg-flash">' + result.message + '</div>');
                        }
                        $(_this).html(existingHTML).prop('disabled', false);
                    }, delay);
                }
            });
        });

    });
</script>