<?php $page = 'chat'; ?>
<?php require APPROOT . '/views/inc/header.php'; ?>
<?php echo card_div(); ?>

<div class="row mb-3">
    <div class="col-sm-12 bg-white rounded-3">
        <div class="app-inner-layout-top-pane border-bottom">
            <div class="pane-left">
                <div class="widget-content p-0">
                    <div class="widget-content-wrapper">
                        <div class="widget-content-left mr-3 w-25">
                            <div class="row">
                                <div class="col-sm-4">
                                    <div class="avatar-icon-wrapper">
                                        <div class="avatar-icon">
                                            <img src="<?php echo $data['chat_icon']; ?>"
                                                 class="mb-1 w-100"
                                                 alt="">
                                        </div>
                                    </div>
                                </div>
                                <div class="col-sm-8">
                                    <div class="widget-content-left">
                                        <div class="widget-heading fw-bold"><?php echo $data['chat_source_name']; ?></div>
                                        <div class="widget-subheading text-muted"><?php echo $data['chat_source_sub_name']; ?></div>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <span class=" mx-1 my-1">
								<span class="fw-bold float-end mx-5 mt-1">
									<span class="badge rounded-pill bg-light">
										<span class="h6 fw-bold text-primary mr-1 user_remaining_words"><?php echo (user(user_id())->user_remaining_words == -1) ? label('unlimited') : (int)user(user_id())->user_remaining_words; ?></span>
										<span class="h6 fw-bold text-dark"><?php echo label('words_left'); ?></span>
									</span>
									<button class="btn btn-light"
                                            onclick="Export2Pdf('load_messages', <?php echo time(); ?>, 'from_html');"><i
                                                class="fa-solid fa-file-pdf" data-bs-toggle="tooltip"
                                                data-bs-placement="bottom"
                                                data-bs-title="<?php echo label('export_as_pdf_document'); ?>"></i></button>
									<button class="btn btn-light"
                                            onclick="Export2Word('load_messages', <?php echo time(); ?>, 'from_html');"><i
                                                class="fa-solid fa-file-word" data-bs-toggle="tooltip"
                                                data-bs-placement="bottom"
                                                data-bs-title="<?php echo label('export_as_word_document'); ?>"></i></button>
									<button class="btn btn-light"
                                            onclick="Export2Text('load_messages', <?php echo time(); ?>, 'from_html');"><i
                                                class="fa-solid fa-file-text" data-bs-toggle="tooltip"
                                                data-bs-placement="bottom"
                                                data-bs-title="<?php echo label('export_as_text_document'); ?>"></i></button>
									<button class="btn btn-light"
                                            onclick="CopyText('load_messages', <?php echo time(); ?>, 'from_html');"><i
                                                class="fa-solid fa-copy" data-bs-toggle="tooltip"
                                                data-bs-placement="bottom"
                                                data-bs-title="<?php echo label('copy_text'); ?>"></i></button>
									<button class="btn btn-light send_email"><i class="fa-solid fa-at"
                                                                                data-bs-toggle="tooltip"
                                                                                data-bs-placement="bottom"
                                                                                data-bs-title="<?php echo label('email_text'); ?>"></i></button>
								</span>
							</span>
                    </div>
                </div>
            </div>
        </div>
        
        <div class="chat-wrapper vh-100 overflow-auto">
            <input type="hidden" name="chat_id" id="chat_id"
                   value="<?php echo ($last_chat_by_source_owner = last_chat_by_source_owner(user_id(), $data['source'], $data['source_id'])) ? $last_chat_by_source_owner->chat_id : ''; ?>"/>
            <input type="hidden" name="assistant_id" id="assistant_id"/>
            <input type="hidden" name="assistant_file_id" id="assistant_file_id"
                   value="<?php echo $data['assistant_file_id']; ?>"/>
            <input type="hidden" name="chat_instructions" id="chat_instructions" value="<?php echo $data['chat_instructions']; ?>">
            <input type="hidden" name="source" id="source" value="<?php echo $data['source']; ?>">
            <input type="hidden" name="source_id" id="source_id" value="<?php echo $data['source_id']; ?>">
            <input type="hidden" name="user_id" id="user_id"
                   value="<?php echo user_id(); ?>"/>
            <input type="hidden" name="thread_id" id="thread_id"/>
            <input type="hidden" name="run_id" id="run_id"/>

            <span class="assistant_description" id="assistant_description"></span>
            <span class="load_messages" id="load_messages">
            	<span class="message"></span>
            </span>

            <span class="load_new_message"></span>

            <span class="mt-3 completion_result"></span>

            <div class="chat-box-wrapper">
                <div class="row">
                    <div class="col-sm-12">
                        <div class="bot" style="display: none">
                            <div class="chat-box">
                                <div class="chat-bubble">

                                </div>
                                <div id="typewriter"></div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <div class="text-center ps-1 pe-1 mb-3">
                <div class="input-group">
                    <input placeholder="<?php echo label('type_a_message'); ?>" type="text"
                           class="form-control rounded-start-5" name="message" id="message">
                    <div class="rounded-end-5 input-group-text root <?php echo $data['send_button_class']; ?>" id="send_message">
                        <i class="fa-solid fa-paper-plane fontawesome"></i>
                    </div>
                    <span class="generate_chat_response"></span>
                    <span class="generate_document_chat_response"></span>
                </div>
            </div>
        </div>
    </div>
</div>
<?php require APPROOT . '/views/inc/footer.php'; ?>
<div class="modal" id="edit_class_modal" tabindex="-1">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-body"></div>
        </div>
    </div>
</div>
<script>
    $(document).ready(function () {
        var delay = 100;

        function load_chats() {
            $(".load_chats").empty();
            jQuery.ajax({
                type: "GET", // Post / Get method
                url: URLROOT + '/chats/load_chats/<?php echo $data["source"]; ?>/<?php echo $data["source_id"]; ?>', //Where form data is sent on submission
                dataType: "text", // Data type, HTML, json etc.
                data: '', //Form variables
                success: function (response) {
                    $(".load_chats").html(response);
                },
                error: function (xhr, ajaxOptions, thrownError) {
                    alert(thrownError);
                }
            });
        }
		function load_messages() {
		    var chat_id = $("#chat_id").val();
		    if (chat_id == '') {
		        return;
		    }

		    jQuery.ajax({
		        type: "GET",
		        url: URLROOT + '/chats/load_messages',
		        dataType: "text",
		        data: { chat_id: chat_id },
		        success: function(response) {
		            $(".load_messages").fadeOut(200, function() {
		                $(this).html(response).fadeIn(200, function() {
		                    scrollToBottom();
		                });
		            });
		        },
		        error: function(xhr, ajaxOptions, thrownError) {
		            alert(thrownError);
		        }
		    });
		}

		function appendMessage(message) 								{
    $(".load_messages").append(
        '<div class="float-end"><div class="chat-box-wrapper chat-box-wrapper-right"><div><div class="chat-box bg-primary text-white">' + message + '</div><small class="opacity-6 float-end"><i class="fa-regular fa-clock me-1"></i><?php echo time_elapsed_string(now()); ?></small></div><div><div class="avatar-icon-wrapper ml-1"><div class="badge badge-bottom btn-shine badge-success badge-dot badge-dot-lg"></div></div></div></div></div>'
    );
}

		function scrollToBottom() {
    $('.chat-wrapper').animate({ scrollTop: $('.chat-wrapper').prop("scrollHeight") }, 0);
}
        
        $('#message').keydown(function (e) {
            if (e.keyCode == 13) {
                $('#send_message').click();
            }
        });

        $(document).on('click', '.send_message', function (e) {
            e.preventDefault();
            var message = stripHTML($('#message').val());
            var chat_id = stripHTML($("#chat_id").val());
            var source = stripHTML("<?php echo $data['source']; ?>");
            var source_id = stripHTML("<?php echo $data['source_id']; ?>");

            $.ajax
            ({
                type: "POST",
                url: "<?php echo URLROOT; ?>/chats/send_message",
                data:
                    "message=" + message +
                    "&&chat_id=" + chat_id +
                    "&&source=" + source +
                    "&&source_id=" + source_id,
                beforeSend: function () {
                    $(".root").removeClass("send_message");
                    $(".fontawesome").removeClass("fa-paper-plane");
                    $(".fontawesome").addClass("fa-ellipsis fa-fade");
                    $('.bot').hide();
                },
                success: function (data) {
                    var result = jQuery.parseJSON(data);
                    setTimeout(function () {
                        if (result.status == "success") {
				            appendMessage(result.message); // Append the new message directly
				            scrollToBottom();
				            $("#load_new_message").html(''); // Clear the message input
                            $("#chat_id").val(result.chat_id);
                            setTimeout(function () {
                                $('.generate_chat_response').click()
                            }, 1)
                        } else {
                        	$('.completion_result').html('<div class="alert alert-danger">' + result.message + '</div>');
                        }
                    }, delay);
                }
            });
        });

        $('.generate_chat_response').click(function (e) {
            e.preventDefault();

            var _this = $(this) //click button
            var existingHTML = _this.html() //store exiting button HTML

            var message = stripHTML($('#message').val());
            var chat_id = stripHTML($("#chat_id").val());
            var source = stripHTML("<?php echo $data['source']; ?>");
            var source_id = stripHTML("<?php echo $data['source_id']; ?>");

            $.ajax
            ({
                type: "POST",
                url: "<?php echo URLROOT; ?>/chats/generate_chat",
                data:
                    "message=" + message +
                    "&&chat_id=" + chat_id +
                    "&&source=" + source +
                    "&&source_id=" + source_id,
                beforeSend: function () {
                    $('#message').val('');
                    $('.bot').show();
                    $('#typewriter').html('');
                    $('.load_new_message').html('');
                    $('.chat-bubble').append('<div class="typing"><div class="dot"></div><div class="dot"></div><div class="dot"></div></div>');
                },
                success: function (data) {
                    var result = jQuery.parseJSON(data);
                    setTimeout(function () {
                        if (result.status == "success") {

                            $(".user_remaining_words").each(function () {
                                $(this).prop("Counter", result.old_tokens).animate(
                                    {
                                        Counter: result.current_tokens,
                                    },
                                    {
                                        duration: 4000,
                                        easing: "swing",
                                        step: function (now) {
                                            now = Number(Math.ceil(now)).toLocaleString('en');
                                            $(this).text(now);
                                        },
                                    }
                                );
                            });

                            var text = result.text;
                            let index = 0;

                            function type() {
                                if (index < text.length) {
                                    document.getElementById('typewriter').innerHTML = text.slice(0, index) + '<span class="blinking-cursor">|</span>';
                                    index++;
                                    setTimeout(type, Math.random() * <?php echo getOption('response_typing_speed'); ?>);
                                    scrollToBottom();
                                } else {
                                    document.getElementById('typewriter').innerHTML = text.slice(0, index);
                                    load_messages();
                    				$('.bot').hide();
                    				scrollToBottom();
                                }
                            }

                            if (<?php echo getOption('response_typing_speed'); ?>>
                            0
                        )
                            {
                                type();
                            }
                        else
                            {
                                document.getElementById('typewriter').innerHTML = text;
                            }
                            $(".root").addClass("send_message");
                            $('.bot').show();
                            scrollToBottom();
                        } else {
                        	$('.completion_result').html('<div class="alert alert-danger">' + result.message + '</div>');
                    		$('.bot').hide();
                        }
	                    $('.chat-bubble').html('');
                        $(".generate_text").removeAttr("disabled", "disabled");
                        $(_this).html(existingHTML).prop('disabled', false);
                    	$(".root").addClass("send_message");
	                    $(".fontawesome").addClass("fa-paper-plane");
	                    $(".fontawesome").removeClass("fa-ellipsis fa-fade");
                    }, delay);
                }
            });
        });

        $('.send_email').click(function (e) {
            e.preventDefault();
            var _this = $(this) //click button
            var existingHTML = _this.html() //store exiting button HTML

            var email_subject = "<?php echo time(); ?>";
            var message = $('#load_messages').html();
            $.ajax
            ({
                type: "POST",
                url: "<?php echo URLROOT; ?>/chats/send_email",
                data:
                    "email_subject=" + email_subject +
                    "&&message=" + message,
                beforeSend: function () {
                    $(".send_email").attr("disabled", "disabled");
                    $('.send_email').html('<span class="spinner-border spinner-border-sm" role="status" aria-hidden="true"></span> <?php echo label('sending'); ?>...');

                },
                success: function (data) {
                    var result = jQuery.parseJSON(data);
                    setTimeout(function () {
                        if (result.status == "success") {
                            $('.completion_result').html('<div class="alert alert-success" id="msg-flash">' + result.message + '</div>');
                        } else {
                            $('.completion_result').html('<div class="alert alert-danger" id="msg-flash">' + result.message + '</div>');
                        }
                        $(_this).html(existingHTML).prop('disabled', false);
                    }, delay);
                }
            });
        });

        load_messages();
        var chat_id = $("#chat_id").val();
        $("#item" + chat_id).addClass("active");

        $('.edit_chat').click(function (e) {
            e.preventDefault();
            setTimeout(function () {
                var chat_id = $("#chat_id").val();
                $('.modal-body').load('<?php echo URLROOT; ?>/chats/edit_modal/' + chat_id, function () {
                    $('#edit_class_modal').modal({show: true});
                }),
                    1
            });
        });

    const widget_document_timeout = '<?php echo !empty(user(user_id())->widget_document_timeout) ? user(user_id())->widget_document_timeout : 5000; ?>';
    let widget_document_retries = '<?php echo !empty(user(user_id())->widget_document_retries) ? user(user_id())->widget_document_retries : 5; ?>';

    function doBeforeSendForFetch() {
        $('#send_message').removeClass("create_thread");
        $(".fontawesome").removeClass("fa-paper-plane");
        $(".fontawesome").addClass("fa-spinner fa-spin-pulse");
        $('#message').val('');
        $('.chat-bubble').html('');
		$("#load_new_message").html('');
        $('.bot').show();
        $('#typewriter').html('');
        $('.chat-bubble').append('<div class="typing"><div class="dot"></div><div class="dot"></div><div class="dot"></div></div>');
    }

    function doAfterResultForFetch() {
        $(".fontawesome").addClass("fa-paper-plane");
        $(".fontawesome").removeClass("fa-spinner fa-spin-pulse");
		$('.bot').hide();
        load_messages();
    }

    $(document).on('click', '.create_thread', function (e) {
        var message = $('#message').val();
        var assistant_id = $("#assistant_id").val();
        var assistant_file_id = $("#assistant_file_id").val();
        var thread_id = $("#thread_id").val();
        var chat_id = $("#chat_id").val();
        var chat_instructions = $("#chat_instructions").val();
        var user_id = $("#user_id").val();
        var source = $("#source").val();
        var source_id = $("#source_id").val();
        $('#message').val('');
        $(".fontawesome").removeClass("fa-paper-plane");
        $(".fontawesome").addClass("fa-ellipsis fa-fade");
        runProcesses(message, assistant_file_id, thread_id, chat_id, user_id, assistant_id, chat_instructions, source, source_id, 'create_thread');
    });
    
    $(document).on('click', '.create_thread_message', function (e) {
        var _this = $(this); //click button
        var existingHTML = _this.html(); //store existing button HTML
        var message = $('#message').val();
        var assistant_id = $("#assistant_id").val();
        var assistant_file_id = $("#assistant_file_id").val();
        var thread_id = $("#thread_id").val();
        var chat_id = $("#chat_id").val();
        var user_id = $("#user_id").val();
        var source = $("#source").val();
        var source_id = $("#source_id").val();
        var chat_instructions = $("#chat_instructions").val();
        doBeforeSendForFetch();
        runProcesses(message, assistant_file_id, thread_id, chat_id, user_id, assistant_id, chat_instructions, source, source_id, 'create_thread_message');
    });
    
    async function updateStatus(message, alert, result) {
        if (result.alert === 'danger') {
            $('.completion_result').html('<div class="alert alert-' + result.alert + '" id="msg-flash">' + result.message + '</div>');
        }
    }

    function callPHPProcess(processNumber, inputData) {
        return $.ajax({
            url: URLROOT + '/chats/' + processNumber,
            type: 'POST',
            data: inputData,
            dataType: 'json'
        });
    }

    function submitPostRequest(processNumber, previousResult) {
        const postData = {
            ...previousResult
        };

        return $.ajax({
            url: URLROOT + '/chats/' + processNumber,
            type: 'POST',
            data: postData,
            dataType: 'json'
        });
    }

    async function promptUntilCompleted(processNumber, inputData) {
        while (widget_document_retries > 0) {
            const result = await callPHPProcess(processNumber, inputData);
            updateStatus("<?php echo label('processing'); ?>...", result.alert, result);

            if (result.status === 'success') {
                updateStatus("<?php echo label('completed_successfully'); ?>", result.alert, result);
                $('#send_message').addClass("create_thread_message");
                return result.data;
            } else if (result.status === 'error') {
                updateStatus(result, result.alert, result);
                doAfterResultForFetch();
                throw new Error(result.message);
            } else {
                updateStatus("<?php echo label('retrying'); ?>...", result.alert, result);
                await sleep(widget_document_timeout);
                widget_document_retries--;
            }
        }

        updateStatus("<?php echo label('failed_after_multiple_retries'); ?> " + result.message, result.alert, result);
    }

    async function runProcesses(message, assistant_file_id, thread_id, chat_id, user_id, assistant_id, chat_instructions, source, source_id, start_from) {
        try {
            let inputData = {
                'message': message,
                'assistant_id': assistant_id,
                'assistant_file_id': assistant_file_id,
                'thread_id': thread_id,
                'chat_id': chat_id,
                'user_id': user_id,
                'source': source,
                'source_id': source_id,
                'chat_instructions': chat_instructions
            };

            // Array of process names
            const processNames = ['create_thread', 'create_thread_message', 'create_run', 'retrieve_run', 'list_messages'];
		    const startIndex = processNames.indexOf(start_from);
		    let modifiedProcessNames;
		    
		    if (startIndex !== -1) {
		        modifiedProcessNames = processNames.slice(startIndex);
		        //console.log(modifiedProcessNames);
		    } else {
		        modifiedProcessNames = processNames;
		    }
            
            for (let processNumber of modifiedProcessNames) {
                inputData = await promptUntilCompleted(processNumber, inputData);
                if (processNumber === 'create_thread') {
                    $('#thread_id').val(inputData.thread_id || $('#thread_id').val());
                    $('#chat_id').val(inputData.chat_id || $('#chat_id').val());
                }
                if (processNumber === 'create_thread_message') {
                    $('#assistant_id').val(inputData.assistant_id || $('#assistant_id').val());
                    doBeforeSendForFetch();
			        appendMessage(inputData.message);
			        scrollToBottom();
				    $("#load_new_message").html('');
                }
                if (processNumber === 'create_run') {
                    $('#run_id').val(inputData.run_id || $('#run_id').val());
                }
                if (processNumber === 'list_messages') {
                    listMessages(inputData);
                }
            }

            //updateStatus("All steps completed successfully");

            // Trigger a click event after the last process completes and pass the last result
            $('.generate_document_chat_response').trigger('click', [inputData]);
        } catch (error) {
            updateStatus("Error: " + error.message, error.alert, error);
        }
    }

    function sleep(ms) {
        return new Promise(resolve => setTimeout(resolve, ms));
    }

    $(document).on('click', '.generate_document_chat_response', function (e, lastResult) {
        var _this = $(this); //click button
        var existingHTML = _this.html(); //store existing button HTML
        $.ajax({
            type: "POST",
            url: URLROOT + "/chats/generate_document_chat",
            data: "data=" + lastResult.messages,
            beforeSend: function () {
                $('#typewriter').html('');
                $('.load_new_message').html('');
                $('.completion_result').html('');
            },
            success: function (data) {
                var result = jQuery.parseJSON(data);
                setTimeout(function () {
                    if (result.status == "success") {
                        var text = result.text;
                        let index = 0;

                            function type() {
                                if (index < text.length) {
                                    document.getElementById('typewriter').innerHTML = text.slice(0, index) + '<span class="blinking-cursor">|</span>';
                                    index++;
                                    setTimeout(type, Math.random() * <?php echo getOption('response_typing_speed'); ?>);
                                    scrollToBottom();
                                } else {
                                    document.getElementById('typewriter').innerHTML = text.slice(0, index);
                    				$('.bot').hide();
                    				scrollToBottom();
                                }
                            }

                        if (<?php echo getOption('response_typing_speed'); ?>>
                            0
                        )
                            {
                            type();
                        } else {
                            document.getElementById('typewriter').innerHTML = text;
                        }
                        $(".root").addClass("create_thread_message");

                    } else {
                        $('.chat-bubble').html('');
                        $('.bot').hide();
                        $('.completion_result').html('<div class="alert alert-danger">' + result.message + '</div>');
                    }
                    $(_this).html(existingHTML).prop('disabled', false);
                }, delay);
                doAfterResultForFetch();
            }
        });
    });

    $(document).on('click', '.stop_document_link_chat', function (e) {
        var _this = $(this); //click button
        var existingHTML = _this.html(); //store existing button HTML
        var run_id = stripHTML($("#run_id").val());
        var thread_id = stripHTML($("#thread_id").val());
        $.ajax({
            type: "POST",
            url: URLROOT + "/chats/stop_document_link_chat",
            data:
                "run_id=" + run_id +
                "&&thread_id=" + thread_id,
            beforeSend: function () {
            },
            success: function (data) {
                var result = jQuery.parseJSON(data);
                setTimeout(function () {
                    $('#send_message').removeClass("create_thread");
                    $('#send_message').removeClass("create_thread_message");
                    $("#send_message").addClass("send_message");
                    $('.click-toggle-checkbox').show();
                    $('.append_stop_document_link_chat').html('');
                    $(_this).html(existingHTML).prop('disabled', false);
                }, delay);
                doAfterResultForFetch();
            }
        });
    });
    
    var retryCount = 0;

function listMessages(data) {
    data.dont_post = "true";
    $.ajax({
        url: URLROOT + "/chats/list_messages",
        type: 'POST',
        data: data,
        success: function (secondResponse) {
            let result = jQuery.parseJSON(secondResponse);
            if (result.status === "success") {
                // Check if there are any messages posted to the thread
                $('.chat-bubble').html('');
                $('.completion_result').html('');

                let nestedMessage = result.messages;
                let keys = Object.keys(nestedMessage);
                let totalKeys = keys.length;
                let text = '';
                let index = 0;

                // Define the type function here
                function type() {
                    if (index < text.length) {
                        document.getElementById('typewriter').innerHTML = text.slice(0, index) + '<span class="blinking-cursor">|</span>';
                        index++;
                        setTimeout(type, Math.random() * <?php echo getOption('response_typing_speed'); ?>); // Random delay up to 100ms for a natural typing effect
                        scrollToBottom();
                    } else {
                        document.getElementById('typewriter').innerHTML = text.slice(0, index);
                        scrollToBottom();
                    }
                }

                for (let i = 0; i < totalKeys; i++) {
                    let key = keys[i];
                    let text = nestedMessage[key];

                    if (text.length > 0) {
                        index = 0; // Reset index before typing each new message
                        document.getElementById('typewriter').innerHTML = ''; // Clear previous text
                        type();
                    } else {
                        document.getElementById('typewriter').innerHTML = text;
                    }

                    if (i === totalKeys - 1) {
                        $('.bot').show();
                    }

                    scrollToBottom();
                }
            } else if (result.status === "wait") {
                // Retry the second request up to 3 times
                if (retryCount < widget_document_retries) {
                    retryCount++;
                    setTimeout(function () {
                        listMessages(data); // Retry after widget_document_timeout milliseconds
                    }, widget_document_timeout);
                } else {
                    $('.bot').hide();
                    $('.chat-bubble').html('');
                    $('.completion_result').html('<div class="alert alert-danger" id="msg-flash">' + result.message + '</div>');
                    retryCount = 0; // Reset retry count
                }
            } else {
                $('.bot').hide();
                $('.chat-bubble').html('');
                $('.completion_result').html('<div class="alert alert-danger" id="msg-flash">' + result.message + '</div>');
            }
        },
        error: function (jqXHR, textStatus, errorThrown) {
            // Handle errors for second request
            $('.completion_result').html('<div class="alert alert-danger" id="msg-flash">' + textStatus + '</div>');
        }
    });
}

    
    

    });
</script>