<?php $page = 'files'; ?>
<?php require APPROOT . '/views/inc/header.php'; ?>
<?php echo card_div(); ?>

<span class="completion_result fw-bold"></span>
<div class="card mb-3">
    <div class="card-body">
        <div class="row">
            <div class="col-md-4">
                <div class="card">
                    <div class="card-body">
                        <form class="dropzone rounded-3 mb-3"></form>
	                    <div class="form-group mb-3">
	                        <label class="form-check-label"
	                               for="upload_for_chat"> <?php echo label('upload_for_chat_immediately'); ?>
	                        </label>
	                        <div class="form-check form-switch fs-5">
	                            <input class="form-check-input" type="checkbox" id="upload_for_chat"
	                                   name="upload_for_chat"
	                                   value="1">
	                        </div>
	                    </div>
                        <button class="form-control btn btn-primary float-end upload_file" id="upload_file"
                                type="button">
                            <?php echo label('upload'); ?>
                        </button>
                    </div>
                </div>
            </div>
            <div class="col-md-8">
                <div id="load_files">
                    <?php if (!empty(chat_files(user_id()))) { ?>
                        <?php $rows = start_paging(chat_files(user_id())); ?>
                        <table class="table table-striped table-hover">
                            <thead>
                            <tr>
                                <th><?php echo label('file'); ?></th>
                                <th><?php echo label('size'); ?></th>
                                <th><?php echo label('date_added'); ?></th>
                                <th></th>
                            </tr>
                            </thead>
                            <tbody>
                            <?php foreach (array_slice($rows, 0, 5) as $file) { ?>
                                <tr>
                                    <td><?php echo n_link('files', 'show', $file->chat_file_id, $file->chat_file); ?></td>
                                    <td><?php echo customFileSize($file->chat_file_size); ?></td>
                                    <td><?php echo dateTimeFormat($file->chat_file_date_added); ?></td>
                                    <td class="text-end">
                                        <?php echo fa_link('files', 'delete', $file->chat_file_id, 'times'); ?>
                                    </td>
                                </tr>
                            <?php } ?>
                            </tbody>
                        </table>
                        <?php echo close_paging(chat_files(user_id())); ?>
                    <?php } else {
                        echo no_records('chat_files');
                    } ?>
                </div>
            </div>
        </div>
    </div>
</div>
<?php require APPROOT . '/views/inc/footer.php'; ?>
<?php
$accepted_file = '';
foreach(accepted_assistant_files() as $accepted){
	$accepted_file .= ', .'.$accepted;
}
$accepted_assistant_files = accepted_assistant_files();
$maximum_upload_file_size = getOption('maximum_upload_file_size');
?>
<script>
    //Disabling autoDiscover
    Dropzone.autoDiscover = false;

    $(function () {
        // Define upload_for_chat_value globally
        var upload_for_chat_value = '0'; // Default value (unchecked)

        // Dropzone class
        var myDropzone = new Dropzone(".dropzone", {
            url: "<?php echo URLROOT; ?>/files/upload_file",
            paramName: "file",
            maxFilesize: "<?php echo $maximum_upload_file_size; ?>",
            acceptedFiles: "<?php echo $accepted_file; ?>",
            autoProcessQueue: false,
            uploadMultiple: true,
            parallelUploads: 100,
            init: function () {
                this.on("sending", function (file, xhr, formData) {
                    // Add upload_for_chat_value to formData before each upload
                    formData.append("upload_for_chat", upload_for_chat_value);
                });
                this.on("success", function (file, response) {
                    var obj = jQuery.parseJSON(response);
                    var out_status;
                    if (obj.status === true) {
                        out_status = 'success';
                    } else {
                        out_status = 'danger';
                    }
                    $('.flash_message').html('<div class="fw-bold alert alert-' + out_status + '">' + obj.message + '</div>');
                });
            }
        });

        let uploadButtonClicked = false;

        $('#upload_file').click(function (e) {
            e.preventDefault(); // Prevent default form submission

            // Update upload_for_chat_value based on checkbox state
            var uploadForChatChecked = $('#upload_for_chat').prop('checked');
            upload_for_chat_value = uploadForChatChecked ? '1' : '0';

            if (!uploadButtonClicked) {
                uploadButtonClicked = true;
                myDropzone.processQueue();
            }
        });
    });
</script>






