<?php $page = 'files'; ?>
<?php require APPROOT . '/views/inc/header.php'; ?>
<?php echo card_div(); ?>

<span class="completion_result fw-bold"></span>
<div class="card mb-3">
    <div class="card-body">
        <div class="row">
            <div class="col-md-4">
                <div class="card">
                    <div class="card-body">
                        <form class="dropzone rounded-3 mb-3"></form>
                        <button class="form-control btn btn-primary float-end upload_file" id="upload_file"
                                type="submit">
                            <?php echo label('upload'); ?>
                        </button>
                    </div>
                </div>
            </div>
            <div class="col-md-8">
                <div id="load_files">
                    <?php if (!empty(finetune_files(user_id()))) { ?>
                        <?php $rows = start_paging(finetune_files(user_id())); ?>
                        <table class="table table-striped table-hover">
                            <thead>
                            <tr>
                                <th><?php echo label('file'); ?></th>
                                <th><?php echo label('size'); ?></th>
                                <th><?php echo label('date_added'); ?></th>
                                <th></th>
                            </tr>
                            </thead>
                            <tbody>
                            <?php foreach (array_slice($rows, 0, 5) as $file) { ?>
                                <tr>
                                    <td><?php echo n_link('finetuning', 'show', $file->finetune_id, $file->finetune_file); ?></td>
                                    <td><?php echo customFileSize($file->finetune_file_size); ?></td>
                                    <td><?php echo dateTimeFormat($file->finetune_file_date_added); ?></td>
                                    <td class="text-end">
                                        <?php echo fa_link('finetuning', 'delete', $file->finetune_id, 'times'); ?>
                                    </td>
                                </tr>
                            <?php } ?>
                            </tbody>
                        </table>
                        <?php echo close_paging(finetune_files(user_id())); ?>
                    <?php } else {
                        echo no_records('finetune_files');
                    } ?>
                </div>
            </div>
        </div>
    </div>
</div>
<?php require APPROOT . '/views/inc/footer.php'; ?>
<script>
    //Disabling autoDiscover
    Dropzone.autoDiscover = false;

    $(function () {
        //Dropzone class
        var myDropzone = new Dropzone(".dropzone", {
            url: "<?php echo URLROOT; ?>/finetuning/upload",
            paramName: "file",
            //maxFilesize: 25,
            maxFiles: 1,
            acceptedFiles: ".jsonl",
            autoProcessQueue: false,
            init: function () {
                this.on("success", function (file, response) {
                    var obj = jQuery.parseJSON(response);
                    let out_status;
                    if (obj.status === true) {
						out_status = 'success';
					} else {
						out_status = 'danger';
					}
                    $('.flash_message').html('<div class="fw-bold alert alert-' + out_status + '">' + obj.message + '</div>');
                })
            }
        });

        $('#upload_file').click(function () {
            myDropzone.processQueue();
        });
    });
</script>




