<?php
    $paytr_settings = payment_option_settings('paytr')['settings'];
    
    $email = user(user_id())->email;
    $payment_amount = package($_POST['package_id'])->package_cost;
    $merchant_oid = uid();
    $user_name = user(user_id())->firstname . " " . user(user_id())->lastname;
    $user_address = user(user_id())->street;
    $user_phone = user(user_id())->phone;
    $merchant_ok_url = URLROOT . "/pmt_paytr/paytr_success";
    $merchant_fail_url = URLROOT . "/pmt_paytr/paytr_error";
    $user_basket = "";
    
    $user_basket = base64_encode(json_encode(array(
        array("Subscription", package($_POST['package_id'])->package_cost, 1)
    )));
    
    if (isset($_SERVER["HTTP_CLIENT_IP"])) {
        $ip = $_SERVER["HTTP_CLIENT_IP"];
    } elseif (isset($_SERVER["HTTP_X_FORWARDED_FOR"])) {
        $ip = $_SERVER["HTTP_X_FORWARDED_FOR"];
    } else {
        $ip = $_SERVER["REMOTE_ADDR"];
    }
    
    $user_ip = $ip;
    $timeout_limit = "30";
    $debug_on = 1;
    $test_mode = payment_option_settings('paytr')['settings']->paytr_status;
    $no_installment = 0;
    $max_installment = 0;
    $currency = getOption('default_currency');
    
    $hash_str = $paytr_settings->paytr_merchant_id . $user_ip . $merchant_oid . $email . $payment_amount . $user_basket . $no_installment . $max_installment . $currency . $test_mode;
    $paytr_token = base64_encode(hash_hmac('sha256', $hash_str . $paytr_settings->paytr_merchant_salt, $paytr_settings->paytr_merchant_key, true));
    $post_vals = array(
        'merchant_id' => $paytr_settings->paytr_merchant_id,
        'user_ip' => $user_ip,
        'merchant_oid' => $merchant_oid,
        'email' => $email,
        'payment_amount' => $payment_amount,
        'paytr_token' => $paytr_token,
        'user_basket' => $user_basket,
        'debug_on' => $debug_on,
        'no_installment' => $no_installment,
        'max_installment' => $max_installment,
        'user_name' => $user_name,
        'user_address' => $user_address,
        'user_phone' => $user_phone,
        'merchant_ok_url' => $merchant_ok_url,
        'merchant_fail_url' => $merchant_fail_url,
        'timeout_limit' => $timeout_limit,
        'currency' => $currency,
        'test_mode' => $test_mode
    );
    
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, "https://www.paytr.com/odeme/api/get-token");
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $post_vals);
    curl_setopt($ch, CURLOPT_FRESH_CONNECT, true);
    curl_setopt($ch, CURLOPT_TIMEOUT, 20);
    
    $result = @curl_exec($ch);
    
    if (curl_errno($ch))
        die("PAYTR IFRAME connection error. err:" . curl_error($ch));
    
    curl_close($ch);
    
    $result = json_decode($result, 1);
    
    if ($result['status'] == 'success')
        $token = $result['token'];
    else
        die("PAYTR IFRAME failed. reason:" . $result['reason']);
?>
<div style="width: 100%;margin: 0 auto;display: table;">
    <script src="https://www.paytr.com/js/iframeResizer.min.js"></script>
    <iframe src="https://www.paytr.com/odeme/guvenli/<?php echo $token; ?>" id="paytriframe" frameborder="0"
            scrolling="no" style="width: 100%;"></iframe>
    <script>iFrameResize({}, '#paytriframe');</script>

</div>
