<?php if (isset($_GET['notification']) && ($_GET['ref'] == 'notifications')) {
    mark_notification_as_read($_GET['notification']);
} ?>

<div class="app-header header-shadow">
    <div class="app-header-logo">
        <img src="<?php echo systemPath(company(!empty(company_id()) ? company_id() : 1)->company_website_logo); ?>"
             alt="<?php echo company(!empty(company_id()) ? company_id() : 1)->company_name; ?>"/>
    </div>
    <div class="app-header-mobile-menu">
        <div>
            <button type="button" class="hamburger hamburger--elastic mobile-toggle-nav d-lg-none">
                        <span class="hamburger-box">
                            <span class="hamburger-inner"></span>
                        </span>
            </button>
        </div>
    </div>

    <div class="app-header-menu">
                <span>
                    <button type="button"
                            class="btn-icon btn-icon-only btn btn-primary btn-sm mobile-toggle-header-nav d-lg-none">
                        <span class="btn-icon-wrapper">
                            <i class="fa-solid fa-ellipsis-v fa-w-6"></i>
                        </span>
                    </button>
                </span>
    </div>
    <div class="app-header-content">
        <div class="app-header-left">
        </div>
        <div class="app-header-right">
            
            <?php if (isLoggedIn()) { ?>
                <ul class="header nav">
                    <li class="nav-item header-btn-lg pr-0">
                        <a href="<?php echo URLROOT; ?>"
                           target="_blank"
                           class="btn btn-outline-primary btn-sm"><?php echo label('view_website'); ?></a>
                    </li>
                    <li class="nav-item  header-btn-lg pr-0">
                        <form action="<?php echo URLROOT; ?>/packages/change_language" method="post"
                              autocomplete="on" enctype="multipart/form-data">
                            <select onchange="this.form.submit()" name="language">
                                <?php foreach (languages() as $default_language) { ?>
                                    <?php if (language_file($default_language->language_iso)) { ?>
                                        <option value="<?php echo $default_language->language_iso; ?>"
                                            <?php
                                                if (isset($_SESSION['language']) && $_SESSION['language'] == $default_language->language_iso) {
                                                    echo "selected";
                                                } elseif (!isset($_SESSION['language'])) {
                                                    $_SESSION['language'] = 'en';
                                                } ?>
                                        >
                                            <?php echo $default_language->language; ?>
                                        </option>
                                    <?php } ?>
                                <?php } ?>
                            </select>
                        </form>
                    </li>
                    <?php if(is_addon_activated('whatsapp_business_ai_chat') && !isSuperAdmin()){ ?>
                    <li class="nav-item header-btn-lg pr-0">
                        <button type="button" aria-haspopup="true" aria-expanded="false" data-bs-toggle="dropdown"
                                class="p-0 mr-2 btn btn-link text-primary">
                            <i class="fa-brands fa-whatsapp"></i><sup
                                    class="badge bg-danger"><?php echo count(getUnreadNotifications('whatsapp')); ?></sup>
                        </button>
                        <div tabindex="-1" role="menu" aria-hidden="true"
                             class="dropdown-menu-xl rm-pointers dropdown-menu dropdown-menu-right">
                            <ul class="nav flex-column">
                                <?php foreach (array_slice(getUnreadNotifications('whatsapp'), 0, 3) as $whatsapp) { ?>
                                    <li class="nav-item mx-3">
                                        <a href="<?php echo URLROOT . '/' . $whatsapp->link; ?>/?notification=<?php echo $whatsapp->notification_id; ?>&&ref=whatsapp">
                                            <?php echo shorten_string(label($whatsapp->notification_description), 25); ?>
                                            <br/>
                                            <span class="float-end fw-lighter text-muted text-sm"> <?php echo dateTimeFormat($whatsapp->notification_date_added); ?></span>
                                        </a>
                                    </li>
                                    <hr class="border-bottom"/>
                                <?php } ?>
                            </ul>
                            <ul class="nav flex-column">
                                <li class="nav-item-btn text-center nav-item">
                                    <a href="<?php echo URLROOT . '/whatsapps'; ?>"
                                       class="btn-shadow btn-wide btn-pill btn btn-focus btn-sm">
                                        <?php echo label('see_all_whatsapp_notifications'); ?>
                                    </a>
                                </li>
                            </ul>
                        </div>
                    </li>
                    <?php } ?>
                    <li class="nav-item header-btn-lg pr-0">
                        <button type="button" aria-haspopup="true" aria-expanded="false" data-bs-toggle="dropdown"
                                class="p-0 mr-2 btn btn-link text-danger">
                            <i class="fa-solid fa-triangle-exclamation"></i><sup
                                    class="badge bg-danger"><?php echo isSuperAdmin() ? count(view_custom_errors()) : custom_errors_count(user_id()); ?></sup>
                        </button>
                        <div tabindex="-1" role="menu" aria-hidden="true"
                             class="dropdown-menu-xl rm-pointers dropdown-menu dropdown-menu-right">
                            <ul class="nav flex-column">
                                <?php foreach (array_slice(view_custom_errors(), 0, 3) as $error) { ?>
                                    <li class="nav-item mx-3">
                                        <a href="<?php echo URLROOT . '/utilities/custom_errors'; ?>&&ref=notifications">
                                            <?php echo shorten_string(label($error->message), 25); ?>
                                            <br/>
                                            <span class="float-end fw-lighter text-muted text-sm"> <?php echo dateTimeFormat($error->date_added); ?></span>
                                        </a>
                                    </li>
                                    <hr class="border-bottom"/>
                                <?php } ?>
                            </ul>
                            <ul class="nav flex-column">
                                <li class="nav-item-btn text-center nav-item">
                                    <a href="<?php echo URLROOT . '/utilities/custom_errors'; ?>"
                                       class="btn-shadow w-100 btn-pill btn btn-focus btn-sm">
                                        <?php echo label('see_all_custom_errors'); ?>
                                    </a>
                                </li>
                            </ul>
                        </div>
                    </li>
                    <li class="nav-item header-btn-lg pr-0">
                        <button type="button" aria-haspopup="true" aria-expanded="false" data-bs-toggle="dropdown"
                                class="p-0 mr-2 btn btn-link text-primary">
                            <i class="fa-solid fa-bell"></i><sup
                                    class="badge bg-danger"><?php echo count(getUnreadNotifications()); ?></sup>
                        </button>
                        <div tabindex="-1" role="menu" aria-hidden="true"
                             class="dropdown-menu-xl rm-pointers dropdown-menu dropdown-menu-right">
                            <ul class="nav flex-column">
                                <?php foreach (array_slice(getUnreadNotifications(), 0, 3) as $notifications) { ?>
                                    <li class="nav-item mx-3">
                                        <a href="<?php echo URLROOT . '/' . $notifications->link; ?>/?notification=<?php echo $notifications->notification_id; ?>&&ref=notifications">
                                            <?php echo shorten_string(label($notifications->notification_description), 25); ?>
                                            <br/>
                                            <span class="float-end fw-lighter text-muted text-sm"> <?php echo dateTimeFormat($notifications->notification_date_added); ?></span>
                                        </a>
                                    </li>
                                    <hr class="border-bottom"/>
                                <?php } ?>
                            </ul>
                            <ul class="nav flex-column">
                                <li class="nav-item-btn text-center nav-item">
                                    <a href="<?php echo URLROOT . '/notifications'; ?>"
                                       class="btn-shadow btn-wide btn-pill btn btn-focus btn-sm">
                                        <?php echo label('see_all_notifications'); ?>
                                    </a>
                                </li>
                            </ul>
                        </div>
                    </li>
                </ul>
            <?php } ?>

            <div class="header-btn-lg pr-0">
                <div class="widget-content p-0">
                    <div class="widget-content-wrapper">
                        <div class="widget-content-left">
                            <div class="btn-group">
                                <a data-bs-toggle="dropdown" aria-haspopup="true" aria-expanded="false" class="p-0 btn">
                                    <?php if (isLoggedIn()) { ?>
                                        <img width="25" class="rounded-circle"
                                             src="<?php echo profilePath(user(user_id())->profile_image); ?>"
                                             alt="<?php echo user(user_id())->username; ?>"> <?php echo user(user_id())->username; ?>
                                    <?php } ?>

                                    <i class="fa fa-angle-down ml-2 opacity-8"></i>
                                </a>
                                <div tabindex="-1" role="menu" aria-hidden="true"
                                     class="rm-pointers dropdown-menu-lg dropdown-menu dropdown-menu-right">
                                    <div class="scroll-area-xs">
                                        <div class="scrollbar-container ps">
                                            <ul class="nav flex-column">
                                                <?php if (isSuperAdmin()) { ?>
                                                    <li class="nav-item">
                                                        <a href="<?php echo URLROOT; ?>/settings/company"
                                                           class="nav-link">
                                                            <?php echo label('company_profile'); ?>
                                                        </a>
                                                    </li>
                                                    <hr class="border-bottom"/>
                                                <?php } ?>
                                                <li class="nav-item">
                                                    <a href="<?php echo URLROOT; ?>/<?php if (isLoggedIn()) {
                                                        echo 'users';
                                                    } ?>/profile" class="nav-link">
                                                        <?php echo label('my_profile'); ?>
                                                    </a>
                                                </li>
                                                <hr class="border-bottom"/>
                                                <li class="nav-item">
                                                    <a href="<?php echo URLROOT; ?>/<?php if (isLoggedIn()) {
                                                        echo 'users';
                                                    } ?>/change_password" class="nav-link">
                                                        <?php echo label('change_password'); ?>
                                                    </a>
                                                </li>
                                                <hr class="border-bottom"/>
                                                <li class="nav-item">
                                                    <a href="<?php echo URLROOT; ?>/<?php if (isLoggedIn()) {
                                                        echo 'users';
                                                    } ?>/logout" class="nav-link">
                                                        <?php echo label('log_out'); ?>
                                                    </a>
                                                </li>
                                            </ul>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>