<?php $page = 'chat_links'; ?>
<?php require APPROOT . '/views/inc/header.php'; ?>
<?php echo card_div(); ?>
<div class="row">
    <div class="col-md-12">
        <button class="btn btn-primary float-end mb-3" data-bs-toggle="modal" data-bs-target="#add_link">
            <?php echo label('add_link'); ?>
        </button>
    </div>
</div>
<?php if (!empty($data['chat_links'])) { ?>
    <?php $rows = start_paging($data['chat_links']); ?>
    <table class="table table-striped table-hover">
        <thead>
        <tr>
            <th><?php echo label('link'); ?></th>
            <th><?php echo label('status'); ?></th>
            <th><?php echo label('size'); ?></th>
            <th><?php echo label('date_created'); ?></th>
            <th></th>
        </tr>
        </thead>
        <tbody>
        <?php foreach ($rows as $link) { ?>
            <tr>
                <td><?php echo n_link('links', 'show', $link->chat_file_id, $link->chat_link, NULL, 'remove_image'); ?></td>
                <td><?php echo $link->chat_file_output_status; ?></td>
                <td><?php echo customFileSize($link->chat_file_size); ?></td>
                <td><?php echo dateTimeFormat($link->chat_file_date_added); ?></td>
                <td class="text-end">
                    <?php echo fa_link('links', 'upload_for_chat', $link->chat_file_id, 'cloud-arrow-up'); ?>
                    <?php echo fa_link('links', 'delete', $link->chat_file_id, 'times'); ?>
                </td>
            </tr>
        <?php } ?>
        </tbody>
    </table>
    <?php echo close_paging($data['chat_links']); ?>
<?php } else {
    echo no_records($page);
} ?>
<?php require APPROOT . '/views/inc/footer.php'; ?>

<div class="modal" id="add_link" tabindex="-1">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-body">
                <form action="<?php echo URLROOT; ?>/links/submit"
                      method="post" autocomplete="off" enctype="multipart/form-data">
                    <div class="row">
                        <div class="col-md-12">
                            <div class="form-group mb-3">
                                <label><?php echo label('chat_link'); ?></label>
                                <input type="url" id="chat_link" name="chat_link"
                                       class="form-control" value="https://" required/>
                            </div>
                            <div class="form-group mb-3">
                                <button class="btn btn-primary btn-wide float-end" type="submit">
                                    <?php echo label('add_chat_link'); ?>
                                </button>
                            </div>
                        </div>
                    </div>
                </form>
            </div>
        </div>
    </div>
</div>