<?php $page = 'sitemaps'; ?>
<?php require APPROOT . '/views/inc/header.php'; ?>
<?php echo card_div(); ?>
<div class="row">
    <div class="col-md-12">
        <button class="btn btn-primary float-end mb-3 mx-3" data-bs-toggle="modal" data-bs-target="#add_link">
            <?php echo label('add_sitemap'); ?>
        </button>
        <button class="btn btn-primary float-end mb-3 mx-3" data-bs-toggle="modal" data-bs-target="#upload_sitemap">
            <?php echo label('upload_sitemap'); ?>
        </button>
    </div>
</div>
<?php if (!empty($data['sitemaps'])) { ?>
    <?php $rows = start_paging($data['sitemaps']); ?>
    <table class="table table-striped table-hover">
        <thead>
        <tr>
            <th><?php echo label('sitemap'); ?></th>
            <th><?php echo label('links'); ?></th>
            <th><?php echo label('date_created'); ?></th>
            <th></th>
        </tr>
        </thead>
        <tbody>
        <?php foreach ($rows as $link) { ?>
            <tr>
                <td><?php echo n_link('links', 'sitemap', $link->chat_file_id, $link->chat_link, NULL, 'remove_image'); ?></td>
                <td><?php echo count(sitemap_links($link->chat_file_id)); ?></td>
                <td><?php echo dateTimeFormat($link->chat_file_date_added); ?></td>
                <td class="text-end">
                    <?php echo fa_link('links', 'delete_sitemap', $link->chat_file_id, 'times'); ?>
                </td>
            </tr>
        <?php } ?>
        </tbody>
    </table>
    <?php echo close_paging($data['sitemaps']); ?>
<?php } else {
    echo no_records($page);
} ?>
<?php require APPROOT . '/views/inc/footer.php'; ?>

<div class="modal" id="add_link" tabindex="-1">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-body">
                <form action="<?php echo URLROOT; ?>/links/add_sitemap"
                      method="post" autocomplete="off" enctype="multipart/form-data">
                    <div class="row">
                        <div class="col-md-12">
                            <div class="form-group mb-3">
                                <label><?php echo label('chat_link'); ?></label>
                                <input type="url" id="chat_link" name="chat_link"
                                       class="form-control" value="https://" required/>
                            </div>
                            <div class="form-group mb-3">
                                <button class="btn btn-primary btn-wide float-end" type="submit">
                                    <?php echo label('add_chat_sitemap'); ?>
                                </button>
                            </div>
                        </div>
                    </div>
                </form>
            </div>
        </div>
    </div>
</div>

<div class="modal" id="upload_sitemap" tabindex="-1">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-body">
                <form class="dropzone rounded-3 mb-3"></form>
                <button class="btn btn-primary float-end upload_file" id="upload_file"
                        type="submit">
                    <?php echo label('upload_sitemap'); ?>
                </button>
            </div>
        </div>
    </div>
</div>
<script>
    //Disabling autoDiscover
    Dropzone.autoDiscover = false;

    $(function () {
        //Dropzone class
        var myDropzone = new Dropzone(".dropzone", {
            url: "<?php echo URLROOT; ?>/links/upload_sitemap",
            paramName: "file",
            //maxFilesize: 512,
            maxFiles: 1,
            acceptedFiles: ".xml",
            autoProcessQueue: false,
            init: function () {
                this.on("success", function (file, response) {
                    var obj = jQuery.parseJSON(response);
                    let out_status;
                    if (obj.status === true) {
						out_status = 'success';
					} else {
						out_status = 'danger';
					}
                    $('.flash_message').html('<div class="fw-bold alert alert-' + out_status + '">' + obj.message + '</div>');
                    $("#upload_sitemap").modal('hide');
                })
            }
        });

        $('#upload_file').click(function () {
            myDropzone.processQueue();
        });
    });
</script>