<?php $page = 'add_package'; ?>
<?php require APPROOT . '/views/inc/header.php'; ?>
<?php echo card_div(); ?>
<form action="<?php echo URLROOT; ?>/packages/add" method="post" autocomplete="off"
      enctype="multipart/form-data">
    <div class="row">
        <div class="col-md-8">
            <div class="card mb-3">
                <div class="card-body">
                    <div class="form-group mb-3">
                        <label class="form-label"><?php echo label('package_name'); ?> <span
                                    class="symbol required"></span></label>
                        <input type="text"
                               class="form-control" name="package_name" required>
                    </div>
                    <div class="form-group mb-3">
                        <label><?php echo label('number_of_chat_assistants'); ?>
                            <a href="#" title="<?php echo label('description'); ?>"
                               data-bs-toggle="popover" data-bs-trigger="hover"
                               data-bs-content="<?php echo label('enter_-1_for_unlimited_number_of_chat_assistants_in_the_package'); ?>">
                                <i class="fa-solid fa-question"></i></a>
                        </label>
                        <div class="input-group">
                            <input type="number" id="package_chat_assistants" name="package_chat_assistants"
                                   class="form-control" min="-1"/>
                            <span class="input-group-text"><?php echo label('chat_assistants'); ?></span>
                        </div>
                    </div>
                    <div class="form-group mb-3">
                        <label><?php echo label('number_of_trained_models'); ?>
                            <a href="#" title="<?php echo label('description'); ?>"
                               data-bs-toggle="popover" data-bs-trigger="hover"
                               data-bs-content="<?php echo label('enter_-1_for_unlimited_number_of_trained_models_in_the_package'); ?>">
                                <i class="fa-solid fa-question"></i></a>
                        </label>
                        <div class="input-group">
                            <input type="number" id="package_trained_models" name="package_trained_models"
                                   class="form-control" min="-1"/>
                            <span class="input-group-text"><?php echo label('trained_models'); ?></span>
                        </div>
                    </div>
                    <div class="form-group mb-3">
                        <label><?php echo label('number_of_chat_files'); ?>
                            <a href="#" title="<?php echo label('description'); ?>"
                               data-bs-toggle="popover" data-bs-trigger="hover"
                               data-bs-content="<?php echo label('enter_-1_for_unlimited_number_of_chat_files_in_the_package'); ?>">
                                <i class="fa-solid fa-question"></i></a>
                        </label>
                        <div class="input-group">
                            <input type="number" id="package_chat_files" name="package_chat_files"
                                   class="form-control" min="-1"/>
                            <span class="input-group-text"><?php echo label('chat_files'); ?></span>
                        </div>
                    </div>
                    <div class="form-group mb-3">
                        <label><?php echo label('number_of_chat_links'); ?>
                            <a href="#" title="<?php echo label('description'); ?>"
                               data-bs-toggle="popover" data-bs-trigger="hover"
                               data-bs-content="<?php echo label('enter_-1_for_unlimited_number_of_chat_links_in_the_package'); ?>">
                                <i class="fa-solid fa-question"></i></a>
                        </label>
                        <div class="input-group">
                            <input type="number" id="package_chat_links" name="package_chat_links"
                                   class="form-control" min="-1"/>
                            <span class="input-group-text"><?php echo label('chat_links'); ?></span>
                        </div>
                    </div>
                    <div class="form-group mb-3">
                        <label><?php echo label('number_of_chat_sitemaps'); ?>
                            <a href="#" title="<?php echo label('description'); ?>"
                               data-bs-toggle="popover" data-bs-trigger="hover"
                               data-bs-content="<?php echo label('enter_-1_for_unlimited_number_of_chat_sitemaps_in_the_package'); ?>">
                                <i class="fa-solid fa-question"></i></a>
                        </label>
                        <div class="input-group">
                            <input type="number" id="package_chat_sitemaps" name="package_chat_sitemaps"
                                   class="form-control" min="-1"/>
                            <span class="input-group-text"><?php echo label('chat_sitemaps'); ?></span>
                        </div>
                    </div>
                    <div class="form-group mb-3">
                        <label><?php echo label('number_of_words'); ?>
                            <a href="#" title="<?php echo label('description'); ?>"
                               data-bs-toggle="popover" data-bs-trigger="hover"
                               data-bs-content="<?php echo label('enter_-1_for_unlimited_number_of_words_in_the_package'); ?>">
                                <i class="fa-solid fa-question"></i></a>
                        </label>
                        <div class="input-group">
                            <input type="number" id="package_words" name="package_words" class="form-control" min="-1"/>
                            <span class="input-group-text"><?php echo label('words'); ?></span>
                        </div>
                    </div>
                    <div class="form-group mb-3">
                        <label class="form-check-label"
                               for="accept_custom_branding"> <?php echo label('accept_custom_branding'); ?>
                            <a href="#" title="<?php echo label('description'); ?>"
                               data-bs-toggle="popover" data-bs-trigger="hover"
                               data-bs-content="<?php echo label('remove_customize_branding_on_the_widget_and_emailing_chat_transcripts'); ?>">
                                <i class="fa-solid fa-question"></i></a>
                        </label>
                        <div class="form-check form-switch fs-5">
                            <input class="form-check-input" type="checkbox" id="accept_custom_branding"
                                   name="accept_custom_branding"
                                   value="1">
                        </div>
                    </div>
                    <div class="form-group mb-3">
                        <label class="form-check-label"
                               for="is_free_trial"> <?php echo label('is_free_trial'); ?>
                        </label>
                        <div class="form-check form-switch fs-5">
                            <input class="form-check-input" type="checkbox" id="is_free_trial"
                                   name="is_free_trial"
                                   value="1">
                        </div>
                    </div>
                    <div class="form-group mb-3">
                        <label class="form-check-label"
                               for="is_private"> <?php echo label('is_private'); ?>
                        </label>
                        <div class="form-check form-switch fs-5">
                            <input class="form-check-input" type="checkbox" id="is_private"
                                   name="is_private"
                                   value="1">
                        </div>
                    </div>
                    <div class="form-group mb-3">
                        <label><?php echo label('package_monthly_cost'); ?></label>
                        <div class="input-group">
                            <span class="input-group-text"><?php echo useCurrency(); ?></span>
                            <input type="text" id="package_monthly_cost" name="package_monthly_cost" class="form-control" required/>
                            <span class="input-group-text"><?php echo label('per_month'); ?></span>
                        </div>
                    </div>
                    <div class="form-group mb-3">
                        <label><?php echo label('package_yearly_cost'); ?></label>
                        <div class="input-group">
                            <span class="input-group-text"><?php echo useCurrency(); ?></span>
                            <input type="text" id="package_yearly_cost" name="package_yearly_cost" class="form-control" required/>
                            <span class="input-group-text"><?php echo label('per_year'); ?></span>
                        </div>
                    </div>
                    <div class="form-group mb-3">
                        <label><?php echo label('package_lifetime_cost'); ?></label>
                        <div class="input-group">
                            <span class="input-group-text"><?php echo useCurrency(); ?></span>
                            <input type="text" id="package_lifetime_cost" name="package_lifetime_cost" class="form-control" required/>
                            <span class="input-group-text"><?php echo label('per_lifetime'); ?></span>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="col-md-4">
            <div class="card mb-3">
                <div class="card-header"><?php echo label('features'); ?></div>
                <div class="card-body">
                    <table class="table table-striped table-hover">
                        <?php foreach (package_features() as $feature) { ?>
                            <tr>
                                <td>
                                    <div class="form-check form-switch">
                                        <input class="form-check-input" type="checkbox"
                                               id="add_feature<?php echo $feature->package_feature_id; ?>"
                                               name="features[]" value="<?php echo $feature->package_feature_id; ?>">
                                        <label class="form-check-label"
                                               for="<?php echo $feature->package_feature_id; ?>"><span
                                                    class="message_box<?php echo $feature->package_feature_id; ?>"></span> <?php echo $feature->package_feature_description; ?>
                                        </label>
                                    </div>
                                </td>
                            </tr>
                        <?php } ?>
                    </table>
                </div>
            </div>
        </div>
    </div>
    <div class="form-group mb-3">
        <button class="btn btn-primary btn-wide float-end" type="submit">
            <?php echo label('add_package'); ?>
        </button>
    </div>
</form>
<?php require APPROOT . '/views/inc/footer.php'; ?>
<script>
    var popoverTriggerList = [].slice.call(document.querySelectorAll('[data-bs-toggle="popover"]'))
    var popoverList = popoverTriggerList.map(function (popoverTriggerEl) {
        return new bootstrap.Popover(popoverTriggerEl)
    })
</script>