<?php $page = 'packages'; ?>
<?php require APPROOT . '/views/inc/header.php'; ?>
<?php echo card_div(); ?>
<?php if (!empty($data['packages'])) { ?>
    <?php $rows = start_paging($data['packages']); ?>
    <table class="table table-striped table-hover ">
        <thead>
        <tr>
            <th><?php echo label('package'); ?></th>
            <th><?php echo label('chat_assistants'); ?> | <?php echo label('trained_models'); ?>
                | <?php echo label('chat_files'); ?> | <?php echo label('chat_links'); ?>
                | <?php echo label('chat_sitemaps'); ?> | <?php echo label('words'); ?></th>
            <th><?php echo label('accept_custom_branding'); ?></th>
            <th><?php echo label('duration'); ?></th>
            <th><?php echo label('cost'); ?></th>
            <th></th>
        </tr>
        </thead>
        <tbody>
        <?php foreach ($rows as $package) { ?>
            <tr>
                <td><?php echo n_link('packages', 'show', $package->package_id, $package->package_name); ?></td>
                <td>
                    <?php echo ($package->package_chat_assistants == -1) ? label('unlimited') : number_format($package->package_chat_assistants); ?>
                    |
                    <?php echo ($package->package_trained_models == -1) ? label('unlimited') : number_format($package->package_trained_models); ?>
                    |
                    <?php echo ($package->package_chat_files == -1) ? label('unlimited') : number_format($package->package_chat_files); ?>
                    |
                    <?php echo ($package->package_chat_links == -1) ? label('unlimited') : number_format($package->package_chat_links); ?>
                    |
                    <?php echo ($package->package_chat_sitemaps == -1) ? label('unlimited') : number_format($package->package_chat_sitemaps); ?>
                    |
                    <?php echo ($package->package_words == -1) ? label('unlimited') : number_format($package->package_words); ?></td>
                <td><?php echo yes_no_label($package->accept_custom_branding); ?></td>
                <td><?php echo package_duration_name($package->package_id); ?></td>
                <td><?php echo package_cost_name($package->package_id); ?></td>
                <td align="right">
                    <?php if ($package->package_featured == 1) {
                        echo fa_link('packages', 'make_package_not_featured', $package->package_id, 'check-circle');
                    } else {
                        echo fa_link('packages', 'make_package_featured', $package->package_id, 'circle');
                    }
                    ?>
                    <?php echo fa_link('packages', 'edit', $package->package_id, 'pencil'); ?>
                    <?php echo fa_link('packages', 'delete', $package->package_id, 'times'); ?>
                </td>
            </tr>
        <?php } ?>
        </tbody>
    </table>
    <?php echo close_paging($data['packages']); ?>
<?php } else {
    echo no_records(strtolower(page_title()));
} ?>
<?php require APPROOT . '/views/inc/footer.php'; ?>
