<?php $page = 'payment_method'; ?>
<?php require APPROOT . '/views/inc/header.php'; ?>
<?php echo card_div(); ?>
<div class="row">
		<div class="col-md-12">
			<?php if(has_valid_subscription(user_id())){ ?>
	            <div class="alert alert-danger mb-3 fw-bold">
					<?php echo label('you_currently_have_an_active_subscription_which_expires') . ' : ' . dateTimeFormat(has_valid_subscription(user_id())->subscription_end_date); ?>
				</div>
			<?php } ?>
	    <div class="card mb-3">
	        <div class="card-body">
	            <?php echo label('amount_to_pay') . ' : '; ?>
	            <?php if (package_cost($data['package_id'], $data['package_group']) < getOption('minimum_payment_acceptable')) { ?>
	                <span class="help-inline">
								<a href="javascript:void(0)"
	                               data-content="<?php echo label('minimum_payment_acceptable_description'); ?>"
	                               data-title="<?php echo label('rounded_off_payment_amount'); ?>" data-placement="top"
	                               data-toggle="popover" data-original-title="" title="">
									<i class="fa-solid fa-help text-large text-primary"></i>
								</a>
							</span>
	            <?php } ?>
	            <?php if (package_cost($data['package_id'], $data['package_group']) < getOption('minimum_payment_acceptable')) { ?><span
	                    class="text-muted text-decoration-line-through"><?php echo bold_currency_format(package_cost($data['package_id'], $data['package_group'])); ?></span> <?php } ?>
	            <?php echo bold_currency_format(str_replace(',','',minimum_payment_acceptable(package_cost($data['package_id'], $data['package_group'])))); ?>
	            <span class="fw-bold float-end">
		                <?php echo package($data['package_id'])->package_name; ?> (
		                <?php echo label('from'); ?> <?php echo dateFormat(today()); ?> <?php echo label('to'); ?> <?php echo dateFormat(date("Y-m-d", strtotime('+' . (package_duration($data['package_id'], $data['package_group'])[0].' '.package_duration($data['package_id'], $data['package_group'])[1])))); ?>
		                )
	                </span>
	        </div>
	    </div>
	</div>
</div>
<div class="row">
    <div class="col-md-6">
        <div class="card mb-3">
            <div class="card-header"><?php echo label('payment_method'); ?></div>
            <div class="card-body">
                <form name="payment_method" id="payment_method"
                      action="<?php echo URLROOT; ?>/packages/choosen/<?php echo $data['package_id']; ?>"
                      method="post"
                      autocomplete="off"
                      enctype="multipart/form-data">
                    <div class="card-body">
                        <?php foreach (payment_options() as $payment_option) {
                            if (payment_option_slug($payment_option->payment_option)->payment_option_online) {
                                $isPaymentGatewayActive = isPaymentGatewayActive($payment_option->payment_option . '_live_enabled');
                                $accepted_currencies_array = !empty(payment_option_slug($payment_option->payment_option)->payment_option_currencies) ? array_map('trim', explode(',', payment_option_slug($payment_option->payment_option)->payment_option_currencies)) : array(getOption('default_currency'));
                                $landing = $payment_option->payment_option . '.php';
                            } elseif (!payment_option_slug($payment_option->payment_option)->payment_option_online || $payment_option->payment_option == 'free-trial') {
                                $isPaymentGatewayActive = payment_option_slug($payment_option->payment_option)->payment_option_status_id;
                                $accepted_currencies_array = array(getOption('default_currency'));
                                $landing = 'cash_on_delivery.php';
                            }
                            $accepted_currencies = "accepted_" . $payment_option->payment_option . "_currencies";
                            if (in_array(getOption('default_currency'), $accepted_currencies_array)) { ?>
                                <?php if (!$isPaymentGatewayActive && package_cost($data['package_id'], $data['package_group']) == 0 && $payment_option->payment_option == 'free-trial') { ?>
                                    <div class="form-check mb-3">
                                        <input class="form-check-input package_gateway"
                                               id="<?php echo $payment_option->payment_option; ?>"
                                               name="payment_option"
                                               value="<?php echo $payment_option->payment_option; ?>" type="radio"
                                               required>
                                        <label for="<?php echo $payment_option->payment_option; ?>"><?php echo $payment_option->payment_option_name; ?></label>
                                    </div>
                                <?php } elseif ($isPaymentGatewayActive && package_cost($data['package_id'], $data['package_group']) > 0 && $payment_option->payment_option != 'free-trial') { ?>
                                    <div class="form-check mb-3">
                                        <input class="form-check-input package_gateway"
                                               id="<?php echo $payment_option->payment_option; ?>"
                                               name="payment_option"
                                               value="<?php echo $payment_option->payment_option; ?>" type="radio"
                                               required>
                                        <label for="<?php echo $payment_option->payment_option; ?>"><?php echo $payment_option->payment_option_name; ?></label>
                                    </div>
                                <?php } ?>
                            <?php } ?>
                        <?php } ?>
                        <input type="hidden" class="form-control" id="package_id" name="package_id"
                               value="<?php echo $data['package_id']; ?>">
                    </div>
                </form>
            </div>
        </div>
    </div>
    <div class="col-md-6">
        <div class="card mb-3">
            <div class="card-header"><?php echo label('payment_details'); ?></div>
            <div class="card-body">
                	<span class="payment_details">
                		
                	</span>
            </div>
        </div>
    </div>
</div>
<?php require APPROOT . '/views/inc/footer.php'; ?>
<script>
    $(document).ready(function () {
        var delay = 20;
        $('.package_gateway').click(function (e) {
            e.preventDefault();

            var payment_option = $('input[name="payment_option"]:checked').val();
            var package_id = <?php echo $data['package_id'] ?>;
            var package_group = "<?php echo $data['package_group'] ?>";

                $.ajax
                ({
                    beforeSend: function () {
                        $('.payment_details').html('<span class="spinner-border spinner-border-sm" role="status" aria-hidden="true"></span> <span class="fs-5 ps-2"><?php echo label('processing'); ?>...</span>');

                    },
                    success: function (data) {
                        setTimeout(function () {
                            $('.payment_details').load('<?php echo URLROOT . "/packages/choosen/"; ?>' + package_id, {
                                subscription_uid: "<?php echo uid(); ?>",
                                payment_option: payment_option,
                                package_id: package_id,
                                package_group: package_group
                            });
                        }, delay);
                        $('#' + payment_option).prop("checked", true);
                    }
                });
        });
    });
</script>

<script src="https://cdn.paddle.com/paddle/v2/paddle.js"></script>

<script src="https://js.stripe.com/v3/"></script>