<?php $page = 'edit_package'; ?>
<?php require APPROOT . '/views/inc/header.php'; ?>
<?php require 'package_nav.php'; ?>
<div class="col-md-12">
    <div class="card mb-3">
        <form action="<?php echo URLROOT; ?>/packages/edit/<?php echo $data['package']->package_id; ?>" method="post"
              autocomplete="off" enctype="multipart/form-data">
            <div class="card-body">
                <div class="form-group mb-3">
                    <label><?php echo label('package_name'); ?></label>
                    <input type="text" id="package_name" name="package_name"
                           value="<?php echo $data['package']->package_name; ?>" class="form-control" required/>
                </div>
                <?php if($data['package']->package_duration){ ?>
                    <div class="form-group mb-3">
                        <label><?php echo label('package_duration'); ?></label>
                        <input type="text" id="package_duration" name="package_duration"
                            value="<?php echo $data['package']->package_duration; ?>" class="form-control" required/>
                    </div>
                    <div class="form-group mb-3">
                        <label><?php echo label('package_duration_type'); ?></label>
                        <select data-show-subtext="true" data-live-search="true"
                                class="form-control <?php echo selectpicker(); ?>"
                                id="duration_type" name="package_duration_type"
                                data-container="body"
                                required>
                            <option value=""></option>
                            <?php foreach (duration_types() as $duration_type) { ?>
                                <option value="<?php echo $duration_type->duration_type_name; ?>" <?php if ($duration_type->duration_type_name == 'months') {
                                    echo "selected";
                                } ?>><?php echo label($duration_type->duration_type_name); ?></option>
                            <?php } ?>
                        </select>
                    </div>
                <?php } ?>
                <div class="form-group mb-3">
                    <label><?php echo label('number_of_chat_assistants'); ?></label>
                    <a href="#" title="<?php echo label('description'); ?>"
                       data-bs-toggle="popover" data-bs-trigger="hover"
                       data-bs-content="<?php echo label('enter_-1_for_unlimited_number_of_chat_assistants_in_the_package'); ?>">
                        <i class="fa-solid fa-question"></i></a>
                    <div class="input-group">
                        <input type="number" id="package_chat_assistants" name="package_chat_assistants"
                               value="<?php echo $data['package']->package_chat_assistants; ?>" class="form-control"
                               min="-1"/>
                        <span class="input-group-text"><?php echo label('chat_assistants'); ?></span>
                    </div>
                </div>
                <div class="form-group mb-3">
                    <label><?php echo label('number_of_trained_models'); ?>
                        <a href="#" title="<?php echo label('description'); ?>"
                           data-bs-toggle="popover" data-bs-trigger="hover"
                           data-bs-content="<?php echo label('enter_-1_for_unlimited_number_of_trained_models_in_the_package'); ?>">
                            <i class="fa-solid fa-question"></i></a>
                    </label>
                    <div class="input-group">
                        <input type="number" id="package_trained_models" name="package_trained_models"
                               value="<?php echo $data['package']->package_trained_models; ?>" class="form-control"
                               min="-1"/>
                        <span class="input-group-text"><?php echo label('trained_models'); ?></span>
                    </div>
                </div>
                <div class="form-group mb-3">
                    <label><?php echo label('number_of_chat_files'); ?>
                        <a href="#" title="<?php echo label('description'); ?>"
                           data-bs-toggle="popover" data-bs-trigger="hover"
                           data-bs-content="<?php echo label('enter_-1_for_unlimited_number_of_chat_files_in_the_package'); ?>">
                            <i class="fa-solid fa-question"></i></a>
                    </label>
                    <div class="input-group">
                        <input type="number" id="package_chat_files" name="package_chat_files"
                               value="<?php echo $data['package']->package_chat_files; ?>" class="form-control"
                               min="-1"/>
                        <span class="input-group-text"><?php echo label('chat_files'); ?></span>
                    </div>
                </div>
                <div class="form-group mb-3">
                    <label><?php echo label('number_of_chat_links'); ?>
                        <a href="#" title="<?php echo label('description'); ?>"
                           data-bs-toggle="popover" data-bs-trigger="hover"
                           data-bs-content="<?php echo label('enter_-1_for_unlimited_number_of_chat_links_in_the_package'); ?>">
                            <i class="fa-solid fa-question"></i></a>
                    </label>
                    <div class="input-group">
                        <input type="number" id="package_chat_links" name="package_chat_links"
                               value="<?php echo $data['package']->package_chat_links; ?>" class="form-control"
                               min="-1"/>
                        <span class="input-group-text"><?php echo label('chat_links'); ?></span>
                    </div>
                </div>
                <div class="form-group mb-3">
                    <label><?php echo label('number_of_chat_sitemaps'); ?>
                        <a href="#" title="<?php echo label('description'); ?>"
                           data-bs-toggle="popover" data-bs-trigger="hover"
                           data-bs-content="<?php echo label('enter_-1_for_unlimited_number_of_chat_sitemaps_in_the_package'); ?>">
                            <i class="fa-solid fa-question"></i></a>
                    </label>
                    <div class="input-group">
                        <input type="number" id="package_chat_sitemaps" name="package_chat_sitemaps"
                               value="<?php echo $data['package']->package_chat_sitemaps; ?>" class="form-control"
                               min="-1"/>
                        <span class="input-group-text"><?php echo label('chat_sitemaps'); ?></span>
                    </div>
                </div>
                <div class="form-group mb-3">
                    <label><?php echo label('number_of_words'); ?>
                        <a href="#" title="<?php echo label('description'); ?>"
                           data-bs-toggle="popover" data-bs-trigger="hover"
                           data-bs-content="<?php echo label('enter_-1_for_unlimited_number_of_words_in_the_package'); ?>">
                            <i class="fa-solid fa-question"></i></a>
                    </label>
                    <div class="input-group">
                        <input type="number" id="package_words" name="package_words"
                               value="<?php echo $data['package']->package_words; ?>" class="form-control" min="-1"/>
                        <span class="input-group-text"><?php echo label('words'); ?></span>
                    </div>
                </div>
                <div class="form-group mb-3">
                    <label class="form-check-label"
                           for="accept_custom_branding"> <?php echo label('accept_custom_branding'); ?></label>
                    <div class="form-check form-switch fs-5">
                        <input class="form-check-input" type="checkbox" id="accept_custom_branding"
                               name="accept_custom_branding"
                               value="1" <?php echo !empty($data['package']->accept_custom_branding) ? 'checked' : ''; ?>>
                    </div>
                </div>
                <div class="form-group mb-3">
                    <label class="form-check-label"
                            for="is_free_trial"> <?php echo label('is_free_trial'); ?>
                    </label>
                    <div class="form-check form-switch fs-5">
                        <input class="form-check-input" type="checkbox" id="is_free_trial"
                                name="is_free_trial"
                                value="1" <?php echo !empty($data['package']->is_free_trial) ? 'checked' : ''; ?>>
                    </div>
                </div>
                <div class="form-group mb-3">
                    <label class="form-check-label"
                            for="is_private"> <?php echo label('is_private'); ?>
                    </label>
                    <div class="form-check form-switch fs-5">
                        <input class="form-check-input" type="checkbox" id="is_private"
                                name="is_private"
                                value="1" <?php echo !empty($data['package']->is_private) ? 'checked' : ''; ?>>
                    </div>
                </div>
                <?php if($data['package']->package_duration){ ?>
                <div class="form-group mb-3">
                    <label><?php echo label('cost'); ?></label>
                    <div class="input-group">
                        <span class="input-group-text"><?php echo useCurrency(); ?></span>
                        <input type="text" id="package_cost" name="package_cost"
                               value="<?php echo $data['package']->package_cost; ?>" class="form-control" required/>
                    </div>
                </div>
                <?php }else{ ?>
                    <div class="form-group mb-3">
                        <label><?php echo label('package_monthly_cost'); ?></label>
                        <div class="input-group">
                            <span class="input-group-text"><?php echo useCurrency(); ?></span>
                            <input type="text" id="package_monthly_cost" name="package_monthly_cost" value="<?php echo $data['package']->package_monthly_cost; ?>" class="form-control" required/>
                            <span class="input-group-text"><?php echo label('per_month'); ?></span>
                        </div>
                    </div>
                    <div class="form-group mb-3">
                        <label><?php echo label('package_yearly_cost'); ?></label>
                        <div class="input-group">
                            <span class="input-group-text"><?php echo useCurrency(); ?></span>
                            <input type="text" id="package_yearly_cost" name="package_yearly_cost" value="<?php echo $data['package']->package_yearly_cost; ?>" class="form-control" required/>
                            <span class="input-group-text"><?php echo label('per_year'); ?></span>
                        </div>
                    </div>
                    <div class="form-group mb-3">
                        <label><?php echo label('package_lifetime_cost'); ?></label>
                        <div class="input-group">
                            <span class="input-group-text"><?php echo useCurrency(); ?></span>
                            <input type="text" id="package_lifetime_cost" name="package_lifetime_cost" value="<?php echo $data['package']->package_lifetime_cost; ?>" class="form-control" required/>
                            <span class="input-group-text"><?php echo label('per_lifetime'); ?></span>
                        </div>
                    </div>
                <?php } ?>
                <div class="form-group mb-3">
                    <button class="btn btn-primary btn-wide float-end mb-3" type="submit">
                        <?php echo label('update_package'); ?>
                    </button>
                </div>
            </div>
        </form>
    </div>
</div>
<?php require APPROOT . '/views/inc/footer.php'; ?>
<script>
    var popoverTriggerList = [].slice.call(document.querySelectorAll('[data-bs-toggle="popover"]'))
    var popoverList = popoverTriggerList.map(function (popoverTriggerEl) {
        return new bootstrap.Popover(popoverTriggerEl)
    })
</script>