<?php $page = 'package_features'; ?>
<?php require APPROOT . '/views/inc/header.php'; ?>
<?php echo card_div(); ?>
<button class="btn btn-primary float-end mb-3" data-bs-toggle="modal" data-bs-target="#add_feature">
    <?php echo label('add_feature'); ?>
</button>
<?php if (!empty($data['package_features'])) { ?>
    <?php $rows = start_paging($data['package_features']); ?>

    <div class="card mb-3">
        <div class="card-body">
            <table class="table table-striped table-hover ">
                <thead>
                <tr>
                    <th><?php echo label('description'); ?></th>
                    <th></th>
                </tr>
                </thead>
                <tbody>
                <?php foreach ($rows as $feature) { ?>
                    <tr>
                        <td><?php echo $feature->package_feature_description; ?></td>
                        <td class="text-end">
                            <a href="#" class="" data-bs-toggle="modal" data-bs-target="#edit_feature"
                               onclick="edit_feature(<?php echo $feature->package_feature_id; ?>)"><i
                                        class="fa-solid fa-pencil"></i></a>
                            <?php echo fa_link('packages', 'delete_feature', $feature->package_feature_id, 'times'); ?>
                        </td>
                    </tr>
                <?php } ?>
                </tbody>
            </table>
        </div>
    </div>
    <?php echo close_paging($data['package_features']); ?>
<?php } else {
    echo no_records('package_features');
} ?>
<?php require APPROOT . '/views/inc/footer.php'; ?>
<div class="modal" id="add_feature" tabindex="-1">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-body">
                <form action="<?php echo URLROOT; ?>/packages/add_feature"
                      method="post" autocomplete="off" enctype="multipart/form-data">
                    <div class="row">
                        <div class="col-md-12">
                            <div class="form-group mb-3">
                                <label><?php echo label('package_feature'); ?></label>
                                <input type="text" id="package_feature_description" name="package_feature_description"
                                       class="form-control" required/>
                            </div>
                            <div class="form-group mb-3">
                                <button class="btn btn-primary btn-wide float-end" type="submit">
                                    <?php echo label('add_package_feature'); ?>
                                </button>
                            </div>
                        </div>
                    </div>
                </form>
            </div>
        </div>
    </div>
</div>
<div class="modal" id="edit_feature" tabindex="-1">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-body"></div>
        </div>
    </div>
</div>

<script>

    function edit_feature(id) {
        $('.modal-body').load('<?php echo URLROOT; ?>/packages/edit_feature/' + id, function () {
            $('#edit_feature').modal({show: true});
        });
    }
</script>