<?php $page = 'packages'; ?>
<?php require APPROOT . '/views/inc/header.php'; ?>
<?php echo card_div(); ?>
<?php if (!empty($data['packages'])) { ?>
<ul class="nav nav-tabs nav-justified">
                            <?php foreach (package_groups() as $key => $group) { ?>
                                    <li class="nav-item">
                                        <button class="nav-link <?php if ($key == 'months') {
                                            echo "active";
                                        } ?>" data-bs-toggle="tab"
                                                data-bs-target="#<?php echo $group; ?>"><span><?php echo label($group); ?> <?php if ($key == 'years') { echo !empty(highest_package_discount_percentage() && highest_package_discount_percentage()>0) ? '<span class="badge rounded-pill text-bg-danger">'.label('upto').' '.highest_package_discount_percentage().'% '.label('off').'</span>' : NULL; } ?></span>
                                        </button>
                                    </li>
                                <?php } ?>
                        </ul>
                    <div class="tab-content">
                        <?php foreach (package_groups() as $key => $group) { ?>
                            <div class="tab-pane fade <?php if ($key == 'months') {
                                echo "show active";
                            } ?>" id="<?php echo $group; ?>" tabindex="0">
    <div class="row justify-content-center">
                                <?php foreach (packages(($key == 'others') ? 1 : 0)  as $package) {
                                    if($package->is_private != 1 || ($package->is_private==1 && user_id() && private_package($package->package_id, user_id()))){
                                	$package_cost = ($package->is_custom) ? 'package_cost' : 'package_'.$group.'_cost';
                                	if (($package->$package_cost != 0) || ($package->$package_cost == 0 && $package->is_free_trial) && !in_array($group, array('yearly','lifetime'))) {
                                	?>
            <div class="col-lg-4 col-md-6 mt-3">
                <div class="pricing <?php if ($package->package_featured) {
                    echo 'pricing-featured bg-primary';
                } ?>">
                    <div class="pricing-body p-5">
                        <div class="text-center"><h5
                                    class="mb-3"><?php echo $package->package_name; ?></h5>
                            <p class="h2"><?php echo currency_format($package->$package_cost); ?></p>
                            <span class="text-muted mb-4"> 
                                <?php if(in_array($key, array('months','years','lifetime'))){
                                    echo label('per').' '.label(singularize($key));
                                }else{
                                    echo '('.$package->package_duration.'  '.label(($package->package_duration==1) ? singularize($package->package_duration_type) : $package->package_duration_type).')';
                                } ?></span>

                            <form action="<?php echo URLROOT; ?>/packages/choose/<?php echo $package->package_id; ?>"
                                  method="post" autocomplete="off" enctype="multipart/form-data">
                                <div class="form-group mb-3">
                                    <button class="btn btn-primary btn-soft btn-block btn-buy" type="submit">
                                        <input type="hidden" value="<?php echo $package->package_id; ?>"
                                               class="form-control" name="package_id">
                                        <input type="hidden" value="<?php echo $group; ?>"
                                            class="form-control" name="package_group">
                                        <?php echo label('subscribe'); ?>
                                    </button>
                                </div>
                            </form>
                        </div>
                        <ul class="styled-list gy-3 pt-2 ps-2">
                            <li><em class="fa-solid fa-check text-success me-2 lh-base"></em>
                                <span><?php echo ($package->package_chat_assistants == -1) ? label('unlimited') : number_format($package->package_chat_assistants); ?> <?php echo label('chat_assistants'); ?></span>
                            </li>
                            <li><em class="fa-solid fa-check text-success me-2 lh-base"></em>
                                <span><?php echo ($package->package_trained_models == -1) ? label('unlimited') : number_format($package->package_trained_models); ?> <?php echo label('trained_models'); ?></span>
                            </li>
                            <li><em class="fa-solid fa-check text-success me-2 lh-base"></em>
                                <span><?php echo ($package->package_chat_files == -1) ? label('unlimited') : number_format($package->package_chat_files); ?> <?php echo label('chat_files'); ?></span>
                            </li>
                            <li><em class="fa-solid fa-check text-success me-2 lh-base"></em>
                                <span><?php echo ($package->package_chat_links == -1) ? label('unlimited') : number_format($package->package_chat_links); ?> <?php echo label('chat_links'); ?></span>
                            </li>
                            <li><em class="fa-solid fa-check text-success me-2 lh-base"></em>
                                <span><?php echo ($package->package_chat_sitemaps == -1) ? label('unlimited') : number_format($package->package_chat_sitemaps); ?> <?php echo label('chat_sitemaps'); ?></span>
                            </li>
                            <li><em class="fa-solid fa-check text-success me-2 lh-base"></em>
                                <span><?php echo ($package->package_words == -1) ? label('unlimited') : number_format($package->package_words); ?> <?php echo label('words'); ?></span>
                            </li>
                            <li>
                                <em class="fa-solid <?php echo !empty($package->accept_custom_branding) ? 'fa-check text-success' : 'fa-times text-danger'; ?> me-2 lh-base"></em>
                                <span class="<?php echo !empty($package->accept_custom_branding) ? '' : 'text-decoration-line-through'; ?>"><?php echo label('accept_custom_branding'); ?></span>
                            </li>
                            <?php foreach (package_features() as $feature) { ?>
                                <?php
                                if (in_array($feature->package_feature_id, package_items_array($package->package_id))) {
                                    $fa = 'fa-check text-success';
                                    $strike = '';
                                } else {
                                    $fa = 'fa-times text-danger';
                                    $strike = 'text-decoration-line-through';
                                }
                                ?>
                                <li><em class="fa-solid <?php echo $fa; ?> me-2 lh-base"></em> <span
                                            class="<?php echo $strike; ?>"><?php echo $feature->package_feature_description; ?></span>
                                </li>
                            <?php } ?>
                        </ul>
                    </div>
                </div>
            </div>
        <?php
        } 
        } 
    }
        ?>
    </div>
    </div>
        <?php } ?>
    </div>
<?php } else {
    echo no_records(strtolower(page_title()));
} ?>
<?php require APPROOT . '/views/inc/footer.php'; ?>
