<?php $page = 'details_of_package'; ?>
<?php require APPROOT . '/views/inc/header.php'; ?>
<?php require 'package_nav.php'; ?>
<div class="col-md-6">
    <div class="card mb-3">
        <div class="card-header"><?php echo label('overview'); ?></div>
        <div class="card-body">
            <table class="table table-striped table-hover">
                <tr>
                    <th><?php echo label('name'); ?></th>
                    <td><?php echo $data['package']->package_name; ?></td>
                </tr>
                <tr>
                    <th><?php echo label('duration'); ?></th>
                    <td><?php echo package_duration_name($data['package']->package_id); ?></td>
                </tr>
                <tr>
                    <th><?php echo label('chat_assistants'); ?></th>
                    <td><?php echo ($data['package']->package_chat_assistants == -1) ? label('unlimited') : number_format($data['package']->package_chat_assistants); ?></td>
                </tr>
                <tr>
                    <th><?php echo label('trained_models'); ?></th>
                    <td><?php echo ($data['package']->package_trained_models == -1) ? label('unlimited') : number_format($data['package']->package_trained_models); ?></td>
                </tr>
                <tr>
                    <th><?php echo label('chat_files'); ?></th>
                    <td><?php echo ($data['package']->package_chat_files == -1) ? label('unlimited') : number_format($data['package']->package_chat_files); ?></td>
                </tr>
                <tr>
                    <th><?php echo label('chat_links'); ?></th>
                    <td><?php echo ($data['package']->package_chat_links == -1) ? label('unlimited') : number_format($data['package']->package_chat_links); ?></td>
                </tr>
                <tr>
                    <th><?php echo label('chat_sitemaps'); ?></th>
                    <td><?php echo ($data['package']->package_chat_sitemaps == -1) ? label('unlimited') : number_format($data['package']->package_chat_sitemaps); ?></td>
                </tr>
                <tr>
                    <th><?php echo label('words'); ?></th>
                    <td><?php echo ($data['package']->package_words == -1) ? label('unlimited') : number_format($data['package']->package_words); ?></td>
                </tr>
                <tr>
                    <th><?php echo label('accept_custom_branding'); ?></th>
                    <td><?php echo yes_no_label($data['package']->accept_custom_branding); ?></td>
                </tr>
                <tr>
                    <th><?php echo label('is_private'); ?></th>
                    <td><?php echo yes_no_label($data['package']->is_private); ?></td>
                </tr>
                <tr>
                    <th><?php echo label('cost'); ?></th>
                    <td><?php echo package_cost_name($data['package']->package_id); ?></td>
                </tr>
            </table>
        </div>
    </div>
</div>
<div class="col-md-6">
    <div class="card mb-3">
        <div class="card-header"><?php echo label('features'); ?></div>
        <div class="card-body">
            <table class="table table-striped table-hover">
                <?php foreach (package_features() as $feature) { ?>
                    <tr>
                        <td>
                            <div class="form-check form-switch">
                                <input class="form-check-input" type="checkbox"
                                       id="add_feature<?php echo $feature->package_feature_id; ?>" <?php if (in_array($feature->package_feature_id, package_items_array($data['package']->package_id))) {
                                    echo 'checked';
                                } ?>>
                                <label class="form-check-label"
                                       for="<?php echo $feature->package_feature_id; ?>"><span
                                            class="message_box<?php echo $feature->package_feature_id; ?>"></span> <?php echo $feature->package_feature_description; ?>
                                </label>
                            </div>
                        </td>
                    </tr>
                <?php } ?>
            </table>
        </div>
    </div>
</div>
<?php require APPROOT . '/views/inc/footer.php'; ?>
<?php foreach (package_features() as $feature) { ?>
    <script>
        $(document).ready(function () {
            var delay = 2000;

            var package_id = "<?php echo $data['package']->package_id; ?>";
            var package_feature_id = "<?php echo $feature->package_feature_id; ?>";
            $('#add_feature' + package_feature_id).click(function (e) {
                if ($('#add_feature' + package_feature_id).is(":checked")) {
                    var action = 'delete';
                    var actionn = 'add';
                } else {
                    var action = 'add';
                    var actionn = 'delete';
                }

                e.preventDefault();
                $.ajax
                ({
                    type: "POST",
                    url: "<?php echo URLROOT; ?>/packages/" + actionn + "_package_item",
                    data: "package_id=" + package_id + "&package_feature_id=" + package_feature_id,
                    beforeSend: function () {
                        $('.message_box' + package_feature_id).html('<div class="spinner-border spinner-border-sm text-primary"></div>');
                    },
                    success: function (data) {
                        var result = jQuery.parseJSON(data);
                        setTimeout(function () {
                            $('.message_box' + package_feature_id).html('');
                        }, delay);
                        if (action == 'add') {
                            $('#add_feature' + package_feature_id).prop('checked', false);
                        } else {
                            $('#add_feature' + package_feature_id).prop('checked', true);
                        }
                    }
                });
            });
        });
    </script>
<?php } ?>
<div class="modal" id="edit_feature" tabindex="-1">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-body"></div>
        </div>
    </div>
</div>

<script>

    function edit_feature(id) {
        $('.modal-body').load('<?php echo URLROOT; ?>/packages/edit_feature/' + id, function () {
            $('#edit_feature').modal({show: true});
        });
    }
</script>