<?php $page = 'payment_method'; ?>
<?php require APPROOT . '/views/inc/header.php'; ?>
<?php require 'package_nav.php'; ?>
    <div class="col-md-12">
        <div class="card mb-3">
            <div class="card-body">
                <?php echo label('amount_to_pay') . ' : '; ?>
                <?php if ($data['package']->package_cost < getOption('minimum_payment_acceptable')) { ?>
                    <span class="help-inline">
							<a href="javascript:void(0)"
                               data-content="<?php echo label('minimum_payment_acceptable_description'); ?>"
                               data-title="<?php echo label('rounded_off_payment_amount'); ?>" data-placement="top"
                               data-toggle="popover" data-original-title="" title="">
								<i class="fa-solid fa-help text-large text-primary"></i>
							</a>
						</span>
                <?php } ?>
                <?php if ($data['package']->package_cost < getOption('minimum_payment_acceptable')) { ?>
                    <span
                            class="text-muted text-decoration-line-through"><?php echo bold_currency_format(!is_null($data['package']) ? $data['package']->package_cost : $data['package_cost']); ?></span> <?php } ?>
                <?php echo bold_currency_format(minimum_payment_acceptable(!is_null($data['package']) ? $data['package']->package_cost : $data['package_cost'])); ?>
                <span class="fw-bold float-end">
	                <?php echo !is_null($data['package']) ? $data['package']->package_name : label('custom_package'); ?> (
	                <?php echo label('from'); ?> <?php echo dateFormat(today()); ?> <?php echo label('to'); ?> <?php echo dateFormat(date("Y-m-d", strtotime('+' . ($data['package']->package_duration) . ' ' . ($data['package']->package_duration_type)))); ?>
	                )
                </span>
            </div>
        </div>
    </div>
    <div class="col-md-12">
        <div class="card mb-3">
            <div class="card-header"><?php echo label('offline_payment'); ?></div>
            <div class="card-body">
                <div class="col-md-12">
                    <form action="<?php echo URLROOT; ?>/packages/record_payment/<?php echo $data['package']->package_id; ?>"
                          method="post" autocomplete="off" enctype="multipart/form-data">
                        <div class="form-group mb-3">
                            <label><?php echo label('user'); ?> <span class="symbol required"></span></label>
                            <select data-show-subtext="true" data-live-search="true"
                                    class="form-control <?php echo selectpicker(); ?>" id="user_id"
                                    name="user_id"
                                    required>
                                <option value=""></option>
                                <?php foreach (users() as $user) { ?>
                                    <option value="<?php echo $user->user_id; ?>"><?php echo $user->username; ?> </option>
                                <?php } ?>
                            </select>
                        </div>
                        <div class="form-group mb-3">
                            <label><?php echo label('payment_option'); ?> <span
                                        class="symbol required"></span></label>
                            <select data-show-subtext="true" data-live-search="true"
                                    class="form-control <?php echo selectpicker(); ?>" id="payment_option_id"
                                    name="payment_option_id" required>
                                <option value=""></option>
                                <?php foreach (payment_options(0) as $payment_option) { ?>
                                    <option value="<?php echo $payment_option->payment_option_id; ?>"><?php echo $payment_option->payment_option_name; ?> </option>
                                <?php } ?>
                            </select>
                        </div>
                        <div class="form-group mb-3">
                            <label><?php echo label('unique_number'); ?> <span
                                        class="symbol required"></span></label>
                            <input type="text"
                                   value="<?php echo !empty($data['transaction_id']) ? $data['transaction_id'] : ''; ?>"
                                   class="form-control" id="transaction_id" name="transaction_id" required>
                        </div>
                        <div class="form-group mb-3">
                            <label><?php echo label('amount_paid'); ?> <span
                                        class="symbol required"></span></label>
                            <div class="input-group">
                                <div class="input-group-prepend"><span
                                            class="input-group-text"><?php echo useCurrency(); ?></span></div>
                                <input type="text"
                                       value="<?php echo !empty($data['amount_added']) ? $data['amount_added'] : ''; ?>"
                                       name="amount_added" class="form-control" required>
                            </div>
                        </div>
                        <div class="form-group mb-3">
                            <button class="btn btn-primary btn-wide float-end" type="submit">
                                <input type="hidden" class="form-control" value="<?php echo uid(8); ?>"
                                       name="subscription_uid">
                                <input type="hidden" class="form-control" id="package_id" name="package_id"
                                       value="<?php echo $data['package']->package_id; ?>">
                                <textarea class="form-control" name="subscription_items"
                                          style="display:none;"><?php echo json_encode($data['package']); ?></textarea>
                                <?php echo label('add_payment'); ?>
                            </button>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
<?php require APPROOT . '/views/inc/footer.php'; ?>