<?php $page = 'edit_page'; ?>
<?php require APPROOT . '/views/inc/header.php'; ?>
<?php require_once 'page_navigation.php'; ?>
<form action="<?php echo URLROOT; ?>/pages/edit/<?php echo $data['page']->page_id; ?>"
      method="post" autocomplete="off" enctype="multipart/form-data">
    <div class="card mb-3">
        <div class="card-body">
            <div class="mb-3">
                <label class="form-label"><?php echo label('page_title'); ?> <span
                            class="symbol required"></span></label>
                <input type="text" value="<?php echo $data['page']->page_title; ?>" class="form-control" id="page_title"
                       name="page_title">
            </div>
            <div class="mb-3">
                <label class="form-label"><?php echo label('description'); ?> <span
                            class="symbol required"></span></label>
                <textarea class="form-control mceEditor" id="page_description" name="page_description"
                          required><?php echo $data['page']->page_description; ?></textarea>
            </div>
            <div class="form-check form-check-inline mb-3">
                <input type="checkbox" class="form-check-input" name="show_in_header" id="show_in_header"
                       value="1" <?php if ($data['page']->show_in_header == 1) {
                    echo 'checked';
                } ?>>
                <label for="show_in_header"><?php echo label('show_in_header'); ?></label>
            </div>
            <div class="form-check form-check-inline mb-3">
                <input type="checkbox" class="form-check-input" name="show_in_footer" id="show_in_footer"
                       value="1" <?php if ($data['page']->show_in_footer == 1) {
                    echo 'checked';
                } ?>>
                <label for="show_in_footer"><?php echo label('show_in_footer'); ?></label>
            </div>
            <div class="form-check form-check-inline mb-3">
                <input type="checkbox" class="form-check-input" name="privacy_policy_page" id="privacy_policy_page"
                       value="1" <?php if (getOption('privacy_policy_page') == $data['page']->page_id) {
                    echo 'checked';
                } ?> onchange="show_hide_page_short_description()">
                <label for="privacy_policy_page"><?php echo label('is_this_your_privacy_policy_page'); ?></label>
            </div>
            <div class="form-check form-check-inline mb-3">
                <input type="checkbox" class="form-check-input" name="terms_and_conditions_page"
                       id="terms_and_conditions_page"
                       value="1" <?php if (getOption('terms_and_conditions_page') == $data['page']->page_id) {
                    echo 'checked';
                } ?>>
                <label for="terms_and_conditions_page"><?php echo label('is_this_your_terms_and_conditions_page'); ?></label>
            </div>
            <div class="form-check form-check-inline mb-3">
                <input type="checkbox" class="form-check-input" name="contact_us_page"
                       id="contact_us_page"
                       value="1" <?php if (getOption('contact_us_page') == $data['page']->page_id) {
                    echo 'checked';
                } ?> onchange="show_hide_contact_us_page()">
                <label for="contact_us_page"><?php echo label('is_this_your_contact_us_page'); ?></label>
            </div>
            <div class="mb-3 page_short_description_div">
                <label class="form-label"><?php echo label('cookie_alert_description'); ?> <span
                            class="symbol required"></span></label>
                <textarea class="form-control" id="page_short_description" id="page_short_description"
                          name="page_short_description"><?php echo $data['page']->page_short_description; ?></textarea>
            </div>
            <div class="mb-3 contact_us_page_div">
                <div class="form-check form-switch">
                    <input class="form-check-input" type="checkbox" role="switch" id="show_contact_us_form"
                           name="show_contact_us_form" <?php if (getOption('show_contact_us_form')) {
                        echo 'checked';
                    } ?>>
                    <label class="form-check-label"
                           for="show_contact_us_form"><?php echo label('show_contact_us_form'); ?></label>
                </div>
                <div class="form-check form-switch">
                    <input class="form-check-input" type="checkbox" role="switch" id="show_contact_us_details"
                           name="show_contact_us_details" <?php if (getOption('show_contact_us_details')) {
                        echo 'checked';
                    } ?> onchange="show_hide_show_contact_us_details()">
                    <label class="form-check-label"
                           for="show_contact_us_details"><?php echo label('show_contact_us_details'); ?></label>
                </div>
            </div>

            <div class="mb-3 show_contact_us_details_div">
                <div class="row">
                    <div class="col">
                        <label class="form-label"><?php echo label('email'); ?> <span
                                    class="symbol required"></span></label>
                        <input type="text" value="<?php echo getOption('contact_us_email'); ?>"
                               class="form-control" id="contact_us_email" name="contact_us_email">
                    </div>
                    <div class="col">
                        <label class="form-label"><?php echo label('phone'); ?> <span
                                    class="symbol required"></span></label>
                        <input type="text" value="<?php echo getOption('contact_us_phone'); ?>"
                               class="form-control" id="contact_us_phone" name="contact_us_phone">
                    </div>
                    <div class="col">
                        <label class="form-label"><?php echo label('address'); ?> <span
                                    class="symbol required"></span></label>
                        <input type="text" value="<?php echo getOption('contact_us_address'); ?>"
                               class="form-control" id="contact_us_address" name="contact_us_address">
                    </div>
                </div>
            </div>

            <div class="mb-3">
                <label class="form-label"><?php echo label('status'); ?> </label>
                <select data-show-subtext="true" data-live-search="true" class="form-control selectpicker"
                        id="page_status_id" name="page_status_id">
                    <option value="<?php echo $data['page']->page_status_id; ?>"><?php echo item_status($data['page']->page_status_id)->item_status_name; ?></option>
                    <?php foreach (item_statuses() as $status) { ?>
                        <option value="<?php echo $status->item_status_id; ?>"><?php echo $status->item_status_name; ?> </option>
                    <?php } ?>
                </select>
            </div>
            <div class="mb-3">
                <button class="btn btn-primary btn-wide float-end" type="submit">
                    <?php echo label('update_page'); ?>
                </button>
            </div>
        </div>
    </div>
</form>
<?php require APPROOT . '/views/inc/footer.php'; ?>
<script>
    if ($('#privacy_policy_page').prop('checked')) {
        $('.page_short_description_div').css('display', 'block');
    } else {
        $('.page_short_description_div').css('display', 'none');
    }

    function show_hide_page_short_description() {
        if ($('#privacy_policy_page').prop('checked')) {
            $('.page_short_description_div').css('display', 'block');
        } else {
            $('.page_short_description_div').css('display', 'none');
        }
    }

    if ($('#contact_us_page').prop('checked')) {
        $('.contact_us_page_div').css('display', 'block');
    } else {
        $('.contact_us_page_div').css('display', 'none');
    }

    function show_hide_contact_us_page() {
        if ($('#contact_us_page').prop('checked')) {
            $('.contact_us_page_div').css('display', 'block');
        } else {
            $('.contact_us_page_div').css('display', 'none');
        }
    }

    if ($('#show_contact_us_details').prop('checked')) {
        $('.show_contact_us_details_div').css('display', 'block');
    } else {
        $('.show_contact_us_details_div').css('display', 'none');
    }

    function show_hide_show_contact_us_details() {
        if ($('#show_contact_us_details').prop('checked')) {
            $('.show_contact_us_details_div').css('display', 'block');
        } else {
            $('.show_contact_us_details_div').css('display', 'none');
        }
    }
</script>