<?php $page = 'details_of_page'; ?>
<?php require APPROOT . '/views/inc/header.php'; ?>
<?php require_once 'page_navigation.php'; ?>
<div class="col-md-6">
    <div class="card mb-3">
        <div class="card-header"><?php echo label('overview'); ?></div>
        <div class="card-body">
            <table class="table table-striped table-hover">
                <tr>
                    <th><?php echo label('name'); ?></th>
                    <td><?php echo $data['page']->page_title; ?></td>
                </tr>
                <tr>
                    <th><?php echo label('added_by'); ?></th>
                    <td><?php echo user($data['page']->page_added_by)->username; ?></td>
                </tr>
                <tr>
                    <th><?php echo label('show_in_header'); ?></th>
                    <td><?php echo yes_no_label($data['page']->show_in_header); ?></td>
                </tr>
                <tr>
                    <th><?php echo label('show_in_footer'); ?></th>
                    <td><?php echo yes_no_label($data['page']->show_in_footer); ?></td>
                </tr>
                <tr>
                    <th><?php echo label('date_added'); ?></th>
                    <td><?php echo dateTimeFormat($data['page']->page_date_added); ?></td>
                </tr>
            </table>
        </div>
    </div>
</div>
<div class="col-md-6">
    <div class="card mb-3">
        <div class="card-header"><?php echo label('page_background'); ?></div>
        <div class="card-body">
            <?php if (!empty($data['page']->page_background)) { ?>
                <a href="#" data-bs-toggle="modal" data-bs-target="#page_backgroundModal"><img class="w-50 mb-3"
                                                                                               src="<?php echo URLROOT . '/app/' . MEDIA_FOLDER . $data['page']->page_background; ?>"/></a>
                <a class="text-danger mt-1 float-end"
                   href="<?php echo URLROOT . '/pages/delete_page_background/' . $data['page']->page_id; ?>"
                   data-bs-toggle="tooltip" data-bs-placement="left" title="<?php echo label('delete'); ?>"><i
                            class="fa-solid fa-close fa-2x"></i></a>
            <?php } ?>
            <form action="<?php echo URLROOT; ?>/pages/update_page_background/<?php echo $data['page']->page_id; ?>"
                  method="post" autocomplete="off" enctype="multipart/form-data">
                <div class="mb-3">
                    <input type="file" class="form-control" id="page_background" name="page_background"
                           accept="image/*">
                </div>
                <div class="mb-3">
                    <button class="btn btn-primary btn-wide float-end" type="submit">
                        <?php echo label('update_page_background'); ?>
                    </button>
                </div>
            </form>
        </div>
    </div>
</div>
<div class="col-md-12">
    <div class="card mb-3">
        <div class="card-header"><?php echo label('description'); ?></div>
        <div class="card-body">
            <p><?php echo $data['page']->page_description; ?></p>
        </div>
    </div>
</div>
<?php require APPROOT . '/views/inc/footer.php'; ?>
<div class="modal" id="page_backgroundModal">
    <div class="modal-dialog modal-lg">
        <div class="modal-content">
            <div class="modal-body">
                <img class="w-100"
                     src="<?php echo URLROOT . '/app/' . MEDIA_FOLDER . $data['page']->page_background; ?>"/>
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-danger"
                        data-bs-dismiss="modal"><?php echo label('close'); ?></button>
            </div>

        </div>
    </div>
</div>