<?php $page = 'add_post'; ?>
<?php require APPROOT . '/views/inc/header.php'; ?>
<?php echo card_div(); ?>
    <form action="<?php echo URLROOT; ?>/posts/add" method="post" autocomplete="off" enctype="multipart/form-data">
        <div class="card mb-3">
            <div class="card-body">
                <div class="mb-3">
                    <label class="form-label"><?php echo label('post_title'); ?> <span
                                class="symbol required"></span></label>
                    <input type="text" value="<?php echo !empty($data['post_title']) ? $data['post_title'] : ''; ?>"
                           class="form-control" id="post_title" name="post_title">
                </div>
                <div class="mb-3">
                    <label class="form-label"><?php echo label('category'); ?> <span
                                class="symbol required"></span></label>
                    <select data-show-subtext="true" data-live-search="true" class="form-control selectpicker"
                            id="post_category_id" name="post_category_id" required>
                        <option value=""></option>
                        <?php foreach (post_categories() as $category) { ?>
                            <option value="<?php echo $category->post_category_id; ?>"><?php echo $category->post_category_name; ?> </option>
                        <?php } ?>
                    </select>
                </div>
                <div class="mb-3">
                    <label class="form-label"><?php echo label('featured_image'); ?> <span
                                class="symbol required"></span></label>
                    <input type="file" name="featured_image" class="form-control" accept="image/*" required>
                </div>
                <div class="mb-3">
                    <label class="form-label"><?php echo label('post_description'); ?> <span
                                class="symbol required"></span></label>
                    <textarea class="form-control mceEditor"
                              name="post_description"><?php echo !empty($data['post_description']) ? $data['post_description'] : ''; ?></textarea>
                </div>
                <div class="mb-3">
                    <label class="form-label"><?php echo label('status'); ?> </label>
                    <select data-show-subtext="true" data-live-search="true" class="form-control selectpicker"
                            id="post_status_id" name="post_status_id">
                        <option value=""></option>
                        <?php foreach (item_statuses() as $status) { ?>
                            <option value="<?php echo $status->item_status_id; ?>"><?php echo $status->item_status_name; ?> </option>
                        <?php } ?>
                    </select>
                </div>
                <div class="mb-3">
                    <button class="btn btn-primary btn-wide float-end" type="submit">
                        <?php echo label('add_post'); ?>
                    </button>
                </div>
            </div>
        </div>
    </form>
<?php require APPROOT . '/views/inc/footer.php'; ?>