<?php $page = 'details_of_post'; ?>
<?php require APPROOT . '/views/inc/header.php'; ?>
<?php require_once 'post_navigation.php'; ?>
    <div class="col-md-6">
        <div class="card mb-3">
            <div class="card-header"><?php echo label('overview'); ?></div>
            <div class="card-body">
                <table class="table table-striped table-hover">
                    <tr>
                        <th><?php echo label('title'); ?></th>
                        <td><?php echo $data['post']->post_title; ?></td>
                    </tr>
                    <tr>
                        <th><?php echo label('category'); ?></th>
                        <td><?php echo post_category($data['post']->post_category_id)->post_category_name; ?></td>
                    </tr>
                    <tr>
                        <th><?php echo label('added_by'); ?></th>
                        <td><?php echo user($data['post']->post_added_by)->username; ?></td>
                    </tr>
                    <tr>
                        <th><?php echo label('date_added'); ?></th>
                        <td><?php echo dateTimeFormat($data['post']->post_date_added); ?></td>
                    </tr>
                </table>
            </div>
        </div>
    </div>
    <div class="col-md-6">
        <div class="card mb-3">
            <div class="card-header"><?php echo label('featured_image'); ?></div>
            <div class="card-body">
                <?php echo load_image(URLROOT . '/app' . MEDIA_FOLDER . $data['post']->post_featured_image, '100'); ?>
                <form action="<?php echo URLROOT; ?>/posts/update_featured_image/<?php echo $data['post']->post_id; ?>"
                      method="post" autocomplete="off" enctype="multipart/form-data">
                    <div class="mb-3 mt-3">
                        <input type="file" name="featured_image" class="form-control" accept="image/*" required>
                    </div>
                    <div class="mb-3">
                        <button class="btn btn-primary btn-wide float-end" type="submit">
                            <?php echo label('update_featured_image'); ?>
                        </button>
                    </div>
                </form>
            </div>
        </div>
    </div>
    <div class="col-md-12">
        <div class="card mb-3">
            <div class="card-header"><?php echo label('description'); ?></div>
            <div class="card-body">
                <?php echo $data['post']->post_description; ?>
            </div>
        </div>
    </div>
<?php require APPROOT . '/views/inc/footer.php'; ?>