<?php $page = 'affiliate_settings'; ?>
<?php require APPROOT . '/views/inc/header.php'; ?>
<?php echo card_div(); ?>
    <div class="col-md-12">
        <div class="card mb-3">
            <form action="<?php echo URLROOT; ?>/settings/affiliate_settings" method="post" autocomplete="off"
                  enctype="multipart/form-data">
                <div class="card-body">
                    <div class="row">
                        <div class="col-md-12">
                            <div class="form-group mb-3">
                                <label class="form-label"><?php echo label('enable_affiliate'); ?> </label>
                                <div class="form-check form-switch checkbox-lg">
                                    <input type="checkbox" name="enable_affiliate" class="form-check-input"
                                           value="1" <?php if (getOption('enable_affiliate') == 1) {
                                        echo 'checked';
                                    } ?>/>
                                </div>
                            </div>
                            <div class="form-group mb-3">
                                <label class="form-label"><?php echo label('affiliate_rule'); ?> <span
                                            class="symbol required"></span></label>
                                <select data-show-subtext="true" data-live-search="true"
                                        class="form-control <?php echo selectpicker(); ?>" id="affiliate_rule_id"
                                        name="affiliate_rule_id" required>
                                    <option value=""></option>
                                    <?php foreach (affiliate_rules() as $rule) { ?>
                                        <option value="<?php echo $rule->affiliate_rule_id; ?>" <?php if ($rule->affiliate_rule_id == getOption('affiliate_rule_id')) {
                                            echo 'selected';
                                        } ?>><?php echo $rule->affiliate_rule; ?></option>
                                    <?php } ?>
                                </select>
                            </div>
                            <div class="form-group mb-3">
                                <label class="form-label"><?php echo label('commission_rate'); ?> <span
                                            class="symbol required"></span></label>
                                <div class="input-group">
                                    <input type="number" name="affiliate_commission_rate"
                                           value="<?php echo getOption('affiliate_commission_rate'); ?>"
                                           class="form-control"
                                           required>
                                    <span class="input-group-text">%</span>
                                </div>
                            </div>
                            <div class="form-group mb-3">
                                <label class="form-label"><?php echo label('minimum_payout'); ?>
                                    (<?php echo getOption('default_currency'); ?>)<span
                                            class="symbol required"></span></label>
                                <div class="input-group">
                                    <span class="input-group-text"><?php echo getOption('default_currency'); ?></span>
                                    <input type="number" name="affiliate_minimum_payout"
                                           value="<?php echo getOption('affiliate_minimum_payout'); ?>"
                                           class="form-control"
                                           required>
                                </div>
                            </div>
                            <div class="form-group mb-3">
                                <label class="form-label"><?php echo label('action_phrase'); ?><span
                                            class="symbol required"></span></label>
                                <textarea name="affiliate_action_phrase" class="form-control mceEditor"
                                          required><?php echo getOption('affiliate_action_phrase'); ?></textarea>
                            </div>
                            <div class="form-group mb-3">
                                <label class="form-label"><?php echo label('affiliate_guidelines'); ?><span
                                            class="symbol required"></span></label>
                                <textarea name="affiliate_guidelines" class="form-control mceEditor"
                                          required><?php echo getOption('affiliate_guidelines'); ?></textarea>
                            </div>
                            <div class="form-group mb-3">
                                <button class="btn btn-primary btn-wide float-end" type="submit">
                                    <?php echo label('update_affiliate_settings'); ?>
                                </button>
                            </div>
                        </div>
                    </div>
                </div>
            </form>
        </div>
    </div>
<?php require APPROOT . '/views/inc/footer.php'; ?>