<?php $page = 'ai_settings'; ?>
<?php require APPROOT . '/views/inc/header.php'; ?>
<?php echo card_div(); ?>
    <form action="<?php echo URLROOT; ?>/settings/ai_settings" method="post" autocomplete="off"
          enctype="multipart/form-data">
        <div class="card mb-3">
            <div class="card-header">
                <?php echo label('openai'); ?>
            </div>
            <div class="card-body">
                <div class="form-group mb-3">
                    <label class="form-label"><?php echo label('openai_api_key'); ?> <span
                                class="symbol required"></span></label>
                    <input type="text" name="openai_api_key"
                           value="<?php echo getOption('openai_api_key'); ?>"
                           class="form-control"
                    >
                </div>
                <div class="form-group mb-3">
                    <label><?php echo label('chat_model'); ?></label>
                    <select data-show-subtext="true" data-live-search="true"
                            class="form-control <?php echo selectpicker(); ?>"
                            id="custom_package_model" name="custom_package_model"
                            data-container="body"
                            required>
                        <option value=""></option>
                        <?php foreach (openai_models() as $model) { ?>
                            <?php if (in_array('chat', json_decode($model->openai_model_usage_type))) { ?>
                                <option value="<?php echo $model->openai_model; ?>" <?php if ($model->openai_model == getOption('custom_package_model')) {
                                    echo "selected";
                                } ?>><?php echo $model->openai_model_type; ?> (<?php echo $model->openai_model; ?>)
                                </option>
                            <?php } ?>
                        <?php } ?>
                    </select>
                </div>
                <div class="form-group mb-3">
                    <label><?php echo label('finetuning_model'); ?></label>
                    <select data-show-subtext="true" data-live-search="true"
                            class="form-control <?php echo selectpicker(); ?>"
                            id="openai_default_finetune_model" name="openai_default_finetune_model"
                            data-container="body"
                            required>
                        <option value=""></option>
                        <?php foreach (openai_models() as $model) { ?>
                            <?php if (in_array('finetune', json_decode($model->openai_model_usage_type))) { ?>
                                <option value="<?php echo $model->openai_model; ?>" <?php if ($model->openai_model == getOption('openai_default_finetune_model')) {
                                    echo "selected";
                                } ?>><?php echo $model->openai_model_type; ?> (<?php echo $model->openai_model; ?>)
                                </option>
                            <?php } ?>
                        <?php } ?>
                    </select>
                </div>
                <div class="form-group mb-3">
                    <label><?php echo label('files_links_and_websites'); ?> (<?php echo label('assistants_model'); ?>)</label>
                    <div class="row">
                    <div class="col">
                    <select data-show-subtext="true" data-live-search="true"
                            class="form-control <?php echo selectpicker(); ?>"
                            id="openai_default_assistant_model" name="openai_default_assistant_model"
                            data-container="body"
                            required>
                        <option value=""></option>
                        <?php foreach (openai_models() as $model) { ?>
                            <?php if (in_array('assistant', json_decode($model->openai_model_usage_type))) { ?>
                                <option value="<?php echo $model->openai_model; ?>" <?php if ($model->openai_model == getOption('openai_default_assistant_model')) {
                                    echo "selected";
                                } ?>><?php echo $model->openai_model_type; ?> (<?php echo $model->openai_model; ?>)
                                </option>
                            <?php } ?>
                        <?php } ?>
                    </select>
                    </div>
                    <div class="col">
                    <select data-show-subtext="true" data-live-search="true"
                            class="form-control <?php echo selectpicker(); ?>"
                            id="assistant_version" name="assistant_version"
                            data-container="body"
                            required>
                                <option value=""></option>
                                <option value="v2" <?php if (getOption('assistant_version')=='v2') { echo "selected"; } ?>> v2 </option>
                                <option value="v1" <?php if (getOption('assistant_version')=='v1') { echo "selected"; } ?>> v1 </option>
                    </select>
                    </div>
                    </div>
                </div>
                <div class="form-group mb-3">
                    <label class="form-label"><?php echo label('maximum_result_length'); ?> <span
                                class="symbol required"></span></label>
                    <input type="number" name="custom_package_maximum_result_length"
                           value="<?php echo getOption('custom_package_maximum_result_length'); ?>" min="1"
                           class="form-control"
                    >
                </div>
                <div class="form-group mb-3">
                    <button class="btn btn-primary btn-wide float-end" type="submit">
                        <?php echo label('update_ai_settings'); ?>
                    </button>
                </div>
            </div>
        </div>
    </form>
<?php require APPROOT . '/views/inc/footer.php'; ?>