<?php $page = 'company_details'; ?>
<?php require APPROOT . '/views/inc/header.php'; ?>
<?php echo card_div(); ?>
<div class="col-md-12">
    <div class="card mb-3">
        <div class="card-body">
            <ul class="nav nav-tabs nav-justified">
                <li class="nav-item"><a data-bs-toggle="tab" href="#card_overview"
                                        class="active nav-link"><?php echo label('company_logo'); ?></a></li>
                <li class="nav-item"><a data-bs-toggle="tab" href="#card_edit_account"
                                        class="nav-link"><?php echo label('edit_profile'); ?></a></li>
                <li class="nav-item"><a data-bs-toggle="tab" href="#card_system_logo"
                                        class="nav-link"><?php echo label('system_logo'); ?></a></li>
                <li class="nav-item"><a data-bs-toggle="tab" href="#card_system_favicon"
                                        class="nav-link"><?php echo label('system_favicon'); ?></a></li>
                <li class="nav-item"><a data-bs-toggle="tab" href="#card_social_profiles"
                                        class="nav-link"><?php echo label('social_profiles'); ?></a></li>
            </ul>
            <div class="tab-content">
                <div id="card_overview" class="tab-pane active">
                    <div class="row">
                        <div class="col-md-6">
                            <h4><?php echo company(1)->company_name; ?></h4>
                            <img class="my-3" src="<?php echo companyPath(company(1)->company_logo); ?>"
                            >
                            <form action="<?php echo URLROOT; ?>/settings/update_company_logo" method="post"
                                  autocomplete="off" enctype="multipart/form-data">
                                <div class="row">
                                    <div class="col-md-8">
                                        <input class="form-control" type="file" name="image" required>
                                    </div>
                                    <div class="col-md-4">
                                        <button class="btn btn-primary float-end" type="submit">
                                            <?php echo label('update_logo'); ?>
                                        </button>
                                    </div>
                                </div>
                            </form>
                        </div>
                    </div>
                </div>
                <div id="card_edit_account" class="tab-pane fade">
                    <form action="<?php echo URLROOT; ?>/settings/update_company_profile" method="post"
                          autocomplete="off" enctype="multipart/form-data">
                        <div class="row">
                            <div class="col-md-6">
                                <div class="form-group mb-3">
                                    <label class="control-label"><?php echo label('company_name'); ?><span
                                                class="symbol required"></span></label>
                                    <input type="text" value="<?php echo company(1)->company_name; ?>"
                                           class="form-control" id="company_name" name="company_name" required>
                                </div>
                                <div class="form-group mb-3">
                                    <label class="control-label"><?php echo label('street'); ?> <span
                                                class="symbol required"></span></label>
                                    <input type="text" value="<?php echo company(1)->company_street; ?>"
                                           class="form-control" id="company_street" name="company_street" required>
                                </div>
                                <div class="form-group mb-3">
                                    <label class="control-label"><?php echo label('city'); ?> <span
                                                class="symbol required"></span></label>
                                    <input type="text" value="<?php echo company(1)->company_city; ?>"
                                           class="form-control" id="company_city" name="company_city" required>
                                </div>
                                <div class="form-group mb-3">
                                    <label class="control-label"><?php echo label('state'); ?> <span
                                                class="symbol required"></span></label>
                                    <input type="text" value="<?php echo company(1)->company_state; ?>"
                                           class="form-control" id="company_state" name="company_state" required>
                                </div>
                                <div class="form-group mb-3">
                                    <label class="control-label"><?php echo label('zip'); ?> <span
                                                class="symbol required"></span></label>
                                    <input type="text" value="<?php echo company(1)->company_zip; ?>"
                                           class="form-control" id="company_zip" name="company_zip" required>
                                </div>
                                <div class="form-group mb-3">
                                    <label class="control-label"><?php echo label('email'); ?> <span
                                                class="symbol required"></span></label>
                                    <input type="email" value="<?php echo company(1)->company_email; ?>"
                                           class="form-control" id="company_email" name="company_email" required>
                                </div>
                                <div class="form-group mb-3">
                                    <label class="control-label"><?php echo label('phone'); ?> <span
                                                class="symbol required"></span></label>
                                    <input type="text" value="<?php echo company(1)->company_phone; ?>"
                                           class="form-control" id="company_phone" name="company_phone" required>
                                </div>
                            </div>
                            <div class="col-md-6">
                                <div class="form-group mb-3">
                                    <label class="control-label"><?php echo label('country'); ?> <span
                                                class="symbol required"></span></label>
                                    <select data-show-subtext="true" data-live-search="true"
                                            class="form-control <?php echo selectpicker(); ?>" id="company_country_id"
                                            name="company_country_id" class="form-control" required>
                                        <option value="<?php echo !empty(company(1)->company_country_id) ? company(1)->company_country_id : ''; ?>"><?php echo !empty(company(1)->company_country_id) ? country(company(1)->company_country_id)->short_name : label('select_your_country'); ?></option>
                                        <?php foreach (countries() as $countries) { ?>
                                            <option value="<?php echo $countries->country_id; ?>"><?php echo $countries->short_name; ?></option>
                                        <?php } ?>
                                    </select>
                                </div>
                                <div class="form-group mb-3">
                                    <label class="control-label"><?php echo label('tax'); ?> <span
                                                class="symbol required"></span></label>
                                    <div class="input-group">
                                        <input type="number" value="<?php echo company(1)->company_tax; ?>"
                                               class="form-control" id="company_tax" name="company_tax" required>
                                        <span class="input-group-addon"></span>
                                        <div class="input-group-prepend"><span class="input-group-text">%</span></div>
                                    </div>
                                </div>
                                <div class="form-group mb-3">
                                    <label class="control-label"><?php echo label('website'); ?> <span
                                                class="symbol required"></span></label>
                                    <input type="url" value="<?php echo company(1)->company_website; ?>"
                                           class="form-control" id="company_website" name="company_website" required>
                                </div>
                                <div class="form-group mb-3">
                                    <label class="control-label"><?php echo label('website_title'); ?> <span
                                                class="symbol required"></span></label>
                                    <input type="text" value="<?php echo company(1)->company_website_title; ?>"
                                           class="form-control" id="company_website_title" name="company_website_title"
                                           required>
                                </div>
                                <div class="form-group mb-3">
                                    <label class="control-label"><?php echo label('website_description'); ?> <span
                                                class="symbol required"></span></label>
                                    <textarea class="form-control" id="company_website_description"
                                              name="company_website_description"
                                              required><?php echo company(1)->company_website_description; ?></textarea>
                                </div>
                                <div class="form-group mb-3">
                                    <label class="control-label"><?php echo label('website_keywords'); ?> <span
                                                class="symbol required"></span></label>
                                    <textarea class="form-control" id="company_website_keywords"
                                              name="company_website_keywords"
                                              required><?php echo company(1)->company_website_keywords; ?></textarea>
                                </div>
                            </div>
                        </div>
                        <div class="form-group mb-3">
                            <button class="btn btn-primary btn-wide float-end" type="submit">
                                <?php echo label('update_company_profile'); ?>
                            </button>
                        </div>
                    </form>
                </div>
                <div id="card_system_logo" class="tab-pane fade">
                    <img class="my-3" src="<?php echo companyPath(company(1)->company_website_logo); ?>">
                    <form action="<?php echo URLROOT; ?>/settings/update_company_website_logo"
                          method="post" enctype="multipart/form-data">

                        <div class="row">
                            <div class="col-md-8">
                                <input class="form-control" type="file" name="image" required>
                            </div>
                            <div class="col-md-4">
                                <div class="form-group mb-3">
                                    <button class="btn btn-primary float-end" type="submit">
                                        <?php echo label('update_system_logo'); ?>
                                    </button>
                                </div>
                            </div>
                        </div>
                    </form>
                </div>
                <div id="card_system_favicon" class="tab-pane fade">
                    <img class="my-3" src="<?php echo faviconPath(company(1)->company_website_favicon); ?>">
                    <form action="<?php echo URLROOT; ?>/settings/update_company_website_favicon"
                          method="post" autocomplete="off" enctype="multipart/form-data">

                        <div class="row">
                            <div class="col-md-8">
                                <input class="form-control" type="file" name="image" required>
                            </div>
                            <div class="col-md-4">
                                <div class="form-group mb-3">
                                    <button class="btn btn-primary float-end" type="submit">
                                        <?php echo label('update_system_favicon'); ?>
                                    </button>
                                </div>
                            </div>
                        </div>
                    </form>
                </div>
                <div id="card_social_profiles" class="tab-pane fade">
                    <form action="<?php echo URLROOT; ?>/settings/update_social_profiles" method="post"
                          autocomplete="off" enctype="multipart/form-data">

                        <div class="row">
                            <div class="col-md-3">
                                <div class="form-group mb-3">
                                    <label><?php echo label('name'); ?></label>
                                </div>
                            </div>
                            <div class="col-md-4">
                                <div class="form-group mb-3">
                                    <label><?php echo label('link'); ?></label>
                                </div>
                            </div>
                            <div class="col-md-4">
                                <div class="form-group mb-3">
                                    <label><?php echo label('icon'); ?></label>
                                </div>
                            </div>
                            <div class="col-md-1 show_hide">
                                <div class="form-group mb-3">
                                    <label class="form-label">&nbsp;</label>
                                </div>
                            </div>
                            <div class="col-md-3">
                                <div class="form-group mb-3">
                                    <input type="hidden" name="social_profile_id[]"/>
                                    <input type="text" id="social_profile_name" name="social_profile_name[]"
                                           class="form-control"/>
                                </div>
                            </div>
                            <div class="col-md-4">
                                <div class="form-group mb-3">
                                    <input type="text" id="social_profile_link" name="social_profile_link[]"
                                           class="form-control"/>
                                </div>
                            </div>
                            <div class="col-md-4">
                                <div class="form-group mb-3">
                                    <textarea id="social_profile_icon" name="social_profile_icon[]"
                                              class="form-control"></textarea>
                                </div>
                            </div>
                            <div class="col-md-1 show_hide">
                                <div class="form-group mb-3">
                                    <button type="button" class="form-control btn float-end btn-success add_button"><i
                                                class="fa-solid fa-plus"></i></button>
                                </div>
                            </div>
                            
                            <?php foreach (social_profiles() as $profile) { ?>
                                <div class="col-md-3">
                                    <div class="form-group mb-3">
                                        <input type="hidden" name="social_profile_id[]"
                                               value="<?php echo $profile->social_profile_id; ?>"/>
                                        <input type="text" id="social_profile_name" name="social_profile_name[]"
                                               class="form-control"
                                               value="<?php echo $profile->social_profile_name; ?>"/>
                                    </div>
                                </div>
                                <div class="col-md-4">
                                    <div class="form-group mb-3">
                                        <input type="text" id="social_profile_link" name="social_profile_link[]"
                                               class="form-control"
                                               value="<?php echo $profile->social_profile_link; ?>"/>
                                    </div>
                                </div>
                                <div class="col-md-4">
                                    <div class="form-group mb-3">
                                        <textarea id="social_profile_icon" name="social_profile_icon[]"
                                                  class="form-control"><?php echo $profile->social_profile_icon; ?></textarea>
                                    </div>
                                </div>
                                <div class="col-md-1 show_hide">
                                    <div class="form-group mb-3">
                                        <a href="<?php echo URLROOT . '/settings/delete_social_profile/' . $profile->social_profile_id; ?>"
                                           class="float-end"><i class="fa fa-trash fa-2x" style="color:red"></i></a>
                                    </div>
                                </div>
                            <?php } ?>

                            <div class="field_wrapper"></div>
                            <div class="col-sm-12">
                                <div class="mb-3">
                                    <button class="btn btn-primary btn-wide float-end" type="submit">
                                        <?php echo label('update_social_profiles'); ?>
                                    </button>
                                </div>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
<?php require APPROOT . '/views/inc/footer.php'; ?>
<?php
    $rand = floor(microtime(true) * 1000);
    $defined = '<div class="row">';
    $defined .= '<div class="col-md-3">';
    $defined .= '<div class="form-group mb-3">';
    $defined .= '<input type="hidden" name="social_profile_id[]" />';
    $defined .= '<input type="text" id="social_profile_name" name="social_profile_name[]" class="form-control"/>';
    $defined .= '</div>';
    $defined .= '</div>';
    $defined .= '<div class="col-md-4">';
    $defined .= '<div class="form-group mb-3">';
    $defined .= '<input type="url" id="social_profile_link" name="social_profile_link[]" class="form-control"/>';
    $defined .= '</div>';
    $defined .= '</div>';
    $defined .= '<div class="col-md-4">';
    $defined .= '<div class="form-group mb-3">';
    $defined .= '<textarea id="social_profile_icon" name="social_profile_icon[]" class="form-control"></textarea>';
    $defined .= '</div>';
    $defined .= '</div>';
    $defined .= '<div class="col-md-1 mt-1">';
    $defined .= '<a href="javascript:void(0);" class="float-end"><i class="fa fa-trash fa-2x" id=first' . $rand . ' onclick="second(' . $rand . ')" style="color:red"></i></a>';
    $defined .= '</div>';
    $defined .= '<a href="javascript:void(0);" class="remove_button' . $rand . '" id=second' . $rand . '></a>';
    $defined .= '</div>';
?>
<script type="text/javascript">
    function second(vari) {
        let itemm = 'second' + vari;
        document.getElementById(itemm).click();
    }
</script>

<script type="text/javascript">
    $(document).ready(function () {
        var DEFINEDUSERS = '<?php echo $defined; ?>';
        var maxField = 10; //Input fields increment limitation
        var addButton = $('.add_button'); //Add button selector
        var wrapper = $('.field_wrapper'); //Input field wrapper
        var fieldHTML = DEFINEDUSERS; //New input field html
        var x = 1; //Initial field counter is 1

        //Once add button is clicked
        $(addButton).click(function () {
            //Check maximum number of input fields
            if (x < maxField) {
                x++; //Increment field counter
                $(wrapper).append(fieldHTML); //Add field html
            }
        });

        //Once remove button is clicked
        $(wrapper).on('click', '.remove_button<?php echo $rand; ?>', function (e) {
            e.preventDefault();
            $(this).parent('div.row').remove(); //Remove field html
            x--; //Decrement field counter
        });
    });
</script>