<?php $page = 'default_currency_settings'; ?>
<?php require APPROOT . '/views/inc/header.php'; ?>
<?php echo card_div(); ?>
<div class="row">
    <div class="col-md-12">
        <div class="card mb-3">
            <div class="card-body">
                <form action="<?php echo URLROOT; ?>/settings/default_currency" method="post" autocomplete="off"
                      enctype="multipart/form-data">
                    <div class="form-group mb-3">
                        <label class="form-label"><?php echo label('default_currency'); ?> <span
                                    class="symbol required"></span></label>
                        <select data-show-subtext="true" data-live-search="true"
                                class="form-control <?php echo selectpicker(); ?>" id="default_currency"
                                name="default_currency" required onChange="changeCurrencySymbol(this.value)">
                            <option value="<?php echo getOption('default_currency'); ?>"><?php echo getOption('default_currency'); ?></option>
                            <?php foreach (supported_currencies() as $supported_currency) { ?>
                                <option value="<?php echo $supported_currency->supported_currency_iso; ?>"><?php echo $supported_currency->supported_currency_iso; ?></option>
                            <?php } ?>
                        </select>
                    </div>
                    <div id="itemDiv">
                        <div class="form-group mb-3">
                            <label class="form-label"><?php echo label('currency_symbol'); ?> <span
                                        class="symbol required"></span></label>
                            <input class="form-control"
                                   value="<?php echo htmlentities(getOption('currency_symbol')); ?>"
                                   name="currency_symbol" type="text" required>
                        </div>
                    </div>
                    <div class="form-group mb-3">
                        <div class="form-check form-switch">
                            <input class="form-check-input" type="checkbox" id="use_currency_symbol"
                                   name="use_currency_symbol" <?php if (getOption('use_currency_symbol') == 1) {
                                echo 'checked';
                            } ?>>
                            <label class="form-check-label"
                                   for="use_currency_symbol"><?php echo label('use_currency_symbol'); ?></label>
                        </div>
                    </div>
		            <div class="mb-3">
		                <label class="form-label"><?php echo label('currency_symbol_placement'); ?> <span
		                            class="symbol required"></span></label>
		                <select data-show-subtext="true" data-live-search="true" class="form-control selectpicker"
		                        id="currency_symbol_placement" name="currency_symbol_placement" required>
		                    <option value="before" <?php if (getOption('currency_symbol_placement') == 'before') {
		                        echo 'selected';
		                    } ?>><?php echo label('place_symbol_before_number'); ?></option>
		                    <option value="after" <?php if (getOption('currency_symbol_placement') == 'after') {
		                        echo 'selected';
		                    } ?>><?php echo label('place_symbol_after_number'); ?></option>
		                </select>
		            </div>
                    <div class="form-group mb-3">
                        <label class="form-label"><?php echo label('number_of_decimals'); ?> <span
                                    class="symbol required"></span></label>
                        <input class="form-control"
                               value="<?php echo getOption('number_of_currency_decimals'); ?>"
                               name="number_of_currency_decimals" type="number" min="0" required>
                    </div>
                    <div class="form-group mb-3">
                        <button class="btn btn-primary btn-wide float-end" type="submit">
                            <?php echo label('update_default_currency_settings'); ?>
                        </button>
                    </div>
                </form>
            </div>
        </div>
    </div>
</div>
<?php require APPROOT . '/views/inc/footer.php'; ?>
<script>
    function changeCurrencySymbol(str) {
        if (str == "") {
            document.getElementById("itemDiv").innerHTML = "";
            return;
        }
        if (window.XMLHttpRequest) {
            // code for IE7+, Firefox, Chrome, Opera, Safari
            xmlhttp = new XMLHttpRequest();
        } else {  // code for IE6, IE5
            xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
        }
        xmlhttp.onreadystatechange = function () {
            if (xmlhttp.readyState == 4 && xmlhttp.status == 200) {
                document.getElementById("itemDiv").innerHTML = xmlhttp.responseText;
            }
        }
        xmlhttp.open("GET", URLROOT + "/settings/default_currency_addon/" + str, true);
        xmlhttp.send();
    }
</script>