<?php $page = 'email_settings'; ?>
<?php require APPROOT . '/views/inc/header.php'; ?>
<?php echo card_div(); ?>
    <div class="card mb-3">
        <div class="card-body">
            <ul class="nav nav-tabs nav-justified">
                <li class="nav-item">
                    <a class="nav-link active" id="card_overview_tab" data-bs-toggle="tab"
                       data-bs-target="#card_overview"
                       type="button" role="tab" aria-controls="card_overview"
                       aria-selected="true"><?php echo label('overview'); ?></a></li>
                <li class="nav-item">
                    <a class="nav-link" id="card_smtp_tab" data-bs-toggle="tab" data-bs-target="#card_smtp"
                       type="button" role="tab" aria-controls="card_smtp"
                       aria-selected="true"><?php echo label('smtp'); ?></a></li>
                <li class="nav-item">
                    <a class="nav-link" id="card_sendgrid_settings_tab" data-bs-toggle="tab"
                       data-bs-target="#card_sendgrid_settings" type="button" role="tab"
                       aria-controls="card_sendgrid_settings" aria-selected="false">
                        <?php echo label('sendgrid'); ?>
                    </a>
                </li>
            </ul>
            <div class="tab-content">
                <div id="card_overview" class="tab-pane fade show active">
                    <div class="form-group mb-3">
                        <label class="form-label"><?php echo label('overview'); ?></label>
                        <hr>
                    </div>
                    <div class="row">
                        <div class="col-md-12">
                            <div class="cardcard-light">
                                <div class="card-body">
                                    <form action="<?php echo URLROOT; ?>/settings/update_email_settings" method="post"
                                          autocomplete="off"
                                          enctype="multipart/form-data">
                                        <div class="form-group mb-3">
                                            <label for="input-form-control"><?php echo label('use'); ?></label>
                                            <select data-show-subtext="true" data-live-search="true"
                                                    class="form-control <?php echo selectpicker(); ?>"
                                                    id="email_gateway" name="email_gateway"
                                                    data-container="body"
                                                    required>
                                                <option value=""></option>
                                                <?php foreach (email_gateways() as $gateway) { ?>
                                                    <option value="<?php echo $gateway->email_gateway_slug; ?>" <?php if ($gateway->email_gateway_slug == getOption('email_gateway')) {
                                                        echo "selected";
                                                    } ?>><?php echo $gateway->email_gateway_name; ?>
                                                    </option>
                                                <?php } ?>
                                            </select>

                                        </div>
                                        <div class="form-group mb-3">
                                            <button class="btn btn-primary btn-wide float-end" type="submit">
                                                <?php echo label('update_email_settings'); ?>
                                            </button>
                                        </div>
                                    </form>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <div id="card_smtp" class="tab-pane fade">
                    <div class="form-group mb-3">
                        <label class="form-label"><?php echo label('smtp'); ?></label>
                        <hr>
                    </div>
                    <div class="row">
                        <div class="col-md-12">
                            <div class="cardcard-light">
                                <div class="card-body">
                                    <form action="<?php echo URLROOT; ?>/settings/update_smtp_settings" method="post"
                                          autocomplete="off"
                                          enctype="multipart/form-data">
                                        <div class="form-group mb-3">
                                            <label for="input-form-control"><?php echo label('smtp_active'); ?>?</label>
                                            <div class="form-group mb-3">
                                                <div class="radio mybizcms-radio radio-lg radio-primary radio-inline">
                                                    <input id="radio3" class="option_autoload" name="option_autoload"
                                                           value="1" <?php if ($data['smtp_live_enabled']->option_autoload == '1') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="radio3"><?php echo label('yes'); ?></label>
                                                    <input id="radio4" class="option_autoload" name="option_autoload"
                                                           value="0" <?php if ($data['smtp_live_enabled']->option_autoload == '0') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="radio4"><?php echo label('no'); ?></label>
                                                </div>
                                            </div>
                                            <div class="form-group mb-3">
                                                <label><?php echo label('smtp_host'); ?></label>
                                                <input type="text" id="smtp_host" name="smtp_host" class="form-control"
                                                       value="<?php echo $data['smtp_settings']->smtp_host; ?>"/>
                                            </div>
                                            <div class="form-group mb-3">
                                                <label><?php echo label('smtp_encryption'); ?></label>
                                                <input type="text" id="smtp_encryption" name="smtp_encryption"
                                                       class="form-control"
                                                       value="<?php echo $data['smtp_settings']->smtp_encryption; ?>"/>
                                            </div>
                                            <div class="form-group mb-3">
                                                <label><?php echo label('smtp_username'); ?></label>
                                                <input type="text" id="smtp_username" name="smtp_username"
                                                       class="form-control"
                                                       value="<?php echo $data['smtp_settings']->smtp_username; ?>"/>
                                            </div>
                                            <div class="form-group mb-3">
                                                <label><?php echo label('smtp_password'); ?></label>
                                                <input type="password" id="smtp_password" name="smtp_password"
                                                       class="form-control"
                                                       value="<?php echo $data['smtp_settings']->smtp_password; ?>"/>
                                            </div>
                                            <div class="form-group mb-3">
                                                <label><?php echo label('smtp_port'); ?></label>
                                                <input type="text" id="smtp_port" name="smtp_port" class="form-control"
                                                       value="<?php echo $data['smtp_settings']->smtp_port; ?>"/>
                                            </div>
                                        </div>
                                        <div class="form-group mb-3">
                                            <button class="btn btn-primary btn-wide float-end" type="submit">
                                                <?php echo label('update_smtp_settings'); ?>
                                            </button>
                                        </div>
                                    </form>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <div id="card_sendgrid_settings" class="tab-pane fade">
                    <div class="form-group mb-3">
                        <label class="form-label"><?php echo label('sendgrid_settings'); ?></label>
                        <hr>
                    </div>
                    <div class="row">
                        <div class="col-md-12">
                            <div class="cardcard-light">
                                <div class="card-body">
                                    <form action="<?php echo URLROOT; ?>/settings/update_sendgrid_settings"
                                          method="post"
                                          autocomplete="off"
                                          enctype="multipart/form-data">
                                        <div class="form-group mb-3">
                                            <label for="input-form-control"><?php echo label('sendgrid_active'); ?>
                                                ?</label>
                                            <div class="form-group mb-3">
                                                <div class="radio mybizcms-radio radio-lg radio-primary radio-inline">
                                                    <input id="radio7" class="option_autoload" name="option_autoload"
                                                           value="1" <?php if ($data['sendgrid_live_enabled']->option_autoload == '1') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="radio7"><?php echo label('yes'); ?></label>
                                                    <input id="radio8" class="option_autoload" name="option_autoload"
                                                           value="0" <?php if ($data['sendgrid_live_enabled']->option_autoload == '0') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="radio8"><?php echo label('no'); ?></label>
                                                </div>
                                            </div>
                                            <div class="form-group mb-3">
                                                <label><?php echo label('sendgrid_api_key'); ?></label>
                                                <input type="text" id="sendgrid_api_key" name="sendgrid_api_key"
                                                       class="form-control"
                                                       value="<?php echo $data['sendgrid_settings']->sendgrid_api_key; ?>"/>
                                            </div>
                                        </div>
                                        <div class="form-group mb-3">
                                            <button class="btn btn-primary btn-wide float-end" type="submit">
                                                <?php echo label('update_sendgrid_settings'); ?>
                                            </button>
                                        </div>
                                    </form>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
<?php require APPROOT . '/views/inc/footer.php'; ?>