<?php $page = 'general_settings'; ?>
<?php require APPROOT . '/views/inc/header.php'; ?>
<?php echo card_div(); ?>
<form action="<?php echo URLROOT; ?>/settings/general_settings" method="post" autocomplete="off"
      enctype="multipart/form-data">
    <div class="row">
        <div class="col-md-6">
            <div class="card mb-3">
                <div class="card-header">
                    <?php echo label('records_per_page'); ?>
                </div>
                <div class="card-body">
                    <div class="form-group mb-3">
                        <label class="form-label"><?php echo label('no_of_records_to_display_per_page'); ?></label>
                        <input type="number" name="records_per_page"
                               value="<?php echo getOption('records_per_page'); ?>" class="form-control">
                    </div>
                </div>
            </div>
        </div>

        <div class="col-md-6">
            <div class="card mb-3">
                <div class="card-header">
                    <?php echo label('enable_users_create_account'); ?>
                </div>
                <div class="card-body">
                    <div class="form-group mb-3">
                        <div class="form-check form-switch fs-5">
                            <input id="create_accounts" name="create_accounts" class="form-check-input"
                                   value="1" <?php if (getOption('create_accounts')) {
                                echo 'checked';
                            } ?> type="checkbox">
                        </div>
                    </div>
                </div>
            </div>
        </div>

        <div class="col-md-6">
            <div class="card mb-3">
                <div class="card-header">
                    <?php echo label('email_custom_errors'); ?>
                </div>
                <div class="card-body">
                    <div class="form-group mb-3">
                        <div class="form-check form-switch fs-5">
                            <input id="email_custom_errors" name="email_custom_errors" class="form-check-input"
                                   value="1" <?php if (getOption('email_custom_errors')) {
                                echo 'checked';
                            } ?> type="checkbox">
                        </div>
                    </div>
                </div>
            </div>
        </div>

        <div class="col-md-6">
            <div class="card mb-3">
                <div class="card-header">
                    <?php echo label('enable_htmlentities_decode'); ?>
                </div>
                <div class="card-body">
                    <a class="float-end" data-bs-toggle="modal"
                       data-bs-target="#enable_htmlentities_decode"><?php echo label('example'); ?></a>
                    <div class="form-group mb-3">
                        <div class="form-check form-switch fs-5">
                            <input id="htmlentities_decode_enabled" name="htmlentities_decode_enabled"
                                   class="form-check-input"
                                   value="1" <?php if (getOption('htmlentities_decode_enabled')) {
                                echo 'checked';
                            } ?> type="checkbox">
                        </div>
                    </div>
                </div>
            </div>
        </div>

        <div class="col-md-6">
            <div class="card mb-3">
                <div class="card-header">
                    <?php echo label('timezone'); ?>
                </div>
                <div class="card-body">
                    <div class="form-group mb-3">
                        <label class="form-label"><?php echo label('default_timezone'); ?></label>
                        <select data-show-subtext="true" data-live-search="true"
                                class="form-control <?php echo selectpicker(); ?>" name="default_timezone"
                                id="default_timezone">
                            <option value=""></option>
                            <?php foreach (timezones() as $timezone) { ?>
                                <option value="<?php echo $timezone->timezone; ?>" <?php if ($timezone->timezone == getOption('default_timezone')) {
                                    echo "selected";
                                } ?>><?php echo $timezone->timezone_name; ?> (<?php echo $timezone->timezone; ?>
                                    [<?php echo $timezone->timezone_gmt; ?>])
                                </option>
                            <?php } ?>
                        </select>
                    </div>
                </div>
            </div>
        </div>

        <div class="col-md-6">
            <div class="card mb-3">
                <div class="card-header">
                    <?php echo label('default_language'); ?>
                </div>
                <div class="card-body">
                    <div class="form-group mb-3">
                        <label class="form-label"><?php echo label('select_your_default_language'); ?></label>
                        <select data-show-subtext="true" data-live-search="true"
                                class="form-control <?php echo selectpicker(); ?>" id="default_language"
                                name="default_language">
                        <option value="<?php echo getOption('default_language'); ?>"><?php echo language(getOption('default_language'))->language; ?></option>
                        <?php foreach (languages() as $default_language) { ?>
                            <?php if (language_file($default_language->language_iso)) { ?>
                                <option value="<?php echo $default_language->language_iso; ?>"><?php echo $default_language->language; ?></option>
                            <?php } ?>
                        <?php } ?>
                        </select>
                    </div>
                </div>
            </div>
        </div>

        <div class="col-md-6">
            <div class="card mb-3">
                <div class="card-header">
                    <?php echo label('custom_script_and_css'); ?>
                </div>
                <div class="card-body">
                    <div class="form-group mb-3">
                        <label><?php echo label('custom_css_file_url'); ?></label>
                        <input type="url" id="custom_css_file_url" name="custom_css_file_url" class="form-control"
                               value="<?php echo getOption('custom_css_file_url'); ?>"/>
                    </div>
                    <div class="form-group mb-3">
                        <label><?php echo label('custom_js_file_url'); ?></label>
                        <input type="url" id="custom_js_file_url" name="custom_js_file_url" class="form-control"
                               value="<?php echo getOption('custom_js_file_url'); ?>"/>
                    </div>
                    <div class="mb-3">
                        <label class="form-label"><?php echo label('custom_script_in_header'); ?> </label>
                        <textarea class="form-control"
                                  name="custom_script_in_header"><?php echo getOption('custom_script_in_header'); ?></textarea>
                    </div>
                    <div class="mb-3">
                        <label class="form-label"><?php echo label('custom_script_in_footer'); ?> </label>
                        <textarea class="form-control"
                                  name="custom_script_in_footer"><?php echo getOption('custom_script_in_footer'); ?></textarea>
                    </div>
                </div>
            </div>
        </div>

        <div class="col-md-6">
            <div class="card mb-3">
                <div class="card-header">
                    <?php echo label('date_and_time_format_settings'); ?>
                </div>
                <div class="card-body">
                    <a class="float-end" data-bs-toggle="modal"
                       data-bs-target="#available_date_and_time_format_characters"><?php echo label('available_date_and_time_format_characters'); ?></a>
                    <div class="form-group mb-3">
                        <label for="input-small form-control"><?php echo label('date_format'); ?></label>
                        <?php foreach (supported_date_formats() as $date_format) { ?>
                            <div class="form-check">
                                <input id="supported_date_format<?php echo $date_format->supported_date_format_id; ?>"
                                       class="form-check-input supported_date_format_radio" name="default_date_format"
                                       value="<?php echo $date_format->supported_date_format; ?>" <?php if ($date_format->supported_date_format == getOption('default_date_format')) {
                                    echo 'checked';
                                } ?> type="radio">
                                <label for="supported_date_format<?php echo $date_format->supported_date_format_id; ?>">
                                    <?php if ($date_format->supported_date_format == 'custom') { ?>
                                        <?php echo "<code>" . $date_format->supported_date_format . "</code>"; ?>
                                        <input type="text" class="form-control"
                                               id="default_date_format"
                                               name="default_date_format">
                                    <?php } else { ?>
                                        <?php echo "<code>" . $date_format->supported_date_format . "</code>"; ?><?php echo date($date_format->supported_date_format); ?>
                                    <?php } ?>
                                </label>
                            </div>
                        <?php } ?>
                    </div>
                    <hr>
                    <div class="form-group mb-3">
                        <label for="input-small form-control"><?php echo label('date_time_format'); ?></label>
                        <?php foreach (supported_date_time_formats() as $datetime_format) { ?>
                            <div class="form-check">
                                <input id="default_datetime_format<?php echo $datetime_format->supported_datetime_format_id; ?>"
                                       class="form-check-input supported_datetime_format_radio"
                                       name="default_datetime_format"
                                       value="<?php echo $datetime_format->supported_datetime_format; ?>" <?php if ($datetime_format->supported_datetime_format == getOption('default_datetime_format')) {
                                    echo 'checked';
                                } ?> type="radio">
                                <label for="default_datetime_format<?php echo $datetime_format->supported_datetime_format_id; ?>">
                                    <?php if ($datetime_format->supported_datetime_format == 'custom') { ?>
                                        <?php echo "<code>" . $datetime_format->supported_datetime_format . "</code>"; ?>
                                        <input type="text" class="form-control"
                                               id="default_datetime_format"
                                               name="default_datetime_format">
                                    <?php } else { ?>
                                        <?php echo "<code>" . $datetime_format->supported_datetime_format . "</code>"; ?><?php echo date($datetime_format->supported_datetime_format); ?>
                                    <?php } ?>
                                </label>
                            </div>
                        <?php } ?>
                    </div>
                </div>
            </div>
        </div>

        <div class="col-md-6">
            <div class="card mb-3">
                <div class="card-header">
                    <?php echo label('not_found_setting'); ?>
                </div>
                <div class="card-body">
                    <div class="form-group mb-3">
                        <label class="form-label"><?php echo label('title'); ?></label>
                        <input type="text" name="not_found_public_title"
                               value="<?php echo getOption('not_found_public_title'); ?>"
                               class="form-control">
                    </div>
                    <div class="mb-3">
                        <label class="form-label"><?php echo label('description'); ?> </label>
                        <textarea class="form-control mceEditor" id="not_found_public_description"
                                  name="not_found_public_description"><?php echo getOption('not_found_public_description'); ?></textarea>
                    </div>
                    <div class="form-group mb-3">
                        <label class="form-label"><?php echo label('image'); ?></label>
                        <input type="file" name="not_found_public_image" accept="image/*" class="form-control">
                        <?php echo label('current'); ?> : <?php echo getOption('not_found_public_image'); ?>
                    </div>
                </div>
            </div>
        </div>

        <div class="col-md-6">
            <div class="card mb-3">
                <div class="card-header">
                    <?php echo label('graph_settings'); ?>
                </div>
                <div class="card-body">
                    <?php foreach (item_settings() as $item) { ?>
                        <div class="form-group mb-3">
                            <label><?php echo label($item->item_name); ?></label>
                            <input type="hidden" id="item_id" name="item_id[]" value="<?php echo $item->item_id; ?>"/>
                            <input type="color" id="item_hex_colour" name="item_hex_colour[]"
                                   value="<?php echo $item->item_hex_colour; ?>" class="form-control"/>
                        </div>
                    <?php } ?>
                </div>
            </div>
        </div>

        <div class="col-md-6">
            <div class="card mb-3">
                <div class="card-header">
                    <?php echo label('font_settings'); ?>
                </div>
                <div class="card-body">
                    <div class="mb-3">
                        <label class="form-label"><?php echo label('google_font_link'); ?></label>
                        <textarea class="form-control"
                                  name="google_font_link"><?php echo getOption('google_font_link'); ?></textarea>
                    </div>
                    <div class="mb-3">
                        <label class="form-label"><?php echo label('google_font_css_rules'); ?></label>
                        <textarea class="form-control"
                                  name="google_font_css_rules"><?php echo getOption('google_font_css_rules'); ?></textarea>
                    </div>
                </div>
            </div>
        </div>

        <div class="col-md-6">
            <div class="card mb-3">
                <div class="card-header">
                    <?php echo label('google_recaptcha_settings'); ?>
                </div>
                <div class="card-body">
                    <div class="form-group mb-3">
                        <label class="form-label"><?php echo label('enable_google_recaptcha'); ?></label>
                        <div class="form-check form-switch">
                            <input type="checkbox" name="enable_google_recaptcha" value="1"
                                   class="form-check-input" <?php if (getOption('enable_google_recaptcha')) {
                                echo 'checked';
                            } ?>>
                        </div>
                    </div>
                    <div class="form-group mb-3">
                        <label class="form-label"><?php echo label('google_recaptcha_site_key'); ?></label>
                        <input type="text" name="google_recaptcha_site_key"
                               value="<?php echo google_recaptcha_settings()->google_recaptcha_site_key; ?>"
                               class="form-control">
                    </div>
                    <div class="form-group mb-3">
                        <label class="form-label"><?php echo label('google_recaptcha_secret_key'); ?></label>
                        <input type="text" name="google_recaptcha_secret_key"
                               value="<?php echo google_recaptcha_settings()->google_recaptcha_secret_key; ?>"
                               class="form-control">
                    </div>
                </div>
            </div>
        </div>

        <div class="col-md-6">
            <div class="card mb-3">
                <div class="card-header">
                    <?php echo label('google_analytics_settings'); ?>
                </div>
                <div class="card-body">
                    <div class="mb-3">
                        <label class="form-label"><?php echo label('google_tracking_code'); ?></label>
                        <textarea class="form-control"
                                  name="google_tracking_code"><?php echo getOption('google_tracking_code'); ?></textarea>
                    </div>
                </div>
            </div>
        </div>

        <div class="col-md-6">
            <div class="card mb-3">
                <div class="card-header">
                    <?php echo label('pwa_settings'); ?>
                </div>
                <div class="card-body">
                    <div class="mb-3">
                        <label class="form-label"><?php echo label('manifest_json'); ?></label>

                    </div>
                    <?php
                        if (file_exists($file = APPROOT . MEDIA_FOLDER . 'manifest.json')) {
                            $jsonData = read_json_file($file);
                            $jsonContent = json_encode($jsonData, JSON_PRETTY_PRINT | JSON_UNESCAPED_SLASHES | JSON_UNESCAPED_UNICODE);
                        } else {
                            $jsonContent = label('create_pwa_manifest_json_content');
                        }
                    ?>
                    <textarea class="form-control"
                              name="pwa_settings"><?php echo $jsonContent; ?></textarea>
                </div>
            </div>
        </div>

        <div class="col-md-6">
            <div class="card mb-3">
                <div class="card-header">
                    <?php echo label('file_settings'); ?>
                </div>
                <div class="card-body">
                    <div class="form-group mb-3">
                        <label class="form-label"><?php echo label('maximum_upload_file_size'); ?>></label>
                        <div class="input-group">
                            <input type="number" name="maximum_upload_file_size"
                               value="<?php echo getOption('maximum_upload_file_size'); ?>" min="1"
                               class="form-control">
                            <div class="input-group-prepend"><span class="input-group-text">Mbs</span></div>
                        </div>
                    </div>
                </div>
            </div>
        </div>

        <div class="col-md-6">
            <div class="card mb-3">
                <div class="card-header">
                    <?php echo label('response_typing_speed'); ?>
                </div>
                <div class="card-body">
                    <div class="form-group mb-3">
                        <label><?php echo label('response_typing_speed'); ?></label>
                        <select data-show-subtext="true" data-live-search="true"
                                class="form-control <?php echo selectpicker(); ?>"
                                id="response_typing_speed" name="response_typing_speed"
                                data-container="body">
                            <option value=""></option>
                            <option value="200" <?php if (getOption('response_typing_speed') == 200) {
                                echo 'selected';
                            } ?>><?php echo label('human'); ?></option>
                            <option value="75" <?php if (getOption('response_typing_speed') == 75) {
                                echo 'selected';
                            } ?>><?php echo label('faster'); ?></option>
                            <option value="0" <?php if (getOption('response_typing_speed') == 0) {
                                echo 'selected';
                            } ?>><?php echo label('instant'); ?></option>
                        </select>
                    </div>
                </div>
            </div>
        </div>

        <div class="col-md-12">
            <div class="form-group mb-3">
                <button class="btn btn-primary btn-wide float-end" type="submit">
                    <?php echo label('update_general_settings'); ?>
                </button>
            </div>
        </div>
    </div>
</form>
<?php require APPROOT . '/views/inc/footer.php'; ?>
<script>
    $(document).ready(function () {
        $('#default_datetime_format').val('<?php echo getOption('default_datetime_format'); ?>')
    });
    $('.supported_datetime_format_radio').on('change', function () {
        var result = this.value
        if (result == 'custom') {
            $('#default_datetime_format').val('')
        } else {
            $('#default_datetime_format').val(result)
        }
    });

    $(document).ready(function () {
        $('#default_date_format').val('<?php echo getOption('default_date_format'); ?>')
    });
    $('.supported_date_format_radio').on('change', function () {
        var result = this.value
        if (result == 'custom') {
            $('#default_date_format').val('')
        } else {
            $('#default_date_format').val(result)
        }
    });
</script>

<div class="modal" id="available_date_and_time_format_characters">
    <div class="modal-dialog modal-xl">
        <div class="modal-content">

            <!-- Modal Header -->
            <div class="modal-header">
                <h4 class="modal-title"><?php echo label('available_date_and_time_format_characters'); ?></h4>
                <button type="button" class="btn-close" data-bs-dismiss="modal"></button>
            </div>

            <!-- Modal body -->
            <div class="modal-body">
                <div class=" row">
                    <div class=" col-sm-6">
                        <div class="card mb-3">
                            <div class="card-header">
                                <?php echo label('here_are_some_of_the_most_common_date_format_characters_and_their_values'); ?>
                            </div>
                            <div class="card-body">
                                <table class="table table-striped table-hover">
                                    <thead>
                                    <tr>
                                        <th><?php echo label('character'); ?></th>
                                        <th><?php echo label('meaning'); ?></th>
                                        <th><?php echo label('example'); ?></th>
                                    </tr>
                                    </thead>
                                    <tbody>
                                    <tr>
                                        <td><code>d</code></td>
                                        <td><?php echo label('day_of_the_month_with_leading_zeros'); ?></td>
                                        <td>03 <?php echo label('or'); ?> 17</td>
                                    </tr>
                                    <tr>
                                        <td><code>j</code></td>
                                        <td><?php echo label('day_of_the_month_without_leading_zeros'); ?></td>
                                        <td>3 <?php echo label('or'); ?> 17</td>
                                    </tr>
                                    <tr>
                                        <td><code>D</code></td>
                                        <td><?php echo label('day_of_the_week_as_a_three_letter_abbreviation'); ?></td>
                                        <td><?php echo label('mon'); ?></td>
                                    </tr>
                                    <tr>
                                        <td><code>l</code></td>
                                        <td><?php echo label('full_day_of_the_week'); ?></td>
                                        <td><?php echo label('monday'); ?></td>
                                    </tr>
                                    <tr>
                                        <td><code>m</code></td>
                                        <td><?php echo label('month_as_a_number_with_leading_zeros'); ?></td>
                                        <td>09 <?php echo label('or'); ?> 12</td>
                                    </tr>
                                    <tr>
                                        <td><code>n</code></td>
                                        <td><?php echo label('month_as_a_number_without_leading_zeros'); ?></td>
                                        <td>9 <?php echo label('or'); ?> 12</td>
                                    </tr>
                                    <tr>
                                        <td><code>M</code></td>
                                        <td><?php echo label('month_as_a_three_letter_abbreviation'); ?></td>
                                        <td><?php echo label('sep'); ?></td>
                                    </tr>
                                    <tr>
                                        <td><code>F</code></td>
                                        <td><?php echo label('full_month'); ?></td>
                                        <td><?php echo label('september'); ?></td>
                                    </tr>
                                    <tr>
                                        <td><code>y</code></td>
                                        <td><?php echo label('two_digit_year'); ?></td>
                                        <td>18</td>
                                    </tr>
                                    <tr>
                                        <td><code>Y</code></td>
                                        <td><?php echo label('full_year'); ?></td>
                                        <td>2018</td>
                                    </tr>
                                    </tbody>
                                </table>
                            </div>
                        </div>
                    </div>

                    <div class=" col-sm-6">
                        <div class="card mb-3">
                            <div class="card-header">
                                <?php echo label('here_are_some_of_the_most_common_time_format_characters_and_their_values'); ?>
                            </div>
                            <div class="card-body">
                                <table class="table table-striped table-hover">
                                    <thead>
                                    <tr>
                                        <th><?php echo label('character'); ?></th>
                                        <th><?php echo label('meaning'); ?></th>
                                        <th><?php echo label('example'); ?></th>
                                    </tr>
                                    </thead>
                                    <tbody>
                                    <tr>
                                        <td><code>g</code></td>
                                        <td><?php echo label('hours_in_12_hour_format_without_leading_zeros'); ?></td>
                                        <td>1 <?php echo label('or'); ?> 12</td>
                                    </tr>
                                    <tr>
                                        <td><code>h</code></td>
                                        <td><?php echo label('hours_in_12_hour_format_with_leading_zeros'); ?></td>
                                        <td>01 <?php echo label('or'); ?> 12</td>
                                    </tr>
                                    <tr>
                                        <td><code>G</code></td>
                                        <td><?php echo label('hours_in_24_hour_format_without_leading_zeros'); ?></td>
                                        <td>1 <?php echo label('or'); ?> 13</td>
                                    </tr>
                                    <tr>
                                        <td><code>H</code></td>
                                        <td><?php echo label('hours_in_24_hour_format_with_leading_zeros'); ?></td>
                                        <td>01 <?php echo label('or'); ?> 13</td>
                                    </tr>
                                    <tr>
                                        <td><code>a</code></td>
                                        <td><?php echo label('am_pm_in_lowercase'); ?></td>
                                        <td><?php echo label('am'); ?></td>
                                    </tr>
                                    <tr>
                                        <td><code>A</code></td>
                                        <td><?php echo label('am_pm_in_uppercase'); ?></td>
                                        <td><?php echo label('AM'); ?></td>
                                    </tr>
                                    <tr>
                                        <td><code>i</code></td>
                                        <td><?php echo label('seconds_with_leading_zeros'); ?></td>
                                        <td>09 <?php echo label('or'); ?> 15</td>
                                    </tr>
                                    <tr>
                                        <td><code>s</code></td>
                                        <td><?php echo label('seconds_with_leading_zeros'); ?></td>
                                        <td>05 <?php echo label('or'); ?> 30</td>
                                    </tr>
                                    </tbody>
                                </table>
                            </div>
                        </div>
                    </div>

                </div>
            </div>
        </div>
    </div>
</div>

<div class="modal" id="enable_htmlentities_decode">
    <div class="modal-dialog modal-xl">
        <div class="modal-content">

            <!-- Modal Header -->
            <div class="modal-header">
                <h4 class="modal-title"><?php echo label('this_applies_on_data_inserted_through_timyce_or_textarea'); ?></h4>
                <button type="button" class="btn-close" data-bs-dismiss="modal"></button>
            </div>

            <!-- Modal body -->
            <div class="modal-body">
                <div class="card mb-3">
                    <div class="card-body">
                        <div class="row">
                            <div class="col-md-6">
                                <div class="card mb-3">
                                    <div class="card-body">
                                        <h4><?php echo label('when_htmlentities_decode_enabled_is_disabled'); ?></h4>
                                        <?php echo htmlentities('
				<p>This is a sentence</p> <p><strong>This is a sentence</strong></p> <p><em>This is a sentence</em></p> <p><s>This is a sentence</s></p> <p>&lt;?php echo &#39;This is a sentence&#39;; ?&gt;</p> 
				'); ?>
                                    </div>
                                </div>
                            </div>
                            <div class="col-md-6">
                                <div class="card mb-3">
                                    <div class="card-body">
                                        <h4><?php echo label('when_htmlentities_decode_enabled_is_enabled'); ?></h4>
                                        <?php echo '
				<p>This is a sentence</p> <p><strong>This is a sentence</strong></p> <p><em>This is a sentence</em></p> <p><s>This is a sentence</s></p> <p>&lt;?php echo &#39;This is a sentence&#39;; ?&gt;</p> 
				'; ?>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>

        </div>
    </div>
</div>
</div>
</div>