<?php $page = 'homepage_applications'; ?>
<?php require APPROOT . '/views/inc/header.php'; ?>
<?php echo card_div(); ?>
<form action="<?php echo URLROOT; ?>/settings/homepage_applications" method="post" autocomplete="off"
      enctype="multipart/form-data">
    <div class="row">
        <div class="col-sm-7">
            <div class="card mb-3">
                <div class="card-body">
                    <div class="form-group mb-3">
                        <label class="form-label"><?php echo label('background_colour'); ?> <span
                                    class="symbol required"></span></label>
                        <div class="mb-3">
                            <div class="form-check form-check-inline">
                                <input type="radio" class="form-check-input homepage_applications_background_type"
                                       id="static" name="homepage_applications_background_type" value="static"
                                    <?php if (homepage_applications()->homepage_applications_background_type == 'static') {
                                        echo 'checked';
                                    } ?>>
                                <label class="form-check-label"
                                       for="static"><?php echo label('static_colour'); ?></label>
                            </div>
                            <div class="form-check form-check-inline">
                                <input type="radio" class="form-check-input homepage_applications_background_type"
                                       id="gradient" name="homepage_applications_background_type" value="gradient"
                                    <?php if (homepage_applications()->homepage_applications_background_type == 'gradient') {
                                        echo 'checked';
                                    } ?>>
                                <label class="form-check-label"
                                       for="gradient"><?php echo label('gradient_colour'); ?></label>
                            </div>
                            <div class="form-check form-check-inline">
                                <input type="radio" class="form-check-input homepage_applications_background_type"
                                       id="image" name="homepage_applications_background_type" value="image"
                                    <?php if (homepage_applications()->homepage_applications_background_type == 'image') {
                                        echo 'checked';
                                    } ?>>
                                <label class="form-check-label" for="image"><?php echo label('image'); ?></label>
                            </div>
                        </div>
                        <input type="color" name="homepage_applications_background_static"
                               id="homepage_applications_background_static"
                               value="<?php echo homepage_applications()->homepage_applications_background; ?>"
                               class="form-control form-control-color" style="display: none">
                        <textarea class="form-control"
                                  name="homepage_applications_background_gradient"
                                  id="homepage_applications_background_gradient"
                                  style="display: none"><?php echo homepage_applications()->homepage_applications_background; ?></textarea>
                        <input class="form-control" type="file" name="homepage_applications_background_image"
                               id="homepage_applications_background_image" style="display: none">
                    </div>
                    <div class="form-group mb-3">
                        <label class="form-label"><?php echo label('heading'); ?> <span
                                    class="symbol required"></span></label>
                        <input type="text" name="homepage_applications_heading"
                               value="<?php echo homepage_applications()->homepage_applications_heading; ?>"
                               class="form-control"
                               required>
                    </div>
                    <div class="form-group mb-3">
                        <label class="form-label"><?php echo label('title'); ?> <span
                                    class="symbol required"></span></label>
                        <input type="text" name="homepage_applications_title"
                               value="<?php echo homepage_applications()->homepage_applications_title; ?>"
                               class="form-control"
                               required>
                    </div>
                </div>
            </div>
        </div>
        <div class="col-sm-5">
            <div class="card vh-100 mb-3">
                <div class="card-body" id="playground"></div>
            </div>
        </div>

        <div class="col-md-12">
            <div class="card mb-3">
                <div class="card-header"><?php echo label('items'); ?></div>
                <div class="card-body">
                    <div class="row">
                        <div class="col-md-5">
                            <div class="form-group mb-3">
                                <label class="form-label"><?php echo label('name'); ?> <span
                                            class="symbol required"></span></label>
                            </div>
                        </div>
                        <div class="col-md-7">
                            <div class="form-group mb-3">
                                <label class="form-label"><?php echo label('icon'); ?> <span
                                            class="symbol required"></span></label>
                            </div>
                        </div>
                    </div>
                    <div class="field_wrapper">
                        <?php foreach (homepage_applications_items() as $step) { ?>
                            <div class="row">
                                <div class="col-md-5">
                                    <div class="form-group mb-3">
                                        <input type="text" name="homepage_applications_item[]"
                                               value="<?php echo $step->homepage_applications_item; ?>"
                                               class="form-control"
                                               required>
                                        <input type="hidden" name="homepage_applications_item_id[]"
                                               value="<?php echo $step->homepage_applications_item_id; ?>">
                                    </div>
                                </div>
                                <div class="col-md-7">
                                    <div class="input-group mb-3">
             <textarea class="form-control"
                       name="homepage_applications_item_icon[]"><?php echo $step->homepage_applications_item_icon; ?></textarea>
                                        <span class="input-group-text">
                        	<a href="<?php echo URLROOT . '/settings/delete_homepage_applications_item/' . $step->homepage_applications_item_id; ?>"
                               class="remove_button"><i class="fa fasolid fa-trash text-danger"></i></a>
                        </span>
                                    </div>
                                </div>
                            </div>
                        <?php } ?>
                    </div>
                    <a href="javascript:void(0);" class="add_button float-end" title="Add field"><i
                                class="fa-solid fa-plus fa-2x text-success"></i></a>
                </div>
            </div>
        </div>
        <div class="form-group mb-3">
            <button class="btn btn-primary btn-wide float-end" type="submit">
                <?php echo label('update_homepage_settings'); ?>
            </button>
        </div>
</form>
<?php require APPROOT . '/views/inc/footer.php'; ?>
<?php
    $html = '<div class="row"> <div class="col-md-5"> <div class="form-group mb-3"> <input type="text" name="homepage_applications_item[]" class="form-control" required> <input type="hidden" name="homepage_applications_item_id[]"> </div> </div> <div class="col-md-7"> <div class="input-group mb-3"> <textarea class="form-control" name="homepage_applications_item_icon[]"></textarea> <span class="input-group-text"><i class="fa-solid fa-trash text-danger remove_button_prompt"></i></span></div><span class="remove_button"></span></div>';
?>
<script type="text/javascript">
    $(document).ready(function () {
        var DEFINEDHTML = '<?php echo $html; ?>';
        var maxField = 10; //Input fields increment limitation
        var addButton = $('.add_button'); //Add button selector
        var wrapper = $('.field_wrapper'); //Input field wrapper
        var fieldHTML = DEFINEDHTML; //New input field html
        var x = 1; //Initial field counter is 1

        //Once add button is clicked
        $(addButton).click(function () {
            //Check maximum number of input fields
            var randomID = (Math.random() + 1).toString(36).substring(7); //randomnumber generator
            if (x < maxField) {
                x++; //Increment field counter
                $(wrapper).append(fieldHTML);
                $(wrapper).children().last().attr('id', 'homepage_applications_item' + randomID); //Add field html
                $('.remove_button_prompt').last().attr('id', 'remove_button_prompt' + randomID); //Add field html
                $('.remove_button').last().attr('id', 'remove_button' + randomID); //Add field html
            }

            //$(wrapper).on('click', '#remove_button_prompt'+x, function(){
            $('#remove_button_prompt' + randomID).click(function (e) {
                setTimeout(function () {
                    $('#remove_button' + randomID).click();
                }, 1);
            });

            //Once remove button is clicked
            $('#remove_button' + randomID).click(function (e) {
                e.preventDefault();
                $('#homepage_applications_item' + randomID).remove(); //Remove field html
                x--; //Decrement field counter
            });
        });
    });
</script>
<script>
    $(document).ready(function () {
        $('input[type="radio"]').click(function () {
            var value = $(this).val();
            if (value == 'static') {
                $('#homepage_applications_background_static').show();
                $('#homepage_applications_background_gradient').hide();
                $('#homepage_applications_background_image').hide();
                $('#playground').css('background-color', '<?php echo homepage_applications()->homepage_applications_background; ?>');
            } else if (value == 'gradient') {
                $('#homepage_applications_background_static').hide();
                $('#homepage_applications_background_gradient').show();
                $('#homepage_applications_background_image').hide();
                $('#playground').css('background-image', '<?php echo homepage_applications()->homepage_applications_background; ?>');
            } else if (value == 'image') {
                $('#homepage_applications_background_static').hide();
                $('#homepage_applications_background_gradient').hide();
                $('#homepage_applications_background_image').show();
                var img = '<?php echo URLROOT . "/app/uploads/media/" . homepage_applications()->homepage_applications_background; ?>';
                $('#playground').css("background-image", "url(" + img + ")");
            }
        });

        var value = $(".homepage_applications_background_type:checked").val();
        $('input:radio[name=homepage_applications_background_type][value=' + value + ']:checked').trigger('click');

    });
</script>