<?php $page = 'homepage_faqs'; ?>
<?php require APPROOT . '/views/inc/header.php'; ?>
<?php echo card_div(); ?>
<div class="row">
    <div class="col-sm-7">
        <form action="<?php echo URLROOT; ?>/settings/homepage_faqs" method="post" autocomplete="off"
              enctype="multipart/form-data">
            <div class="card mb-3">
                <div class="card-body">
                    <div class="form-group mb-3">
                        <label class="form-label"><?php echo label('background_colour'); ?> <span
                                    class="symbol required"></span></label>
                        <div class="mb-3">
                            <div class="form-check form-check-inline">
                                <input type="radio" class="form-check-input homepage_faqs_background_type" id="static"
                                       name="homepage_faqs_background_type" value="static"
                                    <?php if (homepage_faqs()->homepage_faqs_background_type == 'static') {
                                        echo 'checked';
                                    } ?>>
                                <label class="form-check-label"
                                       for="static"><?php echo label('static_colour'); ?></label>
                            </div>
                            <div class="form-check form-check-inline">
                                <input type="radio" class="form-check-input homepage_faqs_background_type" id="gradient"
                                       name="homepage_faqs_background_type" value="gradient"
                                    <?php if (homepage_faqs()->homepage_faqs_background_type == 'gradient') {
                                        echo 'checked';
                                    } ?>>
                                <label class="form-check-label"
                                       for="gradient"><?php echo label('gradient_colour'); ?></label>
                            </div>
                            <div class="form-check form-check-inline">
                                <input type="radio" class="form-check-input homepage_faqs_background_type" id="image"
                                       name="homepage_faqs_background_type" value="image"
                                    <?php if (homepage_faqs()->homepage_faqs_background_type == 'image') {
                                        echo 'checked';
                                    } ?>>
                                <label class="form-check-label" for="image"><?php echo label('image'); ?></label>
                            </div>
                        </div>
                        <input type="color" name="homepage_faqs_background_static" id="homepage_faqs_background_static"
                               value="<?php echo homepage_faqs()->homepage_faqs_background; ?>"
                               class="form-control form-control-color" style="display: none">
                        <textarea class="form-control"
                                  name="homepage_faqs_background_gradient" id="homepage_faqs_background_gradient"
                                  style="display: none"><?php echo homepage_faqs()->homepage_faqs_background; ?></textarea>
                        <input class="form-control" type="file" name="homepage_faqs_background_image"
                               id="homepage_faqs_background_image" style="display: none">
                    </div>
                    <div class="form-group mb-3">
                        <label class="form-label"><?php echo label('heading'); ?> <span
                                    class="symbol required"></span></label>
                        <input type="text" name="homepage_faqs_heading"
                               value="<?php echo homepage_faqs()->homepage_faqs_heading; ?>"
                               class="form-control"
                               required>
                    </div>
                    <div class="form-group mb-3">
                        <label class="form-label"><?php echo label('title'); ?> <span
                                    class="symbol required"></span></label>
                        <input type="text" name="homepage_faqs_title"
                               value="<?php echo homepage_faqs()->homepage_faqs_title; ?>"
                               class="form-control"
                               required>
                    </div>
                    <div class="form-group mb-3">
                        <button class="btn btn-primary btn-wide float-end" type="submit">
                            <?php echo label('update_homepage_settings'); ?>
                        </button>
                    </div>
                </div>
            </div>
        </form>
    </div>
    <div class="col-md-5">
        <div class="card vh-100 mb-3">
            <div class="card-body" id="playground"></div>
        </div>
    </div>
</div>
<?php require APPROOT . '/views/inc/footer.php'; ?>
<script>
    $(document).ready(function () {
        $('input[type="radio"]').click(function () {
            var value = $(this).val();
            if (value == 'static') {
                $('#homepage_faqs_background_static').show();
                $('#homepage_faqs_background_gradient').hide();
                $('#homepage_faqs_background_image').hide();
                $('#playground').css('background-color', '<?php echo homepage_faqs()->homepage_faqs_background; ?>');
            } else if (value == 'gradient') {
                $('#homepage_faqs_background_static').hide();
                $('#homepage_faqs_background_gradient').show();
                $('#homepage_faqs_background_image').hide();
                $('#playground').css('background-image', '<?php echo homepage_faqs()->homepage_faqs_background; ?>');
            } else if (value == 'image') {
                $('#homepage_faqs_background_static').hide();
                $('#homepage_faqs_background_gradient').hide();
                $('#homepage_faqs_background_image').show();
                var img = '<?php echo URLROOT . "/app/uploads/media/" . homepage_faqs()->homepage_faqs_background; ?>';
                $('#playground').css("background-image", "url(" + img + ")");
            }
        });

        var value = $(".homepage_faqs_background_type:checked").val();
        $('input:radio[name=homepage_faqs_background_type][value=' + value + ']:checked').trigger('click');

    });
</script>