<?php $page = 'homepage_intro'; ?>
<?php require APPROOT . '/views/inc/header.php'; ?>
<?php echo card_div(); ?>
<form action="<?php echo URLROOT; ?>/settings/homepage_intro" method="post" autocomplete="off"
      enctype="multipart/form-data">
    <div class="row">
        <div class="col-md-7">
            <div class="card mb-3">
                <div class="card-body">
                    <div class="form-group mb-3">
                        <label class="form-label"><?php echo label('background_colour'); ?> <span
                                    class="symbol required"></span></label>
                        <div class="mb-3">
                            <div class="form-check form-check-inline">
                                <input type="radio" class="form-check-input homepage_intro_background_type" id="static"
                                       name="homepage_intro_background_type" value="static"
                                    <?php if (homepage_intro()->homepage_intro_background_type == 'static') {
                                        echo 'checked';
                                    } ?>>
                                <label class="form-check-label"
                                       for="static"><?php echo label('static_colour'); ?></label>
                            </div>
                            <div class="form-check form-check-inline">
                                <input type="radio" class="form-check-input homepage_intro_background_type"
                                       id="gradient" name="homepage_intro_background_type" value="gradient"
                                    <?php if (homepage_intro()->homepage_intro_background_type == 'gradient') {
                                        echo 'checked';
                                    } ?>>
                                <label class="form-check-label"
                                       for="gradient"><?php echo label('gradient_colour'); ?></label>
                            </div>
                            <div class="form-check form-check-inline">
                                <input type="radio" class="form-check-input homepage_intro_background_type" id="image"
                                       name="homepage_intro_background_type" value="image"
                                    <?php if (homepage_intro()->homepage_intro_background_type == 'image') {
                                        echo 'checked';
                                    } ?>>
                                <label class="form-check-label" for="image"><?php echo label('image'); ?></label>
                            </div>
                        </div>
                        <input type="color" name="homepage_intro_background_static"
                               id="homepage_intro_background_static"
                               value="<?php echo homepage_intro()->homepage_intro_background; ?>"
                               class="form-control form-control-color" style="display: none">
                        <textarea class="form-control"
                                  name="homepage_intro_background_gradient" id="homepage_intro_background_gradient"
                                  style="display: none"><?php echo homepage_intro()->homepage_intro_background; ?></textarea>
                        <input class="form-control" type="file" name="homepage_intro_background_image"
                               id="homepage_intro_background_image" style="display: none">
                    </div>
                    <div class="form-group mb-3">
                        <label class="form-label"><?php echo label('title'); ?> <span
                                    class="symbol required"></span></label>
                        <textarea class="form-control mceEditor" id="homepage_intro_title"
                                  name="homepage_intro_title"
                                  required><?php echo homepage_intro()->homepage_intro_title; ?></textarea>
                    </div>
                    <div class="form-group mb-3">
                        <label class="form-label">
                            <?php echo label('description'); ?> <span
                                    class="symbol required"></span>
                        </label>
                        <textarea class="form-control mceEditor" id="homepage_intro_description"
                                  name="homepage_intro_description"><?php echo homepage_intro()->homepage_intro_description; ?></textarea>
                    </div>
                    <div class="form-group mb-3">
                        <label class="form-label">
                            <?php echo label('sub_description'); ?> <span
                                    class="symbol required"></span>
                        </label>
                        <textarea class="form-control mceEditor" id="homepage_intro_sub_description"
                                  name="homepage_intro_sub_description"><?php echo homepage_intro()->homepage_intro_sub_description; ?></textarea>
                    </div>
                    <div class="form-group mb-3">
                        <label class="form-label"><?php echo label('image'); ?> <span
                                    class="symbol required"></span></label>
                        <div class="input-group">
                            <input class="form-control" type="file" name="homepage_intro_image">
                            <span class="input-group-text link-primary" data-bs-toggle="modal"
                                  data-bs-target="#exampleModal"><i class="fa-solid fa-image"></i></span>
                        </div>
                    </div>
                    <div class="form-group mb-3">
                        <label class="form-label"><?php echo label('image_text'); ?> <span
                                    class="symbol required"></span></label>
                        <textarea class="form-control mceEditor" id="homepage_intro_image_text"
                                  name="homepage_intro_image_text"
                                  required><?php echo homepage_intro()->homepage_intro_image_text; ?></textarea>
                    </div>
                </div>
            </div>
        </div>
        <div class="col-md-5">
            <div class="card vh-100 mb-3">
                <div class="card-body" id="playground"></div>
            </div>
        </div>
        <div class="col-md-7">
            <div class="card mb-3">
                <div class="card-body">
                    <div class="card-header"><?php echo label('items'); ?></div>
                    <div class="field_wrapper">
                        <?php foreach (homepage_intro_items() as $intro_item) { ?>
                            <div class="row">
                                <div class="col-md-6">
                                    <div class="mb-3">
                                        <input type="text" class="form-control" id="homepage_intro_item"
                                               name="homepage_intro_item[]"
                                               value="<?php echo $intro_item->homepage_intro_item; ?>">
                                    </div>
                                </div>
                                <div class="col-md-6">
                                    <div class="input-group mb-3">
                                        <input type="hidden" name="homepage_intro_item_id[]"
                                               value="<?php echo $intro_item->homepage_intro_item_id; ?>"
                                               class="form-control">
                                        <input type="text" class="form-control" id="homepage_intro_item_value"
                                               name="homepage_intro_item_value[]"
                                               value="<?php echo $intro_item->homepage_intro_item_value; ?>">
                                        <span class="input-group-text"><a
                                                    href="<?php echo URLROOT . '/settings/delete_homepage_intro_item/' . $intro_item->homepage_intro_item_id; ?>"
                                                    class="remove_button"><i
                                                        class="fa fasolid fa-trash text-danger"></i></a></span>
                                    </div>
                                </div>
                            </div>
                        <?php } ?>
                    </div>
                    <a href="javascript:void(0);" class="add_button float-end" title="Add field"><i
                                class="fa-solid fa-plus fa-2x text-success"></i></a>
                </div>
            </div>
        </div>
    </div>
    <div class="form-group mb-3">
        <button class="btn btn-primary btn-wide float-end" type="submit">
            <?php echo label('update_homepage_settings'); ?>
        </button>
    </div>
</form>
<?php require APPROOT . '/views/inc/footer.php'; ?>
<div class="modal fade" id="exampleModal" tabindex="-1" aria-labelledby="exampleModalLabel" aria-hidden="true">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <h1 class="modal-title fs-5" id="exampleModalLabel"><?php echo label('image'); ?></h1>
                <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
            </div>
            <div class="modal-body">
                <img class="w-100 rounded-5"
                     src="<?php echo URLROOT . '/app' . MEDIA_FOLDER . homepage_intro()->homepage_intro_image; ?>"
                     alt="<?php echo company(1)->company_name; ?>">
            </div>
        </div>
    </div>
</div>
<script>
    $(document).ready(function () {
        $('input[type="radio"]').click(function () {
            var value = $(this).val();
            if (value == 'static') {
                $('#homepage_intro_background_static').show();
                $('#homepage_intro_background_gradient').hide();
                $('#homepage_intro_background_image').hide();
                $('#playground').css('background-color', '<?php echo homepage_intro()->homepage_intro_background; ?>');
            } else if (value == 'gradient') {
                $('#homepage_intro_background_static').hide();
                $('#homepage_intro_background_gradient').show();
                $('#homepage_intro_background_image').hide();
                $('#playground').css('background-image', '<?php echo homepage_intro()->homepage_intro_background; ?>');
            } else if (value == 'image') {
                $('#homepage_intro_background_static').hide();
                $('#homepage_intro_background_gradient').hide();
                $('#homepage_intro_background_image').show();
                var img = '<?php echo URLROOT . "/app/uploads/media/" . homepage_intro()->homepage_intro_background; ?>';
                $('#playground').css("background-image", "url(" + img + ")");
            }
        });

        var value = $(".homepage_intro_background_type:checked").val();
        $('input:radio[name=homepage_intro_background_type][value=' + value + ']:checked').trigger('click');

    });
</script>
<?php
    $html = '<div class="form-group"><div class="input-group mb-3"><input type="text" class="form-control" name="homepage_intro_item[]"><span class="input-group-text remove_button_prompt"><i class="fa-solid fa-trash text-danger"></i></span></div><span class="remove_button"></span></div>';
?>
<script type="text/javascript">
    $(document).ready(function () {
        var DEFINEDHTML = '<?php echo $html; ?>';
        var maxField = 10; //Input fields increment limitation
        var addButton = $('.add_button'); //Add button selector
        var wrapper = $('.field_wrapper'); //Input field wrapper
        var fieldHTML = DEFINEDHTML; //New input field html
        var x = 1; //Initial field counter is 1

        //Once add button is clicked
        $(addButton).click(function () {
            //Check maximum number of input fields
            var randomID = (Math.random() + 1).toString(36).substring(7); //randomnumber generator
            if (x < maxField) {
                x++; //Increment field counter
                $(wrapper).append(fieldHTML);
                $(wrapper).children().last().attr('id', 'homepage_intro_item' + randomID); //Add field html
                $('.remove_button_prompt').last().attr('id', 'remove_button_prompt' + randomID); //Add field html
                $('.remove_button').last().attr('id', 'remove_button' + randomID); //Add field html
            }

            //$(wrapper).on('click', '#remove_button_prompt'+x, function(){
            $('#remove_button_prompt' + randomID).click(function (e) {
                setTimeout(function () {
                    $('#remove_button' + randomID).click();
                }, 1);
            });

            //Once remove button is clicked
            $('#remove_button' + randomID).click(function (e) {
                e.preventDefault();
                $('#homepage_intro_item' + randomID).remove(); //Remove field html
                x--; //Decrement field counter
            });
        });
    });
</script>