<?php $page = 'homepage_settings'; ?>
<?php require APPROOT . '/views/inc/header.php'; ?>
<?php echo card_div(); ?>
    <div class="row">
        <div class="col-md-6">
		    <div class="card mb-3">
		        <div class="card-header">
		            <?php echo label('sections'); ?>
		        </div>
		        <div class="card-body">
			        <table class="table table-hover caption-top">
			            <caption><?php echo label('drag_and_drop_to_order_sections'); ?></caption>
			            <thead>
			            <tr>
			                <th><?php echo label('section'); ?></th>
			                <th><?php echo label('active'); ?></th>
			                <th><?php echo label('show_in_header'); ?></th>
			            </tr>
			            </thead>
			            <tbody class="row_position">
			            <?php foreach (homepage_sections() as $section) { ?>
			                <tr id="<?php echo $section->homepage_section_id; ?>">
			                    <td>
			                        <i class="fa-solid fa-arrows-up-down-left-right"></i> <?php echo label($section->homepage_section); ?>
			                    </td>
			                    <td class="text-end">
			                        <div class="form-check form-switch">
			                            <input class="form-check-input" type="checkbox"
			                                   id="activate_section<?php echo $section->homepage_section_id; ?>" <?php if ($section->homepage_section_status_id) {
			                                echo 'checked';
			                            } ?>>
			                            <span
			                                    class="message_box<?php echo $section->homepage_section_id; ?>"></span>
			                        </div>
			                    </td>
			                    <td class="text-end">
			                        <div class="form-check form-switch">
			                            <input class="form-check-input" type="checkbox"
			                                   id="show_in_header<?php echo $section->homepage_section_id; ?>" <?php if ($section->homepage_section_show_in_header) {
			                                echo 'checked';
			                            } ?>>
			                            <span
			                                    class="message_box_show_in_header<?php echo $section->homepage_section_id; ?>"></span>
			                        </div>
			                    </td>
			                </tr>
			            <?php } ?>
			            </tbody>
			        </table>
			    </div>
		    </div>
    	</div>
        <div class="col-md-6">
		    <div class="card mb-3">
		        <div class="card-header">
		            <?php echo label('general'); ?>
		        </div>
		        <div class="card-body">
<form action="<?php echo URLROOT; ?>/settings/homepage_settings" method="post" autocomplete="off"
                      enctype="multipart/form-data">
		            <div class="form-group mb-3">
		                <label class="form-label"><?php echo label('enable_homepage'); ?> <span
		                            class="symbol required"></span></label>
			                        <div class="form-check form-switch fs-5">
			                            <input class="form-check-input" type="checkbox" name="enable_homepage" value="1"
			                                   id="enable_homepage" <?php if (getOption('enable_homepage')) {
			                                echo 'checked';
			                            } ?>>
			                        </div>
		        </div>
		            <div class="form-group mb-3">
		                <label class="form-label"><?php echo label('gradient_colour'); ?> <span
		                            class="symbol required"></span></label>
		        		<textarea class="form-control"
			                          name="homepage_gradient_colour" id="homepage_gradient_colour"><?php echo getOption('homepage_gradient_colour'); ?></textarea>
		        </div>
		        
        <div class="form-group mb-3">
            <button class="btn btn-primary btn-wide float-end" type="submit">
                <?php echo label('update_homepage_settings'); ?>
            </button>
        </div>
        </form>
		    </div>
		</div>
    </div>
<?php require APPROOT . '/views/inc/footer.php'; ?>
    <script>
        $(document).ready(function () {
            $(".row_position").sortable({
                delay: 150,
                stop: function () {
                    var selectedData = [];
                    $('.row_position>tr').each(function () {
                        selectedData.push($(this).attr("id"));
                    });
                    updateHomepageSectionOrder(selectedData);
                }
            });
        });

        function updateHomepageSectionOrder() {
            var selectedData = [];
            $('.row_position>tr').each(function () {
                selectedData.push($(this).attr("id"));
            });
            var order_string = 'position=' + selectedData;
            $.ajax({
                type: "GET",
                url: "update_section_order",
                data: order_string,
                cache: false,
                success: function (data) {
                }
            });
        }
    </script>
<?php foreach (homepage_sections() as $section) { ?>
    <script>
        $(document).ready(function () {
            var delay = 2000;

            var homepage_section_id = "<?php echo $section->homepage_section_id; ?>";
            $('#activate_section' + homepage_section_id).click(function (e) {
                if ($('#activate_section' + homepage_section_id).is(":checked")) {
                    var action = 'delete';
                    var status = 1;
                } else {
                    var action = 'add';
                    var status = 0;
                }

                e.preventDefault();
                $.ajax
                ({
                    type: "POST",
                    url: "<?php echo URLROOT; ?>/settings/homepage_section_status",
                    data: "homepage_section_id=" + homepage_section_id + "&homepage_section_status_id=" + status,
                    beforeSend: function () {
                        $('.message_box' + homepage_section_id).html('<div class="spinner-border spinner-border-sm text-primary"></div>');
                    },
                    success: function (data) {
                        var result = jQuery.parseJSON(data);
                        setTimeout(function () {
                            $('.message_box' + homepage_section_id).html('');
                        }, delay);
                        if (action == 'add') {
                            $('#activate_section' + homepage_section_id).prop('checked', false);
                        } else {
                            $('#activate_section' + homepage_section_id).prop('checked', true);
                        }
                    }
                });
            });

            $('#show_in_header' + homepage_section_id).click(function (e) {
                if ($('#show_in_header' + homepage_section_id).is(":checked")) {
                    var action = 'uncheck';
                    var status = 1;
                } else {
                    var action = 'check';
                    var status = 0;
                }

                e.preventDefault();
                $.ajax
                ({
                    type: "POST",
                    url: "<?php echo URLROOT; ?>/settings/homepage_section_show_in_header",
                    data: "homepage_section_id=" + homepage_section_id + "&homepage_section_show_in_header=" + status,
                    beforeSend: function () {
                        $('.message_box_show_in_header' + homepage_section_id).html('<div class="spinner-border spinner-border-sm text-primary"></div>');
                    },
                    success: function (data) {
                        var result = jQuery.parseJSON(data);
                        setTimeout(function () {
                            $('.message_box_show_in_header' + homepage_section_id).html('');
                        }, delay);
                        if (action == 'check') {
                            $('#show_in_header' + homepage_section_id).prop('checked', false);
                        } else {
                            $('#show_in_header' + homepage_section_id).prop('checked', true);
                        }
                    }
                });
            });
        });
    </script>
<?php } ?>