<?php $page = 'payment_settings'; ?>
<?php require APPROOT . '/views/inc/header.php'; ?>
<?php echo card_div(); ?>
    <div class="card mb-3">
        <div class="card-body">
            <ul class="nav nav-tabs nav-justified">
                <li class="nav-item"><a data-bs-toggle="tab" href="#panel_payment_settings_overview"
                                        class="active nav-link"><?php echo label('overview'); ?></a></li>
                <?php foreach (payment_options(1) as $payment_option) { ?>
                    <?php $payment_option_slug = $payment_option->payment_option; ?>
                    <li class="nav-item"><a data-bs-toggle="tab"
                                            href="#panel_<?php echo $payment_option_slug; ?>_settings"
                                            class="nav-link text-nowrap"><?php echo $payment_option->payment_option_name; ?></a>
                    </li>
                <?php } ?>
            </ul>
            <div class="tab-content">
                <div id="panel_payment_settings_overview" class="tab-pane active" role="tabpanel"
                     aria-labelledby="panel_paypal_standard_settings_tab">
                    <div class="row">
                        <div class="col-sm-12">
                            <div class="card bg-transparent mt-3">
                                <div class="card-header">
                                    <?php echo label('payment_settings_overview'); ?>
                                </div>
                                <div class="card-body">
                                    <table class="table table-striped table-hover">
                                        <thead>
                                        <tr>
                                            <th><?php echo label('payment_gateway'); ?></th>
                                            <th><?php echo label('is_sandbox_or_live'); ?>?</th>
                                            <th><?php echo label('is_active'); ?>?</th>
                                            <th>
                                                <?php echo label('is'); ?> <?php echo getOption('default_currency'); ?> <?php echo label('accepted'); ?>
                                                ?
                                            </th>
                                        </tr>
                                        </thead>
                                        <tbody>
                                        <?php foreach (payment_options(1) as $payment_option) { ?>
                                            <?php if (!in_array($payment_option->payment_option, array('wallet', 'free-trial'))) { ?>
                                                <tr>
                                                    <td><?php echo $payment_option->payment_option_name; ?></td>
                                                    <td><?php if (payment_option_settings($payment_option->payment_option)['live_enabled']->option_value == '1') {
                                                            echo '<span class="label label-success">' . label('live') . '</span>';
                                                        } else {
                                                            echo '<span class="label label-warning">' . label('sandbox_demo') . '</span>';
                                                        } ?></td>
                                                    <td><?php echo yes_no_label(payment_option_settings($payment_option->payment_option)['live_enabled']->option_autoload); ?></td>
                                                    <td><?php
                                                            $currencies = explode(',', $payment_option->payment_option_currencies);
                                                            $currencies = array_map('trim', $currencies);
                                                            if (!in_array(getOption('default_currency'), $currencies)) {
                                                                echo yes_no_label(0);
                                                            } else {
                                                                echo yes_no_label(1);
                                                            } ?></td>
                                                </tr>
                                            <?php } ?>
                                        <?php } ?>
                                        </tbody>
                                    </table>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <div id="panel_paypal_standard_settings" class="tab-pane fade">
                    <div class="card bg-transparent mt-3">
                        <div class="card-header">
                            <?php echo label('paypal_standard_settings'); ?>
                        </div>
                        <div class="card-body">
                            <form action="<?php echo URLROOT; ?>/settings/update_paypal_standard_settings"
                                  method="post" autocomplete="off" enctype="multipart/form-data">
                                <div class="mb-3">
                                    <label for="input-form-control"><?php echo label('paypal_standard_active'); ?>
                                        ?</label>
                                    <div class="mb-3">
                                        <div class="form-check form-check-inline">
                                            <input id="paypal_standard11" class="form-check-input"
                                                   name="option_autoload"
                                                   value="1" <?php if (payment_option_settings('paypal_standard')['live_enabled']->option_autoload == '1') {
                                                echo 'checked';
                                            } ?> type="radio">
                                            <label for="paypal_standard11"><?php echo label('yes'); ?></label>
                                        </div>
                                        <div class="form-check form-check-inline">
                                            <input id="paypal_standard00" class="form-check-input"
                                                   name="option_autoload"
                                                   value="0" <?php if (payment_option_settings('paypal_standard')['live_enabled']->option_autoload == '0') {
                                                echo 'checked';
                                            } ?> type="radio">
                                            <label for="paypal_standard00"><?php echo label('no'); ?></label>
                                        </div>
                                    </div>
                                    <label for="input-form-control"><?php echo label('paypal_standard_status'); ?></label>
                                    <div class="mb-3">
                                        <div class="form-check form-check-inline">
                                            <input id="paypal_standard0" class="form-check-input"
                                                   name="paypal_standard_status"
                                                   value="0" <?php if (payment_option_settings('paypal_standard')['live_enabled']->option_value == '0') {
                                                echo 'checked';
                                            } ?> type="radio">
                                            <label for="paypal_standard0"><?php echo label('sandbox_demo'); ?></label>
                                        </div>
                                        <div class="form-check form-check-inline">
                                            <input id="paypal_standard1" class="form-check-input"
                                                   name="paypal_standard_status"
                                                   value="1" <?php if (payment_option_settings('paypal_standard')['live_enabled']->option_value == '1') {
                                                echo 'checked';
                                            } ?> type="radio">
                                            <label for="paypal_standard1"><?php echo label('live'); ?></label>
                                        </div>
                                    </div>
                                </div>
                                <div class="mb-3">
                                    <label><?php echo label('paypal_standard_label'); ?></label>
                                    <input type="text" id="paypal_standard_label" name="paypal_standard_label"
                                           class="form-control"
                                           value="<?php echo getOption('paypal_standard_label'); ?>"/>
                                </div>
                                <div class="mb-3">
                                    <label><?php echo label('paypal_standard_email'); ?></label>
                                    <input type="text" id="paypal_standard_email" name="paypal_standard_email"
                                           class="form-control"
                                           value="<?php echo payment_option_settings('paypal_standard')['settings']->paypal_standard_email; ?>"/>
                                </div>
                                <div class="mb-3">
                                    <label><?php echo label('accepted_currencies'); ?></label>
                                    <textarea id="payment_option_currencies" name="payment_option_currencies"
                                              class="form-control"><?php echo payment_option_slug('paypal_standard')->payment_option_currencies; ?></textarea>
                                </div>
                                <div class="mb-3">
                                    <button class="btn btn-primary btn-wide float-end" type="submit">
                                        <?php echo label('update_paypal_standard_settings'); ?>
                                    </button>
                                </div>
                            </form>
                        </div>
                    </div>
                </div>
                <div id="panel_paypal_pro_settings" class="tab-pane fade">
                    <div class="row">
                        <div class="col-sm-12">
                            <div class="card bg-transparent mt-3">
                                <div class="card-header">
                                    <?php echo label('paypal_pro_settings'); ?>
                                </div>
                                <div class="card-body">
                                    <form action="<?php echo URLROOT; ?>/settings/update_paypal_pro_settings"
                                          method="post"
                                          autocomplete="off"
                                          enctype="multipart/form-data">

                                        <label for="input-form-control"><?php echo label('paypal_pro_active'); ?>
                                            ?</label>
                                        <div class="mb-3">
                                            <div class="form-check form-check-inline">
                                                <input id="paypal_pro11" class="option_autoload" name="option_autoload"
                                                       value="1" <?php if (payment_option_settings('paypal_pro')['live_enabled']->option_autoload == '1') {
                                                    echo 'checked';
                                                } ?> type="radio">
                                                <label for="paypal_pro11"><?php echo label('yes'); ?></label>
                                                <input id="paypal_pro00" class="option_autoload" name="option_autoload"
                                                       value="0" <?php if (payment_option_settings('paypal_pro')['live_enabled']->option_autoload == '0') {
                                                    echo 'checked';
                                                } ?> type="radio">
                                                <label for="paypal_pro00"><?php echo label('no'); ?></label>
                                            </div>
                                        </div>
                                        <label for="input-form-control"><?php echo label('paypal_pro_status'); ?></label>
                                        <div class="mb-3">
                                            <div class="form-check form-check-inline">
                                                <input id="paypal_pro0" class="paypal_pro_status"
                                                       name="paypal_pro_status"
                                                       value="0" <?php if (payment_option_settings('paypal_pro')['live_enabled']->option_value == '0') {
                                                    echo 'checked';
                                                } ?> type="radio">
                                                <label for="paypal_pro0"><?php echo label('sandbox_demo'); ?></label>
                                                <input id="paypal_pro1" class="paypal_pro_status"
                                                       name="paypal_pro_status"
                                                       value="1" <?php if (payment_option_settings('paypal_pro')['live_enabled']->option_value == '1') {
                                                    echo 'checked';
                                                } ?> type="radio">
                                                <label for="paypal_pro1"><?php echo label('live'); ?></label>
                                            </div>
                                        </div>
                                        <div class="mb-3">
                                            <label><?php echo label('paypal_pro_label'); ?></label>
                                            <input type="text" id="paypal_pro_label" name="paypal_pro_label"
                                                   class="form-control"
                                                   value="<?php echo getOption('paypal_pro_label'); ?>"/>
                                        </div>
                                        <div class="mb-3">
                                            <label><?php echo label('paypal_pro_username'); ?></label>
                                            <input type="text" id="paypal_pro_username" name="paypal_pro_username"
                                                   class="form-control"
                                                   value="<?php echo payment_option_settings('paypal_pro')['settings']->paypal_pro_username; ?>"/>
                                        </div>
                                        <div class="mb-3">
                                            <label><?php echo label('paypal_pro_password'); ?></label>
                                            <input type="text" id="paypal_pro_password" name="paypal_pro_password"
                                                   class="form-control"
                                                   value="<?php echo payment_option_settings('paypal_pro')['settings']->paypal_pro_password; ?>"/>
                                        </div>
                                        <div class="mb-3">
                                            <label><?php echo label('paypal_pro_signature'); ?></label>
                                            <input type="text" id="paypal_pro_signature" name="paypal_pro_signature"
                                                   class="form-control"
                                                   value="<?php echo payment_option_settings('paypal_pro')['settings']->paypal_pro_signature; ?>"/>
                                        </div>
                                        <div class="mb-3">
                                            <label><?php echo label('accepted_currencies'); ?></label>
                                            <textarea id="payment_option_currencies" name="payment_option_currencies"
                                                      class="form-control"><?php echo payment_option_slug('paypal_pro')->payment_option_currencies; ?></textarea>
                                        </div>
                                        <div class="mb-3">
                                            <button class="btn btn-primary btn-wide float-end" type="submit">
                                                <?php echo label('update_paypal_pro_settings'); ?>
                                            </button>
                                        </div>
                                    </form>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <div id="panel_stripe_settings" class="tab-pane fade">
                    <div class="row">
                        <div class="col-sm-12">
                            <div class="card bg-transparent mt-3">
                                <div class="card-header">
                                    <?php echo label('stripe_settings'); ?>
                                </div>
                                <div class="card-body">
                                    <form action="<?php echo URLROOT; ?>/settings/update_stripe_settings" method="post"
                                          autocomplete="off"
                                          enctype="multipart/form-data">

                                        <div class="mb-3">
                                            <label for="input-form-control"><?php echo label('stripe_active'); ?>
                                                ?</label>
                                            <div class="mb-3">
                                                <div class="form-check form-check-inline">
                                                    <input id="stripe11" class="option_autoload" name="option_autoload"
                                                           value="1" <?php if (payment_option_settings('stripe')['live_enabled']->option_autoload == '1') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="stripe11"><?php echo label('yes'); ?></label>
                                                    <input id="stripe00" class="option_autoload" name="option_autoload"
                                                           value="0" <?php if (payment_option_settings('stripe')['live_enabled']->option_autoload == '0') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="stripe00"><?php echo label('no'); ?></label>
                                                </div>
                                            </div>
                                            <label for="input-form-control"><?php echo label('stripe_status'); ?></label>
                                            <div class="mb-3">
                                                <div class="form-check form-check-inline">
                                                    <input id="stripe0" class="stripe_status" name="stripe_status"
                                                           value="0" <?php if (payment_option_settings('stripe')['live_enabled']->option_value == '0') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="stripe0"><?php echo label('sandbox_demo'); ?></label>
                                                    <input id="stripe1" class="stripe_status" name="stripe_status"
                                                           value="1" <?php if (payment_option_settings('stripe')['live_enabled']->option_value == '1') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="stripe1"><?php echo label('live'); ?></label>
                                                </div>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('stripe_label'); ?></label>
                                                <input type="text" id="stripe_label" name="stripe_label"
                                                       class="form-control"
                                                       value="<?php echo getOption('stripe_label'); ?>"/>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('stripe_secret_key'); ?></label>
                                                <input type="text" id="stripe_secret_key" name="stripe_secret_key"
                                                       class="form-control"
                                                       value="<?php echo payment_option_settings('stripe')['settings']->stripe_secret_key; ?>"/>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('stripe_publishable_key'); ?></label>
                                                <input type="text" id="stripe_publishable_key"
                                                       name="stripe_publishable_key"
                                                       class="form-control"
                                                       value="<?php echo payment_option_settings('stripe')['settings']->stripe_publishable_key; ?>"/>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('accepted_currencies'); ?></label>
                                                <textarea id="payment_option_currencies"
                                                          name="payment_option_currencies"
                                                          class="form-control"><?php echo payment_option_slug('stripe')->payment_option_currencies; ?></textarea>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('accepted_zero_decimal_currencies'); ?></label>
                                                <textarea id="payment_option_zero_decimal_currencies"
                                                          name="payment_option_zero_decimal_currencies"
                                                          class="form-control"><?php echo payment_option_slug('stripe')->payment_option_zero_decimal_currencies; ?></textarea>
                                            </div>
                                        </div>
                                        <div class="mb-3">
                                            <button class="btn btn-primary btn-wide float-end" type="submit">
                                                <?php echo label('update_stripe_settings'); ?>
                                            </button>
                                        </div>
                                    </form>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <div id="panel_authorize_net_settings" class="tab-pane fade">
                    <div class="row">
                        <div class="col-sm-12">
                            <div class="card bg-transparent mt-3">
                                <div class="card-header">
                                    <?php echo label('authorize_net_settings'); ?>
                                </div>
                                <div class="card-body">
                                    <form action="<?php echo URLROOT; ?>/settings/update_authorize_net_settings"
                                          autocomplete="off"
                                          method="post" enctype="multipart/form-data">

                                        <div class="mb-3">
                                            <label for="input-form-control"><?php echo label('authorize_net_active'); ?>
                                                ?</label>
                                            <div class="mb-3">
                                                <div class="form-check form-check-inline">
                                                    <input id="authorize_net11" class="option_autoload"
                                                           name="option_autoload"
                                                           value="1" <?php if (payment_option_settings('authorize_net')['live_enabled']->option_autoload == '1') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="authorize_net11"><?php echo label('yes'); ?></label>
                                                    <input id="authorize_net00" class="option_autoload"
                                                           name="option_autoload"
                                                           value="0" <?php if (payment_option_settings('authorize_net')['live_enabled']->option_autoload == '0') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="authorize_net00"><?php echo label('no'); ?></label>
                                                </div>
                                            </div>
                                            <label for="input-form-control"><?php echo label('authorize_net_status'); ?></label>
                                            <div class="mb-3">
                                                <div class="form-check form-check-inline">
                                                    <input id="authorize_net0" class="authorize_net_status"
                                                           name="authorize_net_status"
                                                           value="0" <?php if (payment_option_settings('authorize_net')['live_enabled']->option_value == '0') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="authorize_net0"><?php echo label('sandbox_demo'); ?></label>
                                                    <input id="authorize_net1" class="authorize_net_status"
                                                           name="authorize_net_status"
                                                           value="1" <?php if (payment_option_settings('authorize_net')['live_enabled']->option_value == '1') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="authorize_net1"><?php echo label('live'); ?></label>
                                                </div>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('authorize_net_label'); ?></label>
                                                <input type="text" id="authorize_net_label" name="authorize_net_label"
                                                       class="form-control"
                                                       value="<?php echo getOption('authorize_net_label'); ?>"/>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('authorize_net_login_id'); ?></label>
                                                <input type="text" id="authorize_net_login_id"
                                                       name="authorize_net_login_id"
                                                       class="form-control"
                                                       value="<?php echo payment_option_settings('authorize_net')['settings']->authorize_net_login_id; ?>"/>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('authorize_net_transaction_key'); ?></label>
                                                <input type="text" id="authorize_net_transaction_key"
                                                       name="authorize_net_transaction_key" class="form-control"
                                                       value="<?php echo payment_option_settings('authorize_net')['settings']->authorize_net_transaction_key; ?>"/>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('accepted_currencies'); ?></label>
                                                <textarea id="payment_option_currencies"
                                                          name="payment_option_currencies"
                                                          class="form-control"><?php echo payment_option_slug('authorize_net')->payment_option_currencies; ?></textarea>
                                            </div>
                                        </div>
                                        <div class="mb-3">
                                            <button class="btn btn-primary btn-wide float-end" type="submit">
                                                <?php echo label('update_authorize_net_settings'); ?>
                                            </button>
                                        </div>
                                    </form>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <div id="panel_flutterwave_settings" class="tab-pane fade">
                    <div class="row">
                        <div class="col-sm-12">
                            <div class="card bg-transparent mt-3">
                                <div class="card-header">
                                    <?php echo label('flutterwave_settings'); ?>
                                </div>
                                <div class="card-body">
                                    <form action="<?php echo URLROOT; ?>/settings/update_flutterwave_settings"
                                          method="post"
                                          autocomplete="off"
                                          enctype="multipart/form-data">

                                        <div class="mb-3">
                                            <label for="input-form-control"><?php echo label('flutterwave_active'); ?>
                                                ?</label>
                                            <div class="mb-3">
                                                <div class="form-check form-check-inline">
                                                    <input id="flutterwave11" class="option_autoload"
                                                           name="option_autoload"
                                                           value="1" <?php if (payment_option_settings('flutterwave')['live_enabled']->option_autoload == '1') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="flutterwave11"><?php echo label('yes'); ?></label>
                                                    <input id="flutterwave00" class="option_autoload"
                                                           name="option_autoload"
                                                           value="0" <?php if (payment_option_settings('flutterwave')['live_enabled']->option_autoload == '0') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="flutterwave00"><?php echo label('no'); ?></label>
                                                </div>
                                            </div>
                                            <label for="input-form-control"><?php echo label('flutterwave_status'); ?></label>
                                            <div class="mb-3">
                                                <div class="form-check form-check-inline">
                                                    <input id="flutterwave0" class="flutterwave_status"
                                                           name="flutterwave_status"
                                                           value="0" <?php if (payment_option_settings('flutterwave')['live_enabled']->option_value == '0') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="flutterwave0"><?php echo label('sandbox_demo'); ?></label>
                                                    <input id="flutterwave1" class="flutterwave_status"
                                                           name="flutterwave_status"
                                                           value="1" <?php if (payment_option_settings('flutterwave')['live_enabled']->option_value == '1') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="flutterwave1"><?php echo label('live'); ?></label>
                                                </div>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('flutterwave_label'); ?></label>
                                                <input type="text" id="flutterwave_label" name="flutterwave_label"
                                                       class="form-control"
                                                       value="<?php echo getOption('flutterwave_label'); ?>"/>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('flutterwave_public_key'); ?></label>
                                                <input type="text" id="flutterwave_public_key"
                                                       name="flutterwave_public_key"
                                                       class="form-control"
                                                       value="<?php echo payment_option_settings('flutterwave')['settings']->flutterwave_public_key; ?>"/>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('flutterwave_secret_key'); ?></label>
                                                <input type="text" id="flutterwave_secret_key"
                                                       name="flutterwave_secret_key"
                                                       class="form-control"
                                                       value="<?php echo payment_option_settings('flutterwave')['settings']->flutterwave_secret_key; ?>"/>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('flutterwave_encryption_key'); ?></label>
                                                <input type="text" id="flutterwave_encryption_key"
                                                       name="flutterwave_encryption_key" class="form-control"
                                                       value="<?php echo payment_option_settings('flutterwave')['settings']->flutterwave_encryption_key; ?>"/>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('accepted_currencies'); ?></label>
                                                <textarea id="payment_option_currencies"
                                                          name="payment_option_currencies"
                                                          class="form-control"><?php echo payment_option_slug('flutterwave')->payment_option_currencies; ?></textarea>
                                            </div>
                                        </div>
                                        <div class="mb-3">
                                            <button class="btn btn-primary btn-wide float-end" type="submit">
                                                <?php echo label('update_flutterwave_settings'); ?>
                                            </button>
                                        </div>
                                    </form>
                                </div>

                            </div>
                        </div>
                    </div>
                </div>
                <div id="panel_sslcommerz_settings" class="tab-pane fade">
                    <div class="row">
                        <div class="col-sm-12">
                            <div class="card bg-transparent mt-3">
                                <div class="card-header">
                                    <?php echo label('sslcommerz_settings'); ?>
                                </div>
                                <div class="card-body">
                                    <form action="<?php echo URLROOT; ?>/settings/update_sslcommerz_settings"
                                          method="post"
                                          autocomplete="off"
                                          enctype="multipart/form-data">

                                        <div class="mb-3">
                                            <label for="input-form-control"><?php echo label('sslcommerz_active'); ?>
                                                ?</label>
                                            <div class="mb-3">
                                                <div class="form-check form-check-inline">
                                                    <input id="sslcommerz11" class="option_autoload"
                                                           name="option_autoload"
                                                           value="1" <?php if (payment_option_settings('sslcommerz')['live_enabled']->option_autoload == '1') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="sslcommerz11"><?php echo label('yes'); ?></label>
                                                    <input id="sslcommerz00" class="option_autoload"
                                                           name="option_autoload"
                                                           value="0" <?php if (payment_option_settings('sslcommerz')['live_enabled']->option_autoload == '0') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="sslcommerz00"><?php echo label('no'); ?></label>
                                                </div>
                                            </div>
                                            <label for="input-form-control"><?php echo label('sslcommerz_status'); ?></label>
                                            <div class="mb-3">
                                                <div class="form-check form-check-inline">
                                                    <input id="sslcommerz0" class="sslcommerz_status"
                                                           name="sslcommerz_status"
                                                           value="0" <?php if (payment_option_settings('sslcommerz')['live_enabled']->option_value == '0') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="sslcommerz0"><?php echo label('sandbox_demo'); ?></label>
                                                    <input id="sslcommerz1" class="sslcommerz_status"
                                                           name="sslcommerz_status"
                                                           value="1" <?php if (payment_option_settings('sslcommerz')['live_enabled']->option_value == '1') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="sslcommerz1"><?php echo label('live'); ?></label>
                                                </div>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('sslcommerz_label'); ?></label>
                                                <input type="text" id="sslcommerz_label" name="sslcommerz_label"
                                                       class="form-control"
                                                       value="<?php echo getOption('sslcommerz_label'); ?>"/>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('sslcommerz_store_id'); ?></label>
                                                <input type="text" id="sslcommerz_store_id" name="sslcommerz_store_id"
                                                       class="form-control"
                                                       value="<?php echo payment_option_settings('sslcommerz')['settings']->sslcommerz_store_id; ?>"/>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('sslcommerz_password'); ?></label>
                                                <input type="text" id="sslcommerz_password" name="sslcommerz_password"
                                                       class="form-control"
                                                       value="<?php echo payment_option_settings('sslcommerz')['settings']->sslcommerz_password; ?>"/>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('accepted_currencies'); ?></label>
                                                <textarea id="payment_option_currencies"
                                                          name="payment_option_currencies"
                                                          class="form-control"><?php echo payment_option_slug('sslcommerz')->payment_option_currencies; ?></textarea>
                                            </div>
                                        </div>
                                        <div class="mb-3">
                                            <button class="btn btn-primary btn-wide float-end" type="submit">
                                                <?php echo label('update_sslcommerz_settings'); ?>
                                            </button>
                                        </div>
                                    </form>
                                </div>

                            </div>
                        </div>
                    </div>
                </div>
                <div id="panel_esewa_settings" class="tab-pane fade">
                    <div class="row">
                        <div class="col-sm-12">
                            <div class="card bg-transparent mt-3">
                                <div class="card-header">
                                    <?php echo label('esewa_settings'); ?>
                                </div>
                                <div class="card-body">
                                    <form action="<?php echo URLROOT; ?>/settings/update_esewa_settings" method="post"
                                          autocomplete="off"
                                          enctype="multipart/form-data">

                                        <div class="mb-3">
                                            <label for="input-form-control"><?php echo label('esewa_active'); ?>
                                                ?</label>
                                            <div class="mb-3">
                                                <div class="form-check form-check-inline">
                                                    <input id="esewa11" class="option_autoload" name="option_autoload"
                                                           value="1" <?php if (payment_option_settings('esewa')['live_enabled']->option_autoload == '1') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="esewa11"><?php echo label('yes'); ?></label>
                                                    <input id="esewa00" class="option_autoload" name="option_autoload"
                                                           value="0" <?php if (payment_option_settings('esewa')['live_enabled']->option_autoload == '0') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="esewa00"><?php echo label('no'); ?></label>
                                                </div>
                                            </div>
                                            <label for="input-form-control"><?php echo label('esewa_status'); ?></label>
                                            <div class="mb-3">
                                                <div class="form-check form-check-inline">
                                                    <input id="esewa0" class="esewa_status" name="esewa_status"
                                                           value="0" <?php if (payment_option_settings('esewa')['live_enabled']->option_value == '0') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="esewa0"><?php echo label('sandbox_demo'); ?></label>
                                                    <input id="esewa1" class="esewa_status" name="esewa_status"
                                                           value="1" <?php if (payment_option_settings('esewa')['live_enabled']->option_value == '1') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="esewa1"><?php echo label('live'); ?></label>
                                                </div>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('esewa_label'); ?></label>
                                                <input type="text" id="esewa_label" name="esewa_label"
                                                       class="form-control"
                                                       value="<?php echo getOption('esewa_label'); ?>"/>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('esewa_merchant_code'); ?></label>
                                                <input type="text" id="esewa_merchant_code" name="esewa_merchant_code"
                                                       class="form-control"
                                                       value="<?php echo payment_option_settings('esewa')['settings']->esewa_merchant_code; ?>"/>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('accepted_currencies'); ?></label>
                                                <textarea id="payment_option_currencies"
                                                          name="payment_option_currencies"
                                                          class="form-control"><?php echo payment_option_slug('esewa')->payment_option_currencies; ?></textarea>
                                            </div>
                                        </div>
                                        <div class="mb-3">
                                            <button class="btn btn-primary btn-wide float-end" type="submit">
                                                <?php echo label('update_esewa_settings'); ?>
                                            </button>
                                        </div>
                                    </form>
                                </div>

                            </div>
                        </div>
                    </div>
                </div>
                <div id="panel_instamojo_settings" class="tab-pane fade">
                    <div class="row">
                        <div class="col-sm-12">
                            <div class="card bg-transparent mt-3">
                                <div class="card-header">
                                    <?php echo label('instamojo_settings'); ?>
                                </div>
                                <div class="card-body">
                                    <form action="<?php echo URLROOT; ?>/settings/update_instamojo_settings"
                                          method="post"
                                          autocomplete="off"
                                          enctype="multipart/form-data">

                                        <div class="mb-3">
                                            <label for="input-form-control"><?php echo label('instamojo_active'); ?>
                                                ?</label>
                                            <div class="mb-3">
                                                <div class="form-check form-check-inline">
                                                    <input id="instamojo11" class="option_autoload"
                                                           name="option_autoload"
                                                           value="1" <?php if (payment_option_settings('instamojo')['live_enabled']->option_autoload == '1') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="instamojo11"><?php echo label('yes'); ?></label>
                                                    <input id="instamojo00" class="option_autoload"
                                                           name="option_autoload"
                                                           value="0" <?php if (payment_option_settings('instamojo')['live_enabled']->option_autoload == '0') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="instamojo00"><?php echo label('no'); ?></label>
                                                </div>
                                            </div>
                                            <label for="input-form-control"><?php echo label('instamojo_status'); ?></label>
                                            <div class="mb-3">
                                                <div class="form-check form-check-inline">
                                                    <input id="instamojo0" class="instamojo_status"
                                                           name="instamojo_status"
                                                           value="0" <?php if (payment_option_settings('instamojo')['live_enabled']->option_value == '0') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="instamojo0"><?php echo label('sandbox_demo'); ?></label>
                                                    <input id="instamojo1" class="instamojo_status"
                                                           name="instamojo_status"
                                                           value="1" <?php if (payment_option_settings('instamojo')['live_enabled']->option_value == '1') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="instamojo1"><?php echo label('live'); ?></label>
                                                </div>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('instamojo_label'); ?></label>
                                                <input type="text" id="instamojo_label" name="instamojo_label"
                                                       class="form-control"
                                                       value="<?php echo getOption('instamojo_label'); ?>"/>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('instamojo_api_key'); ?></label>
                                                <input type="text" id="instamojo_api_key" name="instamojo_api_key"
                                                       class="form-control"
                                                       value="<?php echo payment_option_settings('instamojo')['settings']->instamojo_api_key; ?>"/>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('instamojo_auth_token'); ?></label>
                                                <input type="text" id="instamojo_auth_token" name="instamojo_auth_token"
                                                       class="form-control"
                                                       value="<?php echo payment_option_settings('instamojo')['settings']->instamojo_auth_token; ?>"/>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('accepted_currencies'); ?></label>
                                                <textarea id="payment_option_currencies"
                                                          name="payment_option_currencies"
                                                          class="form-control"><?php echo payment_option_slug('instamojo')->payment_option_currencies; ?></textarea>
                                            </div>
                                        </div>
                                        <div class="mb-3">
                                            <button class="btn btn-primary btn-wide float-end" type="submit">
                                                <?php echo label('update_instamojo_settings'); ?>
                                            </button>
                                        </div>
                                    </form>
                                </div>

                            </div>
                        </div>
                    </div>
                </div>
                <div id="panel_paystack_settings" class="tab-pane fade">
                    <div class="row">
                        <div class="col-sm-12">
                            <div class="card bg-transparent mt-3">
                                <div class="card-header">
                                    <?php echo label('paystack_settings'); ?>
                                </div>
                                <div class="card-body">
                                    <form action="<?php echo URLROOT; ?>/settings/update_paystack_settings"
                                          method="post"
                                          autocomplete="off"
                                          enctype="multipart/form-data">

                                        <div class="mb-3">
                                            <label for="input-form-control"><?php echo label('paystack_active'); ?>
                                                ?</label>
                                            <div class="mb-3">
                                                <div class="form-check form-check-inline">
                                                    <input id="paystack11" class="option_autoload"
                                                           name="option_autoload"
                                                           value="1" <?php if (payment_option_settings('paystack')['live_enabled']->option_autoload == '1') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="paystack11"><?php echo label('yes'); ?></label>
                                                    <input id="paystack00" class="option_autoload"
                                                           name="option_autoload"
                                                           value="0" <?php if (payment_option_settings('paystack')['live_enabled']->option_autoload == '0') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="paystack00"><?php echo label('no'); ?></label>
                                                </div>
                                            </div>
                                            <label for="input-form-control"><?php echo label('paystack_status'); ?></label>
                                            <div class="mb-3">
                                                <div class="form-check form-check-inline">
                                                    <input id="paystack0" class="paystack_status" name="paystack_status"
                                                           value="0" <?php if (payment_option_settings('paystack')['live_enabled']->option_value == '0') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="paystack0"><?php echo label('sandbox_demo'); ?></label>
                                                    <input id="paystack1" class="paystack_status" name="paystack_status"
                                                           value="1" <?php if (payment_option_settings('paystack')['live_enabled']->option_value == '1') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="paystack1"><?php echo label('live'); ?></label>
                                                </div>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('paystack_label'); ?></label>
                                                <input type="text" id="paystack_label" name="paystack_label"
                                                       class="form-control"
                                                       value="<?php echo getOption('paystack_label'); ?>"/>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('paystack_secret_key'); ?></label>
                                                <input type="text" id="paystack_secret_key" name="paystack_secret_key"
                                                       class="form-control"
                                                       value="<?php echo payment_option_settings('paystack')['settings']->paystack_secret_key; ?>"/>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('paystack_public_key'); ?></label>
                                                <input type="text" id="paystack_public_key" name="paystack_public_key"
                                                       class="form-control"
                                                       value="<?php echo payment_option_settings('paystack')['settings']->paystack_public_key; ?>"/>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('accepted_currencies'); ?></label>
                                                <textarea id="payment_option_currencies"
                                                          name="payment_option_currencies"
                                                          class="form-control"><?php echo payment_option_slug('paystack')->payment_option_currencies; ?></textarea>
                                            </div>
                                        </div>
                                        <div class="mb-3">
                                            <button class="btn btn-primary btn-wide float-end" type="submit">
                                                <?php echo label('update_paystack_settings'); ?>
                                            </button>
                                        </div>
                                    </form>
                                </div>

                            </div>
                        </div>
                    </div>
                </div>
                <div id="panel_aamarpay_settings" class="tab-pane fade">
                    <div class="row">
                        <div class="col-sm-12">
                            <div class="card bg-transparent mt-3">
                                <div class="card-header">
                                    <?php echo label('aamarpay_settings'); ?>
                                </div>
                                <div class="card-body">
                                    <form action="<?php echo URLROOT; ?>/settings/update_aamarpay_settings"
                                          method="post"
                                          autocomplete="off"
                                          enctype="multipart/form-data">

                                        <div class="mb-3">
                                            <label for="input-form-control"><?php echo label('aamarpay_active'); ?>
                                                ?</label>
                                            <div class="mb-3">
                                                <div class="form-check form-check-inline">
                                                    <input id="aamarpay11" class="option_autoload"
                                                           name="option_autoload"
                                                           value="1" <?php if (payment_option_settings('aamarpay')['live_enabled']->option_autoload == '1') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="aamarpay11"><?php echo label('yes'); ?></label>
                                                    <input id="aamarpay00" class="option_autoload"
                                                           name="option_autoload"
                                                           value="0" <?php if (payment_option_settings('aamarpay')['live_enabled']->option_autoload == '0') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="aamarpay00"><?php echo label('no'); ?></label>
                                                </div>
                                            </div>
                                            <label for="input-form-control"><?php echo label('aamarpay_status'); ?></label>
                                            <div class="mb-3">
                                                <div class="form-check form-check-inline">
                                                    <input id="aamarpay0" class="aamarpay_status" name="aamarpay_status"
                                                           value="0" <?php if (payment_option_settings('aamarpay')['live_enabled']->option_value == '0') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="aamarpay0"><?php echo label('sandbox_demo'); ?></label>
                                                    <input id="aamarpay1" class="aamarpay_status" name="aamarpay_status"
                                                           value="1" <?php if (payment_option_settings('aamarpay')['live_enabled']->option_value == '1') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="aamarpay1"><?php echo label('live'); ?></label>
                                                </div>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('aamarpay_label'); ?></label>
                                                <input type="text" id="aamarpay_label" name="aamarpay_label"
                                                       class="form-control"
                                                       value="<?php echo getOption('aamarpay_label'); ?>"/>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('aamarpay_store_id'); ?></label>
                                                <input type="text" id="aamarpay_store_id" name="aamarpay_store_id"
                                                       class="form-control"
                                                       value="<?php echo payment_option_settings('aamarpay')['settings']->aamarpay_store_id; ?>"/>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('aamarpay_signature_key'); ?></label>
                                                <input type="text" id="aamarpay_signature_key"
                                                       name="aamarpay_signature_key"
                                                       class="form-control"
                                                       value="<?php echo payment_option_settings('aamarpay')['settings']->aamarpay_signature_key; ?>"/>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('accepted_currencies'); ?></label>
                                                <textarea id="payment_option_currencies"
                                                          name="payment_option_currencies"
                                                          class="form-control"><?php echo payment_option_slug('aamarpay')->payment_option_currencies; ?></textarea>
                                            </div>
                                        </div>
                                        <div class="mb-3">
                                            <button class="btn btn-primary btn-wide float-end" type="submit">
                                                <?php echo label('update_aamarpay_settings'); ?>
                                            </button>
                                        </div>
                                    </form>
                                </div>

                            </div>
                        </div>
                    </div>
                </div>
                <div id="panel_hyperpay_settings" class="tab-pane fade">
                    <div class="row">
                        <div class="col-sm-12">
                            <div class="card bg-transparent mt-3">
                                <div class="card-header">
                                    <?php echo label('hyperpay_settings'); ?>
                                </div>
                                <div class="card-body">
                                    <form action="<?php echo URLROOT; ?>/settings/update_hyperpay_settings"
                                          method="post"
                                          autocomplete="off"
                                          enctype="multipart/form-data">

                                        <div class="mb-3">
                                            <label for="input-form-control"><?php echo label('hyperpay_active'); ?>
                                                ?</label>
                                            <div class="mb-3">
                                                <div class="form-check form-check-inline">
                                                    <input id="hyperpay11" class="option_autoload"
                                                           name="option_autoload"
                                                           value="1" <?php if (payment_option_settings('hyperpay')['live_enabled']->option_autoload == '1') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="hyperpay11"><?php echo label('yes'); ?></label>
                                                    <input id="hyperpay00" class="option_autoload"
                                                           name="option_autoload"
                                                           value="0" <?php if (payment_option_settings('hyperpay')['live_enabled']->option_autoload == '0') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="hyperpay00"><?php echo label('no'); ?></label>
                                                </div>
                                            </div>
                                            <label for="input-form-control"><?php echo label('hyperpay_status'); ?></label>
                                            <div class="mb-3">
                                                <div class="form-check form-check-inline">
                                                    <input id="hyperpay0" class="hyperpay_status" name="hyperpay_status"
                                                           value="0" <?php if (payment_option_settings('hyperpay')['live_enabled']->option_value == '0') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="hyperpay0"><?php echo label('sandbox_demo'); ?></label>
                                                    <input id="hyperpay1" class="hyperpay_status" name="hyperpay_status"
                                                           value="1" <?php if (payment_option_settings('hyperpay')['live_enabled']->option_value == '1') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="hyperpay1"><?php echo label('live'); ?></label>
                                                </div>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('hyperpay_label'); ?></label>
                                                <input type="text" id="hyperpay_label" name="hyperpay_label"
                                                       class="form-control"
                                                       value="<?php echo getOption('hyperpay_label'); ?>"/>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('hyperpay_access_token'); ?></label>
                                                <input type="text" id="hyperpay_access_token"
                                                       name="hyperpay_access_token"
                                                       class="form-control"
                                                       value="<?php echo payment_option_settings('hyperpay')['settings']->hyperpay_access_token; ?>"/>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('hyperpay_entity_id'); ?></label>
                                                <input type="text" id="hyperpay_entity_id" name="hyperpay_entity_id"
                                                       class="form-control"
                                                       value="<?php echo payment_option_settings('hyperpay')['settings']->hyperpay_entity_id; ?>"/>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('hyperpay_brands'); ?></label>
                                                <input type="text" id="hyperpay_brands" name="hyperpay_brands"
                                                       class="form-control"
                                                       value="<?php echo payment_option_settings('hyperpay')['settings']->hyperpay_brands; ?>"/>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('accepted_currencies'); ?></label>
                                                <textarea id="payment_option_currencies"
                                                          name="payment_option_currencies"
                                                          class="form-control"><?php echo payment_option_slug('hyperpay')->payment_option_currencies; ?></textarea>
                                            </div>
                                        </div>
                                        <div class="mb-3">
                                            <button class="btn btn-primary btn-wide float-end" type="submit">
                                                <?php echo label('update_hyperpay_settings'); ?>
                                            </button>
                                        </div>
                                    </form>
                                </div>

                            </div>
                        </div>
                    </div>
                </div>
                <div id="panel_toyyibpay_settings" class="tab-pane fade">
                    <div class="row">
                        <div class="col-sm-12">
                            <div class="card bg-transparent mt-3">
                                <div class="card-header">
                                    <?php echo label('toyyibpay_settings'); ?>
                                </div>
                                <div class="card-body">
                                    <form action="<?php echo URLROOT; ?>/settings/update_toyyibpay_settings"
                                          method="post"
                                          autocomplete="off"
                                          enctype="multipart/form-data">

                                        <div class="mb-3">
                                            <label for="input-form-control"><?php echo label('toyyibpay_active'); ?>
                                                ?</label>
                                            <div class="mb-3">
                                                <div class="form-check form-check-inline">
                                                    <input id="toyyibpay11" class="option_autoload"
                                                           name="option_autoload"
                                                           value="1" <?php if (payment_option_settings('toyyibpay')['live_enabled']->option_autoload == '1') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="toyyibpay11"><?php echo label('yes'); ?></label>
                                                    <input id="toyyibpay00" class="option_autoload"
                                                           name="option_autoload"
                                                           value="0" <?php if (payment_option_settings('toyyibpay')['live_enabled']->option_autoload == '0') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="toyyibpay00"><?php echo label('no'); ?></label>
                                                </div>
                                            </div>
                                            <label for="input-form-control"><?php echo label('toyyibpay_status'); ?></label>
                                            <div class="mb-3">
                                                <div class="form-check form-check-inline">
                                                    <input id="toyyibpay0" class="toyyibpay_status"
                                                           name="toyyibpay_status"
                                                           value="0" <?php if (payment_option_settings('toyyibpay')['live_enabled']->option_value == '0') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="toyyibpay0"><?php echo label('sandbox_demo'); ?></label>
                                                    <input id="toyyibpay1" class="toyyibpay_status"
                                                           name="toyyibpay_status"
                                                           value="1" <?php if (payment_option_settings('toyyibpay')['live_enabled']->option_value == '1') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="toyyibpay1"><?php echo label('live'); ?></label>
                                                </div>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('toyyibpay_label'); ?></label>
                                                <input type="text" id="toyyibpay_label" name="toyyibpay_label"
                                                       class="form-control"
                                                       value="<?php echo getOption('toyyibpay_label'); ?>"/>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('toyyibpay_secret_key'); ?></label>
                                                <input type="text" id="toyyibpay_secret_key" name="toyyibpay_secret_key"
                                                       class="form-control"
                                                       value="<?php echo payment_option_settings('toyyibpay')['settings']->toyyibpay_secret_key; ?>"/>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('toyyibpay_category'); ?></label>
                                                <input type="text" id="toyyibpay_category" name="toyyibpay_category"
                                                       class="form-control"
                                                       value="<?php echo payment_option_settings('toyyibpay')['settings']->toyyibpay_category; ?>"/>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('accepted_currencies'); ?></label>
                                                <textarea id="payment_option_currencies"
                                                          name="payment_option_currencies"
                                                          class="form-control"><?php echo payment_option_slug('toyyibpay')->payment_option_currencies; ?></textarea>
                                            </div>
                                        </div>
                                        <div class="mb-3">
                                            <button class="btn btn-primary btn-wide float-end" type="submit">
                                                <?php echo label('update_toyyibpay_settings'); ?>
                                            </button>
                                        </div>
                                    </form>
                                </div>

                            </div>
                        </div>
                    </div>
                </div>

                <div id="panel_pesapal_settings" class="tab-pane fade">
                    <div class="mb-3">
                        <label class="form-label">
                            <?php echo label('pesapal_settings'); ?>
                        </label>
                    </div>
                    <hr>
                    <div class="row">
                        <div class="col-sm-12">
                            <div class="card bg-light mb-3">
                                <div class="card-body">
                                    <form action="<?php echo URLROOT; ?>/settings/update_pesapal_settings" method="post"
                                          enctype="multipart/form-data">
                                        <div class="mb-3">
                                            <label for="input-form-control"><?php echo label('pesapal_active'); ?>
                                                ?</label>
                                            <div class="mb-3">
                                                <div class="radio mybizcms-radio radio-lg radio-primary radio-inline">
                                                    <input id="pesapal11" class="option_autoload" name="option_autoload"
                                                           value="1" <?php if (payment_option_settings('pesapal')['live_enabled']->option_autoload == '1') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="pesapal11"><?php echo label('yes'); ?></label>
                                                    <input id="pesapal00" class="option_autoload" name="option_autoload"
                                                           value="0" <?php if (payment_option_settings('pesapal')['live_enabled']->option_autoload == '0') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="pesapal00"><?php echo label('no'); ?></label>
                                                </div>
                                            </div>
                                            <label for="input-form-control"><?php echo label('pesapal_status'); ?></label>
                                            <div class="mb-3">
                                                <div class="radio mybizcms-radio radio-lg radio-primary radio-inline">
                                                    <input id="pesapal0" class="pesapal_status" name="pesapal_status"
                                                           value="0" <?php if (payment_option_settings('pesapal')['live_enabled']->option_value == '0') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="pesapal0"><?php echo label('sandbox_demo'); ?></label>
                                                    <input id="pesapal1" class="pesapal_status" name="pesapal_status"
                                                           value="1" <?php if (payment_option_settings('pesapal')['live_enabled']->option_value == '1') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="pesapal1"><?php echo label('live'); ?></label>
                                                </div>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('pesapal_label'); ?></label>
                                                <input type="text" id="pesapal_label" name="pesapal_label"
                                                       class="form-control"
                                                       value="<?php echo getOption('pesapal_label'); ?>"/>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('pesapal_consumer_key'); ?></label>
                                                <input type="text" id="pesapal_consumer_key" name="pesapal_consumer_key"
                                                       class="form-control"
                                                       value="<?php echo payment_option_settings('pesapal')['settings']->pesapal_consumer_key; ?>"/>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('pesapal_consumer_secret'); ?></label>
                                                <input type="text" id="pesapal_consumer_secret"
                                                       name="pesapal_consumer_secret" class="form-control"
                                                       value="<?php echo payment_option_settings('pesapal')['settings']->pesapal_consumer_secret; ?>"/>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('pesapal_notification_id'); ?> (<a
                                                            href="https://pay.pesapal.com/iframe/PesapalIframe3/IpnRegistration"
                                                            target="_blank"><?php echo label('click_here_to_generate_notification_id'); ?></a>)</label>
                                                <input type="text" id="pesapal_notification_id"
                                                       name="pesapal_notification_id" class="form-control"
                                                       value="<?php echo payment_option_settings('pesapal')['settings']->pesapal_notification_id; ?>"/>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('accepted_currencies'); ?></label>
                                                <textarea id="payment_option_currencies"
                                                          name="payment_option_currencies"
                                                          class="form-control"><?php echo payment_option_slug('pesapal')->payment_option_currencies; ?></textarea>
                                            </div>
                                        </div>
                                        <div class="mb-3">
                                            <button class="btn btn-primary btn-wide float-end" type="submit">
                                                <?php echo label('update_pesapal_settings'); ?>
                                            </button>
                                        </div>
                                    </form>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>

                <div id="panel_paddle_settings" class="tab-pane fade">
                    <div class="mb-3">
                        <label class="form-label">
                            <?php echo label('paddle_settings'); ?>
                        </label>
                    </div>
                    <hr>
                    <div class="row">
                        <div class="col-sm-12">
                            <div class="card bg-light mb-3">
                                <div class="card-body">
                                    <form action="<?php echo URLROOT; ?>/settings/update_paddle_settings" method="post"
                                          enctype="multipart/form-data">
                                        <div class="mb-3">
                                            <label for="input-form-control"><?php echo label('paddle_active'); ?>
                                                ?</label>
                                            <div class="mb-3">
                                                <div class="radio mybizcms-radio radio-lg radio-primary radio-inline">
                                                    <input id="paddle11" class="option_autoload" name="option_autoload"
                                                           value="1" <?php if (payment_option_settings('paddle')['live_enabled']->option_autoload == '1') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="paddle11"><?php echo label('yes'); ?></label>
                                                    <input id="paddle00" class="option_autoload" name="option_autoload"
                                                           value="0" <?php if (payment_option_settings('paddle')['live_enabled']->option_autoload == '0') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="paddle00"><?php echo label('no'); ?></label>
                                                </div>
                                            </div>
                                            <label for="input-form-control"><?php echo label('paddle_status'); ?></label>
                                            <div class="mb-3">
                                                <div class="radio mybizcms-radio radio-lg radio-primary radio-inline">
                                                    <input id="paddle0" class="paddle_status" name="paddle_status"
                                                           value="0" <?php if (payment_option_settings('paddle')['live_enabled']->option_value == '0') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="paddle0"><?php echo label('sandbox_demo'); ?></label>
                                                    <input id="paddle1" class="paddle_status" name="paddle_status"
                                                           value="1" <?php if (payment_option_settings('paddle')['live_enabled']->option_value == '1') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="paddle1"><?php echo label('live'); ?></label>
                                                </div>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('paddle_label'); ?></label>
                                                <input type="text" id="paddle_label" name="paddle_label"
                                                       class="form-control"
                                                       value="<?php echo getOption('paddle_label'); ?>"/>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('paddle_api_key'); ?></label>
                                                <input type="text" id="paddle_api_key" name="paddle_api_key"
                                                       class="form-control"
                                                       value="<?php echo payment_option_settings('paddle')['settings']->paddle_api_key; ?>"/>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('paddle_client_side_token'); ?></label>
                                                <input type="text" id="paddle_client_side_token"
                                                       name="paddle_client_side_token" class="form-control"
                                                       value="<?php echo payment_option_settings('paddle')['settings']->paddle_client_side_token; ?>"/>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('accepted_currencies'); ?></label>
                                                <textarea id="payment_option_currencies"
                                                          name="payment_option_currencies"
                                                          class="form-control"><?php echo payment_option_slug('paddle')->payment_option_currencies; ?></textarea>
                                            </div>
                                        </div>
                                        <div class="mb-3">
                                            <button class="btn btn-primary btn-wide float-end" type="submit">
                                                <?php echo label('update_paddle_settings'); ?>
                                            </button>
                                        </div>
                                    </form>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>

                <div id="panel_iyzico_settings" class="tab-pane fade">
                    <div class="mb-3">
                        <label class="form-label">
                            <?php echo label('iyzico_settings'); ?>
                        </label>
                    </div>
                    <hr>
                    <div class="row">
                        <div class="col-sm-12">
                            <div class="card bg-light mb-3">
                                <div class="card-body">
                                    <form action="<?php echo URLROOT; ?>/settings/update_iyzico_settings" method="post"
                                          enctype="multipart/form-data">
                                        <div class="mb-3">
                                            <label for="input-form-control"><?php echo label('iyzico_active'); ?>
                                                ?</label>
                                            <div class="mb-3">
                                                <div class="radio mybizcms-radio radio-lg radio-primary radio-inline">
                                                    <input id="iyzico11" class="option_autoload" name="option_autoload"
                                                           value="1" <?php if (payment_option_settings('iyzico')['live_enabled']->option_autoload == '1') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="iyzico11"><?php echo label('yes'); ?></label>
                                                    <input id="iyzico00" class="option_autoload" name="option_autoload"
                                                           value="0" <?php if (payment_option_settings('iyzico')['live_enabled']->option_autoload == '0') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="iyzico00"><?php echo label('no'); ?></label>
                                                </div>
                                            </div>
                                            <label for="input-form-control"><?php echo label('iyzico_status'); ?></label>
                                            <div class="mb-3">
                                                <div class="radio mybizcms-radio radio-lg radio-primary radio-inline">
                                                    <input id="iyzico0" class="iyzico_status" name="iyzico_status"
                                                           value="0" <?php if (payment_option_settings('iyzico')['live_enabled']->option_value == '0') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="iyzico0"><?php echo label('sandbox_demo'); ?></label>
                                                    <input id="iyzico1" class="iyzico_status" name="iyzico_status"
                                                           value="1" <?php if (payment_option_settings('iyzico')['live_enabled']->option_value == '1') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="iyzico1"><?php echo label('live'); ?></label>
                                                </div>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('iyzico_label'); ?></label>
                                                <input type="text" id="iyzico_label" name="iyzico_label"
                                                       class="form-control"
                                                       value="<?php echo getOption('iyzico_label'); ?>"/>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('iyzico_api_key'); ?></label>
                                                <input type="text" id="iyzico_api_key" name="iyzico_api_key"
                                                       class="form-control"
                                                       value="<?php echo payment_option_settings('iyzico')['settings']->iyzico_api_key; ?>"/>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('iyzico_secret_key'); ?></label>
                                                <input type="text" id="iyzico_secret_key" name="iyzico_secret_key"
                                                       class="form-control"
                                                       value="<?php echo payment_option_settings('iyzico')['settings']->iyzico_secret_key; ?>"/>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('accepted_currencies'); ?></label>
                                                <textarea id="payment_option_currencies"
                                                          name="payment_option_currencies"
                                                          class="form-control"><?php echo payment_option_slug('iyzico')->payment_option_currencies; ?></textarea>
                                            </div>
                                        </div>
                                        <div class="mb-3">
                                            <button class="btn btn-primary btn-wide float-end" type="submit">
                                                <?php echo label('update_iyzico_settings'); ?>
                                            </button>
                                        </div>
                                    </form>
                                </div>

                            </div>
                        </div>
                    </div>
                </div>


                <div id="panel_paytr_settings" class="tab-pane fade">
                    <div class="mb-3">
                        <label class="form-label">
                            <?php echo label('paytr_settings'); ?>
                        </label>
                    </div>
                    <hr>
                    <div class="row">
                        <div class="col-sm-12">
                            <div class="card bg-light mb-3">
                                <div class="card-body">
                                    <form action="<?php echo URLROOT; ?>/settings/update_paytr_settings" method="post"
                                          enctype="multipart/form-data">
                                        <div class="mb-3">
                                            <label for="input-form-control"><?php echo label('paytr_active'); ?>
                                                ?</label>
                                            <div class="mb-3">
                                                <div class="radio mybizcms-radio radio-lg radio-primary radio-inline">
                                                    <input id="paytr11" class="option_autoload" name="option_autoload"
                                                           value="1" <?php if (payment_option_settings('paytr')['live_enabled']->option_autoload == '1') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="paytr11"><?php echo label('yes'); ?></label>
                                                    <input id="paytr00" class="option_autoload" name="option_autoload"
                                                           value="0" <?php if (payment_option_settings('paytr')['live_enabled']->option_autoload == '0') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="paytr00"><?php echo label('no'); ?></label>
                                                </div>
                                            </div>
                                            <label for="input-form-control"><?php echo label('paytr_status'); ?></label>
                                            <div class="mb-3">
                                                <div class="radio mybizcms-radio radio-lg radio-primary radio-inline">
                                                    <input id="paytr0" class="paytr_status" name="paytr_status"
                                                           value="0" <?php if (payment_option_settings('paytr')['live_enabled']->option_value == '0') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="paytr0"><?php echo label('sandbox_demo'); ?></label>
                                                    <input id="paytr1" class="paytr_status" name="paytr_status"
                                                           value="1" <?php if (payment_option_settings('paytr')['live_enabled']->option_value == '1') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="paytr1"><?php echo label('live'); ?></label>
                                                </div>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('paytr_label'); ?></label>
                                                <input type="text" id="paytr_label" name="paytr_label"
                                                       class="form-control"
                                                       value="<?php echo getOption('paytr_label'); ?>"/>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('paytr_merchant_id'); ?></label>
                                                <input type="text" id="paytr_merchant_id" name="paytr_merchant_id"
                                                       class="form-control"
                                                       value="<?php echo payment_option_settings('paytr')['settings']->paytr_merchant_id; ?>"/>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('paytr_merchant_key'); ?></label>
                                                <input type="text" id="paytr_merchant_key" name="paytr_merchant_key"
                                                       class="form-control"
                                                       value="<?php echo payment_option_settings('paytr')['settings']->paytr_merchant_key; ?>"/>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('paytr_merchant_salt'); ?></label>
                                                <input type="text" id="paytr_merchant_salt" name="paytr_merchant_salt"
                                                       class="form-control"
                                                       value="<?php echo payment_option_settings('paytr')['settings']->paytr_merchant_salt; ?>"/>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('accepted_currencies'); ?></label>
                                                <textarea id="payment_option_currencies"
                                                          name="payment_option_currencies"
                                                          class="form-control"><?php echo payment_option_slug('paytr')->payment_option_currencies; ?></textarea>
                                            </div>
                                        </div>
                                        <div class="mb-3">
                                            <button class="btn btn-primary btn-wide float-end" type="submit">
                                                <?php echo label('update_paytr_settings'); ?>
                                            </button>
                                        </div>
                                    </form>
                                </div>

                            </div>
                        </div>
                    </div>
                </div>
                
                <div id="panel_tap_settings" class="tab-pane fade">
                    <div class="row">
                        <div class="col-sm-12">
                            <div class="card bg-transparent mt-3">
                                <div class="card-header">
                                    <?php echo label('tap_settings'); ?>
                                </div>
                                <div class="card-body">
                                    <form action="<?php echo URLROOT; ?>/settings/update_tap_settings" method="post"
                                          autocomplete="off"
                                          enctype="multipart/form-data">

                                        <div class="mb-3">
                                            <label for="input-form-control"><?php echo label('tap_active'); ?>
                                                ?</label>
                                            <div class="mb-3">
                                                <div class="form-check form-check-inline">
                                                    <input id="tap11" class="option_autoload" name="option_autoload"
                                                           value="1" <?php if (payment_option_settings('tap')['live_enabled']->option_autoload == '1') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="tap11"><?php echo label('yes'); ?></label>
                                                    <input id="tap00" class="option_autoload" name="option_autoload"
                                                           value="0" <?php if (payment_option_settings('tap')['live_enabled']->option_autoload == '0') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="tap00"><?php echo label('no'); ?></label>
                                                </div>
                                            </div>
                                            <label for="input-form-control"><?php echo label('tap_status'); ?></label>
                                            <div class="mb-3">
                                                <div class="form-check form-check-inline">
                                                    <input id="tap0" class="tap_status" name="tap_status"
                                                           value="0" <?php if (payment_option_settings('tap')['live_enabled']->option_value == '0') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="tap0"><?php echo label('sandbox_demo'); ?></label>
                                                    <input id="tap1" class="tap_status" name="tap_status"
                                                           value="1" <?php if (payment_option_settings('tap')['live_enabled']->option_value == '1') {
                                                        echo 'checked';
                                                    } ?> type="radio">
                                                    <label for="tap1"><?php echo label('live'); ?></label>
                                                </div>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('tap_label'); ?></label>
                                                <input type="text" id="tap_label" name="tap_label"
                                                       class="form-control"
                                                       value="<?php echo getOption('tap_label'); ?>"/>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('tap_secret_key'); ?></label>
                                                <input type="text" id="tap_secret_key" name="tap_secret_key"
                                                       class="form-control"
                                                       value="<?php echo payment_option_settings('tap')['settings']->tap_secret_key; ?>"/>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('tap_publishable_key'); ?></label>
                                                <input type="text" id="tap_publishable_key"
                                                       name="tap_publishable_key"
                                                       class="form-control"
                                                       value="<?php echo payment_option_settings('tap')['settings']->tap_publishable_key; ?>"/>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('tap_encryption_key'); ?></label>
                                                <input type="text" id="tap_encryption_key"
                                                       name="tap_encryption_key"
                                                       class="form-control"
                                                       value="<?php echo payment_option_settings('tap')['settings']->tap_encryption_key; ?>"/>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('accepted_currencies'); ?></label>
                                                <textarea id="payment_option_currencies"
                                                          name="payment_option_currencies"
                                                          class="form-control"><?php echo payment_option_slug('tap')->payment_option_currencies; ?></textarea>
                                            </div>
                                            <div class="mb-3">
                                                <label><?php echo label('accepted_zero_decimal_currencies'); ?></label>
                                                <textarea id="payment_option_zero_decimal_currencies"
                                                          name="payment_option_zero_decimal_currencies"
                                                          class="form-control"><?php echo payment_option_slug('tap')->payment_option_zero_decimal_currencies; ?></textarea>
                                            </div>
                                        </div>
                                        <div class="mb-3">
                                            <button class="btn btn-primary btn-wide float-end" type="submit">
                                                <?php echo label('update_tap_settings'); ?>
                                            </button>
                                        </div>
                                    </form>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                
	            <div id="panel_paygate_settings" class="tab-pane fade">
	                <div class="mb-3">
	                    <label class="form-label">
	                        <h4><?php echo label('paygate_settings'); ?></h4>
	                    </label>
	                </div>
	                <hr>
	                <div class="row">
	                    <div class="col-sm-12">
	                        <div class="card bg-light mb-3">
	                            <div class="card-body">
	                                <form action="<?php echo URLROOT; ?>/settings/update_paygate_settings" method="post"
	                                      enctype="multipart/form-data">
	                                    <div class="mb-3">
	                                        <label for="input-form-control"><?php echo label('paygate_active'); ?>?</label>
	                                        <div class="mb-3">
	                                            <div class="radio mybizcms-radio radio-lg radio-primary radio-inline">
	                                                <input id="paygate11" class="option_autoload" name="option_autoload"
	                                                       value="1" <?php if (payment_option_settings('paygate')['live_enabled']->option_autoload == '1') {
	                                                    echo 'checked';
	                                                } ?> type="radio">
	                                                <label for="paygate11"><?php echo label('yes'); ?></label>
	                                                <input id="paygate00" class="option_autoload" name="option_autoload"
	                                                       value="0" <?php if (payment_option_settings('paygate')['live_enabled']->option_autoload == '0') {
	                                                    echo 'checked';
	                                                } ?> type="radio">
	                                                <label for="paygate00"><?php echo label('no'); ?></label>
	                                            </div>
	                                        </div>
	                                        <label for="input-form-control"><?php echo label('paygate_status'); ?></label>
	                                        <div class="mb-3">
	                                            <div class="radio mybizcms-radio radio-lg radio-primary radio-inline">
	                                                <input id="paygate0" class="paygate_status" name="paygate_status"
	                                                       value="0" <?php if (payment_option_settings('paygate')['live_enabled']->option_value == '0') {
	                                                    echo 'checked';
	                                                } ?> type="radio">
	                                                <label for="paygate0"><?php echo label('sandbox_demo'); ?></label>
	                                                <input id="paygate1" class="paygate_status" name="paygate_status"
	                                                       value="1" <?php if (payment_option_settings('paygate')['live_enabled']->option_value == '1') {
	                                                    echo 'checked';
	                                                } ?> type="radio">
	                                                <label for="paygate1"><?php echo label('live'); ?></label>
	                                            </div>
	                                        </div>
	                                        <div class="mb-3">
	                                            <label><?php echo label('paygate_label'); ?></label>
	                                            <input type="text" id="paygate_label" name="paygate_label"
	                                                   class="form-control"
	                                                   value="<?php echo getOption('paygate_label'); ?>"/>
	                                        </div>
	                                        <div class="mb-3">
	                                            <label><?php echo label('paygate_paygate_id'); ?></label>
	                                            <input type="text" id="paygate_paygate_id" name="paygate_paygate_id"
	                                                   class="form-control"
	                                                   value="<?php echo payment_option_settings('paygate')['settings']->paygate_paygate_id; ?>"/>
	                                        </div>
	                                        <div class="mb-3">
	                                            <label><?php echo label('paygate_encryption_key'); ?></label>
	                                            <input type="text" id="paygate_encryption_key" name="paygate_encryption_key"
	                                                   class="form-control"
	                                                   value="<?php echo payment_option_settings('paygate')['settings']->paygate_encryption_key; ?>"/>
	                                        </div>
	                                        <div class="mb-3">
	                                            <label><?php echo label('accepted_currencies'); ?></label>
	                                            <textarea id="payment_option_currencies" name="payment_option_currencies"
	                                                      class="form-control"><?php echo payment_option_slug('paygate')->payment_option_currencies; ?></textarea>
	                                        </div>
	                                    </div>
	                                    <div class="mb-3">
	                                        <button class="btn btn-primary btn-wide float-end" type="submit">
	                                            <?php echo label('update_paygate_settings'); ?>
	                                        </button>
	                                    </div>
	                                </form>
	                            </div>
	                        </div>
	                    </div>
	                </div>
	            </div>
	                       
	            <div id="panel_twocheckout_settings" class="tab-pane fade">
	                <div class="mb-3">
	                    <label class="form-label"><h4><?php echo label('2checkout_settings'); ?></h4></label>
	                    <hr>
	                </div>
	                <div class="row">
	                    <div class="col-sm-12">
	                        <div class="card bg-light mb-3">
	                            <div class="card-body">
	                                <form action="<?php echo URLROOT; ?>/settings/update_two_checkout_settings"
	                                      method="post" enctype="multipart/form-data">
	                                    <div class="mb-3">
	                                        <label for="input-form-control"><?php echo label('2checkout'); ?> <?php echo label('active'); ?>
	                                            ?</label>
	                                        <div class="mb-3">
	                                            <div class="radio mybizcms-radio radio-lg radio-primary radio-inline">
	                                                <input id="twocheckout11" class="option_autoload" name="option_autoload"
	                                                       value="1" <?php if (payment_option_settings('twocheckout')['live_enabled']->option_autoload == '1') {
	                                                    echo 'checked';
	                                                } ?> type="radio">
	                                                <label for="twocheckout11"><?php echo label('yes'); ?></label>
	                                                <input id="twocheckout00" class="option_autoload" name="option_autoload"
	                                                       value="0" <?php if (payment_option_settings('twocheckout')['live_enabled']->option_autoload == '0') {
	                                                    echo 'checked';
	                                                } ?> type="radio">
	                                                <label for="twocheckout00"><?php echo label('no'); ?></label>
	                                            </div>
	                                        </div>
	                                        <label for="input-form-control"><?php echo label('2checkout_status'); ?></label>
	                                        <div class="mb-3">
	                                            <div class="radio mybizcms-radio radio-lg radio-primary radio-inline">
	                                                <input id="twocheckout0" class="twocheckout_status"
	                                                       name="twocheckout_status"
	                                                       value="0" <?php if (payment_option_settings('twocheckout')['live_enabled']->option_value == '0') {
	                                                    echo 'checked';
	                                                } ?> type="radio">
	                                                <label for="twocheckout0"><?php echo label('sandbox_demo'); ?></label>
	                                                <input id="twocheckout1" class="twocheckout_status"
	                                                       name="twocheckout_status"
	                                                       value="1" <?php if (payment_option_settings('twocheckout')['live_enabled']->option_value == '1') {
	                                                    echo 'checked';
	                                                } ?> type="radio">
	                                                <label for="twocheckout1"><?php echo label('live'); ?></label>
	                                            </div>
	                                        </div>
	                                        <div class="mb-3">
	                                            <label><?php echo label('2checkout_label'); ?></label>
	                                            <input type="text" id="twocheckout_label" name="twocheckout_label"
	                                                   class="form-control"
	                                                   value="<?php echo getOption('twocheckout_label'); ?>"/>
	                                        </div>
	                                        <div class="mb-3">
	                                            <label><?php echo label('2checkout_publishable_key'); ?></label>
	                                            <input type="text" id="twocheckout_publishable_key"
	                                                   name="twocheckout_publishable_key" class="form-control"
	                                                   value="<?php echo payment_option_settings('twocheckout')['settings']->twocheckout_publishable_key; ?>"/>
	                                        </div>
	                                        <div class="mb-3">
	                                            <label><?php echo label('2checkout_private_key'); ?></label>
	                                            <input type="text" id="twocheckout_private_key"
	                                                   name="twocheckout_private_key" class="form-control"
	                                                   value="<?php echo payment_option_settings('twocheckout')['settings']->twocheckout_private_key; ?>"/>
	                                        </div>
	                                        <div class="mb-3">
	                                            <label><?php echo label('2checkout_secret_key'); ?></label>
	                                            <input type="text" id="twocheckout_secret_key"
	                                                   name="twocheckout_secret_key" class="form-control"
	                                                   value="<?php echo payment_option_settings('twocheckout')['settings']->twocheckout_secret_key; ?>"/>
	                                        </div>
	                                        <div class="mb-3">
	                                            <label><?php echo label('2checkout_merchant_code'); ?></label>
	                                            <input type="text" id="twocheckout_merchant_code"
	                                                   name="twocheckout_merchant_code" class="form-control"
	                                                   value="<?php echo payment_option_settings('twocheckout')['settings']->twocheckout_merchant_code; ?>"/>
	                                        </div>
	                                    </div>
	                                    <div class="mb-3">
	                                        <label><?php echo label('accepted_currencies'); ?></label>
	                                        <textarea id="payment_option_currencies" name="payment_option_currencies"
	                                                  class="form-control"><?php echo payment_option_slug('twocheckout')->payment_option_currencies; ?></textarea>
	                                    </div>
	                                    <div class="mb-3">
	                                        <button class="btn btn-primary btn-wide float-end" type="submit">
	                                            <?php echo label('update_2checkout_settings'); ?>
	                                        </button>
	                                    </div>
	                                </form>
	                            </div>
	                        </div>
	                    </div>
	                </div>
	            </div>
                
                <div id="panel_midtrans_settings" class="tab-pane fade">
                <div class="mb-3">
                    <label class="form-label">
                        <h4><?php echo label('midtrans_settings'); ?></h4>
                    </label>
                </div>
                <hr>
                <div class="row">
                    <div class="col-sm-12">
                        <div class="card bg-light mb-3">
                            <div class="card-body">
                                <form action="<?php echo URLROOT; ?>/settings/update_midtrans_settings" method="post"
                                      enctype="multipart/form-data">
                                    <div class="mb-3">
                                        <label for="input-form-control"><?php echo label('midtrans_active'); ?>?</label>
                                        <div class="mb-3">
                                            <div class="radio mybizcms-radio radio-lg radio-primary radio-inline">
                                                <input id="midtrans11" class="option_autoload" name="option_autoload"
                                                       value="1" <?php if (payment_option_settings('midtrans')['live_enabled']->option_autoload == '1') {
                                                    echo 'checked';
                                                } ?> type="radio">
                                                <label for="midtrans11"><?php echo label('yes'); ?></label>
                                                <input id="midtrans00" class="option_autoload" name="option_autoload"
                                                       value="0" <?php if (payment_option_settings('midtrans')['live_enabled']->option_autoload == '0') {
                                                    echo 'checked';
                                                } ?> type="radio">
                                                <label for="midtrans00"><?php echo label('no'); ?></label>
                                            </div>
                                        </div>
                                        <label for="input-form-control"><?php echo label('midtrans_status'); ?></label>
                                        <div class="mb-3">
                                            <div class="radio mybizcms-radio radio-lg radio-primary radio-inline">
                                                <input id="midtrans0" class="midtrans_status" name="midtrans_status"
                                                       value="0" <?php if (payment_option_settings('midtrans')['live_enabled']->option_value == '0') {
                                                    echo 'checked';
                                                } ?> type="radio">
                                                <label for="midtrans0"><?php echo label('sandbox_demo'); ?></label>
                                                <input id="midtrans1" class="midtrans_status" name="midtrans_status"
                                                       value="1" <?php if (payment_option_settings('midtrans')['live_enabled']->option_value == '1') {
                                                    echo 'checked';
                                                } ?> type="radio">
                                                <label for="midtrans1"><?php echo label('live'); ?></label>
                                            </div>
                                        </div>
                                        <div class="mb-3">
                                            <label><?php echo label('midtrans_label'); ?></label>
                                            <input type="text" id="midtrans_label" name="midtrans_label"
                                                   class="form-control"
                                                   value="<?php echo getOption('midtrans_label'); ?>"/>
                                        </div>
                                        <div class="mb-3">
                                            <label><?php echo label('midtrans_client_id'); ?></label>
                                            <input type="text" id="midtrans_client_id" name="midtrans_client_id"
                                                   class="form-control"
                                                   value="<?php echo payment_option_settings('midtrans')['settings']->midtrans_client_id; ?>"/>
                                        </div>
                                        <div class="mb-3">
                                            <label><?php echo label('midtrans_server_key'); ?></label>
                                            <input type="text" id="midtrans_server_key" name="midtrans_server_key"
                                                   class="form-control"
                                                   value="<?php echo payment_option_settings('midtrans')['settings']->midtrans_server_key; ?>"/>
                                        </div>
                                        <div class="mb-3">
                                            <label><?php echo label('accepted_currencies'); ?></label>
                                            <textarea id="payment_option_currencies" name="payment_option_currencies"
                                                      class="form-control"><?php echo payment_option_slug('midtrans')->payment_option_currencies; ?></textarea>
                                        </div>
                                    </div>
                                    <div class="mb-3">
                                        <button class="btn btn-primary btn-wide float-end" type="submit">
                                            <?php echo label('update_midtrans_settings'); ?>
                                        </button>
                                    </div>
                                </form>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
                
	            <div id="panel_tripay_settings" class="tab-pane fade">
	                <div class="mb-3">
	                    <label class="form-label">
	                        <h4><?php echo label('tripay_settings'); ?></h4>
	                    </label>
	                </div>
	                <hr>
	                <div class="row">
	                    <div class="col-sm-12">
	                        <div class="card bg-light mb-3">
	                            <div class="card-body">
	                                <form action="<?php echo URLROOT; ?>/settings/update_tripay_settings" method="post"
	                                      enctype="multipart/form-data">
	                                    <div class="mb-3">
	                                        <label for="input-form-control"><?php echo label('tripay_active'); ?>?</label>
	                                        <div class="mb-3">
	                                            <div class="radio mybizcms-radio radio-lg radio-primary radio-inline">
	                                                <input id="tripay11" class="option_autoload" name="option_autoload"
	                                                       value="1" <?php if (payment_option_settings('tripay')['live_enabled']->option_autoload == '1') {
	                                                    echo 'checked';
	                                                } ?> type="radio">
	                                                <label for="tripay11"><?php echo label('yes'); ?></label>
	                                                <input id="tripay00" class="option_autoload" name="option_autoload"
	                                                       value="0" <?php if (payment_option_settings('tripay')['live_enabled']->option_autoload == '0') {
	                                                    echo 'checked';
	                                                } ?> type="radio">
	                                                <label for="tripay00"><?php echo label('no'); ?></label>
	                                            </div>
	                                        </div>
	                                        <label for="input-form-control"><?php echo label('tripay_status'); ?></label>
	                                        <div class="mb-3">
	                                            <div class="radio mybizcms-radio radio-lg radio-primary radio-inline">
	                                                <input id="tripay0" class="tripay_status" name="tripay_status"
	                                                       value="0" <?php if (payment_option_settings('tripay')['live_enabled']->option_value == '0') {
	                                                    echo 'checked';
	                                                } ?> type="radio">
	                                                <label for="tripay0"><?php echo label('sandbox_demo'); ?></label>
	                                                <input id="tripay1" class="tripay_status" name="tripay_status"
	                                                       value="1" <?php if (payment_option_settings('tripay')['live_enabled']->option_value == '1') {
	                                                    echo 'checked';
	                                                } ?> type="radio">
	                                                <label for="tripay1"><?php echo label('live'); ?></label>
	                                            </div>
	                                        </div>
	                                        <div class="mb-3">
	                                            <label><?php echo label('tripay_label'); ?></label>
	                                            <input type="text" id="tripay_label" name="tripay_label"
	                                                   class="form-control"
	                                                   value="<?php echo getOption('tripay_label'); ?>"/>
	                                        </div>
	                                        <div class="mb-3">
	                                            <label><?php echo label('tripay_private_key'); ?></label>
	                                            <input type="text" id="tripay_private_key" name="tripay_private_key"
	                                                   class="form-control"
	                                                   value="<?php echo payment_option_settings('tripay')['settings']->tripay_private_key; ?>"/>
	                                        </div>
	                                        <div class="mb-3">
	                                            <label><?php echo label('tripay_api_key'); ?></label>
	                                            <input type="text" id="tripay_api_key" name="tripay_api_key"
	                                                   class="form-control"
	                                                   value="<?php echo payment_option_settings('tripay')['settings']->tripay_api_key; ?>"/>
	                                        </div>
	                                        <div class="mb-3">
	                                            <label><?php echo label('tripay_merchant_code'); ?></label>
	                                            <input type="text" id="tripay_merchant_code" name="tripay_merchant_code"
	                                                   class="form-control"
	                                                   value="<?php echo payment_option_settings('tripay')['settings']->tripay_merchant_code; ?>"/>
	                                        </div>
	                                        <div class="mb-3">
	                                            <label><?php echo label('tripay_payment_method'); ?></label>
	                                            <select id="tripay_payment_method" name="tripay_payment_method" class="form-select">
	                                            	<?php 
	                                            	$array = array('MYBVA','PERMATAVA','BNIVA','BRIVA','MANDIRIVA','BCAVA','MUAMALATVA','CIMBVA','BSIVA','OCBCVA','DANAMONVA','OTHERBANKVA','ALFAMART','INDOMARET','ALFAMIDI','OVO','QRIS','QRISC','QRIS2','FUNDS','SHOPEEPAY','QRIS_SHOPEEPAY');
	                                            	foreach($array as $method){
	                                            	?>
	                                            	<option value="<?php echo $method; ?>" <?php if($method==payment_option_settings('tripay')['settings']->tripay_payment_method){ echo 'selected'; } ?>><?php echo $method; ?></option>
	                                            	<?php } ?>
	                                            </select>
	                                        </div>
	                                        <div class="mb-3">
	                                            <label><?php echo label('accepted_currencies'); ?></label>
	                                            <textarea id="payment_option_currencies" name="payment_option_currencies"
	                                                      class="form-control"><?php echo payment_option_slug('tripay')->payment_option_currencies; ?></textarea>
	                                        </div>
	                                    </div>
	                                    <div class="mb-3">
	                                        <button class="btn btn-primary btn-wide float-end" type="submit">
	                                            <?php echo label('update_tripay_settings'); ?>
	                                        </button>
	                                    </div>
	                                </form>
	                            </div>
	                        </div>
	                    </div>
	                </div>
	            </div>

            </div>
        </div>
    </div>
<?php require APPROOT . '/views/inc/footer.php'; ?>