<?php $page = 'subscription_settings'; ?>
<?php require APPROOT . '/views/inc/header.php'; ?>
<?php echo card_div(); ?>
    <form action="<?php echo URLROOT; ?>/settings/subscription_settings" method="post" autocomplete="off"
          enctype="multipart/form-data">
        <div class="row">
            <div class="col-sm-12">
                <div class="card mb-3">
                    <div class="card-header">
                        <?php echo label('subscription_settings'); ?>
                    </div>
                    <div class="card-body">
                        <div class="form-group mb-3">
                            <label class="form-check-label"
                                   for="approve_subscription_automatically"> <?php echo label('approve_subscription_automatically'); ?>
                                <span class="symbol required"></span></label>
                            <div class="form-check form-switch fs-5">
                                <input class="form-check-input" type="checkbox" id="approve_subscription_automatically"
                                       name="approve_subscription_automatically"
                                       value="1" <?php echo !empty(getOption('approve_subscription_automatically')) ? 'checked' : NULL; ?>>
                            </div>
                        </div>
                        <div class="form-group mb-3">
                            <label class="form-label"><?php echo label('minimum_payment_acceptable'); ?> <span
                                        class="symbol required"></span></label>
                            <div class="input-group">
                                <div class="input-group-prepend"><span
                                            class="input-group-text"><?php echo useCurrency(); ?></span></div>
                                <input type="text" name="minimum_payment_acceptable"
                                       value="<?php echo getOption('minimum_payment_acceptable'); ?>"
                                       class="form-control"
                                       required>
                            </div>
                        </div>
                        <div class="form-group mb-3">
                            <label class="form-check-label"
                                   for="keep_remaining_balances_after_subscription_expiry"> <?php echo label('keep_remaining_balances_after_subscription_expiry'); ?>
                                <span class="symbol required"></span></label>
                            <div class="form-check form-switch fs-5">
                                <input class="form-check-input" type="checkbox"
                                       id="keep_remaining_balances_after_subscription_expiry"
                                       name="keep_remaining_balances_after_subscription_expiry"
                                       value="1" <?php echo !empty(getOption('keep_remaining_balances_after_subscription_expiry')) ? 'checked' : NULL; ?>>
                            </div>
                        </div>
                    <?php foreach (itemsPrefixed() as $item) { ?>
                        <div class="form-group mb-3">
                            <label class="form-label"><?php echo label($item); ?> <?php echo label('prefix'); ?></label>
                            <div class="input-group">
                                <input type="text" name="<?php echo $item . '_prefix'; ?>"
                                       value="<?php echo getOption($item . '_prefix'); ?>" class="form-control">
                                <div class="input-group-prepend"><span class="input-group-text">-</span></div>
                            </div>
                        </div>
                    <?php } ?>
                        <div class="form-group mb-3">
                            <label class="form-label"><?php echo label('order_code_length'); ?> <span
                                        class="symbol required"></span></label>
                            <input type="number" name="order_code_length"
                                   value="<?php echo getOption('order_code_length'); ?>"
                                   class="form-control" min="1"
                                   required>
                        </div>
                    </div>
                </div>
            </div>
            <div class="form-group mb-3">
                <button class="btn btn-primary btn-wide float-end" type="submit">
                    <?php echo label('update_subscription_settings'); ?>
                </button>
            </div>
        </div>

    </form>
<?php require APPROOT . '/views/inc/footer.php'; ?>