<?php $page = 'subscriptions'; ?>
<?php require APPROOT . '/views/inc/header.php'; ?>
<?php echo card_div(); ?>
<?php if (!empty($data['subscriptions'])) { ?>
    <div class="card mb-3">
        <div class="card-body">
            <div class="input-group">
                <input type="text" class="form-control" name="order_code" id="order_code" placeholder="<?php echo label('order_code'); ?>">
                 <span class="input-group-text"><i class="fa-solid fa-search"></i></span>
            </div>
        </div>
    </div>
    <?php $rows = start_paging($data['subscriptions']); ?>
    <table class="table table-striped table-hover">
        <thead>
        <tr>
            <th><?php echo label('subscription'); ?></th>
            <th><?php echo label('order_code'); ?></th>
            <th><?php echo label('user'); ?></th>
            <th><?php echo label('added_by'); ?></th>
            <th><?php echo label('package'); ?></th>
            <th><?php echo label('from_date'); ?></th>
            <th><?php echo label('to_date'); ?></th>
            <th><?php echo label('amount'); ?></th>
            <th><?php echo label('status'); ?></th>
            <th></th>
        </tr>
        </thead>
        <tbody>
        <?php foreach ($rows as $subscription) { ?>
            <tr>
                <td><?php echo n_link('subscriptions', 'show', $subscription->subscription_id, $subscription->subscription_name); ?></td>
                <td><?php echo $subscription->order_code; ?></td>
                <td><?php echo user($subscription->user_id)->username; ?></td>
                <td><?php echo user($subscription->subscription_added_by)->username; ?></td>
                <td><?php echo !empty($subscription->package_id) ? package($subscription->package_id)->package_name : label('custom_package'); ?></td>
                <td><?php echo dateTimeFormat($subscription->subscription_start_date); ?></td>
                <td><?php echo subscription_end_date($subscription->subscription_id); ?></td>
                <td><?php echo bold_currency_format($subscription->subscription_cost); ?></td>
                <td><?php echo status_label(subscription_statuses($subscription->subscription_status_id)->subscription_status_colour, label(subscription_statuses($subscription->subscription_status_id)->subscription_status)); ?></td>
                <td class="text-end">
                    <?php
                        if (!in_array($subscription->subscription_status_id, array('2', '3')) && isSuperAdmin()) {
                            echo fa_link('subscriptions', 'approve', $subscription->subscription_id, 'check');
                            echo fa_link('subscriptions', 'cancel', $subscription->subscription_id, 'times');
                        }
                    ?>
                </td>
            </tr>
        <?php } ?>
        </tbody>
    </table>
    <?php echo close_paging($data['subscriptions']); ?>
<?php } else {
    echo no_records($page);
} ?>
<?php require APPROOT . '/views/inc/footer.php'; ?>
<script>
        $(function() {
            $("#order_code").autocomplete({
                source: function(request, response) {
                    $.ajax({
                        url: URLROOT+"/subscriptions/order_code_search",
                        type: "GET",
                        dataType: "json",
                        data: {
                            term: request.term
                        },
                        success: function(data) {
                            response($.map(data, function(item) {
                                return {
                                    label: item.order_code,
                                    value: item.order_code,
                                    subscription_id: item.subscription_id
                                };
                            }));
                        }
                    });
                },
                minLength: 2,
                focus: function(event, ui) {
                    event.preventDefault();
                    $("#order_code").val(ui.item.label);
                },
            }).data("ui-autocomplete")._renderMenu = function(ul, items) {
                var self = this;
                ul.addClass("list-group");
                $.each(items, function(index, item) {
                    self._renderItemData(ul, item);
                });
            };

            $.ui.autocomplete.prototype._renderItem = function(ul, item) {
                return $("<li>")
                    .append('<a href="' + URLROOT + '/subscriptions/show/' + item.subscription_id + '" class="list-group-item list-group-item-action lh-lg">' + item.label + '</a>')
                    .appendTo(ul);
            };
        });
</script>