<?php $page = 'details_of_subscription'; ?>
<?php require APPROOT . '/views/inc/header.php'; ?>
<?php require APPROOT . '/views/subscriptions/subscription_nav.php'; ?>
    <div class="row">
    <div class="col-sm-12">
        <div class="card mb-3">
            <div class="card-body fw-bold"><?php echo label('order_code'); ?> : <?php echo $data['subscription']->order_code; ?></div>
        </div>
        <div class="card mb-3">
            <div class="card-header"><?php echo label('overview'); ?></div>
            <div class="card-body">
                <table class="table table-striped table-hover">
                    <tr>
                        <th><?php echo label('subscription'); ?></th>
                        <td><?php echo $data['subscription']->subscription_name; ?></td>
                    </tr>
                    <tr>
                        <th><?php echo label('user'); ?></th>
                        <td><?php echo user($data['subscription']->user_id)->username; ?></td>
                    </tr>
                    <tr>
                        <th><?php echo label('added_by'); ?></th>
                        <td><?php echo user($data['subscription']->subscription_added_by)->username; ?></td>
                    </tr>
                    <tr>
                        <th><?php echo label('plan'); ?></th>
                        <td>
                            <?php
                                echo !empty($data['subscription']->package_id) ? package($data['subscription']->package_id)->package_name : label('custom_package');
                                echo ' (' . label('duration') . ':<span class="text-muted fw-bold">' . $data['subscription']->subscription_duration . ' ' . $data['subscription']->subscription_duration_type . '</span>)';
                            ?>
                        </td>
                    </tr>
                    <tr>
                        <th><?php echo label('from_date'); ?></th>
                        <td><?php echo dateTimeFormat($data['subscription']->subscription_start_date); ?></td>
                    </tr>
                    <tr>
                        <th><?php echo label('to_date'); ?></th>
                        <td><?php echo dateTimeFormat($data['subscription']->subscription_end_date); ?></td>
                    </tr>
                    <tr>
                        <th><?php echo label('payment_option'); ?></th>
                        <td><?php echo payment_option($data['subscription']->payment_option_id)->payment_option_name; ?></td>
                    </tr>
                    <tr>
                        <th><?php echo label('transaction_id'); ?></th>
                        <td><?php echo $data['subscription']->transaction_id; ?></td>
                    </tr>
                    <tr>
                        <th><?php echo label('amount'); ?></th>
                        <td><?php echo bold_currency_format($data['subscription']->subscription_cost); ?></td>
                    </tr>
                    <tr>
                        <th><?php echo label('date_added'); ?></th>
                        <td><?php echo dateTimeFormat($data['subscription']->subscription_date_added); ?></td>
                    </tr>
                </table>
            </div>
        </div>
    </div>
    </div>
<?php require APPROOT . '/views/inc/footer.php'; ?>