<?php if (!in_array(current_file(), array('login', 'register', 'reset_password', 'forgot_password'))) { ?>
    <!-- Footer -->
    <div class="eai-footer-portion">
        <div class="upper-portion">
            <div class="container">
                <div class="eai-contact-portion" style="<?php echo homepage_background('homepage_footer_block'); ?>">
                    <div class="row">
                        <div class="col-lg-4 col-md-5 col-sm-5 col-12">
                        </div>
                        <div class="col-lg-8 col-md-7 col-sm-7 col-12">
                            <div class="content">
                                <h2><?php echo homepage_footer_block()->homepage_footer_block_heading; ?></h2>
                                <a class="discover"
                                   href="<?php echo homepage_footer_block()->homepage_footer_block_link; ?>"><?php echo homepage_footer_block()->homepage_footer_block_link_description; ?></a>
                            </div>
                            <ul class="content list-group list-group-horizontal mt-3">
                                <?php foreach (homepage_footer_block_features() as $feature) { ?>
                                    <li>
                                        <i class="fa-solid fa-check-circle text-white lh-base pe-1"></i> <span
                                                class="text-white lh-base pe-1"><?php echo $feature->homepage_footer_block_feature_description; ?></span>
                                    </li>
                                <?php } ?>
                            </ul>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="eai-footer-section">
            <div class="container">
                <div class="eai-middle-portion">
                    <div class="row">
                        <div class="col-lg-4 col-md-5 col-sm-6 col-12">
                            <a href="<?php echo URLROOT; ?>">
                                <figure class="eai-footer-logo">
                                    <img src="<?php echo systemPath(company(!empty(company_id()) ? company_id() : 1)->company_website_logo); ?>"
                                         alt="<?php echo company(!empty(company_id()) ? company_id() : 1)->company_name; ?>"
                                         class="img-fluid">
                                </figure>
                            </a>
                            <p class="eai-fs-2 eai-footer-text"><?php echo company(1)->company_website_description; ?></p>
                            <ul class="list-unstyled mb-0 eai-social-icons">
                                <?php foreach (social_profiles() as $profile) { ?>
                                    <li><a href="<?php echo $profile->social_profile_link; ?>"
                                           class="text-decoration-none"
                                           title="<?php echo $profile->social_profile_name; ?>"><?php echo $profile->social_profile_icon; ?></a>
                                    </li>
                                <?php } ?>
                            </ul>
                        </div>
                        <div class="col-lg-2 col-md-3 col-sm-12 col-12 d-md-block d-none">
                            <div class="links">
                                <ul class="list-unstyled mb-0">
                                    <?php foreach (pages() as $page) { ?>
                                        <?php if ($page->show_in_footer && $page->page_status_id == 2) { ?>
                                            <li><i class="fa-solid fa-circle"></i><a
                                                        href="<?php echo URLROOT; ?>/<?php echo $page->page_slug; ?>"
                                                        class=" eai-fs-2 text text-decoration-none"><?php echo $page->page_title; ?></a>
                                            </li>
                                        <?php } ?>
                                    <?php } ?>
                                </ul>
                            </div>
                        </div>
                        <div class="col-lg-3 col-md-4 col-sm-6 col-12 d-sm-block">
                            <div class="icon">
                                <ul class="list-unstyled mb-0">
                                    <li class="text">
                                        <i class="fa fa-phone fa-icon eai-footer-location"></i>
                                        <a href="tel:<?php echo company(1)->company_phone; ?>"
                                           class="mb-0 text text-decoration-none eai-fs-2"><?php echo company(1)->company_phone; ?></a>
                                    </li>
                                    <li class="text">
                                        <i class="fa fa-envelope fa-icon eai-footer-location"></i>
                                        <a href="mailto:<?php echo company(1)->company_email; ?>"
                                           class="mb-0 text text-decoration-none eai-fs-2"><?php echo company(1)->company_email; ?></a>
                                    </li>
                                    <li class="text">
                                        <i class="fa-solid fa-location-dot eai-footer-location"></i>
                                        <p class="text1 eai-fs-2"><?php echo company(1)->company_street; ?></p>
                                    </li>
                                </ul>
                            </div>
                        </div>
                        <div class="col-lg-3 col-md-2 col-sm-12 col-12 d-lg-block">
                            <div class="eai-email-form">
                                <div id="messages"></div>
                                <form action="javascript:void(0)" method="post" id="subscribe_form"
                                      enctype="multipart/form-data">
                                    <div class="form-group position-relative">
                                        <input type="text" class="form_style"
                                               placeholder="<?php echo label('enter_your_email_address'); ?>"
                                               name="subscriber_email">
                                        <button type="submit" name="subscribe"
                                                id="subscribe"><i class="send fa-sharp fa-solid fa-paper-plane"></i>
                                        </button>
                                    </div>
                                    <?php echo label('subscribe_to_our_newsletter_for_offers_and_promotions'); ?>
                                </form>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="eai-copyright">
                    <div class="row">
                        <div class="col-12">
                            <p class="mb-0 eai-fs-2">
                                &copy; <?php echo date('Y'); ?> <?php echo company(1)->company_name; ?></p>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
<?php } ?>

<div class="js">
    <div id="preloader"></div>
</div>

<script src="<?php echo URLROOT; ?>/template/vendor/jquery/jquery.min.js"></script>
<script src="<?php echo URLROOT; ?>/template/vendor/bootstrap/js/bootstrap.min.js"></script>
<script src="<?php echo URLROOT; ?>/template/assets/themes/<?php echo getOption('active_theme'); ?>/assets/js/owl.carousel.js"></script>
<script src="<?php echo URLROOT; ?>/template/assets/themes/<?php echo getOption('active_theme'); ?>/assets/js/animation.js"></script>
<script src="<?php echo URLROOT; ?>/template/assets/themes/<?php echo getOption('active_theme'); ?>/assets/js/custom.js"></script>
<?php echo getOption('custom_script_in_footer'); ?>
</body>
</html>
<script>
    $(document).ready(function () {
        $("#subscribe").click(function (e) {
            e.preventDefault(); // It will Prevent Default action of the form
            /* Storing email in the javascript variable for validation */
            var email = $("input[name=subscriber_email]").val();
            if (email == "") {
                $("#messages").html('<p style="color:red;"><?php echo label("please_enter_email_address"); ?></p>');

                setTimeout(function () {
                    $("#messages").html("");
                }, 1000); // After 1 second / 1000 milliseconds the message will be disappear
            } else {

                /* Submit form data using ajax Starts Here*/

                $.ajax({
                    url: "<?php echo URLROOT; ?>/subscribers/add",
                    method: "post",
                    data: $("#subscribe_form").serialize(),
                    /* Displaying Loading Symbol during the request is processing */
                    beforeSend: function () {
                        $("#messages").html(
                            '<br><span class="spinner-border"></span>'
                        );
                    },

                    success: function (Response) {
                        $("#messages").html(Response);
                        $("#subscribe_form")[0].reset(); // It will reset the form

                        setTimeout(function () {
                            $("#messages").html("");
                        }, 20000); // after 2 seconds the response will be disappear
                    }
                });
                /* Submit form data using ajax Ends Here*/
            }
        });
    });
</script>