<header class="header">
    <div class="container">
        <nav class="navbar navbar-expand-lg navbar-light">
            <?php if (!in_array(current_file(), array('login', 'register', 'reset_password', 'forgot_password'))) { ?>
                <a class="navbar-brand" href="<?php echo URLROOT; ?>">
                    <figure class="mb-0 banner-logo"><img
                                src="<?php echo systemPath(company(!empty(company_id()) ? company_id() : 1)->company_website_logo); ?>"
                                alt="<?php echo company(!empty(company_id()) ? company_id() : 1)->company_name; ?>"
                                class="img-fluid"></figure>
                </a>
                <button class="navbar-toggler collapsed" type="button" data-bs-toggle="collapse"
                        data-bs-target="#navbarNav" aria-controls="navbarNav" aria-expanded="false"
                        aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                    <span class="navbar-toggler-icon"></span>
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="collapse navbar-collapse" id="navbarNav">
                    <ul class="navbar-nav ms-auto">
                        <li class="nav-item active">
                            <a class="nav-link" href="<?php echo URLROOT; ?>"><?php echo label('home'); ?></a>
                        </li>
                        <?php foreach (homepage_sections() as $section) {
                            if ($section->homepage_section_show_in_header) { ?>
                                <li class="nav-item">
                                    <a href="<?php echo URLROOT; ?>/#<?php echo $section->homepage_section; ?>"
                                       class="nav-link">
                                        <?php echo label($section->homepage_section); ?>
                                    </a>
                                </li>
                            <?php }
                        } ?>
                        <?php foreach (pages() as $page) { ?>
                            <?php if ($page->show_in_header && $page->page_status_id == 2) { ?>
                                <li class="nav-item">
                                    <a class="nav-link" href="<?php echo URLROOT; ?>/<?php echo $page->page_slug; ?>">
                                        <?php echo $page->page_title; ?>
                                    </a>
                                </li>
                            <?php } ?>
                        <?php } ?>
                    </ul>
                    <div class="eai-last-list">
                        <?php if (!user_id()) { ?>
                            <a class="eai-register-btn"
                               href="<?php echo URLROOT; ?>/users/register"><?php echo label('register'); ?></a>
                            <a class="eai-login-btn"
                               href="<?php echo URLROOT; ?>/users/login"><?php echo label('login'); ?></a>
                        <?php } else { ?>
                            <a class="eai-login-btn"
                               href="<?php echo URLROOT; ?>/dashboards"><?php echo label('dashboard'); ?></a>
                        <?php } ?>
                    </div>
                </div>
            <?php } ?>
        </nav>
    </div>
</header>