<?php $exclude = TRUE; ?>
<?php require 'inc/head.php'; ?>
<div class="eai-container">
    <?php require_once('inc/header.php'); ?>
    <section class="section">
        <div class="container">
            <div class="row justify-content-center">
                <div class="col-lg-5 col-md-8">
                    <div class="card bg-white shadow rounded border-0 mb-5">
				        <div class="text-center">
				            <a href="<?php echo URLROOT; ?>">
				            <figure class="mt-3">
				                <img src="<?php echo systemPath(company(!empty(company_id()) ? company_id() : 1)->company_website_logo); ?>" alt="<?php echo company(!empty(company_id()) ? company_id() : 1)->company_name; ?>">
				            </figure>
				            </a>
				        </div>
                        <div class="card-body">
                            <h4 class="card-title text-center"><?php echo label('register'); ?></h4>
                            <div class="ml-auto">
                                <span class="fw-bold"><?php flash('user_message'); ?></span>
                            </div>
                            <form action="<?php echo URLROOT; ?>/users/register" method="post" autocomplete="off"
                                  enctype="multipart/form-data">
                                <div class="row">
                                    <div class="col-sm-6">
                                        <div class="form-group mb-3">
                                            <label class="form-label"><?php echo label('first_name'); ?> <i
                                                        class="text-danger fa-solid fa-asterisk"></i></label>
                                            <input type="text"
                                                   value="<?php echo !empty($data['firstname']) ? $data['firstname'] : ''; ?>"
                                                   class="form-control" id="firstname" name="firstname" required>
                                        </div>
                                    </div>
                                    <div class="col-sm-6">
                                        <div class="form-group mb-3">
                                            <label class="form-label"><?php echo label('last_name'); ?> <i
                                                        class="text-danger fa-solid fa-asterisk"></i></label>
                                            <input type="text"
                                                   value="<?php echo !empty($data['lastname']) ? $data['lastname'] : ''; ?>"
                                                   class="form-control" id="lastname" name="lastname" required>
                                        </div>
                                    </div>
                                    <div class="col-sm-6">
                                        <div class="form-group mb-3">
                                            <label class="form-label"><?php echo label('username'); ?> <i
                                                        class="text-danger fa-solid fa-asterisk"></i></label>
                                            <input type="text"
                                                   value="<?php echo !empty($data['username']) ? $data['username'] : ''; ?>"
                                                   class="form-control" id="username" name="username" required>
                                        </div>
                                    </div>
                                    <div class="col-sm-6">
                                        <div class="form-group mb-3">
                                            <label class="form-label"><?php echo label('email_address'); ?> <i
                                                        class="text-danger fa-solid fa-asterisk"></i></label>
                                            <input type="email"
                                                   value="<?php echo !empty($data['email']) ? $data['email'] : (!empty($_SESSION['email']) ? $_SESSION['email'] : ''); ?>"
                                                   class="form-control" id="email" name="email" required>
                                        </div>
                                    </div>
                                    <div class="col-sm-6">
                                        <div class="form-group mb-3">
                                            <label class="form-label"><?php echo label('password'); ?> <i
                                                        class="text-danger fa-solid fa-asterisk"></i></label>
                                            <input type="password" class="form-control"
                                                   name="password"
                                                   id="password" required>
                                        </div>
                                    </div>
                                    <div class="col-sm-6">
                                        <div class="form-group mb-3">
                                            <label class="form-label"><?php echo label('confirm_password'); ?> <i
                                                        class="text-danger fa-solid fa-asterisk"></i></label>
                                            <input type="password" class="form-control"
                                                   name="confirm_password"
                                                   id="confirm_password" required>
                                        </div>
                                    </div>
                                    <div class="col-md-12 mb-3">
                                        <?php if (getOption('enable_google_recaptcha')) { ?>
                                            <!-- Google reCAPTCHA box -->
                                            <div class="g-recaptcha"
                                                 data-sitekey="<?php echo google_recaptcha_settings()->google_recaptcha_site_key; ?>"></div>
                                        <?php } ?>
                                    </div>
                                    <?php if (page(getOption('terms_and_conditions_page'))) { ?>
                                        <div class="col-md-12">
                                            <div class="mb-3">
                                                <div class="form-check">
                                                    <input class="form-check-input" type="checkbox" value=""
                                                           id="terms_and_conditions" name="terms_and_conditions">
                                                    <label class="form-check-label"
                                                           for="terms_and_conditions"><?php echo label('i_accept'); ?>
                                                        <a href="<?php echo URLROOT . '/' . page(getOption('terms_and_conditions_page'))->page_slug; ?>"
                                                           target="_blank"
                                                           class="text-primary"><?php echo label('terms_and_conditions'); ?>
                                                            <i class="fa-solid fa-external-link"></i></a></label>
                                                </div>
                                            </div>
                                        </div>
                                    <?php } ?>
                                    <div class="col-md-12">
                                        <div class="d-grid">
                                            <button class="btn btn-primary btn-lg w-100" type="submit">
                                                <?php echo label('create_account'); ?>
                                            </button>
                                        </div>
                                    </div>
                                </div>


                                <div class="mx-auto mt-4">
                                    <p class="mb-0 mt-3"><small
                                                class="text-dark me-2"><?php echo label('already_have_an_account'); ?></small>
                                        <a href="<?php echo URLROOT . '/users/login'; ?>"
                                           class="link-primary"><?php echo label('login'); ?></a></p>
                                </div>
                            </form>
                        </div>
                    </div>
                </div><!--end col-->
            </div><!--end row-->
        </div> <!--end container-->
    </section>
<?php require 'inc/footer.php'; ?>
<?php if (getOption('enable_google_recaptcha')) { ?>
    <script src="https://www.google.com/recaptcha/api.js" async defer></script>
<?php } ?>