<?php $page = 'details_of_ticket'; ?>
<?php require APPROOT . '/views/inc/header.php'; ?>
<?php require_once 'ticket_navigation.php'; ?>
<?php echo card_div(); ?>
    <div class="col-sm-12">
        <?php if ($data['ticket']->ticket_status_id == 2) { ?>
            <div class="alert alert-warning text-center">
                <?php echo label('this_ticket_is_closed_you_may_reply_to_this_ticket_to_reopen_it'); ?>
            </div>
        <?php } ?>
        <div class="card mb-3">
            <div class="card-header"><?php echo $data['ticket']->ticket_subject; ?></div>
            <div class="card-body">
                <form action="<?php echo URLROOT; ?>/tickets/add_ticket_reply/<?php echo $data['ticket']->ticket_id; ?>"
                      method="post" autocomplete="off" enctype="multipart/form-data">
                    <div class="row">
                        <div class="col-sm-10">
                            <textarea class="form-control" name="ticket_reply"
                                      placeholder="<?php echo label('write_your_reply_here'); ?>..."
                                      required></textarea>
                        </div>
                        <div class="col-sm-2">
                            <?php if ($data['ticket']->ticket_status_id != 2) { ?>
                                <div class="form-check mb-3">
                                    <input class="form-check-input" type="checkbox" value="" id="close_ticket"
                                           name="close_ticket">
                                    <label class="form-check-label" for="close_ticket">
                                        <?php echo label('close_ticket'); ?>
                                    </label>
                                </div>
                            <?php } ?>
                            <button class="btn btn-primary w-100 float-end" type="submit">
                                <?php echo label('reply'); ?>
                            </button>
                        </div>
                    </div>
                </form>
                <hr/>
                <?php foreach (ticket_replies($data['ticket']->ticket_id) as $reply) {
                    if ($data['ticket']->ticket_added_by == $reply->ticket_reply_added_by) {
                        $colour = 'primary';
                    } else {
                        $colour = 'success';
                    }
                    ?>
                    <p class="border border-<?php echo $colour; ?>-subtle rounded px-1">
				<span class="border-bottom mb-3">
					<strong>
						<?php echo n_link('users', 'show', $reply->ticket_reply_added_by, user($reply->ticket_reply_added_by)->username); ?>
					</strong>
					<span class="text-muted float-end border-bottom">
						<?php echo time_elapsed_string($reply->ticket_reply_date_added); ?>
					</span>
				</span>
                        <br/>
                        <?php echo $reply->ticket_reply; ?>
                    </p>
                <?php } ?>
                <p class="border border-primary-subtle rounded px-1">
		<span class="border-bottom mb-3">
					<strong>
						<?php echo n_link('users', 'show', $data['ticket']->ticket_added_by, user($data['ticket']->ticket_added_by)->username); ?>
					</strong>
					<span class="text-muted float-end border-bottom">
						<?php echo time_elapsed_string($data['ticket']->ticket_date_added); ?>
					</span>
				</span>
                    <br/>
                    <?php echo $data['ticket']->ticket_description; ?>
                </p>

            </div>
        </div>
    </div>


<?php require APPROOT . '/views/inc/footer.php'; ?>