<?php $page = 'user_profile'; ?>
<?php require APPROOT . '/views/inc/header.php'; ?>
<?php echo card_div(); ?>
    <div class="col-md-12">
        <div class="card mb-3">
            <div class="card-body">
                <ul class="nav nav-tabs nav-justified">
                    <li class="nav-item">
                        <a data-bs-toggle="tab" href="#card_overview" class="active nav-link">
                            <?php echo label('overview'); ?>
                        </a>
                    </li>
                    <li class="nav-item">
                        <a data-bs-toggle="tab" href="#card_edit_account" class="nav-link">
                            <?php echo label('edit_account'); ?>
                        </a>
                    </li>
                    <li class="nav-item">
                        <a data-bs-toggle="tab" href="#card_language" class="nav-link">
                            <?php echo label('language'); ?>
                        </a>
                    </li>
                    <li class="nav-item">
                        <a data-bs-toggle="tab" href="#card_payout_settings" class="nav-link">
                            <?php echo label('payout_settings'); ?>
                        </a>
                    </li>
                </ul>
                <div class="tab-content">
                    <div id="card_overview" class="tab-pane active">
                        <div class="row">
                            <div class="col-md-5">
                                <p class="h4"><?php echo user(user_id())->firstname; ?><?php echo user(user_id())->lastname; ?></p>
                                <img class="w-25 mb-3"
                                     src="<?php echo profilePath(user(user_id())->profile_image); ?>"
                                     alt="">
                                <form action="<?php echo URLROOT; ?>/users/update_image"
                                      method="post" autocomplete="off" enctype="multipart/form-data">
                                    <input class="form-control mb-3" type="file" name="image" required>
                                    <input type="hidden" class="form-control" id="current_image"
                                           name="current_image"
                                           value="<?php echo user(user_id())->profile_image; ?>">
                                    <div class="float-end">
                                        <input type="submit" name="updateProfileImage"
                                               class="btn btn-primary float-end"
                                               value="<?php echo label('update_profile_image'); ?>"/>
                                    </div>
                                    <a href="<?php echo URLROOT; ?>/users/delete_profile_image"
                                       class="btn btn-danger mb-3 float-start">
                                        <?php echo label('delete_profile_image'); ?>
                                    </a>
                                </form>
                            </div>
                            <div class="col-md-7">
                                <p class="h4"><?php echo label('history'); ?></p>
                                <?php if (!empty(package_history(NULL, NULL, NULL, user_id()))) { ?>
                                    <?php $rows = start_paging(package_history(NULL, NULL, NULL, user_id())); ?>
                                    <div class="vertical-timeline vertical-timeline--animate vertical-timeline--one-column">
                                        <?php foreach ($rows as $history) { ?>
                                            <div class="vertical-timeline-item vertical-timeline-element">
                                                <div>
                <span class="vertical-timeline-element-icon bounce-in">
                <i class="badge-custom badge-custom-dot badge-custom-dot-xl <?php echo timeline_type($history->transaction_type); ?>"></i>
                </span>
                                                    <div class="vertical-timeline-element-content bounce-in">
                                                        <h4 class="timeline-title"><?php echo label($history->type); ?>
                                                            (<?php echo label($history->transaction_type); ?>
                                                            ) <?php echo ($history->user_package_history_comment == 'adjustment') ? '(' . label($history->user_package_history_comment) . ')' : NULL; ?></h4>
                                                        <span><?php echo label('current'); ?>:</span> <span
                                                                class="fw-bold"><?php echo ($history->current == -1) ? label('unlimited') : (int)$history->current; ?></span>
                                                        <span><?php echo label('old'); ?>:</span> <span
                                                                class="fw-bold"><?php echo ($history->old == -1) ? label('unlimited') : $history->old; ?></span>
                                                        <span class="vertical-timeline-element-date"><?php echo dateTimeFormat($history->user_package_history_date_added); ?></span>
                                                    </div>
                                                </div>
                                            </div>
                                        <?php } ?>
                                    </div>
                                    <?php echo close_paging(package_history(NULL, NULL, NULL, user_id())); ?>
                                <?php } else {
                                    echo no_records($page);
                                } ?>
                            </div>
                        </div>
                    </div>
                    <div id="card_edit_account" class="tab-pane fade">
                        <form class="row" action="<?php echo URLROOT; ?>/users/update_profile" method="post"
                              autocomplete="off" enctype="multipart/form-data">
                            <div class="col-md-4">
                                <div class="form-group mb-3">
                                    <label class="form-label">
                                        <?php echo label('first_name'); ?> <span class="symbol required"></span>
                                    </label>
                                    <input type="text" value="<?php echo user(user_id())->firstname; ?>"
                                           class="form-control" id="firstname" name="firstname" required>
                                </div>
                                <div class="form-group mb-3">
                                    <label class="form-label">
                                        <?php echo label('last_name'); ?> <span class="symbol required"></span>
                                    </label>
                                    <input type="text" value="<?php echo user(user_id())->lastname; ?>"
                                           class="form-control" id="lastname" name="lastname" required>
                                </div>
                                <div class="form-group mb-3">
                                    <label class="form-label">
                                        <?php echo label('email_address'); ?> <span class="symbol required"></span>
                                    </label>
                                    <input type="email" value="<?php echo user(user_id())->email; ?>"
                                           class="form-control" id="email" name="email" required>
                                </div>
                                <div class="row">
                                    <div class="col-md-4">
                                        <div class="form-group mb-3">
                                            <label class="form-label">
                                                <?php echo label('country_code'); ?> <span
                                                        class="symbol required"></span>
                                            </label>
                                            <select data-show-subtext="true" data-live-search="true"
                                                    class="form-control <?php echo selectpicker(); ?>" id="calling_code"
                                                    name="calling_code" required>
                                                <option value="<?php echo user(user_id())->calling_code; ?>"><?php echo user(user_id())->calling_code; ?></option>
                                                <?php foreach (countries() as $countries) { ?>
                                                    <option value="<?php echo $countries->calling_code; ?>"><?php echo $countries->short_name; ?>
                                                        (+<?php echo $countries->calling_code; ?>)
                                                    </option>
                                                <?php } ?>
                                            </select>
                                        </div>
                                    </div>
                                    <div class="col-md-8">
                                        <div class="form-group mb-3">
                                            <label class="form-label">
                                                <?php echo label('phone_number'); ?> <span
                                                        class="symbol required"></span>
                                            </label>
                                            <input type="number" value="<?php echo user(user_id())->phone; ?>"
                                                   class="form-control" id="phone" name="phone" required>
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <div class="col-md-4">
                                <div class="form-group mb-3">
                                    <label class="form-label">
                                        <?php echo label('country'); ?> <span class="symbol required"></span>
                                    </label>
                                    <select data-show-subtext="true" data-live-search="true"
                                            class="form-control <?php echo selectpicker(); ?>" id="country"
                                            name="country_id" required>
                                        <option value="<?php echo user(user_id())->country_id; ?>"><?php echo !empty(user(user_id())->country_id) ? country(user(user_id())->country_id)->short_name : ''; ?></option>
                                        <?php foreach (countries() as $countries) { ?>
                                            <option value="<?php echo $countries->country_id; ?>"><?php echo $countries->short_name; ?></option>
                                        <?php } ?>
                                    </select>
                                </div>
                                <div class="form-group mb-3">
                                    <label class="form-label">
                                        <?php echo label('city'); ?> <span class="symbol required"></span>
                                    </label>
                                    <input class="form-control" type="text" value="<?php echo user(user_id())->city; ?>"
                                           name="city" id="city" required>
                                </div>
                                <div class="form-group mb-3">
                                    <label class="form-label">
                                        <?php echo label('state'); ?> <span class="symbol required"></span>
                                    </label>
                                    <input type="text" value="<?php echo user(user_id())->state; ?>"
                                           class="form-control" id="state" name="state" required>
                                </div>
                            </div>
                            <div class="col-md-4">
                                <div class="form-group mb-3">
                                    <label class="form-label">
                                        <?php echo label('postal_code'); ?> <span class="symbol required"></span>
                                    </label>
                                    <input type="text" value="<?php echo user(user_id())->postal_code; ?>"
                                           class="form-control" id="postal_code" name="postal_code" required>
                                </div>
                                <div class="form-group mb-3">
                                    <label class="form-label">
                                        <?php echo label('zip_code'); ?> <span class="symbol required"></span>
                                    </label>
                                    <input class="form-control" value="<?php echo user(user_id())->zip_code; ?>"
                                           type="text" name="zip_code" id="zip_code" required>
                                </div>
                                <div class="form-group mb-3">
                                    <label class="form-label">
                                        <?php echo label('street'); ?> <span class="symbol required"></span>
                                    </label>
                                    <input type="text" value="<?php echo user(user_id())->street; ?>"
                                           class="form-control" id="street" name="street" required>
                                </div>
                            </div>
                            <input type="hidden" value="<?php echo user(user_id())->user_id; ?>" class="form-control"
                                   id="user_id" name="user_id">
                            <input type="hidden" value="<?php echo user(user_id())->role_id; ?>" class="form-control"
                                   id="role_id" name="role_id">

                            <div class="col-md-12">
                                <button class="btn btn-primary btn-wide float-end" type="submit">
                                    <?php echo label('update_profile'); ?>
                                </button>
                            </div>
                        </form>
                    </div>
                    <div id="card_language" class="tab-pane fade">
                        <form class="row" action="<?php echo URLROOT; ?>/users/update_language" method="post"
                              autocomplete="off" enctype="multipart/form-data">
                            <div class="col-md-12">
                                <div class="form-group mb-3">
                                    <label class="form-label">
                                        <?php echo label('select_your_default_language'); ?> <span
                                                class="symbol required"></span>
                                    </label>
                                    <select data-show-subtext="true" data-live-search="true"
                                            class="form-control <?php echo selectpicker(); ?>" id="default_language"
                                            name="default_language" required>
                                        <option value="<?php echo !empty(user(user_id())->default_language) ? user(user_id())->default_language : NULL; ?>"><?php echo !empty(user(user_id())->default_language) ? language(user(user_id())->default_language)->language : NULL; ?></option>
                                        <?php foreach (languages() as $language) { ?>
                                            <?php if (language_file($language->language_iso)) { ?>
                                                <option value="<?php echo $language->language_iso; ?>"><?php echo $language->language; ?></option>
                                            <?php } ?>
                                        <?php } ?>
                                    </select>
                                </div>
                                <input type="hidden" value="<?php echo user_id(); ?>" class="form-control" id="user_id"
                                       name="user_id">
                                <div class="form-group mb-3">
                                    <button class="btn btn-primary btn-wide float-end" type="submit">
                                        <?php echo label('update_language'); ?>
                                    </button>
                                </div>
                            </div>
                        </form>
                    </div>
                    <div id="card_payout_settings" class="tab-pane fade">
                        <form class="row" action="<?php echo URLROOT; ?>/users/update_payout_settings" method="post"
                              autocomplete="off" enctype="multipart/form-data">
                            <div class="col-md-12">
                                <div class="form-group mb-3">
                                    <label class="form-label">
                                        <?php echo label('select_your_payout_mode'); ?> <span
                                                class="symbol required"></span>
                                    </label>
                                    <select data-show-subtext="true" data-live-search="true"
                                            class="form-control <?php echo selectpicker(); ?>" id="payout_mode_id"
                                            name="payout_mode_id" required>
                                        <option value=""></option>
                                        <?php foreach (payout_modes() as $payout_mode) { ?>
                                            <option value="<?php echo $payout_mode->payout_mode_id; ?>" <?php if ($payout_mode->payout_mode_id == user(user_id())->payout_mode_id) {
                                                echo 'selected';
                                            } ?>><?php echo $payout_mode->payout_mode_name; ?></option>
                                        <?php } ?>
                                    </select>
                                </div>
                                <div class="form-group mb-3">
                                    <label class="form-label">
                                        <?php echo label('payout_address'); ?> <span class="symbol required"></span>
                                    </label>
                                    <textarea class="form-control" name="payout_address"
                                              required><?php echo user(user_id())->payout_address; ?></textarea>
                                </div>
                                <input type="hidden" value="<?php echo user_id(); ?>" class="form-control" id="user_id"
                                       name="user_id">
                                <div class="form-group mb-3">
                                    <button class="btn btn-primary btn-wide float-end" type="submit">
                                        <?php echo label('update_payout_address'); ?>
                                    </button>
                                </div>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
<?php require APPROOT . '/views/inc/footer.php'; ?>