﻿<?php $page = 'details_of_user'; ?>
<?php require APPROOT . '/views/inc/header.php'; ?>
<?php require_once 'user_navigation.php'; ?>
    <div class="col-md-6">
        <div class="card mb-3">
            <div class="card-header"><?php echo label('overview'); ?></div>
            <div class="card-body">
                <table class="table table-striped table-hover">
                    <tr>
                        <th><?php echo label('email'); ?></th>
                        <td><?php echo $data['user']->email; ?></td>
                    </tr>
                    <tr>
                        <th><?php echo label('phone'); ?></th>
                        <td><?php echo $data['user']->calling_code . " " . $data['user']->phone; ?></td>
                    </tr>
                    <tr>
                        <th><?php echo label('country'); ?></th>
                        <td><?php echo !empty($data['user']->country_id) ? country($data['user']->country_id)->short_name : ''; ?></td>
                    </tr>
                    <tr>
                        <th><?php echo label('state'); ?></th>
                        <td><?php echo $data['user']->state; ?></td>
                    </tr>
                    <tr>
                        <th><?php echo label('postal_code'); ?></th>
                        <td><?php echo $data['user']->postal_code; ?></td>
                    </tr>
                    <tr>
                        <th><?php echo label('zip_code'); ?></th>
                        <td><?php echo $data['user']->zip_code; ?></td>
                    </tr>
                    <tr>
                        <th><?php echo label('city'); ?></th>
                        <td><?php echo $data['user']->city; ?></td>
                    </tr>
                    <tr>
                        <th><?php echo label('street'); ?></th>
                        <td><?php echo $data['user']->street; ?></td>
                    </tr>
                    <tr>
                        <th><?php echo label('status'); ?></th>
                        <td><?php echo status_label(user_status($data['user']->user_status_id)->user_status_colour, label(user_status($data['user']->user_status_id)->user_status)); ?></td>
                    </tr>
                </table>
            </div>
        </div>
    </div>
    <div class="col-md-6">
        <div class="card mb-3">
            <div class="card-header"><?php echo label('profile'); ?></div>
            <div class="card-body">
                <img src="<?php echo profilePath($data['user']->profile_image); ?>" class="img-rounded w-25"
                     alt="<?php echo label('no_image'); ?>"/>
                <p class="fw-bold"><?php echo $data['user']->firstname . " " . $data['user']->lastname; ?>
                    (<?php echo $data['user']->username; ?>)</p>
                <p>
                <table class="table">
                    <tr>
                        <td>
                            <span class="fw-bold"><?php echo ($data['user']->user_remaining_chat_assistants == -1) ? label('unlimited') : number_format($data['user']->user_remaining_chat_assistants); ?></span> <?php echo label('chat_assistants_left'); ?>
                        </td>
                    </tr>
                    <tr>
                        <td>
                            <span class="fw-bold"><?php echo ($data['user']->user_remaining_trained_models == -1) ? label('unlimited') : number_format($data['user']->user_remaining_trained_models); ?></span> <?php echo label('trained_models_left'); ?>
                        </td>
                    </tr>
                    <tr>
                        <td>
                            <span class="fw-bold"><?php echo ($data['user']->user_remaining_chat_files == -1) ? label('unlimited') : number_format($data['user']->user_remaining_chat_files); ?></span> <?php echo label('chat_files_left'); ?>
                        </td>
                    </tr>
                    <tr>
                        <td>
                            <span class="fw-bold"><?php echo ($data['user']->user_remaining_chat_links == -1) ? label('unlimited') : number_format($data['user']->user_remaining_chat_links); ?></span> <?php echo label('chat_links_left'); ?>
                        </td>
                    </tr>
                    <tr>
                        <td>
                            <span class="fw-bold"><?php echo ($data['user']->user_remaining_chat_sitemaps == -1) ? label('unlimited') : number_format($data['user']->user_remaining_chat_sitemaps); ?></span> <?php echo label('chat_sitemaps_left'); ?>
                        </td>
                    </tr>
                    <tr>
                        <td>
                            <span class="fw-bold"><?php echo ($data['user']->user_remaining_words == -1) ? label('unlimited') : number_format($data['user']->user_remaining_words); ?></span> <?php echo label('words_left'); ?>
                        </td>
                    </tr>
                </table>
                </p>
            </div>
        </div>
    </div>
    <div class="col-md-6">
        <div class="card mb-3">
            <div class="card-header"><?php echo label('history'); ?></div>
            <div class="card-body">
                <?php if (!empty(package_history(NULL, NULL, NULL, $data['user']->user_id))) { ?>
                    <?php $rows = start_paging(package_history(NULL, NULL, NULL, $data['user']->user_id)); ?>
                    <div class="vertical-timeline vertical-timeline--animate vertical-timeline--one-column">
                        <?php foreach ($rows as $history) { ?>
                            <div class="vertical-timeline-item vertical-timeline-element">
                                <div>
                <span class="vertical-timeline-element-icon bounce-in">
                <i class="badge-custom badge-custom-dot badge-custom-dot-xl <?php echo timeline_type($history->transaction_type); ?>"></i>
                </span>
                                    <div class="vertical-timeline-element-content bounce-in">
                                        <h4 class="timeline-title"><?php echo label($history->type); ?>
                                            (<?php echo label($history->transaction_type); ?>
                                            ) <?php echo ($history->user_package_history_comment == 'adjustment') ? '(' . label($history->user_package_history_comment) . ')' : NULL; ?></h4>
                                        <span><?php echo label('current'); ?>:</span> <span
                                                class="fw-bold"><?php echo ($history->current == -1) ? label('unlimited') : (int)$history->current; ?></span>
                                        <span><?php echo label('old'); ?>:</span> <span
                                                class="fw-bold"><?php echo ($history->old == -1) ? label('unlimited') : $history->old; ?></span>
                                        <span class="vertical-timeline-element-date"><?php echo dateTimeFormat($history->user_package_history_date_added); ?></span>
                                    </div>
                                </div>
                            </div>
                        <?php } ?>
                    </div>
                    <?php echo close_paging(package_history(NULL, NULL, NULL, $data['user']->user_id)); ?>
                <?php } else {
                    echo no_records($page);
                } ?>
            </div>
        </div>
    </div>
    <div class="col-md-6">
        <div class="card mb-3">
            <div class="card-header"><?php echo label('adjust'); ?></div>
            <div class="card-body">
                <form action="<?php echo URLROOT; ?>/users/adjust/<?php echo $data['user']->user_id; ?>"
                      method="post" autocomplete="off" enctype="multipart/form-data">
                    <div class="mb-3">
                        <label class="form-label"><?php echo label('item'); ?> <span
                                    class="symbol required"></span></label>
                        <select data-show-subtext="true" data-live-search="true" class="form-control selectpicker"
                                id="type" name="type" required>
                            <option value=""></option>
                            <?php foreach (package_types() as $type) { ?>
                                <option value="<?php echo $type; ?>"><?php echo label($type); ?> </option>
                            <?php } ?>
                        </select>
                    </div>
                    <div class="mb-3">
                        <label class="form-label"><?php echo label('quantity'); ?> <span
                                    class="symbol required"></span></label>
                        <input type="number" value="0"
                               class="form-control" id="quantity" name="quantity" required>
                    </div>
                    <div class="mb-3">
                        <button class="btn btn-primary btn-wide float-end" type="submit">
                            <?php echo label('adjust'); ?>
                        </button>
                    </div>
                </form>
            </div>
        </div>
    </div>
<?php require APPROOT . '/views/inc/footer.php'; ?>