<?php $page = 'backups'; ?>
<?php require APPROOT . '/views/inc/header.php'; ?>
<?php echo card_div(); ?>
    <div class="row">
        <div class="col-md-6">
            <div class="card mb-3">
                <div class="card-body">
                    <div class="row">
                        <div class="col-sm-12">
                            <form method="post" id="export_form">
                                <?php $Tables_in_mybizcmsthree = 'Tables_in_' . DB_NAME; ?>
                                <?php foreach ($data['all_tables'] as $table) { ?>
                                    <div class="checkbox">
                                        <label hidden=""><input type="checkbox" class="checkbox_table" name="table[]"
                                                                value="<?php echo $table->$Tables_in_mybizcmsthree; ?>"
                                                                checked
                                                                hidden/> <?php echo $table->$Tables_in_mybizcmsthree; ?>
                                        </label>
                                    </div>
                                <?php } ?>
                                <div class="mb-3">
                                    <button class="btn btn-primary btn-wide float-end" type="submit">
                                        <?php echo label('backup_database'); ?>
                                    </button>
                                </div>
                            </form>
                        </div>
                        <div class="col-sm-12">
                            <table class="table table-striped table-hover">
                                <thead>
                                <tr>
                                    <th><?php echo label('backup'); ?></th>
                                    <th><?php echo label('size'); ?></th>
                                    <th><?php echo label('date_created'); ?></th>
                                    <th></th>
                                </tr>
                                </thead>
                                <tbody>
                                <?php $dir = APPROOT . DATABASE_FOLDER;
                                    if (is_dir($dir)){
                                    if ($dh = opendir($dir)){
                                    while (($file = readdir($dh)) !== false){
                                    if (($file == '.') || ($file == '..')){
                                        //ignore them
                                }else{
                                ?>
                                <tr>
                                    <td><a
                                                href="<?php echo URLROOT; ?>/utilities/download_db_backup/?backup=<?php echo $file; ?>"><?php echo $file; ?></a>
                                    </td>
                                    <td> <?php echo customFileSize(filesize($dir . $file)); ?> </td>
                                    <td><?php echo dateTimeFormat(date("Y-m-d H:i:s", filemtime($dir . $file))); ?></td>
                                    <td class="text-end">
                                        <a href="<?php echo URLROOT; ?>/utilities/delete_db_backup/?backup=<?php echo $file; ?>"
                                           title="<?php echo label('delete'); ?>" data-placement="left"
                                           data-toggle="tooltip" class="btn btn-transparent btn-xs">
                                            <div
                                            <i class="fa fa-times fa fa-white">
                        </div>
                        </a>
                        </td>
                        </tr>
                        <?php
                            }
                            }
                            closedir($dh);
                            }
                            }
                        ?>
                        </tbody>
                        </table>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <div class="col-md-6">
        <div class="card mb-3">
            <form action="<?php echo URLROOT; ?>/utilities/backup_settings" method="post" autocomplete="off"
                  enctype="multipart/form-data">

                <div class="card-body">
                    <div class="row">
                        <div class="mb-3">
                            <label class="form-label"><?php echo label('backup_database_automatically'); ?>?
                                <span class="symbol required"></span> </label>
                            <div class="mb-3">
                                <div class="form-check form-check-inline">
                                    <input id="radio1" name="backup_database_automatically"
                                           value="1" <?php if (getOption('backup_database_automatically') == 1) {
                                        echo 'checked';
                                    } ?> type="radio">
                                    <label class="form-check-label" for="radio1"><?php echo label('yes'); ?></label>
                                </div>
                                <div class="form-check form-check-inline">
                                    <input id="radio2" name="backup_database_automatically"
                                           value="0" <?php if (getOption('backup_database_automatically') == 0) {
                                        echo 'checked';
                                    } ?> type="radio">
                                    <label class="form-check-label" for="radio2"><?php echo label('no'); ?></label>
                                </div>
                            </div>
                        </div>
                        <div class="mb-3">
                            <label class="form-label"><?php echo label('backup_database_automatically_after'); ?></label>
                            <div class="input-group">
                                <input type="number"
                                       value="<?php echo explode(' ', getOption('backup_database_automatically_after'))[0]; ?>"
                                       min="0" class="form-control" id="backup_database_automatically_after"
                                       name="backup_database_automatically_after">
                                <div class="input-group-prepend">
                                    <select data-show-subtext="true" data-live-search="true"
                                            class="form-control <?php echo selectpicker(); ?>"
                                            id="backup_database_automatically_after_duration_type"
                                            name="backup_database_automatically_after_duration_type"
                                            data-container="body"
                                            required>
                                        <option value=""></option>
                                        <?php foreach (duration_types() as $duration_type) { ?>
                                            <option value="<?php echo $duration_type->duration_type_name; ?>" <?php if ($duration_type->duration_type_name == explode(' ', getOption('backup_database_automatically_after'))[1]) {
                                                echo "selected";
                                            } ?>><?php echo label($duration_type->duration_type_name); ?></option>
                                        <?php } ?>
                                    </select>
                                </div>
                            </div>
                            <i><?php echo label('last_database_backup'); ?>
                                : <?php echo time_elapsed_string(getOption('last_database_backup')); ?></i>
                        </div>
                        <div class="mb-3">
                            <label class="form-label"><?php echo label('delete_database_backups_older_than'); ?>
                                ? <?php echo label('set_to_0_days_to_never_delete_backups'); ?></label>
                            <div class="input-group">
                                <input type="number"
                                       value="<?php echo getOption('delete_database_backups_older_than'); ?>"
                                       min="0" class="form-control" id="delete_database_backups_older_than"
                                       name="delete_database_backups_older_than" required>
                                <div class="input-group-prepend"><span
                                            class="input-group-text"><?php echo label('days'); ?></span></div>
                            </div>
                        </div>
                        <div class="mb-3">
                            <button class="btn btn-primary btn-wide float-end" type="submit">
                                <?php echo label('update_backup_settings'); ?>
                            </button>
                        </div>
                    </div>
                </div>
            </form>
        </div>
    </div>
    </div>
<?php require APPROOT . '/views/inc/footer.php'; ?>