<?php $page = 'edit_widget'; ?>
<?php require APPROOT . '/views/inc/header.php'; ?>
<?php require_once 'widget_navigation.php'; ?>
<?php echo card_div(); ?>
<form action="<?php echo URLROOT; ?>/widgets/edit/<?php echo $data['widget']->widget_id; ?>" method="post"
      autocomplete="off" enctype="multipart/form-data">
    <div class="card mb-3">
        <div class="card-body">
            <div class="mb-3">
                <label class="form-label"><?php echo label('name'); ?> <span
                            class="symbol required"></span></label>
                <input type="text"
                       class="form-control" id="widget_name" name="widget_name"
                       value="<?php echo $data['widget']->widget_name; ?>" required>
            </div>
        </div>
    </div>
    <div class="card mb-3">
        <div class="card-body">
            <div class="row">
                <div class="col-sm-6">
                    <div class="mb-3">
                        <label class="form-label"><?php echo label('header'); ?> <span
                                    class="symbol required"></span></label>
                        <input type="text" value="<?php echo $data['widget']->widget_header; ?>"
                               class="form-control" id="widget_header" name="widget_header">
                    </div>
                    <div class="mb-3">
                        <label class="form-label"><?php echo label('header_textarea'); ?> <span
                                    class="symbol required"></span></label>
                        <textarea
                                class="form-control" id="widget_header_textarea"
                                name="widget_header_textarea"><?php echo $data['widget']->widget_header_textarea; ?></textarea>
                    </div>
                    <div class="mb-3">
                        <label class="form-label"><?php echo label('chat_message_placeholder'); ?> <span
                                    class="symbol required"></span></label>
                        <textarea
                                class="form-control" id="chat_message_placeholder"
                                name="chat_message_placeholder"><?php echo $data['widget']->widget_message_placeholder; ?></textarea>
                    </div>
                    <div class="mb-3">
                        <label class="form-label"><?php echo label('chat_instructions'); ?> <span
                                    class="symbol required"></span></label>
                        <textarea
                                class="form-control" id="user_chat_instructions"
                                name="user_chat_instructions"><?php echo $data['widget']->user_chat_instructions; ?></textarea>
                    </div>
                    <div class="mb-3">
                        <label class="form-label"><?php echo label('document_or_link_timeout'); ?> <span
                                    class="symbol required"></span></label>
                        <div class="input-group">
                            <input type="number" value="<?php echo $data['widget']->widget_document_timeout; ?>"
                                   min="1"
                                   class="form-control" id="widget_document_timeout" placeholder="5000"
                                   name="widget_document_timeout" required>
                            <span class="input-group-text"><?php echo label('milliseconds'); ?></span>
                        </div>
                    </div>
                    <div class="mb-3">
                        <label class="form-label"><?php echo label('document_or_link_retries'); ?> <span
                                    class="symbol required"></span></label>
                        <div class="input-group">
                            <input type="number" value="<?php echo $data['widget']->widget_document_retries; ?>"
                                   min="1"
                                   class="form-control" id="widget_document_retries" placeholder="10"
                                   name="widget_document_retries" required>
                            <span class="input-group-text"><?php echo label('times'); ?></span>
                        </div>
                    </div>
                    <div class="mb-3">
                        <label class="form-label"><?php echo label('visit_timeout'); ?> <span
                                    class="symbol required"></span></label>
                        <div class="input-group">
                            <input type="number" value="<?php echo $data['widget']->widget_visit_timeout; ?>"
                                   min="1"
                                   class="form-control" id="widget_visit_timeout"
                                   name="widget_visit_timeout" required>
                            <span class="input-group-text"><?php echo label('seconds'); ?></span>
                        </div>
                    </div>
                </div>
                <div class="col-sm-6">
                    <div class="mb-3">
                        <label class="form-label"><?php echo label('colour'); ?> <span
                                    class="symbol required"></span></label>
                        <input type="color" value="<?php echo $data['widget']->widget_colour; ?>"
                               class="form-control  form-control-color" id="widget_colour"
                               name="widget_colour">
                    </div>
                    <fieldset class="border border-primary border-opacity-25 rounded px-3 mb-3">
                        <legend class="form-label fs-6 fw-normal"><?php echo label('assistant_chat_colour'); ?></legend>
                        <div class="row">
                            <div class="col mb-3">
                                <label class="form-label"><?php echo label('background'); ?> <span
                                            class="symbol required"></span></label>
                                <input type="color" value="<?php echo $data['widget']->widget_assistant_background_colour; ?>"
                                    class="form-control  form-control-color" id="widget_assistant_background_colour"
                                    name="widget_assistant_background_colour">
                            </div>
                            <div class="col mb-3">
                                <label class="form-label"><?php echo label('text'); ?> <span
                                            class="symbol required"></span></label>
                                <input type="color" value="<?php echo $data['widget']->widget_assistant_text_colour; ?>"
                                    class="form-control  form-control-color" id="widget_assistant_text_colour"
                                    name="widget_assistant_text_colour">
                            </div>
                        </div>
                    </fieldset>
                    <fieldset class="border border-primary border-opacity-25 rounded px-3 mb-3">
                        <legend class="form-label fs-6 fw-normal"><?php echo label('user_chat_colour'); ?></legend>
                        <div class="row">
                            <div class="col mb-3">
                                <label class="form-label"><?php echo label('background'); ?> <span
                                            class="symbol required"></span></label>
                                <input type="color" value="<?php echo $data['widget']->widget_user_background_colour; ?>"
                                    class="form-control  form-control-color" id="widget_user_background_colour"
                                    name="widget_user_background_colour">
                            </div>
                            <div class="col mb-3">
                                <label class="form-label"><?php echo label('text'); ?> <span
                                            class="symbol required"></span></label>
                                <input type="color" value="<?php echo $data['widget']->widget_user_text_colour; ?>"
                                    class="form-control  form-control-color" id="widget_user_text_colour"
                                    name="widget_user_text_colour">
                            </div>
                        </div>
                    </fieldset>
                    <div class="mb-3">
                        <label class="form-label"><?php echo label('open_button'); ?> <span
                                    class="symbol required"></span></label>
                        <textarea
                                class="form-control" id="widget_open_button"
                                name="widget_open_button"><?php echo $data['widget']->widget_open_button; ?></textarea>
                    </div>
                    <div class="mb-3">
                        <label class="form-label"><?php echo label('close_button'); ?> <span
                                    class="symbol required"></span></label>
                        <textarea
                                class="form-control" id="widget_close_button"
                                name="widget_close_button"><?php echo $data['widget']->widget_close_button; ?></textarea>
                    </div>
                    <div class="mb-3">
                        <label class="form-label"><?php echo label('chat_icon_animation'); ?> <span
                                    class="symbol required"></span></label>
                        <select class="form-select" id="user_chat_icon_animation" name="user_chat_icon_animation">
                            <option><?php echo label('none'); ?></option>
                            <?php foreach (chat_icon_animations() as $chat_icon_animation) { ?>
                                <option value="<?php echo $chat_icon_animation->chat_icon_animation; ?>" <?php if ($data['widget']->user_chat_icon_animation == $chat_icon_animation->chat_icon_animation) {
                                    echo 'selected';
                                } ?>><?php echo label($chat_icon_animation->chat_icon_animation); ?></option>
                            <?php } ?>
                        </select>
                    </div>
                    <div class="mb-3">
                        <label class="form-label"><?php echo label('position'); ?> <span
                                    class="symbol required"></span></label>
                        <select class="form-select" id="user_chat_icon_position" name="user_chat_icon_position">
                            <option></option>
                            <option value="right" <?php if ($data['widget']->user_chat_icon_position == 'right') {
                                echo 'selected';
                            } ?>><?php echo label('right'); ?></option>
                            <option value="center" <?php if ($data['widget']->user_chat_icon_position == 'center') {
                                echo 'selected';
                            } ?>><?php echo label('center'); ?></option>
                            <option value="left" <?php if ($data['widget']->user_chat_icon_position == 'left') {
                                echo 'selected';
                            } ?>><?php echo label('left'); ?></option>
                        </select>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <div class="card mb-3">
        <div class="card-body">
            <label class="form-label"><?php echo label('use'); ?> <span
                        class="symbol required"></span></label>
            <div class="mb-3">
                <div class="form-check form-check-inline">
                    <input type="radio" class="form-check-input chatbot_options" id="chat_assistants"
                           name="chatbot_options"
                           value="chat_assistants" <?php if (!empty($data['widget']->user_bots)) {
                        echo 'checked';
                    } ?>>
                    <label class="form-check-label"
                           for="chat_assistants"><?php echo label('chat_assistants'); ?></label>
                </div>
                <div class="form-check form-check-inline">
                    <input type="radio" class="form-check-input chatbot_options"
                           id="favourite_chat_assistants" name="chatbot_options"
                           value="favourite_chat_assistants">
                    <label class="form-check-label"
                           for="favourite_chat_assistants"><?php echo label('favourite_chat_assistants'); ?></label>
                </div>
                <div class="form-check form-check-inline">
                    <input type="radio" class="form-check-input chatbot_options" id="trained_model"
                           name="chatbot_options"
                           value="trained_model" <?php if (!empty($data['widget']->user_trained_model)) {
                        echo 'checked';
                    } ?>>
                    <label class="form-check-label"
                           for="trained_model"><?php echo label('trained_model'); ?></label>
                </div>
                <div class="form-check form-check-inline">
                    <input type="radio" class="form-check-input chatbot_options" id="chat_files"
                           name="chatbot_options"
                           value="chat_files" <?php if (!empty($data['widget']->user_chat_files)) {
                        echo 'checked';
                    } ?>>
                    <label class="form-check-label"
                           for="chat_files"><?php echo label('chat_files'); ?></label>
                </div>
                <div class="form-check form-check-inline">
                    <input type="radio" class="form-check-input chatbot_options" id="chat_links"
                           name="chatbot_options"
                           value="chat_links" <?php if (!empty($data['widget']->user_chat_links)) {
                        echo 'checked';
                    } ?>>
                    <label class="form-check-label"
                           for="chat_links"><?php echo label('chat_links'); ?></label>
                </div>
                <div class="form-check form-check-inline">
                    <input type="radio" class="form-check-input chatbot_options" id="chat_sitemaps"
                           name="chatbot_options"
                           value="chat_sitemaps" <?php if (!empty($data['widget']->user_chat_sitemaps)) {
                        echo 'checked';
                    } ?>>
                    <label class="form-check-label"
                           for="chat_sitemaps"><?php echo label('chat_sitemaps'); ?></label>
                </div>
            </div>
            <span id="response"></span>
        </div>
    </div>
    <div class="mb-3">
        <button class="btn btn-primary btn-wide float-end" type="submit">
            <?php echo label('update_widget'); ?>
        </button>
    </div>
</form>
<?php require APPROOT . '/views/inc/footer.php'; ?>
<script>
    $(document).ready(function () {
        $('input[type="radio"]').click(function () {
            var value = $(this).val();
            var widget_id = "<?php echo $data['widget']->widget_id; ?>";
            $.ajax({
                url: "<?php echo URLROOT; ?>/chatbots/chatbot_options",
                type: "post",
                data: "chatbot_option=" + value +
                    "&&widget_id=" + widget_id + 
                	"&&source=widget",
                success: function (response) {
                    $("#response").html(response);
                },
                error: function (response) {
                    console.log(response)
                }
            });
        });

        var value = $(".chatbot_options:checked").val();
        $('input:radio[name=chatbot_options][value=' + value + ']:checked').trigger('click');
    });
</script>