function Export2Word(element, filename = '', from_html) {
    var preHtml = "<html xmlns:o='urn:schemas-microsoft-com:office:office' xmlns:w='urn:schemas-microsoft-com:office:word' xmlns='http://www.w3.org/TR/REC-html40'><head><meta charset='utf-8'><title>Export HTML To Doc</title></head><body>";
    var postHtml = "</body></html>";
    //var html = preHtml+document.getElementById(element).innerHTML+postHtml;
    //var html = preHtml+document.getElementById(element).value+postHtml;
    if (from_html) {
        var html = preHtml + document.getElementById(element).innerHTML + postHtml;
    } else {
        var html = preHtml + CKEDITOR.instances[element].getData() + postHtml;
    }

    var blob = new Blob(['\ufeff', html], {
        type: 'application/msword'
    });

    // Specify link url
    var url = 'data:application/vnd.ms-word;charset=utf-8,' + encodeURIComponent(html);

    // Specify file name
    filename = filename ? filename + '.doc' : 'document.doc';

    // Create download link element
    var downloadLink = document.createElement("a");

    document.body.appendChild(downloadLink);

    if (navigator.msSaveOrOpenBlob) {
        navigator.msSaveOrOpenBlob(blob, filename);
    } else {
        // Create a link to the file
        downloadLink.href = url;

        // Setting the file name
        downloadLink.download = filename;

        //triggering the function
        downloadLink.click();
    }

    document.body.removeChild(downloadLink);
}

function Export2Text(element, filename = '', from_html) {
    if (from_html) {
        var html = document.getElementById(element).innerHTML;
    } else {
        var html = CKEDITOR.instances[element].getData();
    }

    const textDataBlob = new Blob([html], {type: "text/plain"});

    const downloadUrl = window.URL.createObjectURL(textDataBlob);

    const downloadLink = document.createElement('a');

    filename = filename + '.txt';
    downloadLink.download = filename
    downloadLink.href = downloadUrl;
    downloadLink.click();
}

function CopyText(element, filename = '', from_html) {
    // Get the text field
    if (from_html) {
        var copyText = document.getElementById(element).innerHTML;
    } else {
        var copyText = CKEDITOR.instances[element].getData();
    }

    // Copy the text inside the text field
    navigator.clipboard.writeText(copyText);

    // Alert the copied text
    alert("Copied the text: " + copyText);
}

function Export2Pdf(element, filename = '', from_html) {

    window.jsPDF = window.jspdf.jsPDF;

    var doc = new jsPDF();

// Source HTMLElement or a string containing HTML.
//var elementHTML = document.querySelector("#temperature");
    if (from_html) {
        var elementHTML = document.getElementById(element).innerHTML;
    } else {
        var elementHTML = CKEDITOR.instances[element].getData();
    }

// Add new page
    /*doc.text(20, 20, elementHTML);

    // Save the PDF
    doc.save('document.pdf');
    */

    doc.html(elementHTML, {
        callback: function (doc) {
            // Save the PDF
            doc.save(filename + '.pdf');
        },
        x: 15,
        y: 15,
        width: 170, //target width in the PDF document
        windowWidth: 650 //window width in CSS pixels
    });
}