async function get() {
    let url = URLROOT + "/embedded/common/" + user_uid + custom_widget_url
    let obj = await (await fetch(url)).json();
    return obj;
}

var tags;

const fetchData = async () => {
    tags = await get();
};

const readTxt = async () => {
    if (!tags) {
        await fetchData();
    }

    let url = tags.widget_url + tags.user_uid + tags.custom_widget_url;
    let response = await fetch(url);
    const txt = await response.text().then((str) => {
        return str.split('\r');
    });

    let result = txt;

    let ele = document.getElementById('textData');
    ele.innerHTML = ele.innerHTML + '<br />' + result;
};

const readTxtHeader = async () => {
    if (!tags) {
        await fetchData();
    }

    let url = tags.widget_url + "assistant_header/" + tags.user_uid + tags.custom_widget_url;
    let response = await fetch(url);
    const txt = await response.text().then((str) => {
        return str.split('\r');
    });

    let result = txt;

    let ele = document.getElementById('textDataHeader');
    ele.innerHTML = ele.innerHTML + '<br />' + result;
};

const readTxtFooter = async () => {
    if (!tags) {
        await fetchData();
    }
    //if (tags.accept_custom_branding == 0) {
    let url = tags.widget_url + "assistant_footer/" + tags.user_uid + tags.custom_widget_url;
    let response = await fetch(url);
    const txt = await response.text().then((str) => {
        return str.split('\r');
    });

    let result = txt;

    let ele = document.getElementById('textDataFooter');
    ele.innerHTML = ele.innerHTML + result;
    //}
};

// Call fetchData once to get the tags
fetchData();

// Call other functions as needed
readTxt();
readTxtHeader();
readTxtFooter();

const checkbox = document.createElement('input');
checkbox.type = "checkbox";
checkbox.id = "check";
document.body.appendChild(checkbox);

const label = document.createElement('label');
label.className = "sai-chat-btn";
label.id = "chatButton";
label.setAttribute("for", "check");
document.body.appendChild(label);

const span_comment = document.createElement('span');
span_comment.className = "sai-comment";
span_comment.id = "comment";
label.appendChild(span_comment);

const i_comment = document.createElement('i');
i_comment.className = "fa fa-robot";
span_comment.appendChild(i_comment);

const span_closed = document.createElement('span');
span_closed.className = "closed";
span_closed.id = "closed";
label.appendChild(span_closed);

const i_closed = document.createElement('i');
i_closed.className = "fa-solid fa-close sai-close";
span_closed.appendChild(i_closed);

const div_wrapper = document.createElement('div');
div_wrapper.className = "sai-wrapper";
div_wrapper.id = "sai-wrapper";
document.body.appendChild(div_wrapper);

const div_header = document.createElement('div');
div_header.className = "sai-header";
div_header.id = "textDataHeader";
div_wrapper.appendChild(div_header);

const div_form_container = document.createElement('div');
div_form_container.className = "sai-form-container";
div_wrapper.appendChild(div_form_container);

const div_chat_form = document.createElement('div');
div_chat_form.className = "sai-chat-form";
div_chat_form.id = "textData";
div_form_container.appendChild(div_chat_form);

const div_current_url = document.createElement('input');
div_current_url.setAttribute("type", "hidden");
div_current_url.setAttribute("id", "current_url");
div_current_url.setAttribute("name", "current_url");
div_current_url.className = "current_url";
div_chat_form.appendChild(div_current_url);

const div_footer = document.createElement('div');
div_footer.className = "sai-footer";
div_footer.id = "textDataFooter";
div_wrapper.appendChild(div_footer);


(async () => {
    tags = await get()
    setTimeout(function () {
        document.getElementById('textDataHeader').style.backgroundColor = tags.colour;
        document.getElementById('sai-wrapper').style.borderColor = tags.colour;
        document.getElementById('chatButton').style.backgroundColor = tags.colour;
        document.getElementById('comment').innerHTML = tags.comment;
        document.getElementById('closed').innerHTML = tags.closed;
        document.getElementById('textData').style.height = "100%";
        if (tags.accept_custom_branding == 1) {
            //document.getElementById('textDataFooter').remove();
        }
    }, 2)
})();


