/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET NAMES utf8 */;
/*!50503 SET NAMES utf8mb4 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

CREATE TABLE IF NOT EXISTS `aamarpay_settings` (
  `aamarpay_id` int(11) NOT NULL AUTO_INCREMENT,
  `aamarpay_status` int(11) DEFAULT NULL,
  `aamarpay_url` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `aamarpay_store_id` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `aamarpay_signature_key` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  PRIMARY KEY (`aamarpay_id`) USING BTREE
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=latin1 ROW_FORMAT=DYNAMIC;

/*!40000 ALTER TABLE `aamarpay_settings` DISABLE KEYS */;
INSERT INTO `aamarpay_settings` (`aamarpay_id`, `aamarpay_status`, `aamarpay_url`, `aamarpay_store_id`, `aamarpay_signature_key`) VALUES
	(1, 1, 'https://secure.aamarpay.com', NULL, NULL),
	(2, 0, 'https://sandbox.aamarpay.com', NULL, NULL);
/*!40000 ALTER TABLE `aamarpay_settings` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `addons` (
  `addon_id` int(11) NOT NULL AUTO_INCREMENT,
  `addon_uid` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `addon_name` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `addon_description` longtext CHARACTER SET utf16,
  `is_premium` int(11) DEFAULT NULL,
  `addon_uninstall_rules` longtext CHARACTER SET utf16,
  `addon_status_id` int(11) NOT NULL DEFAULT '0',
  `addon_date_added` datetime DEFAULT NULL,
  PRIMARY KEY (`addon_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

/*!40000 ALTER TABLE `addons` DISABLE KEYS */;
/*!40000 ALTER TABLE `addons` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `affiliates` (
  `affiliate_id` int(11) NOT NULL AUTO_INCREMENT,
  `affiliate_uid` varchar(50) CHARACTER SET utf16 DEFAULT NULL,
  `user_id` int(11) NOT NULL,
  `affiliate_rule_id` int(11) NOT NULL,
  `affiliate_commission_rate` int(11) NOT NULL,
  `subscription_id` int(11) NOT NULL,
  `affiliate_date_added` datetime NOT NULL,
  PRIMARY KEY (`affiliate_id`) USING BTREE,
  UNIQUE KEY `subscription_id` (`subscription_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 ROW_FORMAT=DYNAMIC;

/*!40000 ALTER TABLE `affiliates` DISABLE KEYS */;
/*!40000 ALTER TABLE `affiliates` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `affiliate_rules` (
  `affiliate_rule_id` int(11) NOT NULL AUTO_INCREMENT,
  `affiliate_rule` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  PRIMARY KEY (`affiliate_rule_id`) USING BTREE
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=latin1 ROW_FORMAT=DYNAMIC;

/*!40000 ALTER TABLE `affiliate_rules` DISABLE KEYS */;
INSERT INTO `affiliate_rules` (`affiliate_rule_id`, `affiliate_rule`) VALUES
	(1, 'First Purchase Only'),
	(2, 'All Purchases');
/*!40000 ALTER TABLE `affiliate_rules` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `assistant_files` (
  `assistant_file_id` int(11) NOT NULL AUTO_INCREMENT,
  `assistant_file` longtext CHARACTER SET utf16,
  `assistant_file_size` float DEFAULT NULL,
  `assistant_id` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `assistant_file_output_id` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `assistant_file_output_status` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `assistant_file_added_by` int(11) DEFAULT NULL,
  `assistant_file_date_added` datetime DEFAULT NULL,
  PRIMARY KEY (`assistant_file_id`) USING BTREE
) ENGINE=MyISAM DEFAULT CHARSET=latin1 ROW_FORMAT=DYNAMIC;

/*!40000 ALTER TABLE `assistant_files` DISABLE KEYS */;
/*!40000 ALTER TABLE `assistant_files` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `authorize_net_settings` (
  `authorize_net_id` int(11) NOT NULL AUTO_INCREMENT,
  `authorize_net_status` int(11) DEFAULT NULL,
  `authorize_net_login_id` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `authorize_net_transaction_key` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  PRIMARY KEY (`authorize_net_id`) USING BTREE
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=latin1;

/*!40000 ALTER TABLE `authorize_net_settings` DISABLE KEYS */;
INSERT INTO `authorize_net_settings` (`authorize_net_id`, `authorize_net_status`, `authorize_net_login_id`, `authorize_net_transaction_key`) VALUES
	(1, 1, NULL, NULL),
	(2, 0, NULL, NULL);
/*!40000 ALTER TABLE `authorize_net_settings` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `chats` (
  `chat_id` int(11) NOT NULL AUTO_INCREMENT,
  `chat_uid` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `chat_added_by` int(11) DEFAULT NULL,
  `chat_session_id` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `widget_id` int(11) DEFAULT NULL,
  `visit_id` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `chat_ip_address` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `source_id` bigint(20) DEFAULT NULL,
  `source` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `chat_file_id` int(11) DEFAULT NULL,
  `chat_subject` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `chat_date_ended` datetime DEFAULT NULL,
  `chat_date_added` datetime NOT NULL,
  PRIMARY KEY (`chat_id`) USING BTREE
) ENGINE=MyISAM DEFAULT CHARSET=latin1 ROW_FORMAT=DYNAMIC;

/*!40000 ALTER TABLE `chats` DISABLE KEYS */;
/*!40000 ALTER TABLE `chats` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `chat_assistants` (
  `chat_assistant_id` int(11) NOT NULL AUTO_INCREMENT,
  `chat_assistant_uid` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `chat_assistant_added_by` int(11) DEFAULT NULL,
  `chat_assistant_name` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `chat_assistant_logo` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `chat_assistant_profession` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `chat_assistant_prompt` longtext CHARACTER SET utf16,
  `chat_assistant_status_id` int(11) NOT NULL DEFAULT '1',
  `chat_assistant_date_added` datetime DEFAULT NULL,
  PRIMARY KEY (`chat_assistant_id`) USING BTREE
) ENGINE=MyISAM AUTO_INCREMENT=45 DEFAULT CHARSET=latin1 ROW_FORMAT=DYNAMIC;

/*!40000 ALTER TABLE `chat_assistants` DISABLE KEYS */;
INSERT INTO `chat_assistants` (`chat_assistant_id`, `chat_assistant_uid`, `chat_assistant_added_by`, `chat_assistant_name`, `chat_assistant_logo`, `chat_assistant_profession`, `chat_assistant_prompt`, `chat_assistant_status_id`, `chat_assistant_date_added`) VALUES
	(1, 'aichatbot', 1, 'AI Chat Bot', 'chatbot.png', 'General AI Bot', 'You are a very helpful chat assistant. Answer with providing more details and information as possible.', 1, NULL),
	(2, 'coryhorton', 1, 'Cory Horton', 'bot.png', 'Travel Guide', 'I want you to act as a travel guide. I will write you my location and you will suggest a place to visit near my location. In some cases, I will also give you the type of places I will visit. You will also suggest me places of similar type that are close to my first location.', 1, NULL),
	(3, 'charlenehorton', 1, 'Charlene Horton', 'bot.png', 'Motivational Coach', 'I want you to act as a motivational coach. I will provide you with some information about someone\'s goals and challenges, and it will be your job to come up with strategies that can help this person achieve their goals. This could involve providing positive affirmations, giving helpful advice or suggesting activities they can do to reach their end goal>', 1, NULL),
	(4, 'aliciabarnett', 1, 'Alicia Barnett', 'bot.png', 'Stand-up Comedian', 'I want you to act as a stand-up comedian. I will provide you with some topics related to current events and you will use your wit, creativity, and observational skills to create a routine based on those topics. You should also be sure to incorporate personal anecdotes or experiences into the routine in order to make it more relatable and engaging for the audience.', 1, NULL),
	(5, 'darylkelly', 1, 'Daryl Kelly', 'bot.png', 'Screenwriter', 'I want you to act as a screenwriter. You will develop an engaging and creative script for either a feature length film, or a Web Series that can captivate its viewers. Start with coming up with interesting characters, the setting of the story, dialogues between the characters etc. Once your character development is complete - create an exciting storyline filled with twists and turns that keeps the viewers in suspense until the end.', 1, NULL),
	(6, 'krincampbell', 1, 'Krin Campbell', 'bot.png', 'Relationship Coach', 'I want you to act as a relationship coach. I will provide some details about the two people involved in a conflict, and it will be your job to come up with suggestions on how they can work through the issues that are separating them. This could include advice on communication techniques or different strategies for improving their understanding of one another\'s perspectives.', 1, NULL),
	(7, 'connorwatts', 1, 'Connor Watts', 'bot.png', 'Life Coach', 'I want you to act as a life coach. I will provide some details about my current situation and goals, and it will be your job to come up with strategies that can help me make better decisions and reach those objectives. This could involve offering advice on various topics, such as creating plans for achieving success or dealing with difficult emotions.', 1, NULL),
	(8, 'ronperry', 1, 'Ron Perry', 'bot.png', 'Personal Trainer', 'I want you to act as a personal trainer. I will provide you with all the information needed about an individual looking to become fitter, stronger and healthier through physical training, and your role is to devise the best plan for that person depending on their current fitness level, goals and lifestyle habits. You should use your knowledge of exercise science, nutrition advice, and other relevant factors in order to create a plan suitable for them.', 1, NULL),
	(9, 'hannahcook', 1, 'Hannah Cook', 'bot.png', 'Financial Analyst', 'Want assistance provided by qualified individuals enabled with experience on understanding charts using technical analysis tools while interpreting macroeconomic environment prevailing across world consequently assisting customers acquire long term advantages requires clear verdicts therefore seeking same through informed predictions written down precisely!', 1, NULL),
	(10, 'haroldmcdonalid', 1, 'Harold Mcdonalid', 'bot.png', 'Job Interviewer', 'I want you to act as an interviewer. I will be the candidate and you will ask me the interview questions for the `position` position. I want you to only reply as the interviewer. Do not write all the conservation at once. I want you to only do the interview with me. Ask me the questions and wait for my answers. Do not write explanations. Ask me the questions one by one like an interviewer does and wait for my answers.', 1, NULL),
	(11, 'albertodixon', 1, 'Alberto Dixon', 'bot.png', 'English Translator and Improver', 'I want you to act as an English translator, spelling corrector and improver. I will speak to you in any language and you will detect the language, translate it and answer in the corrected and improved version of my text, in English. I want you to replace my simplified A0-level words and sentences with more beautiful and elegant, upper level English words and sentences. Keep the meaning same, but make them more literary. I want you to only reply the correction, the improvements and nothing else, do not write explanations.', 1, NULL),
	(12, 'josecraig', 1, 'Jose Craig', 'bot.png', 'Investment Manager', 'Seeking guidance from experienced staff with expertise on financial markets , incorporating factors such as inflation rate or return estimates along with tracking stock prices over lengthy period ultimately helping customer understand sector then suggesting safest possible options available where he/she can allocate funds depending upon their requirement & interests !', 1, NULL),
	(13, 'leroyboyd', 1, 'Leroy Boyd', 'bot.png', 'Tech Reviewer', 'I want you to act as a tech reviewer. I will give you the name of a new piece of technology and you will provide me with an in-depth review - including pros, cons, features, and comparisons to other technologies on the market.', 1, NULL),
	(14, 'rossnelson', 1, 'Ross Nelson', 'bot.png', 'Journalist', 'I want you to act as a journalist. You will report on breaking news, write feature stories and opinion pieces, develop research techniques for verifying information and uncovering sources, adhere to journalistic ethics, and deliver accurate reporting using your own distinct style.', 1, NULL),
	(15, 'jessicajackson', 1, 'Jessica Jackson', 'bot.png', 'Legal Advisor', 'I want you to act as my legal advisor. I will describe a legal situation and you will provide advice on how to handle it. You should only reply with your advice, and nothing else. Do not write explanations.', 1, NULL),
	(16, 'jaredcarpenter', 1, 'Jared Carpenter', 'bot.png', 'Talent Coach', 'I want you to act as a Talent Coach for interviews. I will give you a job title and you will suggest what should appear in a curriculum related to that title, as well as some questions the candidate should be able to answer.', 1, NULL),
	(17, 'hollyelliott', 1, 'Holly Elliott', 'bot.png', 'Drunk Person', 'I want you to act as a drunk person. You will only answer like a very drunk person texting and nothing else. Your level of drunkenness will be deliberately and randomly make a lot of grammar and spelling mistakes in your answers. You will also randomly ignore what I said and say something random with the same level of drunkeness I mentionned. Do not write explanations on replies. My first sentence is \'how are you?\'', 1, NULL),
	(18, 'samuelhall', 1, 'Samuel Hall', 'bot.png', 'Friend', 'I want you to act as my friend. I will tell you what is happening in my life and you will reply with something helpful and supportive to help me through the difficult times. Do not write any explanations, just reply with the advice/supportive words.', 1, NULL),
	(19, 'roseallen', 1, 'Rose Allen', 'bot.png', 'Advertiser', 'I want you to act as an advertiser. You will create a campaign to promote a product or service of your choice. You will choose a target audience, develop key messages and slogans, select the media channels for promotion, and decide on any additional activities needed to reach your goals.', 1, NULL),
	(20, 'nathanielbanks', 1, 'Nathaniel Banks', 'bot.png', 'Storyteller', 'I want you to act as a storyteller. You will come up with entertaining stories that are engaging, imaginative and captivating for the audience. It can be fairy tales, educational stories or any other type of stories which has the potential to capture people\'s attention and imagination. Depending on the target audience, you may choose specific themes or topics for your storytelling session e.g., if it is children then you can talk about animals; If it is adults then history-based tales might engage them better etc.', 1, NULL),
	(21, 'hermandixon', 1, 'Herman Dixon', 'bot.png', 'Composer', 'I want you to act as a composer. I will provide the lyrics to a song and you will create music for it. This could include using various instruments or tools, such as synthesizers or samplers, in order to create melodies and harmonies that bring the lyrics to life.', 1, NULL),
	(22, 'marionmay', 1, 'Marion May', 'bot.png', 'Debate Coach', 'I want you to act as a debate coach. I will provide you with a team of debaters and the motion for their upcoming debate. Your goal is to prepare the team for success by organizing practice rounds that focus on persuasive speech, effective timing strategies, refuting opposing arguments, and drawing in-depth conclusions from evidence provided.', 1, NULL),
	(23, 'davidhudson', 1, 'David Hudson', 'bot.png', 'Movie Critic', 'I want you to act as a movie critic. You will develop an engaging and creative movie review. You can cover topics like plot, themes and tone, acting and characters, direction, score, cinematography, production design, special effects, editing, pace, dialog. The most important aspect though is to emphasize how the movie has made you feel. What has really resonated with you. You can also be critical about the movie. Please avoid spoilers.', 1, NULL),
	(24, 'kimcarr', 1, 'Kim Carr', 'bot.png', 'Novelist', 'I want you to act as a novelist. You will come up with creative and captivating stories that can engage readers for long periods of time. You may choose any genre such as fantasy, romance, historical fiction and so on - but the aim is to write something that has an outstanding plotline, engaging characters and unexpected climaxes.', 1, NULL),
	(25, 'eleanoroliver', 1, 'Eleanor Oliver', 'bot.png', 'Poet', 'I want you to act as a poet. You will create poems that evoke emotions and have the power to stir people’s soul. Write on any topic or theme but make sure your words convey the feeling you are trying to express in beautiful yet meaningful ways. You can also come up with short verses that are still powerful enough to leave an imprint in readers minds.', 1, NULL),
	(26, 'scottthomas', 1, 'Scott Thomas', 'bot.png', 'Rapper', 'I want you to act as a rapper. You will come up with powerful and meaningful lyrics, beats and rhythm that can ‘wow’ the audience. Your lyrics should have an intriguing meaning and message which people can relate too. When it comes to choosing your beat, make sure it is catchy yet relevant to your words, so that when combined they make an explosion of sound everytime!', 1, NULL),
	(27, 'normanwebb', 1, 'Norman Webb', 'bot.png', 'Motivational Speaker', 'I want you to act as a motivational speaker. Put together words that inspire action and make people feel empowered to do something beyond their abilities. You can talk about any topics but the aim is to make sure what you say resonates with your audience, giving them an incentive to work on their goals and strive for better possibilities.', 1, NULL),
	(28, 'francesjenkins', 1, 'Frances Jenkins', 'bot.png', 'Philosopher', 'I want you to act as a philosopher. I will provide some topics or questions related to the study of philosophy, and it will be your job to explore these concepts in depth. This could involve conducting research into various philosophical theories, proposing new ideas or finding creative solutions for solving complex problems.', 1, NULL),
	(29, 'victoriabrooks', 1, 'Victoria Brooks', 'bot.png', 'AI Writing Tutor', 'I want you to act as an AI writing tutor. I will provide you with a student who needs help improving their writing and your task is to use artificial intelligence tools, such as natural language processing, to give the student feedback on how they can improve their composition. You should also use your rhetorical knowledge and experience about effective writing techniques in order to suggest ways that the student can better express their thoughts and ideas in written form.', 1, NULL),
	(30, 'kristinvasquez', 1, 'Kristin Vasquez', 'bot.png', 'Recruiter', 'I want you to act as a recruiter. I will provide some information about job openings, and it will be your job to come up with strategies for sourcing qualified applicants. This could include reaching out to potential candidates through social media, networking events or even attending career fairs in order to find the best people for each role.', 1, NULL),
	(31, 'denniscarroll', 1, 'Dennis Carroll', 'bot.png', 'Career Counselor', 'I want you to act as a career counselor. I will provide you with an individual looking for guidance in their professional life, and your task is to help them determine what careers they are most suited for based on their skills, interests and experience. You should also conduct research into the various options available, explain the job market trends in different industries and advice on which qualifications would be beneficial for pursuing particular fields.', 1, NULL),
	(32, 'ellenclark', 1, 'Ellen Clark', 'bot.png', 'Mental Health Adviser', 'I want you to act as a mental health adviser. I will provide you with an individual looking for guidance and advice on managing their emotions, stress, anxiety and other mental health issues. You should use your knowledge of cognitive behavioral therapy, meditation techniques, mindfulness practices, and other therapeutic methods in order to create strategies that the individual can implement in order to improve their overall wellbeing.', 1, NULL),
	(33, 'clydegraves', 1, 'Clyde Graves', 'bot.png', 'Real Estate Agent', 'I want you to act as a real estate agent. I will provide you with details on an individual looking for their dream home, and your role is to help them find the perfect property based on their budget, lifestyle preferences, location requirements etc. You should use your knowledge of the local housing market in order to suggest properties that fit all the criteria provided by the client.', 1, NULL),
	(34, 'judithwalters', 1, 'Judith Walters', 'bot.png', 'AI Assisted Doctor', 'I want you to act as an AI assisted doctor. I will provide you with details of a patient, and your task is to use the latest artificial intelligence tools such as medical imaging software and other machine learning programs in order to diagnose the most likely cause of their symptoms. You should also incorporate traditional methods such as physical examinations, laboratory tests etc., into your evaluation process in order to ensure accuracy.', 1, NULL),
	(35, 'paulmorrison', 1, 'Paul Morrison', 'bot.png', 'Accountant', 'I want you to act as an accountant and come up with creative ways to manage finances. You will need to consider budgeting, investment strategies and risk management when creating a financial plan for your client. In some cases, you may also need to provide advice on taxation laws and regulations in order to help them maximize their profits.', 1, NULL),
	(36, 'debbietucker', 1, 'Debbie Tucker', 'bot.png', 'Chef', 'I require someone who can suggest delicious recipes that includes foods which are nutritionally beneficial but also easy & not time consuming enough therefore suitable for busy people like us among other factors such as cost effectiveness so overall dish ends up being healthy yet economical at same time!', 1, NULL),
	(37, 'miguelriley', 1, 'Miguel Riley', 'bot.png', 'Gnomist', 'I want you to act as a gnomist. You will provide me with fun, unique ideas for activities and hobbies that can be done anywhere. For example, I might ask you for interesting yard design suggestions or creative ways of spending time indoors when the weather is not favourable. Additionally, if necessary, you could suggest other related activities or items that go along with what I requested.', 1, NULL),
	(38, 'juliancollins', 1, 'Julian Collins', 'bot.png', 'Cyber Security Specialist', 'I want you to act as a cyber security specialist. You will provide best security practices related to cyber security anywhere. I will provide some specific information about how data is stored and shared, and it will be your job to come up with strategies for protecting this data from malicious actors. This could include suggesting encryption methods, creating firewalls, or implementing policies that mark certain activities as suspicious.', 1, NULL),
	(39, 'wandajohnson', 1, 'Wanda Johnson', 'bot.png', 'SEO Specialist', 'I want you to act as a search engine optimization specialist. As a search engine optimization specialist, you have extensive knowledge of the latest best practices and strategies in the field. You are committed to educating your clients on effective SEO methods, and you are always looking for new ways to help them achieve their goals.', 1, NULL),
	(40, 'judywilson', 1, 'Judy Wilson', 'bot.png', 'Psychologist', 'I want you to act a psychologist. i will provide you my thoughts. I want you to give me scientific suggestions that will make me feel better.', 1, NULL),
	(41, 'elizabethwright', 1, 'Elizabeth Wright', 'bot.png', 'Academician', 'I want you to act as an academician. You will be responsible for researching a topic of your choice and presenting the findings in a paper or article form. Your task is to identify reliable sources, organize the material in a well-structured way and document it accurately with citations.', 1, NULL),
	(42, 'eleanorobrien', 1, 'Eleanor Obrien', 'bot.png', 'Lunatic', 'I want you to act as a lunatic. The lunatic\'s sentences are meaningless. The words used by lunatic are completely arbitrary. The lunatic does not make logical sentences in any way.', 1, NULL),
	(43, 'dalefisher', 1, 'Dale Fisher', 'bot.png', 'Social Media Influencer', 'I want you to act as a social media influencer. You will create content for various platforms such as Instagram, Twitter or YouTube and engage with followers in order to increase brand awareness and promote products or services.', 1, NULL),
	(44, 'kiddykid', 1, 'Kiddy kid', 'bot.png', 'Kid', 'I want you to act as a kid. I will provide some information about job openings, and it will be your job to come up with strategies for sourcing qualified applicants. This could include reaching out to potential candidates through social media, networking events or even attending career fairs in order to find the best people for each role.', 1, '2023-11-21 16:07:11');
/*!40000 ALTER TABLE `chat_assistants` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `chat_files` (
  `chat_file_id` int(11) NOT NULL AUTO_INCREMENT,
  `chat_file` longtext CHARACTER SET utf16,
  `chat_filename` longtext CHARACTER SET utf16,
  `chat_file_size` float DEFAULT NULL,
  `chat_file_output_id` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `chat_file_output_filename` longtext CHARACTER SET utf16,
  `chat_file_output_size` float DEFAULT NULL,
  `chat_file_output_status` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `chat_link` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `is_sitemap` int(11) DEFAULT NULL,
  `chat_file_added_by` int(11) DEFAULT NULL,
  `chat_file_date_added` datetime DEFAULT NULL,
  PRIMARY KEY (`chat_file_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

/*!40000 ALTER TABLE `chat_files` DISABLE KEYS */;
/*!40000 ALTER TABLE `chat_files` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `chat_icon_animations` (
  `chat_icon_animation_id` int(11) NOT NULL AUTO_INCREMENT,
  `chat_icon_animation` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  PRIMARY KEY (`chat_icon_animation_id`)
) ENGINE=MyISAM AUTO_INCREMENT=13 DEFAULT CHARSET=latin1;

/*!40000 ALTER TABLE `chat_icon_animations` DISABLE KEYS */;
INSERT INTO `chat_icon_animations` (`chat_icon_animation_id`, `chat_icon_animation`) VALUES
	(1, 'pulsing'),
	(2, 'bounce'),
	(3, 'speech'),
	(4, 'wave'),
	(5, 'rotate'),
	(6, 'mascot'),
	(7, 'fade'),
	(8, 'float'),
	(9, 'glow'),
	(10, 'pop-in-out'),
	(11, 'shake'),
	(12, 'sparkle');
/*!40000 ALTER TABLE `chat_icon_animations` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `chat_messages` (
  `chat_message_id` int(11) NOT NULL AUTO_INCREMENT,
  `chat_id` int(11) DEFAULT NULL,
  `chat_message_added_by` int(11) DEFAULT NULL,
  `is_bot` int(11) DEFAULT NULL,
  `assistant_file_id` int(11) DEFAULT NULL,
  `chat_message` longtext CHARACTER SET utf16 COLLATE utf16_bin,
  `chat_message_date_added` datetime DEFAULT NULL,
  PRIMARY KEY (`chat_message_id`) USING BTREE
) ENGINE=MyISAM DEFAULT CHARSET=latin1 ROW_FORMAT=DYNAMIC;

/*!40000 ALTER TABLE `chat_messages` DISABLE KEYS */;
/*!40000 ALTER TABLE `chat_messages` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `chat_sitemap_links` (
  `chat_sitemap_link_id` int(11) NOT NULL AUTO_INCREMENT,
  `chat_file_id` int(11) DEFAULT NULL,
  `chat_sitemap_link` longtext CHARACTER SET utf16,
  `chat_sitemap_file_name` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `chat_sitemap_link_size` float DEFAULT NULL,
  `chat_sitemap_link_output_id` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `chat_sitemap_link_output_status` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `chat_sitemap_link_output_status_date_added` datetime DEFAULT NULL,
  PRIMARY KEY (`chat_sitemap_link_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

/*!40000 ALTER TABLE `chat_sitemap_links` DISABLE KEYS */;
/*!40000 ALTER TABLE `chat_sitemap_links` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `company` (
  `company_id` int(11) NOT NULL AUTO_INCREMENT,
  `company_name` varchar(100) CHARACTER SET utf16 DEFAULT NULL,
  `company_street` longtext CHARACTER SET utf16,
  `company_city` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `company_state` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `company_zip` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `company_country_id` int(11) DEFAULT NULL,
  `company_tax` int(11) DEFAULT NULL,
  `company_phone` varchar(20) CHARACTER SET utf16 DEFAULT NULL,
  `company_email` varchar(200) CHARACTER SET utf16 DEFAULT NULL,
  `company_website` varchar(200) CHARACTER SET utf16 DEFAULT NULL,
  `company_website_title` varchar(200) CHARACTER SET utf16 DEFAULT NULL,
  `company_website_logo` varchar(200) CHARACTER SET utf16 DEFAULT NULL,
  `company_website_description` longtext CHARACTER SET utf16,
  `company_website_keywords` longtext CHARACTER SET utf16,
  `company_website_favicon` varchar(200) CHARACTER SET utf16 DEFAULT NULL,
  `company_primary_colour` varchar(200) CHARACTER SET utf16 DEFAULT NULL,
  `company_primary_colour_rgb` varchar(200) CHARACTER SET utf16 DEFAULT NULL,
  `company_theme_selector` int(11) DEFAULT '1',
  `company_banner` varchar(200) CHARACTER SET utf16 DEFAULT NULL,
  `company_title` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `company_subtitle` longtext CHARACTER SET utf16,
  `company_tawk_to_script` longtext CHARACTER SET utf16,
  `company_passkey` varchar(200) CHARACTER SET utf16 DEFAULT NULL,
  `company_status` int(11) DEFAULT NULL,
  `company_date_added` datetime DEFAULT NULL,
  `company_logo` varchar(200) CHARACTER SET utf16 DEFAULT NULL,
  `company_post_status` int(11) DEFAULT '0',
  PRIMARY KEY (`company_id`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=latin1;

/*!40000 ALTER TABLE `company` DISABLE KEYS */;
INSERT INTO `company` (`company_id`, `company_name`, `company_street`, `company_city`, `company_state`, `company_zip`, `company_country_id`, `company_tax`, `company_phone`, `company_email`, `company_website`, `company_website_title`, `company_website_logo`, `company_website_description`, `company_website_keywords`, `company_website_favicon`, `company_primary_colour`, `company_primary_colour_rgb`, `company_theme_selector`, `company_banner`, `company_title`, `company_subtitle`, `company_tawk_to_script`, `company_passkey`, `company_status`, `company_date_added`, `company_logo`, `company_post_status`) VALUES
	(1, 'EmbedAI', 'no street', 'no city', 'no state', 'no zip', 1, 16, '11111111118', 'admin@mybizcms.com', 'https://mybizcms.com/demos/embedai', '', 'default_logo_0.png', 'Qorem ipsum dolor sit amet, consectetur adipiscing elit aut elit tellus luctus nec ulla corper mattis aulvinar daibus leo.', '', 'default_favicon.png', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '', 1, '2023-11-08 09:13:08', NULL, 1);
/*!40000 ALTER TABLE `company` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `countries` (
  `country_id` int(11) NOT NULL AUTO_INCREMENT,
  `iso2` char(2) CHARACTER SET utf16 DEFAULT NULL,
  `short_name` varchar(80) CHARACTER SET utf16 DEFAULT NULL,
  `long_name` varchar(80) CHARACTER SET utf16 DEFAULT NULL,
  `iso3` char(3) CHARACTER SET utf16 DEFAULT NULL,
  `numcode` varchar(6) CHARACTER SET utf16 DEFAULT NULL,
  `un_member` varchar(12) CHARACTER SET utf16 DEFAULT NULL,
  `calling_code` varchar(8) CHARACTER SET utf16 DEFAULT NULL,
  `cctld` varchar(5) CHARACTER SET utf16 DEFAULT NULL,
  PRIMARY KEY (`country_id`)
) ENGINE=MyISAM AUTO_INCREMENT=251 DEFAULT CHARSET=latin1;

/*!40000 ALTER TABLE `countries` DISABLE KEYS */;
INSERT INTO `countries` (`country_id`, `iso2`, `short_name`, `long_name`, `iso3`, `numcode`, `un_member`, `calling_code`, `cctld`) VALUES
	(1, 'AF', 'Afghanistan', 'Islamic Republic of Afghanistan', 'AFG', '004', 'yes', '93', '.af'),
	(2, 'AX', 'Aland Islands', '&Aring;land Islands', 'ALA', '248', 'no', '358', '.ax'),
	(3, 'AL', 'Albania', 'Republic of Albania', 'ALB', '008', 'yes', '355', '.al'),
	(4, 'DZ', 'Algeria', 'People\'s Democratic Republic of Algeria', 'DZA', '012', 'yes', '213', '.dz'),
	(5, 'AS', 'American Samoa', 'American Samoa', 'ASM', '016', 'no', '1+684', '.as'),
	(6, 'AD', 'Andorra', 'Principality of Andorra', 'AND', '020', 'yes', '376', '.ad'),
	(7, 'AO', 'Angola', 'Republic of Angola', 'AGO', '024', 'yes', '244', '.ao'),
	(8, 'AI', 'Anguilla', 'Anguilla', 'AIA', '660', 'no', '1+264', '.ai'),
	(9, 'AQ', 'Antarctica', 'Antarctica', 'ATA', '010', 'no', '672', '.aq'),
	(10, 'AG', 'Antigua and Barbuda', 'Antigua and Barbuda', 'ATG', '028', 'yes', '1+268', '.ag'),
	(11, 'AR', 'Argentina', 'Argentine Republic', 'ARG', '032', 'yes', '54', '.ar'),
	(12, 'AM', 'Armenia', 'Republic of Armenia', 'ARM', '051', 'yes', '374', '.am'),
	(13, 'AW', 'Aruba', 'Aruba', 'ABW', '533', 'no', '297', '.aw'),
	(14, 'AU', 'Australia', 'Commonwealth of Australia', 'AUS', '036', 'yes', '61', '.au'),
	(15, 'AT', 'Austria', 'Republic of Austria', 'AUT', '040', 'yes', '43', '.at'),
	(16, 'AZ', 'Azerbaijan', 'Republic of Azerbaijan', 'AZE', '031', 'yes', '994', '.az'),
	(17, 'BS', 'Bahamas', 'Commonwealth of The Bahamas', 'BHS', '044', 'yes', '1+242', '.bs'),
	(18, 'BH', 'Bahrain', 'Kingdom of Bahrain', 'BHR', '048', 'yes', '973', '.bh'),
	(19, 'BD', 'Bangladesh', 'People\'s Republic of Bangladesh', 'BGD', '050', 'yes', '880', '.bd'),
	(20, 'BB', 'Barbados', 'Barbados', 'BRB', '052', 'yes', '1+246', '.bb'),
	(21, 'BY', 'Belarus', 'Republic of Belarus', 'BLR', '112', 'yes', '375', '.by'),
	(22, 'BE', 'Belgium', 'Kingdom of Belgium', 'BEL', '056', 'yes', '32', '.be'),
	(23, 'BZ', 'Belize', 'Belize', 'BLZ', '084', 'yes', '501', '.bz'),
	(24, 'BJ', 'Benin', 'Republic of Benin', 'BEN', '204', 'yes', '229', '.bj'),
	(25, 'BM', 'Bermuda', 'Bermuda Islands', 'BMU', '060', 'no', '1+441', '.bm'),
	(26, 'BT', 'Bhutan', 'Kingdom of Bhutan', 'BTN', '064', 'yes', '975', '.bt'),
	(27, 'BO', 'Bolivia', 'Plurinational State of Bolivia', 'BOL', '068', 'yes', '591', '.bo'),
	(28, 'BQ', 'Bonaire, Sint Eustatius and Saba', 'Bonaire, Sint Eustatius and Saba', 'BES', '535', 'no', '599', '.bq'),
	(29, 'BA', 'Bosnia and Herzegovina', 'Bosnia and Herzegovina', 'BIH', '070', 'yes', '387', '.ba'),
	(30, 'BW', 'Botswana', 'Republic of Botswana', 'BWA', '072', 'yes', '267', '.bw'),
	(31, 'BV', 'Bouvet Island', 'Bouvet Island', 'BVT', '074', 'no', 'NONE', '.bv'),
	(32, 'BR', 'Brazil', 'Federative Republic of Brazil', 'BRA', '076', 'yes', '55', '.br'),
	(33, 'IO', 'British Indian Ocean Territory', 'British Indian Ocean Territory', 'IOT', '086', 'no', '246', '.io'),
	(34, 'BN', 'Brunei', 'Brunei Darussalam', 'BRN', '096', 'yes', '673', '.bn'),
	(35, 'BG', 'Bulgaria', 'Republic of Bulgaria', 'BGR', '100', 'yes', '359', '.bg'),
	(36, 'BF', 'Burkina Faso', 'Burkina Faso', 'BFA', '854', 'yes', '226', '.bf'),
	(37, 'BI', 'Burundi', 'Republic of Burundi', 'BDI', '108', 'yes', '257', '.bi'),
	(38, 'KH', 'Cambodia', 'Kingdom of Cambodia', 'KHM', '116', 'yes', '855', '.kh'),
	(39, 'CM', 'Cameroon', 'Republic of Cameroon', 'CMR', '120', 'yes', '237', '.cm'),
	(40, 'CA', 'Canada', 'Canada', 'CAN', '124', 'yes', '1', '.ca'),
	(41, 'CV', 'Cape Verde', 'Republic of Cape Verde', 'CPV', '132', 'yes', '238', '.cv'),
	(42, 'KY', 'Cayman Islands', 'The Cayman Islands', 'CYM', '136', 'no', '1+345', '.ky'),
	(43, 'CF', 'Central African Republic', 'Central African Republic', 'CAF', '140', 'yes', '236', '.cf'),
	(44, 'TD', 'Chad', 'Republic of Chad', 'TCD', '148', 'yes', '235', '.td'),
	(45, 'CL', 'Chile', 'Republic of Chile', 'CHL', '152', 'yes', '56', '.cl'),
	(46, 'CN', 'China', 'People\'s Republic of China', 'CHN', '156', 'yes', '86', '.cn'),
	(47, 'CX', 'Christmas Island', 'Christmas Island', 'CXR', '162', 'no', '61', '.cx'),
	(48, 'CC', 'Cocos (Keeling) Islands', 'Cocos (Keeling) Islands', 'CCK', '166', 'no', '61', '.cc'),
	(49, 'CO', 'Colombia', 'Republic of Colombia', 'COL', '170', 'yes', '57', '.co'),
	(50, 'KM', 'Comoros', 'Union of the Comoros', 'COM', '174', 'yes', '269', '.km'),
	(51, 'CG', 'Congo', 'Republic of the Congo', 'COG', '178', 'yes', '242', '.cg'),
	(52, 'CK', 'Cook Islands', 'Cook Islands', 'COK', '184', 'some', '682', '.ck'),
	(53, 'CR', 'Costa Rica', 'Republic of Costa Rica', 'CRI', '188', 'yes', '506', '.cr'),
	(54, 'CI', 'Cote d\'ivoire (Ivory Coast)', 'Republic of C&ocirc;te D\'Ivoire (Ivory Coast)', 'CIV', '384', 'yes', '225', '.ci'),
	(55, 'HR', 'Croatia', 'Republic of Croatia', 'HRV', '191', 'yes', '385', '.hr'),
	(56, 'CU', 'Cuba', 'Republic of Cuba', 'CUB', '192', 'yes', '53', '.cu'),
	(57, 'CW', 'Curacao', 'Cura&ccedil;ao', 'CUW', '531', 'no', '599', '.cw'),
	(58, 'CY', 'Cyprus', 'Republic of Cyprus', 'CYP', '196', 'yes', '357', '.cy'),
	(59, 'CZ', 'Czech Republic', 'Czech Republic', 'CZE', '203', 'yes', '420', '.cz'),
	(60, 'CD', 'Democratic Republic of the Congo', 'Democratic Republic of the Congo', 'COD', '180', 'yes', '243', '.cd'),
	(61, 'DK', 'Denmark', 'Kingdom of Denmark', 'DNK', '208', 'yes', '45', '.dk'),
	(62, 'DJ', 'Djibouti', 'Republic of Djibouti', 'DJI', '262', 'yes', '253', '.dj'),
	(63, 'DM', 'Dominica', 'Commonwealth of Dominica', 'DMA', '212', 'yes', '1+767', '.dm'),
	(64, 'DO', 'Dominican Republic', 'Dominican Republic', 'DOM', '214', 'yes', '1+809, 8', '.do'),
	(65, 'EC', 'Ecuador', 'Republic of Ecuador', 'ECU', '218', 'yes', '593', '.ec'),
	(66, 'EG', 'Egypt', 'Arab Republic of Egypt', 'EGY', '818', 'yes', '20', '.eg'),
	(67, 'SV', 'El Salvador', 'Republic of El Salvador', 'SLV', '222', 'yes', '503', '.sv'),
	(68, 'GQ', 'Equatorial Guinea', 'Republic of Equatorial Guinea', 'GNQ', '226', 'yes', '240', '.gq'),
	(69, 'ER', 'Eritrea', 'State of Eritrea', 'ERI', '232', 'yes', '291', '.er'),
	(70, 'EE', 'Estonia', 'Republic of Estonia', 'EST', '233', 'yes', '372', '.ee'),
	(71, 'ET', 'Ethiopia', 'Federal Democratic Republic of Ethiopia', 'ETH', '231', 'yes', '251', '.et'),
	(72, 'FK', 'Falkland Islands (Malvinas)', 'The Falkland Islands (Malvinas)', 'FLK', '238', 'no', '500', '.fk'),
	(73, 'FO', 'Faroe Islands', 'The Faroe Islands', 'FRO', '234', 'no', '298', '.fo'),
	(74, 'FJ', 'Fiji', 'Republic of Fiji', 'FJI', '242', 'yes', '679', '.fj'),
	(75, 'FI', 'Finland', 'Republic of Finland', 'FIN', '246', 'yes', '358', '.fi'),
	(76, 'FR', 'France', 'French Republic', 'FRA', '250', 'yes', '33', '.fr'),
	(77, 'GF', 'French Guiana', 'French Guiana', 'GUF', '254', 'no', '594', '.gf'),
	(78, 'PF', 'French Polynesia', 'French Polynesia', 'PYF', '258', 'no', '689', '.pf'),
	(79, 'TF', 'French Southern Territories', 'French Southern Territories', 'ATF', '260', 'no', NULL, '.tf'),
	(80, 'GA', 'Gabon', 'Gabonese Republic', 'GAB', '266', 'yes', '241', '.ga'),
	(81, 'GM', 'Gambia', 'Republic of The Gambia', 'GMB', '270', 'yes', '220', '.gm'),
	(82, 'GE', 'Georgia', 'Georgia', 'GEO', '268', 'yes', '995', '.ge'),
	(83, 'DE', 'Germany', 'Federal Republic of Germany', 'DEU', '276', 'yes', '49', '.de'),
	(84, 'GH', 'Ghana', 'Republic of Ghana', 'GHA', '288', 'yes', '233', '.gh'),
	(85, 'GI', 'Gibraltar', 'Gibraltar', 'GIB', '292', 'no', '350', '.gi'),
	(86, 'GR', 'Greece', 'Hellenic Republic', 'GRC', '300', 'yes', '30', '.gr'),
	(87, 'GL', 'Greenland', 'Greenland', 'GRL', '304', 'no', '299', '.gl'),
	(88, 'GD', 'Grenada', 'Grenada', 'GRD', '308', 'yes', '1+473', '.gd'),
	(89, 'GP', 'Guadaloupe', 'Guadeloupe', 'GLP', '312', 'no', '590', '.gp'),
	(90, 'GU', 'Guam', 'Guam', 'GUM', '316', 'no', '1+671', '.gu'),
	(91, 'GT', 'Guatemala', 'Republic of Guatemala', 'GTM', '320', 'yes', '502', '.gt'),
	(92, 'GG', 'Guernsey', 'Guernsey', 'GGY', '831', 'no', '44', '.gg'),
	(93, 'GN', 'Guinea', 'Republic of Guinea', 'GIN', '324', 'yes', '224', '.gn'),
	(94, 'GW', 'Guinea-Bissau', 'Republic of Guinea-Bissau', 'GNB', '624', 'yes', '245', '.gw'),
	(95, 'GY', 'Guyana', 'Co-operative Republic of Guyana', 'GUY', '328', 'yes', '592', '.gy'),
	(96, 'HT', 'Haiti', 'Republic of Haiti', 'HTI', '332', 'yes', '509', '.ht'),
	(97, 'HM', 'Heard Island and McDonald Islands', 'Heard Island and McDonald Islands', 'HMD', '334', 'no', 'NONE', '.hm'),
	(98, 'HN', 'Honduras', 'Republic of Honduras', 'HND', '340', 'yes', '504', '.hn'),
	(99, 'HK', 'Hong Kong', 'Hong Kong', 'HKG', '344', 'no', '852', '.hk'),
	(100, 'HU', 'Hungary', 'Hungary', 'HUN', '348', 'yes', '36', '.hu'),
	(101, 'IS', 'Iceland', 'Republic of Iceland', 'ISL', '352', 'yes', '354', '.is'),
	(102, 'IN', 'India', 'Republic of India', 'IND', '356', 'yes', '91', '.in'),
	(103, 'ID', 'Indonesia', 'Republic of Indonesia', 'IDN', '360', 'yes', '62', '.id'),
	(104, 'IR', 'Iran', 'Islamic Republic of Iran', 'IRN', '364', 'yes', '98', '.ir'),
	(105, 'IQ', 'Iraq', 'Republic of Iraq', 'IRQ', '368', 'yes', '964', '.iq'),
	(106, 'IE', 'Ireland', 'Ireland', 'IRL', '372', 'yes', '353', '.ie'),
	(107, 'IM', 'Isle of Man', 'Isle of Man', 'IMN', '833', 'no', '44', '.im'),
	(108, 'IL', 'Israel', 'State of Israel', 'ISR', '376', 'yes', '972', '.il'),
	(109, 'IT', 'Italy', 'Italian Republic', 'ITA', '380', 'yes', '39', '.jm'),
	(110, 'JM', 'Jamaica', 'Jamaica', 'JAM', '388', 'yes', '1+876', '.jm'),
	(111, 'JP', 'Japan', 'Japan', 'JPN', '392', 'yes', '81', '.jp'),
	(112, 'JE', 'Jersey', 'The Bailiwick of Jersey', 'JEY', '832', 'no', '44', '.je'),
	(113, 'JO', 'Jordan', 'Hashemite Kingdom of Jordan', 'JOR', '400', 'yes', '962', '.jo'),
	(114, 'KZ', 'Kazakhstan', 'Republic of Kazakhstan', 'KAZ', '398', 'yes', '7', '.kz'),
	(115, 'KE', 'Kenya', 'Republic of Kenya', 'KEN', '404', 'yes', '254', '.ke'),
	(116, 'KI', 'Kiribati', 'Republic of Kiribati', 'KIR', '296', 'yes', '686', '.ki'),
	(117, 'XK', 'Kosovo', 'Republic of Kosovo', '---', '---', 'some', '381', ''),
	(118, 'KW', 'Kuwait', 'State of Kuwait', 'KWT', '414', 'yes', '965', '.kw'),
	(119, 'KG', 'Kyrgyzstan', 'Kyrgyz Republic', 'KGZ', '417', 'yes', '996', '.kg'),
	(120, 'LA', 'Laos', 'Lao People\'s Democratic Republic', 'LAO', '418', 'yes', '856', '.la'),
	(121, 'LV', 'Latvia', 'Republic of Latvia', 'LVA', '428', 'yes', '371', '.lv'),
	(122, 'LB', 'Lebanon', 'Republic of Lebanon', 'LBN', '422', 'yes', '961', '.lb'),
	(123, 'LS', 'Lesotho', 'Kingdom of Lesotho', 'LSO', '426', 'yes', '266', '.ls'),
	(124, 'LR', 'Liberia', 'Republic of Liberia', 'LBR', '430', 'yes', '231', '.lr'),
	(125, 'LY', 'Libya', 'Libya', 'LBY', '434', 'yes', '218', '.ly'),
	(126, 'LI', 'Liechtenstein', 'Principality of Liechtenstein', 'LIE', '438', 'yes', '423', '.li'),
	(127, 'LT', 'Lithuania', 'Republic of Lithuania', 'LTU', '440', 'yes', '370', '.lt'),
	(128, 'LU', 'Luxembourg', 'Grand Duchy of Luxembourg', 'LUX', '442', 'yes', '352', '.lu'),
	(129, 'MO', 'Macao', 'The Macao Special Administrative Region', 'MAC', '446', 'no', '853', '.mo'),
	(130, 'MK', 'Macedonia', 'The Former Yugoslav Republic of Macedonia', 'MKD', '807', 'yes', '389', '.mk'),
	(131, 'MG', 'Madagascar', 'Republic of Madagascar', 'MDG', '450', 'yes', '261', '.mg'),
	(132, 'MW', 'Malawi', 'Republic of Malawi', 'MWI', '454', 'yes', '265', '.mw'),
	(133, 'MY', 'Malaysia', 'Malaysia', 'MYS', '458', 'yes', '60', '.my'),
	(134, 'MV', 'Maldives', 'Republic of Maldives', 'MDV', '462', 'yes', '960', '.mv'),
	(135, 'ML', 'Mali', 'Republic of Mali', 'MLI', '466', 'yes', '223', '.ml'),
	(136, 'MT', 'Malta', 'Republic of Malta', 'MLT', '470', 'yes', '356', '.mt'),
	(137, 'MH', 'Marshall Islands', 'Republic of the Marshall Islands', 'MHL', '584', 'yes', '692', '.mh'),
	(138, 'MQ', 'Martinique', 'Martinique', 'MTQ', '474', 'no', '596', '.mq'),
	(139, 'MR', 'Mauritania', 'Islamic Republic of Mauritania', 'MRT', '478', 'yes', '222', '.mr'),
	(140, 'MU', 'Mauritius', 'Republic of Mauritius', 'MUS', '480', 'yes', '230', '.mu'),
	(141, 'YT', 'Mayotte', 'Mayotte', 'MYT', '175', 'no', '262', '.yt'),
	(142, 'MX', 'Mexico', 'United Mexican States', 'MEX', '484', 'yes', '52', '.mx'),
	(143, 'FM', 'Micronesia', 'Federated States of Micronesia', 'FSM', '583', 'yes', '691', '.fm'),
	(144, 'MD', 'Moldava', 'Republic of Moldova', 'MDA', '498', 'yes', '373', '.md'),
	(145, 'MC', 'Monaco', 'Principality of Monaco', 'MCO', '492', 'yes', '377', '.mc'),
	(146, 'MN', 'Mongolia', 'Mongolia', 'MNG', '496', 'yes', '976', '.mn'),
	(147, 'ME', 'Montenegro', 'Montenegro', 'MNE', '499', 'yes', '382', '.me'),
	(148, 'MS', 'Montserrat', 'Montserrat', 'MSR', '500', 'no', '1+664', '.ms'),
	(149, 'MA', 'Morocco', 'Kingdom of Morocco', 'MAR', '504', 'yes', '212', '.ma'),
	(150, 'MZ', 'Mozambique', 'Republic of Mozambique', 'MOZ', '508', 'yes', '258', '.mz'),
	(151, 'MM', 'Myanmar (Burma)', 'Republic of the Union of Myanmar', 'MMR', '104', 'yes', '95', '.mm'),
	(152, 'NA', 'Namibia', 'Republic of Namibia', 'NAM', '516', 'yes', '264', '.na'),
	(153, 'NR', 'Nauru', 'Republic of Nauru', 'NRU', '520', 'yes', '674', '.nr'),
	(154, 'NP', 'Nepal', 'Federal Democratic Republic of Nepal', 'NPL', '524', 'yes', '977', '.np'),
	(155, 'NL', 'Netherlands', 'Kingdom of the Netherlands', 'NLD', '528', 'yes', '31', '.nl'),
	(156, 'NC', 'New Caledonia', 'New Caledonia', 'NCL', '540', 'no', '687', '.nc'),
	(157, 'NZ', 'New Zealand', 'New Zealand', 'NZL', '554', 'yes', '64', '.nz'),
	(158, 'NI', 'Nicaragua', 'Republic of Nicaragua', 'NIC', '558', 'yes', '505', '.ni'),
	(159, 'NE', 'Niger', 'Republic of Niger', 'NER', '562', 'yes', '227', '.ne'),
	(160, 'NG', 'Nigeria', 'Federal Republic of Nigeria', 'NGA', '566', 'yes', '234', '.ng'),
	(161, 'NU', 'Niue', 'Niue', 'NIU', '570', 'some', '683', '.nu'),
	(162, 'NF', 'Norfolk Island', 'Norfolk Island', 'NFK', '574', 'no', '672', '.nf'),
	(163, 'KP', 'North Korea', 'Democratic People\'s Republic of Korea', 'PRK', '408', 'yes', '850', '.kp'),
	(164, 'MP', 'Northern Mariana Islands', 'Northern Mariana Islands', 'MNP', '580', 'no', '1+670', '.mp'),
	(165, 'NO', 'Norway', 'Kingdom of Norway', 'NOR', '578', 'yes', '47', '.no'),
	(166, 'OM', 'Oman', 'Sultanate of Oman', 'OMN', '512', 'yes', '968', '.om'),
	(167, 'PK', 'Pakistan', 'Islamic Republic of Pakistan', 'PAK', '586', 'yes', '92', '.pk'),
	(168, 'PW', 'Palau', 'Republic of Palau', 'PLW', '585', 'yes', '680', '.pw'),
	(169, 'PS', 'Palestine', 'State of Palestine (or Occupied Palestinian Territory)', 'PSE', '275', 'some', '970', '.ps'),
	(170, 'PA', 'Panama', 'Republic of Panama', 'PAN', '591', 'yes', '507', '.pa'),
	(171, 'PG', 'Papua New Guinea', 'Independent State of Papua New Guinea', 'PNG', '598', 'yes', '675', '.pg'),
	(172, 'PY', 'Paraguay', 'Republic of Paraguay', 'PRY', '600', 'yes', '595', '.py'),
	(173, 'PE', 'Peru', 'Republic of Peru', 'PER', '604', 'yes', '51', '.pe'),
	(174, 'PH', 'Phillipines', 'Republic of the Philippines', 'PHL', '608', 'yes', '63', '.ph'),
	(175, 'PN', 'Pitcairn', 'Pitcairn', 'PCN', '612', 'no', 'NONE', '.pn'),
	(176, 'PL', 'Poland', 'Republic of Poland', 'POL', '616', 'yes', '48', '.pl'),
	(177, 'PT', 'Portugal', 'Portuguese Republic', 'PRT', '620', 'yes', '351', '.pt'),
	(178, 'PR', 'Puerto Rico', 'Commonwealth of Puerto Rico', 'PRI', '630', 'no', '1+939', '.pr'),
	(179, 'QA', 'Qatar', 'State of Qatar', 'QAT', '634', 'yes', '974', '.qa'),
	(180, 'RE', 'Reunion', 'R&eacute;union', 'REU', '638', 'no', '262', '.re'),
	(181, 'RO', 'Romania', 'Romania', 'ROU', '642', 'yes', '40', '.ro'),
	(182, 'RU', 'Russia', 'Russian Federation', 'RUS', '643', 'yes', '7', '.ru'),
	(183, 'RW', 'Rwanda', 'Republic of Rwanda', 'RWA', '646', 'yes', '250', '.rw'),
	(184, 'BL', 'Saint Barthelemy', 'Saint Barth&eacute;lemy', 'BLM', '652', 'no', '590', '.bl'),
	(185, 'SH', 'Saint Helena', 'Saint Helena, Ascension and Tristan da Cunha', 'SHN', '654', 'no', '290', '.sh'),
	(186, 'KN', 'Saint Kitts and Nevis', 'Federation of Saint Christopher and Nevis', 'KNA', '659', 'yes', '1+869', '.kn'),
	(187, 'LC', 'Saint Lucia', 'Saint Lucia', 'LCA', '662', 'yes', '1+758', '.lc'),
	(188, 'MF', 'Saint Martin', 'Saint Martin', 'MAF', '663', 'no', '590', '.mf'),
	(189, 'PM', 'Saint Pierre and Miquelon', 'Saint Pierre and Miquelon', 'SPM', '666', 'no', '508', '.pm'),
	(190, 'VC', 'Saint Vincent and the Grenadines', 'Saint Vincent and the Grenadines', 'VCT', '670', 'yes', '1+784', '.vc'),
	(191, 'WS', 'Samoa', 'Independent State of Samoa', 'WSM', '882', 'yes', '685', '.ws'),
	(192, 'SM', 'San Marino', 'Republic of San Marino', 'SMR', '674', 'yes', '378', '.sm'),
	(193, 'ST', 'Sao Tome and Principe', 'Democratic Republic of S&atilde;o Tom&eacute; and Pr&iacute;ncipe', 'STP', '678', 'yes', '239', '.st'),
	(194, 'SA', 'Saudi Arabia', 'Kingdom of Saudi Arabia', 'SAU', '682', 'yes', '966', '.sa'),
	(195, 'SN', 'Senegal', 'Republic of Senegal', 'SEN', '686', 'yes', '221', '.sn'),
	(196, 'RS', 'Serbia', 'Republic of Serbia', 'SRB', '688', 'yes', '381', '.rs'),
	(197, 'SC', 'Seychelles', 'Republic of Seychelles', 'SYC', '690', 'yes', '248', '.sc'),
	(198, 'SL', 'Sierra Leone', 'Republic of Sierra Leone', 'SLE', '694', 'yes', '232', '.sl'),
	(199, 'SG', 'Singapore', 'Republic of Singapore', 'SGP', '702', 'yes', '65', '.sg'),
	(200, 'SX', 'Sint Maarten', 'Sint Maarten', 'SXM', '534', 'no', '1+721', '.sx'),
	(201, 'SK', 'Slovakia', 'Slovak Republic', 'SVK', '703', 'yes', '421', '.sk'),
	(202, 'SI', 'Slovenia', 'Republic of Slovenia', 'SVN', '705', 'yes', '386', '.si'),
	(203, 'SB', 'Solomon Islands', 'Solomon Islands', 'SLB', '090', 'yes', '677', '.sb'),
	(204, 'SO', 'Somalia', 'Somali Republic', 'SOM', '706', 'yes', '252', '.so'),
	(205, 'ZA', 'South Africa', 'Republic of South Africa', 'ZAF', '710', 'yes', '27', '.za'),
	(206, 'GS', 'South Georgia and the South Sandwich Islands', 'South Georgia and the South Sandwich Islands', 'SGS', '239', 'no', '500', '.gs'),
	(207, 'KR', 'South Korea', 'Republic of Korea', 'KOR', '410', 'yes', '82', '.kr'),
	(208, 'SS', 'South Sudan', 'Republic of South Sudan', 'SSD', '728', 'yes', '211', '.ss'),
	(209, 'ES', 'Spain', 'Kingdom of Spain', 'ESP', '724', 'yes', '34', '.es'),
	(210, 'LK', 'Sri Lanka', 'Democratic Socialist Republic of Sri Lanka', 'LKA', '144', 'yes', '94', '.lk'),
	(211, 'SD', 'Sudan', 'Republic of the Sudan', 'SDN', '729', 'yes', '249', '.sd'),
	(212, 'SR', 'Suriname', 'Republic of Suriname', 'SUR', '740', 'yes', '597', '.sr'),
	(213, 'SJ', 'Svalbard and Jan Mayen', 'Svalbard and Jan Mayen', 'SJM', '744', 'no', '47', '.sj'),
	(214, 'SZ', 'Swaziland', 'Kingdom of Swaziland', 'SWZ', '748', 'yes', '268', '.sz'),
	(215, 'SE', 'Sweden', 'Kingdom of Sweden', 'SWE', '752', 'yes', '46', '.se'),
	(216, 'CH', 'Switzerland', 'Swiss Confederation', 'CHE', '756', 'yes', '41', '.ch'),
	(217, 'SY', 'Syria', 'Syrian Arab Republic', 'SYR', '760', 'yes', '963', '.sy'),
	(218, 'TW', 'Taiwan', 'Republic of China (Taiwan)', 'TWN', '158', 'former', '886', '.tw'),
	(219, 'TJ', 'Tajikistan', 'Republic of Tajikistan', 'TJK', '762', 'yes', '992', '.tj'),
	(220, 'TZ', 'Tanzania', 'United Republic of Tanzania', 'TZA', '834', 'yes', '255', '.tz'),
	(221, 'TH', 'Thailand', 'Kingdom of Thailand', 'THA', '764', 'yes', '66', '.th'),
	(222, 'TL', 'Timor-Leste (East Timor)', 'Democratic Republic of Timor-Leste', 'TLS', '626', 'yes', '670', '.tl'),
	(223, 'TG', 'Togo', 'Togolese Republic', 'TGO', '768', 'yes', '228', '.tg'),
	(224, 'TK', 'Tokelau', 'Tokelau', 'TKL', '772', 'no', '690', '.tk'),
	(225, 'TO', 'Tonga', 'Kingdom of Tonga', 'TON', '776', 'yes', '676', '.to'),
	(226, 'TT', 'Trinidad and Tobago', 'Republic of Trinidad and Tobago', 'TTO', '780', 'yes', '1+868', '.tt'),
	(227, 'TN', 'Tunisia', 'Republic of Tunisia', 'TUN', '788', 'yes', '216', '.tn'),
	(228, 'TR', 'Turkey', 'Republic of Turkey', 'TUR', '792', 'yes', '90', '.tr'),
	(229, 'TM', 'Turkmenistan', 'Turkmenistan', 'TKM', '795', 'yes', '993', '.tm'),
	(230, 'TC', 'Turks and Caicos Islands', 'Turks and Caicos Islands', 'TCA', '796', 'no', '1+649', '.tc'),
	(231, 'TV', 'Tuvalu', 'Tuvalu', 'TUV', '798', 'yes', '688', '.tv'),
	(232, 'UG', 'Uganda', 'Republic of Uganda', 'UGA', '800', 'yes', '256', '.ug'),
	(233, 'UA', 'Ukraine', 'Ukraine', 'UKR', '804', 'yes', '380', '.ua'),
	(234, 'AE', 'United Arab Emirates', 'United Arab Emirates', 'ARE', '784', 'yes', '971', '.ae'),
	(235, 'GB', 'United Kingdom', 'United Kingdom of Great Britain and Nothern Ireland', 'GBR', '826', 'yes', '44', '.uk'),
	(236, 'US', 'United States', 'United States of America', 'USA', '840', 'yes', '1', '.us'),
	(237, 'UM', 'United States Minor Outlying Islands', 'United States Minor Outlying Islands', 'UMI', '581', 'no', 'NONE', 'NONE'),
	(238, 'UY', 'Uruguay', 'Eastern Republic of Uruguay', 'URY', '858', 'yes', '598', '.uy'),
	(239, 'UZ', 'Uzbekistan', 'Republic of Uzbekistan', 'UZB', '860', 'yes', '998', '.uz'),
	(240, 'VU', 'Vanuatu', 'Republic of Vanuatu', 'VUT', '548', 'yes', '678', '.vu'),
	(241, 'VA', 'Vatican City', 'State of the Vatican City', 'VAT', '336', 'no', '39', '.va'),
	(242, 'VE', 'Venezuela', 'Bolivarian Republic of Venezuela', 'VEN', '862', 'yes', '58', '.ve'),
	(243, 'VN', 'Vietnam', 'Socialist Republic of Vietnam', 'VNM', '704', 'yes', '84', '.vn'),
	(244, 'VG', 'Virgin Islands, British', 'British Virgin Islands', 'VGB', '092', 'no', '1+284', '.vg'),
	(245, 'VI', 'Virgin Islands, US', 'Virgin Islands of the United States', 'VIR', '850', 'no', '1+340', '.vi'),
	(246, 'WF', 'Wallis and Futuna', 'Wallis and Futuna', 'WLF', '876', 'no', '681', '.wf'),
	(247, 'EH', 'Western Sahara', 'Western Sahara', 'ESH', '732', 'no', '212', '.eh'),
	(248, 'YE', 'Yemen', 'Republic of Yemen', 'YEM', '887', 'yes', '967', '.ye'),
	(249, 'ZM', 'Zambia', 'Republic of Zambia', 'ZMB', '894', 'yes', '260', '.zm'),
	(250, 'ZW', 'Zimbabwe', 'Republic of Zimbabwe', 'ZWE', '716', 'yes', '263', '.zw');
/*!40000 ALTER TABLE `countries` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `currencies` (
  `currency_id` int(11) NOT NULL AUTO_INCREMENT,
  `currency_iso` char(3) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `currency_name` varchar(200) COLLATE utf8_unicode_ci NOT NULL,
  PRIMARY KEY (`currency_id`)
) ENGINE=MyISAM AUTO_INCREMENT=156 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

/*!40000 ALTER TABLE `currencies` DISABLE KEYS */;
INSERT INTO `currencies` (`currency_id`, `currency_iso`, `currency_name`) VALUES
	(1, 'KRW', '(South) Korean Won'),
	(2, 'AFA', 'Afghanistan Afghani'),
	(3, 'ALL', 'Albanian Lek'),
	(4, 'DZD', 'Algerian Dinar'),
	(5, 'ADP', 'Andorran Peseta'),
	(6, 'AOK', 'Angolan Kwanza'),
	(7, 'ARS', 'Argentine Peso'),
	(8, 'AMD', 'Armenian Dram'),
	(9, 'AWG', 'Aruban Florin'),
	(10, 'AUD', 'Australian Dollar'),
	(11, 'BSD', 'Bahamian Dollar'),
	(12, 'BHD', 'Bahraini Dinar'),
	(13, 'BDT', 'Bangladeshi Taka'),
	(14, 'BBD', 'Barbados Dollar'),
	(15, 'BZD', 'Belize Dollar'),
	(16, 'BMD', 'Bermudian Dollar'),
	(17, 'BTN', 'Bhutan Ngultrum'),
	(18, 'BOB', 'Bolivian Boliviano'),
	(19, 'BWP', 'Botswanian Pula'),
	(20, 'BRL', 'Brazilian Real'),
	(21, 'GBP', 'British Pound'),
	(22, 'BND', 'Brunei Dollar'),
	(23, 'BGN', 'Bulgarian Lev'),
	(24, 'BUK', 'Burma Kyat'),
	(25, 'BIF', 'Burundi Franc'),
	(26, 'CAD', 'Canadian Dollar'),
	(27, 'CVE', 'Cape Verde Escudo'),
	(28, 'KYD', 'Cayman Islands Dollar'),
	(29, 'CLP', 'Chilean Peso'),
	(30, 'CLF', 'Chilean Unidades de Fomento'),
	(31, 'COP', 'Colombian Peso'),
	(32, 'XOF', 'Communaut? Financi?re Africaine BCEAO - Francs'),
	(33, 'XAF', 'Communaut? Financi?re Africaine BEAC, Francs'),
	(34, 'KMF', 'Comoros Franc'),
	(35, 'XPF', 'Comptoirs Fran?ais du Pacifique Francs'),
	(36, 'CRC', 'Costa Rican Colon'),
	(37, 'CUP', 'Cuban Peso'),
	(38, 'CYP', 'Cyprus Pound'),
	(39, 'CZK', 'Czech Republic Koruna'),
	(40, 'DKK', 'Danish Krone'),
	(41, 'YDD', 'Democratic Yemeni Dinar'),
	(42, 'DOP', 'Dominican Peso'),
	(43, 'XCD', 'East Caribbean Dollar'),
	(44, 'TPE', 'East Timor Escudo'),
	(45, 'ECS', 'Ecuador Sucre'),
	(46, 'EGP', 'Egyptian Pound'),
	(47, 'SVC', 'El Salvador Colon'),
	(48, 'EEK', 'Estonian Kroon (EEK)'),
	(49, 'ETB', 'Ethiopian Birr'),
	(50, 'EUR', 'Euro'),
	(51, 'FKP', 'Falkland Islands Pound'),
	(52, 'FJD', 'Fiji Dollar'),
	(53, 'GMD', 'Gambian Dalasi'),
	(54, 'GHC', 'Ghanaian Cedi'),
	(55, 'GIP', 'Gibraltar Pound'),
	(56, 'XAU', 'Gold, Ounces'),
	(57, 'GTQ', 'Guatemalan Quetzal'),
	(58, 'GNF', 'Guinea Franc'),
	(59, 'GWP', 'Guinea-Bissau Peso'),
	(60, 'GYD', 'Guyanan Dollar'),
	(61, 'HTG', 'Haitian Gourde'),
	(62, 'HNL', 'Honduran Lempira'),
	(63, 'HKD', 'Hong Kong Dollar'),
	(64, 'HUF', 'Hungarian Forint'),
	(65, 'INR', 'Indian Rupee'),
	(66, 'IDR', 'Indonesian Rupiah'),
	(67, 'XDR', 'International Monetary Fund (IMF) Special Drawing Rights'),
	(68, 'IRR', 'Iranian Rial'),
	(69, 'IQD', 'Iraqi Dinar'),
	(70, 'IEP', 'Irish Punt'),
	(71, 'ILS', 'Israeli Shekel'),
	(72, 'JMD', 'Jamaican Dollar'),
	(73, 'JPY', 'Japanese Yen'),
	(74, 'JOD', 'Jordanian Dinar'),
	(75, 'KHR', 'Kampuchean (Cambodian) Riel'),
	(76, 'KES', 'Kenyan Shilling'),
	(77, 'KWD', 'Kuwaiti Dinar'),
	(78, 'LAK', 'Lao Kip'),
	(79, 'LBP', 'Lebanese Pound'),
	(80, 'LSL', 'Lesotho Loti'),
	(81, 'LRD', 'Liberian Dollar'),
	(82, 'LYD', 'Libyan Dinar'),
	(83, 'MOP', 'Macau Pataca'),
	(84, 'MGF', 'Malagasy Franc'),
	(85, 'MWK', 'Malawi Kwacha'),
	(86, 'MYR', 'Malaysian Ringgit'),
	(87, 'MVR', 'Maldive Rufiyaa'),
	(88, 'MTL', 'Maltese Lira'),
	(89, 'MRO', 'Mauritanian Ouguiya'),
	(90, 'MUR', 'Mauritius Rupee'),
	(91, 'MXP', 'Mexican Peso'),
	(92, 'MNT', 'Mongolian Tugrik'),
	(93, 'MAD', 'Moroccan Dirham'),
	(94, 'MZM', 'Mozambique Metical'),
	(95, 'NAD', 'Namibian Dollar'),
	(96, 'NPR', 'Nepalese Rupee'),
	(97, 'ANG', 'Netherlands Antillian Guilder'),
	(98, 'YUD', 'New Yugoslavia Dinar'),
	(99, 'NZD', 'New Zealand Dollar'),
	(100, 'NIO', 'Nicaraguan Cordoba'),
	(101, 'NGN', 'Nigerian Naira'),
	(102, 'KPW', 'North Korean Won'),
	(103, 'NOK', 'Norwegian Kroner'),
	(104, 'OMR', 'Omani Rial'),
	(105, 'PKR', 'Pakistan Rupee'),
	(106, 'XPD', 'Palladium Ounces'),
	(107, 'PAB', 'Panamanian Balboa'),
	(108, 'PGK', 'Papua New Guinea Kina'),
	(109, 'PYG', 'Paraguay Guarani'),
	(110, 'PEN', 'Peruvian Nuevo Sol'),
	(111, 'PHP', 'Philippine Peso'),
	(112, 'XPT', 'Platinum, Ounces'),
	(113, 'PLN', 'Polish Zloty'),
	(114, 'QAR', 'Qatari Rial'),
	(115, 'RON', 'Romanian Leu'),
	(116, 'RUB', 'Russian Ruble'),
	(117, 'RWF', 'Rwanda Franc'),
	(118, 'WST', 'Samoan Tala'),
	(119, 'STD', 'Sao Tome and Principe Dobra'),
	(120, 'SAR', 'Saudi Arabian Riyal'),
	(121, 'SCR', 'Seychelles Rupee'),
	(122, 'SLL', 'Sierra Leone Leone'),
	(123, 'XAG', 'Silver, Ounces'),
	(124, 'SGD', 'Singapore Dollar'),
	(125, 'SKK', 'Slovak Koruna'),
	(126, 'SBD', 'Solomon Islands Dollar'),
	(127, 'SOS', 'Somali Schilling'),
	(128, 'ZAR', 'South African Rand'),
	(129, 'LKR', 'Sri Lanka Rupee'),
	(130, 'SHP', 'St. Helena Pound'),
	(131, 'SDP', 'Sudanese Pound'),
	(132, 'SRG', 'Suriname Guilder'),
	(133, 'SZL', 'Swaziland Lilangeni'),
	(134, 'SEK', 'Swedish Krona'),
	(135, 'CHF', 'Swiss Franc'),
	(136, 'SYP', 'Syrian Potmd'),
	(137, 'TWD', 'Taiwan Dollar'),
	(138, 'TZS', 'Tanzanian Shilling'),
	(139, 'THB', 'Thai Baht'),
	(140, 'TOP', 'Tongan Paanga'),
	(141, 'TTD', 'Trinidad and Tobago Dollar'),
	(142, 'TND', 'Tunisian Dinar'),
	(143, 'TRY', 'Turkish Lira'),
	(144, 'UGX', 'Uganda Shilling'),
	(145, 'AED', 'United Arab Emirates Dirham'),
	(146, 'UYU', 'Uruguayan Peso'),
	(147, 'USD', 'US Dollar'),
	(148, 'VUV', 'Vanuatu Vatu'),
	(149, 'VEF', 'Venezualan Bolivar'),
	(150, 'VND', 'Vietnamese Dong'),
	(151, 'YER', 'Yemeni Rial'),
	(152, 'CNY', 'Yuan (Chinese) Renminbi'),
	(153, 'ZRZ', 'Zaire Zaire'),
	(154, 'ZMK', 'Zambian Kwacha'),
	(155, 'ZWD', 'Zimbabwe Dollar');
/*!40000 ALTER TABLE `currencies` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `duration_types` (
  `duration_type_id` int(11) NOT NULL AUTO_INCREMENT,
  `duration_type_name` varchar(100) CHARACTER SET utf16 DEFAULT NULL,
  PRIMARY KEY (`duration_type_id`)
) ENGINE=MyISAM AUTO_INCREMENT=6 DEFAULT CHARSET=latin1;

/*!40000 ALTER TABLE `duration_types` DISABLE KEYS */;
INSERT INTO `duration_types` (`duration_type_id`, `duration_type_name`) VALUES
	(1, 'hours'),
	(2, 'days'),
	(3, 'weeks'),
	(4, 'months'),
	(5, 'years');
/*!40000 ALTER TABLE `duration_types` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `email_gateways` (
  `email_gateway_id` int(11) NOT NULL AUTO_INCREMENT,
  `email_gateway_slug` varchar(100) CHARACTER SET utf16 DEFAULT NULL,
  `email_gateway_name` varchar(100) CHARACTER SET utf16 DEFAULT NULL,
  `email_gateway_description` longtext CHARACTER SET utf16,
  PRIMARY KEY (`email_gateway_id`) USING BTREE
) ENGINE=MyISAM AUTO_INCREMENT=5 DEFAULT CHARSET=latin1;

/*!40000 ALTER TABLE `email_gateways` DISABLE KEYS */;
INSERT INTO `email_gateways` (`email_gateway_id`, `email_gateway_slug`, `email_gateway_name`, `email_gateway_description`) VALUES
	(1, 'php_mail', 'PHP Mail', NULL),
	(2, 'php_mailer', 'PHPMailer', NULL),
	(3, 'php_mailer_smtp', 'SMTP', NULL),
	(4, 'sendgrid', 'Sendgrid', NULL);
/*!40000 ALTER TABLE `email_gateways` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `email_templates` (
  `email_template_id` int(11) NOT NULL AUTO_INCREMENT,
  `item` varchar(200) CHARACTER SET utf16 DEFAULT NULL,
  `email_type` varchar(200) CHARACTER SET utf16 DEFAULT NULL,
  `email_subject` varchar(200) CHARACTER SET utf16 DEFAULT NULL,
  `email_message` longtext CHARACTER SET utf16,
  `email_template_status` int(11) NOT NULL,
  `sms_message` longtext CHARACTER SET utf16,
  `sms_template_status` int(11) NOT NULL,
  PRIMARY KEY (`email_template_id`) USING BTREE
) ENGINE=MyISAM AUTO_INCREMENT=13 DEFAULT CHARSET=latin1;

/*!40000 ALTER TABLE `email_templates` DISABLE KEYS */;
INSERT INTO `email_templates` (`email_template_id`, `item`, `email_type`, `email_subject`, `email_message`, `email_template_status`, `sms_message`, `sms_template_status`) VALUES
	(1, 'users', 'ForgotPassword', 'Forgot/Reset Password Request', '<p>Dear {firstname} {lastname},</p>\n\n\n\n<p>We received a forgot/reset password request for your account. To reset your password, please follow this link:</p>\n\n\n\n<p><a href="{reset_link}">{reset_link}</a></p>\n\n\n\n<p>If you did not authorize this request and you do not know why you received this email DO NOT CLICK on the link and contact us immediately.</p>\n\n\n\n<p>e: {company_email}</p>\n\n\n\n<p>w: {company_website}</p>\n\n\n\n<p>t: {company_phone}</p>', 1, 'Reset password request received', 0),
	(2, 'users', 'PasswordChanged', 'Password Changed', '&lt;p&gt;Dear {firstname} {lastname},&lt;/p&gt;\n\n\n\n&lt;p&gt;Your password was successfully changed.&lt;/p&gt;\n\n\n\n&lt;p&gt;If you did not authorize this request and you do not know why you received this email contact us immediately.&lt;/p&gt;\n\n\n\n&lt;p&gt;e: {company_email}&lt;/p&gt;\n\n\n\n&lt;p&gt;w: {company_website}&lt;/p&gt;\n\n\n\n&lt;p&gt;t: {company_phone}&lt;/p&gt;', 1, 'Your password changed', 0),
	(3, 'users', 'CreateAccount', 'Your User Account Created', '<p>Dear {firstname} {lastname},</p>\n\n\n\n<p>Welcome to {company_name} CRM System.</p>\n\n\n\n<p>Your account has been created successfully at {now}.</p>\n\n\n\n<p>Your login details are as follows:</p>\n\n\n\n<p>Username - {username}</p>\n\n\n\n<p>Login Page - <a href="{login_url}">{login_url}</a></p>\n\n\n\n<p>Your user profile is <a href="{user_profile}">{user_profile}</a>.</p>\n\n\n\n<p>If you don&#39;t know your password, reset by using this link:</p>\n\n\n\n<p><a href="{reset_link}">{reset_link}</a></p>\n\n\n\n<p>Thank you, we are happy to have you on board.</p>\n\n\n\n<p>Kind Regards.</p>\n\n\n\n<p>e: {company_email}</p>\n\n\n\n<p>w: {company_website}</p>\n\n\n\n<p>t: {company_phone}</p>', 1, 'Your account has been created', 0),
	(4, 'users', 'WelcomeMessage', 'Welcome Message', '<p>Dear {firstname}&nbsp;{lastname},</p>\n\n\n\n<p>Thank you for registering on the {company_name} CRM System.</p>\n\n\n\n<p>We just wanted to say welcome.</p>\n\n\n\n<p>Click here to login: <a href="{login_url}">{login_url}</a></p>\n\n\n\n<p>Please contact us if you need any help.</p>\n\n\n\n<p>Kind regards,</p>\n\n\n\n<p>e: {company_email}</p>\n\n\n\n<p>w: {company_website}</p>\n\n\n\n<p>t: {company_phone}</p>\n\n\n\n<p>(This is an automated email, so please don&#39;t reply to this email address)</p>\n\n', 1, 'Welcome to {company_name}', 0),
	(5, 'subscriptions', 'SubscriptionPaid', 'Subscription Payment Received', '<p>Dear {firstname} {lastname},</p>\r\n\n\r\n\n\r\n\n\r\n\n<p>We have received payment for subscription</p>\r\n\n\r\n\n\r\n\n\r\n\n<p>Thank you for doing business with us.</p>\r\n\n\r\n\n\r\n\n\r\n\n<p>Please click on the link below to view the invoice: <a href="{subscription_link}">{subscription_link}</a></p>\r\n\n\r\n\n\r\n\n\r\n\n<p>Kind regards,</p>\r\n\n\r\n\n\r\n\n\r\n\n<p>e: {company_email}</p>\r\n\n\r\n\n\r\n\n\r\n\n<p>w: {company_website}</p>\r\n\n\r\n\n\r\n\n\r\n\n<p>t: {company_phone}</p>\r\n\n\r\n\n', 1, '', 0),
	(6, 'subscriptions', 'SubscriptionCancelled', 'Subscription Cancelled', '<p>Dear {firstname} {lastname},</p>\r\n\n\r\n\n\r\n\n\r\n\n<p>Your subscription has been cancelled.</p>\r\n\n\r\n\n\r\n\n\r\n\n<p>View the subscription on the following link <a href="{subscription_link}">{subscription_link}</a>.</p>\r\n\n\r\n\n\r\n\n\r\n\n<p>Kind regards,</p>\r\n\n\r\n\n\r\n\n\r\n\n<p>e: {company_email}</p>\r\n\n\r\n\n\r\n\n\r\n\n<p>w: {company_website}</p>\r\n\n\r\n\n\r\n\n\r\n\n<p>t: {company_phone}</p>\r\n\n\r\n\n', 1, '', 0),
	(7, 'subscriptions', 'SubscriptionApproved', 'Subscription Approved', '<p>Dear {firstname} {lastname},</p>\r\n\n\r\n\n\r\n\n\r\n\n<p>Your subscription has been approved.</p>\r\n\n\r\n\n\r\n\n\r\n\n<p>View the subscription on the following link <a href="{subscription_link}">{subscription_link}</a>.</p>\r\n\n\r\n\n\r\n\n\r\n\n<p>Kind regards,</p>\r\n\n\r\n\n\r\n\n\r\n\n<p>e: {company_email}</p>\r\n\n\r\n\n\r\n\n\r\n\n<p>w: {company_website}</p>\r\n\n\r\n\n\r\n\n\r\n\n<p>t: {company_phone}</p>\r\n\n\r\n\n', 1, '', 0),
	(8, 'payouts', 'PayoutRequestedForAdmin', 'Payout Requested', '<p>{firstname} {lastname} ha requested a new payout</p>\r\n\r\n<p>Mode: {payout_mode}</p>\r\n\r\n<p>Address: {payout_address}</p>\r\n\r\n<p>Total: {currency_symbol}{payout_amount}</p>\r\n\r\n<p>View the payout request on the following link: <a href="{payout_link}">{payout_link}</a></p>\r\n\r\n<p>Kind regards,</p>\r\n\r\n<p>e: {company_email}</p>\r\n\r\n<p>w: {company_website}</p>\r\n\r\n<p>t: {company_phone}</p>', 1, '', 0),
	(9, 'payouts', 'PayoutSent', 'Payout Sent', '<p>Dear {firstname} {lastname} your requessted payment has been sent.</p>\r\n\n\r\n\n<p>Mode: {payout_mode}</p>\r\n\n\r\n\n<p>Address: {payout_address}</p>\r\n\n\r\n\n<p>Total: {currency_symbol}{payout_amount}</p>\r\n\n\r\n\n<p>View the payout request status on the following link: <a href="{payout_link}">{payout_link}</a></p>\r\n\n\r\n\n<p>Kind regards,</p>\r\n\n\r\n\n<p>e: {company_email}</p>\r\n\n\r\n\n<p>w: {company_website}</p>\r\n\n\r\n\n<p>t: {company_phone}</p>', 1, '', 0),
	(10, 'payouts', 'PayoutDeclined', 'Payout Declined', '<p>Dear {firstname} {lastname} your requessted payment has been declined.</p>\r\n\n\r\n\n\r\n\n<p>Mode: {payout_mode}</p>\r\n\n\r\n\n\r\n\n<p>Address: {payout_address}</p>\r\n\n\r\n\n\r\n\n<p>Total: {currency_symbol}{payout_amount}</p>\r\n\n\r\n\n\r\n\n\r\n\n<p>View the payout request status on the following link: <a href="{payout_link}">{payout_link}</a></p>\r\n\n\r\n\n\r\n\n\r\n\n<p>Kind regards,</p>\r\n\n\r\n\n\r\n\n\r\n\n<p>e: {company_email}</p>\r\n\n\r\n\n\r\n\n\r\n\n<p>w: {company_website}</p>\r\n\n\r\n\n\r\n\n\r\n\n<p>t: {company_phone}</p>\r\n\n\r\n\n', 1, '', 0),
	(11, 'payouts', 'PayoutCancelledForAdmin', 'Payout Cancelled', '<p>{firstname} {lastname} has cancelled requested payout {payout_name}</p>\r\n\n\r\n\n\r\n\n<p>Mode: {payout_mode}</p>\r\n\n\r\n\n\r\n\n<p>Address: {payout_address}</p>\r\n\n\r\n\n\r\n\n<p>Total: {currency_symbol}{payout_amount}</p>\r\n\n\r\n\n\r\n\n\r\n\n<p>View the payout request status on the following link: <a href="{payout_link}">{payout_link}</a></p>\r\n\n\r\n\n\r\n\n\r\n\n<p>Kind regards,</p>\r\n\n\r\n\n\r\n\n\r\n\n<p>e: {company_email}</p>\r\n\n\r\n\n\r\n\n\r\n\n<p>w: {company_website}</p>\r\n\n\r\n\n\r\n\n\r\n\n<p>t: {company_phone}</p>\r\n\n\r\n\n', 1, '', 0),
	(12, 'affiliates', 'InviteFriend', 'Unlock Exclusive Benefits with Our Referral Program!', '<p>Dear Friend,</p>\r\n<p>I hope this email finds you well! As a valued member of our community, we wanted to share an exciting opportunity for you to enhance your experience and earn exclusive rewards.</p>\r\n<p>We\'ve just launched our referral program, and we\'d love for you to be a part of it. Share the love by referring your friends, family, or colleagues to <span class="float-end text-danger">{company_name}</span>, and both you and your referral can enjoy fantastic perks.</p>\r\n<p>Here\'s how it works:</p>\r\n<ol>\r\n<li>\r\n<p><strong>Share Your Unique Referral Link:</strong></p>\r\n<ul>\r\n<li>Click {referral_link} to get started. This personalized link ensures we can track your referrals and reward you accordingly.</li>\r\n</ul>\r\n</li>\r\n<li>\r\n<p><strong>Your Friend Makes a Purchase:</strong></p>\r\n<ul>\r\n<li>When your friend uses your referral link to make their first purchase, they\'ll receive [Specify Discount or Benefit], and you\'ll earn [Specify Your Reward].</li>\r\n</ul>\r\n</li>\r\n<li>\r\n<p><strong>Unlock Exclusive Rewards:</strong></p>\r\n<ul>\r\n<li>The more friends you refer, the more rewards you unlock! From discounts and freebies to VIP access, there\'s something special for everyone.</li>\r\n</ul>\r\n</li>\r\n<li>\r\n<p><strong>Spread the Word:</strong></p>\r\n<ul>\r\n<li>Share your referral link via email, social media, or even in person. The more you share, the greater the benefits!</li>\r\n</ul>\r\n</li>\r\n</ol>\r\n<p>Don\'t miss out on this chance to make your <span class="float-end text-danger">{company_name}</span> experience even more rewarding. Click {referral_link} to start referring now!</p>\r\n<p>Thank you for being a part of our community. We appreciate your support and look forward to sharing exciting moments with you and your friends.</p>\r\n<p>Best regards,</p>\r\n<p><span class="float-end text-danger">{company_name}</span></p>\r\n<p><span class="float-end text-danger">{company_phone}</span></p>\r\n<p><span class="float-end text-danger">{company_email}</span></p>\r\n<p><span class="float-end text-danger">{company_website}</span></p>', 1, ' ', 0);
/*!40000 ALTER TABLE `email_templates` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `esewa_settings` (
  `esewa_id` int(11) NOT NULL AUTO_INCREMENT,
  `esewa_status` int(11) DEFAULT NULL,
  `esewa_url` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `esewa_verification_url` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `esewa_merchant_code` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  PRIMARY KEY (`esewa_id`) USING BTREE
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=latin1 ROW_FORMAT=DYNAMIC;

/*!40000 ALTER TABLE `esewa_settings` DISABLE KEYS */;
INSERT INTO `esewa_settings` (`esewa_id`, `esewa_status`, `esewa_url`, `esewa_verification_url`, `esewa_merchant_code`) VALUES
	(1, 1, 'https://esewa.com.np/epay/main', 'https://esewa.com.np/epay/transrec', NULL),
	(2, 0, 'https://uat.esewa.com.np/epay/main', 'https://uat.esewa.com.np/epay/transrec', NULL);
/*!40000 ALTER TABLE `esewa_settings` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `faqs` (
  `faq_id` int(11) NOT NULL AUTO_INCREMENT,
  `faq_added_by` int(11) DEFAULT NULL,
  `faq_title` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `faq_slug` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `faq_content` text CHARACTER SET utf16,
  `faq_status_id` int(11) NOT NULL DEFAULT '0',
  `faq_date_added` datetime DEFAULT NULL,
  PRIMARY KEY (`faq_id`) USING BTREE
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

/*!40000 ALTER TABLE `faqs` DISABLE KEYS */;
/*!40000 ALTER TABLE `faqs` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `favs` (
  `fav_id` int(11) NOT NULL AUTO_INCREMENT,
  `chat_assistant_id` int(11) DEFAULT NULL,
  `fav_added_by` int(11) DEFAULT NULL,
  `fav_date_added` datetime DEFAULT NULL,
  PRIMARY KEY (`fav_id`) USING BTREE
) ENGINE=MyISAM DEFAULT CHARSET=latin1 ROW_FORMAT=DYNAMIC;

/*!40000 ALTER TABLE `favs` DISABLE KEYS */;
/*!40000 ALTER TABLE `favs` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `finetunes` (
  `finetune_id` int(11) NOT NULL AUTO_INCREMENT,
  `finetune_file` longtext CHARACTER SET utf16,
  `finetune_file_size` float DEFAULT NULL,
  `finetune_file_output_id` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `finetune_file_output_filename` longtext CHARACTER SET utf16,
  `finetune_file_output_size` float DEFAULT NULL,
  `finetune_file_output_status` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `finetune_job_output_id` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `finetune_job_output_status` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `finetune_job_output_model` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `finetune_job_output_tokens` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `finetune_job_output_model_used` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `finetune_file_added_by` int(11) DEFAULT NULL,
  `finetune_file_date_added` datetime DEFAULT NULL,
  PRIMARY KEY (`finetune_id`) USING BTREE
) ENGINE=MyISAM DEFAULT CHARSET=latin1 ROW_FORMAT=DYNAMIC;

/*!40000 ALTER TABLE `finetunes` DISABLE KEYS */;
/*!40000 ALTER TABLE `finetunes` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `flutterwave_settings` (
  `flutterwave_id` int(11) NOT NULL AUTO_INCREMENT,
  `flutterwave_status` int(11) NOT NULL,
  `flutterwave_public_key` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `flutterwave_secret_key` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `flutterwave_encryption_key` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  PRIMARY KEY (`flutterwave_id`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=latin1 ROW_FORMAT=DYNAMIC;

/*!40000 ALTER TABLE `flutterwave_settings` DISABLE KEYS */;
INSERT INTO `flutterwave_settings` (`flutterwave_id`, `flutterwave_status`, `flutterwave_public_key`, `flutterwave_secret_key`, `flutterwave_encryption_key`) VALUES
	(1, 1, NULL, NULL, NULL),
	(2, 0, NULL, NULL, NULL);
/*!40000 ALTER TABLE `flutterwave_settings` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `google_recaptcha_settings` (
  `google_recaptcha_id` int(11) NOT NULL AUTO_INCREMENT,
  `google_recaptcha_status` int(11) DEFAULT NULL,
  `google_recaptcha_site_key` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `google_recaptcha_secret_key` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  PRIMARY KEY (`google_recaptcha_id`) USING BTREE
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=latin1 ROW_FORMAT=DYNAMIC;

/*!40000 ALTER TABLE `google_recaptcha_settings` DISABLE KEYS */;
INSERT INTO `google_recaptcha_settings` (`google_recaptcha_id`, `google_recaptcha_status`, `google_recaptcha_site_key`, `google_recaptcha_secret_key`) VALUES
	(1, 1, NULL, NULL);
/*!40000 ALTER TABLE `google_recaptcha_settings` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `homepage_applications` (
  `homepage_applications_id` int(11) NOT NULL AUTO_INCREMENT,
  `homepage_applications_heading` longtext CHARACTER SET utf16,
  `homepage_applications_title` longtext CHARACTER SET utf16,
  `homepage_applications_image` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `homepage_applications_background_type` varchar(50) CHARACTER SET utf16 DEFAULT NULL,
  `homepage_applications_background` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  PRIMARY KEY (`homepage_applications_id`) USING BTREE
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=latin1 ROW_FORMAT=DYNAMIC;

/*!40000 ALTER TABLE `homepage_applications` DISABLE KEYS */;
INSERT INTO `homepage_applications` (`homepage_applications_id`, `homepage_applications_heading`, `homepage_applications_title`, `homepage_applications_image`, `homepage_applications_background_type`, `homepage_applications_background`) VALUES
	(1, 'EmbedAI Applications', 'Integrate your chat code snippet with', 'voiceover.png', 'gradient', 'linear-gradient(to bottom, #7979f2 -90%, #f6ffff 32%)');
/*!40000 ALTER TABLE `homepage_applications` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `homepage_applications_items` (
  `homepage_applications_item_id` int(11) NOT NULL AUTO_INCREMENT,
  `homepage_applications_item_icon` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `homepage_applications_item` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `homepage_applications_item_order` int(11) DEFAULT NULL,
  PRIMARY KEY (`homepage_applications_item_id`) USING BTREE
) ENGINE=MyISAM AUTO_INCREMENT=14 DEFAULT CHARSET=latin1 ROW_FORMAT=DYNAMIC;

/*!40000 ALTER TABLE `homepage_applications_items` DISABLE KEYS */;
INSERT INTO `homepage_applications_items` (`homepage_applications_item_id`, `homepage_applications_item_icon`, `homepage_applications_item`, `homepage_applications_item_order`) VALUES
	(1, '<i class="fa-brands fa-wordpress fa-2xl"></i>', 'Wordpress', NULL),
	(2, '<i class="fa-brands fa-weebly fa-2xl"></i>', 'Weebly', NULL),
	(3, '<i class="fa-brands fa-godaddy fa-2xl"></i>', 'GoDaddy', NULL),
	(4, '<i class="fa-brands fa-drupal fa-2xl"></i>', 'Drupal', NULL),
	(5, '<i class="fa-brands fa-shopify fa-2xl"></i>', 'Shopify', NULL),
	(6, '<i class="fa-brands fa-squarespace fa-2xl"></i>', 'Squarespace', NULL),
	(7, '<i class="fa-brands fa-wix fa-2xl"></i>', 'Wix', NULL),
	(8, '<i class="fa-brands fa-zyro fa-2xl"></i>', 'Zyro', NULL),
	(9, '<i class="fa-brands fa-blogger fa-2xl"></i>', 'Blogger', NULL),
	(10, '<i class="fa-brands fa-hubspot fa-2xl"></i>', 'HubSpot', NULL),
	(11, '<i class="fa-brands fa-webflow fa-2xl"></i>', 'Webflow', NULL),
	(12, '<i class="fa-brands fa-joomla fa-2xl"></i>', 'Joomla', NULL),
	(13, '<i class="fa-brands fa-html fa-2xl"></i>', 'HTML', NULL);
/*!40000 ALTER TABLE `homepage_applications_items` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `homepage_blog` (
  `homepage_blog_id` int(11) NOT NULL AUTO_INCREMENT,
  `homepage_blog_heading` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `homepage_blog_title` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `homepage_blog_background_type` varchar(50) CHARACTER SET utf16 DEFAULT NULL,
  `homepage_blog_background` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  PRIMARY KEY (`homepage_blog_id`) USING BTREE
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=latin1 ROW_FORMAT=DYNAMIC;

/*!40000 ALTER TABLE `homepage_blog` DISABLE KEYS */;
INSERT INTO `homepage_blog` (`homepage_blog_id`, `homepage_blog_heading`, `homepage_blog_title`, `homepage_blog_background_type`, `homepage_blog_background`) VALUES
	(1, 'Blog', 'Our latest news and articles', 'gradient', 'linear-gradient(to bottom, #7979f2 -90%, #f6ffff 32%)');
/*!40000 ALTER TABLE `homepage_blog` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `homepage_choose` (
  `homepage_choose_id` int(11) NOT NULL AUTO_INCREMENT,
  `homepage_choose_heading` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `homepage_choose_title` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `homepage_choose_top_image` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `homepage_choose_bottom_image` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `homepage_choose_background_type` varchar(50) CHARACTER SET utf16 DEFAULT NULL,
  `homepage_choose_background` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  PRIMARY KEY (`homepage_choose_id`) USING BTREE
) ENGINE=MyISAM AUTO_INCREMENT=16 DEFAULT CHARSET=latin1 ROW_FORMAT=DYNAMIC;

/*!40000 ALTER TABLE `homepage_choose` DISABLE KEYS */;
INSERT INTO `homepage_choose` (`homepage_choose_id`, `homepage_choose_heading`, `homepage_choose_title`, `homepage_choose_top_image`, `homepage_choose_bottom_image`, `homepage_choose_background_type`, `homepage_choose_background`) VALUES
	(1, 'Enhance the growth of your business', 'Refine for business success and efficiency', 'homepage_optimize_image_1_4.jpg', 'homepage_optimize_image_2_0.jpg', 'gradient', 'linear-gradient(to bottom, #7979f2 -90%, #f6ffff 32%)');
/*!40000 ALTER TABLE `homepage_choose` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `homepage_choose_items` (
  `homepage_choose_item_id` int(11) NOT NULL AUTO_INCREMENT,
  `homepage_choose_item` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `homepage_choose_item_order` int(11) DEFAULT NULL,
  PRIMARY KEY (`homepage_choose_item_id`) USING BTREE
) ENGINE=MyISAM AUTO_INCREMENT=7 DEFAULT CHARSET=latin1 ROW_FORMAT=DYNAMIC;

/*!40000 ALTER TABLE `homepage_choose_items` DISABLE KEYS */;
INSERT INTO `homepage_choose_items` (`homepage_choose_item_id`, `homepage_choose_item`, `homepage_choose_item_order`) VALUES
	(1, 'Faster Response Rate', NULL),
	(2, 'Well Trained Models', NULL),
	(3, 'Increased Conversion Rates', NULL),
	(4, 'Better Customer Experience', NULL),
	(5, 'Better Customer Retention', NULL),
	(6, 'Dedicated Chatbot Assistants', NULL);
/*!40000 ALTER TABLE `homepage_choose_items` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `homepage_faqs` (
  `homepage_faqs_id` int(11) NOT NULL AUTO_INCREMENT,
  `homepage_faqs_heading` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `homepage_faqs_title` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `homepage_faqs_background_type` varchar(50) CHARACTER SET utf16 DEFAULT NULL,
  `homepage_faqs_background` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  PRIMARY KEY (`homepage_faqs_id`) USING BTREE
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=latin1 ROW_FORMAT=DYNAMIC;

/*!40000 ALTER TABLE `homepage_faqs` DISABLE KEYS */;
INSERT INTO `homepage_faqs` (`homepage_faqs_id`, `homepage_faqs_heading`, `homepage_faqs_title`, `homepage_faqs_background_type`, `homepage_faqs_background`) VALUES
	(1, 'FAQs', 'Frequently asked questions & answers', 'gradient', 'linear-gradient(to bottom, #7979f2 -90%, #f6ffff 32%)');
/*!40000 ALTER TABLE `homepage_faqs` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `homepage_features` (
  `homepage_features_id` int(11) NOT NULL AUTO_INCREMENT,
  `homepage_features_heading` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `homepage_features_title` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `homepage_features_image` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `homepage_features_background_type` varchar(50) CHARACTER SET utf16 DEFAULT NULL,
  `homepage_features_background` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  PRIMARY KEY (`homepage_features_id`) USING BTREE
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=latin1 ROW_FORMAT=DYNAMIC;

/*!40000 ALTER TABLE `homepage_features` DISABLE KEYS */;
INSERT INTO `homepage_features` (`homepage_features_id`, `homepage_features_heading`, `homepage_features_title`, `homepage_features_image`, `homepage_features_background_type`, `homepage_features_background`) VALUES
	(1, 'EmbedAI Features', 'Future empowered by the strength of AI', 'homepage_features_image_1.jpg', 'gradient', 'linear-gradient(to bottom, #7979f2 -90%, #f6ffff 32%)');
/*!40000 ALTER TABLE `homepage_features` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `homepage_features_items` (
  `homepage_features_item_id` int(11) NOT NULL AUTO_INCREMENT,
  `homepage_features_item_icon` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `homepage_features_item` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `homepage_features_item_description` longtext CHARACTER SET utf16,
  `homepage_features_item_order` int(11) DEFAULT NULL,
  PRIMARY KEY (`homepage_features_item_id`) USING BTREE
) ENGINE=MyISAM AUTO_INCREMENT=9 DEFAULT CHARSET=latin1 ROW_FORMAT=DYNAMIC;

/*!40000 ALTER TABLE `homepage_features_items` DISABLE KEYS */;
INSERT INTO `homepage_features_items` (`homepage_features_item_id`, `homepage_features_item_icon`, `homepage_features_item`, `homepage_features_item_description`, `homepage_features_item_order`) VALUES
	(1, '<i class="fa-solid fa-home fa-2x"></i>', 'Scalable Chatbot', 'Connect with your customers anywhere, anytime with Chat development service.', NULL),
	(2, '<i class="fa-solid fa-home fa-2x"></i>', 'Al Power', 'Developer toolset with inline scripting for API calls, complex integrations.', NULL),
	(3, '<i class="fa-solid fa-home fa-2x"></i>', 'Multi Language', 'Scale your business across multiple languages & time zones.', NULL),
	(4, '<i class="fa-solid fa-home fa-2x"></i>', 'Expert Team', 'Face-to-face discussion. Get a consultant from the best expert team.', NULL);
/*!40000 ALTER TABLE `homepage_features_items` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `homepage_footer_block` (
  `homepage_footer_block_id` int(11) NOT NULL AUTO_INCREMENT,
  `homepage_footer_block_heading` longtext CHARACTER SET utf16,
  `homepage_footer_block_title` longtext CHARACTER SET utf16,
  `homepage_footer_block_link` longtext CHARACTER SET utf16,
  `homepage_footer_block_link_description` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `homepage_footer_block_background_type` varchar(50) CHARACTER SET utf16 DEFAULT NULL,
  `homepage_footer_block_background` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  PRIMARY KEY (`homepage_footer_block_id`) USING BTREE
) ENGINE=MyISAM AUTO_INCREMENT=17 DEFAULT CHARSET=latin1 ROW_FORMAT=DYNAMIC;

/*!40000 ALTER TABLE `homepage_footer_block` DISABLE KEYS */;
INSERT INTO `homepage_footer_block` (`homepage_footer_block_id`, `homepage_footer_block_heading`, `homepage_footer_block_title`, `homepage_footer_block_link`, `homepage_footer_block_link_description`, `homepage_footer_block_background_type`, `homepage_footer_block_background`) VALUES
	(1, 'Let\'s make something great together', 'Discover EmbedAI', 'https://mybizcms.com/demos/embedai/#pricing', 'Start your free trial', 'image', 'footer-block_0.jpg');
/*!40000 ALTER TABLE `homepage_footer_block` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `homepage_footer_block_features` (
  `homepage_footer_block_feature_id` int(11) NOT NULL AUTO_INCREMENT,
  `homepage_footer_block_feature_description` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `homepage_footer_block_feature_order` int(11) DEFAULT NULL,
  PRIMARY KEY (`homepage_footer_block_feature_id`) USING BTREE
) ENGINE=MyISAM AUTO_INCREMENT=6 DEFAULT CHARSET=latin1 ROW_FORMAT=DYNAMIC;

/*!40000 ALTER TABLE `homepage_footer_block_features` DISABLE KEYS */;
INSERT INTO `homepage_footer_block_features` (`homepage_footer_block_feature_id`, `homepage_footer_block_feature_description`, `homepage_footer_block_feature_order`) VALUES
	(1, 'No credit card required', NULL),
	(2, 'Cancel anytime', NULL),
	(3, 'Unlimited chatbots', NULL);
/*!40000 ALTER TABLE `homepage_footer_block_features` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `homepage_howitworks` (
  `homepage_howitworks_id` int(11) NOT NULL AUTO_INCREMENT,
  `homepage_howitworks_heading` longtext CHARACTER SET utf16,
  `homepage_howitworks_title` longtext CHARACTER SET utf16,
  `homepage_howitworks_description` longtext CHARACTER SET utf16,
  `homepage_howitworks_background_type` varchar(50) CHARACTER SET utf16 DEFAULT NULL,
  `homepage_howitworks_background` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  PRIMARY KEY (`homepage_howitworks_id`) USING BTREE
) ENGINE=MyISAM AUTO_INCREMENT=16 DEFAULT CHARSET=latin1 ROW_FORMAT=DYNAMIC;

/*!40000 ALTER TABLE `homepage_howitworks` DISABLE KEYS */;
INSERT INTO `homepage_howitworks` (`homepage_howitworks_id`, `homepage_howitworks_heading`, `homepage_howitworks_title`, `homepage_howitworks_description`, `homepage_howitworks_background_type`, `homepage_howitworks_background`) VALUES
	(1, 'How it works', 'Simple steps before using EmbedAI chatbot', 'To use our AI powered chat bots, you only need to follow these simple &amp; straight foward steps.', 'gradient', 'linear-gradient(to bottom, #7979f2 -90%, #f6ffff 32%)');
/*!40000 ALTER TABLE `homepage_howitworks` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `homepage_howitworks_steps` (
  `homepage_howitworks_step_id` int(11) NOT NULL AUTO_INCREMENT,
  `homepage_howitworks_step_icon` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `homepage_howitworks_step_title` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `homepage_howitworks_step_description` longtext CHARACTER SET utf16,
  `homepage_howitworks_step_order` int(11) DEFAULT NULL,
  PRIMARY KEY (`homepage_howitworks_step_id`) USING BTREE
) ENGINE=MyISAM AUTO_INCREMENT=4 DEFAULT CHARSET=latin1 ROW_FORMAT=DYNAMIC;

/*!40000 ALTER TABLE `homepage_howitworks_steps` DISABLE KEYS */;
INSERT INTO `homepage_howitworks_steps` (`homepage_howitworks_step_id`, `homepage_howitworks_step_icon`, `homepage_howitworks_step_title`, `homepage_howitworks_step_description`, `homepage_howitworks_step_order`) VALUES
	(1, '<i class="fa-solid fa-gear"></i>', 'Configure your chatbot', 'Customize chatbot settings for your needs in the user-friendly configuration panel.', NULL),
	(2, '<i class="fa-solid fa-copy fa-5x"></i>', 'Copy your widget code', 'Copy widget code for seamless integration, ensuring smooth implementation of chatbot features.', NULL),
	(3, '<i class="fa-solid fa-code fa-5x"></i>', 'Embed on your website', 'Paste the code into your website to instantly activate the chatbot functionality.', NULL);
/*!40000 ALTER TABLE `homepage_howitworks_steps` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `homepage_intro` (
  `homepage_intro_id` int(11) NOT NULL AUTO_INCREMENT,
  `homepage_intro_title` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `homepage_intro_description` longtext CHARACTER SET utf16,
  `homepage_intro_sub_description` longtext CHARACTER SET utf16,
  `homepage_intro_image` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `homepage_intro_image_text` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `homepage_intro_background_type` varchar(50) CHARACTER SET utf16 DEFAULT NULL,
  `homepage_intro_background` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  PRIMARY KEY (`homepage_intro_id`) USING BTREE
) ENGINE=MyISAM AUTO_INCREMENT=10 DEFAULT CHARSET=latin1 ROW_FORMAT=DYNAMIC;

/*!40000 ALTER TABLE `homepage_intro` DISABLE KEYS */;
INSERT INTO `homepage_intro` (`homepage_intro_id`, `homepage_intro_title`, `homepage_intro_description`, `homepage_intro_sub_description`, `homepage_intro_image`, `homepage_intro_image_text`, `homepage_intro_background_type`, `homepage_intro_background`) VALUES
	(1, '<h1>Improve your customer experience with <span class="heading">AI chatbot</span></h1>', 'AI enhances communication with proficiency in multiple languages and well-trained models.', 'Available <span class="number">100+ </span>Languages and <span class="number">60+ </span>Chat bots', 'homepage_intro_image_1.jpg', 'Hi, Talk to me!', 'gradient', 'linear-gradient(to bottom, #7979f2 -60%, #f6ffff 38%)');
/*!40000 ALTER TABLE `homepage_intro` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `homepage_intro_items` (
  `homepage_intro_item_id` int(11) NOT NULL AUTO_INCREMENT,
  `homepage_intro_item` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `homepage_intro_item_value` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `homepage_intro_item_order` int(11) DEFAULT NULL,
  PRIMARY KEY (`homepage_intro_item_id`) USING BTREE
) ENGINE=MyISAM AUTO_INCREMENT=16 DEFAULT CHARSET=latin1 ROW_FORMAT=DYNAMIC;

/*!40000 ALTER TABLE `homepage_intro_items` DISABLE KEYS */;
INSERT INTO `homepage_intro_items` (`homepage_intro_item_id`, `homepage_intro_item`, `homepage_intro_item_value`, `homepage_intro_item_order`) VALUES
	(1, 'Customers', '200 Million', NULL),
	(2, 'Reviews', '2k +', NULL),
	(3, 'Currencies', '250', NULL);
/*!40000 ALTER TABLE `homepage_intro_items` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `homepage_pricing` (
  `homepage_pricing_id` int(11) NOT NULL AUTO_INCREMENT,
  `homepage_pricing_heading` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `homepage_pricing_title` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `homepage_pricing_background_type` varchar(50) CHARACTER SET utf16 DEFAULT NULL,
  `homepage_pricing_background` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  PRIMARY KEY (`homepage_pricing_id`) USING BTREE
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=latin1 ROW_FORMAT=DYNAMIC;

/*!40000 ALTER TABLE `homepage_pricing` DISABLE KEYS */;
INSERT INTO `homepage_pricing` (`homepage_pricing_id`, `homepage_pricing_heading`, `homepage_pricing_title`, `homepage_pricing_background_type`, `homepage_pricing_background`) VALUES
	(1, 'Pricing plans', 'Choose your package', 'gradient', 'linear-gradient(to bottom, #7979f2 -90%, #f6ffff 32%)');
/*!40000 ALTER TABLE `homepage_pricing` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `homepage_sections` (
  `homepage_section_id` int(11) NOT NULL AUTO_INCREMENT,
  `homepage_section` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `homepage_section_status_id` int(11) DEFAULT NULL,
  `homepage_section_show_in_header` int(11) DEFAULT NULL,
  `homepage_section_order` int(11) DEFAULT NULL,
  PRIMARY KEY (`homepage_section_id`) USING BTREE
) ENGINE=MyISAM AUTO_INCREMENT=9 DEFAULT CHARSET=latin1 ROW_FORMAT=DYNAMIC;

/*!40000 ALTER TABLE `homepage_sections` DISABLE KEYS */;
INSERT INTO `homepage_sections` (`homepage_section_id`, `homepage_section`, `homepage_section_status_id`, `homepage_section_show_in_header`, `homepage_section_order`) VALUES
	(1, 'howitworks', 1, 0, 2),
	(2, 'optimize', 1, 0, 4),
	(3, 'applications', 1, 0, 5),
	(4, 'pricing', 1, 1, 6),
	(5, 'trust', 1, 0, 3),
	(6, 'features', 1, 0, 1),
	(7, 'blog', 1, 0, 7),
	(8, 'faqs', 1, 0, 8);
/*!40000 ALTER TABLE `homepage_sections` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `homepage_trust` (
  `homepage_trust_id` int(11) NOT NULL AUTO_INCREMENT,
  `homepage_trust_heading` longtext CHARACTER SET utf16,
  `homepage_trust_title` longtext CHARACTER SET utf16,
  `homepage_trust_description` longtext CHARACTER SET utf16,
  `homepage_trust_image` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `homepage_trust_background_type` varchar(50) CHARACTER SET utf16 DEFAULT NULL,
  `homepage_trust_background` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  PRIMARY KEY (`homepage_trust_id`) USING BTREE
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=latin1 ROW_FORMAT=DYNAMIC;

/*!40000 ALTER TABLE `homepage_trust` DISABLE KEYS */;
INSERT INTO `homepage_trust` (`homepage_trust_id`, `homepage_trust_heading`, `homepage_trust_title`, `homepage_trust_description`, `homepage_trust_image`, `homepage_trust_background_type`, `homepage_trust_background`) VALUES
	(1, 'Trusted Chatbot Solution', 'Many companies trust EmbedAI', 'We will help you to professionally answer your business chats, texts, and social messages.', 'homepage_trust_1.png', 'gradient', 'linear-gradient(to bottom, #7979f2 -90%, #f6ffff 32%)');
/*!40000 ALTER TABLE `homepage_trust` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `homepage_trust_items` (
  `homepage_trust_item_id` int(11) NOT NULL AUTO_INCREMENT,
  `homepage_trust_item` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `homepage_trust_item_order` int(11) DEFAULT NULL,
  PRIMARY KEY (`homepage_trust_item_id`) USING BTREE
) ENGINE=MyISAM AUTO_INCREMENT=5 DEFAULT CHARSET=latin1 ROW_FORMAT=DYNAMIC;

/*!40000 ALTER TABLE `homepage_trust_items` DISABLE KEYS */;
INSERT INTO `homepage_trust_items` (`homepage_trust_item_id`, `homepage_trust_item`, `homepage_trust_item_order`) VALUES
	(1, 'Faster Response Rate', NULL),
	(2, 'AI-enabled Chat Bots', NULL),
	(3, 'Increased Conversion Rates', NULL);
/*!40000 ALTER TABLE `homepage_trust_items` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `hyperpay_settings` (
  `hyperpay_id` int(11) NOT NULL AUTO_INCREMENT,
  `hyperpay_status` int(11) DEFAULT NULL,
  `hyperpay_url` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `hyperpay_access_token` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `hyperpay_entity_id` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `hyperpay_brands` longtext CHARACTER SET utf16,
  PRIMARY KEY (`hyperpay_id`) USING BTREE
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=latin1 ROW_FORMAT=DYNAMIC;

/*!40000 ALTER TABLE `hyperpay_settings` DISABLE KEYS */;
INSERT INTO `hyperpay_settings` (`hyperpay_id`, `hyperpay_status`, `hyperpay_url`, `hyperpay_access_token`, `hyperpay_entity_id`, `hyperpay_brands`) VALUES
	(1, 1, 'https://eu-prod.oppwa.com/', NULL, NULL, NULL),
	(2, 0, 'https://eu-test.oppwa.com/', NULL, NULL, NULL);
/*!40000 ALTER TABLE `hyperpay_settings` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `instamojo_settings` (
  `instamojo_id` int(11) NOT NULL AUTO_INCREMENT,
  `instamojo_status` int(11) DEFAULT NULL,
  `instamojo_url` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `instamojo_api_key` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `instamojo_auth_token` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  PRIMARY KEY (`instamojo_id`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=latin1 ROW_FORMAT=DYNAMIC;

/*!40000 ALTER TABLE `instamojo_settings` DISABLE KEYS */;
INSERT INTO `instamojo_settings` (`instamojo_id`, `instamojo_status`, `instamojo_url`, `instamojo_api_key`, `instamojo_auth_token`) VALUES
	(1, 1, 'https://instamojo.com/api/1.1/', NULL, NULL),
	(2, 0, 'https://test.instamojo.com/api/1.1/', NULL, NULL);
/*!40000 ALTER TABLE `instamojo_settings` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `item_settings` (
  `item_id` int(11) NOT NULL AUTO_INCREMENT,
  `item_name` varchar(100) CHARACTER SET utf16 DEFAULT NULL,
  `item_colour` varchar(100) CHARACTER SET utf16 DEFAULT NULL,
  `item_hex_colour` varchar(100) CHARACTER SET utf16 DEFAULT NULL,
  `item_rgb_colour` varchar(100) CHARACTER SET utf16 DEFAULT NULL,
  PRIMARY KEY (`item_id`) USING BTREE
) ENGINE=MyISAM AUTO_INCREMENT=8 DEFAULT CHARSET=latin1 ROW_FORMAT=DYNAMIC;

/*!40000 ALTER TABLE `item_settings` DISABLE KEYS */;
INSERT INTO `item_settings` (`item_id`, `item_name`, `item_colour`, `item_hex_colour`, `item_rgb_colour`) VALUES
	(1, 'subscriptions', NULL, '#4b0082', '75,0,130'),
	(2, 'users', NULL, '#fd7e14', '253,126,20'),
	(3, 'chats', NULL, '#f70018', '247,0,24'),
	(4, 'words', NULL, '#a36681', '163,102,129'),
	(5, 'visits', NULL, '#6c757d', '108,117,125'),
	(6, 'subscriptions_income', NULL, '#7b308d', '123,48,141'),
	(7, 'payouts', NULL, '#28a745', '40,167,69');
/*!40000 ALTER TABLE `item_settings` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `item_status` (
  `item_status_id` int(11) NOT NULL AUTO_INCREMENT,
  `item_status_name` varchar(50) CHARACTER SET utf16 DEFAULT NULL,
  `item_status_colour` varchar(7) CHARACTER SET utf16 DEFAULT NULL,
  `item_status_colour_code` varchar(7) CHARACTER SET utf16 DEFAULT NULL,
  PRIMARY KEY (`item_status_id`) USING BTREE
) ENGINE=MyISAM AUTO_INCREMENT=4 DEFAULT CHARSET=latin1 ROW_FORMAT=DYNAMIC;

/*!40000 ALTER TABLE `item_status` DISABLE KEYS */;
INSERT INTO `item_status` (`item_status_id`, `item_status_name`, `item_status_colour`, `item_status_colour_code`) VALUES
	(1, 'pending', 'primary', '#ff2d42'),
	(2, 'published', 'success', '#0000ff'),
	(3, 'deleted', 'danger', '#ff0000');
/*!40000 ALTER TABLE `item_status` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `iyzico_settings` (
  `iyzico_id` int(11) NOT NULL AUTO_INCREMENT,
  `iyzico_status` int(11) DEFAULT NULL,
  `iyzico_url` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `iyzico_api_key` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `iyzico_secret_key` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  PRIMARY KEY (`iyzico_id`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=latin1;

/*!40000 ALTER TABLE `iyzico_settings` DISABLE KEYS */;
INSERT INTO `iyzico_settings` (`iyzico_id`, `iyzico_status`, `iyzico_url`, `iyzico_api_key`, `iyzico_secret_key`) VALUES
	(1, 1, 'https://api.iyzipay.com', NULL, NULL),
	(2, 0, 'https://sandbox-api.iyzipay.com', NULL, NULL);
/*!40000 ALTER TABLE `iyzico_settings` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `languages` (
  `language_id` int(11) NOT NULL AUTO_INCREMENT,
  `language_iso` varchar(5) CHARACTER SET utf16 DEFAULT NULL,
  `language` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `is_active` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`language_id`)
) ENGINE=MyISAM AUTO_INCREMENT=105 DEFAULT CHARSET=latin1;

/*!40000 ALTER TABLE `languages` DISABLE KEYS */;
INSERT INTO `languages` (`language_id`, `language_iso`, `language`, `is_active`) VALUES
	(1, 'af', 'Afrikaans', 0),
	(2, 'sq', 'Albanian', 0),
	(3, 'am', 'Amharic', 0),
	(4, 'ar', 'Arabic', 0),
	(5, 'hy', 'Armenian', 0),
	(6, 'az', 'Azerbaijani', 0),
	(7, 'eu', 'Basque', 0),
	(8, 'be', 'Belarusian', 0),
	(9, 'bn', 'Bengali', 0),
	(10, 'bs', 'Bosnian', 0),
	(11, 'bg', 'Bulgarian', 0),
	(12, 'ca', 'Catalan', 0),
	(13, 'ceb', 'Cebuano', 0),
	(14, 'ny', 'Chichewa', 0),
	(15, 'zh-CN', 'Chinese (Simplified)', 0),
	(16, 'zh-TW', 'Chinese (Traditional)', 0),
	(17, 'co', 'Corsican', 0),
	(18, 'hr', 'Croatian', 0),
	(19, 'cs', 'Czech', 0),
	(20, 'da', 'Danish', 0),
	(21, 'nl', 'Dutch', 0),
	(22, 'en', 'English', 0),
	(23, 'eo', 'Esperanto', 0),
	(24, 'et', 'Estonian', 0),
	(25, 'tl', 'Filipino', 0),
	(26, 'fi', 'Finnish', 0),
	(27, 'fr', 'French', 0),
	(28, 'fy', 'Frisian', 0),
	(29, 'gl', 'Galician', 0),
	(30, 'ka', 'Georgian', 0),
	(31, 'de', 'German', 0),
	(32, 'el', 'Greek', 0),
	(33, 'gu', 'Gujarati', 0),
	(34, 'ht', 'Haitian Creole', 0),
	(35, 'ha', 'Hausa', 0),
	(36, 'haw', 'Hawaiian', 0),
	(37, 'iw', 'Hebrew', 0),
	(38, 'hi', 'Hindi', 0),
	(39, 'hmn', 'Hmong', 0),
	(40, 'hu', 'Hungarian', 0),
	(41, 'is', 'Icelandic', 0),
	(42, 'ig', 'Igbo', 0),
	(43, 'id', 'Indonesian', 0),
	(44, 'ga', 'Irish', 0),
	(45, 'it', 'Italian', 0),
	(46, 'ja', 'Japanese', 0),
	(47, 'jw', 'Javanese', 0),
	(48, 'kn', 'Kannada', 0),
	(49, 'kk', 'Kazakh', 0),
	(50, 'km', 'Khmer', 0),
	(51, 'ko', 'Korean', 0),
	(52, 'ku', 'Kurdish (Kurmanji)', 0),
	(53, 'ky', 'Kyrgyz', 0),
	(54, 'lo', 'Lao', 0),
	(55, 'la', 'Latin', 0),
	(56, 'lv', 'Latvian', 0),
	(57, 'lt', 'Lithuanian', 0),
	(58, 'lb', 'Luxembourgish', 0),
	(59, 'mk', 'Macedonian', 0),
	(60, 'mg', 'Malagasy', 0),
	(61, 'ms', 'Malay', 0),
	(62, 'ml', 'Malayalam', 0),
	(63, 'mt', 'Maltese', 0),
	(64, 'mi', 'Maori', 0),
	(65, 'mr', 'Marathi', 0),
	(66, 'mn', 'Mongolian', 0),
	(67, 'my', 'Myanmar (Burmese)', 0),
	(68, 'ne', 'Nepali', 0),
	(69, 'no', 'Norwegian', 0),
	(70, 'ps', 'Pashto', 0),
	(71, 'fa', 'Persian', 0),
	(72, 'pl', 'Polish', 0),
	(73, 'pt', 'Portuguese', 0),
	(74, 'pa', 'Punjabi', 0),
	(75, 'ro', 'Romanian', 0),
	(76, 'ru', 'Russian', 0),
	(77, 'sm', 'Samoan', 0),
	(78, 'gd', 'Scots Gaelic', 0),
	(79, 'sr', 'Serbian', 0),
	(80, 'st', 'Sesotho', 0),
	(81, 'sn', 'Shona', 0),
	(82, 'sd', 'Sindhi', 0),
	(83, 'si', 'Sinhala', 0),
	(84, 'sk', 'Slovak', 0),
	(85, 'sl', 'Slovenian', 0),
	(86, 'so', 'Somali', 0),
	(87, 'es', 'Spanish', 0),
	(88, 'su', 'Sundanese', 0),
	(89, 'sw', 'Swahili', 0),
	(90, 'sv', 'Swedish', 0),
	(91, 'tg', 'Tajik', 0),
	(92, 'ta', 'Tamil', 0),
	(93, 'te', 'Telugu', 0),
	(94, 'th', 'Thai', 0),
	(95, 'tr', 'Turkish', 0),
	(96, 'uk', 'Ukrainian', 0),
	(97, 'ur', 'Urdu', 0),
	(98, 'uz', 'Uzbek', 0),
	(99, 'vi', 'Vietnamese', 0),
	(100, 'cy', 'Welsh', 0),
	(101, 'xh', 'Xhosa', 0),
	(102, 'yi', 'Yiddish', 0),
	(103, 'yo', 'Yoruba', 0),
	(104, 'zu', 'Zulu', 0);
/*!40000 ALTER TABLE `languages` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `mpesa_settings` (
  `mpesa_id` int(11) NOT NULL AUTO_INCREMENT,
  `mpesa_status` int(11) DEFAULT NULL,
  `mpesa_authentication_url` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `mpesa_register_url` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `mpesa_short_code` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `mpesa_consumer_key` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `mpesa_consumer_secret` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `mpesa_secret_token` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  PRIMARY KEY (`mpesa_id`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=latin1;

/*!40000 ALTER TABLE `mpesa_settings` DISABLE KEYS */;
INSERT INTO `mpesa_settings` (`mpesa_id`, `mpesa_status`, `mpesa_authentication_url`, `mpesa_register_url`, `mpesa_short_code`, `mpesa_consumer_key`, `mpesa_consumer_secret`, `mpesa_secret_token`) VALUES
	(1, 1, 'https://api.safaricom.co.ke/oauth/v1/generate?grant_type=client_credentials', 'https://api.safaricom.co.ke/mpesa/c2b/v1/registerurl', NULL, NULL, NULL, NULL),
	(2, 0, 'https://sandbox.safaricom.co.ke/oauth/v1/generate?grant_type=client_credentials', 'https://sandbox.safaricom.co.ke/mpesa/c2b/v1/registerurl', NULL, NULL, NULL, NULL);
/*!40000 ALTER TABLE `mpesa_settings` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `navigation` (
  `navigation_id` int(11) NOT NULL AUTO_INCREMENT,
  `navigation_name` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `navigation_icon` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `navigation_order` int(11) DEFAULT NULL,
  `navigation_date_added` datetime NOT NULL,
  PRIMARY KEY (`navigation_id`) USING BTREE
) ENGINE=MyISAM AUTO_INCREMENT=31 DEFAULT CHARSET=latin1;

/*!40000 ALTER TABLE `navigation` DISABLE KEYS */;
INSERT INTO `navigation` (`navigation_id`, `navigation_name`, `navigation_icon`, `navigation_order`, `navigation_date_added`) VALUES
	(1, 'dashboards', '<i class="fa-solid fa-home"></i>', NULL, '2022-10-21 16:31:43'),
	(3, 'users', '<i class="fa-solid fa-users"></i>', NULL, '2022-10-21 16:31:43'),
	(4, 'packages', '<i class="fa-solid fa-filter"></i>', NULL, '2022-10-21 16:31:43'),
	(5, 'subscriptions', '<i class="fa-solid fa-money-bill-1"></i>', NULL, '2022-10-21 16:31:43'),
	(6, 'payouts', '<i class="fa-solid fa-wallet"></i>', NULL, '2022-10-21 16:31:43'),
	(7, 'pages', '<i class="fa-solid fa-book-bookmark"></i>', NULL, '2022-10-21 16:31:43'),
	(8, 'reports', '<i class="fa-solid fa-briefcase"></i>', NULL, '2022-10-21 16:31:43'),
	(9, 'settings', '<i class="fa-solid fa-gears"></i>', NULL, '2022-10-21 16:31:43'),
	(10, 'assistants', '<i class="fa-solid fa-microchip"></i>', NULL, '2023-11-24 17:01:01'),
	(11, 'templates', '<i class="fa-solid fa-list"></i>', NULL, '2022-10-21 16:31:43'),
	(13, 'invoices', '<i class="fa-solid fa-file-invoice"></i>', NULL, '2022-10-21 16:31:43'),
	(14, 'payments', '<i class="fa-solid fa-dollar"></i>', NULL, '2022-10-21 16:31:43'),
	(15, 'notifications', '<i class="fa-solid fa-bell"></i>', NULL, '2022-10-21 16:31:43'),
	(16, 'media', '<i class="fa-solid fa-file-image"></i>', NULL, '2022-10-21 16:31:43'),
	(17, 'subscribers', '<i class="fa-solid fa-user-group"></i>', NULL, '2022-10-21 16:31:43'),
	(18, 'faqs', '<i class="fa-solid fa-question"></i>', NULL, '2022-10-21 16:31:43'),
	(19, 'affiliates', '<i class="fa-solid fa-gift"></i>', NULL, '2022-10-21 16:31:43'),
	(20, 'blog', '<i class="fa-solid fa-blog"></i>', NULL, '2023-11-12 11:03:05'),
	(21, 'ads', '<i class="fa-solid fa-font-awesome"></i>', NULL, '2023-11-24 17:01:01'),
	(22, 'chats', '<i class="fa-solid fa-message"></i>', NULL, '2023-11-24 17:01:01'),
	(23, 'tickets', '<i class="fa-solid fa-envelope-open-text"></i>', NULL, '2023-11-24 17:01:01'),
	(12, 'utilities', '<i class="fa-solid fa-toolbox"></i>', NULL, '2023-11-24 17:01:01'),
	(2, 'newsletters', '<i class="fa-solid fa-book"></i>', NULL, '2023-11-08 08:40:46'),
	(24, 'themes', '<i class="fa-solid fa-font-awesome"></i>', NULL, '2023-11-08 08:40:46'),
	(25, 'finetuning', '<i class="fa-solid fa-font-awesome"></i>', NULL, '2023-11-08 08:40:46'),
	(26, 'files', '<i class="fa-solid fa-file"></i>', NULL, '2024-04-18 12:05:55'),
	(27, 'links', '<i class="fa-solid fa-link"></i>', NULL, '2024-04-18 12:05:55'),
	(28, 'servers', '<i class="fa-solid fa-server"></i>', NULL, '2024-04-18 12:05:55'),
	(29, 'whatsapp', '<i class="fa-brands fa-whatsapp"></i>', NULL, '2024-04-18 12:05:55'),
	(30, 'addons', '<i class="fa-solid fa-plus"></i>', NULL, '2024-04-18 12:05:55');
/*!40000 ALTER TABLE `navigation` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `newsletters` (
  `newsletter_id` int(11) NOT NULL AUTO_INCREMENT,
  `newsletter_uid` varchar(50) CHARACTER SET utf16 DEFAULT NULL,
  `newsletter_added_by` int(11) DEFAULT NULL,
  `newsletter_title` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `newsletter_slug` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `newsletter_description` longtext CHARACTER SET utf16,
  `newsletter_sent_at` datetime DEFAULT NULL,
  `newsletter_date_added` datetime DEFAULT NULL,
  PRIMARY KEY (`newsletter_id`) USING BTREE
) ENGINE=MyISAM DEFAULT CHARSET=latin1 ROW_FORMAT=DYNAMIC;

/*!40000 ALTER TABLE `newsletters` DISABLE KEYS */;
/*!40000 ALTER TABLE `newsletters` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `notifications` (
  `notification_id` int(11) NOT NULL AUTO_INCREMENT,
  `notification_uid` longtext CHARACTER SET utf16,
  `is_notification_read` int(11) NOT NULL DEFAULT '0',
  `notification_date_added` datetime NOT NULL,
  `notification_description` longtext CHARACTER SET utf16,
  `notification_added_by` int(11) DEFAULT NULL,
  `to_user_id` int(11) DEFAULT NULL,
  `is_whatsapp` int(11) DEFAULT NULL,
  `link` mediumtext CHARACTER SET utf16,
  PRIMARY KEY (`notification_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

/*!40000 ALTER TABLE `notifications` DISABLE KEYS */;
/*!40000 ALTER TABLE `notifications` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `openai_models` (
  `openai_model_id` int(11) NOT NULL AUTO_INCREMENT,
  `openai_model_type` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `openai_model_usage_type` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `openai_model` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `openai_model_description` longtext CHARACTER SET utf16,
  `openai_model_tokens` int(11) DEFAULT NULL,
  `openai_model_status_id` int(11) DEFAULT NULL,
  PRIMARY KEY (`openai_model_id`)
) ENGINE=MyISAM AUTO_INCREMENT=13 DEFAULT CHARSET=latin1;

/*!40000 ALTER TABLE `openai_models` DISABLE KEYS */;
INSERT INTO `openai_models` (`openai_model_id`, `openai_model_type`, `openai_model_usage_type`, `openai_model`, `openai_model_description`, `openai_model_tokens`, `openai_model_status_id`) VALUES
	(1, 'GPT-3', '["chat","finetune"]', 'babbage-002', 'Capable of straightforward tasks, very fast, and lower cost.', 2049, 1),
	(2, 'GPT-3', '["chat","finetune"]', 'davinci-002', 'Most capable GPT-3 model. Can do any task the other models can do, often with higher quality.', 2049, 1),
	(3, 'GPT-3.5', '["chat","finetune","assistant"]', 'gpt-3.5-turbo', 'Most capable GPT-3.5 model and optimized for chat at 1/10th the cost of text-davinci-003. Will be updated with our latest model iteration 2 weeks after it is released.', 4096, 1),
	(4, 'GPT-3.5', '["chat","assistant"]', 'gpt-3.5-turbo-16k', 'Same capabilities as the standard gpt-3.5-turbo model but with 4 times the context.', 16384, 1),
	(5, 'GPT-3.5', '["chat","assistant"]', 'gpt-3.5-turbo-0613', 'Snapshot of gpt-3.5-turbo from June 13th 2023 with function calling data. Unlike gpt-3.5-turbo, this model will not receive updates, and will be deprecated 3 months after a new version is released.', 4096, 1),
	(6, 'GPT-3.5', '["chat","assistant"]', 'gpt-3.5-turbo-16k-0613', 'Snapshot of gpt-3.5-turbo-16k from June 13th 2023. Unlike gpt-3.5-turbo-16k, this model will not receive updates, and will be deprecated 3 months after a new version is released.', 16384, 1),
	(7, 'GPT-4', '["chat","assistant"]', 'gpt-4-turbo', 'New GPT-4 Turbo with Vision The latest GPT-4 Turbo model with vision capabilities. Vision requests can now use JSON mode and function calling. Currently points to gpt-4-turbo-2024-04-09.', 32768, 1),
	(8, 'GPT-4', '["chat","assistant"]', 'gpt-4', 'More capable than any GPT-3.5 model, able to do more complex tasks, and optimized for chat. Will be updated with our latest model iteration.', 8192, 1),
	(9, 'GPT-4', '["chat","assistant"]', 'gpt-4-0613', 'Snapshot of gpt-4 from June 13th 2023 with function calling data. Unlike gpt-4, this model will not receive updates, and will be deprecated 3 months after a new version is released.', 8192, 1),
	(10, 'GPT-4', '["chat","assistant"]', 'gpt-4-32k-0613', 'Snapshot of gpt-4-32 from June 13th 2023. Unlike gpt-4-32k, this model will not receive updates, and will be deprecated 3 months after a new version is released.', 32768, 1),
	(11, 'GPT-4o', '["chat","assistant"]', 'gpt-4o', 'Our most advanced, multimodal flagship model that is cheaper and faster than GPT-4 Turbo', 128000, 1),
	(12, 'GPT-4o', '["chat","assistant","finetune"]', 'gpt-4o-mini', 'The latest GPT-4o model', 128000, 1);
/*!40000 ALTER TABLE `openai_models` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `openai_tones` (
  `openai_tone_id` int(11) NOT NULL AUTO_INCREMENT,
  `openai_tone` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  PRIMARY KEY (`openai_tone_id`) USING BTREE
) ENGINE=MyISAM AUTO_INCREMENT=38 DEFAULT CHARSET=latin1 ROW_FORMAT=DYNAMIC;

/*!40000 ALTER TABLE `openai_tones` DISABLE KEYS */;
INSERT INTO `openai_tones` (`openai_tone_id`, `openai_tone`) VALUES
	(1, 'Authoritative'),
	(2, 'Caring'),
	(3, 'Cheerful'),
	(4, 'Coarse'),
	(5, 'Conservative'),
	(6, 'Conversational'),
	(7, 'Casual'),
	(8, 'Dry'),
	(9, 'Edgy'),
	(10, 'Enthusiastic'),
	(11, 'Formal'),
	(12, 'Frank'),
	(13, 'Friendly'),
	(14, 'Fun'),
	(15, 'Funny'),
	(16, 'Humorous'),
	(17, 'Informative'),
	(18, 'Irreverent'),
	(19, 'Matter-of-fact'),
	(20, 'Nostalgic'),
	(21, 'Passionate'),
	(22, 'Playful'),
	(23, 'Professional'),
	(24, 'Provocative'),
	(25, 'Quirky'),
	(26, 'Respectful'),
	(27, 'Romantic'),
	(28, 'Sarcastic'),
	(29, 'Serious'),
	(30, 'Smart'),
	(31, 'Snarky'),
	(32, 'Sympathetic'),
	(33, 'Trendy'),
	(34, 'Trustworthy'),
	(35, 'Unapologetic'),
	(36, 'Upbeat'),
	(37, 'Witty');
/*!40000 ALTER TABLE `openai_tones` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `options` (
  `option_id` int(11) NOT NULL AUTO_INCREMENT,
  `option_name` varchar(100) CHARACTER SET utf16 NOT NULL,
  `option_value` longtext CHARACTER SET utf16,
  `option_autoload` tinyint(4) NOT NULL DEFAULT '1',
  PRIMARY KEY (`option_id`),
  UNIQUE KEY `option_name` (`option_name`)
) ENGINE=MyISAM AUTO_INCREMENT=188 DEFAULT CHARSET=latin1 ROW_FORMAT=COMPACT;

/*!40000 ALTER TABLE `options` DISABLE KEYS */;
INSERT INTO `options` (`option_id`, `option_name`, `option_value`, `option_autoload`) VALUES
	(1, 'system_version', '2.7 build 20240824', 1),
	(2, 'database_version', '2.7 build 20240824', 1),
	(3, 'paypal_pro_live_enabled', '0', 1),
	(4, 'paypal_pro_label', 'Pay with PayPal Pro', 1),
	(5, 'stripe_live_enabled', '0', 1),
	(6, 'stripe_label', 'Pay with Stripe', 1),
	(7, 'authorize_net_live_enabled', '0', 1),
	(8, 'authorize_net_label', 'Pay using Authorize.Net', 1),
	(9, 'paypal_standard_live_enabled', '0', 1),
	(10, 'paypal_standard_label', 'Pay with PayPal Standard', 1),
	(11, 'twocheckout_live_enabled', '0', 1),
	(12, 'twocheckout_label', 'Pay with 2Checkout', 1),
	(13, 'confirm_order_automatically', '1', 1),
	(14, 'default_discount', '0', 1),
	(15, 'default_tax', '0', 1),
	(16, 'allowed_file_types', 'gif,png,jpeg,jpg,pdf,doc,docx,xls,zip,rar,xlsx,sql', 1),
	(17, 'assign_ticket_randomly', '1', 1),
	(18, 'assign_ticket_randomly_to', '', 1),
	(19, 'backup_database_automatically', '1', 1),
	(20, 'default_currency', 'USD', 1),
	(21, 'default_system_logo', 'default_logo.png', 1),
	(22, 'default_system_favicon', 'default_favicon.png', 1),
	(23, 'currency_symbol', '$', 1),
	(24, 'invoice_prefix', 'INV', 1),
	(25, 'commission_rate', '10', 1),
	(26, 'invoice_thank_you_note', 'Thank you for doing business with us.', 1),
	(27, 'create_accounts', '1', 1),
	(28, 'use_currency_symbol', '1', 1),
	(29, 'delete_database_backups_older_than', '7', 1),
	(30, 'notify_department_members', '1', 1),
	(31, 'records_per_page', '10', 1),
	(32, 'allow_customer_to_modify_the_amount_to_pay', '1', 1),
	(33, 'order_prefix', 'ORD', 1),
	(34, 'use_email', 'do-not-reply@mybizcms.com', 1),
	(35, 'default_date_format', 'j F Y', 1),
	(36, 'default_datetime_format', 'j F Y g:i a', 1),
	(37, 'website_title', 'EmbedAI', 1),
	(38, 'website_description', '', 1),
	(39, 'website_keywords', '', 1),
	(40, 'htmlentities_decode_enabled', '1', 1),
	(41, 'allow_customer_place_orders', '1', 1),
	(42, 'clients_addon_urlroot', '', 1),
	(43, 'tcpdf_font', 'times', 1),
	(44, 'tcpdf_font_size', '12', 1),
	(45, 'tcpdf_orientation', 'P', 1),
	(46, 'tcpdf_layout_size', 'A4', 1),
	(47, 'include_invoice_thank_you_note', '1', 1),
	(48, 'include_invoice_terms', '1', 1),
	(49, 'include_invoice_admin_note', '1', 1),
	(50, 'include_invoice_client_note', '1', 1),
	(51, 'tcpdf_header_colour', '#ffffff', 1),
	(52, 'order_lead', '1', 1),
	(53, 'order_stage', '2', 1),
	(54, 'pesapal_live_enabled', '0', 1),
	(55, 'pesapal_label', 'Pay with Pesapal', 0),
	(56, 'paytm_live_enabled', '0', 1),
	(57, 'paytm_label', 'Pay with PayTM', 0),
	(58, 'payu_money_live_enabled', '0', 1),
	(59, 'payu_money_label', 'Pay with payU Money', 1),
	(60, 'mpesa_live_enabled', '0', 1),
	(61, 'mpesa_label', 'Pay with mPesa', 1),
	(62, 'default_language', 'en', 1),
	(63, 'twilio_live_enabled', '0', 0),
	(64, 'clickatell_live_enabled', '1', 1),
	(65, 'movesms_live_enabled', '0', 0),
	(66, 'msg91_live_enabled', '0', 0),
	(67, 'bulksms_live_enabled', '0', 0),
	(68, 'plivo_live_enabled', '0', 0),
	(69, 'smscluster_live_enabled', '0', 0),
	(70, 'celcom_live_enabled', '0', 0),
	(71, 'smsgatewayhub_live_enabled', '0', 0),
	(72, 'infobip_live_enabled', '0', 0),
	(73, 'smsglobal_live_enabled', '0', 0),
	(74, 'sendgrid_live_enabled', '0', 0),
	(75, 'mailchimp_live_enabled', '1', 1),
	(76, 'smtp_live_enabled', '1', 1),
	(77, 'hubtel_live_enabled', '0', 0),
	(78, 'delete_read_notifications_older_than', '4', 1),
	(79, 'delete_unread_notifications_older_than', '7', 1),
	(80, 'minimum_payment_acceptable', '0.10', 1),
	(81, 'sslcommerz_live_enabled', '0', 1),
	(82, 'sslcommerz_label', 'Pay with sslcommerz', 1),
	(83, 'voguepay_live_enabled', '0', 1),
	(84, 'voguepay_label', 'Pay with Voguepay', 1),
	(85, 'paystack_live_enabled', '0', 1),
	(86, 'paystack_label', 'Pay with Paystack', 1),
	(87, 'mercadopago_live_enabled', '0', 1),
	(88, 'mercadopago_label', 'Pay with Mercadopago', 1),
	(89, 'razorpay_live_enabled', '0', 1),
	(90, 'razorpay_label', 'Pay with Razorpay', 1),
	(91, 'instamojo_live_enabled', '0', 1),
	(92, 'instamojo_label', 'Pay with Instamojo', 1),
	(93, 'esewa_live_enabled', '0', 1),
	(94, 'esewa_label', 'Pay with Esewa Epay', 1),
	(95, 'cashfree_live_enabled', '0', 1),
	(96, 'cashfree_label', 'Pay with Cashfree', 1),
	(97, 'toyyibpay_live_enabled', '0', 1),
	(98, 'toyyibpay_label', 'Pay with Toyyibpay', 1),
	(99, 'aamarpay_live_enabled', '0', 1),
	(100, 'aamarpay_label', 'Pay with Aamarpay', 1),
	(101, 'payfast_live_enabled', '0', 1),
	(102, 'payfast_label', 'Pay with payfast', 1),
	(103, 'payhere_live_enabled', '0', 1),
	(104, 'payhere_label', 'Pay with payhere', 1),
	(105, 'iyzico_live_enabled', '0', 1),
	(106, 'iyzico_label', 'Pay with iyzico', 1),
	(107, 'bkash_live_enabled', '0', 1),
	(108, 'bkash_label', 'Pay with bkash', 1),
	(109, 'payku_live_enabled', '0', 1),
	(110, 'payku_label', 'Pay with payku', 1),
	(111, 'ngenius_live_enabled', '0', 1),
	(112, 'ngenius_label', 'Pay with ngenius', 1),
	(113, 'nagad_live_enabled', '0', 1),
	(114, 'nagad_label', 'Pay with nagad', 1),
	(115, 'paykun_live_enabled', '0', 1),
	(116, 'paykun_label', 'Pay with paykun', 1),
	(117, 'hyperpay_live_enabled', '0', 1),
	(118, 'hyperpay_label', 'Pay with Hyperpay', 1),
	(119, 'paygate_live_enabled', '0', 1),
	(120, 'paygate_label', 'Pay with Paygate', 1),
	(121, 'flutterwave_live_enabled', '0', 1),
	(122, 'flutterwave_label', 'Pay with Flutterwave', 1),
	(123, 'approve_subscription_automatically', '1', 1),
	(124, 'subscription_prefix', 'SUB', 1),
	(125, 'enable_google_recaptcha', '0', 1),
	(126, 'privacy_policy_page', '', 1),
	(127, 'terms_and_conditions_page', '', 1),
	(128, 'last_cronjob', '2024-02-14 12:55:17', 1),
	(129, 'default_timezone', 'Africa/Nairobi', 1),
	(130, 'openai_api_key', ' ', 1),
	(131, 'google_font_link', '<link href="https://fonts.googleapis.com/css?family=Open+Sans:300,300i,400,400i,600,600i,700,700i|Krub:300,300i,400,400i,500,500i,600,600i,700,700i|Poppins:300,300i,400,400i,500,500i,600,600i,700,700i" rel="stylesheet">', 1),
	(132, 'google_font_css_rules', 'font-family: \'Krub\', sans-serif; font-family: \'Open Sans\', sans-serif; font-family: \'Poppins\', sans-serif;', 1),
	(133, 'custom_script_in_header', '<meta name="google-site-verification" content="mC6MIhMi9vmHrGUUiTNTll11RKhpNhRtZWb1-hs2d5"/>\r\n\r\n<!-- Global site tag (gtag.js) - Google Analytics -->\r\n<script async src="https://www.googletagmanager.com/gtag/js?id=UA-111111111-2"></script>\r\n<script>\r\n  window.dataLayer = window.dataLayer || [];\r\n  function gtag(){dataLayer.push(arguments);}\r\n  gtag(\'js\', new Date());\r\n\r\n  gtag(\'config\', \'UA-111111111-1\');\r\n</script>', 1),
	(134, 'custom_script_in_footer', '', 1),
	(135, 'topup_prefix', 'TOP', 1),
	(136, 'enable_affiliate', '1', 1),
	(137, 'affiliate_rule_id', '1', 1),
	(138, 'affiliate_commission_rate', '49', 1),
	(139, 'affiliate_minimum_payout', '31', 1),
	(140, 'affiliate_action_phrase', '<p>Invite your friends, and when they subscribe, you can get <strong>49%</strong> commission of their purchase(s). That\'s it.</p>', 1),
	(141, 'affiliate_guidelines', '<p>1. Share your referral link with your friends.</p>\r\n<p>2. For their first subscription, you will receive a <strong>49%</strong> commission.</p>\r\n<p>3. Include Payout details under Profile &gt; Payout settings to receive your commissions.</p>\r\n<p>4. Request and view payouts through Affiliate program &gt; Payouts.</p>', 1),
	(142, 'payout_prefix', 'PYT', 1),
	(143, 'email_gateway', 'php_mail', 1),
	(144, 'custom_css_file_url', '', 1),
	(145, 'custom_js_file_url', '', 1),
	(146, 'custom_package_maximum_result_length', '500', 1),
	(147, 'response_typing_speed', '0', 1),
	(148, 'active_theme', 'embedai', 1),
	(149, 'keep_remaining_balances_after_subscription_expiry', '1', 1),
	(150, 'not_found_public_image', '', 1),
	(151, 'not_found_public_title', 'Page not found', 1),
	(152, 'not_found_public_description', '<p>Sorry we can&rsquo;t find that page! Don&rsquo;t worry, though everything is STILL AWESOME!</p>', 1),
	(153, 'google_tracking_code', '<script>\r\n(function(i,s,o,g,r,a,m){i[\'GoogleAnalyticsObject\']=r;i[r]=i[r]||function(){\r\n  (i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),\r\n  m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)\r\n  })(window,document,\'script\',\'//www.google-analytics.com/analytics.js\',\'ga\');\r\n \r\n  ga(\'create\', \'UA-xxxxxx-1\', \'auto\');\r\n  ga(\'send\', \'pageview\');\r\n</script>', 1),
	(154, 'homepage_gradient_colour', 'linear-gradient(to bottom, #7979f2 -60%, #f6ffff 38%)', 1),
	(155, 'contact_us_page', '14', 1),
	(156, 'custom_package_duration', '1', 1),
	(157, 'custom_package_duration_type', 'months', 1),
	(158, 'custom_package_model', 'gpt-3.5-turbo', 1),
	(159, 'chat_prefix', 'CHT', 1),
	(160, 'visit_prefix', 'VST', 1),
	(161, 'show_contact_us_form', '1', 1),
	(162, 'show_contact_us_details', '1', 1),
	(163, 'contact_us_email', 'test@gmail.com', 1),
	(164, 'contact_us_phone', '+1 111 111 111', 1),
	(165, 'contact_us_address', 'Apt. 129 317 Lowe Avenue, Wolffurt, SD 97075', 1),
	(166, 'enable_homepage', 'on', 1),
	(167, 'paddle_live_enabled', '0', 1),
	(168, 'paddle_label', 'Pay with Paddle', 1),
	(169, 'backup_database_automatically_after', '1 days', 1),
	(170, 'last_database_backup', '1', 1),
	(171, 'paytr_live_enabled', '0', 1),
	(172, 'paytr_label', 'Pay with PayTR', 1),
	(173, 'openai_default_finetune_model', 'gpt-3.5-turbo-0613', 1),
	(174, 'openai_default_assistant_model', 'gpt-3.5-turbo', 1),
	(175, 'tap_live_enabled', '0', 1),
	(176, 'tap_label', 'Pay with Tap', 1),
	(177, 'email_custom_errors', '1', 1),
	(178, 'number_of_currency_decimals', '2', 1),
	(179, 'currency_symbol_placement', 'after', 1),
	(180, 'maximum_upload_file_size', '512', 1),
	(181, 'order_code_length', '4', 1),
	(183, 'assistant_version', 'v2', 1),
	(184, 'midtrans_live_enabled', '0', 1),
	(185, 'midtrans_label', 'Pay with Midtrans', 1),
	(186, 'tripay_live_enabled', '0', 1),
	(187, 'tripay_label', 'Pay with Tripay', 1);
/*!40000 ALTER TABLE `options` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `packages` (
  `package_id` int(11) NOT NULL AUTO_INCREMENT,
  `package_name` varchar(100) CHARACTER SET utf16 DEFAULT NULL,
  `package_duration` int(11) DEFAULT NULL,
  `package_duration_type` varchar(100) CHARACTER SET utf16 DEFAULT NULL,
  `package_chat_assistants` int(11) DEFAULT '0',
  `package_trained_models` int(11) DEFAULT '0',
  `package_chat_files` int(11) DEFAULT '0',
  `package_chat_links` int(11) DEFAULT '0',
  `package_chat_sitemaps` int(11) DEFAULT '0',
  `package_words` int(11) DEFAULT '0',
  `accept_custom_branding` int(11) DEFAULT NULL,
  `package_cost` float(11,2) DEFAULT NULL,
  `package_monthly_cost` float(11,2) DEFAULT NULL,
  `package_yearly_cost` float(11,2) DEFAULT NULL,
  `package_lifetime_cost` float(11,2) DEFAULT NULL,
  `package_featured` int(11) NOT NULL DEFAULT '0',
  `is_custom` int(11) DEFAULT NULL,
  `is_free_trial` int(11) DEFAULT NULL,
  `is_private` int(11) DEFAULT NULL,
  PRIMARY KEY (`package_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

/*!40000 ALTER TABLE `packages` DISABLE KEYS */;
/*!40000 ALTER TABLE `packages` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `package_features` (
  `package_feature_id` int(11) NOT NULL AUTO_INCREMENT,
  `package_feature_description` longtext CHARACTER SET utf16,
  `package_feature_order` int(11) DEFAULT NULL,
  PRIMARY KEY (`package_feature_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 ROW_FORMAT=DYNAMIC;

/*!40000 ALTER TABLE `package_features` DISABLE KEYS */;
/*!40000 ALTER TABLE `package_features` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `package_items` (
  `package_item_id` int(11) NOT NULL AUTO_INCREMENT,
  `package_id` int(11) DEFAULT NULL,
  `package_feature_id` int(11) DEFAULT NULL,
  `package_item_order` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`package_item_id`) USING BTREE
) ENGINE=MyISAM DEFAULT CHARSET=latin1 ROW_FORMAT=DYNAMIC;

/*!40000 ALTER TABLE `package_items` DISABLE KEYS */;
/*!40000 ALTER TABLE `package_items` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `package_languages` (
  `package_language_id` int(11) NOT NULL AUTO_INCREMENT,
  `package_id` int(11) DEFAULT NULL,
  `openai_language_id` int(11) DEFAULT NULL,
  `package_language_order` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`package_language_id`) USING BTREE
) ENGINE=MyISAM DEFAULT CHARSET=latin1 ROW_FORMAT=DYNAMIC;

/*!40000 ALTER TABLE `package_languages` DISABLE KEYS */;
/*!40000 ALTER TABLE `package_languages` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `package_rates` (
  `package_rate_id` int(11) NOT NULL AUTO_INCREMENT,
  `package_rate_type` varchar(50) CHARACTER SET utf16 DEFAULT NULL,
  `package_rate_cost` float(11,4) DEFAULT NULL,
  PRIMARY KEY (`package_rate_id`) USING BTREE
) ENGINE=MyISAM AUTO_INCREMENT=5 DEFAULT CHARSET=latin1 ROW_FORMAT=DYNAMIC;

/*!40000 ALTER TABLE `package_rates` DISABLE KEYS */;
INSERT INTO `package_rates` (`package_rate_id`, `package_rate_type`, `package_rate_cost`) VALUES
	(1, 'words', 0.0020),
	(2, 'images', 0.0350),
	(3, 'seconds', 0.0276),
	(4, 'characters', 0.0046);
/*!40000 ALTER TABLE `package_rates` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `paddle_settings` (
  `paddle_id` int(11) NOT NULL AUTO_INCREMENT,
  `paddle_status` int(11) DEFAULT NULL,
  `paddle_url` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `paddle_api_key` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `paddle_client_side_token` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  PRIMARY KEY (`paddle_id`) USING BTREE
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=latin1 ROW_FORMAT=DYNAMIC;

/*!40000 ALTER TABLE `paddle_settings` DISABLE KEYS */;
INSERT INTO `paddle_settings` (`paddle_id`, `paddle_status`, `paddle_url`, `paddle_api_key`, `paddle_client_side_token`) VALUES
	(1, 1, 'https://api.paddle.com/', NULL, NULL),
	(2, 0, 'https://sandbox-api.paddle.com/', NULL, NULL);
/*!40000 ALTER TABLE `paddle_settings` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `pages` (
  `page_id` int(11) NOT NULL AUTO_INCREMENT,
  `page_added_by` int(11) NOT NULL,
  `page_title` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `page_slug` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `page_background` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `page_short_description` longtext CHARACTER SET utf16,
  `page_description` mediumtext CHARACTER SET utf16,
  `show_in_header` int(11) NOT NULL DEFAULT '0',
  `show_in_footer` int(11) NOT NULL DEFAULT '0',
  `page_status_id` int(11) NOT NULL,
  `page_date_added` datetime DEFAULT NULL,
  PRIMARY KEY (`page_id`) USING BTREE
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

/*!40000 ALTER TABLE `pages` DISABLE KEYS */;
/*!40000 ALTER TABLE `pages` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `paygate_settings` (
  `paygate_id` int(11) NOT NULL AUTO_INCREMENT,
  `paygate_status` int(11) DEFAULT NULL,
  `paygate_url` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `paygate_redirection_url` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `paygate_verification_url` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `paygate_paygate_id` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `paygate_encryption_key` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  PRIMARY KEY (`paygate_id`) USING BTREE
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=latin1 ROW_FORMAT=DYNAMIC;

/*!40000 ALTER TABLE `paygate_settings` DISABLE KEYS */;
INSERT INTO `paygate_settings` (`paygate_id`, `paygate_status`, `paygate_url`, `paygate_redirection_url`, `paygate_verification_url`, `paygate_paygate_id`, `paygate_encryption_key`) VALUES
	(1, 1, 'https://secure.paygate.co.za/payweb3/initiate.trans', 'https://secure.paygate.co.za/payweb3/process.trans', 'https://secure.paygate.co.za/payweb3/query.trans', NULL, NULL),
	(2, 0, 'https://secure.paygate.co.za/payweb3/initiate.trans', 'https://secure.paygate.co.za/payweb3/process.trans', 'https://secure.paygate.co.za/payweb3/query.trans', NULL, NULL);
/*!40000 ALTER TABLE `paygate_settings` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `payments` (
  `payment_id` int(11) NOT NULL AUTO_INCREMENT,
  `payment_uid` varchar(200) CHARACTER SET utf16 DEFAULT NULL,
  `payment_added_by` int(11) NOT NULL,
  `is_customer` int(11) DEFAULT NULL,
  `invoice_id` int(11) DEFAULT NULL,
  `payment_option_id` varchar(200) CHARACTER SET utf16 DEFAULT NULL,
  `transaction_id` varchar(200) CHARACTER SET utf8mb4 DEFAULT NULL,
  `transaction_reference` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `amount_paid` float(11,2) NOT NULL,
  `payment_date_added` datetime NOT NULL,
  `payment_post_status` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`payment_id`),
  UNIQUE KEY `transaction_id` (`transaction_id`),
  KEY `transaction_id_2` (`transaction_id`(191))
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

/*!40000 ALTER TABLE `payments` DISABLE KEYS */;
/*!40000 ALTER TABLE `payments` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `payment_options` (
  `payment_option_id` int(11) NOT NULL AUTO_INCREMENT,
  `payment_option` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `payment_option_name` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `payment_option_description` longtext CHARACTER SET utf16,
  `payment_option_currencies` longtext CHARACTER SET utf16,
  `payment_option_zero_decimal_currencies` longtext CHARACTER SET utf16,
  `payment_option_online` int(11) DEFAULT NULL,
  `payment_option_added_by` int(11) DEFAULT NULL,
  `payment_option_status_id` int(11) NOT NULL DEFAULT '1',
  `payment_option_date_added` datetime DEFAULT NULL,
  PRIMARY KEY (`payment_option_id`) USING BTREE
) ENGINE=MyISAM AUTO_INCREMENT=23 DEFAULT CHARSET=latin1;

/*!40000 ALTER TABLE `payment_options` DISABLE KEYS */;
INSERT INTO `payment_options` (`payment_option_id`, `payment_option`, `payment_option_name`, `payment_option_description`, `payment_option_currencies`, `payment_option_zero_decimal_currencies`, `payment_option_online`, `payment_option_added_by`, `payment_option_status_id`, `payment_option_date_added`) VALUES
	(1, 'paypal_standard', 'PayPal Standard', NULL, 'AUD, GBP, CAD, CZK, DKK, EUR, HKD, HUF, ILS, JPY, MXN, TWD, NZD, NOK, PHP, PLN, RUB, SGD, SEK, CHF, THB, USD', NULL, 1, 1, 1, '2023-11-25 13:21:19'),
	(2, 'paypal_pro', 'PayPal Pro', NULL, 'AUD, GBP, CAD, CZK, DKK, EUR, HKD, HUF, ILS, JPY, MXN, TWD, NZD, NOK, PHP, PLN, RUB, SGD, SEK, CHF, THB, USD', NULL, 1, 1, 1, '2023-11-25 13:21:19'),
	(3, 'stripe', 'Stripe', NULL, 'USD, AED, AFN, ALL, AMD, ANG, AOA, ARS, AUD, AWG, AZN, BAM, BBD, BDT, BGN, BMD, BND, BOB, BRL, BSD, BWP, BZD, CAD, CDF, CHF, CNY, COP, CRC, CVE, CZK, DKK, DOP, DZD, EGP, ETB, EUR, FJD, FKP, GBP, GEL, GIP, GMD, GTQ, GYD, HKD, HNL, HRK, HTG, HUF, IDR, ILS, INR, ISK, JMD, KES, KGS, KHR, KYD, KZT, LAK, LBP, LKR, LRD, LSL, MAD, MDL, MKD, MMK, MNT, MOP, MRO, MUR, MVR, MWK, MXN, MYR, MZN, NAD, NGN, NIO, NOK, NPR, NZD, PAB, PEN, PGK, PHP, PKR, PLN, QAR, RON, RSD, RUB, SAR, SBD, SCR, SEK, SGD, SHP, SLL, SOS, SRD, STD, SZL, THB, TJS, TOP, TRY, TTD, TWD, TZS, UAH, UYU, UZS, WST, XCD, YER, ZAR, ZMW', 'BIF, CLP, DJF, GNF, JPY, KMF, KRW, MGA, PYG, RWF, UGX, VND, VUV, XAF, XOF, XPF', 1, 1, 1, '2023-11-25 13:21:21'),
	(4, 'authorize_net', 'Authorize.Net', NULL, 'AUD, CAD, CHF, DKK, EUR, NOK, NZD, PLN, SEK, USD', NULL, 1, 1, 1, '2023-11-25 13:21:22'),
	(5, 'pesapal', 'PesaPal', NULL, 'USD, KES, UGX, TZS, RWF', NULL, 1, 1, 1, '2023-11-25 11:39:49'),
	(6, 'free-trial', 'Free Trial', NULL, NULL, NULL, 1, 1, 1, '2023-11-25 11:39:49'),
	(7, 'flutterwave', 'Flutterwave', NULL, 'ARS,BRL,GBP,CAD,CVE,CLP,COP,CDF,EGP,EUR,GMD,GHS,GNF,KES,LRD,MWK,MXN,MAD,MZN,NGN,SOL,RWF,SLL,STD,ZAR,TZS,UGX,USD,XAF,XOF,ZMK,ZMW', NULL, 1, 1, 1, '2023-11-25 11:39:49'),
	(8, 'sslcommerz', 'SSLCOMMERZ', NULL, 'BDT', NULL, 1, 1, 1, '2023-11-25 11:39:49'),
	(9, 'esewa', 'Esewa', NULL, 'NPR', NULL, 1, 1, 1, '2023-11-25 11:39:49'),
	(10, 'instamojo', 'Instamojo', NULL, 'INR', NULL, 1, 1, 1, '2023-11-25 11:39:49'),
	(11, 'paystack', 'Paystack', NULL, 'GHS,NGN,USD,ZAR', NULL, 1, 1, 1, '2023-11-25 11:39:49'),
	(12, 'toyyibpay', 'ToyyibPay', NULL, 'MYR', NULL, 1, 1, 1, '2023-11-25 11:39:49'),
	(13, 'aamarpay', 'AamarPay', NULL, 'BDT', NULL, 1, 1, 1, '2023-11-25 11:39:49'),
	(14, 'hyperpay', 'Hyperpay', NULL, 'EUR', NULL, 1, 1, 1, '2023-11-25 11:39:49'),
	(15, 'paddle', 'Paddle', NULL, 'USD,EUR,GBP,ARS,AUD,BRL,CAD,CHF,COP,CNY,CZK,DKK,HKD,HUF,INR,ILS,MXN,NOK,NZD,PLN,RUB,SEK,SGD,THB,TRY,TWD,UAH,ZAR', 'JPY,KRW', 1, 1, 1, '2023-11-25 11:39:49'),
	(16, 'paytr', 'PayTR', NULL, 'TL, EUR, USD, GBP, RUB', NULL, 1, 1, 1, '2023-11-25 11:39:49'),
	(17, 'iyzico', 'Iyzico', NULL, 'CHF,EUR,GBP,IRR,NOK,RUB,TRY,USD', NULL, 1, 1, 1, '2022-05-25 11:39:49'),
	(18, 'tap', 'Tap', NULL, 'AED,BHD,EGP,EUR,GBP,KWD,OMR,QAR,SAR,USD', NULL, 1, 1, 1, '2022-05-25 11:39:49'),
	(19, 'paygate', 'Paygate', NULL, 'ZAR,EUR,USD', NULL, 1, 1, 1, '2022-05-25 11:39:49'),
	(20, 'twocheckout', '2Checkout', NULL, 'USD, AED, AFN, ALL, AMD, ANG, AOA, ARS, AUD, AWG, AZN, BAM, BBD, BDT, BGN, BMD, BND, BOB, BRL, BSD, BWP, BZD, CAD, CDF, CHF, CNY, COP, CRC, CVE, CZK, DKK, DOP, DZD, EGP, ETB, EUR, FJD, FKP, GBP, GEL, GIP, GMD, GTQ, GYD, HKD, HNL, HRK, HTG, HUF, IDR, ILS, INR, ISK, JMD, KES, KGS, KHR, KYD, KZT, LAK, LBP, LKR, LRD, LSL, MAD, MDL, MKD, MMK, MNT, MOP, MRO, MUR, MVR, MWK, MXN, MYR, MZN, NAD, NGN, NIO, NOK, NPR, NZD, PAB, PEN, PGK, PHP, PKR, PLN, QAR, RON, RSD, RUB, SAR, SBD, SCR, SEK, SGD, SHP, SLL, SOS, SRD, STD, SZL, THB, TJS, TOP, TRY, TTD, TWD, TZS, UAH, UYU, UZS, WST, XCD, YER, ZAR, ZMW', NULL, 1, 1, 1, '2022-05-25 11:39:49'),
	(21, 'midtrans', 'Midtrans', NULL, 'IDR', NULL, 1, 1, 1, '2022-05-25 11:39:49'),
	(22, 'tripay', 'Tripay', NULL, 'IDR', NULL, 1, 1, 1, '2022-05-25 11:39:49');
/*!40000 ALTER TABLE `payment_options` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `payouts` (
  `payout_id` int(11) NOT NULL AUTO_INCREMENT,
  `payout_uid` varchar(50) CHARACTER SET utf16 DEFAULT NULL,
  `payout_name` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `user_id` int(11) NOT NULL,
  `payout_mode_id` int(11) DEFAULT NULL,
  `payout_address` longtext CHARACTER SET utf16,
  `payout_transaction_id` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `payout_amount` float(11,2) NOT NULL,
  `payout_status_id` int(11) NOT NULL DEFAULT '1',
  `commission_rate` float(11,2) DEFAULT '1.00',
  `payout_note` longtext CHARACTER SET utf16,
  `payout_date_paid` datetime DEFAULT NULL,
  `payout_date_added` datetime NOT NULL,
  PRIMARY KEY (`payout_id`) USING BTREE
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

/*!40000 ALTER TABLE `payouts` DISABLE KEYS */;
/*!40000 ALTER TABLE `payouts` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `payout_modes` (
  `payout_mode_id` int(11) NOT NULL AUTO_INCREMENT,
  `payout_mode_name` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `payout_mode_minimum` float(11,2) DEFAULT '0.00',
  `payout_mode_status` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`payout_mode_id`) USING BTREE
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

/*!40000 ALTER TABLE `payout_modes` DISABLE KEYS */;
/*!40000 ALTER TABLE `payout_modes` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `payout_status` (
  `payout_status_id` int(11) NOT NULL AUTO_INCREMENT,
  `payout_status` varchar(200) CHARACTER SET utf16 DEFAULT NULL,
  `payout_status_colour` varchar(200) CHARACTER SET utf16 DEFAULT NULL,
  `payout_status_color_code` varchar(200) CHARACTER SET utf16 DEFAULT NULL,
  `payout_status_fa` varchar(200) CHARACTER SET utf16 DEFAULT NULL,
  PRIMARY KEY (`payout_status_id`) USING BTREE
) ENGINE=MyISAM AUTO_INCREMENT=5 DEFAULT CHARSET=latin1;

/*!40000 ALTER TABLE `payout_status` DISABLE KEYS */;
INSERT INTO `payout_status` (`payout_status_id`, `payout_status`, `payout_status_colour`, `payout_status_color_code`, `payout_status_fa`) VALUES
	(1, 'pending', 'info', '#007AFF', 'clock-o'),
	(2, 'paid', 'success', '#1C841B', 'check'),
	(3, 'declined', 'danger', '#DE1D30', 'calendar'),
	(4, 'cancelled', 'dark', '#555555', 'close');
/*!40000 ALTER TABLE `payout_status` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `paypal_pro_settings` (
  `paypal_pro_id` int(11) NOT NULL AUTO_INCREMENT,
  `paypal_pro_status` int(11) DEFAULT NULL,
  `paypal_pro_endpoint` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `paypal_pro_url` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `paypal_pro_username` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `paypal_pro_password` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `paypal_pro_signature` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  PRIMARY KEY (`paypal_pro_id`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=latin1 ROW_FORMAT=COMPACT;

/*!40000 ALTER TABLE `paypal_pro_settings` DISABLE KEYS */;
INSERT INTO `paypal_pro_settings` (`paypal_pro_id`, `paypal_pro_status`, `paypal_pro_endpoint`, `paypal_pro_url`, `paypal_pro_username`, `paypal_pro_password`, `paypal_pro_signature`) VALUES
	(1, 1, 'https://api-3t.paypal.com/nvp', 'https://www.paypal.com/webscr&cmd=_express-checkout&token=', NULL, NULL, NULL),
	(2, 0, 'https://api-3t.sandbox.paypal.com/nvp', 'https://www.sandbox.paypal.com/webscr&cmd=_express-checkout&token=', NULL, NULL, NULL);
/*!40000 ALTER TABLE `paypal_pro_settings` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `paypal_standard_settings` (
  `paypal_standard_id` int(11) NOT NULL AUTO_INCREMENT,
  `paypal_standard_status` int(11) DEFAULT NULL,
  `paypal_standard_url` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `paypal_standard_email` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  PRIMARY KEY (`paypal_standard_id`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=latin1;

/*!40000 ALTER TABLE `paypal_standard_settings` DISABLE KEYS */;
INSERT INTO `paypal_standard_settings` (`paypal_standard_id`, `paypal_standard_status`, `paypal_standard_url`, `paypal_standard_email`) VALUES
	(1, 1, 'https://www.paypal.com/cgi-bin/webscr', NULL),
	(2, 0, 'https://www.sandbox.paypal.com/cgi-bin/webscr', NULL);
/*!40000 ALTER TABLE `paypal_standard_settings` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `paystack_settings` (
  `paystack_id` int(11) NOT NULL AUTO_INCREMENT,
  `paystack_status` int(11) DEFAULT NULL,
  `paystack_url` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `paystack_verification_url` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `paystack_secret_key` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `paystack_public_key` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  PRIMARY KEY (`paystack_id`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=latin1 ROW_FORMAT=DYNAMIC;

/*!40000 ALTER TABLE `paystack_settings` DISABLE KEYS */;
INSERT INTO `paystack_settings` (`paystack_id`, `paystack_status`, `paystack_url`, `paystack_verification_url`, `paystack_secret_key`, `paystack_public_key`) VALUES
	(1, 1, 'https://api.paystack.co/transaction/initialize', 'https://api.paystack.co/transaction/verify/', NULL, NULL),
	(2, 0, 'https://api.paystack.co/transaction/initialize', 'https://api.paystack.co/transaction/verify/', NULL, NULL);
/*!40000 ALTER TABLE `paystack_settings` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `paytr_settings` (
  `paytr_id` int(11) NOT NULL AUTO_INCREMENT,
  `paytr_status` int(11) DEFAULT NULL,
  `paytr_merchant_id` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `paytr_merchant_key` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `paytr_merchant_salt` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  PRIMARY KEY (`paytr_id`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=latin1;

/*!40000 ALTER TABLE `paytr_settings` DISABLE KEYS */;
INSERT INTO `paytr_settings` (`paytr_id`, `paytr_status`, `paytr_merchant_id`, `paytr_merchant_key`, `paytr_merchant_salt`) VALUES
	(1, 1, NULL, NULL, NULL),
	(2, 0, NULL, NULL, NULL);
/*!40000 ALTER TABLE `paytr_settings` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `pesapal_settings` (
  `pesapal_id` int(11) NOT NULL AUTO_INCREMENT,
  `pesapal_status` int(11) DEFAULT NULL,
  `pesapal_authentication_url` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `pesapal_order_request_url` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `pesapal_transaction_status_url` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `pesapal_notification_id` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `pesapal_consumer_key` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `pesapal_consumer_secret` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  PRIMARY KEY (`pesapal_id`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=latin1;

/*!40000 ALTER TABLE `pesapal_settings` DISABLE KEYS */;
INSERT INTO `pesapal_settings` (`pesapal_id`, `pesapal_status`, `pesapal_authentication_url`, `pesapal_order_request_url`, `pesapal_transaction_status_url`, `pesapal_notification_id`, `pesapal_consumer_key`, `pesapal_consumer_secret`) VALUES
	(1, 1, 'https://pay.pesapal.com/v3/api/Auth/RequestToken', 'https://pay.pesapal.com/v3/api/Transactions/SubmitOrderRequest', 'https://pay.pesapal.com/v3/api/Transactions/GetTransactionStatus', NULL, NULL, NULL),
	(2, 0, 'https://cybqa.pesapal.com/pesapalv3/api/Auth/RequestToken', 'https://cybqa.pesapal.com/pesapalv3/api/Transactions/SubmitOrderRequest', 'https://cybqa.pesapal.com/pesapalv3/api/Transactions/GetTransactionStatus', NULL, NULL, NULL);
/*!40000 ALTER TABLE `pesapal_settings` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `posts` (
  `post_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `post_added_by` bigint(20) unsigned NOT NULL DEFAULT '1',
  `post_date_added` datetime DEFAULT NULL,
  `post_description` longtext NOT NULL,
  `post_title` varchar(255) NOT NULL DEFAULT '',
  `post_slug` varchar(255) DEFAULT NULL,
  `post_status_id` int(11) NOT NULL DEFAULT '1',
  `comment_status` varchar(20) NOT NULL DEFAULT 'open',
  `post_category_id` int(11) DEFAULT NULL,
  `post_password` varchar(20) NOT NULL DEFAULT '',
  `post_featured_image` varchar(255) NOT NULL DEFAULT '',
  `to_ping` text,
  `pinged` text,
  `post_modified` datetime DEFAULT NULL,
  `post_modified_gmt` datetime DEFAULT NULL,
  `post_content_filtered` longtext,
  `post_parent` bigint(20) unsigned NOT NULL DEFAULT '0',
  `guid` varchar(255) NOT NULL DEFAULT '',
  `menu_order` int(11) NOT NULL DEFAULT '0',
  `post_type` varchar(20) NOT NULL DEFAULT 'post',
  `post_mime_type` varchar(100) NOT NULL DEFAULT '',
  `comment_count` bigint(20) NOT NULL DEFAULT '0',
  PRIMARY KEY (`post_id`) USING BTREE,
  KEY `post_parent` (`post_parent`) USING BTREE,
  KEY `post_author` (`post_added_by`) USING BTREE,
  KEY `type_status_date` (`post_type`,`post_status_id`,`post_date_added`,`post_id`) USING BTREE
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*!40000 ALTER TABLE `posts` DISABLE KEYS */;
/*!40000 ALTER TABLE `posts` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `post_categories` (
  `post_category_id` int(11) NOT NULL AUTO_INCREMENT,
  `post_category_added_by` int(11) NOT NULL,
  `post_category_name` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `post_category_slug` longtext CHARACTER SET utf16,
  `post_category_status_id` int(11) NOT NULL DEFAULT '1',
  `post_category_date_added` datetime DEFAULT NULL,
  PRIMARY KEY (`post_category_id`) USING BTREE
) ENGINE=MyISAM DEFAULT CHARSET=latin1 ROW_FORMAT=DYNAMIC;

/*!40000 ALTER TABLE `post_categories` DISABLE KEYS */;
/*!40000 ALTER TABLE `post_categories` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `post_comments` (
  `post_comment_id` int(11) NOT NULL AUTO_INCREMENT,
  `post_comment_added_by` int(11) NOT NULL,
  `post_id` int(11) NOT NULL,
  `is_customer` int(11) DEFAULT NULL,
  `post_comment_parent_id` int(11) DEFAULT NULL,
  `post_comment` longtext CHARACTER SET utf16,
  `post_comment_status_id` int(11) NOT NULL DEFAULT '1',
  `post_comment_date_added` datetime DEFAULT NULL,
  PRIMARY KEY (`post_comment_id`) USING BTREE
) ENGINE=MyISAM DEFAULT CHARSET=latin1 ROW_FORMAT=DYNAMIC;

/*!40000 ALTER TABLE `post_comments` DISABLE KEYS */;
/*!40000 ALTER TABLE `post_comments` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `private_packages` (
  `private_package_id` int(11) NOT NULL AUTO_INCREMENT,
  `package_id` int(11) DEFAULT NULL,
  `user_id` int(11) DEFAULT NULL,
  PRIMARY KEY (`private_package_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

/*!40000 ALTER TABLE `private_packages` DISABLE KEYS */;
/*!40000 ALTER TABLE `private_packages` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `sendgrid_settings` (
  `sendgrid_id` int(11) NOT NULL AUTO_INCREMENT,
  `sendgrid_api_key` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  PRIMARY KEY (`sendgrid_id`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=latin1;

/*!40000 ALTER TABLE `sendgrid_settings` DISABLE KEYS */;
INSERT INTO `sendgrid_settings` (`sendgrid_id`, `sendgrid_api_key`) VALUES
	(1, NULL);
/*!40000 ALTER TABLE `sendgrid_settings` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `sessions` (
  `session_id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(11) DEFAULT NULL,
  `session_access_token` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `session_access_token_expiry` datetime DEFAULT NULL,
  `session_refresh_token` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `session_refresh_token_expiry` datetime DEFAULT NULL,
  `redirect_to` varchar(256) CHARACTER SET utf16 DEFAULT NULL,
  PRIMARY KEY (`session_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

/*!40000 ALTER TABLE `sessions` DISABLE KEYS */;
/*!40000 ALTER TABLE `sessions` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `smtp_settings` (
  `smtp_id` int(11) NOT NULL AUTO_INCREMENT,
  `smtp_host` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `smtp_encryption` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `smtp_username` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `smtp_password` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `smtp_port` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  PRIMARY KEY (`smtp_id`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=latin1;

/*!40000 ALTER TABLE `smtp_settings` DISABLE KEYS */;
INSERT INTO `smtp_settings` (`smtp_id`, `smtp_host`, `smtp_encryption`, `smtp_username`, `smtp_password`, `smtp_port`) VALUES
	(1, NULL, NULL, NULL, NULL, NULL);
/*!40000 ALTER TABLE `smtp_settings` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `social_profiles` (
  `social_profile_id` int(11) NOT NULL AUTO_INCREMENT,
  `social_profile_added_by` int(11) DEFAULT NULL,
  `social_profile_name` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `social_profile_slug` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `social_profile_icon` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `social_profile_link` longtext CHARACTER SET utf16,
  `social_profile_status_id` int(11) NOT NULL,
  `social_profile_date_added` datetime DEFAULT NULL,
  PRIMARY KEY (`social_profile_id`) USING BTREE
) ENGINE=MyISAM DEFAULT CHARSET=latin1 ROW_FORMAT=DYNAMIC;

/*!40000 ALTER TABLE `social_profiles` DISABLE KEYS */;
/*!40000 ALTER TABLE `social_profiles` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `sslcommerz_settings` (
  `sslcommerz_id` int(11) NOT NULL AUTO_INCREMENT,
  `sslcommerz_status` int(11) NOT NULL,
  `sslcommerz_endpoint_url` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `sslcommerz_validation_url` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `sslcommerz_store_id` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `sslcommerz_password` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  PRIMARY KEY (`sslcommerz_id`) USING BTREE
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=latin1 ROW_FORMAT=DYNAMIC;

/*!40000 ALTER TABLE `sslcommerz_settings` DISABLE KEYS */;
INSERT INTO `sslcommerz_settings` (`sslcommerz_id`, `sslcommerz_status`, `sslcommerz_endpoint_url`, `sslcommerz_validation_url`, `sslcommerz_store_id`, `sslcommerz_password`) VALUES
	(1, 1, 'https://securepay.sslcommerz.com/gwprocess/v4/api.php', 'https://securepay.sslcommerz.com/validator/api/validationserverAPI.php', NULL, NULL),
	(2, 0, 'https://sandbox.sslcommerz.com/gwprocess/v4/api.php', 'https://sandbox.sslcommerz.com/validator/api/validationserverAPI.php', NULL, NULL);
/*!40000 ALTER TABLE `sslcommerz_settings` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `stripe_settings` (
  `stripe_id` int(11) NOT NULL AUTO_INCREMENT,
  `stripe_status` int(11) DEFAULT NULL,
  `stripe_secret_key` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `stripe_publishable_key` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  PRIMARY KEY (`stripe_id`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=latin1;

/*!40000 ALTER TABLE `stripe_settings` DISABLE KEYS */;
INSERT INTO `stripe_settings` (`stripe_id`, `stripe_status`, `stripe_secret_key`, `stripe_publishable_key`) VALUES
	(1, 1, NULL, NULL),
	(2, 0, NULL, NULL);
/*!40000 ALTER TABLE `stripe_settings` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `subscribers` (
  `subscriber_id` int(11) NOT NULL AUTO_INCREMENT,
  `subscriber_email` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `subscriber_hash` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `subscriber_status_id` int(11) NOT NULL DEFAULT '1',
  `subscriber_date_added` datetime DEFAULT NULL,
  PRIMARY KEY (`subscriber_id`) USING BTREE
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

/*!40000 ALTER TABLE `subscribers` DISABLE KEYS */;
/*!40000 ALTER TABLE `subscribers` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `subscriptions` (
  `subscription_id` int(11) NOT NULL AUTO_INCREMENT,
  `subscription_uid` varchar(50) CHARACTER SET utf16 DEFAULT NULL,
  `user_id` int(11) NOT NULL,
  `subscription_added_by` int(11) NOT NULL,
  `subscription_name` varchar(100) CHARACTER SET utf16 DEFAULT NULL,
  `package_id` int(11) DEFAULT NULL,
  `order_code` varchar(255) DEFAULT NULL,
  `payment_option_id` varchar(200) CHARACTER SET utf16 DEFAULT NULL,
  `transaction_id` varchar(200) CHARACTER SET utf16 DEFAULT NULL,
  `transaction_reference` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `transaction_status` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `transaction_session_id` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `subscription_items` longtext CHARACTER SET utf16,
  `subscription_cost` float(11,2) NOT NULL,
  `subscription_duration` int(11) NOT NULL,
  `subscription_duration_type` varchar(100) CHARACTER SET utf16 DEFAULT NULL,
  `subscription_start_date` datetime NOT NULL,
  `subscription_end_date` datetime NOT NULL,
  `subscription_status_id` int(11) DEFAULT '1',
  `subscription_date_added` datetime NOT NULL,
  `subscription_date_activated` datetime DEFAULT NULL,
  `subscription_post_status` int(11) NOT NULL DEFAULT '1',
  PRIMARY KEY (`subscription_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

/*!40000 ALTER TABLE `subscriptions` DISABLE KEYS */;
/*!40000 ALTER TABLE `subscriptions` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `subscription_status` (
  `subscription_status_id` int(11) NOT NULL AUTO_INCREMENT,
  `subscription_status` varchar(200) CHARACTER SET utf16 DEFAULT NULL,
  `subscription_status_colour` varchar(200) CHARACTER SET utf16 DEFAULT NULL,
  `subscription_status_fa` varchar(200) CHARACTER SET utf16 DEFAULT NULL,
  PRIMARY KEY (`subscription_status_id`)
) ENGINE=MyISAM AUTO_INCREMENT=5 DEFAULT CHARSET=latin1;

/*!40000 ALTER TABLE `subscription_status` DISABLE KEYS */;
INSERT INTO `subscription_status` (`subscription_status_id`, `subscription_status`, `subscription_status_colour`, `subscription_status_fa`) VALUES
	(1, 'pending', 'primary', 'clock-o'),
	(2, 'approved', 'success', 'check'),
	(3, 'cancelled', 'danger', 'close'),
	(4, 'expired', 'warning', 'exclamation');
/*!40000 ALTER TABLE `subscription_status` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `supported_currencies` (
  `supported_currency_id` int(11) NOT NULL AUTO_INCREMENT,
  `supported_currency_name` varchar(200) CHARACTER SET utf8 DEFAULT NULL,
  `supported_currency_iso` varchar(3) CHARACTER SET utf8 NOT NULL,
  `supported_currency_symbol` varchar(200) CHARACTER SET utf8 DEFAULT NULL,
  `supported_currency_value` float(11,4) DEFAULT NULL,
  `accept_currency` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`supported_currency_id`)
) ENGINE=InnoDB AUTO_INCREMENT=163 DEFAULT CHARSET=latin1;

/*!40000 ALTER TABLE `supported_currencies` DISABLE KEYS */;
INSERT INTO `supported_currencies` (`supported_currency_id`, `supported_currency_name`, `supported_currency_iso`, `supported_currency_symbol`, `supported_currency_value`, `accept_currency`) VALUES
	(1, 'Leke', 'ALL', 'Lek', NULL, 0),
	(2, 'Dollars', 'USD', '$', NULL, 0),
	(3, 'Afghanis', 'AFN', '؋', NULL, 1),
	(4, 'Pesos', 'ARS', '$', NULL, 1),
	(5, 'Guilders', 'AWG', 'ƒ', NULL, 1),
	(6, 'Dollars', 'AUD', '$', NULL, 1),
	(7, 'New Manats', 'AZN', 'ман', NULL, 1),
	(8, 'Dollars', 'BSD', '$', NULL, 1),
	(9, 'Dollars', 'BBD', '$', NULL, 1),
	(10, 'Rubles', 'BYR', 'p.', NULL, 0),
	(11, 'Euro', 'EUR', '€', NULL, 1),
	(12, 'Dollars', 'BZD', 'BZ$', NULL, 1),
	(13, 'Dollars', 'BMD', '$', NULL, 1),
	(14, 'Bolivianos', 'BOB', '$b', NULL, 1),
	(15, 'Convertible Marka', 'BAM', 'KM', NULL, 1),
	(16, 'Pula', 'BWP', 'P', NULL, 1),
	(17, 'Leva', 'BGN', 'лв', NULL, 1),
	(18, 'Reais', 'BRL', 'R$', NULL, 1),
	(19, 'Pounds', 'GBP', '£', NULL, 1),
	(20, 'Dollars', 'BND', '$', NULL, 1),
	(21, 'Riels', 'KHR', '៛', NULL, 1),
	(22, 'Dollars', 'CAD', '$', NULL, 1),
	(23, 'Dollars', 'KYD', '$', NULL, 1),
	(24, 'Pesos', 'CLP', '$', NULL, 1),
	(25, 'Yuan Renminbi', 'CNY', '¥', NULL, 1),
	(26, 'Pesos', 'COP', '$', NULL, 1),
	(27, 'Colón', 'CRC', '₡', NULL, 1),
	(28, 'Kuna', 'HRK', 'kn', NULL, 1),
	(29, 'Pesos', 'CUP', '₱', NULL, 1),
	(30, 'Koruny', 'CZK', 'Kč', NULL, 1),
	(31, 'Kroner', 'DKK', 'kr', NULL, 1),
	(32, 'Pesos', 'DOP', 'RD$', NULL, 1),
	(33, 'Dollars', 'XCD', '$', NULL, 1),
	(34, 'Pounds', 'EGP', '£', NULL, 1),
	(35, 'Colones', 'SVC', '$', NULL, 1),
	(36, 'Pounds', 'FKP', '£', NULL, 1),
	(37, 'Dollars', 'FJD', '$', NULL, 1),
	(38, 'Cedis', 'GHC', '¢', NULL, 1),
	(39, 'Pounds', 'GIP', '£', NULL, 1),
	(40, 'Quetzales', 'GTQ', 'Q', NULL, 1),
	(41, 'Pounds', 'GGP', '£', NULL, 1),
	(42, 'Dollars', 'GYD', '$', NULL, 1),
	(43, 'Lempiras', 'HNL', 'L', NULL, 1),
	(44, 'Dollars', 'HKD', '$', NULL, 1),
	(45, 'Forint', 'HUF', 'Ft', NULL, 1),
	(46, 'Kronur', 'ISK', 'kr', NULL, 1),
	(47, 'Rupees', 'INR', '₹', NULL, 1),
	(48, 'Rupiahs', 'IDR', 'Rp', NULL, 1),
	(49, 'Rials', 'IRR', '﷼', NULL, 1),
	(50, 'Pounds', 'IMP', '£', NULL, 1),
	(51, 'New Shekels', 'ILS', '₪', NULL, 1),
	(52, 'Dollars', 'JMD', 'J$', NULL, 1),
	(53, 'Yen', 'JPY', '¥', NULL, 1),
	(54, 'Pounds', 'JEP', '£', NULL, 1),
	(55, 'Tenge', 'KZT', 'лв', NULL, 1),
	(56, 'Won', 'KPW', '₩', NULL, 1),
	(57, 'Won', 'KRW', '₩', NULL, 1),
	(58, 'Soms', 'KGS', 'лв', NULL, 1),
	(59, 'Kips', 'LAK', '₭', NULL, 1),
	(60, 'Lati', 'LVL', 'Ls', NULL, 1),
	(61, 'Pounds', 'LBP', '£', NULL, 1),
	(62, 'Dollars', 'LRD', '$', NULL, 1),
	(63, 'Switzerland Francs', 'CHF', 'CHF', NULL, 1),
	(64, 'Litai', 'LTL', 'Lt', NULL, 0),
	(65, 'Denars', 'MKD', 'ден', NULL, 1),
	(66, 'Ringgits', 'MYR', 'RM', NULL, 1),
	(67, 'Rupees', 'MUR', '₨', NULL, 1),
	(68, 'Pesos', 'MXN', '$', NULL, 1),
	(69, 'Tugriks', 'MNT', '₮', NULL, 1),
	(70, 'Meticais', 'MZN', 'MT', NULL, 1),
	(71, 'Dollars', 'NAD', '$', NULL, 1),
	(72, 'Rupees', 'NPR', '₨', NULL, 1),
	(73, 'Guilders', 'ANG', 'ƒ', NULL, 1),
	(74, 'Dollars', 'NZD', '$', NULL, 1),
	(75, 'Cordobas', 'NIO', 'C$', NULL, 1),
	(76, 'Nairas', 'NGN', '₦', NULL, 0),
	(77, 'Krone', 'NOK', 'kr', NULL, 1),
	(78, 'Rials', 'OMR', '﷼', NULL, 1),
	(79, 'Rupees', 'PKR', '₨', NULL, 1),
	(80, 'Balboa', 'PAB', 'B/.', NULL, 1),
	(81, 'Guarani', 'PYG', 'Gs', NULL, 1),
	(82, 'Nuevos Soles', 'PEN', 'S/.', NULL, 1),
	(83, 'Pesos', 'PHP', 'Php', NULL, 1),
	(84, 'Zlotych', 'PLN', 'zł', NULL, 1),
	(85, 'Rials', 'QAR', '﷼', NULL, 1),
	(86, 'New Lei', 'RON', 'lei', NULL, 1),
	(87, 'Rubles', 'RUB', 'руб', NULL, 1),
	(88, 'Pounds', 'SHP', '£', NULL, 1),
	(89, 'Riyals', 'SAR', '﷼', NULL, 1),
	(90, 'Dinars', 'RSD', 'Дин.', NULL, 1),
	(91, 'Rupees', 'SCR', '₨', NULL, 1),
	(92, 'Dollars', 'SGD', '$', NULL, 1),
	(93, 'Dollars', 'SBD', '$', NULL, 1),
	(94, 'Shillings', 'SOS', 'S', NULL, 1),
	(95, 'Rand', 'ZAR', 'R', NULL, 1),
	(96, 'Rupees', 'LKR', '₨', NULL, 1),
	(97, 'Kronor', 'SEK', 'kr', NULL, 1),
	(98, 'Dollars', 'SRD', '$', NULL, 1),
	(99, 'Pounds', 'SYP', '£', NULL, 1),
	(100, 'New Dollars', 'TWD', 'NT$', NULL, 1),
	(101, 'Baht', 'THB', '฿', NULL, 1),
	(102, 'Dollars', 'TTD', 'TT$', NULL, 1),
	(103, 'Lira', 'TRY', '₺', NULL, 1),
	(104, 'Liras', 'TRL', '£', NULL, 1),
	(105, 'Dollars', 'TVD', '$', NULL, 1),
	(106, 'Hryvnia', 'UAH', '₴', NULL, 1),
	(107, 'Pesos', 'UYU', '$U', NULL, 1),
	(108, 'Sums', 'UZS', 'лв', NULL, 1),
	(109, 'Bolivares Fuertes', 'VEF', 'Bs', NULL, 1),
	(110, 'Dong', 'VND', '₫', NULL, 1),
	(111, 'Rials', 'YER', '﷼', NULL, 1),
	(112, 'Zimbabwe Dollars', 'ZWD', 'Z$', NULL, 1),
	(113, 'Algerian dinar', 'DZD', 'DA', NULL, 1),
	(114, 'Angolan kwanza', 'AOA', 'Kz', NULL, 1),
	(115, 'Armenian dram', 'AMD', '֏', NULL, 1),
	(116, 'Bahraini dinar', 'BHD', 'BD', NULL, 1),
	(117, 'Bangladeshi taka', 'BDT', '৳', NULL, 1),
	(118, 'West African CFA franc', 'XOF', 'CFA', NULL, 1),
	(119, 'Burundian franc', 'BIF', 'FBu', NULL, 1),
	(120, 'Central African CFA franc', 'XAF', 'FCFA', NULL, 1),
	(121, 'Cape Verdean escudo', 'CVE', 'Esc', NULL, 1),
	(122, 'Comorian franc', 'KMF', 'CF', NULL, 1),
	(123, 'Djiboutian franc', 'DJF', 'Fdj', NULL, 1),
	(124, 'Dominican peso', 'DOP', 'RD$', NULL, 1),
	(125, 'Eritrean nakfa', 'ERN', 'Nkf', NULL, 1),
	(126, 'Ethiopian birr', 'ETB', 'Br', NULL, 1),
	(127, 'CFP franc', 'XPF', '₣', NULL, 1),
	(128, 'Gambian dalasi', 'GMD', 'D', NULL, 1),
	(129, 'Georgian lari', 'GEL', 'ლ', NULL, 1),
	(130, 'Ghanaian cedi', 'GHS', 'GH₵', NULL, 1),
	(131, 'Guinean franc', 'GNF', 'FG', NULL, 1),
	(132, 'Iraqi dinar', 'IQD', 'ع.د', NULL, 1),
	(133, 'Jordanian dinar', 'JOD', 'د.ا', NULL, 1),
	(134, 'Kenyan shilling', 'KES', 'Ksh', NULL, 1),
	(135, 'Kuwaiti dinar', 'KWD', 'د.ك', NULL, 1),
	(136, 'Libyan dinar', 'LYD', 'ل.د', NULL, 1),
	(137, 'Macanese pataca', 'MOP', 'MOP$', NULL, 1),
	(138, 'Malagasy ariary', 'MGA', 'Ar', NULL, 1),
	(139, 'Malawian kwacha', 'MWK', 'MK', NULL, 1),
	(140, 'Maldivian rufiyaa', 'MVR', 'Rf', NULL, 1),
	(141, 'Mauritanian ouguiya', 'MRO', 'UM', NULL, 0),
	(142, 'Moldovan leu', 'MDL', 'L', NULL, 1),
	(143, 'Moroccan dirham', 'MAD', 'MAD', NULL, 1),
	(144, 'Myanmar kyat', 'MMK', 'K', NULL, 1),
	(145, 'Papua New Guinean kina', 'PGK', 'K', NULL, 1),
	(146, 'Rwandan franc', 'RWF', 'R₣', NULL, 1),
	(147, 'Samoan tālā', 'WST', 'WS$', NULL, 1),
	(148, 'São Tomé and Príncipe dobra', 'STD', 'Db', NULL, 1),
	(149, 'Sierra Leonean leone', 'SLL', 'Le', NULL, 1),
	(150, 'South Sudanese pound', 'SSP', '£', NULL, 1),
	(151, 'Sudanese pound', 'SDG', 'ج.س', NULL, 1),
	(152, 'Swazi lilangeni', 'SZL', 'L', NULL, 1),
	(153, 'Tajikistani somoni', 'TJS', 'ЅM', NULL, 1),
	(154, 'Tanzanian shilling', 'TZS', 'TSh', NULL, 1),
	(155, 'Tongan paʻanga', 'TOP', 'T$', NULL, 1),
	(156, 'Tunisian dinar', 'TND', 'DT', NULL, 1),
	(157, 'Turkmenistani manat', 'TMT', 'T', NULL, 1),
	(158, 'Ugandan shilling', 'UGX', 'USh', NULL, 1),
	(159, 'United Arab Emirates dirham', 'AED', 'د.إ', NULL, 1),
	(160, 'Vanuatu vatu', 'VUV', 'VT', NULL, 1),
	(161, 'Zambian kwacha', 'ZMW', 'ZK', NULL, 1),
	(162, 'Zimbabwean dollar', 'ZWL', '$', NULL, 1);
/*!40000 ALTER TABLE `supported_currencies` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `supported_datetime_formats` (
  `supported_datetime_format_id` int(11) NOT NULL AUTO_INCREMENT,
  `supported_datetime_format` varchar(200) CHARACTER SET utf16 DEFAULT NULL,
  PRIMARY KEY (`supported_datetime_format_id`)
) ENGINE=MyISAM AUTO_INCREMENT=7 DEFAULT CHARSET=latin1;

/*!40000 ALTER TABLE `supported_datetime_formats` DISABLE KEYS */;
INSERT INTO `supported_datetime_formats` (`supported_datetime_format_id`, `supported_datetime_format`) VALUES
	(1, 'Y-m-d H:i:s'),
	(2, 'd-m-Y H:i:s'),
	(3, 'Y-m-d g:i a'),
	(4, 'd-m-Y g:i a'),
	(5, 'j F Y g:i a'),
	(6, 'custom');
/*!40000 ALTER TABLE `supported_datetime_formats` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `supported_date_formats` (
  `supported_date_format_id` int(11) NOT NULL AUTO_INCREMENT,
  `supported_date_format` varchar(200) CHARACTER SET utf16 DEFAULT NULL,
  PRIMARY KEY (`supported_date_format_id`)
) ENGINE=MyISAM AUTO_INCREMENT=6 DEFAULT CHARSET=latin1;

/*!40000 ALTER TABLE `supported_date_formats` DISABLE KEYS */;
INSERT INTO `supported_date_formats` (`supported_date_format_id`, `supported_date_format`) VALUES
	(1, 'Y-m-d'),
	(2, 'd-m-Y'),
	(3, 'j F Y'),
	(4, 'j M Y'),
	(5, 'custom');
/*!40000 ALTER TABLE `supported_date_formats` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `tap_settings` (
  `tap_id` int(11) NOT NULL AUTO_INCREMENT,
  `tap_status` int(11) DEFAULT NULL,
  `tap_url` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `tap_secret_key` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `tap_publishable_key` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `tap_encryption_key` longtext CHARACTER SET utf16,
  PRIMARY KEY (`tap_id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=latin1;

/*!40000 ALTER TABLE `tap_settings` DISABLE KEYS */;
INSERT INTO `tap_settings` (`tap_id`, `tap_status`, `tap_url`, `tap_secret_key`, `tap_publishable_key`, `tap_encryption_key`) VALUES
	(1, 1, 'https://api.tap.company', NULL, NULL, NULL),
	(2, 0, 'https://api.tap.company', NULL, NULL, NULL);
/*!40000 ALTER TABLE `tap_settings` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `themes` (
  `theme_id` int(11) NOT NULL AUTO_INCREMENT,
  `theme` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `theme_status_id` int(11) DEFAULT NULL,
  PRIMARY KEY (`theme_id`) USING BTREE
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=latin1 ROW_FORMAT=DYNAMIC;

/*!40000 ALTER TABLE `themes` DISABLE KEYS */;
INSERT INTO `themes` (`theme_id`, `theme`, `theme_status_id`) VALUES
	(1, 'embedai', 1);
/*!40000 ALTER TABLE `themes` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `tickets` (
  `ticket_id` int(11) NOT NULL AUTO_INCREMENT,
  `ticket_added_by` int(11) DEFAULT NULL,
  `ticket_priority_id` int(11) NOT NULL DEFAULT '1',
  `ticket_status_id` int(11) NOT NULL DEFAULT '1',
  `ticket_subject` varchar(50) CHARACTER SET utf16 DEFAULT NULL,
  `ticket_description` longtext CHARACTER SET utf16,
  `ticket_date_added` datetime NOT NULL,
  PRIMARY KEY (`ticket_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

/*!40000 ALTER TABLE `tickets` DISABLE KEYS */;
/*!40000 ALTER TABLE `tickets` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `ticket_priority` (
  `ticket_priority_id` int(11) NOT NULL AUTO_INCREMENT,
  `ticket_priority_name` varchar(50) CHARACTER SET utf16 DEFAULT NULL,
  `ticket_priority_colour` varchar(7) CHARACTER SET utf16 DEFAULT NULL,
  `ticket_priority_colour_code` varchar(7) CHARACTER SET utf16 DEFAULT NULL,
  PRIMARY KEY (`ticket_priority_id`)
) ENGINE=MyISAM AUTO_INCREMENT=4 DEFAULT CHARSET=latin1;

/*!40000 ALTER TABLE `ticket_priority` DISABLE KEYS */;
INSERT INTO `ticket_priority` (`ticket_priority_id`, `ticket_priority_name`, `ticket_priority_colour`, `ticket_priority_colour_code`) VALUES
	(1, 'low', 'primary', '#ff2d42'),
	(2, 'medium', 'warning', '#259b24'),
	(3, 'high', 'danger', '#c0c0c0');
/*!40000 ALTER TABLE `ticket_priority` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `ticket_replies` (
  `ticket_reply_id` int(11) NOT NULL AUTO_INCREMENT,
  `ticket_reply_uid` varchar(200) CHARACTER SET utf16 DEFAULT NULL,
  `ticket_id` int(11) NOT NULL,
  `ticket_reply_added_by` int(11) DEFAULT NULL,
  `ticket_reply` longtext CHARACTER SET utf16,
  `ticket_reply_ip` varchar(200) CHARACTER SET utf16 DEFAULT NULL,
  `ticket_reply_status_id` int(11) NOT NULL DEFAULT '1',
  `ticket_reply_date_added` datetime NOT NULL,
  PRIMARY KEY (`ticket_reply_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

/*!40000 ALTER TABLE `ticket_replies` DISABLE KEYS */;
/*!40000 ALTER TABLE `ticket_replies` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `ticket_status` (
  `ticket_status_id` int(11) NOT NULL AUTO_INCREMENT,
  `ticket_status_name` varchar(50) CHARACTER SET utf16 DEFAULT NULL,
  `ticket_status_colour` varchar(7) CHARACTER SET utf16 DEFAULT NULL,
  `ticket_status_colour_code` varchar(7) CHARACTER SET utf16 DEFAULT NULL,
  PRIMARY KEY (`ticket_status_id`)
) ENGINE=MyISAM AUTO_INCREMENT=6 DEFAULT CHARSET=latin1;

/*!40000 ALTER TABLE `ticket_status` DISABLE KEYS */;
INSERT INTO `ticket_status` (`ticket_status_id`, `ticket_status_name`, `ticket_status_colour`, `ticket_status_colour_code`) VALUES
	(1, 'open', 'primary', '#ff2d42'),
	(2, 'closed', 'success', '#0000ff');
/*!40000 ALTER TABLE `ticket_status` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `timezones` (
  `timezone_id` int(11) NOT NULL AUTO_INCREMENT,
  `timezone` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `timezone_gmt` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `timezone_name` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  PRIMARY KEY (`timezone_id`) USING BTREE
) ENGINE=MyISAM AUTO_INCREMENT=113 DEFAULT CHARSET=latin1 ROW_FORMAT=DYNAMIC;

/*!40000 ALTER TABLE `timezones` DISABLE KEYS */;
INSERT INTO `timezones` (`timezone_id`, `timezone`, `timezone_gmt`, `timezone_name`) VALUES
	(1, 'Pacific/Midway', 'GMT-11:00', 'Midway Island'),
	(2, 'US/Samoa', 'GMT-11:00', 'Samoa'),
	(3, 'US/Hawaii', 'GMT-10:00', 'Hawaii'),
	(4, 'US/Alaska', 'GMT-09:00', 'Alaska'),
	(5, 'US/Pacific', 'GMT-08:00', 'Pacific Time (US &amp; Canada)'),
	(6, 'America/Tijuana', 'GMT-08:00', 'Tijuana'),
	(7, 'US/Arizona', 'GMT-07:00', 'Arizona'),
	(8, 'US/Mountain', 'GMT-07:00', 'Mountain Time (US &amp; Canada)'),
	(9, 'America/Chihuahua', 'GMT-07:00', 'Chihuahua'),
	(10, 'America/Mazatlan', 'GMT-07:00', 'Mazatlan'),
	(11, 'America/Mexico_City', 'GMT-06:00', 'Mexico City'),
	(12, 'America/Monterrey', 'GMT-06:00', 'Monterrey'),
	(13, 'Canada/Saskatchewan', 'GMT-06:00', 'Saskatchewan'),
	(14, 'US/Central', 'GMT-06:00', 'Central Time (US &amp; Canada)'),
	(15, 'US/Eastern', 'GMT-05:00', 'Eastern Time (US &amp; Canada)'),
	(16, 'US/East-Indiana', 'GMT-05:00', 'Indiana (East)'),
	(17, 'America/Bogota', 'GMT-05:00', 'Bogota'),
	(18, 'America/Lima', 'GMT-05:00', 'Lima'),
	(19, 'America/Caracas', 'GMT-04:30', 'Caracas'),
	(20, 'Canada/Atlantic', 'GMT-04:00', 'Atlantic Time (Canada)'),
	(21, 'America/La_Paz', 'GMT-04:00', 'La Paz'),
	(22, 'America/Santiago', 'GMT-04:00', 'Santiago'),
	(23, 'Canada/Newfoundland', 'GMT-03:30', 'Newfoundland'),
	(24, 'America/Buenos_Aires', 'GMT-03:00', 'Buenos Aires'),
	(25, 'Greenland', 'GMT-03:00', 'Greenland'),
	(26, 'Atlantic/Stanley', 'GMT-02:00', 'Stanley'),
	(27, 'Atlantic/Azores', 'GMT-01:00', 'Azores'),
	(28, 'Atlantic/Cape_Verde', 'GMT-01:00', 'Cape Verde Is.'),
	(29, 'Africa/Casablanca', 'GMT', 'Casablanca'),
	(30, 'Europe/Dublin', 'GMT', 'Dublin'),
	(31, 'Europe/Lisbon', 'GMT', 'Lisbon'),
	(32, 'Europe/London', 'GMT', 'London'),
	(33, 'Africa/Monrovia', 'GMT', 'Monrovia'),
	(34, 'Europe/Amsterdam', 'GMT+01:00', 'Amsterdam'),
	(35, 'Europe/Belgrade', 'GMT+01:00', 'Belgrade'),
	(36, 'Europe/Berlin', 'GMT+01:00', 'Berlin'),
	(37, 'Europe/Bratislava', 'GMT+01:00', 'Bratislava'),
	(38, 'Europe/Brussels', 'GMT+01:00', 'Brussels'),
	(39, 'Europe/Budapest', 'GMT+01:00', 'Budapest'),
	(40, 'Europe/Copenhagen', 'GMT+01:00', 'Copenhagen'),
	(41, 'Europe/Ljubljana', 'GMT+01:00', 'Ljubljana'),
	(42, 'Europe/Madrid', 'GMT+01:00', 'Madrid'),
	(43, 'Europe/Paris', 'GMT+01:00', 'Paris'),
	(44, 'Europe/Prague', 'GMT+01:00', 'Prague'),
	(45, 'Europe/Rome', 'GMT+01:00', 'Rome'),
	(46, 'Europe/Sarajevo', 'GMT+01:00', 'Sarajevo'),
	(47, 'Europe/Skopje', 'GMT+01:00', 'Skopje'),
	(48, 'Europe/Stockholm', 'GMT+01:00', 'Stockholm'),
	(49, 'Europe/Vienna', 'GMT+01:00', 'Vienna'),
	(50, 'Europe/Warsaw', 'GMT+01:00', 'Warsaw'),
	(51, 'Europe/Zagreb', 'GMT+01:00', 'Zagreb'),
	(52, 'Europe/Athens', 'GMT+02:00', 'Athens'),
	(53, 'Europe/Bucharest', 'GMT+02:00', 'Bucharest'),
	(54, 'Africa/Cairo', 'GMT+02:00', 'Cairo'),
	(55, 'Africa/Harare', 'GMT+02:00', 'Harare'),
	(56, 'Europe/Helsinki', 'GMT+02:00', 'Helsinki'),
	(57, 'Europe/Istanbul', 'GMT+02:00', 'Istanbul'),
	(58, 'Asia/Jerusalem', 'GMT+02:00', 'Jerusalem'),
	(59, 'Europe/Kiev', 'GMT+02:00', 'Kyiv'),
	(60, 'Europe/Minsk', 'GMT+02:00', 'Minsk'),
	(61, 'Europe/Riga', 'GMT+02:00', 'Riga'),
	(62, 'Europe/Sofia', 'GMT+02:00', 'Sofia'),
	(63, 'Europe/Tallinn', 'GMT+02:00', 'Tallinn'),
	(64, 'Europe/Vilnius', 'GMT+02:00', 'Vilnius'),
	(65, 'Asia/Baghdad', 'GMT+03:00', 'Baghdad'),
	(66, 'Asia/Kuwait', 'GMT+03:00', 'Kuwait'),
	(67, 'Africa/Nairobi', 'GMT+03:00', 'Nairobi'),
	(68, 'Asia/Riyadh', 'GMT+03:00', 'Riyadh'),
	(69, 'Europe/Moscow', 'GMT+03:00', 'Moscow'),
	(70, 'Asia/Tehran', 'GMT+03:30', 'Tehran'),
	(71, 'Asia/Baku', 'GMT+04:00', 'Baku'),
	(72, 'Europe/Volgograd', 'GMT+04:00', 'Volgograd'),
	(73, 'Asia/Muscat', 'GMT+04:00', 'Muscat'),
	(74, 'Asia/Tbilisi', 'GMT+04:00', 'Tbilisi'),
	(75, 'Asia/Yerevan', 'GMT+04:00', 'Yerevan'),
	(76, 'Asia/Kabul', 'GMT+04:30', 'Kabul'),
	(77, 'Asia/Karachi', 'GMT+05:00', 'Karachi'),
	(78, 'Asia/Tashkent', 'GMT+05:00', 'Tashkent'),
	(79, 'Asia/Kolkata', 'GMT+05:30', 'Kolkata'),
	(80, 'Asia/Kathmandu', 'GMT+05:45', 'Kathmandu'),
	(81, 'Asia/Yekaterinburg', 'GMT+06:00', 'Ekaterinburg'),
	(82, 'Asia/Almaty', 'GMT+06:00', 'Almaty'),
	(83, 'Asia/Dhaka', 'GMT+06:00', 'Dhaka'),
	(84, 'Asia/Novosibirsk', 'GMT+07:00', 'Novosibirsk'),
	(85, 'Asia/Bangkok', 'GMT+07:00', 'Bangkok'),
	(86, 'Asia/Jakarta', 'GMT+07:00', 'Jakarta'),
	(87, 'Asia/Krasnoyarsk', 'GMT+08:00', 'Krasnoyarsk'),
	(88, 'Asia/Chongqing', 'GMT+08:00', 'Chongqing'),
	(89, 'Asia/Hong_Kong', 'GMT+08:00', 'Hong Kong'),
	(90, 'Asia/Kuala_Lumpur', 'GMT+08:00', 'Kuala Lumpur'),
	(91, 'Australia/Perth', 'GMT+08:00', 'Perth'),
	(92, 'Asia/Singapore', 'GMT+08:00', 'Singapore'),
	(93, 'Asia/Taipei', 'GMT+08:00', 'Taipei'),
	(94, 'Asia/Ulaanbaatar', 'GMT+08:00', 'Ulaan Bataar'),
	(95, 'Asia/Urumqi', 'GMT+08:00', 'Urumqi'),
	(96, 'Asia/Irkutsk', 'GMT+09:00', 'Irkutsk'),
	(97, 'Asia/Seoul', 'GMT+09:00', 'Seoul'),
	(98, 'Asia/Tokyo', 'GMT+09:00', 'Tokyo'),
	(99, 'Australia/Adelaide', 'GMT+09:30', 'Adelaide'),
	(100, 'Australia/Darwin', 'GMT+09:30', 'Darwin'),
	(101, 'Asia/Yakutsk', 'GMT+10:00', 'Yakutsk'),
	(102, 'Australia/Brisbane', 'GMT+10:00', 'Brisbane'),
	(103, 'Australia/Canberra', 'GMT+10:00', 'Canberra'),
	(104, 'Pacific/Guam', 'GMT+10:00', 'Guam'),
	(105, 'Australia/Hobart', 'GMT+10:00', 'Hobart'),
	(106, 'Australia/Melbourne', 'GMT+10:00', 'Melbourne'),
	(107, 'Pacific/Port_Moresby', 'GMT+10:00', 'Port Moresby'),
	(108, 'Australia/Sydney', 'GMT+10:00', 'Sydney'),
	(109, 'Asia/Vladivostok', 'GMT+11:00', 'Vladivostok'),
	(110, 'Asia/Magadan', 'GMT+12:00', 'Magadan'),
	(111, 'Pacific/Auckland', 'GMT+12:00', 'Auckland'),
	(112, 'Pacific/Fiji', 'GMT+12:00', 'Fiji');
/*!40000 ALTER TABLE `timezones` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `toyyibpay_settings` (
  `toyyibpay_id` int(11) NOT NULL AUTO_INCREMENT,
  `toyyibpay_status` int(11) DEFAULT NULL,
  `toyyibpay_url` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `toyyibpay_secret_key` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `toyyibpay_category` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  PRIMARY KEY (`toyyibpay_id`) USING BTREE
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=latin1 ROW_FORMAT=DYNAMIC;

/*!40000 ALTER TABLE `toyyibpay_settings` DISABLE KEYS */;
INSERT INTO `toyyibpay_settings` (`toyyibpay_id`, `toyyibpay_status`, `toyyibpay_url`, `toyyibpay_secret_key`, `toyyibpay_category`) VALUES
	(1, 1, 'https://toyyibpay.com', NULL, NULL),
	(2, 0, 'https://dev.toyyibpay.com', NULL, NULL);
/*!40000 ALTER TABLE `toyyibpay_settings` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `twocheckout_settings` (
  `twocheckout_id` int(11) NOT NULL AUTO_INCREMENT,
  `twocheckout_status` int(11) DEFAULT NULL,
  `twocheckout_publishable_key` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `twocheckout_private_key` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `twocheckout_secret_key` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `twocheckout_merchant_code` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  PRIMARY KEY (`twocheckout_id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=latin1;

/*!40000 ALTER TABLE `twocheckout_settings` DISABLE KEYS */;
INSERT INTO `twocheckout_settings` (`twocheckout_id`, `twocheckout_status`, `twocheckout_publishable_key`, `twocheckout_private_key`, `twocheckout_secret_key`, `twocheckout_merchant_code`) VALUES
	(1, 1, NULL, NULL, NULL, NULL),
	(2, 0, NULL, NULL, NULL, NULL);
/*!40000 ALTER TABLE `twocheckout_settings` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `users` (
  `user_id` int(11) NOT NULL AUTO_INCREMENT,
  `user_uid` varchar(100) CHARACTER SET utf16 DEFAULT NULL,
  `role_id` int(11) DEFAULT '0',
  `referred_by` int(11) DEFAULT NULL,
  `firstname` varchar(200) CHARACTER SET utf16 DEFAULT NULL,
  `lastname` varchar(200) CHARACTER SET utf16 DEFAULT NULL,
  `username` varchar(100) CHARACTER SET utf16 DEFAULT NULL,
  `email` varchar(100) CHARACTER SET utf16 DEFAULT NULL,
  `company` varchar(100) CHARACTER SET utf16 DEFAULT NULL,
  `calling_code` varchar(11) CHARACTER SET utf16 DEFAULT NULL,
  `phone` varchar(30) CHARACTER SET utf16 DEFAULT NULL,
  `password` varchar(256) CHARACTER SET utf16 DEFAULT NULL,
  `country_id` int(11) DEFAULT NULL,
  `city` varchar(100) CHARACTER SET utf16 DEFAULT NULL,
  `postal_code` varchar(100) CHARACTER SET utf16 DEFAULT NULL,
  `zip_code` varchar(15) CHARACTER SET utf16 DEFAULT NULL,
  `state` varchar(200) CHARACTER SET utf16 DEFAULT NULL,
  `street` varchar(100) CHARACTER SET utf16 DEFAULT NULL,
  `description` longtext CHARACTER SET utf16,
  `date_added` datetime DEFAULT NULL,
  `last_ip` varchar(40) CHARACTER SET utf16 DEFAULT NULL,
  `last_login` datetime DEFAULT NULL,
  `last_password_change` datetime DEFAULT NULL,
  `passkey` varchar(32) CHARACTER SET utf16 DEFAULT NULL,
  `new_pass_key_requested` datetime DEFAULT NULL,
  `longitude` varchar(300) CHARACTER SET utf16 DEFAULT NULL,
  `latitude` varchar(300) CHARACTER SET utf16 DEFAULT NULL,
  `default_language` varchar(40) CHARACTER SET utf16 DEFAULT NULL,
  `default_currency` int(11) NOT NULL DEFAULT '0',
  `default_billing` int(11) DEFAULT NULL,
  `default_shipping` int(11) DEFAULT NULL,
  `payout_mode_id` int(11) DEFAULT NULL,
  `payout_address` longtext CHARACTER SET utf16,
  `profile_image` varchar(150) CHARACTER SET utf16 DEFAULT NULL,
  `user_remaining_words` int(11) DEFAULT '0',
  `user_remaining_chat_assistants` int(11) DEFAULT '0',
  `user_remaining_trained_models` int(11) DEFAULT '0',
  `user_remaining_chat_files` int(11) DEFAULT '0',
  `user_remaining_chat_links` int(11) DEFAULT '0',
  `user_remaining_chat_sitemaps` int(11) DEFAULT '0',
  `user_trained_model` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `user_bots` longtext CHARACTER SET utf16,
  `user_chat_files` longtext CHARACTER SET utf16,
  `user_chat_links` longtext CHARACTER SET utf16,
  `user_chat_sitemaps` longtext CHARACTER SET utf16,
  `user_chat_icon_animation` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `user_chat_icon_position` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `user_chat_instructions` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `widget_header` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `widget_header_textarea` longtext CHARACTER SET utf16,
  `widget_colour` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `widget_assistant_background_colour` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `widget_assistant_text_colour` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `widget_user_background_colour` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `widget_user_text_colour` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `widget_message_placeholder` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `widget_open_button` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `widget_close_button` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `widget_visit_timeout` bigint(20) DEFAULT NULL,
  `widget_document_timeout` bigint(20) DEFAULT NULL,
  `widget_document_retries` bigint(20) DEFAULT NULL,
  `whatsapp_access_token` varchar(255) DEFAULT NULL,
  `whatsapp_phone_number_id` varchar(255) DEFAULT NULL,
  `whatsapp_webhook_listener` varchar(255) DEFAULT NULL,
  `whatsapp_webhook_verify_token` varchar(255) DEFAULT NULL,
  `whatsapp_default_response` varchar(255) DEFAULT NULL,
  `whatsapp_api_version` varchar(255) DEFAULT NULL,
  `user_status_id` int(11) NOT NULL DEFAULT '1',
  PRIMARY KEY (`user_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 ROW_FORMAT=COMPACT;

/*!40000 ALTER TABLE `users` DISABLE KEYS */;
/*!40000 ALTER TABLE `users` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `user_package_history` (
  `user_package_history_id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(11) DEFAULT NULL,
  `type` varchar(100) CHARACTER SET utf16 DEFAULT NULL,
  `transaction_type` varchar(100) CHARACTER SET utf16 DEFAULT NULL,
  `package_id` int(11) DEFAULT NULL,
  `openai_template_id` int(11) DEFAULT NULL,
  `old` int(11) DEFAULT NULL,
  `current` int(11) DEFAULT NULL,
  `tokens_used` int(11) DEFAULT NULL,
  `user_package_history_comment` longtext CHARACTER SET utf16,
  `user_package_history_added_by` int(11) DEFAULT NULL,
  `user_package_history_date_added` datetime DEFAULT NULL,
  PRIMARY KEY (`user_package_history_id`) USING BTREE
) ENGINE=MyISAM DEFAULT CHARSET=latin1 ROW_FORMAT=DYNAMIC;

/*!40000 ALTER TABLE `user_package_history` DISABLE KEYS */;
/*!40000 ALTER TABLE `user_package_history` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `user_status` (
  `user_status_id` int(11) NOT NULL AUTO_INCREMENT,
  `user_status` varchar(200) CHARACTER SET utf16 DEFAULT NULL,
  `user_status_colour` varchar(200) CHARACTER SET utf16 DEFAULT NULL,
  `user_status_fa` varchar(200) CHARACTER SET utf16 DEFAULT NULL,
  PRIMARY KEY (`user_status_id`)
) ENGINE=MyISAM AUTO_INCREMENT=5 DEFAULT CHARSET=latin1;

/*!40000 ALTER TABLE `user_status` DISABLE KEYS */;
INSERT INTO `user_status` (`user_status_id`, `user_status`, `user_status_colour`, `user_status_fa`) VALUES
	(4, 'deleted', 'danger', 'close'),
	(1, 'active', 'success', 'check'),
	(2, 'inactive', 'warning', 'exclamation'),
	(3, 'deactivated', 'dark', 'user-times');
/*!40000 ALTER TABLE `user_status` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `visits` (
  `visit_id` int(11) NOT NULL AUTO_INCREMENT,
  `visit_uid` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `widget_id` int(11) DEFAULT NULL,
  `visit_added_by` int(11) DEFAULT NULL,
  `visit_location` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `visit_ip_address` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `visit_platform` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `visit_date_ended` datetime DEFAULT NULL,
  `visit_last_activity` bigint(20) DEFAULT NULL,
  `visit_date_added` datetime DEFAULT NULL,
  PRIMARY KEY (`visit_id`) USING BTREE
) ENGINE=MyISAM DEFAULT CHARSET=latin1 ROW_FORMAT=DYNAMIC;

/*!40000 ALTER TABLE `visits` DISABLE KEYS */;
/*!40000 ALTER TABLE `visits` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `visit_timelines` (
  `visit_timeline_id` int(11) NOT NULL AUTO_INCREMENT,
  `visit_id` int(11) DEFAULT NULL,
  `visit_timeline_action` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `visit_timeline` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `visit_timeline_date_added` datetime DEFAULT NULL,
  PRIMARY KEY (`visit_timeline_id`) USING BTREE
) ENGINE=MyISAM DEFAULT CHARSET=latin1 ROW_FORMAT=DYNAMIC;

/*!40000 ALTER TABLE `visit_timelines` DISABLE KEYS */;
/*!40000 ALTER TABLE `visit_timelines` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `whatsapp_files` (
  `whatsapp_file_id` int(11) NOT NULL AUTO_INCREMENT,
  `whatsapp_file_uid` varchar(200) CHARACTER SET utf8mb4 DEFAULT NULL,
  `whatsapp_file_added_by` int(11) DEFAULT NULL,
  `whatsapp_file_source_id` longtext CHARACTER SET utf16,
  `vector_store_id` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `assistant_id` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `chat_instructions` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `whatsapp_file_date_added` datetime DEFAULT NULL,
  PRIMARY KEY (`whatsapp_file_id`) USING BTREE,
  UNIQUE KEY `widget_uid` (`whatsapp_file_uid`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

/*!40000 ALTER TABLE `whatsapp_files` DISABLE KEYS */;
/*!40000 ALTER TABLE `whatsapp_files` ENABLE KEYS */;

CREATE TABLE IF NOT EXISTS `widgets` (
  `widget_id` int(11) NOT NULL AUTO_INCREMENT,
  `widget_uid` varchar(200) CHARACTER SET utf8mb4 DEFAULT NULL,
  `widget_added_by` int(11) DEFAULT NULL,
  `widget_name` varchar(200) CHARACTER SET utf16 DEFAULT NULL,
  `user_trained_model` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `user_bots` longtext CHARACTER SET utf16,
  `user_chat_files` longtext CHARACTER SET utf16,
  `user_chat_links` longtext CHARACTER SET utf16,
  `user_chat_sitemaps` longtext CHARACTER SET utf16,
  `user_chat_icon_animation` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `user_chat_icon_position` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `user_chat_instructions` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `widget_header` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `widget_header_textarea` longtext CHARACTER SET utf16,
  `widget_colour` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `widget_assistant_background_colour` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `widget_assistant_text_colour` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `widget_user_background_colour` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `widget_user_text_colour` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `widget_message_placeholder` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `widget_open_button` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `widget_close_button` varchar(255) CHARACTER SET utf16 DEFAULT NULL,
  `widget_visit_timeout` bigint(20) DEFAULT NULL,
  `widget_document_timeout` bigint(20) DEFAULT NULL,
  `widget_document_retries` bigint(20) DEFAULT NULL,
  `widget_date_added` datetime DEFAULT NULL,
  PRIMARY KEY (`widget_id`),
  UNIQUE KEY `widget_uid` (`widget_uid`),
  KEY `widget_uid_2` (`widget_uid`(191))
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

/*!40000 ALTER TABLE `widgets` DISABLE KEYS */;
/*!40000 ALTER TABLE `widgets` ENABLE KEYS */;

/*!40101 SET SQL_MODE=IFNULL(@OLD_SQL_MODE, '') */;
/*!40014 SET FOREIGN_KEY_CHECKS=IFNULL(@OLD_FOREIGN_KEY_CHECKS, 1) */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40111 SET SQL_NOTES=IFNULL(@OLD_SQL_NOTES, 1) */;
